<?php
/**
 * Add / update admin account
 */

	if (!defined("ENV")) exit();

	$mode = isset($_REQUEST["mode"]) ? trim($_REQUEST["mode"]) : "";
	
	$admin_id = isset($_REQUEST["aid"]) ? intval($_REQUEST["aid"]) : "";
	
	$name = isset($_POST["name"]) ? trim($_POST["name"]) : "";
	$email = isset($_POST["email"]) ? trim($_POST["email"]) : "";
	$email_mode = isset($_POST["email_mode"]) ? trim($_POST["email_mode"]) : "text";
	$username = isset($_POST["username"]) ? trim($_POST["username"]) : "";
	$password = isset($_POST["password"]) ? trim($_POST["password"]) : "";
	$password2 = isset($_POST["password2"]) ? trim($_POST["password2"]) : "";
	$active = isset($_POST["active"]) ? trim($_POST["active"]) : "No";
	
	$privilege = isset($_POST["privilege"]) ? $_POST["privilege"] : array();
	$privileges = implode(",", $privilege);
	
	$receive_notification = isset($_POST["receive_notification"]) ? $_POST["receive_notification"] : array();	
	$receive_notifications = implode(",", $receive_notification);
	  
	$is_error = false;
	$error_message = "";
	
	switch($mode)
	{
		/**
		 * Create a new account
		 */
		case "insert" :
		{
			$db->query("SELECT * FROM ".DB_PREFIX."admins WHERE username LIKE '".$db->escape($username)."'");
			if ($db->moveNext())
			{
				pageHeader("Can't Create Account", "", "ic_admin_done.gif");
				pageNote(array(
					array("icon"=>"ic_error.gif", "text"=>"<b>Backend administrator with this username ".gs($username)." already exists</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Click here to check error", "url"=>"javascript:history.back()"),
					array("text"=>"Browse administrators", "url"=>"admin.php?p=admins")
				));
			}
			else
			{
				$db->reset();
				$db->assign("last_access", "NOW()");
				$db->assign("last_update", "NOW()");
				$db->assignStr("name", $name);
				$db->assignStr("email", $email);
				$db->assignStr("email_mode", $email_mode);
				$db->assignStr("username", $username);
				$db->assignStr("password", getPasswordHash($password));
				$db->assignStr("rights", $privileges);
				$db->assignStr("receive_notifications", $receive_notifications);
				$db->assignStr("password_history", base64_encode(serialize(array(array("p"=>getPasswordHash($password), "s"=>pwdStrength($password))))));
				$db->assignStr("active", $active);
				if (!DEMO_LOCK)
				{
					$admin_id = $db->insert(DB_PREFIX."admins");
				}
				else
				{
					$admin_id = 0;
				}
				pageHeader("Administrator Account Created", "", "ic_admin_done.gif");
				pageNote(array(
					array("icon"=>"ic_hint.gif", "text"=>"<b>New administrator account has been successfully created</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Click here to edit just created account", "url"=>"admin.php?p=admin&mode=update&aid=".$admin_id),
					array("text"=>"Create new account again", "url"=>"admin.php?p=admin&mode=insert"),
					array("icon"=>"ic_admin.gif", "text"=>"Browse administrators", "url"=>"admin.php?p=admins")
				));
			}
			break;
		}
		case "update" :
		{
			/**
			 * Update account
			 */
			$db->query("SELECT * FROM ".DB_PREFIX."admins WHERE username LIKE '".$db->escape($username)."'  AND aid<>'".intval($admin_id)."'");
			if ($db->moveNext())
			{
				pageHeader("Can't Update Account", "", "ic_admin_done.gif");
				pageNote(array(
					array("icon"=>"ic_error.gif", "text"=>"<b>Backend administrator with this username ".gs($username)." already exists</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Click here to check error", "url"=>"javascript:history.back()"),
					array("text"=>"Browse administrators", "url"=>"admin.php?p=admins")
				));
			}
			else
			{
				if (!DEMO_LOCK)
				{
					$password_history = array();
					if ($password != "")
					{
						$db->query("SELECT password_history FROM ".DB_PREFIX."admins WHERE aid='".intval($admin_id)."' AND aid<>'".intval($admin_auth_id)."'");
						if (($admin = $db->moveNext()) != false)
						{
							if($admin["password_history"] != "")
							{
								$password_history = unserialize(base64_decode($admin["password_history"]));
							}
						}
					}
					
					$db->reset();
					$db->assignStr("name", $name);
					$db->assignStr("username", $username);
					$db->assignStr("email", $email);
					$db->assignStr("email_mode", $email_mode);
					$db->assignStr("active", $active);
					$db->assignStr("rights", $privileges);
					$db->assignStr("receive_notifications", $receive_notifications);
					
					/**
					 * Update password if it is not empty
					 */
					if ($password != "")
					{
						$passwordHash = getPasswordHash($password);
			
						/**
						 * If current password in array, remove it
						 */
						foreach ($password_history as $key=>$value)
						{
							if($value["p"] == $passwordHash)
							{
								unset($password_history[$key]);
								break;
							}
						}
			
						/**
						 * and rearrange array keys (like 0,1,3,4 to 0,1,2,3)
						 * @var unknown_type
						 */
						$_password_history = array();
						foreach ($password_history as $ph)
						{
							$_password_history[] = $ph;
						}
						$password_history = $_password_history;
			
						/**
						 * if history already has 4 or more (why??) password - remove last one
						 */
						if(count($password_history) > 3) array_shift($password_history);
			
						/**
						 * finaly add current password
						 */
						$password_history[] = array(
							"p" => $passwordHash,
							"s" => pwdStrength($password)
						);
						$db->assignStr("password", $passwordHash);
						$db->assignStr("password_history", base64_encode(serialize($password_history)));
						$db->assign("last_update", "NOW()");
					}
					$db->update(DB_PREFIX."admins", "WHERE aid='".intval($admin_id)."' AND aid<>'".intval($admin_auth_id)."'");
				}
				pageHeader("Administrator Account Updated", "", "ic_admin_done.gif");
				pageNote(array(
					array("icon"=>"ic_hint.gif", "text"=>"<b>Administrator account has been successfully updated</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Back to last account editing", "url"=>"admin.php?p=admin&mode=update&aid=".$admin_id),
					array("text"=>"Create new account", "url"=>"admin.php?p=admin&mode=insert"),
					array("text"=>"Browse administrators", "url"=>"admin.php?p=admins")
				));
			}
			break;
		}

		/**
		 * Delete admin account
		 */
		case "delete" :
		{
			if (!DEMO_LOCK)
			{
				$db->query("DELETE FROM ".DB_PREFIX."admins WHERE aid='".intval($admin_id)."' AND aid<>'".intval($admin_auth_id)."'");
			}
			pageHeader("Administrator Account Removed", "", "ic_admin_done.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Administrator account has been successfully removed</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("text"=>"Browse administrators", "url"=>"admin.php?p=admins"),
				array("text"=>"Create new account", "url"=>"admin.php?p=admin&mode=insert")
				
			));
			break;
		}
		default :
		{
			pageHeader("Incorrect Action", "", "ic_admin_done.gif");
			pageWhat(array(
				array("text"=>"Browse administrators", "url"=>"admin.php?p=admins")
			));
		}
	}