<?php
/**
 * Show administrators list
 */

	if (!defined('ENV') || defined('IS_INTUIT_FEDERATED')) exit();

	loadJS('cd_admin.js');

	pageHeader('Site Administrators', '', 'icb-administrator');

	if (AccessManager::checkAccess('MAX_ADMINS') > 1)
	{
		pageNote(
			array(
				array('class' => 'ic-add', 'url' => 'admin.php?p=admin&mode=insert', 'text' => '<strong>Create a New Administrator Account</strong>'),
				array('class' => 'ic-id', 'url' => 'admin.php?p=profile', 'text' => '<strong>Update Your Profile</strong>'),
			)
		);

		$db->query('SELECT aid, username, name, active, DATE_FORMAT(last_access, "'.$settings['LocalizationDateTimeFormat'].'") AS last_access FROM '.DB_PREFIX.'admins WHERE aid <> "'.intval($admin_auth_id).'" ORDER BY name');

		if ($db->numRows() > 0)
		{
?>
<div style="display: none;"><input type="hidden" id="admin-delete-nonce" name="admin-delete-nonce" value="<?=gs(create_nonce('admin_delete'));?>" /></div>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon"><span class="icon ic-icon ic-administrator"></span></th>
			<th>User Name</th>
			<th>First &amp; Last Name</th>
			<th>Active</th>
			<th>Last Access</th>
			<th>&nbsp;</th>
		</tr>
	</thead>
	<tbody>
<?php
			while (($admin = $db->moveNext()) != false)
			{
?>
		<tr>
			<td><span class="icon ic-icon ic-administrator"></span></td>
			<td><a href="admin.php?p=admin&mode=update&aid=<?=$admin['aid']?>"><?=htmlspecialchars($admin['username'])?></a></td>
			<td><a href="admin.php?p=admin&mode=update&aid=<?=$admin['aid']?>"><?=htmlspecialchars($admin['name'])?></a></td>
			<td><?=$admin['active']?></td>
			<td><?=$admin['last_access']?></td>
			<td class="text-align-right">
				<a href="admin.php?p=admin&mode=update&aid=<?=$admin["aid"]?>" title="Edit Account"><img src="images/icons/a/pencil.png" border="0" hspace="2" title="Edit"></a>
				<a href="javascript:ConfirmDeleteAdmin(<?=$admin["aid"]?>)" title="Delete Account"><img src="images/icons/a/delete.png" border="0" hspace="2" title="Delete"></a>
			</td>
		</tr>
<?php
			}
?>
	</tbody>
</table>
<?php
		}
		else
		{
?>
	<div class="listEmpty">
		No admins have been created.
	</div>
<?php
		}
	}
	else
	{
		AccessManager::notAllowed("Your current license agreement only allows ".AccessManager::checkAccess('MAX_ADMINS')." admin(s).");
	}
