<?php
/**
 * Show administrators list
 */

if (!defined("ENV") || defined('IS_INTUIT_FEDERATED')) exit();

loadJS("cd_admin.js");

pageHeader("Site Administrators", "", 'icb-administrator');

if (AccessManager::checkAccess('MAX_ADMINS') > 1)
{
	pageNote(
		array(
			array("class"=>"ic-add","url"=>"admin.php?p=admin&mode=insert","text"=>"<strong>Create a New Administrator Account</strong>", "visible"=>true),
			array("class"=>"ic-id","url"=>"admin.php?p=profile","text"=>"<strong>Update Your Profile</strong>", "visible"=>true),
		)
	);

	$db->query("SELECT *, DATE_FORMAT(last_access, '".$settings["LocalizationDateTimeFormat"]."') AS la FROM ".DB_PREFIX."admins WHERE aid<> '".intval($admin_auth_id)."' ORDER BY name");
	
	if ($db->numRows()>0)
	{
?>
<div style="display: none;"><input type="hidden" id="admin-delete-nonce" name="admin-delete-nonce" value="<?=gs(create_nonce('admin_delete'));?>" /></div>
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:150px;">User Name</div>
	<div class="listHeaderCaption" style="width:200px;">First &amp; Last Name</div>
	<div class="listHeaderCaption" style="width:100px;">Active</div>
	<div class="listHeaderCaption" style="width:170px;">Last Access</div>
</div>
<?php
		while (($admin = $db->moveNext()) != false)
		{
?>

<div class="listItem">
	<div class="listItemIcon"><span class="icon ic-icon ic-administrator"></span></div>
	<div class="listItemText" style="width:150px;"><a href="admin.php?p=admin&mode=update&aid=<?=$admin["aid"]?>"><?=htmlspecialchars($admin["username"])?></a></div>
	<div class="listItemText" style="width:200px;"><a href="admin.php?p=admin&mode=update&aid=<?=$admin["aid"]?>"><?=htmlspecialchars($admin["name"])?></a></div>
	<div class="listItemText" style="width:100px;"><?=$admin["active"]?></div>
	<div class="listItemText" style="width:170px;"><?=$admin["la"]?></div>
	<div class="listItemButtons">
		<a href="admin.php?p=admin&mode=update&aid=<?=$admin["aid"]?>" title="Edit Account"><img src="images/icons/a/pencil.png" border="0" hspace="2" title="Edit"></a>
		<a href="javascript:ConfirmDeleteAdmin(<?=$admin["aid"]?>)" title="Delete Account"><img src="images/icons/a/delete.png" border="0" hspace="2" title="Delete"></a>
	</div>
</div>
<?php
		}
	}
	else
	{
?>
<div class="listEmpty">
	No admins have been created.
</div>
<?php
	}
}
else
{
	AccessManager::notAllowed("Your current license agreement only allows ".AccessManager::checkAccess('MAX_ADMINS')." admin(s).");
}
