<?php
/**
 * Show admins log
 */

	if (!defined("ENV")) exit();
	
	pageHeader("Administrators Activity Log", "", "icb-log");
	
	$from_y = isset($from_y)?$from_y:date("Y");
	$from_m = isset($from_m)?$from_m:date("n");
	$from_d = isset($from_d)?$from_d:1;
	$to_y = isset($to_y)?$to_y:date("Y");	
	$to_m = isset($to_m)?$to_m:date("n");
	$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
	$sort_by = isset($sort_by) ? $sort_by : "date_desc";
	$sort_by = in_array($sort_by, array("date", "date_desc", "username", "username_desc", "ip", "message")) ? $sort_by : "date_desc";
	
	function GetReportDate()
	{
		global $from_y, $from_m, $from_d, $to_y, $to_m, $to_d;
		return 
			date("F j, Y", mktime(1, 1, 1, $from_m, $from_d, $from_y))." - ".
			date("F j, Y", mktime(1, 1, 1, $to_m, $to_d, $to_y));
	}
	
	$mysql_from =  $from_y."-".$from_m."-".$from_d." 00:00:01";
	$mysql_to =  $to_y."-".$to_m."-".$to_d." 23:59:59";
?>
&nbsp;
<form action="admin.php" method="get">
	<input type="hidden" name="p" value="admins_log">
	
	<div class="admin-search-form clearfix">
		<div class="admin-search-form-header">Search Administrators Activity Log</div>
		
		<div class="admin-search-form-wrap clearfix">
			<div class="admin-search-form-item">
				<label>Date From:</label>
				<select name="from_m" style="width:120px;">
					<?php for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option><?}?>
				</select>
				<select name="from_d" style="width:57px;">
					<?php for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option><?}?>
				</select>
				<select name="from_y" style="width:75px;">
					<?php for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option><?}?>
				</select>
				<br/><br/>

				<label>Date To:</label>
				<select name="to_m" style="width:120px;">
					<? for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option><?}?>
				</select>
				<select name="to_d" style="width:57px;">
					<? for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option><?}?>
				</select>
				<select name="to_y" style="width:75px;">
					<? for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option><?}?>
				</select>
			</div>

			<div class="admin-search-form-item">
				Sort By:<br>
				<select name="sort_by">
					<option value="date">Date</option>
					<option <?=$sort_by=="date_desc"?'selected="selected"':''?> value="date_desc">Date desc.</option>
					<option <?=$sort_by=="username"?'selected="selected"':''?> value="username">Username</option>
					<option <?=$sort_by=="username_desc"?'selected="selected"':''?> value="username_desc">Username desc.</option>
					<option <?=$sort_by=="ip"?'selected="selected"':''?> value="ip">IP</option>
					<option <?=$sort_by=="message"?'selected="selected"':''?> value="message">Action</option>
				</select>
			</div>
		</div>
		&nbsp;
		<div class="admin-form-buttons admin-search-form-buttons">
			<input type="submit" value="Search"/>
			<input type="reset" value="Reset Search"/>
		</div>
	</div>
</form>

<div class="admin-form-header">
	<span class="icon ic-icon ic-calendar-month"></span> Administrators Activity (<?=GetReportDate();?>)
</div>
<?php
	$db->query("SELECT *, log_date as date FROM ".DB_PREFIX."admins_logs WHERE log_date>='".$db->escape($mysql_from)."' AND log_date<='".$db->escape($mysql_to)."' ORDER BY ".str_replace("_"," ",$sort_by));
	if ($db->numRows()>0)
	{
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon">&nbsp;</th>
			<th width="20%">Date</th>
			<th width="20%">Username</th>
			<th width="20%">IP Address</th>
			<th>Action</td>
		</tr>
	</thead>
	<tbody>
<?php
		while (($log = $db->moveNext()) != false)
		{
?>
	<tr>
		<td class="icon">&nbsp;</td>
		<td><?=date("m/d/Y H:i:s", strtotime($log["log_date"]));?></td>
		<td><?=htmlspecialchars($log["username"])?></td>
		<td><?=long2ip($log["ip"])?></td>
		<td><?=htmlspecialchars($log["message"])?></td>
	</tr>

<?php
		}
?>
	</tbody>
</table>
<?php
	}

	else
	{
		pageNote(array(
			array('text'=>'No data available for selected period', 'class'=>'ic-info')
		));
	}
