<?php

if (!defined("ENV")) exit();

require_once 'content/classes/class.product_attribute.php';

$obj = new stdClass();
$obj->status = 200;
$obj->addedAttributes = array();

$pid = isset($_REQUEST['pid']) ? intval($_REQUEST['pid']) : 0;

$productAttribute = new ProductAttribute($db);

if ($pid > 0)
{
	$mode = isset($_REQUEST['mode']) ? $_REQUEST['mode'] : 'none';
	if ($mode == 'add')
	{
		$name = isset($_REQUEST['name']) ? trim($_REQUEST['name']) : '';
		$caption = isset($_REQUEST['caption']) ? trim($_REQUEST['caption']) : '';

		$obj->fields = array();
		$validationMessages = '';
		if ($name == '')
		{
			$obj->fields['name'] = 'Attribute Name is required';
		}
		// if ($caption == '')
		// {
		// 	$obj->fields['caption'] = 'Attribute Caption is required';
		// }

		if (count($obj->fields) > 0)
		{
			$obj->status = 500;
			$obj->message = 'Validation failed';
		}
		else
		{
			if ($_REQUEST['mode'] == 'add')
			{
				$obj->nonce = create_nonce('product_delete_attribute');
				$paid = $productAttribute->add($pid, $_REQUEST);
				$obj->addedAttributes[] = $_REQUEST;
				$obj->paid = $paid;
				$obj->message = 'Product attribute added';
			}
			else if ($_REQUEST['mode'] == 'update')
			{
				$product_attribute_id = isset($_REQUEST['paid']) ? intval($_REQUEST['paid']) : 0;
				$productAttribute->update($pid, $product_attribute_id, $_REQUEST);
				$obj->paid = $product_attribute_id;
				$obj->message = 'Product attribute updated';
			}
		}
	}
	else if ($mode == 'add_globals')
	{
		$global_attributes_str = $_REQUEST['global_aids'] ? $_REQUEST['global_aids'] : '';
		$global_attributes = explode(',', $global_attributes_str);

		if (count($global_attributes) > 0)
		{
			$where_already_assigned = "";
			$where_categories = "";

			// select already assigned attributes
			$db->query("SELECT * FROM ".DB_PREFIX."products_attributes WHERE pid='".intval($pid)."' AND gaid > 0");
			while ($db->moveNext())
			{
				$where_already_assigned.= ($where_already_assigned == "" ? " " : " AND ")." gaid <> ".$db->col["gaid"];
			}

			//select category-specific attributes
			$db->query("SELECT ca.* FROM ".DB_PREFIX."catalog_attributes ca INNER JOIN ".DB_PREFIX."products p ON ca.cid = p.cid WHERE p.pid = '".intval($pid)."'");

			while ($db->moveNext())
			{
				$where_categories.= ($where_categories == "" ? "" : " OR ")." gaid = '".intval($db->col["gaid"])."'";
			}

			if ($where_categories != "")
			{
				$sql = "SELECT * FROM ".DB_PREFIX."global_attributes WHERE ((is_global='Yes') OR (".$where_categories.")) ";
			}
			else
			{
				$sql = "SELECT * FROM ".DB_PREFIX."global_attributes WHERE (is_global='Yes') ";
			}

			$sql.= ($where_already_assigned != "") ? " AND (".$where_already_assigned.")" : "";

			$db->query($sql);

			$selected_attributes = $db->getRecords();

			foreach ($selected_attributes as $selected_attribute)
			{
				if (in_array($selected_attribute["gaid"], $global_attributes))
				{
					$productAttribute->add($pid, $selected_attribute);
					$obj->addedAttributes[] = $selected_attribute;
				}
			}
		}
		$obj->message = 'Add Globals';
	}
}
else
{
	$obj->status = 500;
	$obj->message = 'No product selected';
}

$db->query("SELECT COUNT(*) FROM ".DB_PREFIX."products_attributes WHERE pid = '".intval($pid)."'");
if ($row = $db->moveNext())
{
	$attributesCount = $row[0];
	$db->query("UPDATE ".DB_PREFIX."products SET attributes_count = ".intval($attributesCount)." WHERE pid = '".intval($pid)."'");
}

header('HTTP/1.0 '.$obj->status);
header('Content-Type: application/json');
if (isset($_REQUEST['callback']))
{
	echo $_REQUEST['callback'].'('.json_encode($messages).');';
}
else
{
	echo json_encode($obj);
}