<?php

	if (!defined("ENV")) exit();

	if (!isset($adminView) && !is_object($adminView))
	{
		$adminView = Ddm_AdminView::getInstance();
	}

	if (
		$settings['CompanyName'] == 'Company Name' || $settings['CompanyName'] == '' ||
		$settings['CompanyAddressLine1'] == 'Address Line 1' || $settings['CompanyAddressLine1'] == '' ||
		$settings['CompanyState'] == 'State' || $settings['CompanyState'] == '' ||
		$settings['CompanyZip'] == '-' || $settings['CompanyZip'] == ''
	)
	{
		Admin_Flash::setMessage(
			'To calculate taxes using Avalara, please make sure you have updated your <a href="admin.php?p=settings&group=1">Company Information</a> under Global Cart Settings. '.
			'Please note: Avalara requires a valid address',
			Admin_Flash::TYPE_ERROR
		);
	}

	$message_responses = array(
		'TS' => 'Was succesfull able to connect to avalara!'
	);

	if (isset($_REQUEST['action']))
	{
		$redirect_data = '';

		if ($_REQUEST['action'] == 'update_codes')
		{
			$nonce_valid = verify_nonce($_REQUEST['nonce'], 'tax_update_codes');

			if (!$nonce_valid)
			{
				invalid_nonce_message();
				exit;
			}

			$avalaraUsername = isset($_REQUEST['avalaraUsername']) ? trim($_REQUEST['avalaraUsername']) : '';
			$avalaraPassword = isset($_REQUEST['avalaraPassword']) ? trim($_REQUEST['avalaraPassword']) : ''; //'p1nn4cl3';

			if (Tax_Avalara_AvalaraTaxCodeHelper::updateTaxCodes($avalaraUsername, $avalaraPassword))
			{
				Admin_Flash::setMessage('Avalara tax codes have been updated');
			}
			else
			{
				Admin_Flash::setMessage('Cannot update Avalara tax codes. Please check username and password', Admin_Flash::TYPE_ERROR);
			}

		}
		else if ($_REQUEST['action'] == 'save_avalara')
		{
			$formData = $_REQUEST['form'];

			if ($formData['AvalaraEnableTax'] == 'Yes' && $settings['ExactorEnableTax'] == 'Yes')
			{
				Admin_Flash::setMessage('Exactor Tax Service is enabled.  Please disable before enabling the Avalara Tax Service.', Admin_Flash::TYPE_ERROR);
				$formData['AvalaraEnableTax'] = 'No';
			}

			if ($formData['AvalaraEnableTax'] == 'Yes')
			{
				$avalaraTax = new Tax_Avalara_AvalaraService($db, array_merge($settings, $formData));
				$result = $avalaraTax->ping('Test Connection');

				$action_result = !empty($result) ? 'TAS' : 'TAF';

				// Force deactivate
				if ($action_result == 'TAF')
				{
					$formData['AvalaraEnableTax'] = 'No';
				}

				$settingsRepository = DataAccess_SettingsRepository::getInstance();

				// enable address validation
				if ($formData['AvalaraEnableTax'] == 'Yes')
				{
					$formData['EndiciaUspsAddressValidation'] = 1;
				}

				$settingsRepository->save($formData);
			}
			else if ($formData['AvalaraEnableTax'] == 'No')
			{
				$formDataTemp = array('AvalaraEnableTax' => 'No');

				$settingsRepository = DataAccess_SettingsRepository::getInstance();
				$settingsRepository->save($formData);
			}
		}
		else if ($_REQUEST['action'] == 'save_tax_codes')
		{
			if (!empty($avalara_add_tax_code['name']) && !empty($avalara_add_tax_code['code']))
			{
				$db->reset();
				$db->assignStr('name',$avalara_add_tax_code['name']);
				$db->assignStr('code',$avalara_add_tax_code['code']);
				$db->insert(DB_PREFIX.'avalara_tax_codes');
			}

			if (!empty($avalara_tax_code_fields) && is_array($avalara_tax_code_fields))
			{
				foreach ($avalara_tax_code_fields as $k => $code_item)
				{
					$db->reset();
					$db->assignStr('name',$code_item['name']);
					$db->assignStr('code',$code_item['code']);
					$db->update(DB_PREFIX.'avalara_tax_codes',"WHERE id = $k");
				}
			}
				
			$redirect_data .= "&action_result=EAS&last_active_tab=avalara-tax-codes";
		}
		else if ($_REQUEST['action'] == 'delete_tax_code')
		{
			$tax_code = $db->selectOne("SELECT code FROM ".DB_PREFIX."avalara_tax_codes WHERE id = ".intval($delete_tax_code));
			if ($tax_code)
			{
				$tax_code = array_shift($tax_code);
				$db->query("DELETE FROM ".DB_PREFIX."avalara_tax_codes WHERE id = ".intval($delete_tax_code));
				$db->query("UPDATE ".DB_PREFIX."products SET avalara_tax_code = ''  WHERE avalara_tax_code = '".$db->escape($tax_code)."'");
				$db->query("UPDATE ".DB_PREFIX."catalog SET avalara_tax_code = ''  WHERE avalara_tax_code = '".$db->escape($tax_code)."'");
			}

			$redirect_data .= "&action_result=DAS&last_active_tab=avalara-tax-codes";
		}

		if (trim($redirect_data) != '')
		{
			header("Location: admin.php?p=avalara_tax".$redirect_data);
			_session_write_close();
			exit();
		}
	}

	$avalaraSetupForm = new core_Form_FormBuilder('avalara_setup_form', array('label'=>'Properties', 'class'=>'ic-payment', 'first'=>true));
	$avalaraSetupForm->add('action','hidden',array('label'=>'saveAvalaraTax','value'=>'save_avalara'));
	$avalaraSetupForm->add('nonce','hidden',array('label'=>'nonce','value'=>create_nonce('tax_save_avalara')));
	$avalaraSetupForm->add('form[AvalaraEnableTax]','choice',array(
		'label'  => 'Enable Avalara Tax',
		'value'  => 'Yes' == $settings['AvalaraEnableTax']?'Yes':'No',
		'attr' => array('class'=>'short'),
		'options' => array(
			new core_Form_Option('Yes','Yes'),
			new core_Form_Option('No','No'),
		)
	));
	$avalaraSetupForm->add('form[AvalaraAccountNumber]', 'text', array('label' => 'Account Number', 'value' => $settings['AvalaraAccountNumber'], 'required' => true));
	$avalaraSetupForm->add('form[AvalaraLicenseKey]' , 'text' , array('label' => 'License Key', 'value' => $settings['AvalaraLicenseKey'], 'required' => true));
	$avalaraSetupForm->add('form[AvalaraCompanyCode]', 'text', array('label' => 'Company Code', 'value' => $settings['AvalaraCompanyCode'], 'required' => true));
	$avalaraSetupForm->add('form[AvalaraCurrencyCode]', 'text', array('label' => 'Currency Code', 'value' => $settings['AvalaraCurrencyCode'], 'required' => false,
		'note' => 'Use this field to override the Currency Code passed to Avalara for calculating taxes.  It must match the default currency code for your store (e.g. USD or EUR).<br/>Leave this field blank to use the default currency code configured in your Avalara Admin Console.'
	));
	$avalaraSetupForm->add('form[AvalaraURL]', 'text', array('label' => 'URL', 'value' => $settings['AvalaraURL'], 'required' => true));

	$avalaraActive =
		$settings['AvalaraEnableTax'] == "Yes" && trim($settings['AvalaraAccountNumber']) != ""
		&& trim($settings['AvalaraLicenseKey']) != "" && $settings['AvalaraCompanyCode'] != ""
		&& trim($settings['AvalaraURL']) != "";

	$adminView->assign('avalaraSetupForm',$avalaraSetupForm->getForm());

	$action_result = isset($action_result) ? $action_result : '';
	switch ($action_result)
	{
		case 'TAS':
			Admin_Flash::setMessage('Avalara Connection Successful', Admin_Flash::TYPE_SUCCESS);
			break;
		case 'TAF':
			Admin_Flash::setMessage('Unable to connect to Avalara. Please check your settings.', Admin_Flash::TYPE_ERROR);
			break;
		case 'EAS':
			Admin_Flash::setMessage('Tax code saved successfully.', Admin_Flash::TYPE_SUCCESS);
			break;
		case 'DAS':
			Admin_Flash::setMessage('Tax exemption codes has been deleted.', Admin_Flash::TYPE_SUCCESS);
			break;
	}

	$avalara_tax_codes = $db->selectAll("SELECT * FROM ".DB_PREFIX."avalara_tax_codes");
	$adminView->assign('avalara_tax_codes', $avalara_tax_codes);

	$avalataTaxCodesCount = Tax_Avalara_AvalaraTaxCodeHelper::getTaxCodesCount();
	$adminView->assign('avalara_tax_codes_count', $avalataTaxCodesCount);

	$last_active_tab = isset($last_active_tab) ? $last_active_tab : 'main';

	$tabs = new Admin_Tabs(
		'tabs-avalara-tax', $last_active_tab,
		array(
			array('title' => 'About Avalara', 'id' => 'main'),
			array('title' => 'Manage Avalara', 'id' => 'settings'),
			array('title' => 'Avalara Tax Codes', 'id' => 'avalara-tax-codes')
		)
	);

	$adminView->assign('lastActiveTab', $last_active_tab);
	$adminView->assign('tabs', $tabs);
	$adminView->assign('update_codes_nonce', create_nonce('tax_update_codes'));

	$adminView->render('pages/taxes/avalara');
