<?php

	$action = isset($_REQUEST['action']) ? $_REQUEST['action'] : false;

	require_once('content/classes/Payment/Bongo/BongoExport.php');
	
	if ($action)
	{
		$bongoExport = new BongoExport($db, $settings);
		$exportAllProducts = isset($_REQUEST['export_all_products']) ? $_REQUEST['export_all_products'] == 'yes' : true;

		switch ($action)
		{
			/**
			 * Save address settings
			 */
			case 'save-address' :
			{
				$form = isset($_REQUEST['form']) ? $_REQUEST['form'] : array();
				foreach ($form as $name=>$value)
				{
					$db->query('UPDATE '.DB_PREFIX.'settings SET value="'.$db->escape($value).'" WHERE name="'.$db->escape($name).'"');
					$settings[$name] = $value;
				}
				break;
			}
			/**
			 * Export CSV file
			 */
			case 'export-csv' :
			{
				$bongoExport->exportCsv($exportAllProducts);
				die();
				break;
			}

			/**
			 * Start products synch
			 */
			case 'start-synch' :
			{
				// prepare data for synchronization
				$_SESSION['bongo_categories'] = $bongoExport->getCategories();
				$_SESSION['bongo_count_with_subids'] =  $bongoExport->getProductsCountWithSubids($exportAllProducts);
				$_SESSION['bongo_count_with_no_subids'] =  $bongoExport->getProductsCountWithNoSubids($exportAllProducts);
				$_SESSION['bongo_done_with_subids'] = 0;
				$_SESSION['bongo_done_with_no_subids'] = 0;

				$count = $_SESSION['bongo_count_with_subids'] + $_SESSION['bongo_count_with_no_subids'];

				$result = array('result' => 1, 'count' => $count);

				echo json_encode($result);

				die();
				break;
			}

			/**
			 * Do actual synchronization
			 */
			case 'synch' :
			{
				$offset = isset($_REQUEST['offset']) ? intval($_REQUEST['offset']) : 0;
				
				if ($_SESSION['bongo_done_with_subids'] < $_SESSION['bongo_count_with_subids'])
				{
					$result = $bongoExport->getProductsWithSubids($exportAllProducts, $offset, 10);
					$c = $bongoExport->synch($result, $_SESSION['bongo_categories']);
					$_SESSION['bongo_done_with_subids'] = $_SESSION['bongo_done_with_subids'] + $c;
				}
				else if ($_SESSION['bongo_done_with_no_subids'] < $_SESSION['bongo_count_with_no_subids'])
				{
					$result = $bongoExport->getProductsWithNoSubids($exportAllProducts, $offset - $_SESSION['bongo_count_with_subids'], 10);
					$c = $bongoExport->synch($result, $_SESSION['bongo_categories']);
					$_SESSION['bongo_done_with_no_subids'] = $_SESSION['bongo_done_with_no_subids'] + $c;
				}

				$processed = $_SESSION['bongo_done_with_subids'] + $_SESSION['bongo_done_with_no_subids'];

				if ($processed >= $_SESSION['bongo_count_with_subids'] + $_SESSION['bongo_count_with_no_subids'])
				{
					unset($_SESSION['bongo_categories']);
					unset($_SESSION['bongo_count_with_subids']);
					unset($_SESSION['bongo_count_with_no_subids']);
					unset($_SESSION['bongo_done_with_subids']);
					unset($_SESSION['bongo_done_with_no_subids']);
				}

				$result = array('result' => 1, 'processed'=> $processed);

				echo json_encode($result);
				die();
				break;
			}
		}
	}

	$last_active_tab = isset($_REQUEST['last_active_tab']) ? $_REQUEST['last_active_tab'] : "main";

	pageHeader('Bongo Checkout');

	pageNote(array(
		array(
			"class"=>"ic-info", 
			"text"=>"Please click here for Bongo Checkout Settings", 
			"url"=>"admin.php?p=payment_method&mode=update&payment_method_id=bongocheckout", 
			"visible"=>true
		)
   	));

	echo '<div class="admin-tabs admin-tabs-framed" id="tabs-bongo">';

	pageTabs(array(
		array("title"=>"About Bongo Checkout", "id"=>"main"),
		array("title"=>"CSV Export", "id"=>"csv"),
		array("title"=>"API Import", "id"=>"api"),
		array("title"=>"Shipping Settings", "id"=>"address"),
	), 'tabs-bongo', $last_active_tab);

	$states = array();
	$result = $db->query('SELECT stid, name, short_name FROM '.DB_PREFIX.'states WHERE coid=1 ORDER BY name');
	while ($db->moveNext($result, MYSQL_ASSOC)) $states[] = $db->col;

	// TODO: move in repository, optimize, recheck condition for USA
	$domesticShippingMethods = $db->selectAll('
		SELECT ssid, method_name
		FROM '.DB_PREFIX.'shipping_selected
		WHERE
			method_id <> "product_level"
			AND
			(country="0" OR country="1" OR country LIKE "1,%" OR country LIKE "%,1,%" OR country LIKE "%,1")
			AND
			(country_exclude IS NULL OR (country_exclude<>"1" AND country_exclude NOT LIKE "1,%" AND country_exclude NOT LIKE "%,1,%" AND country_exclude NOT LIKE "%,1"))
		ORDER BY priority
	');

	$adminView->assign('shippingMethods', $domesticShippingMethods);

	$adminView->assign('states', $states);
	$adminView->assign('settings', $settings);
	$adminView->assign('referrer', defined('IS_LABEL') && IS_LABEL ? '' : base64_decode('cGlubmFjbGUtY2FydC8='));
	$adminView->assign('bongocheckout_ExtendJS', $settings['bongocheckout_ExtendJS']);
	$adminView->render('pages/bongo/bongo-main-tab');
	$adminView->render('pages/bongo/bongo-csv-tab');
	$adminView->render('pages/bongo/bongo-api-tab');
	$adminView->render('pages/bongo/bongo-address-tab');

	echo '</div>';