<?php
/**
 * Bulk uploader step 1
 */
	if (!defined("ENV")) exit();

	// products bulk uploader - step 1
	pageNote(array(
		array("class"=>"ic-info", "text"=>
			"This section will allow you to upload category data into your shopping cart from a .CSV file only. ".
			"Most database programs (including Excel) will allow you to import or save data in this format. ".
			"The data must have a delimiter (comma or semicolon) and each line must contain data specific to the category. ".
			"Once uploaded, ".$label_app_name." will ask you which column represents what data type (Category Key, Name, Meta keywords, etc). ".
			$label_app_name." uses Category Key as a data key and any category with a duplicate key will be overwritten with the new data. ".
			"This is a 3 step process and the data will not be stored until the final step is complete.", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>Please fill out this form carefully!</b>", "visible"=>true),
	));
?>
<form action="admin.php?p=bulk_categories" method="post" name="frmBulk" id="frmBulk" enctype="multipart/form-data">
	<input type="hidden" name="step" value="2">
	<div class="admin-tabs admin-tabs-framed" id="tabs-category">
<?php 
	pageTabs(array(
		array("title"=>"Bulk Uploading - Step 1", "id"=>"main"),
	), "tabs-category", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Uploading settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Delimeter used to separate the data</td>
						<td class="formItemControl">
							<select name="fields_separator">
								<option value=",">Comma (,)</option>
								<option value=";">Semicolon (;)</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Show uploaded categories?</td>
						<td class="formItemControl">
							<select name="make_categories_visible">
								<option value="Yes">Yes, make them visible</option>
								<option value="No">No, hide them</option>
							</select>
							<div class="formItemComment">
								Depending on your choice, the bulk loader will show categories on a site or will hide them.
								You may also set this option in the uploaded file.
							</span>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Change categories visibility?</td>
						<td class="formItemControl">
							<select name="make_categories_visible_type">
								<option value="inserted">Inserted only</option>
								<option value="updated">Inserted and Updated</option>
							</select>
							<div class="formItemComment">
								Apply category visibility choice to inserted categories only, or all categories in uploaded file.
							</span>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Choose CSV file from local drive</b></td>
						<td class="formItemControl"><input type="file" name="bulk"></td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Upload file" />
		<input type="reset" value="Reset form" />
	</div>
</form>