<?php
/**
 * Bulk uploader step 2
 */
	if (!defined("ENV")) exit();
	
	$is_error = false;

	// check is file is really CSV file
	if ($_FILES["bulk"]["name"] == "")
	{
		$is_error = true;
		$error_message = "Please choose .CSV file with categories";
	}
	else
	{
		// open temporary file
		$f = @fopen($_FILES["bulk"]["tmp_name"], "r");
		if (!$f)
		{
			$is_error = true;
			$error_message = "Can't open file with categories!";
		}
		else
		{
			// load CSV file
			$lines = array();
			$max_fields = 0;
			$lines_count = 0;
			while ($line = fgetcsv($f, 4096, $fields_separator))
			{
				$max_fields = $max_fields > count($line)?$max_fields:count($line);
				if (count($lines) < 10) $lines[] = $line;
				$lines_count++;
			}
			fclose($f);
			// move uplaoded file to a temporary folder
			$tmp_file_name =  md5(uniqid(rand(),1));
			if (!copy($_FILES["bulk"]["tmp_name"], "content/cache/tmp/".$tmp_file_name))
			{
				$is_error = true;
				$error_message = "Can not save temporary file. Please check free space and permissions.";
			}
			else
			{
				pageNote(array(
					array("icon"=>"ic_import.gif", "text"=>
						"Uploaded file name : <b>".$_FILES["bulk"]["name"]."</b><br>".
						"Total lines : <b>".$lines_count."</b><br>",
						"url"=>"", "visible"=>true
					),
					array("icon"=>"ic_hint.gif", "text"=>"<b>Please make sure so data is loaded correctly!</b>", "url"=>"", "visible"=>true),
					array("icon"=>"ic_hint.gif", "text"=>"Please note : all blank lines will be skipped. Required fields are Category Key and Name", "url"=>"", "visible"=>true)
				));
				loadJS("bulkloader.js");
?>
<form action="admin.php?p=bulk_categories" method="post" onSubmit="return checkCategoriesAssignForm(this)">
	<input type="hidden" name="step" value="3">
	<input type="hidden" name="file_name" value="<?=$tmp_file_name?>">
	<input type="hidden" name="make_categories_visible" value="<?=$make_categories_visible?>">
	<input type="hidden" name="fields_separator" value="<?=$fields_separator?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-category">
<?php 
				pageTabs(array(
					array("title"=>"Bulk Uploading - Step 2", "id"=>"main"),
				), "tabs-category", false);
?>

		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header admin-icon-upload">Assign fields with data</div>
				<table width="100%" cellpadding="5" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th style="width:160px;">Select Field</th>
							<th style="width:135px;">CSV Line 1</th>
							<th style="width:135px;">CSV Line 2</th>
							<th style="width:135px;">CSV Line 3</th>
							<th style="width:135px;">CSV Line 4</th>
							<th style="width:135px;">CSV Line 5</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
<?php	
				for ($i=0; $i<$max_fields; $i++)
				{
					echo '<tr>';
					echo '<td class="icon">&nbsp;</td>';
					echo '<td>';
					echo '<select name="fields['.$i.']" class="fields-selector" style="font-size:12px;font-family:Arial Narrow">';
					reset($fields_names);
					while (list($fname, $farray) = each($fields_names))
					{
						echo '<option value="'.$fname.'" '.($farray[2]?'style="color:red"':'').'>'.gs($farray[0]).'</option>';
					}
					echo '</select>';
					echo '</td>';
							
					for ($j=0;(($j < count($lines)) && ($j < 5)); $j++)
					{
						echo '<td onMouseOver="showDiv(\'div'.($i."_".$j).'\', this)" onMouseOut="hideDiv(\'div'.($i."_".$j).'\', this)" style="border-bottom:1px solid #e0e0e0;width:135px;">';
						if (isset($lines[$j][$i])) echo $j<count($lines[$j])?(is_numeric(trim($lines[$j][$i]))?($lines[$j][$i]):(htmlspecialchars(substr($lines[$j][$i], 0, 30)).(strlen($lines[$j][$i])>30?"...":""))):"&nbsp;";
						echo $j<count($lines[$j])?('<div id="div'.($i."_".$j).'" style="width:200px;border:1px solid black;padding:5px;background-color:#F7F7FF;display:none;position:absolute;">'.htmlspecialchars(isset($lines[$j][$i]) ? $lines[$j][$i] : "** EMPTY **").'</div>'):"&nbsp;";
						echo "&nbsp;</td>";
					}
					echo '<td>&nbsp;</td>';
					echo '</tr>';
				}
?>
					</tbody>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Update categories" /> &nbsp;
		<input type="button" value="Back" onClick="history.back();return false;"/>
	</div>
</form>
<?			}
		}
	}
	if ($is_error)
	{
		pageNote(array(
			array("icon"=>"ic_error.gif", "text"=>"<b>".$error_message."</b><br/><br/><br/>".'<input type="button" value="Back" onClick="javascript:history.back();return false;">', "url"=>"", "visible"=>true)
		));
	}
?>