<?php
/**
 * Bulk images update
 */

	if (!defined("ENV")) exit();

	pageHeader("Bulk Image Loader", "", "ic_images_loader.gif");

	$images_count = $settings["CatalogLoaderImages"];
	$step = isset($step)?$step*1:1;
	$step = in_array($step, array(1,2))?$step:1;
	switch ($step)
	{
		/**
		 * STEP 1: SHOW LOAD FORM
		 */
		case 1 : 
		{
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"This section will allow you to add images to products already existing in your shopping cart.<br/>Please note, the file names need to be EXACTLY the same as the Product ID for ".$label_app_name." to match the image with the product.<br/>Example, if the Product ID is my_bike, the image name must be my_bike.jpg or my_bike.gif.", "url"=>"", "visible"=>true),
				array("icon"=>"ic_hint.gif", "text"=>"<b>Please note: only .jpg, .png and .gif will be accepted.</b>", "url"=>"", "visible"=>true),
			));
?>
<form action="admin.php?p=bulk_images" enctype="multipart/form-data" method="post">
	<input type="hidden" name="step" value="2">
	<div class="admin-tabs admin-tabs-framed" id="tabs-images">
<?php 
			pageTabs(array(
				array("title"=>"Images Loader", "id"=>"main"),
			), "tabs-images", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header admin-icon-upload">Choose images to upload</div>

				<table width="100%" cellpadding="0" cellspacing="5" border="0">

<?php
				for ($i=0; $i < $images_count; $i++)
				{
?>
					<tr>
						<td class="formItemCaption">Image #<?=($i+1)?> :</td>
						<td class="formItemControl">
							<input type="file" name="image[]" style="width:250px;">
						</td>
					</tr>
<?php
				}
?>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Upload images" /> &nbsp;
		<input type="reset" value="Reset form" />
	</div>
</form>
<?php
			break;
		}
		/**
		 * STEP 2 : LOAD IMAGES
		 */
		case 2 : 
		{
			pageNote(array(
				array("icon"=>"ic_import.gif", "text"=>"Click here to upload images again", "url"=>"", "visible"=>true, "url"=>"admin.php?p=bulk_images")
			));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-images">
<?php 
			pageTabs(array(
				array("title"=>"Images Loader", "id"=>"main"),
			), "tabs-images", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-upload">Images upload result</div>
			<table width="100%" cellpadding="5" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th style="width:100px;">Images</th>
						<th>Result</th>
					</tr>
				</thead>
				<tbody>
<?php
			$counter = 0;
			for ($i=0; $i<$images_count; $i++)
			{
				$message = "<i>File was not uploaded.</i>";
				if (!empty($_FILES["image"]["tmp_name"][$i]))
				{
					//check is image type correct
					$image_data = @getImageSize($_FILES["image"]["tmp_name"][$i]);
					if ($image_data && in_array($image_data[2], $imageTypes))
					{
						$file_data = pathinfo($_FILES["image"]["name"][$i]);
						$product_id = strtolower(trim(substr($file_data["basename"], 0, strlen($file_data["basename"]) - strlen($file_data["extension"]) - 1)));
						for ($k=0; $k<strlen($product_id); $k++)
						{
							if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "%";
						}

						$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."'");

						if (!DEMO_LOCK && ($product = $db->moveNext()) != false)
						{
							$pid = $product["pid"];
							$destination = $product_images_dir."/".imageFileName($product_id).".";
							//remove existing image & thumbs
							@unlink($destination."jpg");
							@unlink($destination."png");
							@unlink($destination."gif");
							@unlink($product_thumbs_dir."/".imageFileName($product_id).".jpg");
							//add new fil extension
							switch ($image_data[2])
							{
								case IMAGETYPE_GIF: $destination.="gif"; break;
								case IMAGETYPE_JPEG: $destination.="jpg"; break;
								case IMAGETYPE_PNG: $destination.="png"; break;
							}
							if (@copy($_FILES["image"]["tmp_name"][$i], $destination))
							{
								$counter++;
								//in case of JPG and PNG image generate thumb
								if (!DEMO_LOCK)
								{
									if (in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG)))
									{
										getImageThumb($destination, $product_thumbs_dir."/".imageFileName($product_id).".jpg", $settings["CatalogThumbSize"], $settings["CatalogThumbType"], $error);
									}
									$db->query("UPDATE ".DB_PREFIX."products SET image_url='', image_location='Local' WHERE pid='".$pid."'");
								}
								$message = "<b>".$_FILES["image"]["name"][$i]." - File has been successfully uploaded.</b><br>Product Name: ".gs($product["title"])."<br>Image Dimensions: ".$image_data["0"]."x".$image_data["1"]."<br>File Size: ".number_format($_FILES["image"]["size"][$i]/1024, 2, ".", ",")." KB";
							}
							else
							{
								$message = "<font color=red>".$_FILES["image"]["name"][$i]." - Can't copy file to the destination folder. Please check free space and permissions.</font>";
							}
						}
						else
						{
							$message = "<font color=red>".$_FILES["image"]["name"][$i]." - Can't assign image with product by Product ID.</font>";
						}
					}
					else
					{
						$message = "<font color=red>".$_FILES["image"]["name"][$i]." - Incorrect image type: ".$_FILES["image"]["type"][$i].".</font>";
					}
				}
?>
					<tr>
						<td class="icon"></td>
						<td>Image #<?=$i+1?></td>
						<td><?=$message?></td>
					</tr>
<?php
			}
?>
				</tbody>
			</table>
		</div>
	</div>
</div>

<?php 
			pageNote(array(
				array("icon"=>"ic_import.gif", "text"=>"Images loaded : <b>".$counter."</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("icon"=>"ic_jpg.gif", "text"=>"Load images again", "url"=>"admin.php?p=bulk_images"),
				array("icon"=>"ic_product.gif", "text"=>"Browse products", "url"=>"admin.php?p=products")
			));
			break;
		}
	}
?>
		