<?php
/**
 * Bulk uploader step 3
 */

	if (!defined("ENV")) exit();

	$fields = isset($fields) ? $fields : array();
	$fields = is_array($fields) ? $fields : array();

	$make_manufacturers_visible = isset($make_manufacturers_visible) ? $make_manufacturers_visible : 'No';

	if (!in_array($make_manufacturers_visible, array('Yes', 'No'))) $make_manufacturers_visible = 'No';

	$make_manufacturers_visible_type = isset($make_manufacturers_visible_type) ? $make_manufacturers_visible_type : 'inserted';

	$is_error = false;
	$file_name = isset($file_name)?$file_name:"";
	$f = @fopen("content/cache/tmp/".$file_name, "r");

	if (!$f)
	{
		$is_error = true;
		$error_message = "Can't open file with manufacturers!";
	}
	else
	{
		if ((!in_array("manufacturer_code", $fields)) || (!in_array("manufacturer_name", $fields)))
		{
			$is_error = true;
			$error_message = "Please choose all required fields!";
		}
		
		if (DEMO_LOCK)
		{
			$is_error = true;
			$error_message = "This feature is not available in demo mode";
		}

		if (!$is_error)
		{
			$lines = array();
			$max_fields = 0;
			while ($line = fgetcsv ($f, 8192, $fields_separator))
			{
				if (!empty($line))
				{
					$lines[count($lines)] = $line;
					$max_fields = $max_fields > count($line)?$max_fields:count($line);
				}
			}
			fclose($f);
			//

			$insert_count = 0;
			$update_count = 0;

			// first pass - insert new manufacturers first
			// preload manufacturer data - on this step we only need manufacturers keys to check does manufacturer already exists
			$manufacturers = array();
			$db->query("SELECT manufacturer_code FROM ".DB_PREFIX."manufacturers");
			while ($db->moveNext())
			{
				$manufacturers[strtolower(trim($db->col["manufacturer_code"]))] = true;
			}

			for ($i = 0; $i < count($lines); $i++)
			{
				$line = $lines[$i];
				$data = array();
				for ($j=0; $j<count($line); $j++) if ($fields[$j] != "skip")
				{
					$data[$fields[$j]] = getUTF8(trim($line[$j]));
				}

				if (in_array(trim(strtolower(str_replace(' ', '', $data['manufacturer_code']))), array('key', 'id', 'manufacturerkey', 'manufacturerid', 'manufacturercode')))
				{
					continue;
				}

				// check is it a new manufacturer or existing one
				// basically on that pass we only create an empty manufacturer record to assign manufacturer_code with manufacturer_id
				$_key_name = strtolower(trim($data["manufacturer_code"]));
				if (!isset($manufacturers[$_key_name]) && $_key_name != "" && !($_key_name == 'manufacturercode' || $_key_name == 'manufacturerid'))
				{
					$db->reset();
					$db->assignStr("manufacturer_code", $data["manufacturer_code"]);
					$db->assignStr('manufacturer_name', $data['manufacturer_name']);

					if (isset($data['url_custom'])) $db->assignStr('url_custom', $data['url_custom']);

					$db->assignStr("is_visible", (isset($data['is_visible']) ? $data['is_visible'] : $make_manufacturers_visible) == 'Yes' ? 1 : 0);
					$db->insert(DB_PREFIX."manufacturers");

					$insert_count++;
				}
				else
				{
					// update manufacturer
					$db->reset();
					$db->assignStr('manufacturer_name', $data['manufacturer_name']);

					if (isset($data['url_custom'])) $db->assignStr('url_custom', $data['url_custom']);

					if (isset($data['is_visible']))
					{
						$db->assignStr("is_visible", $data['is_visible'] == 'Yes' ? 1 : 0);
					}
					else if ($make_manufacturers_visible_type == 'updated')
					{
						$db->assignStr('is_visible', $make_manufacturers_visible == 'Yes' ? '1' : '0');
					}

					$db->update(DB_PREFIX."manufacturers", " WHERE manufacturer_code='".$db->escape($data['manufacturer_code'])."'");

					$update_count++;
				}
			}

			// Update seo URLs
			updateSeoURLs($db, $settings, true, true, false, true);

			// Get fileds involved in update
			$used_fields = ""; // <-- those always used
			$j = 0;
			for ($i=0; $i<count($fields); $i++)
			{	
				if ($fields[$i] != "skip")
				{
					$used_fields.= ", ".$fields_names[$fields[$i]][0];
					$j++;
				}
			}

			@unlink("content/cache/tmp/".$file_name);

			// Final notes
			pageNote(array(
				array(
					"class"=>"ic-info", 
					"text"=>
						"New Manufacturers: <b>".$insert_count."</b><br/>".
						"Updated Manufacturers: <b>".$update_count."</b><br/>".
						"Used fields: <b>".$used_fields."</b>",
					"url"=>"",
					"visible"=>true
				)
			));

			pageWhat(array(
				array("text"=>"Start loading manufacturers again",	"url"=>"admin.php?p=bulk_manufacturers"),
				array("text"=>"Manage manufacturers", "url"=>"admin.php?p=manufacturers"),
			));
		}
	}

	if ($is_error)
	{
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>".$error_message."</b>", "url"=>"", "visible"=>true)
		));
?>
<blockquote>
	<form action="admin.php?p=bulk_manufacturers" method="GET">
		<input type="submit" value="Back"/>
	</form>
</blockquote>
<?
	}