<?php
/**
 * Bulk products uploader
 */

	set_time_limit(100000);

	if (!defined("ENV")) exit();
	
	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level){
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}
	
	$is_selected_cat = false;
	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param){
			global $is_selected_cat;
			if($this->id!=$param->id){
				if($this->id != TREE_ROOT){
					//echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					echo '<option value="'.$this->id.'" '.($is_selected_cat==false?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					$is_selected_cat = true;
				}
				for($i=0; $i<($param->level-1)*4; $i++){
					echo "&nbsp;";
				}
				echo gs($this->caption).'</option>';
				if(count($this->nodes)>0){
					while(list($id, $node) = each($this->nodes)){
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	//load categories
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Please Select a Category"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	while (($category = $db->moveNext()) != false)
	{
		$tree->addNode(
			new OPTION_NODE(
				$category["cid"], 
				$category["parent"], 
				$category["level"], 
				$category["is_visible"],
				$category["name"]
			)
		);
	}
	
	// set fields for uploading
	//0 - caption
	//1 - default value
	//2 - required
	//3 - boolean
	$fields_names = array();
		
	
	$fields_names["skip"] = array("Skip", "", false, false, array(), "");	
	
	$fields_names["product_id"] = array("Product ID", "", true, false, array("productid", "id"), "Product ID, ID");
	
	$fields_names["is_visible"] = array("Available", "Yes", false, true, array("available", "visible", "isavailable", "isvisible", "isactive"), "Available, Visible, Active, Is available, Is visible, Is active");
	
	$fields_names["product_sku"] = array("Product SKU", "", false, false, array("productsku", "sku"), "Product SKU, SKU");
	
	$fields_names["product_upc"] = array("UPC code", "", false, false, array("upc", "productupc", "upccode"), "UPC, Product UPC, UPC code");
	
	$fields_names["title"] = array("Name", "", true, false, array("producttitle", "title", "productname", "name"), "Product title, Title, Product name, Name");
	
	$fields_names["price"] = array("Price", "", true, false, array("productprice", "price", "itemprice"), "Product price, Price, Item price");
	
	$fields_names["cost"] = array("Cost", "0.00", false, false, array("productcost", "cost", "itemcost"), "Product Cost, Cost, Item cost");
	
	$fields_names["category"] = array("Secondary Categories", "", false, false, array("secondarycategory", "categorykey", "categorykeys", "secondarycategories"), "Secondary Category, Category key, Category keys, Secondary Categories");

	
	/*$fields_names["category"] = array("Category keys", "", false, false, array("category", "categorykey", "categorykeys", "categories"), "Category, Category key, Category keys, Categories");*/
	
	$fields_names["manufacturer"] = array("Manufacturer ID", "0", false, false, array("manufacturer", "manufacturerid", "manufacturerkey", "manufacturercode"), "Manufacturer, Manufacturer ID, Manufacturer key, Manufacturer code");
	
	$fields_names["location"] = array("Product location", "0", false, false, array("location", "productlocation", "itemlocation", "locationcode"), "Location, Product location, Item location, Location code, Location ID, Location key");
		
	$fields_names["is_locked"] = array("Is locked", "", false, false, array("locked", "lock", "is_locked", "productlocked"), "Locked, Lock, Is locked, Produck locked");
	$fields_names["lock_fields"] = array("Lock fields", "", false, false, array("locks", "lockfields", "readonly"), "Locks, Lock fields, Read only");
	
	$fields_names["meta_keywords"] = array("Meta keywords", "", false, false, array("metakeyword", "metakeywords", "keyword", "keywords"), "Meta keyword, Meta keywords, Keyword, Keywords");
	$fields_names["meta_title"] = array("Meta title", "", false, false, array("metatitle"), "Meta title");
	$fields_names["meta_description"] = array("Meta description", "", false, false, array("metadescription"), "Meta description");

	$fields_names["url_custom"] = array("Custom URL", "", false, false, array("producturl", "customurl", "url", "seourl", "urlcustom"), "Custom URL");

	
	$fields_names["call_for_price"] = array("Call for price", "No", false, true, array("call", "callforprice"), "Call, Call for price");
	
	$fields_names["is_taxable"] = array("Is taxable", "Yes", false, true, array("istaxable", "taxable"), "Is taxable, Taxable");
	
	$fields_names["tax_class_id"] = array("Tax class key", "0", false, false, array("taxclass", "taxclassid", "taxclasskey"), "Tax class, Tax class id, Tax class key");
	
	$fields_names["tax_rate"] = array("Tax rate - Product Level", "-1.00000", false, false, array("taxrate", "taxrateproductlevel"), "Tax rate, TaxRateProductLevel");
	
	$fields_names["price2"] = array("Sale price", "", false, false, array("saleprice", "sale"), "Sale Price, Sale");
		
	//$fields_names["price_level_1"] = array("Price level 1", "0.00", false, false, array("pricelevel1"), "Price Level 1");
	//$fields_names["price_level_2"] = array("Price level 2", "0.00", false, false, array("pricelevel2"), "Price Level 2");
	//$fields_names["price_level_3"] = array("Price level 3", "0.00", false, false, array("pricelevel3"), "Price Level 3");
	//$fields_names["price_level_1"] = array("Price Level 1", "0.00", false, false, array("price_level_1", "pricelevel1"), "Price_Level_1, Pricelevel1");
	//$fields_names["price_level_2"] = array("Price Level 2", "0.00", false, false, array());
	//$fields_names["price_level_3"] = array("Price Level 3", "0.00", false, false, array());	
	
	$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE carrier_id='custom' AND method_id='product_level'");
	while (($shipping_selected = $db->moveNext()) != false)
	{
		$n = "Shipping Price - ".$shipping_selected["carrier_name"];
		$s = strtolower(preg_replace("/[^A-Za-z0-9]/", "", $n ));
		$fields_names["shipping_price_".$shipping_selected["ssid"]] = array($n, "0.00", false, false, array($s), $n);
	}
		
	$fields_names["free_shipping"] = array("Free shipping", "No", false, true, array("freeshipping", "shippingisfree"), "Free shipping, Shipping is free");
	
		
	$fields_names["inter_pack"] = array("Inter pack", "0", false, false, array("interpack", "inter"), "Inter pack, Inter");
	$fields_names["case_pack"] = array("Case pack", "0", false, false, array("casepack", "case"), "Case pack, Case");
		
	$fields_names["min_order"] = array("Min order", "1", false, false, array("min_order", "minorder"), "Minorder, Minorder");
	$fields_names["max_order"] = array("Max order", "0", false, false, array("max_order", "maxorder"), "Maxorder, Maxorder");
		
	$fields_names["is_home"] = array("On home page", "No", false, true, array("ishome", "onhomepage", "homepage"), "Is home, On home page, Show on home page");
	$fields_names["is_hotdeal"] = array("Is hotdeal", "No", false, true, array("ishotdeal", "hotdeal"), "Is hotdeal, Hotdeal");
	$fields_names["is_dollar_days"] = array("DollarDays Product", "No", false, true, array("dollardays", "isdollardays", "dollardaysproduct", "isdollardaysproduct"), "Dollar Days, Is Dollar Days, Dollar Days product, Is Dollar Days product");
	$fields_names["is_doba"] = array("Doba product", "No", false, true, array("doba", "isdoba", "dobaproduct", "isdobaproduct"), "Doba, Is Doba, Doba product, Is Doba product");
		
	$fields_names["digital_product"] = array("Is digital product", "No", false, true, array("digital", "isdigital", "digitalproduct", "downloadable"), "Digital, Is digital, Digital Product, Downloadable");
	$fields_names["digital_product_file"] = array("Digital product file", "", false, false, array("digitalproductfile", "digitalfile", "digitalfilename", "downloadfile", "downloadfilename"), "Digital product file, Digital file, Digital file name, Ddownload file, Download file name");
		
	if (_ACCESS_ALL || _ACCESS_INVENTORY)
	{
		$fields_names["inventory_control"] = array("Track inventory", "No", false, true, array("inventorycontrol", "trackinventory"), "Track inventory, Inventory control");
		$fields_names["stock"] = array("Stock", "0", false, false, array("stock", "itemsinstock"), "Stock, Items in stock");
		$fields_names["stock_warning"] = array("Stock warning", "0", false, false, array("minstock", "stockwarning"), "Min. stock, Stock warning");
		$fields_names["inventory_rule"] = array("Inventory rule", "Hide", false, false, array("inventoryrule"), "Inventory rule"); //'Hide', 'OutOfStock'
	}
	
	$fields_names["overview"] = array("Overview", "", false, false, array("productoverview", "overview", "quickoverview"), "Product overview, Overview, Short description");
	$fields_names["description"] = array("Product Description", "", false, false, array("productdescription", "description"), "Product description, Description");
		
	$fields_names["image_url"] = array("Image URL", "", false, false, array("imageurl"), "Image URL");
	$fields_names["zoom_option"] = array("Image zooming option", "global", false, false, array("imagezoomingoption", "zoomoption", "imagezooming", "zoomingtype"), "Image zooming option, Zoom option, Image zooming, Zooming type");
	$fields_names["image_alt_text"] = array("Image alt text", "", false, false, array("imagealttext", "imagetext"), "Image alt text, image text");
	
	$fields_names["product_sub_id"] = array("Product Sub ID", "", false, false, array(), "");
	$fields_names["product_sub_id_stock"] = array("Items in stock on attr. level", "", false, false, array(), "");
	
	$attributes_count = 10;
	$attribute_fields = array();
	if (_ACCESS_ALL || _ACCESS_ATTRIBUTES)
	{
		for ($i = 1; $i <= 10; $i++)
		{	
			$fields_names["attribute_type_".$i] = array("Attribute type ".$i, "", false, false, array("attributetype".$i), "Attribute Type ".$i);
			$fields_names["attribute_name_".$i] = array("Attribute name ".$i, "", false, false, array("attributename".$i), "Attribute Name ".$i);
			$fields_names["attribute_caption_".$i] = array("Attribute caption ".$i, "", false, false, array("attributecaption".$i), "Attribute Caption ".$i);
			$fields_names["attribute_options_".$i] = array("Attribute options ".$i, "", false, false, array("attributeoptions".$i), "Attribute Options ".$i);
			$fields_names["attribute_priority_".$i] = array("Attribute priority ".$i, "", false, false, array("attributepriority".$i), "Attribute Priority ".$i);
			$attribute_fields[] = "attribute_type_".$i;
			$attribute_fields[] = "attribute_name_".$i;
			$attribute_fields[] = "attribute_caption_".$i;
			$attribute_fields[] = "attribute_options_".$i;
			$attribute_fields[] = "attribute_priority_".$i;
		}
	}

// customized field types	
	$fields_names["weight"] = array("Unit Weight LBS", "0", false, false, array("weight", "productweight", "unitweightlbs"), "Weight, Product weight, Unitweight");
	$fields_names["priority"] = array("Sorting priority", "0", false, false, array("priority", "sortingpriority"), "Priority, SortingPriority");
	$fields_names["equipment_type"] = array("Equipment Type","", true, false, array("equipment_type ", "equipmenttype"), "Equipment_Type , EquipmentType");
	$fields_names["size"] = array("Size","", true, false, array("size ", "size"), "Size , Size");
	$fields_names["year"] = array("Year","", true, false, array("year ", "year"), "Year , Year");
	$fields_names["condition1"] = array("PTIC Condition","", true, false, array("condition1 ", "pticcondition"), "Condition1 , Condition");
	$fields_names["pdf_name"] = array("PDF File Name","", false, false, array("pdf_name ", "pdffilename"), "PDF_Name , PDFName");
	$fields_names["shipping_price"] = array("Shipping Price", "0.00", false, false, array("shipping_price", "price1", "shippingpriceforproductlevel"), "Shipping_Price, Price1, ShippingPrice");
	$fields_names["length_inches"] = array("PTIC Length Inches", "0.00", false, false, array("length_inches", "inch", "pticlengthinches"), "Length_Inches, Inch, Lengthinches");
	$fields_names["width_inches"] = array("PTIC Width Inches", "0.00", false, false, array("width_inches", "inch", "pticwidthinches"), "Width_Inches, Inch, Widthinches");
	$fields_names["height_inches"] = array("PTIC Height Inches", "0.00", false, false, array("height_inches", "inch", "pticheightinches"), "Height_Inches, Inch, Heightinches");
	/*
	$fields_names["pticweight"] = array("PTIC Weight LBS", "0", false, false, array("pticweight","pticweightlbs"), "PTICWeight, PTICWeight");
	
	$fields_names["length_feets"] = array("Length Feet", "0.00", false, false, array("length_feets", "feet", "lengthfeet"), "Length_Feets, Feet, Lengthfeet");
	$fields_names["width_feets"] = array("Width Feet", "0.00", false, false, array("width_feets", "feet", "widthfeet"), "Width_Feets, Feet, Widthfeet");
	$fields_names["height_feets"] = array("Height Feet", "0.00", false, false, array("height_feets", "feet", "heightfeet"), "Height_Feets, Feet, Heightfeet");
	$fields_names["length_cms"] = array("Length Cm", "0.00", false, false, array("length_cms", "cms", "lengthcm"), "Length_Cms, Cms, LengthCm");
	$fields_names["width_cms"] = array("Width Cm", "0.00", false, false, array("width_cms", "cms", "widthcm"), "Width_Cm, Cms,  WidthCm");
	$fields_names["height_cms"] = array("Height Cm", "0.00", false, false, array("height_cms", "cms", "heightcm"), "Height_Cms, Cms,  HeightCm");
	*/
	$fields_names["tire_condition"] = array("Tire Condition", "0.00", false, false, array("tire_condition", "tire condition", "tirecondition"), "Tire_Condition, Condition, TireCondition");
	$fields_names["paint_condition"] = array("Paint Condition", "0.00", false, false, array("paint_condition", "paint condition", "paintcondition"), "Paint_Condition, Condition, Paintcondition");
	$fields_names["engine_condition"] = array("Engine Condition", "0.00", false, false, array("engine_condition", "engine condition", "enginecondition"), "Engine_Condition, Condition, Enginecondition");
	$fields_names["pump_condition"] = array("Pump Condition", "0.00", false, false, array("pump_condition", "pump condition", "pumpcondition"), "Pump_Condition, Condition, Pumpcondition");
	$fields_names["trailer_condition"] = array("Trailer Condition", "0.00", false, false, array("trailer_condition", "trailer condition", "trailercondition"), "Trailer_Condition,  Trailer Condition, Trailercondition");
	$fields_names["hose_condition"] = array("Hose Condition", "0.00", false, false, array("hose_condition", "hose condition", "hosecondition"), "Hose_Condition, Hose Condition, Hosecondition");
	$fields_names["hose_length"] = array("Hose Length", "0.00", false, false, array("hose_length", "length", "hoselength"), "Hose_Length, Length, Hoselength");
	$fields_names["hose_type"] = array("Hose Type", "0.00", false, false, array("hose_type", "type", "hosetype"), "Hose_Type, Type, Hosetype");
	$fields_names["consigned_status"] = array("Consigned?","", true, false, array("consigned_status ", "consignformstatus"), "Consigned_Status , Consigned");
	$fields_names["consignee_ask_price"] = array("Owner Wants Price","", false, false, array("consignee_ask_price ", "ownerwantsprice"), "Consignee_Ask_price , ConsigneeAskPrice");
	$fields_names["consignee_low_price"] = array("Owner Lowest Price","", false, false, array("consignee_low_price ", "ownerlowestprice"), "Consignee_Low_price , ConsigneeLowprice");
	$fields_names["owner_company"] = array("Owner Company","", true, false, array("owner_company ", "ownercompany"), "Owner_Company , OwnerCompany");
	
	$fields_names["owner_name"] = array("Owner First Name","", false, false, array("owner_name ", "ownername", "ownerfirstname"), "Owner_First_Name ,  OwnerFirstName, OwnerName");	
	
	$fields_names["owner_lname"] = array("Owner Last Name","", false, false, array("owner_lname ", "ownerlname","ownerlastname"), "Owner_Lname ,  OwnerLname, Owner Last Name");
	
	$fields_names["owner_address1"] = array("Owner Address 1","", false, false, array("owner_address1 ", "owneraddress1"), "Owner_Address1 ,  OwnerAddress1");
	$fields_names["owner_address2"] = array("Owner Address 2","", false, false, array("owner_address2 ", "owneraddress2"), "Owner_Address2 ,  OwnerAddress2");
	$fields_names["owner_city"] = array("Owner City/Town","", false, false, array("owner_city ", "ownercity"), "Owner_City ,  OwnerCity");
	$fields_names["owner_state"] = array("Owner State/Prov/Trtry","", false, false, array("owner_state", "ownerstate"), "Owner_State ,  OwnerState");
	$fields_names["owner_zip"] = array("Owner Zip/Postal Code","", false, false, array("owner_zip ", "ownerzip"), "Owner_Zip ,  OwnerZip");
	$fields_names["owner_country"] = array("Owner Country","", false, false, array("owner_country ", "ownercountry"), "Owner_Country ,  OwnerCountry");
	$fields_names["owner_phone"] = array("Owner Phone","", false, false, array("owner_phone ", "ownerphone"), "Owner_Phone ,  OwnerPhone");
	$fields_names["owner_mobile"] = array("Owner Mobile","", false, false, array("owner_mobile ", "ownermobile"), "Owner_Mobile ,  OwnerMobile");
	$fields_names["owner_fax"] = array("Owner Fax","", false, false, array("owner_fax ", "ownerfax"), "Owner_Fax ,  OwnerFax");
	
	$fields_names["owner_email"] = array("Owner Email","", false, false, array("owner_email ", "owneremail"), "Owner_Email ,  OwnerEmail");
	
	$fields_names["move_date"] = array("Move by Date","", false, false, array("move_date ", "movebydate"), "Move_Date ,  MovebyDate");
	$fields_names["min_sell_price"] = array("Min Sell Price", "0.00", false, false, array("min_sell_price", "minsellprice"), "Min_Sell_price, MinSellprice");
	
	//$fields_names["list_price1"] = array("List Price1", "0.00", false, false, array("list_price1", "listprice1"), "List_Price1 ,Listprice1");
	$fields_names["list_price2"] = array("List Price2", "0.00", false, false, array("list_price2", "listprice2"), "List_Price2 ,Listprice2");
	$fields_names["list_price3"] = array("List Price3", "0.00", false, false, array("list_price3", "listprice3"), "List_Price3 ,Listprice3");
	////////////////////////////////////////////
	//-----items added by mahesh.k.s -----------//
	$fields_names["new_or_used"] = array("New/Used", "", true, false, array("new_or_used", "pticstatus"), "New_Or_Used ,NewUsed");
	$fields_names["model"] = array("Model", "", false, false, array("model", "model"), "Model ,Model");
	$fields_names["capacity"] = array("Capacity", "", false, false, array("capacity", "capacity"), "Capacity ,Capacity");
	$fields_names["hoursmeter"] = array("Hours Meter", "", false, false, array("hoursmeter", "hoursmeter"), "Hoursmeter ,Hoursmeter");
	$fields_names["vin"] = array("Vin#", "", false, false, array("vin", "vin"), "Vin ,Vin");
	$fields_names["serial"] = array("Serial#", "", false, false, array("serial", "serial"), "Serial ,Serial");
	$fields_names["mso_included"] = array("MSO Included?", "", false, false, array("mso_included", "msoincluded"), "Mso_Included ,MsoIncluded");
	$fields_names["title_included"] = array("Title Included?", "", false, false, array("title_included", "titleincluded"), "Title_Included ,TitleIncluded");
	$fields_names["liens"] = array("Liens?", "", false, false, array("liens", "liens"), "Liens ,Liens");
	$fields_names["liens_amount"] = array("Liens Amount", "", false, false, array("liens_amount", "liensamount"), "Liens_Amount ,LiensAmount");	
	$fields_names["item"] = array("Item #", "", false, false, array("item", "item"), "Item ,Item");
	$fields_names["item_addr1"] = array("Item Address1", "", false, false, array("item_addr1", "itemaddress1"), "Item_Addr1 ,ItemAddr2");
	$fields_names["item_addr2"] = array("Item Address2", "", false, false, array("item_addr2", "itemaddress2"), "Item_Address2 ,ItemAddress2");
	$fields_names["item_city"] = array("Item City", "", false, false, array("item_city", "itemcity"), "Item_City ,ItemCity");
	$fields_names["item_state"] = array("Item State", "", false, false, array("item_state", "itemstate"), "Item_State ,ItemState");
	$fields_names["item_zip"] = array("Item Zip", "", false, false, array("item_zip", "itemzip"), "Item_Zip ,ItemZip");
	$fields_names["item_country"] = array("Item Country", "", false, false, array("item_country", "itemcountry"), "Item_Country ,ItemCountry");
	
	$fields_names["item_email"] = array("Item Email","", false, false, array("item_email ", "itememail"), "Item_Email ,  ItemEmail");
	
	$fields_names["loading_method"] = array("Loading Method", "", false, false, array("loading_method", "loadingmethod"), "Loading_Method ,LoadingMethod");
	$fields_names["loading_contact"] = array("Loading Contact", "", false, false, array("loading_contact", "loadingcontact"), "Loading_Contact ,LoadingContact");
	$fields_names["loading_phone"] = array("Loading Phone", "", false, false, array("loading_phone", "loadingphone"), "Loading_Phone ,LoadingPhone");
	$fields_names["loading_hours"] = array("Loading Hours", "", false, false, array("loading_hours", "loadinghours"), "Loading_Hours ,LoadingHours");
	$fields_names["move_by_date"] = array("Move by Date", "", false, false, array("move_by_date", "movebydate"), "Move_by_Date ,MovebyDate");
	$fields_names["zip_from"] = array("Zip From", "", false, false, array("zip_from", "zipfrom"), "Zip_From ,ZipFrom");
	$fields_names["zip_to"] = array("Zip To", "", false, false, array("zip_to", "zipto"), "Zip_To ,ZipTo");
	$fields_names["cost_per_mile"] = array("Cost Per Mile", "", false, false, array("cost_per_mile", "costpermile"), "Cost_Per_Mile ,CostPerMile");	
	
	$fields_names["owner_last_contact_date"] = array("Owner Last Contact Date", "", false, false, array("owner_last_contact_date", "ownerlastcontactdate"), "Owner_Last Contact_Date ,OwnerLastContactDate");  

	$fields_names["inter_pack"] = array("Inter Pack", "-1.00", false, false, array("inter_pack", "interpack"), "Inter_Pack ,InterPack");  
	
	$fields_names["case_pack"] = array("Case Pack", "-1.00", false, false, array("case_pack", "casepack"), "Case_Pack ,CasePack");  
	
	$fields_names["is_sold"] = array("Is Sold", "No", false, false, array("is_sold", "issold"), "Is_Sold, IsSold");
	
	$fields_names["owner_last_contact_date"] = array("Owner Last Contact Date", "", false, false, array("owner_last_contact_date", "ownerlastcontactdate"), "Owner_Last_Contact_Date, OwnerLastContactDate");

	/*
	$fields_names["owner_want_price"] = array("Owner Wants Price", "", false, false, array("owner_want_price", "ownerwantsprice"), "Owner_Wants_Price,OwnerWantsPrice");
	$fields_names["owner_lowest_price"] = array("Owner Lowest Price", "", false, false, array("owner_lowest_price", "ownerlowestprice"), "Owner_Lowest_Price,OwnerLowestPrice");
	*/
	
	///----------end ---------------//
	
	$bool_true = array("true", "yes", "1", "ok", "on");
	$bool_false = array("false", "no", "0", "not", "off");
	
?>