<?php
/**
 * Bulk uploader step 1
 */

	if (!defined("ENV")) exit();

	// products bulk uploader - step 1
	pageNote(array(
		array("class"=>"ic-info", "text"=>"This section will allow you to upload product data into your shopping cart from a .CSV file only. Most database programs (including Excel) will allow you to import or save data in this format. The data must have a delimiter (comma or semicolon) and each line must contain data specific to the product. Once uploaded, ".$label_app_name." will ask you which column represents what data type (Product ID, Product Name, Price, etc). ".$label_app_name." uses Product ID as a data key and any product with a duplicate ID will be overwritten with the new data. This is a 3 step process and the data will not be stored until the final step is complete", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>Please note: Products with undefined weight and shipping price will be automatically marked as Free Shipping</b>", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>Please fill this form very carefully!</b>", "url"=>"", "visible"=>true)
	));
?>
<form action="admin.php?p=bulk_products" method="post" name="frmBulk" id="frmBulk" enctype="multipart/form-data">
	<input type="hidden" name="step" value="2">
	<div class="admin-tabs admin-tabs-framed" id="tabs-product">
<?php 
	pageTabs(array(
		array("title"=>"Bulk Uploading - Step 1", "id"=>"main"),
	), "tabs-product", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Uploading settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Select default category</td>
						<td class="formItemControl">
							<select name="cid">
<?php
	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM(-1, TREE_ROOT, 0)
	);
?>
							</select>
							<div class="formItemComment">Products with undefined category will be moved in selected category</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Delimeter used to separate the data</td>
						<td class="formItemControl">
							<select name="fields_separator">
								<option value=",">Comma (,)</option>
								<option	value=";">Semicolon (;)</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Data update rule</td>
						<td class="formItemControl">
							<div>
								<input type="radio" name="update_rule" value="keep" id="update_rule_keep" checked="checked">
								<label for="update_rule_keep">Update existing products &amp; Add new products</label><br/>
								
								<input type="radio" name="update_rule" value="clean" id="update_rule_clean">
								<label for="update_rule_clean">Remove all existing products &amp; Add new products</label><br/>
								
								<input type="radio" name="update_rule" value="update_only" id="update_rule_update_only">
								<label for="update_rule_update_only">Update existing products only &amp; Do not add new products</label><br/>
								
								<input type="radio" name="update_rule" value="overwrite" id="update_rule_overwrite">
								<label for="update_rule_overwrite">Update existing products, reset fields to default values &amp; Add new products</label>
							</div>
							<div class="formItemComment">
								If the bulk loader encounters a duplicate Product ID, should it overwrite the existing data with the bulk loaded data, keep it, or clear existing products?
							</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Uploaded products availability</td>
						<td class="formItemControl">
							<select name="make_products_visible">
								<option value="Yes">Products are available for sale</option>
								<option value="No">Products are not available for sale</option>
							</select>
							<div class="formItemComment">
								Depending on your choice, the bulk loader will set a Product Availability option.
								You may also set this option in the uploaded file.
							</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Choose CSV file from local drive</td>
						<td class="formItemControl">
							<input type="file" name="bulk">
							<div class="formItemComment">
								Please note: max uploaded file size is <?php echo ini_get("upload_max_filesize");?>
							</div>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Upload file" />
		<input type="reset" value="Reset form" />
	</div>
</form>