<?php
/**
 * Bulk uploader step 3
 */

	if (!defined("ENV")) exit();
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."products");
	$db->moveNext();
	$productsCount = $db->col["c"];

	$skipped_products = 0;
	
	$fields = isset($fields) ? $fields : array();
	$fields = is_array($fields) ? $fields : array();

	$is_error = false;
	$file_name = isset($file_name)?$file_name:"";
	$f = @fopen("content/cache/tmp/".$file_name, "r");
	
	if (!$f)
	{
		$is_error = true;
		$error_message = "Can't open file with products!";
	}
	else
	{
		// check required fields
		if ($update_rule == "update_only")
		{
			if (!in_array("product_id", $fields))
			{
				$is_error = true;
				$error_message = "Please choose all required fields!";
			}
		}
		else
		{
			if ((!in_array("product_id", $fields)) || (!in_array("title", $fields)) || (!in_array("price", $fields)))
			{
				$is_error = true;
				$error_message = "Please choose all required fields!";
			}
		}
		
		if (!$is_error)
		{
			//preread file to get max fields
			$max_fields = 0;
			while ($line = fgetcsv ($f, 4096*2, $fields_separator))
			{
				if (!empty($line))
				{
					$max_fields = $max_fields > count($line)?$max_fields:count($line);
				}
			}
			fclose($f);
			
			//preload products ids
			$existing_products = array();
			$db->query("SELECT pid, product_id FROM ".DB_PREFIX."products");
			while ($db->moveNext())
			{
				$existing_products[strtolower(trim($db->col["product_id"]))] = $db->col["pid"];
			}
			
			// prepare default value for reset values
			$reset_sql = "";
			reset($fields_names);
			foreach ($fields_names as $fname => $farray)
			{
				if (
					!in_array($fname, $attribute_fields) && substr($fname, 0, 14) != "shipping_price" && 
					!in_array($fname, array("category", "manufacturer", "location", "lock"))
				)
				{
					if (!in_array($fname, $fields))
					{
						if ($farray[1] != "" && $fname != "is_visible")
						{
							$reset_sql.=", ".$fname."='".$farray[1]."'";
						}
					}
				}
			}
			
			//load manufacturers
			$manufacturers = array();
			$db->query("SELECT manufacturer_id, manufacturer_code FROM ".DB_PREFIX."manufacturers");
			while ($db->moveNext())
			{
				$manufacturers[strtolower($db->col["manufacturer_code"])] = $db->col["manufacturer_id"];
			}
			
			//load locations
			$locations = array();
			$db->query("SELECT products_location_id, code FROM ".DB_PREFIX."products_locations");
			while ($db->moveNext())
			{
				$locations[strtolower($db->col["code"])] = $db->col["products_location_id"];
			}
			
			// prepare category keys
			$category_keys = array();
			$db->query("SELECT cid, key_name FROM ".DB_PREFIX."catalog WHERE key_name<>'' ORDER BY level DESC, priority DESC, name DESC ");
			while ($db->moveNext())
			{
				$ck = explode(",", $db->col["key_name"]);
				for ($i=0; $i<count($ck); $i++)
				{
					if (trim($ck[$i])!="")
					{
						$category_keys[trim($ck[$i])] = $db->col["cid"];
					}
				}
			}
			
			// prepare tax class keys if necessary
			$tax_class_keys_hash = array();
			$tax_class_keys = array();
			if (in_array("tax_class_id", $fields))
			{
				$db->query("SELECT class_id, key_name FROM ".DB_PREFIX."tax_classes WHERE key_name<>''");
				while ($db->moveNext())
				{
					$ck = explode(",", $db->col["key_name"]);
					for ($i=0; $i<count($ck); $i++)
					{
						if (trim($ck[$i])!="")
						{
							$tax_class_keys_hash[strtolower(trim($ck[$i]))] = $db->col["class_id"];
						}
					}
				}
				$tax_class_keys = array_keys($tax_class_keys_hash);
			}
			
			$insert_count = 0;
			$update_count = 0;
			
			$f = @fopen("content/cache/tmp/".$file_name, "r");
			while ($line = fgetcsv ($f, 4096*2, $fields_separator))
			{
				if (empty($line)) continue;
				
				//assign field names with values
				$data = array();
				for ($j=0; $j<count($line); $j++)
				{
					if ($fields[$j]!="skip")
					{
						$data[$fields[$j]] = getUTF8(trim($line[$j]));
					}
				}
				
				if (array_key_exists("price2", $data) && (is_numeric($data["price2"])))
				{
					if ($data["price2"] > 0)
					{
						$_price = $data["price"];
						$data["price"] = $data["price2"];
						$data["price2"] = $_price;
					}
					elseif($data["price2"] == 0)
					{						
						$data["price"] = $data["price"];
						$data["price2"] = 0;
					}
				}

				//check required fields are correct
				if(
					($update_rule == "update_only" && $data["product_id"] == "") ||
					($update_rule != "update_only" && (($data["product_id"] == "") || ($data["title"] == "") || (!is_numeric($data["price"]))))
				){
					//Ignored. Reason - one or more required fields are blank or contain invalid data</td>
				}
				else
				{
					// check categories
					$pid = false;
					
					$sync_product_attributes = in_array('attribute_type_1', $fields);

					$product_attributes = array();
					$product_categories = array();
					$shipping_prices = array();
					$primary_category = false;
					$categories_set = false;
					if (in_array("category", $fields))
					{
						$product_category_keys = explode("||", $data["category"]);
						
						for ($ck=0; $ck<count($product_category_keys); $ck++)
						{
							$product_category_key = trim($product_category_keys[$ck]);
							if ($product_category_key != "")
							{
								if (array_key_exists($product_category_key, $category_keys))
								{
									$_cid = $category_keys[$product_category_key];
									$primary_category = $primary_category ? $primary_category : $_cid; //the very first one id primary
									$product_categories[$_cid] = $_cid;
								}
							}
						}
						$categories_set = true;
					}
					
					if (count($product_categories) < 1)
					{
						$product_categories[$cid] = $cid;
					}
					
					$primary_category = $primary_category ? $primary_category : $cid;
					
					// map the correct tax class key if provided
					if (in_array('tax_class_id', $fields) && trim($data['tax_class_id']) != '' && in_array(strtolower($data['tax_class_id']), $tax_class_keys))
					{
						$data['tax_class_id'] = $tax_class_keys_hash[strtolower($data['tax_class_id'])];
					}
					
					$is_new_product = false;
					// check product exists in database by product_id
					$db->query("SELECT pid, title, price, lock_fields FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($data["product_id"])."'");
					
					if ($db->moveNext())
					{
						$_stored_title = $db->col["title"];
						$_stored_price = $db->col["price"];
						
						$lock_fields = explode(",", $db->col["lock_fields"]);
						$lock_fields = is_array($lock_fields) ? $lock_fields : array();

						$lock_fields = normalizeProductLockFields($lock_fields);

						$pid = $db->col["pid"];
						
						//mark product will not be removed
						$existing_products[strtolower(trim($data["product_id"]))] = false;
						
						if ($update_rule == "keep" || $update_rule == "update_only")
						{
							if ($categories_set)
							{
								$sql = "UPDATE ".DB_PREFIX."products SET cid=".(in_array("category", $lock_fields) ? "cid " : "'".$primary_category."' ");
							}
							else
							{
								$sql = "UPDATE ".DB_PREFIX."products SET cid=cid ";
							}
						}
						else
						{
							$sql = "UPDATE ".DB_PREFIX."products SET cid=".(in_array("category", $lock_fields) ? "cid " : "'".$primary_category."' ");
						}
						
						// update product
						$status = "updated";
						reset($data);
						
						foreach ($data as $field_name => $field_value)
						{
							$field_info = $fields_names[$field_name];
							
							$update_field = true;
							if ($field_name == "title" && in_array("name", $lock_fields)) $update_field = false;
							elseif ($field_name == "price" && in_array("price", $lock_fields)) $update_field = false;
							elseif ($field_name == "price2" && in_array("sale-price", $lock_fields)) $update_field = false;
							elseif ($field_name == "description" && in_array("description", $lock_fields)) $update_field = false;
							elseif ($field_name == "overview" && in_array("overview", $lock_fields)) $update_field = false;
							elseif ($field_name == "meta_title" && in_array("meta-title", $lock_fields)) $update_field = false;
							elseif ($field_name == "meta_keywords" && in_array("meta-keywords", $lock_fields)) $update_field = false;
							elseif ($field_name == "meta_description" && in_array("meta-description", $lock_fields)) $update_field = false;
							elseif ($field_name == "image_url" && in_array("images", $lock_fields)) $update_field = false;
							
							if ($update_field && !in_array($field_name, $attribute_fields) && substr($field_name, 0, 14) != "shipping_price")
							{
								//field info
								//update fields SQL
								if (!in_array($field_name, array("category","manufacturer","location","product_sub_id","product_sub_id_stock","lock_fields","inventory_control",'product_sub_options')) && !$field_info[3])
								{
									$sql.=", ".$field_name."='".$db->escape($field_value)."'";
								}
								//check boolean values
								if (!in_array($field_name, array("category","manufacturer","location","product_sub_id","product_sub_id_stock","lock_fields","inventory_control",'product_sub_options')) && $field_info[3])
								{
									if (in_array(strtolower($field_value), $bool_true))
									{
										$field_value = "Yes";
									}
									elseif (in_array(strtolower($field_value), $bool_false))
									{
										$field_value = "No";
									}
									else
									{
										$field_value = $field_info[1];
									}
									$sql.=", ".$field_name."='".$db->escape($field_value)."'";
								}
								
								//check image
								if ($field_name == "image_url" && trim($field_value) != "")
								{
									$sql.=", image_location='".(trim($field_value) != ""?"Web":"Local")."'";
								}
								
								if ($field_name == "manufacturer" && array_key_exists(strtolower($data[$field_name]), $manufacturers))
								{
									$sql.=", manufacturer_id='".$manufacturers[strtolower($data[$field_name])]."'";
								}
								if ($field_name == "location" && array_key_exists(strtolower($data[$field_name]), $locations))
								{
									$sql.=", products_location_id='".$locations[strtolower($data[$field_name])]."'";
								}
								if ($field_name == 'inventory_control')
								{
									if (trim($field_value) == '')
										$field_value = 'No';

									$sql.=", ".$field_name."='".$db->escape($field_value)."'";
								}
								if ($field_name == "lock_fields")
								{
									$sql.=", lock_fields='".$db->escape(implode(",", explode("||", $data[$field_name])))."'";
								}
							}
							else
							{
								for ($i_count = 0; $i_count <= $attributes_count; $i_count++)
								{
								
									if ($field_name == "attribute_name_".$i_count &&
										trim($data["attribute_type_".$i_count]) != "" &&
										trim($data["attribute_name_".$i_count]) != "" &&
										trim($data["attribute_caption_".$i_count]) != "" &&
										trim($data["attribute_options_".$i_count]) != ""
									){
										$product_attributes[] = array(
											"type"=>$data["attribute_type_".$i_count],
											"name"=>$data["attribute_name_".$i_count],
											"caption"=>$data["attribute_caption_".$i_count],
											"options"=>$data["attribute_options_".$i_count],
											"priority"=>isset($data["attribute_priority_".$i_count]) ? $data["attribute_priority_".$i_count] : 0,
											'track_inventory' => isset($data['attribute_track_'.$i_count]) ? $data['attribute_track_'.$i_count] : 0,
										);
									}
								}
								if (substr($field_name, 0, 14) == "shipping_price" && trim($data[$field_name]) != "" && is_numeric($data[$field_name]))
								{
									$ssid = substr($field_name, 15, strlen($field_name) - 14);
									$shipping_prices[$ssid] = $data[$field_name];
								}
							}
						}
						
						if (!isset($data["is_visible"]))
						{
							$sql.=", is_visible='".$make_products_visible."'";
						}
						
						if ($update_rule=="overwrite")
						{
							$sql.=$reset_sql;
						}
						$sql.=" WHERE pid='".$pid."'";

                                                if (!DEMO_LOCK)
						{
							$db->query($sql);
						}
						$update_count++;
					}
					else
					{
						$lock_fields = array();
						$is_new_product = true;
						// to avoid inserting new products when performing update_only
						if($update_rule != "update_only"){
							// insert product
							$status = "inserted";

							$sql1 = "INSERT INTO ".DB_PREFIX."products(added, cid";
							$sql2 = "VALUES(NOW(),'".$primary_category."'";
						
							// prepare global
							foreach ($data as $field_name => $field_value)
							{
								$field_info = $fields_names[$field_name];
								if (!in_array($field_name, $attribute_fields) && substr($field_name, 0, 14) != "shipping_price")
								{
									if (!in_array($field_name, array("category","manufacturer","location","product_sub_id","product_sub_id_stock","lock_fields",'inventory_control','product_sub_options')) && !$field_info[3])
									{
										$sql1.=", ".$field_name;
										$sql2.=", '".$db->escape($field_value)."'";
									}
								
									//check boolean values
									if (!in_array($field_name, array("category","manufacturer","location","product_sub_id","product_sub_id_stock","lock_fields",'inventory_control','product_sub_options')) && $field_info[3])
									{
										if (in_array(strtolower($field_value), $bool_true))
										{
											$field_value = "Yes";
										}
										elseif (in_array(strtolower($field_value), $bool_false))
										{
											$field_value = "No";
										}
										else
										{
											$field_value = $fields_names[$field_name][1];
										}
										$sql1.=", ".$field_name;
										$sql2.=", '".$db->escape($field_value)."'";
									}
								
									//check image
									if ($field_name == "image_url")
									{
										$sql1.=", image_location";
										$sql2.=", '".(trim($field_value) != ""?"Web":"Local")."'";
									}
									
									if ($field_name == "manufacturer" && array_key_exists(strtolower($data[$field_name]), $manufacturers))
									{
										$sql1.=", manufacturer_id";
										$sql2.=", '".$manufacturers[strtolower($data[$field_name])]."'";
									}
									if ($field_name == 'inventory_control')
									{
										if (trim($field_value) == '')
											$field_value = 'No';

										$sql1.=', inventory_control';
										$sql2.=", '".$db->escape($field_value)."'";
									}
									if ($field_name == "location" && array_key_exists(strtolower($data[$field_name]), $locations))
									{
										$sql1.=", products_location_id";
										$sql2.=", '".$locations[strtolower($data[$field_name])]."'";
									}
									if ($field_name == "lock_fields")
									{
										$sql1.=", lock_fields";
										$sql2.=", '".$db->escape(implode(",", explode("||", $data[$field_name])))."'";
									}
								}
								else
								{
									for ($i_count = 1; $i_count <= 10; $i_count++)
									{
										if ($field_name == "attribute_name_".$i_count &&
											trim($data["attribute_type_".$i_count]) != "" &&
											trim($data["attribute_name_".$i_count]) != "" &&
											trim($data["attribute_caption_".$i_count]) != "" &&
											trim($data["attribute_options_".$i_count]) != ""
										){
											$product_attributes[] = array(
												"type"=>$data["attribute_type_".$i_count],
												"name"=>$data["attribute_name_".$i_count],
												"caption"=>$data["attribute_caption_".$i_count],
												"options"=>$data["attribute_options_".$i_count],
												"priority"=>isset($data["attribute_priority_".$i_count]) ? $data["attribute_priority_".$i_count] : 0,
											'track_inventory' => isset($data['attribute_track_'.$i_count]) ? $data['attribute_track_'.$i_count] : 0,
											);
										}
									}
									
									if (substr($field_name, 0, 14) == "shipping_price" && trim($data[$field_name]) != "" && is_numeric($data[$field_name])){
										$ssid = substr($field_name, 15, strlen($field_name) - 14);
										$shipping_prices[$ssid] = $data[$field_name];
									}
								}
							}
							if (!isset($data["is_visible"]))
							{
								$sql1.=", is_visible";
								$sql2.=", '".$make_products_visible."'";
							}

							if (!isset($data["tax_rate"]))
							{
								$sql1.=", tax_rate";
								$sql2.=", -1.00000";
							}

							$sql = $sql1.") ".$sql2.")";
							
							if (!DEMO_LOCK)
							{
								if (AccessManager::checkAccess('MAX_PRODUCTS') > $productsCount)
								{
									$db->query($sql);
									$pid = $db->insertId();
									$productsCount++;
									$insert_count++;
								}
								else
								{
									$skipped_products++;
								}
							}
							else
							{
								$insert_count++;
							}
						}
					}
					
					// we have a valid product id to update/edit
					if ($pid) {
						
						//fix for http://.../mantis/view.php?id=425
						if ($update_rule != "update_only")
						{
							if(($update_rule != "keep") || (!$is_new_product)){
								if(count($product_attributes) <= 0 && $sync_product_attributes){
									$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE pid='".$pid."'");
								}
							}
						}
							
						if ($update_rule != "update_only" || !$is_new_product)
						{
							$update_categories = true;
							if (($update_rule =="keep" || $update_rule == "update_only") && !$categories_set && !$is_new_product)
							{
								$update_categories = false;
							}
							
							//update categories
							if (!DEMO_LOCK && !in_array("category", $lock_fields))
							{
								if ($update_categories)
								{
									$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."'");
									if (!in_array($primary_category, $product_categories))
									{
										$product_categories[$primary_category] = $primary_category;
									}
									foreach ($product_categories as $product_cat)
									{
										$db->query("INSERT INTO ".DB_PREFIX."products_categories (pid, cid, is_primary) VALUES ('".$pid."', '".$product_cat."', '".($product_cat == $primary_category?"1":"0")."')");
									}
								}
							}
						
							//update shipping prices
							if (count($shipping_prices))
							{
								if (!DEMO_LOCK)
								{
									foreach ($shipping_prices as $ssid=>$shipping_price)
									{
										$db->query("SELECT * FROM ".DB_PREFIX."products_shipping_price WHERE pid='".$pid."' AND ssid='".$ssid."'");
										if ($db->moveNext())
										{ 
											$db->reset();
											$db->assignStr("is_price", "Yes");
											$db->assignStr("price", $shipping_price);
											$db->update(DB_PREFIX."products_shipping_price", "WHERE pid='".$pid."' AND ssid='".$ssid."'");
										}
										else
										{
											$db->reset();
											$db->assignStr("pid", $pid);
											$db->assignStr("ssid", $ssid);
											$db->assignStr("is_price", "Yes");
											$db->assignStr("price", $shipping_price);
											$db->insert(DB_PREFIX."products_shipping_price");
										}
									}
								}
							}
							
							//update attributess
							if (count($product_attributes) > 0 && $sync_product_attributes)
							{
								if (!DEMO_LOCK)
								{
									$names = array();

									for ($aa = 0; $aa < count($product_attributes); $aa++)
									{
										$pa = $product_attributes[$aa];
										$names[] = '\''.$db->escape(trim($pa['name'])).'\'';
									}

									$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE pid='".$pid."' AND name NOT IN (".implode(',', $names).")");
									$db->query("SELECT paid, name FROM ".DB_PREFIX."products_attributes WHERE pid='".$pid."'");
									$attributeMap = array();
									while ($row = $db->moveNext())
									{
										$attributeMap[$row['name']] = $row['paid'];
									}

									for ($aa = 0; $aa < count($product_attributes); $aa++)
									{
										$pa = $product_attributes[$aa];
										$is_modifier = false;
										$options = "";
										if ($pa["type"] == "select" || $pa["type"] == "radio")
										{
											$_options = explode("||", $pa["options"]);
											for ($zz = 0; $zz < count($_options); $zz++)
											{
												if (trim($_options[$zz]) != "")
												{
													$options .= ($options == "" ? "" : "\n").trim($_options[$zz]);
													if (preg_match("/^.+\(\s*([+-]?)\s*((\d+)|(\d+\.\d+))\s*([%]?)\s*((\,([+-]?)\s*((\d+)|(\d+\.\d+))\s*([%]?))?)\s*\)\s*$/", trim($_options[$zz])))
													{
														$is_modifier = true;
													}
												}
											}
										}
										
										$db->reset();
										$db->assignStr("attribute_type", $pa["type"]);
										$db->assignStr("pid", $pid);
										$db->assignStr("gaid", "0");
										$db->assignStr("is_modifier", $is_modifier?"Yes":"No");
										$db->assignStr("is_active", "Yes");
										$db->assignStr("priority", $pa["priority"]);
										$db->assignStr("name", $pa["name"]);
										$db->assignStr("caption", $pa["caption"]);
										$db->assignStr('track_inventory', $pa['track_inventory']);
										if ($pa["type"] == "text" || $pa["type"] == "textarea")
										{
											$text_length = intval($pa["options"]);
											$db->assignStr("text_length",  $text_length > 0 ? $text_length : 20);
										}
										$db->assignStr("options", str_replace("||", "\n", $options));

										if (isset($attributeMap[$pa['name']]))
										{
											$db->update(DB_PREFIX.'products_attributes', 'WHERE paid='.$attributeMap[$pa['name']]);
										}
										else
										{
											$db->insert(DB_PREFIX."products_attributes");
										}
									}
								}
							}

							if (array_key_exists('product_sub_id', $data) && trim($data['product_sub_id']) != '')
							{
								$exists = false;
								$db->query('SELECT COUNT(*) as `count` FROM '.DB_PREFIX.'products_inventory'." WHERE pid='".intval($pid)."' AND product_subid='".$db->escape($data['product_sub_id'])."'");
								if ($row = $db->moveNext())
								{
									$exists = $row['count'] > 0;
								}

								$db->reset();

								if (array_key_exists('product_sub_id_stock', $data))
								{
									$db->assignStr('stock', intval($data['product_sub_id_stock']));
								}

								if (array_key_exists('product_sub_options', $data))
								{
									$options = explode('||', $data['product_sub_options']);

									$inv_attribute_option = array();
									foreach ($options as $option)
									{
										$idx = strpos($option, ':');

										$inv_attribute_option[substr($option, 0, $idx)] = trim(substr($option, $idx + 1));
									}

									$db->query("
										SELECT * FROM ".DB_PREFIX."products_attributes
										WHERE pid='".$pid."' AND is_active='Yes' AND track_inventory=1 AND (attribute_type='radio' OR attribute_type='select')
										ORDER BY priority, name, is_modifier
									");
								
									$attributes_hash = "";
									$attributes_list = "";
								
									while ($db->moveNext())
									{
										$attributes_hash = $attributes_hash.($attributes_hash == "" ? "" : "\n").$db->col["paid"].": ".$inv_attribute_option[$db->col["name"]];
										$attributes_list = $attributes_list.($attributes_list == "" ? "" : "\n").$db->col["name"].": ".$inv_attribute_option[$db->col["name"]];
									}
								
									$_hash = md5($attributes_hash);

									$db->assignStr('attributes_list', $data['product_sub_options']);
									$db->assignStr('attributes_hash', $_hash);
								}

								if ($exists)
								{
									$db->update(DB_PREFIX.'products_inventory', "WHERE pid='".intval($pid)."' AND product_subid='".$db->escape($data['product_sub_id'])."'");
								}
								else if ($update_rule != 'update_only')
								{
									$db->assignStr('pid', $pid);
									$db->assignStr('product_subid', $data['product_sub_id']);
									$db->assignStr('is_active', 1);

									$db->insert(DB_PREFIX.'products_inventory');

									$insert_count++;
								}

								if (array_key_exists('product_sub_id_stock', $data))
								{
									//update inventory on product level
									$db->query("SELECT SUM(stock) AS products_stock FROM ".DB_PREFIX."products_inventory WHERE pid='".$pid."'");
									$db->moveNext();
									$stock = $db->col["products_stock"];
									$db->reset();
									$db->assignStr("stock", $stock);
									$db->assignStr("stock_warning", 0);
									$db->update(DB_PREFIX."products", "WHERE pid='".$pid."'");

									$update_count++;
								}
							}
						}
					}
				}
			}
			
			if ($update_rule == "clean")
			{
				$products_removed = 0;
				reset($existing_products);
				
				foreach ($existing_products as $product_id=>$pid)
				{
					if ($pid)
					{
						$products_removed ++;
						//$product_id = strtolower(trim($db->col["product_id"]));
						$db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".$pid."'");
						if ($db->numRows()>0)
						{
							while ($db->moveNext())
							{
								if (!DEMO_LOCK)
								{
									@unlink($product_secondary_images_dir."/".$db->col["iid"].".jpg");
									@unlink($product_secondary_images_dir."/".$db->col["iid"].".gif");
									@unlink($product_secondary_images_dir."/".$db->col["iid"].".png");
									@unlink($product_secondary_images_dir."/".$db->col["iid"]."_thumb.jpg");
								}
							}
							if (!DEMO_LOCK)
							{
								$db->query("DELETE FROM ".DB_PREFIX."products_images WHERE pid='".$pid."'");
							}
						}
						
						if (!DEMO_LOCK)
						{
							$db->query("UPDATE ".DB_PREFIX."orders_content SET product_removed='Yes' WHERE pid='".$pid."'");
							$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE pid='".$pid."'");
							$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."'");
							$db->query("DELETE FROM ".DB_PREFIX."products WHERE pid='".$pid."'");
							@unlink($product_images_dir."/".$product_id.".jpg");
							@unlink($product_images_dir."/".$product_id.".png");
							@unlink($product_images_dir."/".$product_id.".gif");
							$productsCount--;
						}
					}
				}
			}
			//$db->query("UPDATE ".DB_PREFIX."products SET free_shipping='Yes' WHERE weight=0 AND shipping_price=0");
			
			$used_fields = "";
			$j = 0;
			for ($i=0; $i<count($fields); $i++)
			{	
				if ($fields[$i] != "skip")
				{
					$used_fields.= $j>0?", ":"";
					$used_fields.= $fields_names[$fields[$i]][0];
					$j++;
				}
			}
			
			updateSeoURLs($db, $settings, true, true, false, true);
			
			fclose($f);
			unlink("content/cache/tmp/".$file_name);
			
			pageNote(array(
				array(
					"class"=>"ic-info", 
					"text"=>
						"New Products: <b>".$insert_count."</b><br/>".
						"Updated Products: <b>".$update_count."</b><br/>".
						($update_rule == "clean"?("Removed Products: <b>".$products_removed."</b><br/>"):"").						
						($skipped_products > 0?("<br/><b>This upload has exceed the number of products allowed under your current cart package. Please contact customer support to upgrade your service.</b><br/>&nbsp;<br/>Skipped Products: <b>".$skipped_products."</b><br/>"):"").
						"Used fields: <b>".$used_fields."</b>",
					"url"=>"",
					"visible"=>true
				)
			));
			
			pageWhat(array(
				array("text"=>"Start loading products again", "url"=>"admin.php?p=bulk_products"),
				array("text"=>"Manage Product", "url"=>"admin.php?p=products")
			));
		}
	}
	
	if ($is_error)
	{
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>".$error_message."</b>", "url"=>"", "visible"=>true)
		));
?>
<blockquote>
	<form action="admin.php?p=bulk_products" method="GET">
		<input type="submit" value="Back"/>
	</form>
</blockquote>
<?
	}
	
	if (!DEMO_LOCK)
	{
		$tmp_table_name = 'attr_count_table_'.substr(md5(time().rand(0,1000)), 4, 8);

			$db->reset();
			$db->query("DROP TABLE IF EXISTS {$tmp_table_name}");
			$db->query("UPDATE ".DB_PREFIX."products SET attributes_count=0");
			$db->query("CREATE TEMPORARY TABLE {$tmp_table_name} (SELECT pid, COUNT(*) as attr_count FROM ".DB_PREFIX."products_attributes WHERE is_active = 'Yes' GROUP BY pid)");
			$db->query("UPDATE ".DB_PREFIX."products p, {$tmp_table_name} act SET p.attributes_count = act.attr_count WHERE p.pid = act.pid");
			$db->query("DROP TABLE IF EXISTS {$tmp_table_name}");
	}
?>