<?php
/**
 * Category
 */

	if (!defined("ENV")) exit();

	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OptionNode extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			if ($this->id!=$param->id)
			{
				echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?"style='color:gray;'":"").'>';
				for ($i=0; $i<$param->level*4; $i++)
				{
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
				if (count($this->nodes)>0)
				{
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}

		public function getValue()
		{
			return $this->id;
		}
		public function getLabel()
		{
			$temp = str_repeat('&nbsp;', ($this->level - 1) * 4);
			$temp .= gs($this->caption);

			return $temp;
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OptionNode(TREE_ROOT, -1, 0, "Yes", "Category Root"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	while ($db->moveNext())
	{
		$tree->addNode(
			new OptionNode(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}

	$cid = isset($cid)?$cid*1:"";
	$mode = isset($mode)?trim($mode):"";
	switch ($mode)
	{
		case "update" : 
		{
			$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid='".$cid."'");
			if ($db->moveNext())
			{

				$name = $db->col["name"];
				$parent = $db->col["parent"];
				$description = $db->col["description"];
				$description_bottom = $db->col["description_bottom"];
				$priority = $db->col["priority"];
				$is_visible = $db->col["is_visible"];
				$list_subcats = $db->col["list_subcats"];
				$key_name = $db->col["key_name"];
				$meta_keywords = $db->col["meta_keywords"];
				$meta_title = $db->col["meta_title"];
				$meta_description = $db->col["meta_description"];
				$category_header = $db->col["category_header"];
				$url_default = $db->col["url_default"];
				$url_custom = $db->col["url_custom"];
				$list_subcats_images = intval($db->col['list_subcats_images']);
				$exactor_euc_code = $db->col['exactor_euc_code'];
				$avalara_tax_code = $db->col['avalara_tax_code'];

				break;
			}
		}
		default :
		case "insert" : 
		{
			$mode = "insert";
			$cid = -1;
			$name = "";
			$parent = isset($parent)?$parent:TREE_ROOT;
			$description = "";
			$description_bottom = "";
			$key_name = "";
			$priority = 5;
			$is_visible = "Yes";
			$list_subcats = "No";
			$meta_keywords = "";
			$meta_title = "";
			$meta_description = "";
			$category_header = "";
			$url_default = "will be generated after category saved";
			$url_custom = "";
			$list_subcats_images = 0;
			$exactor_euc_code = '';
			$avalara_tax_code = '';
		}
	}
	//loadJS("cf_category.js");
	loadJS("cd_category.js");

	$taxService = Tax_ProviderFactory::getTaxService();
	if ($taxService instanceof Tax_Exactor_ExactorService)
	{
		loadJS('exactor.js');
	}

	pageHeader("Category", ucfirst(strtolower($mode)), "icb-folder");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"", "visible"=>true),
		array("class"=>"ic-trash-can", "text"=>"Remove this category", "url"=>"JavaScript:ConfirmDeleteCategory('".$cid."')", "visible" => $mode == "update")
	));

	$category_options = array();
	$tree->collection[TREE_ROOT]->flatten($category_options);

	$generalFormBuilder = new core_Form_FormBuilder('general');

	$categoryGroup = new core_Form_FormBuilder('basic', array('label'=>'Parent Category', 'class'=>'ic-folder', 'first'=>true));
	$generalFormBuilder->add($categoryGroup);

	$categoryGroup->add('parent', 'choice', array('label' => 'Select Parent Category', 'value' => $parent, 'required' => true, 'options' => $category_options, 'empty_value'=>array('0'=>'Category Root'),
		'attr' => array('class' => 'multiselect', 'size' => '10'),
		'note' => 'To add a parent category, highlight Category Root at the top. To assign a child category, highlight the category you want the new category appear under'));

	$propertiesGroup = new core_Form_FormBuilder('properties', array('label' => 'Category Properties', 'class' => 'ic-pencil'));
	$generalFormBuilder->add($propertiesGroup);

	$propertiesGroup->add('name', 'text', array('label' => 'Category Name', 'value' => $name, 'required' => true, 'attr' => array('maxlength' => '255')));
	$propertiesGroup->add('key_name', 'text', array('label' => 'Category Key / ID', 'value' => $key_name, 'required' => true, 'attr' => array('maxlength' => '255'),
		'note' => 'This will be used for bulk loading products. This might be the same as the Category name, but without spaces. Example: digital_recorders.'));
	$propertiesGroup->add('category_header', 'text', array('label' => 'Category Header', 'value' => $category_header, 'attr' => array('maxlength' => '255')));
	$propertiesGroup->add('is_visible', 'checkbox', array('label' => 'Is category visible to users?', 'value'=>'Yes', 'current_value'=>$is_visible));
	$propertiesGroup->add('list_subcats', 'checkbox', array('label' => 'List subcategories on Catalog Page?', 'value'=>'Yes', 'current_value'=>$list_subcats));
	$propertiesGroup->add('list_subcats_images', 'checkbox', array('label' => 'Display subcategory images on Catalog Page?', 'value'=>'1', 'current_value'=>$list_subcats_images));
	$propertiesGroup->add('priority', 'text', array('label' => 'Priority (used for sorting)', 'value' => $priority, 'attr' => array('maxlength' => 200)));

	$taxService = Tax_ProviderFactory::getTaxService();
	if ($taxService instanceof Tax_Avalara_AvalaraService)
	{
		$avalaraTaxCodesOptions = array(new core_Form_Option(0,'None'));
		$avalara_tax_codes = $db->selectAll("select * from ".DB_PREFIX."avalara_tax_codes");

		foreach ($avalara_tax_codes as $code_item)
		{
			$avalaraTaxCodesOptions[] = new core_Form_Option($code_item['code'], $code_item['code'].': '.$code_item['name']);
		}
		$propertiesGroup->add('avalara_tax_code', 'choice', array('label'=>'Avalara tax code', 'value'=> $avalara_tax_code, 'options'=>$avalaraTaxCodesOptions));
	}
	else if ($taxService instanceof Tax_Exactor_ExactorService)
	{
		$exactorTaxCodesOptions = array(new core_Form_Option(0,'None'));
		$exactor_tax_codes = $db->selectAll("select * from ".DB_PREFIX."exactor_tax_codes");

		foreach ($exactor_tax_codes as $code_item)
		{
			$exactorTaxCodesOptions[] = new core_Form_Option($code_item['code'], $code_item['code'].': '.$code_item['name']);
		}
		$propertiesGroup->add('exactor_euc_code', 'choice', array('label'=>'Exactor tax code', 'value'=> $exactor_euc_code, 'options'=>$exactorTaxCodesOptions));
	}

	$seoGroup = new core_Form_FormBuilder('seo_properties', array('label'=>'SEO Properties', 'class'=>'ic-zoom', 'collapsable'=>true));
	$generalFormBuilder->add($seoGroup);

	$seoGroup->add('meta_keywords', 'text', array('label'=>'Meta Keywords', 'value'=>$meta_keywords));
	$seoGroup->add('meta_title', 'text', array('label'=>'Meta Title', 'value'=>$meta_title));
	$seoGroup->add('meta_description', 'textarea', array('label'=>'Meta Description', 'value'=>$meta_description));
	$seoGroup->add('url_default', 'static', array('label'=>'Category Url (pre-generated)', 'value'=>'<span style="color:blue;text-decoration:underline;">'.$url_default.'</span>'));
	$seoGroup->add('url_custom', 'text', array('label'=>'Category Url (custom)', 'value'=>$url_custom));

	$descriptionGroup = new core_Form_FormBuilder('cat_desc_group', array('label'=>'Category Description (Top of Page)', 'class'=>'ic-pencil', 'hasWysiwyg'=>true, 'collapsable'=>true));
	$generalFormBuilder->add($descriptionGroup);
	$descriptionGroup->add('description', 'textarea', array('label' => '', 'wrapperClass' => 'field-full-width', 'value' => $description));

	$descriptionBottomGroup = new core_Form_FormBuilder('cat_desc_bot_group', array('label'=>'Category Description (Bottom of Page)', 'class'=>'ic-pencil', 'hasWysiwyg'=>true, 'collapsable'=>true));
	$generalFormBuilder->add($descriptionBottomGroup);
	$descriptionBottomGroup->add('description_bottom', 'textarea', array('label' => '', 'wrapperClass' => 'field-full-width', 'value' => $description_bottom));
?>
<div style="display:none;"><input type="hidden" id="delete-category-nonce" value="<?php echo create_nonce('category_delete'); ?>"/></div>

<form name="frmCategory" data-auto-validate="1" action="admin.php?p=category_process" method="post" onsubmit="return CheckCategoryForm(this)" enctype="multipart/form-data">
	<input type="hidden" name="cid" value="<?=$cid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="nonce" value="<?=create_nonce('category_'.$mode)?>">

<div class="admin-tabs admin-tabs-framed" id="tabs-category">
<?php 
	pageTabs(array(
		array("title"=>"Category Properties", "id"=>"main"),
		array("title"=>"QR Codes", "id"=>"qr", "visible" => $settings["qr_active"] == "Yes" && $mode == "update")
	), "tabs-category", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
<?php
	$adminView = Ddm_AdminView::getInstance();

	$adminView->assign('generalForm', $generalFormBuilder->getForm());

	$adminView->render('pages/category/category-info-tab');
?>
			<div class="admin-form-header"><span class="icon ic-icon ic-file-format-jpg"></span>Category Image</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">Image File</td>
					<td class="formItemControl">
						<input type="file" name="image" value="">
						<div class="formItemComment">(note: accepted file types are JPG, PNG and GIF)</div>
					</td>
				</tr>
	<?php
		if ($settings['CatalogCategoryThumbAuto'] == 'NO')
		{
	?>
				<tr valign="top">
					<td class="formItemCaption">Thumbnail Image</td>
					<td class="formItemControl">
						<input type="file" name="image_thumb">
					</td>
				</tr>
	<?php
		}
		$img_file = CategoryHasImage($cid);
		$thumb = CategoryHasThumb($cid);

		if ($img_file)
		{
			$size = getimagesize($img_file);
	?>
				<tr valign="top">
					<td class="formItemCaption"><b>Current Image:</b> (<?=$size[0]?>x<?=$size[1]?> pixels)</td>
					<td class="formItemControl">
						<input type="hidden" name="delete-category-image-nonce" id="delete-category-image-nonce" value="<?=create_nonce('category_delete_image');?>" />
						<img src="<?=$img_file?>?<?php echo filemtime($img_file); ?>" border="1" width="<?=$size[0]>500?500:$size[0]?>" border="0"><br/>
						<a href="javascript:ConfirmDeleteCategoryImage(<?=$cid?>)">Delete this image</a>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Thumbnail for this image</td>
					<td class="formItemControl">
	<?php
					if ($thumb)
					{
	?>
						<input type="hidden" name="delete-category-thumb-nonce" id="delete-category-thumb-nonce" value="<?=create_nonce('category_delete_thumb');?>" />
						<img src="<?=$thumb?>?<?=filemtime($thumb)?>" border="1"><br/>
						<a href="javascript:ConfirmDeleteCategoryThumb(<?=$cid?>)">Delete this image</a>
	<?php			
					}
					else
					{
						echo "There is no thumbnail for this image";
					}
	?>
					</td>
				</tr>
	<?php
		}
	?>
			</table>
		</div>
	</div>
	
<?php
	if ($settings["qr_active"] == "Yes" && $mode == "update")
	{
		require_once('content/classes/class.offsite_commerce_campaigns.php');
		$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
		$campaigns = $offsite_commerce_campaigns->getCampaigns("qr");

		loadJS('category_qr.js');
?>
	<div id="admin-tab-sheet-qr" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-raster"></span>QR Code for this category</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">QR Campaign</td>
					<td class="formItemControl">
						<select id="qr-generate-campaign-id">
							<option value="">No campaign</option>
<?php
if ($campaigns)
{
	foreach ($campaigns as $campaign)
	{
		echo '<option value="'.$campaign["campaign_id"].'">'.htmlspecialchars($campaign["name"]).'</option>';
	}
}
?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Image type</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-image-type">
							<option value="<?php echo IMAGETYPE_PNG;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_PNG ? "selected" : "";?>>PNG</option>
							<option value="<?php echo IMAGETYPE_JPG;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_JPG ? "selected" : "";?>>JPG</option>
							<option value="<?php echo IMAGETYPE_GIF;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_GIF ? "selected" : "";?>>GIF</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Media</td>
					<td class="formItemControl">
						<select id="qr-generate-media">
							<option value="1" <?php echo $settings["qr_media"] == "1" ? "selected" : "";?>>Web - Small</option>
							<option value="2" <?php echo $settings["qr_media"] == "2" ? "selected" : "";?>>Web - Big</option>
							<option value="3" <?php echo $settings["qr_media"] == "3" ? "selected" : "";?>>Print Ad - Small</option>
							<option value="4" <?php echo $settings["qr_media"] == "4" ? "selected" : "";?>>Print Ad - Big</option>
							<option value="5" <?php echo $settings["qr_media"] == "5" ? "selected" : "";?>>Parcel Label</option>
							<option value="6" <?php echo $settings["qr_media"] == "6" ? "selected" : "";?>>Factory Environment</option>
							<option value="0" <?php echo $settings["qr_media"] == "0" ? "selected" : "";?>>Custom</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Error correction level</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-error-check">
							<option value="L">Low</option>
							<option value="M" <?php echo $settings["qr_error_check"] == "M" ? "selected" : "";?>>Medium</option>
							<option value="Q" <?php echo $settings["qr_error_check"] == "Q" ? "selected" : "";?>>Good</option>
							<option value="H" <?php echo $settings["qr_error_check"] == "H" ? "selected" : "";?>>The best</option>
						</select>
						<div class="formItemComment">
							Low - approx. 7% of codewords can be restored.<br/>
							Medium - approx. 15% of codewords can be restored.<br/>
							Good - approx. 25% of codewords can be restored.<br/>
							The best - approx. 30% of codewords can be restored.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Pixels per QR Code dot</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-default-size">
<?php
	for($i=4; $i<=12; $i++)
	{
?>
							<option value="<?php echo $i;?>" <?php if($settings["qr_default_size"] == $i) echo "selected";?>><?php echo $i;?></option>
<?php
	}
?>
						</select>
						<div class="formHelp">QR Code dot size in pixels</div>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="button" value="Generate" id="qr-generate-button"/>
			</div>

			<div id="dialog-qr-generated" style="display:none;">
				<div>
					<img id="dialog-qr-generated-image" src="images/icons/a/raster.png"/><br/>
					<div id="dialog-qr-generated-link-url"></div>
				</div>
			</div>
		</div>
	</div>
<?php	
	}
?>
</div>
<div class="admin-form-buttons">
	<input type="submit" value="Save changes" default="default"/>
	<input type="reset" value="Reset form"/>
</div>
</form>
