<?php
/**
 * Category
 */

	if (!defined("ENV")) exit();

	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level){
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE{
		function drawNode($param){
			if($this->id!=$param->id){
				echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?"style='color:gray;'":"").'>';
				for($i=0; $i<$param->level*4; $i++){
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
				if(count($this->nodes)>0){
					while(list($id, $node) = each($this->nodes)){
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	while($db->moveNext()){
		$tree->addNode(
			new OPTION_NODE(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}

	$cid = isset($cid)?$cid*1:"";
	$mode = isset($mode)?trim($mode):"";
	switch($mode){
		case "update" : {
			$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid='".$cid."'");
			if($db->moveNext()){

				$name = $db->col["name"];
				$parent = $db->col["parent"];
				$description = $db->col["description"];
				$description_bottom = $db->col["description_bottom"];
				$priority = $db->col["priority"];
				$is_visible = $db->col["is_visible"];
				$list_subcats = $db->col["list_subcats"];
				$key_name = $db->col["key_name"];
				$meta_keywords = $db->col["meta_keywords"];
				$meta_title = $db->col["meta_title"];
				$meta_description = $db->col["meta_description"];
				$category_header = $db->col["category_header"];
				$url_default = $db->col["url_default"];
				$url_custom = $db->col["url_custom"];

				break;
			}
		}
		default :
		case "insert" : {
			$mode = "insert";
			$cid = -1;
			$name = "";
			$parent = isset($parent)?$parent:TREE_ROOT;
			$description = "";
			$description_bottom = "";
			$key_name = "";
			$priority = 5;
			$is_visible = "Yes";
			$list_subcats = "No";
			$meta_keywords = "";
			$meta_title = "";
			$meta_description = "";
			$category_header = "";
			$url_default = "will be generated after category saved";
			$url_custom = "";
		}
	}
	loadJS("cf_category.js");
	loadJS("cd_category.js");

	pageHeader("Category", ucfirst(strtolower($mode)), "ic_folder_".($mode == "update" ? "edit" : "add").".gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_delete.gif", "text"=>"Remove this category", "url"=>"JavaScript:ConfirmDeleteCategory('".$cid."')", "visible"=>$mode=="update")
	));
	pageTabs(array(
		array("title"=>"Category Properties", "id"=>"Main", "active"=>true, "width"=>140),
	));
?>
<form name="frmCategory" action="admin.php?p=category_process" method="post" onsubmit="return CheckCategoryForm(this)" enctype="multipart/form-data">
	<input type="hidden" name="cid" value="<?=$cid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_open_folder.gif"></div>
				<div class="formHeaderText">Parent Category</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Select Parent Category</b></td>
			<td class="formItemControl">
				<select name="parent" style="width:100%;" size="10">
<?	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM($cid, $parent, 0)
	);?>
				</select>
				<div class="formItemComment">
					To add a parent category, highlight Category Root at the top.
					To assign a child category, highlight the category you want the new category appear under
				</div>
			</td>
		</tr>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
				<div class="formHeaderText">Category Properties</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Category Name</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="name" maxlength="255" value="<?=htmlspecialchars($name)?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Category Key / ID</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="key_name" maxlength="255" value="<?=htmlspecialchars($key_name)?>">
				<div class="formItemComment">
					This will be used for bulk loading products. This might be
					the same as the Category name, but without spaces.
					Example: digital_recorders.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Category Header</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="category_header" maxlength="255" value="<?=htmlspecialchars($category_header)?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Is category visible to users?</td>
			<td class="formItemControl">
				<input id="checkbox_is_visible" type="checkbox" name="is_visible" value="Yes" <?=$is_visible=="Yes"?"checked":""?>>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">List subcategories on Catalog Page?</td>
			<td class="formItemControl">
				<input id="checkbox_is_visible" type="checkbox" name="list_subcats" value="Yes" <?=$list_subcats=="Yes"?"checked":""?>>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Priority (used for sorting)</td>
			<td class="formItemControl">
				<input style="width:125px;" type="text" name="priority" maxlength="200" value="<?=htmlspecialchars($priority)?>">
			</td>
		</tr>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_search.gif"></div>
				<div class="formHeaderText">SEO Properties</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Meta Keywords</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="meta_keywords" maxlength="255" value="<?=htmlspecialchars($meta_keywords)?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Meta Title</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="meta_title" maxlength="255" value="<?=htmlspecialchars($meta_title)?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Meta Description</td>
			<td class="formItemControl">
				<textarea class="no-mce" style="width:100%;height:100px;" name="meta_description"><?=htmlspecialchars($meta_description)?></textarea>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Category URL (pre-generated)</td>
			<td class="formItemControl">
				<span style="text-decoration:underline;color:blue;"><?=htmlspecialchars($url_default)?></span>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Category URL (custom)</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="url_custom" maxlength="255" value="<?=htmlspecialchars($url_custom)?>">
			</td>
		</tr>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
				<div class="formHeaderText">Category Description (Top of Page) [ <a href="javascript:toggleEditorMode('description',this)">Edit HTML online</a> ]&nbsp;</div>
			</td>
		</tr>
		<tr>
			<td class="formItemBig" colspan="2">
				<textarea wrap="off" style="width:100%;height:150px;" width="100%" class="no-mce" id="description" name="description"><?=htmlspecialchars($description)?></textarea>
			</td>
		</tr>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
				<div class="formHeaderText">Category Description (Bottom of Page) [ <a href="javascript:toggleEditorMode('description_bottom',this)">Edit HTML online</a> ]&nbsp;</div>
			</td>
		</tr>
		<tr>
			<td class="formItemBig" colspan="2">
				<textarea wrap="off" style="width:100%;height:150px;" width="100%" class="no-mce" id="description_bottom" name="description_bottom"><?=htmlspecialchars($description_bottom)?></textarea>
			</td>
		</tr>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_jpg.gif"></div>
				<div class="formHeaderText">Category Image</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Image File</td>
			<td class="formItemControl">
				<input style="width:250px;" type="file" name="image" value="">
				<div class="formItemComment">(note: accepted file types are JPG, PNG and GIF)</div>
			</td>
		</tr>
<?php
	if($settings["CatalogCategoryThumbType"] == "Manual"){?>
		<tr valign="top">
			<td class="formItemCaption">Thumbnail Image</td>
			<td class="formItemControl">
				<input style="width:250px;" type="file" name="image_thumb">
			</td>
		</tr>
<?	}
	$img_file = CategoryHasImage($cid);
	$thumb = CategoryHasThumb($cid);
	if($img_file){
		$size = getimagesize($img_file);
?>
		<tr valign="top">
			<td class="formItemCaption"><b>Current Image:</b> (<?=$size[0]?>x<?=$size[1]?> pixels)</td>
			<td class="formItemControl">
				<img src="<?=$img_file?>" border="1" width="<?=$size[0]>500?500:$size[0]?>" border="0"><br/>
				<a href="javascript:ConfirmDeleteCategoryImage(<?=$cid?>)">Delete this image</a>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Thumbnail for this image</td>
			<td class="formItemControl">
<?				if($thumb){?>
				<img src="<?=$thumb?>?<?=rand(1, 9999999)?>" border="1"><br/>
				<a href="javascript:ConfirmDeleteCategoryThumb(<?=$cid?>)">Delete this image</a>
<?				}
				else{
					echo "There is no thumbnail for this image";
				}
?>
			</td>
		</tr>
<?	}?>
	</table>
</div>
<div class="formButtons">
	<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmCategory.reset();return false;">
</div>
</form>