<?php
/**
 * Charts
 */

	if (!defined("ENV")) exit();
	
	header('Cache-Control: cache, must-revalidate');
	header('Pragma: public');
	
	require("content/engine/engine_panachart.php");
	$chartLabels = array();
	$chartValues = array();
	
	function getMonthDays($y, $m)
	{
		global $chartLabels;
		global $chartValues;
		for ($i = 1; $i<= 31; $i++)
		{
			if (checkdate($m, $i, $y))
			{
				$chartLabels[$i-1] = $i;
				$chartValues[$i-1] = 0;
			}
		}
	}
	
	$numberPrefix = '';
	$decimalPrecision = '';
	
	$mode = isset($mode)?trim($mode):"current_month";
	switch($mode)
	{
		/**
		 * Usage statistics by month (hits)
		 */
		default:
		case "usage_by_month_hits" :
		{
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (total pages viewed)";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Pages";
			$color = "#00AAFF";
			$color_shadow_1 = "#0099EE";
			$color_shadow_2 = "#0088DD";
			$db->query("
				SELECT 
					COUNT(*) AS day_hits,
					DAYOFMONTH(visit_date) AS day
				FROM ".DB_PREFIX."statistics
				WHERE
					YEAR(visit_date) = '".$year."'
					AND MONTH(visit_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["day_hits"];
				$i++;
			}
			break;
		}

		/**
		 * Usage statistics by month (hits)
		 */
		case "usage_by_month_hosts" : 
		{
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (unique hosts)";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Hosts";
			$color = "#99EE00";
			$color_shadow_1 = "#88DD00";
			$color_shadow_2 = "#77CC00";
			$db->query("
				SELECT 
					DAYOFMONTH(visit_date) AS day,
					COUNT(DISTINCT hid) AS day_hosts
				FROM ".DB_PREFIX."statistics
				WHERE
					YEAR(visit_date) = '".$year."'
					AND MONTH(visit_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["day_hosts"];
				$i++;
			}
			break;
		}

		/**
		 * Sales statistics by month
		 */
		case "sales_by_month" :
		{
			require_once("content/classes/class.currencies.php");
			$currencies = new Currencies($db);
			$default_currency = $currencies->getDefaultCurrency();
			
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Sales Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (".$default_currency["title"].")";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Sales (".$default_currency["title"].")";
			$color = "#FF00AA";
			$color_shadow_1 = "#EE0099";
			$color_shadow_2 = "#DD0088";
			$numberPrefix = '$';
			$decimalPrecision = '2';
			$db->query("
				SELECT 
					".DB_PREFIX."orders.*,
					SUM(".DB_PREFIX."orders.total_amount) AS total_sum,
					DAYOFMONTH(placed_date) AS day
				FROM ".DB_PREFIX."orders 
				WHERE 
					removed='No' AND
					status='Completed' AND 
					payment_status='Received' AND
					YEAR(placed_date) = '".$year."' AND 
					MONTH(placed_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["total_sum"]>0?$db->col["total_sum"]:0;
				$i++;
			}
			break;
		}
	}
	
	echo '<graph caption="Monthly Unit Sales" decimalPrecision="'.$decimalPrecision.'" showPercentageValues="0" showNames="1" xAxisName="Month" yAxisName="Units" numberPrefix="'.$numberPrefix.'"  canvasBgColor="ffffff" yAxisMinValue="0" yAxisMaxValue="1">'."\n";
	foreach ($chartValues as $key => $value)
	{
		echo '<set value="'.$value.'" name="'.($key + 1).'"/>'."\n";
	}
	echo '</graph>';
	
	die();