<?php
/**
 * Charts
 */

	if (!defined("ENV")) exit();

	require("content/engine/engine_panachart.php");
	$chartLabels = array();
	$chartValues = array();
	
	function getMonthDays($y, $m)
	{
		global $chartLabels;
		global $chartValues;
		for ($i = 1; $i<= 31; $i++)
		{
			if (checkdate($m, $i, $y))
			{
				$chartLabels[$i-1] = $i;
				$chartValues[$i-1] = 0.01;
			}
		}
	}
	
	$mode = isset($mode)?trim($mode):"current_month";
	$chart_view = isset($chart_view)?trim($chart_view):"bar";
	switch($mode)
	{
		/**
		 * Usage statistics by month (hits)
		 */
		default:
		case "usage_by_month_hits" :
		{
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (total pages viewed)";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Pages";
			$color = "#00AAFF";
			$color_shadow_1 = "#0099EE";
			$color_shadow_2 = "#0088DD";
			$db->query("
				SELECT 
					COUNT(*) AS day_hits,
					DAYOFMONTH(visit_date) AS day
				FROM ".DB_PREFIX."statistics
				WHERE
					YEAR(visit_date) = '".$year."'
					AND MONTH(visit_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["day_hits"];//>0?$db->col["day_hits"]:0.01;
				$i++;
			}
			break;
		}

		/**
		 * Usage statistics by month (hits)
		 */
		case "usage_by_month_hosts" : 
		{
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (unique hosts)";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Hosts";
			$color = "#99EE00";
			$color_shadow_1 = "#88DD00";
			$color_shadow_2 = "#77CC00";
			$db->query("
				SELECT 
					DAYOFMONTH(visit_date) AS day,
					COUNT(DISTINCT hid) AS day_hosts
				FROM ".DB_PREFIX."statistics
				WHERE
					YEAR(visit_date) = '".$year."'
					AND MONTH(visit_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["day_hosts"];
				$i++;
			}
			break;
		}

		/**
		 * Sales statistics by month
		 */
		case "sales_by_month" :
		{
			require_once("content/classes/class.currencies.php");
			$currencies = new Currencies($db);
			$default_currency = $currencies->getDefaultCurrency();
			
			$year = isset($year)?$year*1:date("Y");
			$month = isset($month)?$month*1:date("m");
			$title = "Monthly Sales Statistics for ".date("F Y", mktime(0,0,0, $month, 1, $year))." (".$default_currency["title"].")";
			$x_title = "Date (".date("F Y", mktime(0,0,0, $month, 1, $year)).")";
			$y_title = "Sales (".$default_currency["title"].")";
			$color = "#FF00AA";
			$color_shadow_1 = "#EE0099";
			$color_shadow_2 = "#DD0088";
			$db->query("
				SELECT 
					".DB_PREFIX."orders.*,
					SUM(".DB_PREFIX."orders.total_amount) AS total_sum,
					DAYOFMONTH(create_date) AS day
				FROM ".DB_PREFIX."orders 
				WHERE 
					removed='No' AND
					status='Completed' AND 
					payment_status='Received' AND
					YEAR(create_date) = '".$year."' AND 
					MONTH(create_date) = '".$month."'
				GROUP BY day
				ORDER BY day
			");
			
			getMonthDays($year, $month);
			$i = 0;
			while ($db->moveNext())
			{
				$chartValues[$db->col["day"] - 1] = $db->col["total_sum"]>0?$db->col["total_sum"]:0.01;
				$i++;
			}
			break;
		}
	}
	
	//header("Content-Type: image/png");
	
	$chart_width = isset($_REQUEST["chart_width"])?intval($_REQUEST["chart_width"]):500;
	$chart_height = isset($_REQUEST["chart_height"])?intval($_REQUEST["chart_height"]):250;
	$ochart = new chart($chart_width, $chart_height, 10, '#FFFFFF');

	$ochart->setTitle($title, "#444444", 2);
	$ochart->setPlotArea(SOLID,"#aaaaaa", '#aaaaaa');
	$ochart->setFormat(0,',','.');
	$ochart->addSeries($chartValues, $chart_view, 'Series1', SOLID, '#000000', $color, $color_shadow_1, $color_shadow_2);
	
	$ochart->setXAxis('#444444', SOLID, 2, $x_title);
	$ochart->setYAxis('#444444', SOLID, 2, $y_title);
	
	$ochart->setLabels($chartLabels, '#aaaaaa', 1, HORIZONTAL);
	$ochart->setGrid("#aaaaaa", DASHED, "#aaaaaa", DASHED);		
	$ochart->plot('');	
