<?php
/**
 * Compliance
 */

	if (!defined("ENV")) exit();

	pageHeader("PCI-DSS/PA-DSS compliance", "", "ic_settings.gif");

	pageNote(array(
		array(
			"icon" => "ic_hint.gif",
			"text" => "PCI-DSS (Payment Card Industry - Data Security Standard) and PA-DSS (Payment Application - Data Security Standard) were created to help organizations and businesses that process card payments prevent credit card fraud, hacking and various other security vulnerabilities and threats.",
			"url" => "",
			"visible" => true
		),
		array(
			"icon" => "ic_hint.gif",
			"text" => "Updated compliance information can be found by visiting <a href='https://www.pcisecuritystandards.org/' target='_blank'>https://www.pcisecuritystandards.org/</a>",
			"url" => "",
			"visible" => true
		)
	));

?>
<br/>

<div style="clear:both;padding:5px;padding-left:25px;">
	<div style="font-size:16px; font-weight:bold; color:#4f6228">PCI-DSS Compliance</div>
    <? if($settings["SecurityCCSActive"]!="1" || DB_HOST!="localhost") { ?>
    <br /> - Card holder information is not being stored - It appears your cart configuration is compliant as it relates to the storage of card holder information.
	<? }  if($settings["SecurityCCSActive"]=="1" && DB_HOST=="localhost") {?>
	<br /> It appears you are storing credit card information and your database is on the same web server as your shopping cart. This configuration is not considered PCI compliant.
	<? }  ?>
</div>
<br/><br/>
<div style="clear:both;padding:5px;padding-left:25px;">
	<div style="font-size:16px; font-weight:bold; color:#4f6228">PA-DSS Compliance</div>
	<p>Compliance Issue - Notifications to update passwords and delete unused accounts.</p>
	<p>To maintain PA-DSS compliance, your cart will need to run a set of scheduled tasks to make sure your passwords and accounts are up-to-date. These tasks are managed through a script called a cron job. A cron is the name of the program that enables unix / windows users to execute commands or scripts (groups of commands) automatically at a specified time/date. The examples below are meant to help you set-up a cron job on most hosting providers. Please contact your host for more specific instructions, as well as availability. If you can't use a cron job, then the admin login action will be used to activate the password reminders. While this method will work, setting up a cron job is the best method for notifying administrators. If you can't use a cron job, then you will need to modify the notification settings for admin accounts which is located on your Security Settings page.</p>

	<p>LINUX/UNIX</p>
	<p>The cron job should be set for daily execution.</p>
	<p>To setup a cron job on LINUX server use following command:</p>
	<p>/usr/bin/GET http://www.domainname.com/[cart folder]/content/admin/cron/cron.php</p>
	<p>Or</p>
	<p>php http://www.domainname.com/[cart folder]/content/admin/cron/cron.php</p>
 	<p>WINDOWS</p>
	<p>To setup a cron job on a WINDOWS server use following command in task scheduler:</p>
 	<p>[path to your website]\curl_wrapper.php</p>
	<p>Then, you would edit the curl_wrapper.php file with the full url to the script as shown in the example code below using the download from the following link.</p>
	<p><a href="http://cartmanual.com/curl_wrapper.zip">http://cartmanual.com/curl_wrapper.zip</a></p>

<textarea rows="13" cols="100" class="no-mce" readonly="true">function get_data($url){
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}
$returned_content = get_data('http://www.domain.com/content/admin/cron/cron.php') ;
echo $returned_content;
</textarea><br /><br />

	<p>
		To schedule a task in Windows using PLESK:
		<ol>
			<li>Go to Server > Scheduler Tasks.</li>
			<li>Click Add New Task.</li>
			<li>Leave the Switched on checkbox selected if you want your scheduled task to be active immediately after the creation.</li>
			<li>Input a name for your task in the Description field.</li>
			<li>In Scheduler Notification, specify whether the scheduler should notify you when it runs this task.  The following options are available:
				<ul>
					<li>Switched off - do not notify you.</li>
					<li>Send to the default e-mail - send the notification to your default e-mail address.</li>
					<li>Send to the e-mail I specify - send the notification to the e-mail specified in the corresponding field. After selecting this option, you need to input the required e-mail in the field on the right.</li>
					<li>Click 'Set' to save scheduler notification's settings.</li>
				</ul>
			</li>
			<li>Specify the command [path to your website]\curl_wrapper.php with no Arguments in the Arguments field.</li>
			<li>Select the appropriate priority in the Task Priority field.  Task Priority can be set to Low, Normal or High.</li>
			<li>Specify when to run your command by selecting the appropriate checkboxes in the Hours, Days of Month, Months, or Days of Week fields.</li>
			<li>Click OK to schedule the task or click Run Now to schedule the task and immediately run it.</li>
		</ol>
	</p>
</div>
