<?php
/**
 * Countries
 */

	if (!defined("ENV")) exit();
	
	pageHeader("Country Listing", "", "");
	pageNote(array(
		array("icon"=>"ic_hint.gif", 
			"text"=>
				"This page is for enabling / disabling countries within your cart. Only the countries enabled will appear within your checkout process.<br/>".
				"Use Priority to control what order they appear to your customers, highest number listed first.<br/>".
				"<i>ISO numbers are used by real-time shipping providers and most gateway companies. If you are adding / editing a country, make sure the ISO numbers are correct to insure proper functionality.</i>",
			"url"=>"", "visible"=>true)
	));
	loadJS("regions.js");
	
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
	
	$added_country_id = "";
	
	if (!DEMO_LOCK)
	{
		switch($action)
		{
			case "add" :
			{
				$added_country_id = $regions->addCountry($_REQUEST);
				$_REQUEST["showby"] = "abc";
				$_REQUEST["letter"] = $_REQUEST["name"][0];
				break;
			}
			case "save" :
			{
				$regions->saveCountriesData($_REQUEST);
				break;
				}
			case "delete" :
			{
				$regions->deleteCountry($_REQUEST["coid"]);
				break;
			}
		}
	}
	
	$countries_abc = $regions->getCountriesABC();
	
	$showby = isset($_REQUEST["showby"])?$_REQUEST["showby"]:"page";
	$showby = ($showby == "page" || $showby == "abc")?$showby:"page";
	
	$sortorder = isset($_REQUEST["sortorder"])?$_REQUEST["sortorder"]:"asc";
	$sortorder = in_array($sortorder, array("name_asc", "name_desc", "priority_asc", "priority_desc"))?$sortorder:"name_asc";
	
	switch($showby)
	{
		default :
		case "page" :
		{
			$ccc = 20;
			$_countries = $regions->getCountriesList($sortorder);
			$items_count = count($_countries);
			$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
			$pg = isset($pg)?($pg*1):1;
			$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
			$pages_line = format_pages_line(
				$pg, // current pare
				$pages_count, // total pages
				16, 
				"admin.php?p=countries&showby=page&sortorder=".$sortorder
			);
			$countries = array();
			$start = ($pg-1)* $ccc;
			$finish = $start + $ccc;
			$finish = $finish > $items_count ? $items_count : $finish;
			for ($i=$start; $i<$finish; $i++)
			{
				$countries[] = $_countries[$i];
			}
			$letter = "";
			break;
		}
		case "abc" :
		{
			$pg = 1;
			$letter = isset($_REQUEST["letter"])?$_REQUEST["letter"]:$countries_abc[0];
			$letter = in_array($letter, $countries_abc)?$letter:$countries_abc[0];
			$countries = $regions->getCountriesListByLetter($letter, $sortorder);
			break;
		}
	}
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-countries">
<?php 
	pageTabs(array(
		array("title"=>"Countries", "id"=>"list"),
		array("title"=>"New Country", "id"=>"new")
	), "tabs-countries", false);
?>
<script language="javascript" type="text/javascript">
function checkAllCountries(checked)
{
	var f = document.forms["frmCountries"];
	for (i=0; i<f.elements.length; i++)
	{
		el = f.elements[i];
		if (el.type == "checkbox")
		{
			el.checked = checked;
		}
	}
}
</script>

	<div id="admin-tab-sheet-list" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-globe">Country Listing</div>
			<div class="listHeader">
				<div class="listHeaderCaption" style="float:right;font-weight:normal;">
					Browse alphabetically: 
			<?php
				for ($i=0; $i<count($countries_abc); $i++)
			{
					if ($letter == $countries_abc[$i])
					{
						echo '&nbsp; <span class="pageNavItemActive">'.$countries_abc[$i].'</span>';
					}
					else
					{
						echo '&nbsp; <span class="pageNavItem"><a href="admin.php?p=countries&showby=abc&letter='.$countries_abc[$i].'&sortorder='.$sortorder.'">'.$countries_abc[$i].'</a></span>';
					}
				}
			?>
				</div>
			</div>
			<div class="listHeader">
				<div class="listHeaderIcon">&nbsp;</div>
				<div class="listHeaderCaption" style="font-weight:normal;"><a href="javascript:checkAllCountries(true)">Check All</a> | <a href="javascript:checkAllCountries(false)">Uncheck All</a></div>
				<div class="listHeaderCaption" style="float:right;font-weight:normal;">
					Browse by page:
			<?php
				if ($showby == "page")
				{
					echo $pages_line;
				}
				else
				{
					echo '<a href="admin.php?p=countries&sortorder='.$sortorder.'">Back to Pages View</a>';
				}
			?>
				</div>
			</div>
			<div class="clearfix">
				<div class="listHeader clearfix">
					<div class="listHeaderIcon">&nbsp;</div>
					<div class="listHeaderCaption" style="width:50px;">Active</div>
					<div class="listHeaderCaption" style="width:200px;">
						Country Name&nbsp;
						<a href="admin.php?p=countries&showby=<?=$showby?>&letter=<?=$letter?>&pg=1&sortorder=name_asc"><img src="images/admin/arr_up<?=$sortorder=="name_asc"?"_on":""?>.gif" style="border:0px solid #dddddd;"/></a>
						<a href="admin.php?p=countries&showby=<?=$showby?>&letter=<?=$letter?>&pg=1&sortorder=name_desc"><img src="images/admin/arr_down<?=$sortorder=="name_desc"?"_on":""?>.gif" style="border:0px solid #666666;"/></a>
					</div>
					<div class="listHeaderCaption" style="width:80px;">
						Priority&nbsp;
						<a href="admin.php?p=countries&showby=<?=$showby?>&letter=<?=$letter?>&pg=1&sortorder=priority_asc"><img src="images/admin/arr_up<?=$sortorder=="priority_asc"?"_on":""?>.gif" style="border:0px solid #dddddd;"/></a>
						<a href="admin.php?p=countries&showby=<?=$showby?>&letter=<?=$letter?>&pg=1&sortorder=priority_desc"><img src="images/admin/arr_down<?=$sortorder=="priority_desc"?"_on":""?>.gif" style="border:0px solid #666666;"/></a>
					</div>
					<div class="listHeaderCaption" style="width:80px;">ISO Alpha 2</div>
					<div class="listHeaderCaption" style="width:80px;">ISO Alpha 3</div>
					<div class="listHeaderCaption" style="width:80px;">ISO Number</div>
				</div>
			
				<form name="frmCountries" style="padding:0px;margin:0px;" action="admin.php?p=countries&showby=<?=$showby?>&letter=<?=$letter?>&pg=<?=$pg?>&sortorder=<?=$sortorder?>" method="POST">
					<input type="hidden" name="action" value="save"/>
			<?php
				for ($i=0; $i<count($countries); $i++)
				{
					$country = $countries[$i];
			?>
					<div class="listItem">
						<div class="listItemIcon">&nbsp;</div>
						<div class="listItemText" style="width:50px;">
							<input type="checkbox" name="available[<?=$country["coid"]?>]" <?=$country["available"]=="Yes"?"checked":""?>/>
						</div>
						<div class="listItemText" style="width:200px;">
							<input type="text" name="name[<?=$country["coid"]?>]" value="<?=htmlspecialchars($country["name"])?>" style="width:190px;"/>
						</div>
						<div class="listItemText" style="width:80px;">
							<input type="text" name="country_priority[<?=$country["coid"]?>]" maxlength="3" value="<?=htmlspecialchars($country["country_priority"])?>" style="width:70px;"/>
						</div>
						<div class="listItemText" style="width:80px;">
							<input type="text" name="iso_a2[<?=$country["coid"]?>]" maxlength="2" value="<?=htmlspecialchars($country["iso_a2"])?>" style="width:70px;"/>
						</div>
						<div class="listItemText" style="width:80px;">
							<input type="text" name="iso_a3[<?=$country["coid"]?>]" maxlength="3" value="<?=htmlspecialchars($country["iso_a3"])?>" style="width:70px;"/>
						</div>
						<div class="listItemText" style="width:80px;">
							<input type="text" name="iso_number[<?=$country["coid"]?>]" maxlength="3" value="<?=htmlspecialchars($country["iso_number"])?>" style="width:70px;"/>
						</div>
						<div class="listItemButtons">
							<a href="admin.php?p=states&coid=<?=$country["coid"]?>"><img border="0" src="images/icons/ic_globe.gif" alt="Click to edit states and provinces"/>
							<a href="javascript:confirmDeleteCountry('<?=$country["coid"]?>', '<?=$showby?>', '<?=$sortorder?>', '<?=$letter?>', '<?=$pg?>')"><img src="images/icons/ic_delete.gif" alt="Click to delete country" border="0"/></a>
						</div>
					</div>		
			<?php
				}
			?>
					<div class="listFooter">
						<div class="listFooterIcon">&nbsp;</div>
						<div class="listFooterCaption" style="font-weight:normal;"><a href="javascript:checkAllCountries(true)">Check All</a> | <a href="javascript:checkAllCountries(false)">Uncheck All</a></div>
					</div>
				
					<div class="admin-form-buttons">
						<input type="submit" value="Save changes"/> &nbsp;
						<input type="reset" value="Reset form"/>
					</div>
					
				</form>
			</div>		
		
		</div>
	</div>
	
	<div id="admin-tab-sheet-new" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form name="frmNewCountry" method="POST" action="admin.php?p=countries" onsubmit="return checkAddCountryForm(this)">
				<input type="hidden" name="action" value="add"/>
				<div class="admin-form-header">Add a New Country</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formItemCaption">Is country available?</td>
						<td class="formItemControl"><input type="checkbox" name="available"/></td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Country Name</b></td>
						<td class="formItemControl"><input type="text" name="name" value="" style="width:250px;"/></td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Country Priority</b></td>
						<td class="formItemControl"><input type="text" name="country_priority" maxlength="3" value="" style="width:123px;"/></td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>ISO2 Code</b></td>
						<td class="formItemControl"><input type="text" name="iso_a2" maxlength="2" value="" style="width:123px;"/></td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>ISO3 Code</b></td>
						<td class="formItemControl"><input type="text" name="iso_a3" maxlength="3" value="" style="width:123px;"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>ISO Number</b></td>
						<td class="formItemControl">
							<input type="text" name="iso_number" maxlength="3" value="" style="width:123px;"/>
							<div class="formItemComment">
								To learn about country ISO codes please go to <a href="http://www.iso.org/iso/country_codes.htm" target="_blank">http://www.iso.org/iso/country_codes.htm</a>
							</div>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/> &nbsp;
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>
</div>


