<?php

	if (!defined("ENV")) exit();
	
	$mode = isset($mode)?trim($mode):"";
	$field_id = isset($field_id)?intval($field_id):0;
	$field_type = isset($field_type)?trim($field_type):"text";
	$is_active = isset($is_active)?intval($is_active):"0";
	$is_required = isset($is_required)?intval($is_required):"0";
	$priority = isset($priority)?intval($priority):"1";
	$field_place = isset($field_place)?trim($field_place):"signup";
	$field_name = isset($field_name)?trim($field_name):"Custom Field";
	$field_caption = isset($field_caption)?trim($field_caption):"text";
	$text_length = isset($text_length)?intval($text_length):"20";
	$value_checked = isset($value_checked)?trim($value_checked):"Yes";
	$value_unchecked = isset($value_unchecked)?trim($value_unchecked):"No";
	$options = isset($options)?trim($options):"1\n2\n3";
	
	if (in_array($field_type, array("radio")))
	{
		$is_required = 0;
	}
	
	$db->reset();
	
	$db->assignStr("is_active", $is_active);
	$db->assignStr("is_required", $is_required);
	$db->assignStr("priority", $priority);
	$db->assignStr("field_place", $field_place);
	$db->assignStr("field_name", $field_name);
	$db->assignStr("field_caption", $field_caption);
	
	if ($field_type == "text")
	{
		$db->assignStr("text_length", $text_length);
	}
	
	if ($field_type == "checkbox")
	{
		$db->assignStr("value_checked", $value_checked);
		$db->assignStr("value_unchecked", $value_unchecked);
	}
	
	if ($field_type == "select" || $field_type == "radio")
	{
		$db->assignStr("options", $options);
	}
	
	switch($mode)
	{
		case "insert" :
		{
			$db->assignStr("field_type", $field_type);
			$field_id = $db->insert(DB_PREFIX."custom_fields");
			pageHeader("Custom Field Created", "", "ic_form_done.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>New Custom field has been successfully created</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("text"=>"Edit Previously Created Field", "url"=>"admin.php?p=custom_field&mode=update&field_id=".$field_id),
				array("text"=>"Create a New Custom Field", "url"=>"admin.php?p=custom_field&mode=insert"),
				array("text"=>"Back to Forms Control Page", "url"=>"admin.php?p=forms_control")
			));
			break;
		}
		case "update" :
		{
			$db->update(DB_PREFIX."custom_fields", "WHERE field_id='".$field_id."'");
			pageHeader("Custom Field Updated", "", "ic_form_done.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Custom field has been successfully updated</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("text"=>"Back to Custom Field Editing", "url"=>"admin.php?p=custom_field&mode=update&field_id=".$field_id),
				array("text"=>"Create a New Custom Field", "url"=>"admin.php?p=custom_field&mode=insert"),
				array("text"=>"Back to Forms Control Page", "url"=>"admin.php?p=forms_control")
			));
			break;
		}
		case "delete" :
		{
			$db->query("DELETE FROM ".DB_PREFIX."custom_fields WHERE field_id='".$field_id."'");
			pageHeader("Custom Field Removed", "", "ic_form_done.gif");
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>Custom field has been successfully removed</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("text"=>"Back to Forms Control Page", "url"=>"admin.php?p=forms_control"),
				array("text"=>"Create a New Custom Field", "url"=>"admin.php?p=custom_field&mode=insert")
			));
			break;
		}
	}