<?php
	if (!defined("ENV")) exit();
	
	require_once('content/classes/class.skin_settings.php');
	SkinSettings::init();
	
	if (isset($_GET['clear_skin_cache']))
	{
		$designmode = new Ddm_Design_Mode($settings);
		$designmode->clearSkinCache();
	}
	
	if (isset($_GET['design_mode_flag']))
	{
		switch ($_GET['design_mode_flag'])
		{
			case 'On':
				// set admin session
				$_SESSION['admin_design_mode'] = true; 
				session_write_close();
				header('Location: '.$settings['GlobalHttpsUrl']."/".$settings["INDEX"]."?_admc=true&pcsid=".session_id());
				die();
				break;
				
			case 'Off':
			default: 
				// unset admin session
				$_SESSION['admin_design_mode'] = false;
				unset($_SESSION['admin_design_mode']);
				setcookie("_admc", "true", time() - 60*60*24*365, "/");
		}
	}
	
	if (isset($_SESSION['admin_design_mode']) && $_SESSION['admin_design_mode'])
	{
		$design_mode_state = 'Deactivate';
		$design_mode_state_value = 'Off';
		$chart_param = "";
	}
	else
	{
		$design_mode_state = 'Activate';
		$design_mode_state_value = 'On&printing=true';
		$chart_param = "chart=true&";
	}
	
	pageHeader("Appearance Settings", "", "ic_appearance.gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please select the appearance setting you would like to adjust</b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>{$design_mode_state} Cart Designer</b>", "url"=>"?{$chart_param}p=design_settings&design_mode_flag={$design_mode_state_value}", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<span id=\"clear-skin-cache\"><b>Clear Skin Cache</b></span>", "url"=>"?p=design_settings&clear_skin_cache=1", "visible"=>true)
	));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-design">
<?php 
	pageTabs(array(
		array("title"=>"My Templates", "id"=>"templates"),
	), "tabs-design", false);
?>
	<div id="admin-tab-sheet-templates" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="browse">
				<label for="">Items per page</label> 
				<select id="">
					<option value="10">10</option>
					<option value="25">25</option>
					<option value="50">50</option>
					<option value="100">100</option>
				</select>
				<!-- Search: <input type="text" id="myTemplatesFilter" /> -->
			</div>
			<?=SkinSettings::renderSkinSelectionView()?>
			<div class="clear"></div>
			<p class="noResults">No Results</p>
		</div>
	</div>
</div>
<?php
/*
<div id="idTabSheetfreeTemplates" class="admin-tab-sheet hidden">
	<div class="browse">
		<label for="">Items per page</label> 
		<select id="">
			<option value="10">10</option>
			<option value="25">25</option>
			<option value="50">50</option>
			<option value="100">100</option>
		</select>
		Search: <input type="text" id="freeTemplatesFilter" />
	</div>
	<div>
		
	</div>
</div>
<div id="idTabSheetpremiumTemplates" class="admin-tab-sheet hidden">
	<div class="browse">
		<label for="">Items per page</label> 
		<select id="">
			<option value="10">10</option>
			<option value="25">25</option>
			<option value="50">50</option>
			<option value="100">100</option>
		</select>
		
		Search: <input type="text" id="premiumTemplatesFilter" />
	</div>
	<ul class="templates">
		<?=$my_templates?>
	</ul>
	<div class="clear"></div>
</div>
*/
?>