<?php
	if (!defined("ENV")) exit();
	
	$themeManagerController = new Controller_ThemeManager();
	$themeManagerController->setSettings($settings);
	$themeManagerController->setDb($db);
	
	if (array_key_exists('deleteTheme', $_REQUEST))
	{
		$themes = explode(',', $_REQUEST['deleteTheme']);
		
		$response = $themeManagerController->deleteThemeAction($themes, true);
		
		if ($response['status'] == 'success')
		{
			$response = $themeManagerController->deleteThemeAction($themes, false);
		}
		
		print json_encode($response);
		exit;
	}
	
	if (isset($_REQUEST) && array_key_exists('skinName', $_REQUEST))
	{
		$restoreLayout = (array_key_exists('layoutConfig', $_REQUEST) && $_REQUEST['layoutConfig'] == 'default');
		$response = $themeManagerController->activateThemeAction($_REQUEST['skinName'], $restoreLayout);
		
		if ($response)
		{
			view()->assemble('content'.DS.'cache'.DS.'skins'.DS.escapeFileName($settings['DesignSkinName']).DS, array(
				'content'.DS.'engine'.DS.'design'.DS, 
				'content'.DS.'skins'.DS.escapeFileName($settings['DesignSkinName']).DS,
				'content'.DS.'skins'.DS.'_custom'.DS.'skin'.DS,
			));
		}
		
		print json_encode(array('result' => ($response) ? 'success' : 'error'));
		exit;
	}
	
	if (isset($_GET['clear_skin_cache']))
	{
		$designmode = new Ddm_Design_Mode($settings);
		$designmode->clearSkinCache();
	}

	if (isset($_GET['install']))
	{
		$file_name = $_GET['install'].'.zip';
		if (File_Utility::downloadFile('http://www.cartmanual.com/themes/downloads/'.$file_name, 'content/cache/tmp/'.$file_name))
		{
			$path = $settings["GlobalServerPath"];
			if (strpos(strtolower($_SERVER["SERVER_SOFTWARE"]), "win32") or strpos(strtolower("test".$_SERVER["SERVER_SOFTWARE"]), "microsoft") != false) 
			{
				$command_line = 
					$path."/content/admin/7zip/7z.exe ".
					"x \"".$path."/content/cache/tmp/".$file_name."\" -aoa -o\"".$path."\content\skins\"";
				$result = exec($command_line, $a);
			}
			else
			{
				$command_line =
					"unzip -o \"".$path."/content/cache/tmp/".$file_name."\" -d\"".$path."/content/skins/\"";

				$result = exec($command_line, $a);
			}
			
			echo json_encode(array('result' => 'success'));
		}
		else
		{
			echo json_encode(array('result' => 'error'));
		}
		exit;
	}

	if (isset($_GET['design_mode_flag']))
	{
		switch ($_GET['design_mode_flag'])
		{
			case 'On':
				// set admin session
				$_SESSION['admin_design_mode'] = true; 
				session_write_close();
				header('Location: '.$settings['GlobalHttpsUrl']."/".$settings["INDEX"]."?_admc=true&pcsid=".session_id());
				die();
				break;
				
			case 'Off':
			default: 
				// unset admin session
				$_SESSION['admin_design_mode'] = false;
				unset($_SESSION['admin_design_mode']);
				setcookie(
					"_admc", 
					"true", 
					time() - 60*60*24*365, 
					"/",
					isSslMode() ? $settings["GlobalHttpsCookieDomain"] : $settings["GlobalHttpCookieDomain"]
				);
		}
	}
	
	if (isset($_SESSION['admin_design_mode']) && $_SESSION['admin_design_mode'])
	{
		$design_mode_state = 'Deactivate';
		$design_mode_state_value = 'Off';
		$chart_param = "";
	}
	else
	{
		$design_mode_state = 'Activate';
		$design_mode_state_value = 'On&printing=true';
		$chart_param = "chart=true&";
	}

	pageHeader("Appearance Settings", "", "icb-monitor");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"This page allows you to select and manage your site themes", "url"=>"",  "visible"=>true)
	));
	
	$response = $themeManagerController->indexAction();
	
	print $response;
