<?php

	if (!defined("ENV")) exit();
	
	if (isset($_POST) && array_key_exists('skinName', $_POST))
	{
		if (!DEMO_LOCK)
		{
			// Make sure the skin exists
			if (is_dir('content/skins/'.escapeFileName($_POST['skinName'])))
			{
				// read in the skin xml file
				$template_xml = simplexml_load_string(file_get_contents('content'.DS.'skins'.DS.escapeFileName($_POST['skinName']).DS.'skin.xml'), 'SimpleXMLElement', LIBXML_NOCDATA);
				
				
				// Update the current selected skin in settings
				$db->reset();
				$db->assignStr('value', $_POST['skinName']);
				$db->update(DB_PREFIX.'settings', "WHERE name='DesignSkinName'");
				$settings['DesignSkinName'] = $_POST['skinName'];
				
				
				// Set the Site Layout Width to the default as defined in skin xml
				
				$layoutSiteWidth = $template_xml->xpath("/skin/settings/option[@name='LayoutSiteWidth']");
				$layoutSiteWidthValue = (count($layoutSiteWidth) && $layoutSiteWidth !== false)
					? $layoutSiteWidth[0]->attributes()->value
					: $settings['LayoutSiteWidthDefault'];
					
				$db->reset();
				$db->assignStr('value', $layoutSiteWidthValue);
				$db->update(DB_PREFIX.'settings', "WHERE name='LayoutSiteWidth' LIMIT 1");
				$settings['LayoutSiteWidth'] = $layoutSiteWidthValue;
				
				
				// check if we need to override the current layout settings with skin defaults,
				// otherwise, do nothing
				if (array_key_exists('layoutConfig', $_POST) && $_POST['layoutConfig'] == 'default')
				{
					// Does the skin have a default layout as described in the skin.xml file?
					$layoutElements = $settings['LayoutElementsDefault'];
					
					if (isset($template_xml->defaultLayoutElements) && (string) $template_xml->defaultLayoutElements !== '')
					{
						// suppress any possible errors when unserializing, and check if this is a serialized array
						if (($default_layout = @unserialize($template_xml->defaultLayoutElements)) !== false && is_array($default_layout))
						{
							$layoutElements = $template_xml->defaultLayoutElements;
						}
					}
					
					$db->reset();
					$db->assignStr('value', $layoutElements);
					$db->update(DB_PREFIX.'settings', "WHERE name='LayoutElements' LIMIT 1");
				}
				
				
				view()->assemble(
					array(
						'content'.DS.'engine'.DS.'design'.DS, 
						'content'.DS.'skins'.DS.escapeFileName($settings['DesignSkinName']).DS,
						'content'.DS.'skins'.DS.'_custom'.DS.'skin'.DS,
					), 
					'content'.DS.'cache'.DS.'skins'.DS.escapeFileName($settings['DesignSkinName']).DS
				);
			}
		}
		exit;
	}
	
	
	if (isset($_GET['design_mode_flag']))
	{
		switch ($_GET['design_mode_flag'])
		{
			case 'On': 
				$_SESSION['admin_design_mode'] = true;
				header('Location: '.$settings['GlobalHttpUrl']."/");
				break;
				
			case 'Off':
			default: 
				unset($_SESSION['admin_design_mode']);
		}
	}
	
	
	// FIXME: TBD - Need to pull from some service, for now we will read
	// filestructure for subdirectories as new skins
	$templates = array();
	
	if (($fh = opendir('content/skins')) !== false)
	{
		$restricted = array('.', '..', '.svn');
		
		while (($skin_name = readdir($fh)) !== false)
		{
			if (is_dir('content/skins/'.$skin_name) && file_exists('content/skins/'.$skin_name.'/skin.xml'))
			{
				// Read the XML skin file into the array
				$templates[$skin_name] = simplexml_load_string(file_get_contents('content/skins/'.$skin_name.'/skin.xml'), 'SimpleXMLElement', LIBXML_NOCDATA);
			}
		}
		
		closedir($fh);
	}
	
	// For now we read current installed templates by reading the skins directory
	// and parsing the skin.xml file at the skin level root
	$my_templates = '';
	foreach ($templates as $template_name => $template)
	{
		$activateLink = '<a class="activate" title="'.$template->name.'" href="#">Activate</a>';
		$selectedTemplate = '';
		if ($template->name == $settings['DesignSkinName'])
		{
			$activateLink = 'Current Skin';
			$selectedTemplate = 'currentTemplate';
		}
		
		$path_to_images = 'content/skins/'.$template_name.'/';
		$my_templates .= '<li class="template '.$selectedTemplate.'" title="'.htmlentities($template->name).'">
			<a href="'.$path_to_images.escapeFileName($template->preview).'" title="'.$template->title.'" class="preview"><img src="'.$path_to_images.escapeFileName($template->thumbnail).'" /></a>
			<p>
				<a href="'.$path_to_images.escapeFileName($template->preview).'" class="preview" title="'.$template->title.'">Preview</a> | <span class="templateStatus">'.$activateLink.'</span>
			</p>
			<span class="tags">'.strtolower($template->name).'</span>
			<table>
				<tr>
					<td class="key">Name:</td>
					<td class="value">'.$template->name.'</td>
				</tr>
				<tr>
					<td class="key">Author:</dt>
					<td class="value">'.htmlentities($template->author).'</td>
				</tr>
			</table>
		</li>';
	}
	
	if (isset($_SESSION['admin_design_mode']) && $_SESSION['admin_design_mode'])
	{
		$design_mode_state = 'Deactivate';
		$design_mode_state_value = 'Off';
	} else {
		$design_mode_state = 'Activate';
		$design_mode_state_value = 'On&printing=true';
	}
	
	pageHeader("Appearance Settings", "", "ic_appearance.gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please select the appearance setting you would like to adjust</b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>{$design_mode_state} Design Mode</b>", "url"=>"?p=design_settings&design_mode_flag={$design_mode_state_value}", "visible"=>true)
	));
?>
<script type="text/javascript" src="content/vendors/jquery/fancybox/jquery.fancybox.js"></script>
<script type="text/javascript" src="content/admin/javascript/jquery.ddm.core.js"></script>
<script type="text/javascript" src="content/admin/javascript/appearance_settings.js"></script>
<link rel="stylesheet" type="text/css" href="content/vendors/jquery/fancybox/jquery.fancybox-1.3.0.css" />
<link rel="stylesheet" type="text/css" href="content/admin/styles/appearance_settings.css" />
<?php
	pageTabs(array(
		array("title"=>"My Templates", "id"=>"myTemplates", "active"=>true, "width"=>100),
		// array("title"=>"Free Templates", "id"=>"freeTemplates", "active"=>false, "width"=>100),
		// array("title"=>"Premium Templates", "id"=>"premiumTemplates", "active"=>false, "width"=>100)
	));
?>
<div id="confirmSkinDialog">
	Change my skin to <span class="selectedSkin"></span> and:<br />
	<ul>
		<li><input type="radio" checked="checked" id="useLayout_default" name="useLayout" value="default" /> <label for="useLayout_default">discard my layout changes and use <span class="selectedSkin"></span>'s default layout <strong><em>(recommended)</em></strong></label></li>
		<li><input type="radio" id="useLayout_user" name="useLayout" value="user" /> <label for="useLayout_user">leave the layout changes I have already made *</label></li>
	</ul>
	<p class="note">* If selected, your cart may not look like the template in the preview.</p>
</div>
<div id="idTabSheetmyTemplates" class="sheetActive">
	<div class="browse">
		<label for="">Items per page</label> 
		<select id="">
			<option value="10">10</option>
			<option value="25">25</option>
			<option value="50">50</option>
			<option value="100">100</option>
		</select>
		<!-- Search: <input type="text" id="myTemplatesFilter" /> -->
	</div>
	<ul class="templates">
		<?=$my_templates?>
	</ul>
	<div class="clear"></div>
	<p class="noResults">No Results</p>
</div>
<?php
/*
<div id="idTabSheetfreeTemplates" class="sheetUnactive">
	<div class="browse">
		<label for="">Items per page</label> 
		<select id="">
			<option value="10">10</option>
			<option value="25">25</option>
			<option value="50">50</option>
			<option value="100">100</option>
		</select>
		Search: <input type="text" id="freeTemplatesFilter" />
	</div>
	<div>
		
	</div>
</div>
<div id="idTabSheetpremiumTemplates" class="sheetUnactive">
	<div class="browse">
		<label for="">Items per page</label> 
		<select id="">
			<option value="10">10</option>
			<option value="25">25</option>
			<option value="50">50</option>
			<option value="100">100</option>
		</select>
		
		Search: <input type="text" id="premiumTemplatesFilter" />
	</div>
	<ul class="templates">
		<?=$my_templates?>
	</ul>
	<div class="clear"></div>
</div>
*/
?>