<?php

	if (!defined("ENV")) exit();

	$action = isset($action)?trim($action):"";
	if ($action == "update_discounts" && !DEMO_LOCK)
	{
		$min_values = isset($min_values)?(is_array($min_values)?$min_values:array()):array();
		$max_values = isset($max_values)?(is_array($max_values)?$max_values:array()):array();
		$discounts = isset($discounts)?(is_array($discounts)?$discounts:array()):array();
		$types = isset($types)?(is_array($types)?$types:array()):array();
		$active = isset($active)?(is_array($active)?$active:array()):array();
		reset($min_values);
		foreach ($min_values as $id=>$min)
		{
			$db->reset();
			$db->assignStr("min", normalizeNumber($min_values[$id]));
			$db->assignStr("max", normalizeNumber($max_values[$id]));
			$db->assignStr("discount", normalizeNumber($discounts[$id]));
			$db->assignStr("type", $types[$id]);
			$db->assignStr("active", array_key_exists($id, $active)?"Yes":"No");
			$db->update(DB_PREFIX."discounts", "WHERE did='".$id."'");
		}
		$use_discounts = isset($use_discounts)?trim($use_discounts):"YES";
		$db->reset();
		$db->assignStr("value", $DiscountsActive);
		$db->update(DB_PREFIX."settings", "WHERE name='DiscountsActive'");
		$settings["DiscountsActive"] = $DiscountsActive;
	}
	
	//pageHeader("Promo Codes", "", "");
	
	$from_y = isset($from_y)?$from_y:date("Y");
	$from_m = isset($from_m)?$from_m:date("n");
	$from_d = isset($from_d)?$from_d:1;
	$from_hour = isset($from_hour)?intval($from_hour):12;
	$from_min = isset($from_min)?intval($from_min):0;
	$to_y = isset($to_y)?$to_y:date("Y");	
	$to_m = isset($to_m)?$to_m:date("n");
	$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
	$to_hour = isset($to_hour)?intval($to_hour):12;
	$to_min = isset($to_min)?intval($to_min):0;
	
	$action = empty($action)?"":$action;
	if ($action == "insert_promo" && !DEMO_LOCK)
	{
		$mysql_from =  $from_y."-".$from_m."-".$from_d." ".$from_hour.":".$from_min.":00";
		$mysql_to =  $to_y."-".$to_m."-".$to_d." ".$to_hour.":".$to_min.":00";
		$db->reset();
		$db->assignStr("name", $name);
		$db->assignStr("promo_code", $promo_code);
		$db->assignStr("promo_type", $promo_type);
		$db->assignStr("date_start", $mysql_from);
		$db->assignStr("date_stop", $mysql_to);
		$db->assignStr("is_active", $is_active);
		$db->assignStr("min_amount", $min_amount);
		$db->assignStr("discount", $discount);
		$db->assignStr("discount_type", $discount_type);
		$db->insert(DB_PREFIX."promo_codes");
		$pid = $db->insertId();
		$db->query("DELETE FROM ".DB_PREFIX."promo_products WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_categories WHERE pid='".$pid."'");
		
		if ($promo_type == "Product")
		{
			header("Location: admin.php?p=promo_edit&q=" . urlencode($pid));
		}
		$last_active_tab = "promo";
	}
	
	if ($action == "delete_promo" && !DEMO_LOCK)
	{
		$db->query("DELETE FROM ".DB_PREFIX."promo_codes WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_products WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_categories WHERE pid='".$pid."'");
		$last_active_tab = "promo";
	}
	
	if ($action == "update_promo" && !DEMO_LOCK)
	{
		$db->query("UPDATE ".DB_PREFIX."promo_codes SET is_active='No'");
		$is_active = empty($is_active)?array():$is_active;
		foreach ($is_active as $id=>$v)
		{
			$db->query("UPDATE ".DB_PREFIX."promo_codes SET is_active='Yes' WHERE pid='".$id."'");
		}
		$db->reset();
		$db->assignStr("value", $DiscountsPromo);
		$db->update(DB_PREFIX."settings", "WHERE name='DiscountsPromo'");
		$settings["DiscountsPromo"] = $DiscountsPromo;
		$last_active_tab = "promo";
	}
	
	loadJS("cf_promo.js");
	loadJS("cf_discounts.js");
	loadJS("cd_promo.js");
	
	pageHeader("Discounts", "", "icb-cutter");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"The discounts you set on this page are global for the cart and will be applied to all purchases.<br/>To set individual discounts, go to \"Add a Product\" page and enter the specific discount on a product.<br/>You can choose to use a range of discounts as a flat rate or percentage.<br/>Ideally, the range is used as an incentive to get larger purchases.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"Please note: Enter numbers with . (dot) decimal symbol", "url"=>"", "visible"=>true)
	));
	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"global";
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-discounts">
<?php 
	pageTabs(array(
		array("title"=>"Global Discounts", "id"=>"global"),
		array("title"=>"Promo Codes", "id"=>"promo"),
	), "tabs-discounts", $last_active_tab);
?>
<!-- START GLOBAL DISCOUNTS -->
<div id="admin-tab-sheet-global" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
		<div class="admin-form-header first"><span class="icon ic-icon"></span>Global Discounts</div>
		<form name="frmDiscounts" action="admin.php?p=discounts" method="post" onSubmit="return CheckDiscountsForm(this)">
			<input type="hidden" name="action" value="update_discounts">
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">Use global discounts?</td>
					<td class="formItemControl">
						<select name="DiscountsActive" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["DiscountsActive"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
			</table>
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th style="width:150px;">&nbsp;</th>
						<th style="width:150px;">Min Amount</th>
						<th style="width:150px;">Max Amount</th>
						<th style="width:150px;">Discount</th>
						<th>&nbsp;</th>
					</tr>
				</thead>
				<tbody>
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."discounts ORDER BY did");
	$i = 1;
	while ($db->moveNext())
	{
?>
					<tr>
						<td class="icon"><input id="id_active<?=$i?>" type="checkbox" name="active[<?=$db->col["did"]?>]" value="Yes" <?=$db->col["active"]=="Yes"?"checked":""?>></td>
						<td><label for="id_active<?=$i?>">Range <?=$i++?></label></td>
						<td><input type="text" name="min_values[<?=$db->col["did"]?>]" value="<?=myNum($db->col["min"])?>" class="short"/></td>
						<td><input type="text" name="max_values[<?=$db->col["did"]?>]" value="<?=myNum($db->col["max"])?>" class="short"/></td>
						<td><input type="text" name="discounts[<?=$db->col["did"]?>]" value="<?=myNum($db->col["discount"])?>" class="short"/></td>
						<td>
							<select name="types[<?=$db->col["did"]?>]" class="tiny">
								<option value="percent">%</option>
								<option value="amount" <?=$db->col["type"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
							</select>
						</td>
					</tr>
<?php
	}
?>
				</tbody>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
		</form>
	</div>
</div>
<!--- START PROMO CODES      --->
<div id="admin-tab-sheet-promo" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
		<div class="admin-form-header first"><span class="icon ic-icon"></span>Promo Codes</div>
		<form name="frmTaxes" action="admin.php?p=discounts" method="post">
			<input type="hidden" name="action" value="update_promo"/>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">Do you want to enable promo codes?</td>
					<td class="formItemControl">
						<select name="DiscountsPromo" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["DiscountsPromo"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
			</table>
<?php
	$db->query("
		SELECT *, 
			DATE_FORMAT(date_start, '%m/%d/%Y %I:%i %p') AS date1,
			DATE_FORMAT(date_stop, '%m/%d/%Y %I:%i %p') AS date2
		FROM ".DB_PREFIX."promo_codes ORDER BY pid");
	if ($db->numRows() < 1)
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b><span style=\"color:#990000\">There are currently no promo codes.</span></b>", "url"=>"", "visible"=>true)
		));
	}
	else
	{
?>
		
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th width="15%">Campaign Name</th>
						<th width="25%">Date Ranges</th>
						<th width="10%">Promo Code</th>
						<th width="15%">Promo Type</th>
						<th width="10%">Discount</th>
						<th width="10%">Subtotal</th>
						<th>&nbsp;</th>
					</tr>
				</thead>
				<tbody>
<?php
		while($db->moveNext())
		{
			switch (gs($db->col['promo_type']))
			{
				case 'Global': $promotion_type = 'Global Promo'; break;
				case 'Product': $promotion_type = 'Product-based Promo'; break;
				case 'Shipping': $promotion_type = 'Shipping-based Promo'; break;
				default: $promotion_type = 'Error'; break;
			}
?>
					<tr>
						<td class="icon">
							<input id="sdf_<?=$db->col["pid"]?>" type="checkbox" name="is_active[<?=$db->col["pid"]?>]" value="Yes" <?=$db->col["is_active"]=="Yes"?"checked":""?>>
						</td>
						<td><label for="sdf_<?=$db->col["pid"]?>"><?=gs($db->col["name"])?></label></td>
						<td><?=gs($db->col["date1"])?> - <?=gs($db->col["date2"])?></td>
						<td><?=gs($db->col["promo_code"])?></td>
						<td><?=$promotion_type?></td>
						<td><?=$db->col["discount_type"]=="amount"?getAdminPrice($db->col["discount"]):(number_format($db->col["discount"],2)." %")?></td>
						<td><?=getAdminPrice($db->col["min_amount"])?></td>
						<td style="text-align:right;">
<?php
			if ($db->col["promo_type"] == "Product") // In case of typo -- Ricky26
			{
				echo '<a href="admin.php?p=promo_edit&q=' . $db->col["pid"] . '"><img src="images/icons/a/gear.png" alt="Edit" title="Edit Promo Code" border="0"></a>';
			} 
?>
							<a href="javascript:ConfirmDeletePromo(<?=$db->col["pid"]?>)"><img src="images/icons/a/delete.png" title="Delete Promo Code" border="0"></a>
						</td>
					</tr>
<?php
		}
?>
				</tbody>
			</table>
		
<?php
	}
?>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
		</form>
		<div class="admin-form-header"><span class="icon ic-icon"></span>Create a New Promo Code</div>
		<form name="frmPromo" action="admin.php?p=discounts" method="post" onsubmit="return CheckPromoForm(this)" enctype="multipart/form-data">
			<input type="hidden" name="action" value="insert_promo"/>
			
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption required">Campaign Name</td>
					<td class="formItemControl">
						<input type="text" name="name" maxlength="250"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Promo Code</td>
					<td class="formItemControl"><input type="text" name="promo_code" maxlength="250"></td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Is it Active?</td>
					<td class="formItemControl">
						<select name="is_active" class="short">
							<option value="Yes">Yes</option>
							<option value="No">No</option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="formItemCaption required">Type of promotion?</td>
					<td class="formItemControl">
						<select name="promo_type" class="short">
							<option value="Global">Global</option>
							<option value="Product">Product-based</option>
							<option value="Shipping">Shipping-based</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Start Date</td>
					<td class="formItemControl">
						<select name="from_m" class="date-month">
<?php
	for ($i=1; $i<=12; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option>
<?php
	}
?>
						</select>
						<select name="from_d" class="date-day">
<?php
	for ($i=1; $i<=31; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option>
<?php
	}
?>
						</select>
						<select name="from_y" class="date-year">
<?php
	for ($i=2003; $i<=date("Y")+10; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option>
<?php
	}
?>
						</select>
						<select name="from_hour" style="width:80px;margin-left:15px;">		
<?php
	for ($i=0; $i<=23; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $from_hour?"selected":""?>>
<?php 
		if ($i == 0) echo "12";
		elseif ($i < 13) echo $i;
		else echo $i - 12;
		echo $i >= 12 ? " pm" : " am";
?>
							</option>
<?php
	}
?>
						</select>
						<select name="from_min" style="width:80px;">		
<?php
	for ($i=0; $i<=59; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $from_min?"selected":""?>><?=($i<10?"0":"").$i?></option>
<?php
	}
?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">End Date</td>
					<td class="formItemControl">
						<select name="to_m" class="date-month">
<?php
	for ($i=1; $i<=12; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option>
<?php
	}
?>			
						</select>
						<select name="to_d" class="date-day">
<?php
	for ($i=1; $i<=31; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option>
<?php
	}
?>
						</select>
						<select name="to_y" class="date-year">
<?php
	for ($i=2003; $i<=date("Y")+10; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option>
<?php
	}
?>
						</select>
						<select name="to_hour" style="width:80px;margin-left:15px;">		
<?php
	for ($i=0; $i<=23; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $to_hour?"selected":""?>>
<?php 
		if ($i == 0) echo "12";
		elseif ($i < 13) echo $i;
		else echo $i - 12;
		echo $i >= 12 ? " pm" : " am";
?>
							</option>
<?php
	}
?>
						</select>
						<select name="to_min" style="width:80px;">		
<?php
	for ($i=0; $i<=59; $i++)
	{
?>
							<option value="<?=$i?>" <?=$i == $to_min?"selected":""?>><?=($i<10?"0":"").$i?></option>
<?php
	}
?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Discount</td>
					<td class="formItemControl">
						<input type="text" name="discount" class="short"/>
						<select name="discount_type" class="short">
							<option value="amount"><?=$admin_currency["code"]?></option>
							<option value="percent">%</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Minimum order subtotal for this code</td>
					<td class="formItemControl"><input type="text" name="min_amount" class="short"/></td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
		</form>
	</div>
</div>