<?php
	if (!defined("ENV")) exit();
?>
<div class="admin-form-header first"><span class="icon ic-icon ic-cutter"></span>Mapping Products</div>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr valign="top">
		<td class="formItemCaption">Map</td>
		<td class="formItemControl">
			<select id="dobaMappingOption" name="data[doba_mapping_option]">
				<option value="unlocked">Apply only to unlocked products</option>
				<option value="all">Apply to all products</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Keep Doba categories</td>
		<td class="formItemControl">
			<select id="dobaMappingKeepCategories" name="data[doba_mapping_keep_categories]">
				<option value="yes">Yes</option>
				<option value="no">No</option>
			</select>
		</td>
	</tr>
</table>
<div class="admin-form-buttons">
	<input type="button" id="buttonRemapSettings" value="Remap Now"/>
</div>
<?php
	require_once("content/classes/class.doba_mapper.php");
	$mapper = new DobaMapper($db, $settings);
?>
<div class="admin-form-header"><span class="icon ic-icon ic-cutter"></span>Categories and Products Mapping</div>
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr>
		<td colspan="2">
<?php
	if (($categories = $mapper->getDobaCategories()) == null)
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Please import Doba products first!</b>"),
		));
	}
	else
	{
		function drawCategory($category)
		{
			$hideLevel = 2; // hide under level
			$iconWidth = 15; // px
			echo 
				'<div class="admin-tree-node clearfix '.($category["subcats"] == 1 ? "doba-include-subcats" : "").' '.($category["mapped"] == 1 ? "doba-category-mapped" : "").'" id="doba-node-'.($category["cid"]).'">'.
					'<input type="hidden" value="'.($category["cid"]).'"/>'.
					'<div style="padding-left:'.(($category["level"]-1) * $iconWidth).'px;">'.
						'<div class="admin-icon float-left '.(count($category["children"]) > 0 ? ('admin-icon-clickable admin-icon-'.($category["level"] <= $hideLevel ? 'south' : 'east')) : 'admin-icon-square').'">&nbsp;</div>'.
						'<div class="float-left doba-category-name">'.htmlspecialchars($category["name"]).'</div>'.
						'<div class="doba-subcats">&nbsp;<i>(include subcategories)</i></div>'.
					'</div>'.
				'</div>';
			
			if (count($category["children"]) > 0)
			{
				echo '<div class="doba-children '.($category['level'] > $hideLevel ? 'hidden' : '').'">';
				foreach ($category["children"] as $child)
				{
					drawCategory($child);
				}
				echo '</div>';
			}
		}
?>
			<div id="dobaCategories">
				<div style="margin:7px 0px;">
					<a href="" id="dobaCategoriesExpandAll">Expand all</a> /
					<a href="" id="dobaCategoriesCollapseAll">Collapse all</a>
				</div>
<?php
		foreach ($categories as $category)
		{
			if ($category["level"] == 1) drawCategory($category);
		}
?>
			</div>
<?php
	}
?>
		</td>
	</tr>
</table>
<?php

	class OPTION_PARAM
	{
		var $parent_id;
		var $level;
		var $categories;
		function OPTION_PARAM($parent_id, $level, $categories = array())
		{
			$this->parent_id = $parent_id;
			$this->level = $level;
			$this->categories = $categories;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			if ($this->id != TREE_ROOT)
			{
				echo '<option value="'.$this->id.'" '.(($this->id == $param->parent_id || in_array($this->id, $param->categories))?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
				echo str_repeat("&nbsp;", ($param->level-1)*4);
				echo htmlspecialchars($this->caption).'</option>';
			}
			if (count($this->nodes)>0)
			{
				reset($this->nodes);
				foreach ($this->nodes as $id => $node)
				{
					$node->drawNode(
						new OPTION_PARAM($param->parent_id, $param->level+1, $param->categories)
					);
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes",  "None selected"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE SUBSTR(key_name, 1, 5) <> 'doba_' ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	while ($db->moveNext())
	{
		$tree->addNode(
			new OPTION_NODE(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
?>
<div id="dobaMappingDialog">
	<div>
		Primary category:<br/>
		<select style="width:675px;" id="dobaMappingDialogPrimaryCategory">
			<option value="0">None (keep Doba category)</option>
<?php
	$tree->collection[TREE_ROOT]->drawNode(new OPTION_PARAM(0, 0));
?>
		</select><br/><br/>
		Please select secondary cart categories:<br/>
		<input type="text" style="width:670px;margin-bottom:10px;" id="dobaMappingDialogSearch">
		<select multiple style="width:675px;height:230px;" id="dobaMappingDialogCategories">
<?php
	$tree->collection[TREE_ROOT]->drawNode(new OPTION_PARAM(0, 0));
?>
		</select><br/>
		To select multiple categories please hold CTRL key on PC or Command key on your Mac<br/>
		<div style="margin-top:10px;">
			<input type="checkbox" value="1" id="dobaMappingDialogIncludeSubCategories"/>
			<label for="dobaMappingDialogIncludeSubCategories">
				Include nested Doba subcategories.
			</label>
		</div>
	</div>
</div>
