<?php
	if (!defined("ENV")) exit();
?>
<form action="admin.php?p=doba&last_active_tab=idTabSettings" method="POST">
	<input type="hidden" name="action" value="save_settings"/>
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"></div>
				<div class="formHeaderText">Doba Settings</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Current status</td>
			<td class="formItemControl">
				<select name="data[doba_mode]">
					<option value="Live">Live</option>
					<option value="Test" <?=$settings["doba_mode"] == "Test" ? 'selected="selected"' : ''?>>Test</option>
				</select>
				<div class="formItemComment">
					Please note: after changing mode Live to Test, or vice-versa, you may also need to change your username,
					password and retailer id for the system to work properly.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required">Username</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_username]" value="<?=htmlspecialchars($settings["doba_username"])?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required"><b>Password</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_password]" value="<?=htmlspecialchars($settings["doba_password"])?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required">Retailer ID</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_retailer_id]" value="<?=htmlspecialchars($settings["doba_retailer_id"])?>"> <span id="doba-activation-status"></span>
				<div class="formItemComment">
					To get your Retailer ID:
					<ol>
						<li>Log into your Doba account.</li>
						<li>Select "Settings" from the navigation options.</li>
						<li>Your Retailer ID will be listed in the "Personal Information" box.</li>
					</ol>
				</div>
			</td>
		</tr>
<?php
	/**
	 * Start Activation link - only display after they have entered their credentials
	 */
	if (trim($settings['doba_retailer_id']) != '')
	{
?>
		<tr valign="top" class="activation-link">
			<td class="formItemCaption">Activation Link</td>
			<td class="formItemControl">
				<a href="#" id="requestActivation">Click here to activate your account</a>
				<div class="formItemComment">
					Once you clicked the link above, you will need to login to DOBA (www.doba.com) and approve the activation so the cart can access your account.<br />Please understand your cart will not have access to your DOBA account until this step is completed.
				</div>
			</td>
		</tr>
<?php
	}
	/**
	 * End Activation link
	 */
?>
		<tr valign="top">
			<td class="formItemCaption">Auto-send orders?</td>
			<td class="formItemControl">
				<select name="data[doba_autosend_orders]">
					<option value="Yes">Yes</option>
					<option value="No" <?=$settings["doba_autosend_orders"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					Do you want to send orders to Doba immediately after the payment has been received?
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Default payment method</td>
			<td class="formItemControl">
				<select name="data[doba_payment_type]">
					<option value="CC">Credit Card</option>
					<option value="Prepaid" <?=$settings["doba_payment_type"] == "Prepaid" ? 'selected="selected"' : ''?>>Prepaid</option>
				</select>
				<div class="formItemComment">
					For prepaid orders CCV2 code is not required when funding
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Callback propagation mode</td>
			<td class="formItemControl">
				<select name="data[doba_callback_mode]">
					<option value="None">None</option>
					<option value="Master" <?=$settings["doba_callback_mode"] == "Master" ? 'selected="selected"' : ''?>>Master</option>
					<option value="Slave" <?=$settings["doba_callback_mode"] == "Slave" ? 'selected="selected"' : ''?>>Slave</option>
				</select>
				<div class="formItemComment">
					If you have more as one cart using Doba services, you can propagate Doba callbacks on those carts.<br/>In Doba settings set callback URL to Master cart, 
					and in Master cart set URLs to Slave carts.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Callback key</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_callback_access_key]" value="<?=htmlspecialchars($settings["doba_callback_access_key"])?>">
				<div class="formItemComment">
					If you use callback propagation, please enter Key here. It should be the same in Master / Slave carts. 
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Callback URLs</td>
			<td class="formItemControl">
				<textarea style="width:400px;height:120px;" type="text" name="data[doba_callback_urls]"><?=htmlspecialchars($settings["doba_callback_urls"])?></textarea>
				<div class="formItemComment">
					Please enter Slave carts callback URLs. One per line including http:// or https://.
				</div>
			</td>
		</tr>
		<!-- 
		<tr valign="top">
			<td class="formItemCaption">Auto-fund orders?</td>
			<td class="formItemControl">
				<select name="data[doba_autofund_orders]">
					<option value="Yes">Yes</option>
					<option value="No" <?=$settings["doba_autofund_orders"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					Do you want to fund Doba orders immediately after the payment has been received?
					Please note: Auto-send orders MUST be enabled.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Max order amount to be auto funded</td>
			<td class="formItemControl">
				<input type="text" name="data[doba_autofund_limit]" value="<?php echo $settings["doba_autofund_limit"];?>"/>
				<div class="formItemComment">
					Maximum doba products subtotal for auto-funding. 
				</div>
			</td>
		</tr>
		 -->
		<tr valign="top">
			<td class="formItemCaption">Auto-update inventory?</td>
			<td class="formItemControl">
				<select name="data[doba_cron_update]">
					<option value="Yes">Yes</option>
					<option value="No" <?=$settings["doba_cron_update"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					To auto-update inventory, you will need to setup a cron job on your server. Once you have done this,
					you can activate this feature. For more information on setting up a cron job, please contact your
					hosting company's customer service department.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Download images from Doba?</td>
			<td class="formItemControl">
				<select name="data[doba_images]">
					<option value="No" <?=$settings["doba_images"] == "No" ? 'selected="selected"' : ''?>>No</option>
					<option value="New" <?=$settings["doba_images"] == "New" ? 'selected="selected"' : ''?>>Only for new products or when primary image does not exist</option>
					<option value="All" <?=$settings["doba_images"] == "All" ? 'selected="selected"' : ''?>>Force download image for all products (slow)</option>
					
				</select>
				<div class="formItemComment">Do you want to download images from doba and save them locally?</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Download secondary images as well?</td>
			<td class="formItemControl">
				<select name="data[doba_images_secondary]">
					<option value="Yes" <?=$settings["doba_images_secondary"] == "Yes" ? 'selected="selected"' : ''?>>Yes</option>
					<option value="No" <?=$settings["doba_images_secondary"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					If "Yes" is selected, images will be reupdated (removed from site and downloaded back from Doba).
					Require primary image download to be enabled
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">&nbsp;</td>
			<td class="formItemControl">
				<input type="submit" value="Save Settings"/>
			</td>
		</tr>
	</table>
</form>