<?php
	if (!defined("ENV")) exit();
?>
<form action="admin.php?p=doba&last_active_tab=idTabSettings" method="POST">
	<input type="hidden" name="action" value="save_settings"/>
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"></div>
				<div class="formHeaderText">Doba Settings</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Current status</td>
			<td class="formItemControl">
				<select name="data[doba_mode]">
					<option value="Live">Live</option>
					<option value="Test" <?=$settings["doba_mode"] == "Test" ? 'selected="selected"' : ''?>>Test</option>
				</select>
				<div class="formItemComment">
					Please note: after changing mode Live to Test, or vice-versa, you may also need to change your username,
					password and retailer id for the system to work properly.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required">Username</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_username]" value="<?=htmlspecialchars($settings["doba_username"])?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required"><b>Password</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_password]" value="<?=htmlspecialchars($settings["doba_password"])?>">
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption required">Retailer ID</td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="data[doba_retailer_id]" value="<?=htmlspecialchars($settings["doba_retailer_id"])?>"> <span id="doba-activation-status"></span>
				<div class="formItemComment">
					To get your Retailer ID:
					<ol>
						<li>Log into your Doba account.</li>
						<li>Select "Settings" from the navigation options.</li>
						<li>Your Retailer ID will be listed in the "Personal Information" box.</li>
					</ol>
				</div>
			</td>
		</tr>
		<?php
		/**
		 * Start Activation link - only display after they have entered their credentials
		 */
		if (trim($settings['doba_retailer_id']) != '')
		{
		?>
		<tr valign="top" class="activation-link">
			<td class="formItemCaption">Activation Link</td>
			<td class="formItemControl">
				<a href="#" id="requestActivation">Click here to activate your account</a>
				<div class="formItemComment">
					Once you clicked the link above, you will need to login to DOBA (www.doba.com) and approve the activation so the cart can access your account.<br />Please understand your cart will not have access to your DOBA account until this step is completed.
				</div>
			</td>
		</tr>
		<?php
		}
		/**
		 * End Activation link
		 */
		?>
		<tr valign="top">
			<td class="formItemCaption">Auto-send orders?</td>
			<td class="formItemControl">
				<select name="data[doba_autosend_orders]">
					<option value="Yes">Yes</option>
					<option value="No" <?=$settings["doba_autosend_orders"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					Do you want to send orders to Doba immediately after the payment has been received?
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Auto-update inventory?</td>
			<td class="formItemControl">
				<select name="data[doba_cron_update]">
					<option value="Yes">Yes</option>
					<option value="No" <?=$settings["doba_cron_update"] == "No" ? 'selected="selected"' : ''?>>No</option>
				</select>
				<div class="formItemComment">
					To auto-update inventory, you will need to setup a cron job on your server. Once you have done this,
					you can activate this feature. For more information on setting up a cron job, please contact your
					hosting company's customer service department.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">&nbsp;</td>
			<td class="formItemControl">
				<input type="submit" value="Save Settings"/>
			</td>
		</tr>
	</table>
</form>