<?php
	if (!defined("ENV")) exit();

	pageHeader("Drift Marketing Email Campaign", "", "icb-swimming");
	loadJS('drift_marketing.js');

?>
	<div style="margin:20px">
		<div>
			This tool will allow you to set up a campaign to target customer who abandon their cart and create an incentive to invite have them complete their order.
			You can designate the time when the email will be sent and the content for each email.
			The email below will display all the items in their cart with a link to their saved cart on your store.
		</div>
		<div style="margin-top:10px;">IMPORTANT - This feature requires your store to have the cron job feature running.</div>
		<div style="margin-top:10px; font-style: italic;">
			Variable Information:
        </div>
		<div style="margin-left:20px;">
			<div>{$ItemsInCart} - List all items in cart</div>
			<div>{$CartLink} - URL to saved cart</div>
		</div>
	</div>
	
<?php
	require_once("content/classes/class.drift_email_campaign.php");
	$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
	$mode = isset($_REQUEST["mode"])?$_REQUEST["mode"]:"";
    $campaign_id = isset($_REQUEST["campaign_id"])?intval($_REQUEST["campaign_id"]):null;
	$last_active_tab = isset($last_active_tab) ? trim($last_active_tab) : ($mode=="edit"?"edit":"add");

	$message = false;

	switch ($action)
	{
		case "deleteCampaign" :
		{
			if ($campaign_id && !DEMO_LOCK)
			{
				DriftEmailCampaign::DeleteById($db, $campaign_id);
				$active_tab = 'EditCampaign';
				$message = "Campaign has been deleted";
			}
			break;
		}
		
		case "addCampaign" :
		{
			if (!DEMO_LOCK)
			{
				$title = isset($_REQUEST["driftEmailCampaign_title"])?$_REQUEST["driftEmailCampaign_title"]:null;
				$emailHtml  = isset($_REQUEST["driftEmailCampaign_emailHtml"])?$_REQUEST["driftEmailCampaign_emailHtml"]:null;
				$emailPlain = isset($_REQUEST["driftEmailCampaign_emailPlain"])?$_REQUEST["driftEmailCampaign_emailPlain"]:null;
				$emailSubject = isset($_REQUEST["driftEmailCampaign_emailPlain"])?$_REQUEST["driftEmailCampaign_emailSubject"]:null;
				$timeframe  = isset($_REQUEST["driftEmailCampaign_timeframe"])?$_REQUEST["driftEmailCampaign_timeframe"]:null;
				$campaign = new DriftEmailCampaign($db);
				$campaign->SetTitle($title);
				$campaign->SetHtmlEmail($emailHtml);
				$campaign->SetPlainEmail($emailPlain);
				$campaign->SetTimeframe($timeframe);
				$campaign->SetEmailSubject($emailSubject);
				$campaign->Save();

				$message = "New campaign has been added";
				$last_active_tab = "edit";
			}
			break;
		}
		
		case "updateCampaign":
		{
			if (!DEMO_LOCK)
			{
				$title = isset($_REQUEST["driftEmailCampaign_title"])?$_REQUEST["driftEmailCampaign_title"]:null;
				$emailHtml  = isset($_REQUEST["driftEmailCampaign_emailHtml"])?$_REQUEST["driftEmailCampaign_emailHtml"]:null;
				$emailPlain = isset($_REQUEST["driftEmailCampaign_emailPlain"])?$_REQUEST["driftEmailCampaign_emailPlain"]:null;
				$timeframe  = isset($_REQUEST["driftEmailCampaign_timeframe"])?$_REQUEST["driftEmailCampaign_timeframe"]:null;
				$emailSubject = isset($_REQUEST["driftEmailCampaign_emailPlain"])?$_REQUEST["driftEmailCampaign_emailSubject"]:null;
				$campaign = DriftEmailCampaign::LoadById($db, $campaign_id);
				$campaign->SetTitle($title);
				$campaign->SetHtmlEmail($emailHtml);
				$campaign->SetPlainEmail($emailPlain);
				$campaign->SetTimeframe($timeframe);
				$campaign->SetEmailSubject($emailSubject);
				$campaign->Save();

				$message = "Campaign has been updated";
			}
			break;
		}
	}

	if ($message)
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<strong>$message</strong>")
 		));
	}


	$emailCampaigns = DriftEmailCampaign::LoadAll($db);
	$defailtEmail_html = '
<div style="text-align: center">
    <div style="margin: auto; width: 600px; height: 800px; overflow: auto; border: solid 1px #ababab">
        <h1>' . $settings["CompanyName"].'</h1>
        <hr />
        <div>
            <div>
                {$ItemsInCart}
            </div>
        </div>
        <div>
            <a href="{$CartLink}">Click here to go back to your cart</a>
        </div>
    </div>
</div>';
        $defaultEmail_plain = '
' . $settings["CompanyName"].'
----------
{$ItemsInCart}
----------
To go back to your cart, please visit {$CartLink}';
?>

<script type="text/javascript">
function confirmDeleteDriftEmailCampaign(id)
{
	return (confirm('Are you sure you want to delete the campaign "'+$('#campaign_'+id).html()+'" (ID: '+id+')?'));
}
</script>

<div class="admin-tabs admin-tabs-framed" id="tabs-drift">
<?php
	pageTabs(array(
		array("title"=>"Add New Campaign", "id"=>"add"),
		array("title"=>"Edit Existing Campaign", "id"=>"edit"),
	), "tabs-drift", $last_active_tab);
?>
	<div id="admin-tab-sheet-add" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form id="frmAddGroup" action="admin.php?p=drift_marketing" method="POST" onsubmit="return checkAddDriftCampaign(this)">
				<input type="hidden" name="action" value="addCampaign"/>
				<div class="admin-form-header first"><span class="icon ic-icon ic-add"></span>Add a New Email Campaign</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Name Campaign</td>
						<td class="formItemControl">
							<input type="text" name="driftEmailCampaign_title" maxlength="255" value=""/>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">When cart is abandoned, send out the following email</td>
						<td class="formItemControl">
							<select name="driftEmailCampaign_timeframe" class="short">
								<option value="0">Immediately</option>
								<option value="15">15 minutes</option>
								<option value="30">30 minutes</option>
								<option value="60">1 hour</option>
								<option value="120">2 hours</option>
								<option value="240">4 hours</option>
								<option value="720">12 hours</option>
								<option value="1440">24 hours</option>
								<option value="2160">36 hours</option>
								<option value="2880">48 hours</option>
								<option value="4220">3 days</option>
								<option value="5760">4 days</option>
								<option value="7200">5 days</option>
								<option value="86400">6 days</option>
								<option value="10080">7 days</option>
								<option value="20160">14 days</option>
								<option value="30240">21 days</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Email Subject</td>
						<td class="formItemControl">
							<input type="text" name="driftEmailCampaign_emailSubject" maxlength="100" value=""/>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Html Email Contents</td>
						<td class="formItemControl">
							<textarea name="driftEmailCampaign_emailHtml"><?=$defailtEmail_html?></textarea>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Text Email Contents</td>
						<td class="formItemControl">
							<textarea name="driftEmailCampaign_emailPlain"><?=$defaultEmail_plain?></textarea>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>

	<div id="admin-tab-sheet-edit" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
<?php
	if ($mode == "edit")
	{
		if ($campaign_id)
		{
			$campaign = DriftEmailCampaign::LoadById($db, $campaign_id);
		}
?>
			<form id="frmEditCampaign" action="admin.php?p=drift_marketing" method="POST" onsubmit="return checkEditDriftCampaign(this);">
				<input type="hidden" name="action" value="updateCampaign"/>
				<input type="hidden" name="campaign_id" value="<?=$campaign->GetCampaignId()?>"/>
				<input type="hidden" name="last_active_tab" value="edit"/>
	
				<div class="admin-form-header first"><span class="icon ic-icon ic-pencil"></span>Edit Email Campaign</div>
				
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Name Campaign</td>
						<td class="formItemControl">
							<input type="text" name="driftEmailCampaign_title" maxlength="255" value="<?=$campaign->GetTitle()?>"/>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">When cart is abandoned, send out the following email</td>
						<td class="formItemControl">
							<select name="driftEmailCampaign_timeframe" class="short">
								<option value="0" <?=($campaign->GetTimeframe()==0?"selected":"")?>>Immediately</option>
								<option value="15" <?=($campaign->GetTimeframe()==15?"selected":"")?>>15 minutes</option>
								<option value="30" <?=($campaign->GetTimeframe()==30?"selected":"")?>>30 minutes</option>
								<option value="60" <?=($campaign->GetTimeframe()==60?"selected":"")?>>1 hour</option>
								<option value="120" <?=($campaign->GetTimeframe()==120?"selected":"")?>>2 hours</option>
								<option value="240" <?=($campaign->GetTimeframe()==240?"selected":"")?>>4 hours</option>
								<option value="720" <?=($campaign->GetTimeframe()==720?"selected":"")?>>12 hours</option>
								<option value="1440" <?=($campaign->GetTimeframe()==1440?"selected":"")?>>24 hours</option>
								<option value="2160" <?=($campaign->GetTimeframe()==2160?"selected":"")?>>36 hours</option>
								<option value="2880" <?=($campaign->GetTimeframe()==2880?"selected":"")?>>48 hours</option>
								<option value="4220" <?=($campaign->GetTimeframe()==4220?"selected":"")?>>3 days</option>
								<option value="5760" <?=($campaign->GetTimeframe()==5760?"selected":"")?>>4 days</option>
								<option value="7200" <?=($campaign->GetTimeframe()==7200?"selected":"")?>>5 days</option>
								<option value="86400" <?=($campaign->GetTimeframe()==86400?"selected":"")?>>6 days</option>
								<option value="10080" <?=($campaign->GetTimeframe()==10080?"selected":"")?>>7 days</option>
								<option value="20160" <?=($campaign->GetTimeframe()==20160?"selected":"")?>>14 days</option>
								<option value="30240" <?=($campaign->GetTimeframe()==30240?"selected":"")?>>21 days</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Email Subject</td>
						<td class="formItemControl">
							<input type="text" name="driftEmailCampaign_emailSubject" maxlength="100" value="<?=$campaign->GetEmailSubject()?>"/>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Html Email Contents</td>
						<td class="formItemControl">
							<textarea class="EmailInput" name="driftEmailCampaign_emailHtml"><?=$campaign->GetHtmlEmail()?></textarea>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Text Email Contents</td>
						<td class="formItemControl">
							<textarea class="EmailInput" name="driftEmailCampaign_emailPlain"><?=$campaign->GetPlainEmail()?></textarea>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
<?php
	}
	else
	{
?>
			<div class="admin-form-header first"><span class="icon ic-icon"></span>Browse / Edit Campaign</div>
<?php
		if ($emailCampaigns)
		{
?>
			<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon"></th>
						<th>Campaign Name</th>
						<th style="width:100px;">&nbsp;</th>
					</tr>
				</thead>
				<tbody>
<?php
			foreach ($emailCampaigns as $emailCampaign)
			{
?>
					<tr>
						<td>&nbsp;</div>
						<td><span id="campaign_<?=$emailCampaign->GetCampaignId()?>"><?=htmlspecialchars($emailCampaign->GetTitle())?></span></div>
						<td>
							<a href="admin.php?p=drift_marketing&last_active_tab=edit&mode=edit&campaign_id=<?=$emailCampaign->GetCampaignId()?>"><img border="0" src="images/icons/a/pencil.png" alt="Click to edit drift marketing email campaign"/></a>
							<a href="admin.php?p=drift_marketing&last_active_tab=edit&action=deleteCampaign&campaign_id=<?=$emailCampaign->GetCampaignId()?>" onclick="return confirmDeleteDriftEmailCampaign('<?=$emailCampaign->GetCampaignId()?>');"><img src="images/icons/a/delete.png" alt="Click to delete drift marketing email campaign" border="0"/></a>
						</td>
					</tr>
<?php
			}
?>
				</tbody>
			</table>
<?php
		}
		else
		{
?>
			<div class="listEmpty">
				You do not have any drift marketing campaigns setup.
			</div>
<?php
		}
	}
?>			
			
		</div>
	</div>
</div>