<?php
	if (!defined("ENV")) exit();
	$email_templates = array(
		"signup_admin" => "New user registered - for Administrators",
		"signup_user" => "New user registered - for Users",
		"order_received_admin" => "New order - for Administrators",
		"order_received_user" => "New order - for Users",
		"reset_password" => "Password reset - for Users",
		"to_friend" => "Email to a Friend",
		"admin_product_review" => "New product review - for Administrators",
		"products_location_notification" => "Product location facility shipment (drop-shipment) notification"
	);

	$id = isset($id)?trim($id):"";
	
	if (array_key_exists($id, $email_templates))
	{
		pageHeader("Notification", $email_templates[$id], "icb-envelope-star");

		$template_html_location = false;
		$template_text_location = false;

		$email_path_base = "content/engine/design/templates/emails/";
		$email_path_skin = "content/skins/".escapeFileName($settings["DesignSkinName"])."/templates/emails/";
		$email_path_custom = "content/skins/_custom/skin/templates/emails/";
		$email_path_cache = "content/cache/skins/".escapeFileName($settings["DesignSkinName"])."/templates/emails/";
		
		if (isset($_POST['Restore']))
		{
			if (is_file($email_path_custom.$id."_html.html"))
				unlink($email_path_custom.$id."_html.html");
	
			if (is_file($email_path_custom.$id."_text.html"))
				unlink($email_path_custom.$id."_text.html");
		}
		else
		{
			$action = isset($action)?trim($action):"";
			
			if ($action == "save" && !DEMO_LOCK)
			{
				if (!is_dir($email_path_custom)) mkdir($email_path_custom, 0777, 1);
				if (!is_dir($email_path_cache)) mkdir($email_path_cache, 0777, 1);
				
				$email_html = isset($email_html)?$email_html:"";
				$email_text = isset($email_text)?$email_text:"";
				$i = 0;
				$i += (file_put_contents($email_path_custom.$id."_html.html", stripslashes($email_html)) ? 1 : 0);
				$i += (file_put_contents($email_path_custom.$id."_text.html", stripslashes($email_text)) ? 1 : 0);
				$i += (file_put_contents($email_path_cache.$id."_html.html", stripslashes($email_html)) ? 1 : 0);
				$i += (file_put_contents($email_path_cache.$id."_text.html", stripslashes($email_text)) ? 1 : 0);
				
				if ($i<4)
				{
					Admin_Flash::setMessage('Can\'t save email template. Pleas check free space and write permissions!', Admin_Flash::TYPE_ERROR);
				}
				else
				{
					Admin_Flash::setMessage('Email template has been successfully saved');
				}
			}
		}

		//load emails
		if (is_file($email_path_custom.$id."_html.html"))
		{
			$email_file_html = $email_path_custom.$id."_html.html";
			$template_html_location = "custom";
		}
		elseif (is_file($email_path_skin.$id."_html.html"))
		{
			$email_file_html = $email_path_skin.$id."_html.html";
			$template_html_location = "skin";
		}
		else
		{
			$email_file_html = $email_path_base.$id."_html.html";
			$template_html_location = "base";
		}
		
		if (is_file($email_path_custom.$id."_text.html"))
		{
			$email_file_text = $email_path_custom.$id."_text.html";
			$template_text_location = "custom";
		}
		elseif (is_file($email_path_skin.$id."_text.html"))
		{
			$email_file_text = $email_path_skin.$id."_text.html";
			$template_text_location = "skin";
		}
		else
		{
			$email_file_text = $email_path_base.$id."_text.html";
			$template_text_location = "base";
		}

		$email_html = file_get_contents($email_file_html);
		$email_text = file_get_contents($email_file_text);

		pageNote(array(
			array("class"=>"ic-info", "text"=>
				"Please Note: The cart uses specific, pre-defined data tags that will be automatically replaced with critical
				information when an email is sent.<br/>For example, in most notification emails the data tag will be automatically
				replaced with Company name defined in the site settings section.<br/>You must be extremely careful when editing to
				prevent data from being lost. If you want to change the text in the email, go to <a href=\"admin.php?p=localization\">Global
				Cart Settings -> Local Settings</a>.<br/>Select the language template and make the necessary changes.<br/>
				Developers: e-mail notifications can be found in content/engine/engine_notifications.php.", "url"=>"", "visible"=>true
			),
			array("class"=>"ic-info", "text"=>"Note: it is not required to enter email top & bottom. It will automatically be added by shopping cart", "url"=>"", "visible"=>true),
			array("class"=>"ic-pencil", "text"=>"Edit Top & Bottom Email Templates", "url"=>"admin.php?p=email_top_bottom", "visible"=>true)
		));

?>
<form name="frmEmailNotification" action="admin.php?p=email_notification" method="post">
	<input type="hidden" name="action" value="save">
	<input type="hidden" name="id" value="<?=$id?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-email">
<?php 
		pageTabs(array(
			array("title"=>"Update Notification Email", "id"=>"main"),
		), "tabs-email", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-document"></span><?=$email_templates[$id]?> - HTML</div>
				<div style="margin:20px 30px;">
					<textarea class="content" wrap="off" cols="50" rows="8" style="width:100%;height:150px;" id="email_html" name="email_html"><?=gs($email_html)?></textarea>
				</div>
				<div class="admin-form-header"><span class="icon ic-icon ic-document"></span><?=$email_templates[$id]?> - TEXT</div>
				<div style="margin:20px 30px;">
					<textarea class="content" wrap="off" cols="50" rows="8" style="width:100%;height:150px;" name="email_text"><?=gs($email_text)?></textarea>
				</div>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
		<input type="submit" name="Restore" value="Restore Defaults"/>
	</div>
</form>
<?php
	}
?>
