<?php

	if (!defined("ENV")) exit();
	
	if (!safe_mode()) set_time_limit(10000);
	
	if ($settings["USE_MOD_REWRITE"]=="YES")
	{
		require_once("content/engine/engine_url_rewrite.php");	
	}
	else
	{
		require_once("content/engine/engine_url_default.php");
	}
	
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new DB_TREE_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	while($db->moveNext()){
		$tree->addNode(
			new DB_TREE_NODE(
				$db->col["cid"], 
				$db->col["parent"], 
				$db->col["level"], 
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	function fr_normalize($s){
		$ss = str_replace("\r", " ", $s);
		$ss = str_replace("\n", " ", $ss);
		$ss = str_replace("\t", " ", $ss);
		$ss = str_replace("\0", " ", $ss);
		return htmlentities(trim(stripslashes($ss)));
	}
	
	function getCategoryPath($id){
		global $tree;
		$path = "";
		$_id = $id;
		for($i=0; $i<count($tree->collection); $i++){
			$path = (fr_normalize(str_replace(">", " ", $tree->collection[$_id]->caption))).($path==""?"":" > ").$path;
			$_id = $tree->collection[$_id]->parent_id;
			if(!($_id > 0)){
				break;
			}
		}
		return $path;
	}
	
	
	$noImageUrl = DesignElements::getImage('image-no-image-big');

	$mime_type = "text/plain";
	$filename = "shopzilla";
	$ext = "txt";	
	header('Content-Type: '.$mime_type);
	header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
	header('Content-Disposition: inline; filename="'.$filename.'.'.$ext.'"');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Content-Disposition: attachment; filename="'.$filename.'.'.$ext.'"');
	header('Pragma: no-cache');		
	$db->query("
		SELECT ".DB_PREFIX."products.*, 
		IF(".DB_PREFIX."products.url_custom = '', ".DB_PREFIX."products.url_default, ".DB_PREFIX."products.url_custom) AS product_url,
		".DB_PREFIX."catalog.name AS cat_name,
		".DB_PREFIX."manufacturers.manufacturer_name AS manufacturer_name 
		FROM ".DB_PREFIX."products 
		INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid = ".DB_PREFIX."catalog.cid
		LEFT OUTER JOIN ".DB_PREFIX."manufacturers ON ".DB_PREFIX."manufacturers.manufacturer_id = ".DB_PREFIX."products.manufacturer_id
		WHERE ".DB_PREFIX."products.is_visible='Yes' AND call_for_price='No'
		ORDER BY title
	");	
	echo "Category\tMfr\tTitle\tDescription\tLINK\tImage\tSKU\tStock\tCondition\tShip Weight\tShip Cost\tBid\tPromo Des.\tOther\tprice\r\n";	
	while($db->moveNext()){
		$product_url = $product_url = getProductUrl($db->col["product_url"], $db->col["pid"], $db->col["cid"]);
		$name = substr(fr_normalize($db->col["title"]), 0, 80);
		//$_description = trim($db->col["overview"])==""?$db->col["description"]:$db->col["overview"]; 
		$description = substr(fr_normalize($db->col["overview"]), 0, 1000);		
		if($db->col["manufacturer_name"])
			$mfr=$db->col["manufacturer_name"];
		else
			$mfr="";
		if($db->col["shipping_price"]>0)
			$shipping_price=$db->col["shipping_price"];
		else
			$shipping_price="";
		if($db->col["weight"]>0)
			$shipping_weight=$db->col["weight"];
		else
			$shipping_weight="";
		if($db->col["inventory_control"] != "No")
			if($db->col["stock"]>0)
				$stock=$db->col["stock"];
			else
				$stock="Out of Stock";
		else 
			$stock="In Stock";
		$condition="";
		$bid="";
		$promo="";
		$other="";
		$price = $db->col["price"];
		$image_url = "";
		$imageTypes = array( "jpg", "gif", "jpeg", "png");
		if($db->col["image_location"] == "Web" && $db->col["image_url"] != ""){
			$image_url = $db->col["image_url"];
		}
		else{
			foreach($imageTypes as $ext) {
				if(file_exists($settings["GlobalServerPath"]."/images/products/".$db->col["product_id"].".".$ext)) {
					$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".$db->col["product_id"] . "." . $ext); //normalize again
					break;
				}
				elseif(file_exists($settings["GlobalServerPath"]."/images/products/".strtolower($db->col["product_id"]).".".$ext)) {
					$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".strtolower($db->col["product_id"]).".".$ext);
					break;
				}
			}
		}

		$image_url = trim($image_url) == "" ? fr_normalize($settings["GlobalHttpUrl"].'/'.$noImageUrl) : $image_url;
		
		$category = getCategoryPath($db->col["cid"]);
		$pid = $db->col["product_id"];
		echo $category."\t".$mfr."\t".$name."\t".$description."\t".$product_url."\t".$image_url."\t".$pid."\t".$stock."\t".$condition."\t".$shipping_weight."\t".$shipping_price."\t".$bid."\t".$promo."\t".$other."\t".number_format($price, 2, ".", "")."\r\n";	
	}
	
?>