<?php
	if (!defined("ENV")) exit();
	loadJS("languages.js");
	$action = isset($action)?$action:"";
	$mode = isset($mode)?$mode:"insert";
	$language_id = isset($language_id)?$language_id:"";
	$cat_id = isset($cat_id)?$cat_id:"";
	
	if ($action != '')
	{
		$nonce = isset($nonce) ? $nonce : '';
		$nonce_valid = verify_nonce($nonce, 'language_'.$mode);
		if (!$nonce_valid)
		{
			invalid_nonce_message();
			exit;
		}
	}
	
	
	require_once("content/classes/class.languages.php");
	$lang = new Language($db);
	
	$lang->loadTemplate();
	
	$cat_id = array_key_exists($cat_id, $lang->categories)?$cat_id:"common";
	
	switch($action)
	{
		case "add" : 
		{
			break;
		}
		case "save_changes" : 
		{
			$current_cat_id = isset($current_cat_id)?$current_cat_id:"";
			$current_cat_id = array_key_exists($current_cat_id, $lang->categories)?$current_cat_id:"common";
			$edit_msg = isset($_REQUEST["edit_msg"])?$_REQUEST["edit_msg"]:array();
			if (!DEMO_MODE)
			{
				$lang->saveMessages($language_id, $current_cat_id, $edit_msg);
				$lang->updateLanguage($language_id, $_POST);
				$lang->getLanguages();
			}
			break;
		}
	}
	
/*******************************
	UPDATE LANGUAGE
*******************************/
	if ($mode == "update" && array_key_exists($language_id, $lang->languages))
	{
		$messages = $lang->getMessages($language_id, $cat_id);
		pageHeader("Update Language - ".$lang->languages[$language_id]["name"], "", "icb-currency-sign-yen");
		pageNote(array(
			array("class"=>"ic-info","url"=>"","text"=>"Messages that your users see are grouped into categories corresponding to the area of your store.<br>Use this page to edit the messages corresponding to the language and category shown.", "visible"=>true),
			array("class"=>"ic-world","url"=>"admin.php?p=localization&last_active_tab=language","text"=>"<b>Return To Languages Management Page</b>", "visible"=>true)
		));
?>
<script language="javaScript">
	var isChanges = false;
	var isSettingsChanges = false;
	function changeCategory(select){
		if(isChanges || isSettingsChanges){
			if(confirm("You have made languge settings changes or changed at least one message.\nDo you want to continue without saving changes?")){
				document.location='admin.php?p=language&mode=update&language_id=<?=$language_id?>&cat_id=' + select.value;
			}
		}
		else{
			document.location='admin.php?p=language&mode=update&language_id=<?=$language_id?>&cat_id=' + select.value;
		}
	}
</script>
<form name="frmLanguage" method="post" action="admin.php?p=language&mode=update&language_id=<?=$language_id?>">
	<input type="hidden" name="action" value="save_changes">
	<input type="hidden" name="nonce" value="<?=create_nonce('language_update');?>" />
	<input type="hidden" name="language_id" value="<?=$language_id?>">
	<input type="hidden" name="current_cat_id" value="<?=$cat_id?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-localization">
<?php 
	pageTabs(array(
		array("title"=>"Change Language Properties", "id"=>"main"),
	), "tabs-language", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Current Language: <?=htmlspecialchars($lang->languages[$language_id]["name"])?></div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Language Name</td>
						<td class="formItemControl"><input type="text" name="name" onchange="isSettingsChanges=true;" value="<?=htmlspecialchars($lang->languages[$language_id]["name"])?>"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Language Code</td>
						<td class="formItemControl"><input type="text" name="code" onchange="isSettingsChanges=true;" value="<?=gs($lang->languages[$language_id]["code"])?>"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Is this Language Active</td>
							<td class="formItemControl">
<?php
		if ($lang->languages[$language_id]["is_default"] == "Yes")
		{
?>
						<input type="checkbox" checked disabled>
						<input type="hidden" name="is_active" value="Yes">
<?php
		}
		else
		{
?>
						<input type="checkbox" name="is_active" onchange="isSettingsChanges=true;"  value="Yes" <?=$lang->languages[$language_id]["is_active"]=="Yes"?"checked":""?>>
<?php
		}
?>
						</td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Edit Messages Below</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Message Category</td>
						<td class="formItemControl">
							<select name="cat_id" onChange="changeCategory(this)">
<?php
		foreach ($lang->categories as $cat_data)
		{
			$cat_id = $cat_id == ""?$cat_data["id"]:$cat_id;
?>
					<option value="<?=$cat_data["id"]?>" <?=$cat_data["id"]==$cat_id?"selected":""?>><?=$cat_data["name"]?></option>
<?php
		}
?>
							</select>
						</td>
					</tr>
				</table>
				
	
<?php
		$i = 0;
		foreach ($messages as $msg_key => $msg_data)
		{
			if (!is_array($msg_data['message']))
			{
?>
					
				<div class="formItemControl big">
					<div style="background-color:#fffff0;border:1px solid #eeeeee">
						<div style="font-family:courier;margin:20px;">
							<span style="font-size:1.2em;"><?=htmlspecialchars($msg_data["template"])?></span><br/>
							<textarea class="no-mce" style="width:99%;" name="edit_msg[<?=$msg_data["key"]?>]" onChange="isChanges=true;"><?=htmlspecialchars($msg_data["message"])?></textarea>
						</div>
					</div>
				</div>
						
<?php
			$i++;
			}
		}
?>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>
	
<?	}
/*******************************
	INSERT LANGUAGE
*******************************/

	if ($mode == "insert")
	{
		pageHeader("Add / Create Language", "", "icb-currency-sign-yen");
		pageNote(array(
			array("class"=>"ic-info","url"=>"","text"=>"This area is for adding a new language template. If you have a template file compatable with this cart, you can choose to upload it here.<br/> Otherwise, once you have named the template you will be returned to the main language template page,<br/>where you can choose \"Edit\" to enter in the template.", "visible"=>true),
			array("class"=>"ic-world","url"=>"admin.php?p=localization&last_active_tab=language","text"=>"<b>Return To Languages Management Page</b>", "visible"=>true)
		));
?>
<form name="frmLangInsert" method="post" action="admin.php?p=language_process" onSubmit="return checkLanguageForm(this);" enctype="multipart/form-data">
	<input type="hidden" name="action" value="add_language">
	<input type="hidden" name="nonce" value="<?=create_nonce('language_insert');?>" />
	<div class="admin-tabs admin-tabs-framed" id="tabs-new-language">
<?php 
		pageTabs(array(
			array("title"=>"Set New Language Properties", "id"=>"main"),
		), "tabs-new-language", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-add"></span>Add New Language</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Language Name</td>
						<td class="formItemControl"><input type="text" name="name"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Language Code</td>
						<td class="formItemControl"><input type="text" name="code"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Is this Language Active?</td>
						<td class="formItemControl">
							<input type="checkbox" name="is_active" onchange="isSettingsChanges=true;" value="Yes"/><br/><br/><br/><br/><br/>
						</td>
					</tr>
			
					<tr valign="top">
						<td class="formItemCaption">
							<input type="radio" name="create_method" value="base" checked="checked" id="create_method_tamplate">
							<label for="create_method_tamplate">Use existings language as a base</label>
						</td>
						<td class="formItemControl">
							<select name="language_base">
								<option value="_template">Use language template</option>
<?php
		foreach ($lang->languages as $key=>$lang_data)
		{
?>
								<option value="<?=$lang_data["code"]?>"><?=$lang_data["name"]?></option>
<?php
		}
?>
							</select>
							<div class="formItemComment">
								Please select the Base Language for the template.
								The Base Language will be the language that will appear initally.<br/>
								You can edit the Base Language once the template is created.
							</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">
							<input type="radio" name="create_method" value="file" id="create_method_file"/>
							<label for="create_method_file">Upload Language File</label>
						</td>
						<td class="formItemControl">
							<input type="file" name="new_file">
							<div class="formItemComment">
								Uploading language files is a quick and easy way to make global changes to 
								an existing Language Template.<br/>The uploaded file must be compatiable with
								this cart for it to work correctly.
							</div>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>
<?
	}
?>

