<?php
	if (!defined("ENV")) exit();
	$action = isset($action)?$action:"";
	
	$currency_list = array(
		"USD"=>array("US dollar", 2, "$", ""),
		"EUR"=>array("Euro", 2, "&euro;", ""),
		"JPY"=>array("Japanese yen", 0, "&yen;", ""),
		"CYP"=>array("Cyprus pound", 2, "", "&pound;"),
		"CZK"=>array("Czech koruna", 2, "", "Kr"),
		"DKK"=>array("Danish krone", 2, "", "Kr"),
		"EEK"=>array("Estonian kroon", 2, "", "Kr"),
		"GBP"=>array("Pound sterling", 2, "", "&pound;"),
		"HUF"=>array("Hungarian forint", 2, "", "Fr"),
		"LTL"=>array("Lithuanian litas", 2, "", "Li"),
		"LVL"=>array("Latvian lats", 2, "", "LVL"),
		"MTL"=>array("Maltese lira", 2, "", "MTL"),
		"PLN"=>array("Polish zloty", 2, "", "Zl"),
		"SEK"=>array("Swedish krona", 2, "", "Kr"),
		"SIT"=>array("Slovenian tolar", 2, "", "SIT"),
		"SKK"=>array("Slovak koruna", 2, "", "Kr"),
		"CHF"=>array("Swiss franc", 2, "", "Fr"),
		"ISK"=>array("Icelandic krona", 2, "", "Kr"),
		"NOK"=>array("Norwegian krone", 2, "", "Kr"),
		"BGN"=>array("Bulgarian lev", 2, "", "BGN"),
		"HRK"=>array("Croatian kuna", 2, "", "HRK"),
		"RON"=>array("New Romanian leu", 2, "", "RON"),
		"RUB"=>array("Russian rouble", 2, "", "Rub"),
		"TRY"=>array("New Turkish lira", 2, "", "&#20A4;"),
		"AUD"=>array("Australian dollar", 2, "$", ""),
		"CAD"=>array("Canadian dollar", 2, "$", ""),
		"CNY"=>array("Chinese yuan renminbi", 2, "", "&#5143;"),
		"HKD"=>array("Hong Kong dollar", 2, "", "&#5713;"),
		"IDR"=>array("Indonesian rupiah", 2, "", "&#20A8;"),
		"KRW"=>array("South Korean won", 2, "", "&#20A9;"),
		"MYR"=>array("Malaysian ringgit", 2, "", "MYR"),
		"NZD"=>array("New Zealand dollar", 2, "", ""),
		"PHP"=>array("Philippine peso", 2, "", "&#20B1;"),
		"SGD"=>array("Singapore dollar", 2, "$", ""),
		"THB"=>array("Thai baht", 2, "", "&#3647;"),
		"ZAR"=>array("South African rand", 2, "", "R")

	);
	
	require_once("content/classes/class.currencies.php");
	require_once("content/classes/class.languages.php");
	$currencies = new Currencies($db);
	$lang = new Language($db);
	$lang->loadTemplate();
	
	$message = false;
	
	switch($action)
	{
		case "save_settings" : 
		{
			if (!DEMO_LOCK)
			{
				foreach ($form as $key=>$value)
				{
					$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name='".$key."'");
					$settings[$key] = $value;
				}
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Local settings have been saved", "url"=>"", "visible"=>true);
			break;
		}
		
		case "add_currency" : 
		{
			if (!DEMO_LOCK)
			{
				$dc_b = $currencies->getDefaultCurrency();
				$_POST["exchange_rate"] = normalizeNumber($_POST["exchange_rate"]);
				$currencies->addCurrency($_POST);
				$dc_a = $currencies->getDefaultCurrency();
				
				if ($dc_b["currency_id"] != $dc_a["currency_id"])
				{
					$currencies->updateExchangeRates();
				}
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"New currency has been added", "url"=>"", "visible"=>true);
			break;
		}
		
		case "add_standard_currency" : 
		{
			$_POST["code"] = $code;
			$_POST["title"] = $currency_list[$code][0];
			$_POST["exchange_rate"] = normalizeNumber($_POST["exchange_rate"]);
			$_POST["decimal_places"] =  $currency_list[$code][1];
			$_POST["symbol_left"] = $currency_list[$code][2];
			$_POST["symbol_right"] =  $currency_list[$code][3];
			
			if (!DEMO_LOCK)
			{
				$dc_b = $currencies->getDefaultCurrency();
				$currencies->addCurrency($_POST);
				
				$dc_a = $currencies->getDefaultCurrency();
				if ($dc_b["currency_id"] != $dc_a["currency_id"])
				{
					$currencies->updateExchangeRates();
				}
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"New currency has been added", "url"=>"", "visible"=>true);

			break;
		}
		
		case "update_currencies" : 
		{
			if (!DEMO_LOCK)
			{
				$dc_b = $currencies->getDefaultCurrency();
				$currencies->updateCurrencies($_POST);
				$dc_a = $currencies->getDefaultCurrency();
				
				if ($dc_b["currency_id"] != $dc_a["currency_id"])
				{
					$currencies->updateExchangeRates();
				}
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Currencies have been updated", "url"=>"", "visible"=>true);
			break;
		}
		
		case "delete_currency" : 
		{
			if (!DEMO_LOCK)
			{
				$currencies->deleteCurrency($currency_id);
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Currency has been removed", "url"=>"", "visible"=>true);
			break;
		}
		
		case "update_exchange_rates" : 
		{
			if (!DEMO_LOCK)
			{
				$currencies->updateExchangeRates();
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Exchange rates have been updated", "url"=>"", "visible"=>true);
			break;
		}
		
		case "set_default_language" : 
		{
			if (!DEMO_LOCK)
			{
				$default_language_id = isset($default_language_id)?intval($default_language_id):0;
				$lang->setDefaultLanguage($default_language_id);
				//$db->query("UPDATE ".DB_PREFIX."settings SET value='".$ActiveLanguage."' WHERE name='ActiveLanguage'");
				//$settings["ActiveLanguage"] = $ActiveLanguage;
			}
			break;
		}
		
		case "del_language" : 
		{
			if (!DEMO_LOCK)
			{
				$language_id = isset($language_id)?trim($language_id):"";
				$lang->deleteLanguage($language_id);
			}
			break;
		}
	}
	
	$_SESSION["admin_currency"] = $admin_currency = $currencies->getDefaultCurrency();

	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"settings";
	pageHeader("Site Local Settings", "", "");
	
	if (count($currencies->errors) > 0)
	{
		$messages = array();
		foreach ($currencies->errors as $key=>$value)
		{
			$messages[] = array("icon"=>"ic_error.gif", "text"=>"<b>".$value."</b>", "url"=>"", "visible"=>true);
		}
		pageNote($messages);
	}
	elseif ($message)
	{
		pageNote(array($message));
	}
	else
	{
		echo "&nbsp;";
	}
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-localization">
<?php 
	pageTabs(array(
		array("title"=>"Local Settings", "id"=>"settings"),
		array("title"=>"Currency", "id"=>"currency"),
		array("title"=>"Language", "id"=>"language"),
	), "tabs-localization", $last_active_tab);
?>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form method="POST" action="admin.php?p=localization" style="padding:0px;spacing:0px;margin:0px;">
				<input type="hidden" name="last_active_tab" value="settings">
				<input type="hidden" name="action" value="save_settings">
				<div class="admin-form-header">Date, Weight and Currency Formats</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr valign="top">
						<td class="formItemCaption">Local Time/Date Format</td>
						<td class="formItemControl">
							<input type="text" name="form[LocalizationDateTimeFormat]" value="<?=gs($settings["LocalizationDateTimeFormat"])?>">
							<div class="formHelp">
								Date/time format on the site. %Y-Year(yyyy), %m-Month(mm),%d-Day(dd), %r-Time(hh:mm:ss AM/PM);
								%T-Time(hh:mm:ss, 24 hours). Default value is %m/%d/%Y - %r (used MySQL notation)
							</div>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption">Weight Unit</td>
						<td class="formItemControl">
							<select name="form[LocalizationWeightUnits]">
								<option value="lbs">lbs</option>
								<option value="kg" <?=$settings["LocalizationWeightUnits"]=="kg"?"selected":""?>>kg</option>
							</select>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption">Length Unit</td>
						<td class="formItemControl">
							<select name="form[LocalizationLengthUnits]">
								<option value="inches">Inches</option>
								<option value="feet" <?=$settings["LocalizationLengthUnits"]=="feet"?"selected":""?>>Feet</option>
								<option value="cm" <?=$settings["LocalizationLengthUnits"]=="cm"?"selected":""?>>Centimeters</option>
							</select>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption">Currency Decimal Symbol</td>
						<td class="formItemControl">
							<input type="text" name="form[LocalizationCurrencyDecimalSymbol]" value="<?=gs($settings["LocalizationCurrencyDecimalSymbol"])?>">
						</td>
					</tr>
					<tr>
						<td class="formItemCaption">Currency Thousands Separating Symbol</td>
						<td class="formItemControl"><input type="text" name="form[LocalizationCurrencySeparatingSymbol]" value="<?=gs($settings["LocalizationCurrencySeparatingSymbol"])?>"></td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/> &nbsp;
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>
	<div id="admin-tab-sheet-currency" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-tabs admin-tabs-framed" id="tabs-currencies">
<?php 
	pageTabs(array(
		array("title"=>"Currencies In Use", "id"=>"currencies-in-use"),
		array("title"=>"New Currency", "id"=>"new-currency"),
	), "tabs-currencies", false);
?>
				<div id="admin-tab-sheet-currencies-in-use" class="admin-tab-sheet hidden">
					<div class="admin-tab-sheet-wrap">
						<div class="admin-form-header">Currencies in Use</div>
						<form action="admin.php?p=localization" name="frmUpdateCurrency" method="POST">
							<input type="hidden" name="last_active_tab" value="currency">
							<input type="hidden" name="action" value="update_currencies">
							<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
								<thead>
									<tr>
										<th class="icon">&nbsp;</th>
										<th style="width:145px;">Code</th>
										<th style="width:145px;">Title</th>
										<th style="width:150px;">Exch. Rate</th>
										<th style="width:100px;">Decimal</th>
										<th style="width:100px;">Left</th>
										<th style="width:100px;">Right</th>	
										<th>&nbsp;</th>
									</tr>
								</thead>
								<tbody>
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."currencies ORDER BY is_default, title");
	if ($db->numRows() > 0)
	{
		while ($db->moveNext())
		{
?>
									<tr>
										<td class="icon"><input type="radio" name="is_default" value="<?=$db->col["currency_id"]?>" <?=$db->col["is_default"] == "Yes" ? "checked" : ""?>></td>
										<td style="width:145px;"><input type="text" name="code[<?=$db->col["currency_id"]?>]" style="width:100%;" value="<?=gs($db->col["code"])?>"></td>
										<td style="width:145px;"><input type="text" name="title[<?=$db->col["currency_id"]?>]" style="width:100%;" value="<?=gs($db->col["title"])?>"></td>
										<td style="width:150px;"><input type="text" name="exchange_rate[<?=$db->col["currency_id"]?>]" style="width:100%;" value="<?=gs($db->col["exchange_rate"])?>"></td>
										<td style="width:100px;">
											<select name="decimal_places[<?=$db->col["currency_id"]?>]" style="width:100%;">
												<option value="2">2</option>
												<option value="1" <?=$db->col["decimal_places"]==1?"selected":""?>>1</option>
												<option value="0" <?=$db->col["decimal_places"]==0?"selected":""?>>0</option>
											</select>
										</td>
										<td style="width:100px;"><input type="text" name="symbol_left[<?=$db->col["currency_id"]?>]" style="width:100%;" value="<?=gs($db->col["symbol_left"])?>"></td>
										<td style="width:100px;"><input type="text" name="symbol_right[<?=$db->col["currency_id"]?>]" style="width:100%;" value="<?=gs($db->col["symbol_right"])?>"></td>
										<td>
<?php
			if ($db->col["is_default"] == "No")
			{
?>
											<a href="javascript:if(confirm('Do you really want to delete this currency?'))document.location='admin.php?p=localization&action=delete_currency&last_active_tab=currency&currency_id=<?=$db->col["currency_id"]?>';"><img src="images/icons/ic_delete.gif" border="0" alt="Delete Currency"></a>
<?php
			}
			else
			{
				echo "&nbsp;";
			}
?>
										</td>
									</tr>
<?php
		}
?>									
								</tbody>
							</table>
							<div class="admin-form-buttons">
								<input type="submit" value="Save changes"/> &nbsp;
								<input type="reset" value="Reset form"/>
							</div>
						</form>
						<div style="padding-left:26px;padding-bottom:15px;">
							<b><a href="admin.php?p=localization&action=update_exchange_rates&last_active_tab=currency">Update Exchange Rates</a></b><br>
							Please note: Currency exchange rates uses European Central Bank rates. For more information please visit 
							<a target="_blank" href="http://www.ecb.int/stats/exchange/eurofxref/html/index.en.html">http://www.ecb.int/stats/exchange/eurofxref/html/index.en.html</a>.<br>
							Remember to update exchange rates after the default currency has changed or after a new currency has been added. 
						</div>
<?php
		}
?>
					</div>
				</div>
				<div id="admin-tab-sheet-new-currency" class="admin-tab-sheet hidden">
					<div class="admin-tab-sheet-wrap">
						<div class="admin-form-header">Add New Currency</div>
						<form action="admin.php?p=localization" name="frmNewCurrency" method="POST">
							<input type="hidden" name="last_active_tab" value="currency">
							<input type="hidden" name="action" value="add_standard_currency">			
				
							<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
								<tr>
									<td class="icon">&nbsp;</td>
									<td colspan="3">
										Use the drop-down to select the currency you want to add to your cart.
										If you want to add a custom currency, use the form below.
									</td>
								</tr>
								<tr>
									<td class="icon">&nbsp;</td>
									<td style="width:300px;">
										Select currency:<br/>
										<select name="code" style="width:100%;">
<?php
	foreach ($currency_list as $code=>$data)
	{
		echo '<option value="'.$code.'">'.$code." - ".$data[0].'</option>';
	}
?>
										</select>
									</td>
									<td style="width:150px;">
										Exchange rate:
										<input type="text" name="exchange_rate" style="width:100%;" value="1.0000000000">
									</td>
									<td>&nbsp;<br/><input type="submit" value=" Add "/></td>
								</tr>
							</table>
						</form>
						&nbsp;
						<form action="admin.php?p=localization" name="frmNewCurrency" method="POST" onsubmit="return checkAddCurrency(this)">
							<input type="hidden" name="last_active_tab" value="currency">
							<input type="hidden" name="action" value="add_currency">
							<div class="admin-form-header">Add Custom Currency</div>
							<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
								<tr valign="top">
									<td class="icon">&nbsp;</td>
									<td style="width:145px;">Code<br/><input type="text" name="code" style="width:100%;"></td>
									<td style="width:145px;">Title<br/><input type="text" name="title" style="width:100%;"></td>
									<td style="width:150px;">Exch. Rate<br/><input type="text" name="exchange_rate" style="width:100%;" value="1.0000000000"></td>
									<td style="width:100px;">
										Decimal<br/>
										<select name="decimal_places" style="width:100%;">
											<option value="2">2</option>
											<option value="1">1</option>
											<option value="0">0</option>
										</select>
									</td>
									<td style="width:100px;">Left<br/><input type="text" name="symbol_left" style="width:100%;"></td>
									<td style="width:100px;">Right<br/><input type="text" name="symbol_right" style="width:100%;"></td>
									<td>&nbsp;<br/><input type="submit" value=" Add "></td>
								</tr>
							</table>
						</form>
						&nbsp;
					</div>
				</div>
			</div>
		</div>
	</div>
	<div id="admin-tab-sheet-language" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header">Site Language Settings</div>
<?php
	pageNote(
		array(
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Please select which language template you would like to use on your site.<br/>If you would like to create a new template, click \"Add a New Language Template\" below.<br/>If you would like to edit or change text in an existing template, click the edit icon.", "visible"=>true),
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Additional language templates can be found at <a href='http://cartmanual.com/languages/languages.html'>http://cartmanual.com/languages/languages.html</a>", "visible"=>true),
			array("icon"=>"ic_insert_row.gif","url"=>"admin.php?p=language&mode=insert","text"=>"<b>Add a New Language Template</b>", "visible"=>true)
		)
	);
	loadJS("languages.js");
	$lang->getLanguages();
	
?>
			<form method="post" action="admin.php?p=localization">
				<input type="hidden" name="last_active_tab" value="language">
				<input type="hidden" name="action" value="set_default_language">
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr> 
							<th class="icon">&nbsp;</th>
							<th style="width:200px;">Language</th>
							<th style="width:130px;">Enabled</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
<?php
	foreach ($lang->languages as $key=>$lang_data)
	{
?>
						<tr valign="top">
							<td class="icon">
								<input type="radio" name="default_language_id" value="<?=$lang_data["language_id"]?>" <?=$lang_data["is_default"]=="Yes"?"checked":""?>/>
							</td>
							<td>
								<a href="admin.php?p=language&mode=update&language_id=<?=$lang_data["language_id"]?>"><?=htmlspecialchars($lang_data["name"])?></a>
							</td>
							<td><?=$lang_data["is_active"]?></td>
							<td>
								<a href="admin.php?p=language&mode=update&language_id=<?=$lang_data["language_id"]?>"><img src="images/icons/ic_change_text.gif" border="0" title="Edit Language"></a>
								<?if($lang_data["is_default"]!="Yes"){?>
								<a href="javascript:ConfirmDeleteLanguage('<?=$lang_data["name"]?>', '<?=$lang_data["language_id"]?>', <?=$lang_data["language_id"]==$settings["ActiveLanguage"]?"true":"false"?>)"><img src="images/icons/ic_delete.gif" border="0" title="Delete Language"></a>
								<?}?>
							</td>
						</tr>				
<?php
	}
?>
					</tbody>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/> &nbsp;
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>
</div>