<?php
	if (!defined("ENV")) exit();
	$action = isset($action)?$action:"";
	
	$currency_list = array(
		"USD"=>array("US dollar", 2, "$", ""),
		"EUR"=>array("Euro", 2, "&euro;", ""),
		"JPY"=>array("Japanese yen", 0, "&yen;", ""),
		"CYP"=>array("Cyprus pound", 2, "", "&pound;"),
		"CZK"=>array("Czech koruna", 2, "", "Kr"),
		"DKK"=>array("Danish krone", 2, "", "Kr"),
		"EEK"=>array("Estonian kroon", 2, "", "Kr"),
		"GBP"=>array("Pound sterling", 2, "", "&pound;"),
		"HUF"=>array("Hungarian forint", 2, "", "Fr"),
		"LTL"=>array("Lithuanian litas", 2, "", "Li"),
		"LVL"=>array("Latvian lats", 2, "", "LVL"),
		"MTL"=>array("Maltese lira", 2, "", "MTL"),
		"PLN"=>array("Polish zloty", 2, "", "Zl"),
		"SEK"=>array("Swedish krona", 2, "", "Kr"),
		"SIT"=>array("Slovenian tolar", 2, "", "SIT"),
		"SKK"=>array("Slovak koruna", 2, "", "Kr"),
		"CHF"=>array("Swiss franc", 2, "", "Fr"),
		"ISK"=>array("Icelandic krona", 2, "", "Kr"),
		"NOK"=>array("Norwegian krone", 2, "", "Kr"),
		"BGN"=>array("Bulgarian lev", 2, "", "BGN"),
		"HRK"=>array("Croatian kuna", 2, "", "HRK"),
		"RON"=>array("New Romanian leu", 2, "", "RON"),
		"RUB"=>array("Russian rouble", 2, "", "Rub"),
		"TRY"=>array("New Turkish lira", 2, "", "&#20A4;"),
		"AUD"=>array("Australian dollar", 2, "$", ""),
		"CAD"=>array("Canadian dollar", 2, "$", ""),
		"CNY"=>array("Chinese yuan renminbi", 2, "", "&#5143;"),
		"HKD"=>array("Hong Kong dollar", 2, "", "&#5713;"),
		"IDR"=>array("Indonesian rupiah", 2, "", "&#20A8;"),
		"KRW"=>array("South Korean won", 2, "", "&#20A9;"),
		"MYR"=>array("Malaysian ringgit", 2, "", "MYR"),
		"NZD"=>array("New Zealand dollar", 2, "", ""),
		"PHP"=>array("Philippine peso", 2, "", "&#20B1;"),
		"SGD"=>array("Singapore dollar", 2, "$", ""),
		"THB"=>array("Thai baht", 2, "", "&#0E3F;"),
		"ZAR"=>array("South African rand", 2, "", "R")

	);
	
	require_once("content/classes/class.currencies.php");
	require_once("content/classes/class.languages.php");
	$currencies = new Currencies($db);
	$lang = new Language($db);
	$lang->loadTemplate();
	
	$message = false;
	
	switch($action){
		case "save_settings" : {
			foreach($form as $key=>$value){
				$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name='".$key."'");
				$settings[$key] = $value;
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Local settings have been saved", "url"=>"", "visible"=>true);
			break;
		}
		case "add_currency" : {
			$dc_b = $currencies->getDefaultCurrency();
			$_POST["exchange_rate"] = normalizeNumber($_POST["exchange_rate"]);
			$currencies->addCurrency($_POST);
			$dc_a = $currencies->getDefaultCurrency();
			if($dc_b["currency_id"] != $dc_a["currency_id"]){
				$currencies->updateExchangeRates();
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"New currency has been added", "url"=>"", "visible"=>true);
			break;
		}
		
		case "add_standard_currency" : {
			$_POST["code"] = $code;
			$_POST["title"] = $currency_list[$code][0];
			$_POST["exchange_rate"] = normalizeNumber($_POST["exchange_rate"]);
			$_POST["decimal_places"] =  $currency_list[$code][1];
			$_POST["symbol_left"] = $currency_list[$code][2];
			$_POST["symbol_right"] =  $currency_list[$code][3];

			$dc_b = $currencies->getDefaultCurrency();
			$currencies->addCurrency($_POST);
			$dc_a = $currencies->getDefaultCurrency();
			if($dc_b["currency_id"] != $dc_a["currency_id"]){
				$currencies->updateExchangeRates();
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"New currency has been added", "url"=>"", "visible"=>true);
			break;
		}
		
		case "update_currencies" : {
			$dc_b = $currencies->getDefaultCurrency();
			$currencies->updateCurrencies($_POST);
			$dc_a = $currencies->getDefaultCurrency();
			if($dc_b["currency_id"] != $dc_a["currency_id"]){
				$currencies->updateExchangeRates();
			}
			$message = array("icon"=>"ic_hint.gif", "text"=>"Currencies have been updated", "url"=>"", "visible"=>true);
			break;
		}
		case "delete_currency" : {
			$currencies->deleteCurrency($currency_id);
			$message = array("icon"=>"ic_hint.gif", "text"=>"Currency has been removed", "url"=>"", "visible"=>true);
			break;
		}
		case "update_exchange_rates" : {
			$currencies->updateExchangeRates();
			$message = array("icon"=>"ic_hint.gif", "text"=>"Exchange rates have been updated", "url"=>"", "visible"=>true);
			break;
		}
		case "set_default_language" : {
			$default_language_id = isset($default_language_id)?intval($default_language_id):0;
			$lang->setDefaultLanguage($default_language_id);
			//$db->query("UPDATE ".DB_PREFIX."settings SET value='".$ActiveLanguage."' WHERE name='ActiveLanguage'");
			//$settings["ActiveLanguage"] = $ActiveLanguage;
			break;
		}
		case "del_language" : {
			$language_id = isset($language_id)?trim($language_id):"";
			$lang->deleteLanguage($language_id);
			break;
		}
	}
	
	$_SESSION["admin_currency"] = $currencies->getDefaultCurrency();

	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"idTabSheetSettings";
	pageHeader("Site Local Settings", "", "");
	
	if(count($currencies->errors) > 0){
		$messages = array();
		foreach($currencies->errors as $key=>$value){
			$messages[] = array("icon"=>"ic_error.gif", "text"=>"<b>".$value."</b>", "url"=>"", "visible"=>true);
		}
		pageNote($messages);
	}
	elseif($message){
		pageNote(array($message));
	}
	else{
		echo "&nbsp;";
	}
	pageTabs(array(
		array("title"=>"Local Settings", "id"=>"Settings", "active"=>$last_active_tab == "idTabSheetSettings", "width"=>100, "visible"=>true),
		array("title"=>"Currency", "id"=>"Currency", "active"=>$last_active_tab == "idTabSheetCurrency", "width"=>100, "visible"=>true),
		array("title"=>"Language", "id"=>"Language", "active"=>$last_active_tab == "idTabSheetLanguage", "width"=>100, "visible"=>true)
	));
?>
<div id="idTabSheetSettings" class="<?=$last_active_tab == "idTabSheetSettings"?"sheetActive":"sheetUnactive"?>">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
<form method="POST" action="admin.php?p=localization" style="padding:0px;spacing:0px;margin:0px;">
	<input type="hidden" name="last_active_tab" value="idTabSheetSettings">
	<input type="hidden" name="action" value="save_settings">
	<tr>
		<td class="formHeader" colspan="2">
			<div class="formHeaderIcon"><img src="images/icons/ic_localization_settings.gif"></div>
			<div class="formHeaderText">Local Settings</div>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Local Time/Date Format</td>
		<td class="formItemControl">
			<input type="text" name="form[LocalizationDateTimeFormat]" value="<?=gs($settings["LocalizationDateTimeFormat"])?>">
			<div class="formHelp">
				Date/time format on the site. %Y-Year(yyyy), %m-Month(mm),%d-Day(dd), %r-Time(hh:mm:ss AM/PM);
				%T-Time(hh:mm:ss, 24 hours). Default value is %m/%d/%Y - %r (used MySQL notation)
			</div>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Weight Unit</td>
		<td class="formItemControl">
			<select name="form[LocalizationWeightUnits]">
				<option value="lbs">lbs</option>
				<option value="kg" <?=$settings["LocalizationWeightUnits"]=="kg"?"selected":""?>>kg</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Length Unit</td>
		<td class="formItemControl">
			<select name="form[LocalizationLengthUnits]">
				<option value="inches">Inches</option>
				<option value="feet" <?=$settings["LocalizationLengthUnits"]=="feet"?"selected":""?>>Feet</option>
				<option value="cm" <?=$settings["LocalizationLengthUnits"]=="cm"?"selected":""?>>Centimeters</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Currency Decimal Symbol</td>
		<td class="formItemControl">
			<input type="text" name="form[LocalizationCurrencyDecimalSymbol]" value="<?=gs($settings["LocalizationCurrencyDecimalSymbol"])?>">
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Currency Thousands Separating Symbol</td>
		<td class="formItemControl"><input type="text" name="form[LocalizationCurrencySeparatingSymbol]" value="<?=gs($settings["LocalizationCurrencySeparatingSymbol"])?>"></td>
	</tr>
	<tr>
		<td class="formButtons" colspan="2">
			<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
			<input type="image" src="images/admin/bt_reset_form.gif" onclick="document.forms['frmUpdateCurrency'].reset();return false;">
		</td>
	</tr>
</form>
</table>
</div>
<div id="idTabSheetCurrency" class="<?=$last_active_tab == "idTabSheetCurrency"?"sheetActive":"sheetUnactive"?>">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_dollar.gif"/></div>
			<div class="formHeaderText">Add New Currency</div>
		</td>
	</tr>
	<tr>
		<td class="formItemBig">
			Use the drop-down to select the currency you want to add to your cart.
			If you want to add a custom currency, use the form below.
		</td>
	</tr>
</table>

<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<form action="admin.php?p=localization" name="frmNewCurrency" method="POST">
		<input type="hidden" name="last_active_tab" value="idTabSheetCurrency">
		<input type="hidden" name="action" value="add_standard_currency">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption">&nbsp;</td>
		<td class="formListHeaderCaption" colspan="2">
			<select name="code" style="width:261px;">
<?			foreach($currency_list as $code=>$data){
				echo '<option value="'.$code.'">'.$code." - ".$data[0].'</option>';
			}
?>
			</select>
		</td>
		<td class="formListHeaderCaption">
			<input type="text" name="exchange_rate" style="width:123px;" value="1.0000000000">
		</td>
		<td class="formListHeaderCaption">&nbsp;</td>
		<td class="formListHeaderCaption">&nbsp;</td>
		<td class="formListHeaderCaption">&nbsp;</td>
		<td class="formListHeaderCaption"><input type="submit" value=" Add "></td>
	</tr>
	</form>
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
		<td colspan="7"><b>Add Custom Currency</b></td>
	</td>
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:60px;">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:130px;">Code</td>
		<td class="formListHeaderCaption" style="width:130px;">Title</td>
		<td class="formListHeaderCaption" style="width:130px;">Exch. Rate</td>
		<td class="formListHeaderCaption" style="width:70px;">Decimal</td>
		<td class="formListHeaderCaption" style="width:70px;">Left</td>
		<td class="formListHeaderCaption" style="width:70px;">Right</td>	
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>
	<form action="admin.php?p=localization" name="frmNewCurrency" method="POST" onsubmit="return checkAddCurrency(this)">
		<input type="hidden" name="last_active_tab" value="idTabSheetCurrency">
		<input type="hidden" name="action" value="add_currency">
	<tr valign="top">
		<td class="formListItemIcon">&nbsp;</td>
		<td class="formListItemText">&nbsp;</td>
		<td class="formListItemText"><input type="text" name="code" style="width:123px;"></td>
		<td class="formListItemText"><input type="text" name="title" style="width:123px;"></td>
		<td class="formListItemText"><input type="text" name="exchange_rate" style="width:123px;" value="1.0000000000"></td>
		<td class="formListItemText">
			<select name="decimal_places" style="width:63px;">
				<option value="2">2</option>
				<option value="1">1</option>
				<option value="0">0</option>
			</select>
		</td>
		<td class="formListItemText"><input type="text" name="symbol_left" style="width:63px;"></td>
		<td class="formListItemText"><input type="text" name="symbol_right" style="width:63px;"></td>
		<td class="formListItemText"><input type="submit" value=" Add "></td>
	</tr>
	</form>
</table>
<table cellpadding="0" cellspacing="5" border="0" width="100%">
	<tr>
		<td class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_dollar.gif"/></div>
			<div class="formHeaderText">Currencies in Use</div>
		</td>
	</tr>
</table>
<table cellpadding="5" cellspacing="0" border="0" width="100%">
	<form action="admin.php?p=localization" name="frmUpdateCurrency" method="POST">
		<input type="hidden" name="last_active_tab" value="idTabSheetCurrency">
		<input type="hidden" name="action" value="update_currencies">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:60px;">Default</td>
		<td class="formListHeaderCaption" style="width:130px;">Code</td>
		<td class="formListHeaderCaption" style="width:130px;">Title</td>
		<td class="formListHeaderCaption" style="width:130px;">Exch. Rate</td>
		<td class="formListHeaderCaption" style="width:70px;">Decimal</td>
		<td class="formListHeaderCaption" style="width:70px;">Left</td>
		<td class="formListHeaderCaption" style="width:70px;">Right</td>	
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>

<?	$db->query("SELECT * FROM ".DB_PREFIX."currencies ORDER BY is_default, title");
	if($db->numRows() > 0){
		while($db->moveNext()){?>

	<tr>
		<td class="formListItemIcon">&nbsp;</td>
		<td class="formListItemText"><input type="radio" name="is_default" value="<?=$db->col["currency_id"]?>" <?=$db->col["is_default"] == "Yes" ? "checked" : ""?>></td>
		<td class="formListItemText"><input type="text" name="code[<?=$db->col["currency_id"]?>]" style="width:123px;" value="<?=gs($db->col["code"])?>"></td>
		<td class="formListItemText"><input type="text" name="title[<?=$db->col["currency_id"]?>]" style="width:123px;" value="<?=gs($db->col["title"])?>"></td>
		<td class="formListItemText"><input type="text" name="exchange_rate[<?=$db->col["currency_id"]?>]" style="width:123px;" value="<?=gs($db->col["exchange_rate"])?>"></td>
		<td class="formListItemText">
			<select name="decimal_places[<?=$db->col["currency_id"]?>]" style="width:63px;">
				<option value="2">2</option>
				<option value="1" <?=$db->col["decimal_places"]==1?"selected":""?>>1</option>
				<option value="0" <?=$db->col["decimal_places"]==0?"selected":""?>>0</option>
			</select>
		</td>
		<td class="formListItemText"><input type="text" name="symbol_left[<?=$db->col["currency_id"]?>]" style="width:63px;" value="<?=gs($db->col["symbol_left"])?>"></td>
		<td class="formListItemText"><input type="text" name="symbol_right[<?=$db->col["currency_id"]?>]" style="width:63px;" value="<?=gs($db->col["symbol_right"])?>"></td>
		<td class="formListItemText">
<?			if($db->col["is_default"] == "No"){?>
			<a href="javascript:if(confirm('Do you really want to delete this currency?'))document.location='admin.php?p=localization&action=delete_currency&last_active_tab=idTabSheetCurrency&currency_id=<?=$db->col["currency_id"]?>';"><img src="images/icons/ic_delete.gif" border="0" alt="Delete Currency"></a>
<?			}
			else echo "&nbsp;"?>
		</td>

<?		}?>
</table>
<div class="formButtons">
	<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onclick="document.forms['frmUpdateCurrency'].reset();return false;">
</div>
</form>
<div style="padding-left:26px;padding-bottom:15px;">
	<b><a href="admin.php?p=localization&action=update_exchange_rates&last_active_tab=idTabSheetCurrency">Update Exchange Rates</a></b><br>
	Please note: Currency exchange rates uses European Central Bank rates. For more information please visit 
	<a target="_blank" href="http://www.ecb.int/stats/exchange/eurofxref/html/index.en.html">http://www.ecb.int/stats/exchange/eurofxref/html/index.en.html</a>.<br>
	Remember to update exchange rates after the default currency has changed or after a new currency has been added. 
</div>
<?
	}
?>
</div>
<div id="idTabSheetLanguage" class="<?=$last_active_tab == "idTabSheetLanguage"?"sheetActive":"sheetUnactive"?>">
<table cellpadding="0" cellspacing="5" border="0" width="100%">
	<tr>
		<td class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_localization_settings.gif"/></div>
			<div class="formHeaderText">Site Language Settings</div>
		</td>
	</tr>
</table>

<?
	pageNote(
		array(
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Please select which language template you would like to use on your site.<br/>If you would like to create a new template, click \"Add a New Language Template\" below.<br/>If you would like to edit or change text in an existing template, click the edit icon.", "visible"=>true),
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Additional language templates can be found at <a href='http://cartmanual.com/languages/languages.html'>http://cartmanual.com/languages/languages.html</a>", "visible"=>true),
			array("icon"=>"ic_insert_row.gif","url"=>"admin.php?p=language&mode=insert","text"=>"<b>Add a New Language Template</b>", "visible"=>true)
		)
	);
	loadJS("languages.js");
	$lang->getLanguages();
	
?>
<div style="clear:both">
<form method="post" action="admin.php?p=localization">
	<input type="hidden" name="last_active_tab" value="idTabSheetLanguage">
	<input type="hidden" name="action" value="set_default_language">
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr> 
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:60px;">Default</td>
		<td class="formListHeaderCaption" style="width:200px;">Language Name</td>
		<td class="formListHeaderCaption" style="width:130px;">Enabled</td>
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>
<?	foreach($lang->languages as $key=>$lang_data){?>
	<tr valign="top">
		<td class="formListItemIcon">&nbsp;</td>
		<td class="formListItemText">
			<input type="radio" name="default_language_id" value="<?=$lang_data["language_id"]?>" <?=$lang_data["is_default"]=="Yes"?"checked":""?>/>
		</td>
		<td class="formListItemText">
			<a href="admin.php?p=language&mode=update&language_id=<?=$lang_data["language_id"]?>"><?=htmlspecialchars($lang_data["name"])?></a>
		</td>
		<td class="formListItemText"><?=$lang_data["is_active"]?></td>
		<td class="formListItemText">
			<a href="admin.php?p=language&mode=update&language_id=<?=$lang_data["language_id"]?>"><img src="images/icons/ic_change_text.gif" border="0" title="Edit Language"></a>
			<?if($lang_data["is_default"]!="Yes"){?>
			<a href="javascript:ConfirmDeleteLanguage('<?=$lang_data["name"]?>', '<?=$lang_data["language_id"]?>', <?=$lang_data["language_id"]==$settings["ActiveLanguage"]?"true":"false"?>)"><img src="images/icons/ic_delete.gif" border="0" title="Delete Language"></a>
			<?}?>
		</td>
	</tr>
<?	}?>
	
	<tr>
		<td colspan="5" class="formButtons">
			<input type="image" src="images/admin/bt_save_changes.gif" default> &nbsp;
			<input type="image" onClick="frmProduct.reset();return false;" src="images/admin/bt_reset_form.gif">
		</td>
	</tr>
</table>
</form>
</div>
</div>
