<?php
	if (!defined("ENV")) exit();
	pageHeader("Mailchimp Integration","","ic_folder.gif");
?>
	<div style="margin:20px">
		<img src="images/admin/mailchimp_sm.png" align="right" valign="10"/>
		<div>Once activated, your customers are automatically added to your newsletter lists in MailChimp.</div>
		<div>Your list is synchronized to reflect "unsubscribe" and other actions generated by your storefront.</div>
		<div>
			We've also added the tracking necessary for the MailChimp E-Commerce 360 Plugin.
			All conversion (sales) data will be passed back to MailChimp giving you a clear understanding of the effectiveness of your campaigns.
			<span style="font-weight: bold">This feature must be activated in both your cart and MailChimp or sales will not be tracked</span>.
		</div>
		<div>
			Geographic information is also passed to MailChimp allowing you to segment email campaigns by geographic location.
		</div>
		<div style="margin-top:10px;">
		To set up an account with Mail Chimp, <a target="_blank" href="http://eepurl.com/L3JD">click here</a>
		</div>
	</div>
<?php
	require_once("content/vendors/mailchimp/MCAPI.class.php");
	$productGroups = ProductGroup::LoadAll($db);
?>

<form id="frmMailchimpSettings" action="admin.php?p=mailchimp" method="POST" style="margin:0px;padding:0px;">
	<input type="hidden" name="action" value="save"/>
	<div class="admin-tabs admin-tabs-framed" id="tabs-mailchimp">

<?php
	pageTabs(array(
		array("title"=>"Account Setup", "id"=>"main"),
	), "tabs-mailchimp", false);
	
	$action = isset($_REQUEST["action"])?$_REQUEST["action"]:null;

	if ($action == "save" && !DEMO_LOCK)
	{
		$chimpuser = isset($_REQUEST["mailchimp_username"])?$_REQUEST["mailchimp_username"]:null;
		$chimppass = isset($_REQUEST["mailchimp_password"])?$_REQUEST["mailchimp_password"]:null;
		$chimpkey = isset($_REQUEST["mailchimp_apikey"])?$_REQUEST["mailchimp_apikey"]:null;
		$chimpenabled = isset($_REQUEST["mailchimp_enabled"])?$_REQUEST["mailchimp_enabled"]:0;
		$chimplist = isset($_REQUEST["mailchimp_newsletter_list"])?$_REQUEST["mailchimp_newsletter_list"]:"";
		$chimpe360 = isset($_REQUEST["mailchimp_e360"])?$_REQUEST["mailchimp_e360"]:0;
			
		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimpuser) . "' where `name` = 'mailchimp_username'";
		$db->query($sql);
		$settings["mailchimp_username"] = $chimpuser;

		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimppass) . "' where `name` = 'mailchimp_password'";
		$db->query($sql);
		$settings["mailchimp_password"] = $chimppass;

		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimpkey) . "' where `name` = 'mailchimp_apikey'";
		$db->query($sql);
		$settings["mailchimp_apikey"] = $chimpkey;

		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimpenabled) . "' where `name` = 'mailchimp_enabled'";
		$db->query($sql);
		$settings["mailchimp_enabled"] = $chimpenabled;

		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimplist) . "' where `name` = 'mailchimp_newsletter_list'";
		$db->query($sql);
		$settings["mailchimp_newsletter_list"] = $chimplist;

		$sql = "update ".DB_PREFIX."settings set value = '" . $db->escape($chimpe360) . "' where `name` = 'mailchimp_e360'";
		$db->query($sql);
		$settings["mailchimp_e360"] = $chimpe360;

		if ($chimplist)
		{
			if ($chimpkey)
			{
				$mc = new MCAPI($chimpkey);

				if ($chimpenabled)
				{
					$sql = "select * from ".DB_PREFIX."emails where newsletters = 'Yes'";
					$db->query($sql);
					$emails = $db->getRecords();
					foreach ($emails as $email)
					{
						$mc->listSubscribe($chimplist, $email["email"], array(""), $email["email_mode"], false, true);
					}
				}
				else
				{
					$sql = "select * from ".DB_PREFIX."emails where newsletters = 'Yes'";
					$db->query($sql);
					$emails = $db->getRecords();
					foreach ($emails as $email)
					{
						$mc->listUnsubscribe($chimplist, $email["email"], false, false, true);
					}
				}
			}
		}
	}
	else
	{
		$chimpuser = $settings["mailchimp_username"];
		$chimppass = $settings["mailchimp_password"];
		$chimpkey = $settings["mailchimp_apikey"];
		$chimpenabled = $settings["mailchimp_enabled"];
		$chimplist = $settings["mailchimp_newsletter_list"];
		$chimpe360 = $settings["mailchimp_e360"];
	}

	if ($chimpenabled && $chimpkey)
	{
		$mc = new MCAPI($chimpkey);
		$allchimplists = $mc->lists();
	}
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header">Mailchimp Settings</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formItemCaption"><b>Enable Mailchimp</b></td>
						<td class="formItemControl">
							<input type="radio" name="mailchimp_enabled" <?= ($chimpenabled==1?"checked":"") ?> value="1" id="mailchimp_enabled_1" /> <label for="mailchimp_enabled_1">Enabled</label>
							<input type="radio" name="mailchimp_enabled" <?= ($chimpenabled!=1?"checked":"") ?> value="0" id="mailchimp_enabled_0" /> <label for="mailchimp_enabled_0">Disabled</label>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Username</b></td>
						<td class="formItemControl">
							<input type="text" name="mailchimp_username" maxlength="100" value="<?=htmlspecialchars($chimpuser);?>"/>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Password</b></td>
						<td class="formItemControl">
							<input type="text" name="mailchimp_password" maxlength="100" value="<?=htmlspecialchars($chimppass);?>"/>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Api Key</b></td>
						<td class="formItemControl">
							<input type="text" name="mailchimp_apikey" maxlength="100" value="<?=htmlspecialchars($chimpkey);?>"/>
						</td>
					</tr>
<?php 
	if ($chimpenabled && isset($allchimplists))
	{
?>
					<tr>
						<td class="formItemCaption"><b>Newsletter List</b></td>
						<td class="formItemControl">
							<select name="mailchimp_newsletter_list">
								<option value="">None</option>
<?php
		foreach ($allchimplists as $chimplistoption)
		{
?>
								<option value="<?=$chimplistoption["id"]?>" <?=$chimplist==$chimplistoption["id"]?"selected":""?> ><?=$chimplistoption["name"]?></option>
<?php
		}
?>
							</select>
						</td>
					</tr>
<?php
	}
?>
					<tr>
						<td class="formItemCaption"><b>Ecommerce 360</b></td>
						<td class="formItemControl">
							<input type="radio" name="mailchimp_e360" <?= ($chimpe360==1?"checked":"") ?> value="1" id="mailchimp_e360_1" /> <label for="mailchimp_e360_1">Enabled</label>
							<input type="radio" name="mailchimp_e360" <?= ($chimpe360!=1?"checked":"") ?> value="0" id="mailchimp_e360_0" /> <label for="mailchimp_e360_0">Disabled</label>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/> &nbsp;
		<input type="reset" value="Reset form"/>
	</div>
</form>
