<?php
	if (!defined("ENV")) exit();
	require_once("content/classes/class.manufacturers.php");
	$mans = new Manufacturers($db);

	loadJS("cf_manufacturers.js");
	pageHeader("Manufacturers", "", "ic_manufacturer.gif");
	
	$action = isset($action)?trim($action):"";
	
	if (!DEMO_LOCK)
	{
		switch($action)
		{
			case "manufacturer_add" :
			{
				$mans->insertManufacturer($_REQUEST);
				break;
			}
			
			case "manufacturer_delete" :
			{
				$mans->deleteManufacturer($_REQUEST["manufacturer_id"]);
				break;
			}
			case "manufacturer_delete_image" :
			{
				$mans->deleteManufacturerImage($_REQUEST["manufacturer_id"]);
				break;
			}
			case "manufacturers_update" :
			{
				$mans->updateManufacturers($_REQUEST);
				break;
			}
		}
	}

	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"On this page you can manage your Product Manufacturers.", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>New manufacturer has been added.</b>", "url"=>"", "visible"=>$action == "manufacturer_add"),
		array("icon"=>"ic_hint.gif", "text"=>"<b>Manufacturer's data has been saved.</b>", "url"=>"", "visible"=>$action == "manufacturers_update"),
		array("icon"=>"ic_error.gif", "text"=>"<span style=\"color:#990000\"><b>Newly added manufacturer has been saved with a randomly-generated ID<br>because the one you entered already exists in the database.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_CODE_EXISTS, $mans->error_code)),
		array("icon"=>"ic_error.gif", "text"=>"<span style=\"color:#990000\"><b>Note: manufacturer logo was not been uploaded.<br>Please check free space and permissions.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_IMAGE_UPLOAD, $mans->error_code))
	));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-manufacturer">
<?php 
	pageTabs(array(
		array("title"=>"Manufacturers", "id"=>"main"),
		array("title"=>"New Manufacturer", "id"=>"new"),
	), "tabs-manufacturer", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form name="frmManufacturers" action="admin.php?p=manufacturers" enctype="multipart/form-data" method="POST" onsubmit="return checkUpdateManufacturers(this);">
			<input type="hidden" name="action" value="manufacturers_update">
				<div class="admin-form-header admin-icon-manufacturer">Manage manufacturers</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon"></th>
							<th>Manufacturer's Name</th>
							<th style="width:190px;">Manufacturer's ID</th>
							<th style="width:250px;">Logo Image (JPG, GIF or PNG)</th>
							<th style="width:100px;">Available</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
<?php
	$man_list = $mans->getManufacturers();
	if ($man_list)
	{
?>
					<tbody>
<?php 
		for ($i=0; $i<count($man_list); $i++)
		{
			$man = $man_list[$i];?>


					<tr>
						<td>&nbsp;</td>
						<td><input type="text" name="manufacturer_name[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_name"])?>" style="width:100%;"/></td>
						<td><input type="text" name="manufacturer_code[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_code"])?>" style="width:100%;"/></td>
						<td>
							<input type="file" name="manufacturer_logo_<?=$man["manufacturer_id"]?>"  style="width:180px;"/>
<?php				if ($man["image"])
					{
?>
							<a href="javascript:showPopupImage('<?=$man["image"]["file"]?>','<?=$man["image"]["info"][0]?>','<?=$man["image"]["info"][1]?>')">Current Logo</a> |
							<a href="javascript:confirmDeleteManufacturerImage('<?=$man["manufacturer_id"]?>')">Delete Logo</a>
<?php
					}
?>
						</td>
						<td><input type="checkbox" name="is_visible[<?=$man["manufacturer_id"]?>]" <?=$man["is_visible"]?"checked":""?>/></td>
						<td>
							<a href="javascript:confirmDeleteManufacturer('<?=$man["manufacturer_id"]?>')"><img src="images/icons/ic_delete.gif" title="Delete Manufacturer" border="0"></a>
						</td>
					</tr>
<?php
		}
?>
					</tbody>
					<tfoot>
						<tr>
							<td colspan="6" class="admin-form-buttons">
								<input type="submit" value="Save changes"/> &nbsp;
								<input type="reset" value="Reset form"/>
							</td>
						</tr>
					</tfoot>
<?php
	}
	else
	{
?>
					<tr>
						<td class="icon">&nbsp;</td>
						<td colspan="5">There are no orders</td>
					</tr>
<?php
	}
?>
				</table>
			</form>
		</div>
	</div>
	<div id="admin-tab-sheet-new" class="admin-tab-sheet hidden">
		<form name="frmManufacturer" action="admin.php?p=manufacturers#list" enctype="multipart/form-data" method="POST" onsubmit="return checkAddManufacturer(this);">
		<input type="hidden" name="action" value="manufacturer_add">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-manufacturer-add">Add a new manufacturer</div>
			<table width="100%" cellpadding="0" cellspacing="5" border="0">
				<tr valign="top">
					<td class="formItemCaption"><b>Manufacturer's Name</b></td>
					<td class="formItemControl">
						<input style="width:250px;" type="text" name="manufacturer_name" maxlength="255"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Manufacturer's ID</b></td>
					<td class="formItemControl">
						<input style="width:250px;" type="text" name="manufacturer_code" maxlength="255"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Logo Image</td>
					<td class="formItemControl">
						<input style="width:250px;" type="file" name="manufacturer_logo"/>
						<div class=" formItemComment">
							Supported file types are JPG, GIF and PNG.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Available</td>
					<td class="formItemControl">
						<input type="checkbox" name="is_visible" checked />
						<div class=" formItemComment">
							Checking this box will allow customers to search for products by this manufacturer.
						</div>
					</td>
				</tr>
			</table>
		</div>
		<div class="admin-form-buttons">
			<input type="submit" value="Save changes"/> &nbsp;
			<input type="reset" value="Reset form"/>
		</div>
		</form>
	</div>
</div>
