<?php
	if (!defined("ENV")) exit();
	require_once("content/classes/class.manufacturers.php");
	$mans = new Manufacturers($db);

	loadJS("cf_manufacturers.js");
	pageHeader("Manufacturers", "", "ic_manufacturer.gif");
	
	if (!DEMO_LOCK)
	{
		$action = isset($action)?trim($action):"";
		switch($action){
			case "manufacturer_add" :
			{
				$mans->insertManufacturer($_REQUEST);
				break;
			}
			case "manufacturer_delete" :
			{
				$mans->deleteManufacturer($_REQUEST["manufacturer_id"]);
				break;
			}
			case "manufacturer_delete_image" :
			{
				$mans->deleteManufacturerImage($_REQUEST["manufacturer_id"]);
				break;
			}
			case "manufacturers_update" :
			{
				$mans->updateManufacturers($_REQUEST);
				break;
			}
		}
	}

	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"On this page you can manage your Product Manufacturers.", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>New manufacturer has been added.</b>", "url"=>"", "visible"=>$action == "manufacturer_add"),
		array("icon"=>"ic_hint.gif", "text"=>"<b>Manufacturer's data has been saved.</b>", "url"=>"", "visible"=>$action == "manufacturers_update"),
		array("icon"=>"ic_error.gif", "text"=>"<span style=\"color:#990000\"><b>Newly added manufacturer has been saved with a randomly-generated ID<br>because the one you entered already exists in the database.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_CODE_EXISTS, $mans->error_code)),
		array("icon"=>"ic_error.gif", "text"=>"<span style=\"color:#990000\"><b>Note: manufacturer logo was not been uploaded.<br>Please check free space and permissions.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_IMAGE_UPLOAD, $mans->error_code))
	));

	pageTabs(array(
		array("title"=>"New Manufacturer", "id"=>"Main", "active"=>true, "width"=>140),
	));
?>
<form name="frmManufacturer" action="admin.php?p=manufacturers#list" enctype="multipart/form-data" method="POST" onsubmit="return checkAddManufacturer(this);">
<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">
	<input type="hidden" name="action" value="manufacturer_add">
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_manufacturer_add.gif"></div>
				<div class="formHeaderText">Add a New Manufacturer</div>
			</td>
		</tr>

		<tr valign="top">
			<td class="formItemCaption"><b>Manufacturer's Name</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="manufacturer_name" maxlength="255"/>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Manufacturer's ID</b></td>
			<td class="formItemControl">
				<input style="width:250px;" type="text" name="manufacturer_code" maxlength="255"/>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Logo Image</td>
			<td class="formItemControl">
				<input style="width:250px;" type="file" name="manufacturer_logo"/>
				<div class=" formItemComment">
					Supported file types are JPG, GIF and PNG.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Available</td>
			<td class="formItemControl">
				<input type="checkbox" name="is_visible"/>
				<div class=" formItemComment">
					Checking this box will allow customers to search for products by this manufacturer.
				</div>
			</td>
		</tr>
	</table>
</div>
<div class="formButtons">
	<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmManufacturer.reset();return false;">
</div>
</form>
<a name="#list"></a>
<div style="clear:both">
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:190px;">Manufacturer's Name</div>
	<div class="listHeaderCaption" style="width:190px;">Manufacturer's ID</div>
	<div class="listHeaderCaption" style="width:210px;">Logo Image (JPG, GIF or PNG)</div>
	<div class="listHeaderCaption" style="width:70px;">Available</div>
</div>

<form name="frmManufacturers" action="admin.php?p=manufacturers" enctype="multipart/form-data" method="POST" onsubmit="return checkUpdateManufacturers(this);">
	<input type="hidden" name="action" value="manufacturers_update">
<?php
	$man_list = $mans->getManufacturers();
	if($man_list){
		for($i=0; $i<count($man_list); $i++){
			$man = $man_list[$i];?>


<div class="listItem" style="height:50px;">
	<div class="listItemIcon"><img src="images/icons/ic_manufacturer.gif"/></div>
	<div class="listItemText" style="width:190px;"><input type="text" name="manufacturer_name[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_name"])?>" style="width:180px;"></div>
	<div class="listItemText" style="width:190px;"><input type="text" name="manufacturer_code[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_code"])?>" style="width:180px;"></div>
	<div class="listItemText" style="width:210px;">
		<input type="file" name="manufacturer_logo_<?=$man["manufacturer_id"]?>"  style="width:180px;">
<?			if($man["image"]){?>
		<a href="javascript:showPopupImage('<?=$man["image"]["file"]?>','<?=$man["image"]["info"][0]?>','<?=$man["image"]["info"][1]?>')">Current Logo</a> |
		<a href="javascript:confirmDeleteManufacturerImage('<?=$man["manufacturer_id"]?>')">Delete Logo</a>
<?			}?>
	</div>
	<div class="listItemText" style="width:70px;"><input type="checkbox" name="is_visible[<?=$man["manufacturer_id"]?>]" <?=$man["is_visible"]?"checked":""?>></div>
	<div class="listItemButtons">
		<a href="javascript:confirmDeleteManufacturer('<?=$man["manufacturer_id"]?>')"><img src="images/icons/ic_delete.gif" title="Delete Manufacturer" border="0"></a>
	</div>
</div>
<?
		}
		?>
<div class="listButtons">
	<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmManufacturers.reset();return false;">
</div>
</form>
</div>
<?
	}
	else{?>
<div class="listEmpty">
	No manufacturers have been entered yet.
</div>
<?	}?>