<?php
	
	if (!defined("ENV")) exit();

	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	
	require_once('content/classes/class.qr.php');
	require_once('content/classes/class.offsite_commerce_campaigns.php');
	
	$qrCodes = new QR($settings);
	$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
	
	switch ($action)
	{
		/**
		 * Download custom file
		 */
		case "download_qr" :
		{
			$path = isset($_REQUEST["path"]) ? $_REQUEST["path"] : false;
			if ($path && is_file($path))
			{
				$is = getimagesize($path);
				if (in_array($is[2], array(IMAGETYPE_PNG, IMAGETYPE_JPG, IMAGETYPE_GIF)))
				{
					$path_info = pathinfo($path);
					header("Content-Type: application/octet-stream");
					header("Content-Disposition: attachment; filename=".$path_info["basename"]);
					readfile($path);
				}
			}		
			die();
		}
		
		/**
		 * Generate custom
		 */
		case "generate_custom" :
		{
			$image_type = isset($_REQUEST["image_type"]) ? $_REQUEST["image_type"] : IMAGETYPE_PNG;
			$text = isset($_REQUEST["text"]) ? $_REQUEST["text"] : "";
			
			$error_check_level = isset($_REQUEST["error_check"]) ? $_REQUEST["error_check"] : 0;
			$default_pixel_size = isset($_REQUEST["default_size"]) ? $_REQUEST["default_size"] : 0;
			
			$url = $qrCodes->renderCustomCode($text, true, $error_check_level, $default_pixel_size, $image_type);
			$is = getimagesize($path = $qrCodes->getLastRenderedFile());
			echo json_encode(array('url'=>$url, 'path'=>$path, 'width'=>$is[0], 'height'=>$is[1])); die();
			break;
		}
		
		/**
		 * Generate product QR code
		 */
		case "generate_product_qr" :
		{
			$product_id = isset($_REQUEST["product_id"]) ? $_REQUEST["product_id"] : ""; 
			$campaign_id = isset($_REQUEST["campaign_id"]) ? $_REQUEST["campaign_id"] : "";
			$campaign_id = (trim($campaign_id) == "" || $campaign_id == 0)? false : $campaign_id;
			$image_type = isset($_REQUEST["image_type"]) ? $_REQUEST["image_type"] : IMAGETYPE_PNG;
			$error_check_level = isset($_REQUEST["error_check"]) ? $_REQUEST["error_check"] : 0;
			$default_pixel_size = isset($_REQUEST["default_size"]) ? $_REQUEST["default_size"] : 0;
			$url_type = isset($_REQUEST["url_type"]) ? $_REQUEST["url_type"] : "";
			
			switch ($url_type)
			{
				case "product" :
				{
					$link_url = $offsite_commerce_campaigns->getProductUrl($product_id, $campaign_id, "qr");
					$url = $qrCodes->renderProductUrlCode($link_url, $product_id, true, $error_check_level, $default_pixel_size, $image_type, $campaign_id);
					
					break;
				}
				case "cart" :
				{
					$link_url = $offsite_commerce_campaigns->getProductAddToCartUrl($product_id, $campaign_id, "qr");
					$url = $qrCodes->renderProductAddToCartCode($link_url, $product_id, true, $error_check_level, $default_pixel_size, $image_type, $campaign_id);
					break;
				}
			}
		
			$is = getimagesize($path = $qrCodes->getLastRenderedFile());
			
			echo json_encode(array('url'=>$url, 'link_url'=>$link_url, 'path'=>$path, 'width'=>$is[0], 'height'=>$is[1])); die();
			
			break;
		}
		
		/**
		 * Generate category QR code
		 */
		case "generate_category_qr" :
		{
			$category_id = isset($_REQUEST["category_id"]) ? $_REQUEST["category_id"] : ""; 
			$campaign_id = isset($_REQUEST["campaign_id"]) ? $_REQUEST["campaign_id"] : "";
			$campaign_id = (trim($campaign_id) == "" || $campaign_id == 0) ? false : $campaign_id;
			$image_type = isset($_REQUEST["image_type"]) ? $_REQUEST["image_type"] : IMAGETYPE_PNG;
			$error_check_level = isset($_REQUEST["error_check"]) ? $_REQUEST["error_check"] : 0;
			$default_pixel_size = isset($_REQUEST["default_size"]) ? $_REQUEST["default_size"] : 0;
			
			$link_url = $offsite_commerce_campaigns->getCategoryUrl($category_id, $campaign_id, "qr");
			$url = $qrCodes->renderCategoryUrlCode($link_url, $category_id, true, $error_check_level, $default_pixel_size, $image_type, $campaign_id);
			
			$is = getimagesize($path = $qrCodes->getLastRenderedFile());
			
			echo json_encode(array('url'=>$url, 'link_url'=>$link_url, 'path'=>$path, 'width'=>$is[0], 'height'=>$is[1])); die();
			
			break;
		}
	}