<?php
	
	if (!defined("ENV")) exit();

	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	
	require_once('content/classes/class.widgets.php');
	require_once('content/classes/class.offsite_commerce_campaigns.php');
	
	$widgets = new Widgets($settings);
	$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
	
	switch ($action)
	{
		/**
		 * Download product static widget
		 */
		case "get_product_static" :
		{
			$pid = isset($_REQUEST["pid"]) ? intval($_REQUEST["pid"]) : null;
			$error = false;
			
			if ($pid == null)
			{
				$error = "Cannot find product";
			}
			else
			{
				$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".$pid."'");
				
				if (($product = $db->moveNext()) != false)
				{
					if ($product["image_location"] == "Local")
					{
						$thumb = ProductHasThumb($product["product_id"]);
						$thumb2 = ProductHasThumb2($product["product_id"]);
					}
					else
					{
						$thumb = $thumb2 = $product["image_url"];
					}
					
					$thumb = $thumb ? $settings["GlobalHttpUrl"]."/".$thumb : false;
					$thumb2 = $thumb2 ? $settings["GlobalHttpUrl"]."/".$thumb2 : false;
					
					$campaign_id = isset($_REQUEST["campaign_id"]) ? intval($_REQUEST["campaign_id"]) : false;
					
					echo json_encode(array(
						"result" => 1, 
						"widget_html" => $widgets->renderProductStatic(
							$_REQUEST["widget_style"],
							$product["title"],
							getAdminPrice($product["price"]),
							$product["overview"],
							$_REQUEST["widget_type"] == "cart" ? 
								$offsite_commerce_campaigns->getProductAddToCartUrl($pid, $campaign_id, "wg") :
								$offsite_commerce_campaigns->getProductUrl($pid, $campaign_id, "wg"),
							$_REQUEST["widget_type"] == "cart" ? "Buy Now" : "Learn More",
							$_REQUEST["widget_image_type"] == "thumb" ? $thumb : $thumb2,
							$product["image_alt_text"]
						)
					));
				}
				else
				{
					$error = "Cannot find product";
				}
			}
			
			if ($error)
			{
				echo json_encode(array(
					"result" => 0, 
					"error" => $error
				));
			}
			die();
		}
	}