<?php 
	if (!defined("ENV")) exit();
?>
<script type="text/javascript" src="content/admin/javascript/order.js"></script>
<?php
	$oid = isset($oid) ? intval($oid) : 0;
	
	if (AccessManager::checkAccess('CCS') && IsPrivilege(array("ccs", "all"), $auth_rights))
	{
		if (isset($_REQUEST["delete_ccs"]))
		{
			$db->query("UPDATE ".DB_PREFIX."orders SET card_data='' WHERE oid='".$oid."'");
		}
	}

	/**
	 * select order data
	 */
	$result = $db->query("
		SELECT ".DB_PREFIX."orders.*,
			DATE_FORMAT(placed_date, '".$settings["LocalizationDateTimeFormat"]."') AS cd,
			DATE_FORMAT(status_date, '".$settings["LocalizationDateTimeFormat"]."') AS sd,
			IF(DATE_ADD(placed_date, INTERVAL 3 DAY) < NOW(), '3', '1') AS auth_exp,
			".DB_PREFIX."countries.name AS country_name,
			".DB_PREFIX."countries.iso_a2 AS country_iso_a2,
			".DB_PREFIX."countries.iso_a3 AS country_iso_a3,
			".DB_PREFIX."countries.iso_number AS country_iso_number,
			".DB_PREFIX."states.name AS state_name,
			".DB_PREFIX."states.short_name AS state_code,
			".DB_PREFIX."offsite_campaigns.name AS offsite_campaign_name
		FROM ".DB_PREFIX."orders 
		LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."orders.shipping_country
		LEFT JOIN ".DB_PREFIX."states ON ".DB_PREFIX."states.stid = ".DB_PREFIX."orders.shipping_state
		LEFT JOIN ".DB_PREFIX."offsite_campaigns ON ".DB_PREFIX."offsite_campaigns.campaign_id = ".DB_PREFIX."orders.offsite_campaign_id
		WHERE 
			".DB_PREFIX."orders.oid='".$oid."' AND (".DB_PREFIX."orders.removed='No')
	");
	
	/**
	 * if order exists
	 */
	if ($db->moveNext($result, MYSQL_ASSOC))
	{
		$order_data = $db->col;
		
		loadJS("cf_order.js");
		
		//select user data
		$db->query("
			SELECT ".DB_PREFIX."users.*,
				".DB_PREFIX."countries.name AS country_name
			FROM ".DB_PREFIX."users 
			LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."users.country
			WHERE 
				".DB_PREFIX."users.uid='".$order_data["uid"]."' AND ".DB_PREFIX."users.removed='No'
		");
		
		//if user exists
		if ($db->moveNext())
		{
			$user_data = $db->col;
			
			//select admin notes for the order
			$db->query("
				SELECT ".DB_PREFIX."admin_notes.*,
					DATE_FORMAT(created_at , '".$settings["LocalizationDateTimeFormat"]."') AS note_created_at			
				FROM ".DB_PREFIX."admin_notes		
				WHERE 
					".DB_PREFIX."admin_notes.oid='".$oid."' 
			");
			$admin_notes = $db->getRecords();
	
			//get details for promocode used in the order
			$pc_details = "";
			$db->query("
				SELECT ".DB_PREFIX."orders.promo_campaign_id,".DB_PREFIX."promo_codes.*					
				FROM ".DB_PREFIX."orders
				LEFT JOIN ".DB_PREFIX."promo_codes ON ".DB_PREFIX."promo_codes.pid = ".DB_PREFIX."orders.promo_campaign_id		
				WHERE ".DB_PREFIX."orders.oid='".$oid."' 
			");
			$pc_details = $db->getRecords();
			if (count($pc_details) > 0) $pc_details = $pc_details[0];
			
			pageHeader("Order Processing", "order #".$order_data["order_num"], "icb-list2");			
			
			//check is order editable
			$order_editable = $order_data["payment_status"] == "Pending";
			
			//order custom  fields
			$customFields = new CustomFields($db);
			
			$cf_billing = $customFields->getCustomFieldsValues("billing", $user_data["uid"], 0, 0);
			$cf_shipping = $customFields->getCustomFieldsValues("shipping", $user_data["uid"], $oid, 0);
			$cf_invoice = $customFields->getCustomFieldsValues("invoice", $user_data["uid"], $oid, 0);
			
			///////////////////////////////////
			//check for dollay days products
			$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."' AND is_dollar_days='Yes'");
			$db->moveNext();
			$is_dollar_days = $db->col["c"] > 0;
			$is_dollar_days_need_setup = trim($settings["DollarDaysUsername"]) == "" || trim($settings["DollarDaysPassword"]) == "";
			
			///////////////////////////////////
			//check for doba products
			$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."' AND is_doba='Yes'");
			$db->moveNext();
			$is_doba = $db->col["c"] > 0;
			$is_doba_need_setup = trim($settings["doba_username"]) == "" || trim($settings["doba_password"]) == "";
			
			if ($is_dollar_days && !$is_dollar_days_need_setup)
			{
				$dd_xml = 
					'<?xml version="1.0" encoding="ISO-8859-5"?>'.
					'<order>'.
						'<Customer>'.
							'<UserId>'.$settings["DollarDaysUsername"].'</UserId>'.
							'<Password>'.$settings["DollarDaysPassword"].'</Password>'.
							'<SourceCode>Pnaccle</SourceCode>'.
						'</Customer>';
				$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."' AND is_dollar_days='Yes' ORDER BY product_id");
				$dd_order_items = $db->getRecords();
				
				foreach ($dd_order_items as $dd_order_item)
				{
					$dd_xml.=
						'<OrderItem>'.
							'<SKU>'.utf8_encode($dd_order_item["product_id"]).'</SKU>'.
							'<Quantity>'.utf8_encode($dd_order_item["admin_quantity"]).'</Quantity>'.
   						'</OrderItem>';
				}
				$dd_xml.=
					'<Shipping>'.
						'<ShipTo>'.utf8_encode($order_data["shipping_name"]).'</ShipTo>'.
						'<Address1>'.utf8_encode($order_data["shipping_address1"]).'</Address1>'.
						'<Address2>'.utf8_encode($order_data["shipping_address2"]).'</Address2>'.
						'<City>'.utf8_encode($order_data["shipping_city"]).'</City>'.
						'<State>'.utf8_encode($order_data["shipping_province"]).'</State>'.
						'<Country>'.utf8_encode($order_data["country_name"]).'</Country>'.
						'<ShipPhone></ShipPhone>'.
						'<Zip>'.utf8_encode($order_data["shipping_zip"]).'</Zip>'.
					'</Shipping>'.

					'<Billing>'.
						'<CCNo></CCNo>'.
						'<CCPhone>'.utf8_encode($user_data["phone"]).'</CCPhone>'.
						'<CCCvv></CCCvv>'.
						'<CCExpiry></CCExpiry>'.
						'<CCHolderName>'.utf8_encode($user_data["fname"]." ".$user_data["lname"]).'</CCHolderName>'.
						'<CCAddress1>'.utf8_encode($user_data["address1"]).'</CCAddress1>'.
						'<CCAddress2>'.utf8_encode($user_data["address2"]).'</CCAddress2>'.
						'<CCCity>'.utf8_encode($user_data["city"]).'</CCCity>'.
						'<CCState>'.utf8_encode($user_data["province"]).'</CCState>'.
						'<CCZip>'.utf8_encode($user_data["zip"]).'</CCZip>'.
						'</Billing>'.
					'</order>'
				;
				
				echo '<form name="frmDollarDays" target="_new" method="POST" action="https://www.dollardays.com/xml/extOrder.aspx" style="padding:0;margin:0;">';
				echo '<input type="hidden" name="xml" value="'.htmlspecialchars($dd_xml).'">';
				echo '</form>';
			}
			
			echo "<br/>";
?>
<form name="frmOrder" action="admin.php?p=order_process&oid=<?=$oid?>" method="post" onSubmit="return CheckOrderForm(this)">
	<input type="hidden" name="mode" value="update">
	<input type="hidden" name="order_editable" value=" <?=$order_editable?"yes":"no"?>">

<div class="admin-tabs admin-tabs-framed" id="tabs-order">
<?php 		
	$orderTabs = array(array('title' => 'Order Properties', 'id' => 'main'));

	$endiciaEnabled = AccessManager::checkAccess('ENDICIA') && $settings['EndiciaShippingLabelsActive'] == 'Yes' && in_array(strtolower($order_data["shipping_carrier_id"]), array('custom', 'usps'));
	if ($endiciaEnabled)
	{
		$orderTabs[] = array("title" =>"Print Endicia Shipping Label", "id" =>"enlabel");
		$orderTabs[] = array("title" => "View Shipping Labels for this Order", "id" =>"showlabels");
	}
	
	pageTabs($orderTabs, 'tabs-order', false);

	if ($endiciaEnabled)
	{
		include "admin_order_endicia.php";
		include "admin_order_endicia_showlabels.php";
	}
?>

<!-- Begin Main Tab -->	
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first">
					<span class="admin-form-header-buttons">
						<a href="admin.php?p=order_invoice&orders=<?=$oid?>&printing" target="_new" title="Print Receipt"><span class="icon ic-icon ic-printer"></span></a>
					</span>
					<span class="icon ic-icon ic-checkmark"></span>Order Status
				</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr valign="top">
						<td width="50%" style="padding:20px;padding-top:0px;">
							<table width="100%" cellpadding="5" cellspacing="0" border="0">
								<tr>
									<td><strong>Order ID</strong></td>
									<td><strong><?php echo $order_data["order_num"];?></strong></td>
								</tr>
								<tr>
									<td  class="dashed-border">Created At</td>
									<td  class="dashed-border"><?php echo $order_data["cd"];?></td>
								</tr>				
								<tr>
									<td  class="dashed-border">
										Order Status
<?php	
										if ($order_data["is_mobile"]) echo '<img src="images/icons/a/mobile.png" title="Mobile Order"/>';
										if ($order_data["order_source"] == "qr") echo '<img src="images/icons/a/raster.png" title="QR Referrer"/>';
										if ($order_data["order_source"] == "wg") echo '<img src="images/icons/a/window.png" title="Widget Referrer"/>';
?>
									</td>
									<td class="dashed-border" style="font-size:1.1em;">
										<strong><?php echo $order_data["status"];?></strong>
									</td>
								</tr>
<?php		
			if ($order_data["offsite_campaign_id"] != 0 && $order_data["offsite_campaign_name"] != "")
			{
?>
								<tr>
									<td class="dashed-border">Offsite Commerce Campaign</td>
									<td class="dashed-border"><strong><?php echo $order_data["offsite_campaign_name"];?></strong></td>
								</tr>
<?php
			}		
?>
								<tr>
									<td class="dashed-border">Payment Status</td>
									<td class="dashed-border"><?php echo $order_data["payment_status"];?></td>
								</tr>
<?php
			if ($order_data["payment_is_realtime"] != "No" && $order_data["security_id"] != "")
			{
?>
								<tr>
									<td class="dashed-border"><i>Transaction / Reference ID</i></td>
									<td class="dashed-border"><i><?php echo $order_data["security_id"];?></i></td>
								</tr>
<?php
			}

 			if ($is_doba && !$is_doba_need_setup)
			{
				$doba_sent = $order_data["doba_order_sent"]==1 && $order_data["doba_order_id"]!=0;
				$doba_funded = $order_data["doba_order_funded"]==1; 
?>
								<tr>
									<td class="dashed-border"><img src="images/admin/doba.png"/></td>
									<td class="dashed-border">
										<strong>
											<div style="display:none;"><div id="dobaOrderDetailOuter"><div id="dobaOrderDetail"></div></div></div>
											This order has Doba products
											<input type="hidden" id="hiddenOrderId" value="<?=$oid?>"/>
											<input type="hidden" id="hiddenDobaOrderId" value="<?=$order_data["doba_order_id"]?>"/>
											<br/>

											<div id="div-doba-send" style="display:<?php echo $doba_sent?"none":"block";?>">
												<input type="button" id="buttonSendToDoba" value="Send to Doba now"/>
											</div>
											<div id="div-doba-sent" style="display:<?php echo $doba_sent?"block":"none";?>">
												Doba order ID: <a href="#" id="dobaOrderDetailLink"><?php echo $order_data["doba_order_id"]?></a>
											</div>

											<div id="div-doba-fund" style="display:<?php echo $doba_sent ? $doba_funded ? "none":"block" : "none";?>">
	<?php 			if ($settings["doba_payment_type"] == "CC")
					{
	?>							
												<div style="font-size:12px;padding:5px 0px;">Please enter CVV2 code for your Doba default payment method:</div>
												<input type="text" id="inputFundDobaCVV2" style="width:50px;" maxlength="4"/>
	<?php	
					} 
	?>
												<input type="button" id="buttonFundDobaOrder" value="Fund now"/>
											</div>
											<div id="div-doba-funded" style="display:<?php echo $doba_sent ? $doba_funded ? "block":"none" : "none";?>">
												Order already funded
											</div>
										</strong>
									</td>
								</tr>
<?php	 			
 			}

 			if ($order_data["payment_gateway_id"] == "bongocheckout")
			{
?>
								<tr vsalign="top">
									<td class="dashed-border"><img src="images/admin/bongo.png"></td>
									<td class="dashed-border">
										Please note: This is <span style="color:orange">bon</span><span style="color:green">go</span> order<br/>
										<?php echo trim($order_data['custom3']) == '' ? '&nbsp;' : ('<strong>Bongo Order Id: '.$order_data['custom3'].'</strong>');?>
<?php
				if (trim($order_data["custom2"]) != '')
				{
					$bongoOrderData = @unserialize($order_data["custom2"]);
					if (is_array($bongoOrderData) && isset($bongoOrderData['trackingLink']) && trim($bongoOrderData['trackingLink']) != '')
					{
						echo '<br/><br/><span class="icon ic-icon ic-log"></span><a href="'.$bongoOrderData['trackingLink'].'" target="_blank"><strong>Track package</strong></a>';
					}
				}
?>
									</td>
								</tr>
<?php
			}
?>
		
							</table>
						</td>
						<td width="50%" style="border:1px solid #cccccc;background-color:#f7f7f7;padding:20px;padding-bottom:10px;border-radius:10px;">
							<table width="100%" cellpadding="0" cellspacing="5" border="0">
								<tr>
									<td>Last status change</td>
									<td><?=$order_data["sd"]?></td>
								</tr>
								<tr>
									<td style="width:150px;">Set Order Status</td>
									<td>
										<select name="order_status" class="short">
											<option value="">Do not change</option>
											<option value="Process">Process</option>
											<option value="Backorder">Backorder</option>
											<option value="Canceled">Canceled</option>
											<option value="Completed">Completed</option>
										</select>
									</td>
								</tr>
								<tr valign="top">
									<td cladss="formItemCaption" colspan="2">
										<input type="checkbox" checked id="send_notification_email" name="send_notification_email" value="yes">
										<label for="send_notification_email">Send notification to user when order completed?</label>
									</td>
								</tr>
								<tr>
									<td colspan="2" align="center"><input type="submit" value="Save Changes"/> &nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
<?php 		if ($is_doba && $is_doba_need_setup)
			{
?>
					<tr>
						<td colspan="2" style="border:1px solid #cccccc;background-color:#f7f7f7;padding:20px;font-size:14px;">
							This order may be sent to Doba.com but setup is not completed yet. 
							Please <a href="admin.php?p=doba">click here</a> to do it now
						</td>
					</tr>
<?php		
			}

	 		if ($is_dollar_days && !$is_dollar_days_need_setup)
	 		{
?>
					<tr>
						<td colspan="2" style="border:1px solid #cccccc;background-color:#f7f7f7;padding:20px;font-size:14px;">
							<a href="javascript:document.forms['frmDollarDays'].submit();"><b>Send order to DollarDays.com</b></a>
						</td>
					</tr>
<?php	 	
	 		}
			if ($is_dollar_days && $is_dollar_days_need_setup)
			{
?>
					<tr>
						<td colspan="2" style="border:1px solid #cccccc;background-color:#f7f7f7;padding:20px;font-size:14px;">
							This order may be sent to DollarDays.com but setup is not completed yet. 
							Please <a href="admin.php?p=settings_dollar_days&backpage=order&oid=<?=$oid?>">click here</a> to do it now
						</td>
					</tr>
<?php				
			}
?>
				</table>

				<div class="admin-form-header"><span class="icon ic-icon ic-invoice"></span>Billing &amp; Shipping Data</div>
<?php
			$width =  ($order_data["payment_gateway_id"] == "bongocheckout") ? "33%" : "50%";
?>	
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td width="50%" style="padding:10px 0px 0px 31px;">
							<strong>Billing Address &amp; Information</strong><br/>
<?php		
			if ($order_data["payment_gateway_id"] != "paypalec")
			{
?>
							<?=gs($user_data["fname"]." ".$user_data["lname"])?><br/>
							<?=trim($user_data["company"])!=""?(gs($user_data["company"])."<br/>"):""?>
							<?=gs($user_data["address1"])?><?=trim($user_data["address2"])!=""?gs(", ".$user_data["address2"]):""?><br/>
							<?=gs($user_data["city"])?>, <?=gs($user_data["province"])?>, <?=gs($user_data["zip"])?><br/>
							<?=gs($user_data["country_name"])?><br/>
							Email: <a href="mailto:<?=$user_data["email"]?>"><?=$user_data["email"]?></a><br/>
							Phone: <?=gs($user_data["phone"])?><br/>
<?php
				if ($cf_billing && is_array($cf_billing) && count($cf_billing) > 0)
				{
					foreach ($cf_billing as $field)
					{
						echo "<i>".$field["field_name"]."</i> : ".$field["value_translated"]."<br/>";
					}
				}
			}
			else
			{
?>
							<?=gs($user_data["fname"]." ".$user_data["lname"])?><br/>
							Email: <a href="mailto:<?=$user_data["email"]?>"><?=$user_data["email"]?></a><br/><br/>
							<u>PayPal Express Order - BIlling Information at PayPal</u>
<?php
			}
?>			&nbsp;
						</td>
						<td width="50%" style="padding:10px 0px 0px 31px;">
							<strong>Shipping Address</strong><br/>
<?php
			if ($order_data["shipping_digital"])
			{
?>
							There no shipping information available<br/>
							Digital Download
<?php
			}
			else
			{
?>
							<?=gs($order_data["shipping_name"])?> <i>(<?=gs($order_data["shipping_address_type"])?>)</i><br/>
							<?=trim($order_data["shipping_company"])!=""?(gs($order_data["shipping_company"])."<br/>"):""?>
							<?=gs($order_data["shipping_address1"])?><?=trim($order_data["shipping_address2"])!=""?gs(", ".$order_data["shipping_address2"]):""?><br/>
							<?=gs($order_data["shipping_city"])?>, <?=gs($order_data["shipping_province"])?>, <?=gs($order_data["shipping_zip"])?><br/>
							<?=gs($order_data["country_name"])?><br/>
<?php		}

			if ($cf_shipping && is_array($cf_shipping) && count($cf_shipping) > 0)
			{
				foreach ($cf_shipping as $field)
				{
					echo "<i>".$field["field_name"]."</i> : ".$field["value_translated"]."<br/>";
				}
			}
?>
							&nbsp;
						</td>
					</tr>
				</table>
				<!-- end billing and shipping -->
				
				<!-- order content start-->
				<div class="admin-form-header"><span class="icon ic-icon ic-invoice"></span>Products Ordered</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th>&nbsp;</th>
							<th style="width:150px;">Product ID</th>
							<th>Name</th>
							<th style="width:120px;" class="text-align-right">Price</th>
							<th style="width:120px;" class="text-align-right">Quantity</th>
							<th style="width:120px;" class="text-align-right">Total</th>
						</tr>
					</thead>
					<tbody>
<?php
			$order_weight = 0;
			$order_items = 0;
			$order_sa_pr_b = 0; 
			$order_sa_pr_l = 0;
			$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."' ORDER BY product_id");
			
			while ($db->moveNext())
			{
?>
						<tr valign="top">
							<td rowspan="2" class="icon text-align-right"><img src="images/icons/a/<?=$db->col["is_doba"] == "Yes" ? "record" : "product"?>.png"/></td>
							<td rowspan="2"><?=gs($db->col["product_id"].($db->col["product_sub_id"] != "" ? (" / ".$db->col["product_sub_id"]) : ""))?></td>
							<td rowspan="2">
								<strong><?=gs($db->col["title"])?></strong>
								<?=trim($db->col["options"])!=""?("<br/>Options:<br/>".nl2br(gs($db->col["options"]))):""?>
<?php
				if ($db->col["digital_product"] == "Yes")
				{
?>
								<div style="font-size:12px;">
									<a href="<?=$settings["GlobalHttpUrl"]?>/download.php?a=<?=$oid?>&b=<?=$db->col["digital_product_key"]?>">Click to Download</a>
								</div>
<?php			}
				if ($db->col["is_taxable"]=="Yes")
				{
?>
								<div style="font-size:12px;">
									Tax: <?=$db->col["tax_description"]!=""?$db->col["tax_description"]:(myNum($db->col["tax_rate"])."%")?>
								</div>
<?php
	 			}
?>
							</td>
							<td class="text-align-right"><?=getAdminPrice($db->col["price"])?></td>
							<td class="text-align-right"><?=$db->col["quantity"]?></td>
							<td class="text-align-right">
<?php			if ($db->col["is_taxable"]!="Yes")
				{
					echo "<i>(not taxable)</i>";
				}
?>
							</td>
						</tr>
						<tr>
							<td class="text-align-right">
								<input class="text-align-right short" <?=$order_editable && $db->col["is_doba"] != "Yes" ? "" : "disabled"?> type="text" name="prices[<?=$db->col["ocid"]?>]" value="<?=myNum($db->col["admin_price"])?>"/>
							</td>
							<td class="text-align-right">
								<input class="text-align-right short" <?=$order_editable && $db->col["is_doba"] != "Yes"  ? "" : "disabled"?> type="text" name="quantities[<?=$db->col["ocid"]?>]" value="<?=$db->col["admin_quantity"]?>"/>
							</td>
							<td class="text-align-right"><?=getAdminPrice($db->col["admin_price"] * $db->col["admin_quantity"])?></td>
						</tr>
<?php
				$order_weight += $db->col["free_shipping"]=="Yes"?0:($db->col["admin_quantity"] * $db->col["weight"]);
				$order_items += $db->col["admin_quantity"];
				$order_sa_pr_b += $db->col["free_shipping"]=="Yes"?0:($db->col["admin_quantity"] * $db->col["admin_price"]);
				$order_sa_pr_l += $db->col["free_shipping"]=="Yes"?0:($db->col["admin_quantity"] * $db->col["shipping_price"]);
			}
?>
					</tbody>
					<tfoot>
					<!-- order amounts-->
						<tr>
							<td class="text-align-right" colspan="5" align="right">Subtotal amount :</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["subtotal_amount"])?></td>
						</tr>
<?php
 			if ($order_data["discount_amount"]>0)
 			{
?>
						<tr>
							<td class="text-align-right"  colspan="5">
								Discount 
<?php			if ($order_data["discount_type"] == "percent")
{
					echo "(-".myNum($order_data["discount_value"])."%)";
				}
				else
				{
					echo "(-".getAdminPrice($order_data["discount_value"]).")";
				}
?>
								:
							</td>
							<td class="text-align-right">- <?=getAdminPrice($order_data["discount_amount"])?></td>
						</tr>
<?php		}

			if ($order_data["promo_discount_amount"] > 0)
			{
?>
						<tr>
							<td class="text-align-right"  colspan="5">
								Promo Discount (<?php echo $order_data['promo_type'] == 'Shipping' ? 'Applied to shipping' : 'Applied to products';?>:
<?php			
				if ($order_data["promo_discount_type"] == "percent")
				{ 
					echo "-".myNum($order_data["promo_discount_value"])."%)";
				}
				else
				{
					echo "-".getAdminPrice($order_data["promo_discount_value"]).")";
				}
?>
								:
							</td>
							<td class="text-align-right">- <?=getAdminPrice($order_data["promo_discount_amount"])?></td>
						</tr>
<?php
			}
			if ($order_data["shipping_amount"] > 0)
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">
								Shipping amount 
								(<?=gs($order_data["shipping_cm_name"])?><?=$order_data["shipping_taxable"]?"; Taxable - ".$order_data["shipping_tax_description"]:""?>) :
							</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["shipping_amount"])?></td>
						</tr>
<?php
			}
			if ($order_data["handling_amount"] > 0)
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">
								Handling fee 
								<?=$order_data["handling_fee_type"]=="percent"?(" (".myNum($order_data["handling_fee"])."%)"):""?><?=!$order_data["handling_separated"]?", <u>already added to the shipping amount</u>":""?>
								<?=$order_data["handling_taxable"]?" - Taxable - ".$order_data["handling_tax_description"]:""?>	:
							</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["handling_amount"])?></td>
						</tr>
<?php
			}
			if ($order_data["insureship_active"])
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">
								InsureShip 
								(<?php echo $order_data["insureship_policy_id"] != "" ? ("Policy #".$order_data["insureship_policy_id"]." - "):"";?><a id="insureShipCancel" href="admin.php?p=order_process&mode=insureship_cancel&oid=<?php echo $oid;?>">Cancel</a>) :
							</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["insureship_amount"])?></td>
						</tr>
<?php
			}
			if ($order_data["tax_amount"]>0)
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">Tax amount :</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["tax_amount"])?></td>
						</tr>
<?php
			}
			$gift_cert_amount = 0;
			if ($order_data["gift_cert_amount"]>0)
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">Gift Certificate amount :</td>
							<td class="text-align-right">-<?=getAdminPrice($order_data["gift_cert_amount"])?></td>
						</tr>
<?php
				$gift_cert_amount = $order_data["gift_cert_amount"];
			}
			if ($order_data["buysafe_wants_bond"] == "true" && $order_data["buysafe_bond_amount"] > 0)
			{
?>
						<tr>
							<td class="text-align-right" colspan="5">buySafe bond amount :</td>
							<td class="text-align-right"><?=getAdminPrice($order_data["buysafe_bond_amount"])?></td>
						</tr>
<?php				
			}
?>

						
<?php
			if ($order_data["payment_gateway_id"] == "bongocheckout")
			{
				if (trim($order_data["custom2"]) == '' || trim($order_data["custom3"]) == '')
				{
?>
						<tr>
							<td class="text-align-right" colspan="6" style="color:#880000;"><strong>This is Bongo order. Total amount is not final and will be determinated soon</strong></td>
						</tr>
<?php
				}
				else
				{
					if (isset($bongoOrderData) && $bongoOrderData)
					{
?>
						<tr>
							<td class="text-align-right" colspan="6" style="color:#880000;">
								<strong>
									Please note: this is Bongo order. Amounts for this order described below
								</strong>
							</td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Subtotal :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderSubtotalAmount"])?></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Duty amount :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderDutyAmount"])?></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Tax amount :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderTaxAmount"])?></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Shipping amount :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderShippingAmount"])?></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Domestic shipping amount :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderShippingDomesticAmount"])?></strong></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5">Insurance amount :</td>
							<td class="text-align-right"><?=getAdminPrice($bongoOrderData["orderInsuranceAmount"])?></td>
						</tr>
						<tr>
							<td class="text-align-right" colspan="5"><strong>Total amount (<?php echo $bongoOrderData["orderCurrency"];?>) :</strong></td>
							<td class="text-align-right"><strong><?=getAdminPrice($bongoOrderData["orderTotalAmount"])?></strong></td>
						</tr>
<?php
					}
				}
			}
			else
			{
?>
						<tr>
							<td class="text-align-right" colspan="5"><strong>Total amount :</strong></td>
							<td class="text-align-right"><strong><?=getAdminPrice($order_data["total_amount"]-$gift_cert_amount)?></strong></td>
						</tr>
<?php
			}
			
			if (in_array($order_data["custom1"], array("order", "authorization", "fulfill")) && is_numeric($order_data["custom3"]))
			{
?>
						<tr>
							<td class="text-align-right" colspan="5"><strong>Total charged amount :</strong></td>
							<td class="text-align-right"><strong><?=getAdminPrice($order_data["custom3"])?></strong></td>
						</tr>
<?php
			}
?>
					</tfoot>
				</table>
				<!-- end of order amounts -->
				<br/>
<?php
			if ($order_editable)
			{
?>
				<div class="admin-form-header"><span class="icon ic-icon ic-cutter"></span>Change Discount</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Set new discount</td>
						<td class="formItemControl">
							<input <?=$order_editable ? "" : "disabled"?> type="text" name="new_discount_value" value="<?=myNum($order_data["discount_value"])?>" style="width:90px;">
							<select <?=$order_editable ? "" : "disabled"?> name="new_discount_type" class="tiny">
								<option value="none">None</option>
								<option value="percent" <?=$order_data["discount_type"]=="percent"?"selected":""?>>%</option>
								<option value="amount" <?=$order_data["discount_type"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
							</select>
						</td>
					</tr>
					
					<tr valign="top">
						<td class="formItemCaption">Set new promo discount</td>
						<td class="formItemControl">
							<input <?=$order_editable ? "" : "disabled"?> type="text" name="new_promo_discount_value" value="<?=myNum($order_data["promo_discount_value"])?>" style="width:90px;">
							<select <?=$order_editable ? "" : "disabled"?> name="new_promo_discount_type" class="tiny">
								<option value="none">None</option>
								<option value="percent" <?=$order_data["promo_discount_type"]=="percent"?"selected":""?>>%</option>
								<option value="amount" <?=$order_data["promo_discount_type"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
							</select>
							<select <?=$order_editable ? "" : "disabled"?> name="new_promo_type">
								<option value="Global">Global</option>
								<option value="Product" <?=$order_data["promo_type"]=="Product"?"selected":""?>>Apply to specific products</option>
								<option value="Shipping" <?=$order_data["promo_type"]=="Shipping"?"selected":""?>>Apply to shipping</option>
							</select>
						</td>
					</tr>
				</table>
<?php
			}
?>

<!-- promo code information-->
<?php
 			if ($pc_details != "" and $pc_details["name"] != "")
 			{
?>	
				<div class="admin-form-header"><span class="icon ic-icon ic-cutter"></span>Promo Code Information</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Promo Code</td>
						<td class="formItemControl">
							 <?=$pc_details["name"]?>
						</td>
					</tr>
				</table>
<?php
			}
?>
				<!-- shipping information-->
				<div class="admin-form-header"><span class="icon ic-icon ic-truck"></span>Shipping Information</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Shipping Service</td>
						<td class="formItemControl"><b><?=gs($order_data["shipping_cm_name"])?></b></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Enter Tracking Number</td>
						<td class="formItemControl">
							<input type="text" maxlength="250" name="shipping_tracking_number" value="<?=gs($order_data["shipping_tracking_number"])?>">
							<select name="shipping_tracking_number_type" class="short">
								<option value="">-</option>
								<option value="UPS" <?=$order_data["shipping_tracking_number_type"]=="UPS"?"selected":""?>>UPS</option>
								<option value="USPS" <?=$order_data["shipping_tracking_number_type"]=="USPS"?"selected":""?>>USPS</option>
								<option value="FedEx" <?=$order_data["shipping_tracking_number_type"]=="FedEx"?"selected":""?>>FedEx</option>
								<option value="CanadaPost" <?=$order_data["shipping_tracking_number_type"]=="CanadaPost"?"selected":""?>>Canada Post</option>
							</select>
<?php
			if ($order_data["payment_gateway_id"] == "bongocheckout")
			{
?>
							<br/>
							<input type="checkbox" value="1" id="bongoOrderTrackingUpdate" name="bongoOrderTrackingUpdate" checked="checked"/>
							<label for="bongoOrderTrackingUpdate">Send tracking information to <span style="color:orange">bon</span><span style="color:green">go</span></label>
<?php
			}
?>
						</td>
					</tr>
<?php 
			if ($order_data["shipping_tracking"] != "")
			{
				$shipping_tracking = unserialize($order_data["shipping_tracking"]);
?>
					<tr valign="top">
						<td class="formItemCaption">Tracking info</td>
						<td class="formItemControl">
<?php 
				foreach ($shipping_tracking as $st)
				{
				echo $st["carrier"].": ".$st["tracking"]."<br/>";
				}
?>		
						</td>
					</tr>
<?php 
			}
?>
					<tr valign="top">
						<td class="formItemCaption">Total Products Weight (<?=$settings["LocalizationWeightUnits"]?>)</td>
						<td class="formItemControl"><b><?=myNum($order_weight)?></b></td>
					</tr>
				</table>
<?php
			if (($order_data["shipping_carrier_id"] == "ups") && ($order_data["shipping_tracking_number"] > 0))
			{
				require_once("content/engine/engine_ups.php");
				$ups = new UPS;
				$ups->setUserName($settings["ShippingUPSUserID"]);
				$ups->setPass($settings["ShippingUPSUserPassword"]);
				$ups->setAccessKey($settings["ShippingUPSAccessKey"]);
				$ups->setTrackingServer($settings["ShippingUPSTrackingUrl"]);				
				$info = $ups->getTrackingInfo($order_data["shipping_tracking_number"]);
?>
				<div class="admin-form-header"><span class="icon ic-icon ic-truck"></span>UPS Package Information</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td colspan="2">
							<table width="100%">
								<tr>
									<td align="right">Shipping method :</td>
									<td>&nbsp;</td>
									<td><?=$info["shipping_method"] ?></td>
								</tr>
								<tr>
									<td align="right">Pickup date :</td>
									<td>&nbsp;</td>
									<td><?=$info["pickup_date"]?></td>
								</tr>
<?php
				if ($info["scheduled_delivery_date"] != "")
				{
?>
								<tr>
									<td align="right">Scheduled delivery date :</td>
									<td>&nbsp;</td>
									<td><?=$info["scheduled_delivery_date"]?> <?=$info["scheduled_delivery_time"]?></td>
								</tr>
<?php
 				} 	
				if ($info["rescheduled_delivery_date"] != "")
				{
?>	
								<tr>
									<td align="right">Rescheduled delivery date :</td>
									<td>&nbsp;</td>
									<td><?=$info["rescheduled_delivery_date"]?></td>
								</tr>
<?php
 				}
?>
								<tr>
									<td align="right">Last activity :</td>
									<td>&nbsp;</td>
									<td><?=$info["status_type_description"]?></td>
								</tr>
								<tr>
									<td align="right">Last activity location :</td>
									<td>&nbsp;</td>
									<td><?=$info["activity_location"]?><br /> 					 <?=$info["activity_location1"]?></td>
								</tr>
								<tr>
									<td align="right">Last activity date :</td>
									<td>&nbsp;</td>
									<td><?=$info["activity_date"]?> <?=$info["activity_time"]?></td>
								</tr>
<?php			
				if ($info["package_weight"] > 0)
				{
?>
								<tr>
									<td align="right">Shipment weight :</td>
									<td>&nbsp;</td>
									<td ><?=$info["shipment_weight"]?> <?=$info["shipment_weight_unit"]?></td>
								</tr>
<?php		
				}
				if ($info["package_weight"] > 0)
				{
?>
								<tr>
									<td align="right">Package weight :</td>
									<td>&nbsp;</td>
									<td><?=$info["package_weight"]?><?=$info["package_weight_unit"]?></td>
								</tr>
<?php
				}
?>
							</table>
						</td>
					</tr>
				</table>
<?php				
			}
?>

				<!-- end of shipping information -->
				<!-- Notes for the order-->
				<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Order Notes</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">	
<?php
			if (count($admin_notes)>0)
			{
?>
					<tr valign="top" >
						<td class="formItemCaption" colspan="2">
							<table cellspacing="5" cellpadding="0" width="100%">
								<tr>
									<td width="10%">Email Sent</td>
									<td width="20%">Create Time</td>
									<td width="25%">Title</td>
									<td width="45%">Notes</td>
								</tr>
<?php	
				foreach($admin_notes as $k=>$admin_note)
				{
?>
								<tr>
									<td><?=$admin_note["send_email"]?></td>
									<td><?=$admin_note["note_created_at"]?></td>
									<td><?=$admin_note["note_title"]?></td>
									<td><?=$admin_note["note_text"]?></td>
								</tr>
<?php
 				}
?>
		
		 					</table>
						</td>
					</tr>
<?php
			}
?>
					<tr valign="top">
						<td class="formItemCaption">Send Notification to Customer  </td>
						<td class="formItemControl">
						<input id="checkbox_send_email" type="checkbox" name="send_email" value="Yes"></td>
					</tr>
					<input type="hidden" name="send_email_to" value="<?=$user_data["email"]?>"/>
					<input type="hidden" name="order_invoice" value="<?=$order_data["order_num"]?>"/>
					<tr valign="top">
						<td class="formItemCaption">Title </td>
						<td class="formItemControl"><input type="text" style="width:200px;" maxlength="250" name="note_title" value=""></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Note </td>
						<td class="formItemControl">
							<textarea class="no-mce" wrap="off" style="width:100%;height:150px;margin-bottom:10px;" id="note_text" class="content" name="note_text"></textarea>
						<input type="submit" value="Send email"/>
						</td>
					</tr>
				</table>
				<!-- End of order notes-->
				
				<!-- payment information -->
				<div class="admin-form-header"><span class="icon ic-icon ic-payment"></span>Payment Information</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">	
					<tr>
						<td class="formItemCaption">Payment Method</td>
						<td class="formItemControl">
							<b>
								<?=$order_data["payment_is_realtime"]=="Yes"?"Realtime":"Not realtime"?> - 
								<?=gs($order_data["payment_method_name"])?>
								<!--
								<?=trim($order_data["payment_gateway_id"]) == "" ? "[no gateway]" : ucfirst($order_data["payment_gateway_id"])?>
								-->
							</b>
						</td>
					</tr>
					<tr>
						<td class="formItemCaption">Current Payment Status</td>
						<td class="formItemControl"><b><?=$order_data["payment_status"]?></b></td>
					</tr>
<?php
			if (($order_data["card_data"] != "" && AccessManager::checkAccess('CCS')) && IsPrivilege(array("ccs", "all"), $auth_rights))
			{
?>
<script language="JavaScript" type="text/javascript">
		function showCCS(){
			var text_ccs_username = document.getElementById("text_ccs_username");
			var hidden_ccs_username = document.getElementById("hidden_ccs_username");
			var text_ccs_password = document.getElementById("text_ccs_password");
			var hidden_ccs_password = document.getElementById("hidden_ccs_password");
			var form_ccs = document.getElementById("frmCCS");
			if(text_ccs_username && hidden_ccs_username && hidden_ccs_password && hidden_ccs_password && form_ccs){
				hidden_ccs_username.value = text_ccs_username.value;
				hidden_ccs_password.value = text_ccs_password.value;
				form_ccs.submit();
			}
		}
		function deleteCCS(){
			if(confirm("Do you realy want to delete CC data?")){
				document.location="admin.php?p=order&oid=<?=$oid?>&delete_ccs=true";
			}
		}
</script>
					<tr valign="top">
						<td class="formItemCaption">Stored Credit Card</td>
						<td class="formItemControl">
		
<?php
				$card_data = unserialize(urldecode($order_data["card_data"]));
				$show_ccd_passwd = true;
				if (isset($_POST["ccs_show"]))
				{
					adminLog("Access to CCS - order #".$order_data["order_num"]);
					require_once("content/classes/class.openssl.php");
					$ds = DIRECTORY_SEPARATOR;
					$openSSL = new openSSL(4096, OPENSSL_KEYTYPE_RSA, 3650, $settings["GlobalServerPath"].$ds."content".$ds."ssl".$ds."openssl.cnf");
					$decrypted = $openSSL->decrypt($card_data["cr"], $_POST["ccs_username"].$_POST["ccs_password"], base64_decode($settings["SecurityCCSPrivateKey"]));
					if ($decrypted)
					{
						$cc_data = unserialize($decrypted);
						echo "<div>".$cc_data["fn"]." ".$cc_data["ln"]."<br/>";
						echo $cc_data["ct"]."<br/>";
						echo $cc_data["cc"]."<br/>";				
						echo $cc_data["em"]."/".$cc_data["ey"]."</div>";
						$show_ccd_passwd = false;
					}
					else
					{
						echo "Can't get CC data. Please try different password";
					}
				}
				else
				{
					echo "xxxx-xxxx-xxxx-<b>".$card_data["l4"].'</b>';
				}
				if ($show_ccd_passwd)
				{
?>
						<br/>
							Enter your CCS username &amp; password below and click "Show Number" to see the full card number<br/>
							<input type="text" style="width:150px;" id="text_ccs_username"/> &nbsp;
							<input type="password" style="width:150px;" id="text_ccs_password"/> &nbsp; <input type="button" onclick="showCCS();" value="Show Number"/><br/>
		
<?php
				}
?>
							<br/><a href="javascript:deleteCCS()">Delete CC</a>
						</td>
					</tr>
<?php		}
 			if ($order_data["payment_gateway_id"] == "googlecheckout")
 			{
?>
					<tr>
						<td class="formItemCaption">Current Google order status</td>
						<td class="formItemControl"><b><?=$order_data["custom3"]?></b></td>
					</tr>
					<tr>
						<td class="formItemCaption">Google Order Number</td>
						<td class="formItemControl"><b><?=$order_data["custom1"]?></b></td>
					</tr>
<?php
			}
?>
					<tr>
						<td class="formItemCaption">Set Payment Status</td>
						<td class="formItemControl">
							<select name="payment_status" class="short">
								<option value="">Do not change</option>
								<option value="Pending">Pending</option>	
								<option value="Partial">Partial</option>			
								<option value="Received">Received</option>
								<option value="Refunded">Refunded</option>
								<option value="Declined">Declined</option>
								<option value="Canceled">Canceled</option>
								<option value="Error">Error</option>
								<option value="Auth Expired">Auth Expired</option>
								<option value="Reversed">Reversed</option>
							</select>
						</td><?=$db->col["payment_gateway_id"]?>
					</tr>
				
					<!-- payment transactions-->
<?php
			$payment_type = "custom";

			$custom_vars = array("1"=>false, "2"=>false, "3"=>false);
			$db->query("SELECT *, DATE_FORMAT(completed, '".$settings["LocalizationDateTimeFormat"]."') AS co FROM ".DB_PREFIX."payment_transactions WHERE oid='".$oid."' AND is_success = 1 ORDER BY completed");
			if ($db->numRows() > 0)
			{
?>
					<tr>
						<td colspan="2" align="right">
							<img src="images/icons/a/arrow_down.png" style="cursor:pointer;" onClick="showHideDiv(this, 'divTransactionData')" id="arr2" align="right">
							<a href="javascript:showHideDiv(document.images.arr2, 'divTransactionData')">Transaction Details</a> &nbsp;&nbsp;&nbsp;
						</td>
					</tr>
					<tr>
						<td colspan="2" align="center">
							<div id="divTransactionData" style="display:none">
								<table width="100%" cellpadding="0" cellspacing="0">
<?php
				while ($db->moveNext())
				{
					$payment_type = $db->col["payment_type"];
?>
									<tr><td width="5%">&nbsp;</td><td colspan="3"><u>Transaction Data</u></td></tr>
									<tr>
										<td width="5%">&nbsp;</td>
										<td align="right" width="35%">Payment Gateway</td>
										<td width="5%">&nbsp;</td>
										<td width="55%"><b><?=ucfirst($db->col["payment_gateway"])?></b></td>
									</tr>
									<tr>
										<td width="5%">&nbsp;</td>
										<td align="right" height="30">Transaction Amount</td>
										<td>&nbsp;</td>
										<td><b><?=getAdminPrice($db->col["order_total_amount"])?></b></td>
									</tr>
									<tr>
										<td width="5%">&nbsp;</td>
										<td align="right">Completed At</td>
										<td>&nbsp;</td>
										<td><b><?=$db->col["co"]?></b></td>
									</tr>
<?php
					if (strlen(trim($db->col["extra"]))>0)
					{
?>
									<tr>
										<td width="5%">&nbsp;</td>
										<td align="right" height="30">Note</td>
										<td>&nbsp;</td>
										<td><?=gs($db->col["extra"])?></td>
									</tr>
<?php
					}
?>
									<tr>
										<td width="5%">&nbsp;</td>
										<td align="right" height="120">Gateway Response</td>
										<td>&nbsp;</td>
										<td>
											<textarea class="no-mce" wrap="off" readonly style="width:290px;height:100px;font-size:10px;"><?=gs($db->col["payment_response"])?></textarea>
										</td>
									</tr>
<?php
				}
?>
								</table>
							</div>
						</td>
					</tr>
<?php
			}
			$payment_gateway = false;
			if (($payment_type == "cc" || $payment_type == "ipn") && ($order_data["payment_gateway_id"] != "" && file_exists("content/engine/payment/payment_".$order_data["payment_gateway_id"].".php")))
			{
				$gateway_file = escapeFileName($order_data["payment_gateway_id"]); 
				require_once("content/engine/payment/payment_".$gateway_file.".php");
				eval("\$payment_gateway = new ".strtoupper("PAYMENT_".$order_data["payment_gateway_id"])."();");
				if ($payment_gateway)
				{
					$payment_gateway->getSettingsData($db);
					$custom_vars = $payment_gateway->getVarStatus($order_data["custom1"], $order_data["custom2"], $order_data["custom3"], $order_data["status"], $order_data["payment_status"]);
				}
			}
			for ($i=1; $i<=3; $i++)
			{
				if ($custom_vars[$i] != false)
				{
?>
					<tr>
						<td>&nbsp;</td>
						<td class="formItemControl">
							<?=$custom_vars[$i]["message"]?>
							<?if($custom_vars[$i]["executable"]){?>
								<div style="padding-top:7px;"><a href="admin.php?p=order_process&oid=<?=$oid?>&mode=process_custom&custom_id=1"><?=$custom_vars[$i]["link_caption"]?></a></div>
							<?}?>
						</td>
					</tr>
		
<?php			}
			}
?>
				</table>
<?
			if ($payment_gateway)
			{
				$show_refund = $payment_gateway->supportsRefund($order_data);
				$show_void = $payment_gateway->supportsVoid($order_data);
				$show_capture = $payment_gateway->supportsCapture($order_data);

				if ($show_refund || $show_void || $show_capture)
				{
?>
				<div class="admin-form-header"><span class="icon ic-icon ic-payment"></span>Payment Handling</div>
				<input type="hidden" name="handle_custom_method" value="1"/>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">	
					<tr>
						<td class="formItemCaption">Current Order Status:</td>
						<td class="formItemControl"><b><?php echo $payment_gateway->currentOrderPaymentStatus($order_data);?></b></td>
					</tr>
					<tr>
						<td class="formItemCaption">Payment Status:</td>
						<td class="formItemControl">
							<script type="text/javascript">
							function custom_showPanel(sel) {
								var option = $(sel).val();
								$('#custom_Capture').hide();
								$('#custom_Refund').hide();

								$('#custom_'+option).show();
							}
							</script>
							<select name="custom_payment_status" style="width:120px;" onchange="custom_showPanel(this);">
								<option value=" ">Select status</option>
								<?php if ($show_capture) { ?>
									<option value="Capture">Capture</option>
								<?php } ?>
								<? if($show_refund) { ?>
									<option value="Refund">Refund</option>
								<? }?>
								<?php if ($show_void) { ?>
									<option value="Void">Void</option>
								<?php } ?>
							</select>
						</td>
					</tr>
					<tr id="custom_Capture" style="display:none;">
						<td class="formItemCaption">
						Amount to Capture:
						</td>
						<td class="formItemControl">
						<input type="text" name="custom_capture_amt" style="width:100px;" value="<?php print $payment_gateway->capturableAmount($order_data); ?>"/>&nbsp;&nbsp;<?=$admin_currency["code"]?>
						</td>
					</tr>
					<tr id="custom_Refund" style="display:none;">
						<td class="formItemCaption">
						Amount to Refund:
						</td>
						<td class="formItemControl">
						<input type="text" name="custom_refund_amt" style="width:100px;" value="<?php print $payment_gateway->refundableAmount($order_data); ?>"/>&nbsp;&nbsp;<?=$admin_currency["code"]?>
						</td>
					</tr>
				</table>
<?php
				}
			}

			if (in_array($order_data["payment_status"], array("Pending", "Partial")) || in_array(strtolower($order_data["custom1"]), array("sale", "none", "pre", "auth", "erp", "fulfill")))
			{
				require_once("admin_order_customvars.php");
			}
			
			if (($cf_invoice && is_array($cf_invoice) && count($cf_invoice) > 0) || trim($order_data["gift_message"]) != "")
			{
?>
				<div class="admin-form-header"><span class="icon ic-icon ic-password"></span>Order Custom Fields Values</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">	
<?php			
				if (trim($order_data["gift_message"]) != "")
				{
					echo "<tr><td align='right'>Gift Message :</td><td>".$order_data["gift_message"]."</td></tr>";
				}	
			
				if (($cf_invoice && is_array($cf_invoice) && count($cf_invoice) > 0))
				{
					foreach($cf_invoice as $field)
					{
						echo "<tr><td align=\"right\" height=\"40\">".$field["field_name"]." :</td><td>".$field["value_translated"]."</td></tr>";
					}
				}
?>
				</table>
<?php
			}
?>	
	
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes" />
		<input type="reset" value="Reset form" />
	</div>
</div>
</div>
</div>
</form>

<form name="frmCCS" id="frmCCS" method="post" action="admin.php?p=order&oid=<?=$oid?>#ccs" method="POST">
	<input type="hidden" name="ccs_show" value="true"/>
	<input type="hidden" id="hidden_ccs_username" name="ccs_username" value=""/>
	<input type="hidden" id="hidden_ccs_password" name="ccs_password" value=""/>
</form>
<?php
		}
	}
	else
	{
		pageHeader("Can't Select Order", "", "icb-cross");
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>Can't select order by specified ID</b>", "url"=>"", "visible"=>true)
		));
		pageWhat(array(
			array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
		));
	}
