<?php
	if (!defined("ENV")) exit();
	
	$paypal_error = false;

	/**
	 * PayPal changes for DoCapture and DoAuthorization
	 */
	if ($paypal_payment_status != "")
	{
		if (!isset($total_amount))
		{
			$total_amount = $order_data["total_amount"];
		}
		
		$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='".$db->escape($paypal_method)."' AND active='Yes'");
		if ($db->moveNext())
		{
			$currencyCode = $settings[$paypal_method.'_Currency_Code'];

			$testMode = false;
			if (isset($settings[$paypal_method.'_Mode']) && $settings[$paypal_method.'_Mode'] == 'Test')
			{
				$testMode = true;
			}

			if ($paypal_method == 'paypalec')
			{
				$api = Payment_PayPal_PayPalApi::getExpressCheckoutApi($settings);
			}
			else if (isset($settings[$paypal_method.'_Vendor']))
			{
				$api = new Payment_PayPal_PayflowApi($settings, !$testMode);
				$api->setApiPartner($settings[$paypal_method."_Partner"]);
				$api->setApiVendor($settings[$paypal_method."_Vendor"]);
				$api->setApiUsername($settings[$paypal_method."_User"]);
				$api->setApiPassword($settings[$paypal_method."_Password"]);
			}
			else
			{
				$api = new Payment_PayPal_PayPalApi($settings, !$testMode);

				$api->setApiUsername($settings[$paypal_method."_Username"]);
				$api->setApiPassword($settings[$paypal_method."_Password"]);

				if (!is_null($settings[$paypal_method."_Signature"]) && !empty($settings[$paypal_method."_Signature"]))
				{
					$api->setApiSignature($settings[$paypal_method."_Signature"]);
				}
				else
				{
					$api->setUseCertificate(true);
				}
			}
			
			$paypal_partial_capture = isset($paypal_partial_capture) ? $paypal_partial_capture : 0;

			//payment method details. Please change it according to payment method selected
			$gateway_details[0] = "cc";
			$gateway_details[1] = $paypal_method." : ".$paypal_payment_status;
			$total_charged_amount = $paypal_charged_amount + $paypal_partial_capture;
							
			
			if ($total_charged_amount == $chargeable_amt)
			{
				$complete_type = "Complete";
			}
			else if ($total_amount == $total_charged_amount)
			{
				$complete_type = "Complete";
			}
			else if ($chargeable_amt > $paypal_partial_capture)
			{
				$complete_type = "NotComplete";
			}
			else if ($chargeable_amt == $paypal_partial_capture)
			{
				$complete_type = 'Complete';
			}

			$response = "";

			if (isset($settings[$paypal_method.'_Vendor']))
			{
				switch ($paypal_payment_status)
				{
					/**
					 * Capture
					 */
					case "Capture":
					{
						$result = $api->handleCapture($db, $oid, $uid, $authorization_id, $paypal_settlement_note, $total_amount, $gateway_details);

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;									
					}
					/**
					 * Refund
					 */
					case "Refund":
					{
						if ($paypal_charged_amount == $paypal_partial_capture)
						{
							$refund_type ="Full";
						}
						
						if ($total_amount > $paypal_partial_capture)
						{
							$refund_type ="Partial";
						}
						
						$result = $api->handleRefund($db, $oid, $uid, $authorization_id, $paypal_partial_capture, $paypal_charged_amount, $total_amount, $paypal_settlement_note, $gateway_details);

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}		
					
					/**
					 * Cancel
					 */
					case "Cancel":
					{
						$result = $api->handleVoid($db, $oid, $uid, $authorization_id, $paypal_settlement_note, $total_amount, $gateway_details, "Canceled");

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}
				}
			}
			else
			{
				switch ($paypal_payment_status)
				{
					/**
					 * Capture
					 */
					case "Capture":
					{
						$result = $api->handleCapture($db, $oid, $uid, $authorization_id, $paypal_partial_capture, $total_charged_amount, $currencyCode, $paypal_settlement_note, $complete_type, $gateway_details);

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;									
					}
					
					/**
					 * Authorization
					 */
					case "Authorization":
					{
						$result = $api->handleAuthorization($db, $oid, $uid, $authorization_id, $paypal_partial_capture, $currencyCode, $paypal_settlement_note, $gateway_details);
						
						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}
				
					/**
					 * Reauthorization
					 */
					case "Reauthorization":
					{
						$result = $api->handleReauthorization($db, $oid, $uid, $authorization_id, $paypal_partial_capture, $currencyCode, $paypal_settlement_note, $gateway_details);

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}
					
					/**
					 * Refund
					 */
					case "Refund":
					{
						
						$result = $api->handleRefund($db, $oid, $uid, $authorization_id, $paypal_partial_capture, $currencyCode, $paypal_settlement_note, $gateway_details, $paypal_charged_amount, $total_amount);

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}		
					
					/**
					 * Cancel
					 */
					case "Cancel":
					{
						$result = $api->handleVoid($db, $oid, $uid, $authorization_id, $paypal_settlement_note, $paypal_charged_amount, $paypal_partial_capture, $gateway_details, 'Canceled');

						if ($result !== false)
						{
							$paypal_error = true;
							pageHeader("Error Updating Order Payment Status");
							pageNote(array(
								array("class"=>"ic-cross", "text"=>"<b>Error processing transaction. Error message: ".$result."</b>", "url"=>"", "visible"=>true)
							));
						}
						break;
					}
				}
			}
		}
	}