<?php

	if (!defined("ENV")) exit();

	$dollar_days_shipping_percent = 15;
	$dollar_days_shipping_min_amount = 6.95;
	
	///////////////////////////////////////
	// Stock control
	// at this point inventory control based on 2 "after checkout" conditions
	// 1) stock_warning should be < then stock
	// 2) min_order should be <= then stock
	function stockControl(&$db, $oid)
	{
		// select orders products with allowed stock control from database
		$db->query("
			SELECT ".DB_PREFIX."orders_content.*,
				".DB_PREFIX."products.stock,
				".DB_PREFIX."products.stock_warning,
				".DB_PREFIX."products.min_order,
				".DB_PREFIX."products.max_order,
				".DB_PREFIX."products.inventory_rule
			FROM ".DB_PREFIX."orders_content 
			LEFT JOIN ".DB_PREFIX."products ON 
				".DB_PREFIX."products.pid = ".DB_PREFIX."orders_content.pid AND
				(".DB_PREFIX."products.inventory_control = 'Yes' OR ".DB_PREFIX."products.inventory_control IN ('AttrRuleExc', 'AttrRuleInc'))
			WHERE 
				".DB_PREFIX."orders_content.oid='".$oid."' AND ".DB_PREFIX."orders_content.is_stock_changed='No'
		");
		// store products in temporary array
		$products = array();
		while($db->moveNext()){
			$products[$db->col["ocid"]] = array(
				"stock"=>$db->col["stock"], 
				"stock_warning"=>$db->col["stock_warning"],
				"pid"=>$db->col["pid"],
				"quantity"=>$db->col["quantity"],
				"admin_quantity"=>$db->col["admin_quantity"],
				"min_order"=>$db->col["min_order"],
				"inventory_id"=>$db->col["inventory_id"],
				"inventory_rule"=>$db->col["inventory_rule"],
				"is_stock_changed"=>$db->col["is_stock_changed"]
			);
		}
		// update stock for products
		reset($products);			
		foreach($products as $ocid=>$product){
			$inventory_id = $product["inventory_id"];
			/////////////////////////////////////////////////
			// stock on attribute level
			if($inventory_id > 0){
				$db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pi_id='".$inventory_id."'");
				if($db->moveNext()){
					$new_attr_stock = $db->col["stock"] - $product["admin_quantity"];
					if($new_attr_stock <= $db->col["stock_warning"]){						
						//$db->assignStr("is_active", "0");						
						emailOutOfStock($db, $product["pid"], $new_attr_stock, $inventory_id);
					}
					$db->reset();
					$db->assign("stock", $new_attr_stock);
					$db->update(DB_PREFIX."products_inventory", "WHERE pid = '".$product["pid"]."' AND pi_id='".$inventory_id."'");
					$db->query("UPDATE ".DB_PREFIX."products SET stock = stock-".$product["quantity"]." WHERE pid='".$product["pid"]."' ");
				}
			}else{			
				/////////////////////////////////////////////////
				// stock on product level
				$new_stock = $product["stock"] - $product["admin_quantity"];
				if($new_stock <= $product["stock_warning"]) {
					$inventory_rule = 'OutOfStock';
					$inventory_control = 'Yes';
					$is_sold = 'Yes';
					$db->reset();
					$db->assign("stock", $new_stock);
					$db->assignStr("inventory_rule", $inventory_rule);
					$db->assignStr("inventory_control", $inventory_control);
					$db->assignStr("is_sold", $is_sold);
					$db->update(DB_PREFIX."products", "WHERE pid = '".$product["pid"]."'");
					emailOutOfStock($db, $product["pid"], $new_stock, 0);
				}
				else{
					$db->reset();
					$db->assign("stock", $new_stock);
					$db->update(DB_PREFIX."products", "WHERE pid = '".$product["pid"]."'");
				}				
			}
			$db->reset();
			$db->assignStr("is_stock_changed", "Yes");
			$db->update(DB_PREFIX."orders_content", "WHERE ocid='".$ocid."'");
		}
	}

	function returnToInventory(&$db, $oid, $do_make_visible)
	{
		/////////////////////////////////////////////
		// return on attribute level
		$db->query("
			SELECT 
				".DB_PREFIX."orders_content.quantity AS total_quantity,
				".DB_PREFIX."orders_content.pid,
				".DB_PREFIX."orders_content.inventory_id,
				".DB_PREFIX."products_inventory.is_active, 
				".DB_PREFIX."products_inventory.stock,
				".DB_PREFIX."products_inventory.stock_warning
			FROM ".DB_PREFIX."orders_content 
			INNER JOIN ".DB_PREFIX."products_inventory ON ".DB_PREFIX."products_inventory.pi_id=".DB_PREFIX."orders_content.inventory_id
			WHERE 
				".DB_PREFIX."orders_content.oid='".$oid."' AND 
				".DB_PREFIX."orders_content.is_stock_changed='Yes' AND 
				".DB_PREFIX."orders_content.inventory_id > 0
		");
		if ($db->numRows() > 0)
		{
			$products = $db->getRecords();
			foreach ($products as $product)
			{
				$new_attr_stock = $product["stock"] + $product["total_quantity"];
				$db->reset();
				$db->assignStr("stock", $new_attr_stock);
				if ($do_make_visible && $new_attr_stock >= $product["stock_warning"])
				{
					$db->assignStr("is_active", "1");
				}
				$db->update(DB_PREFIX."products_inventory", "WHERE pi_id='".$product["inventory_id"]."'");
			}
		}
		/////////////////////////////////////////////
		// return on product level
		// reason for grouping is there maybe be the same product but with different attributes
		$db->query("
			SELECT 
				SUM(".DB_PREFIX."orders_content.quantity) AS total_quantity,
				".DB_PREFIX."orders_content.pid,
				".DB_PREFIX."products.is_visible, 
				".DB_PREFIX."products.stock,
				".DB_PREFIX."products.stock_warning
			FROM ".DB_PREFIX."orders_content 
			INNER JOIN ".DB_PREFIX."products ON ".DB_PREFIX."products.pid=".DB_PREFIX."orders_content.pid AND ".DB_PREFIX."products.inventory_control='Yes'
			WHERE 
				".DB_PREFIX."orders_content.oid='".$oid."' AND 
				".DB_PREFIX."orders_content.is_stock_changed='Yes'
			GROUP BY ".DB_PREFIX."products.pid
		");
		if ($db->numRows() > 0)
		{
			$products = $db->getRecords();
			foreach ($products as $product)
			{
				$new_stock = $product["stock"] + $product["total_quantity"];
				$db->reset();
				$db->assignStr("stock", $new_stock);
				if ($do_make_visible && $new_stock >= $product["stock_warning"])
				{
					$db->assignStr("is_visible", "Yes");
				}
				$db->update(DB_PREFIX."products", "WHERE pid='".$product["pid"]."'");
			}
			$db->query("UPDATE ".DB_PREFIX."orders_content SET is_stock_changed='No' WHERE oid='".$oid."'");
		}
	}

	$mode = isset($mode)?trim($mode):"";
	
	$allow_linkpoint_extension = true;
	
	if (($mode=="globalstatus" || $mode=="globaldelete") && !DEMO_LOCK)
	{
		switch($mode)
		{
			/**
			 * CHANGE ORDER AND PAYMENT STATUS FOR FEW ORDERS AT ONCE
			 */
			case "globalstatus" : 
			{
				$_payment_status = isset($payment_status)?trim($payment_status):"";
				$_order_status = isset($order_status)?trim($order_status):"";
				$orders = isset($orders)?trim($orders):"";
				$orders = explode(";", $orders);			
				if ($_order_status != "" || $_payment_status != "")
				{
					//create linkpoint instance to batch process orders
					if ($order_status == "Completed" && isset($allow_linkpoint_extension))
					{
						require_once("content/engine/payment/payment_linkpoint.php");
						$payment_gateway = new PAYMENT_LINKPOINT();
						if ($payment_gateway)
						{
							$payment_gateway->getSettingsData($db);
						}
					}				
					//walk selected orders
					foreach ($orders as $i=>$oid)
					{					
						//check is order id correct
						$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$oid."'");
						if ($db->moveNext())
						{
							$order_data = $db->col;
							//reset status vars
							$order_status = $_order_status;
							$payment_status = $_payment_status;													
							$current_payment_status = $order_data["payment_status"];
							$current_custom_value = $order_data["custom1"];
							$order_num = $order_data["order_num"];						
							//process linikpoint batch transactions for PRE/POST AUTH
							if (($order_status == "Completed") && isset($allow_linkpoint_extension) && ($allow_linkpoint_extension == true))
							{
								if (($current_payment_status == "Awaiting") && ($current_custom_value == "PREAUTH"))
								{
									if (!ini_get('safe_mode')) set_time_limit(180);
									$payment_gateway->processCustom($db, 1, $oid);
									
									if ($payment_gateway->is_error)
									{
										pageNote(array(
											array("icon"=>"ic_error.gif", "text"=>"<b>Error processing transaction for order # ".$order_num.". Error message: ".$payment_gateway->error_message."</b>", "url"=>"", "visible"=>true)
										));
										$payment_status = "";
										$order_statut = "";
									}
									else
									{
										$payment_status = "Received";
									}
								}
							}
							
							// *** GIFT CERTIFICATE
							if ($payment_status == "Received" && $order_data["payment_status"] != "Received" )
							{
								require_once("content/engine/engine_notifications.php");
								require_once("content/classes/class.gift_certificates.php");
								require_once("content/admin/admin_init_smarty.php");
								$gift_cert = new GiftCertificates($db);
								$gift_data = $gift_cert->GetGiftCertificate($oid);
								if ($gift_data !== false) 
								{
									// the user has ordered a gift certificate
									$gift_cert->OrderGiftCertificate($gift_data['ocid'], $gift_data['first_name'], $gift_data['last_name'], $gift_data['gift_amount'], $gift_data['voucher']);
									if ($gift_data['email_gift'] == '1')
										$gift_cert->SendNotification($oid);
								}
								if ($settings["InventoryStockUpdateAt"]=="Payment Received")
								{		
									stockControl($db, $oid);
								}
							}
							if ($order_status == "Completed" && $order_data["status"] != "Completed")
							{
								if (isset($send_notification_email))
								{
									require_once("content/engine/engine_notifications.php");
									require_once("content/admin/admin_init_smarty.php");
									// *** GIFT CERTIFICATE
									view()->assign("payment_method_name", "Gift Certificate");
									view()->assign("gift_cert_amount", $order_data['gift_cert_amount']);
									// *** GIFT CERTIFICATE
									emailOrderCompleted($db, $oid);
								}
								
								if ($settings["ProductsLocationsSendOption"] == "admin" || ($payment_status == "Received" && $order_data["payment_status"] != "Received"))
								{
									emailProductsLocationsNotify($db, $oid);
								}
								
								if ($settings["InventoryStockUpdateAt"]=="Order Completed")
								{		
									stockControl($db, $oid);
								}
								//Set google server a notification for order status change
								if ($order_data["payment_gateway_id"] == "googlecheckout")
								{
									$gateway_file = escapeFileName($order_data["payment_gateway_id"]);
									require_once("content/engine/payment/payment_".$gateway_file.".php");
									eval("\$payment_gateway = new ".strtoupper("PAYMENT_".$order_data["payment_gateway_id"])."();");
									if ($payment_gateway)
									{ 
										$payment_gateway->getSettingsData($db);
									}
									$post_form["carrier"] = $order_data["shipping_cm_name"];
									$post_form["tracking_id"] = $order_data["shipping_tracking_number"];
									$payment_gateway->processCustomAdvance($db, 4, $oid, $post_form);
								}
							}
					
							$return_to_inventory = true;
							$make_visible = true;
							if (($order_status == "Canceled" && $order_data["status"] != "Canceled") && isset($return_to_inventory))
							{
								returnToInventory($db, $oid, isset($make_visible));
							}		
							
							if (($order_status == "Canceled" && $order_data["status"] != "Canceled") && $order_data["buysafe_wants_bond"] == "true")
							{
								require_once("content/classes/class.buysafe.php");
								$buysafe->setShoppingCartCancelOrder($oid);
							}	
										
							$db->reset();
							if($order_status != ""){
								$db->assignStr("status", $order_status);
							}						
							if($payment_status != ""){
								$db->assignStr("payment_status", $payment_status);
							}						
							$db->assign("status_date", "NOW()");
							$db->update(DB_PREFIX."orders", "WHERE oid='".$oid."'");
						}
					}
				}
				pageHeader("Orders Status Updated", "", "");
				pageNote(array(
					array("icon"=>"ic_hint.gif", "text"=>"<b>Orders status has been successfully updated</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
				));
				break;
			}
			//////////////////////////////////////////////////////////
			// VIRTUALLY DELETE FEW ORDERS AT ONCE
			case "globaldelete" : {
				$orders = isset($orders)?trim($orders):"";
				$orders = explode(";", $orders);
				foreach($orders as $i=>$oid){
					$db->query("UPDATE ".DB_PREFIX."orders SET removed='Yes' WHERE oid='".$oid."'");
				}
				pageHeader("Orders Removed", "", "");
				pageNote(array(
					array("icon"=>"ic_hint.gif", "text"=>"<b>Selected orders has been successfully removed</b>", "url"=>"", "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
				));
				break;
			}
		}
	}
	else
	{
		$oid = isset($oid)?($oid*1):0;
		
		//SELECT ORDER DATA FROM DATABASE
		$db->query("
			SELECT ".DB_PREFIX."orders.*,
				".DB_PREFIX."countries.name AS country_name,
				".DB_PREFIX."countries.iso_a2 AS country_iso_a2,
				".DB_PREFIX."countries.iso_a3 AS country_iso_a3,
				".DB_PREFIX."countries.iso_number AS country_iso_number
			FROM ".DB_PREFIX."orders 
			LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."orders.shipping_country
			WHERE 
				".DB_PREFIX."orders.oid='".$oid."'
		");
		if ($db->moveNext())
		{
			$order_data = $db->col;
			switch($mode)
			{
				
				/**
				 * Process custom
				 */
				case "process_custom" : 
				{
					$custom_id = isset($custom_id)?intval($custom_id):0;
					$post_form = isset($post_data)?$post_data:"";
					
					$gateway_file = escapeFileName($order_data["payment_gateway_id"]);
					require_once("content/engine/payment/payment_".$gateway_file.".php");
									
					eval("\$payment_gateway = new ".strtoupper("PAYMENT_".$order_data["payment_gateway_id"])."();");
					if ($payment_gateway)
					{
						$payment_gateway->getSettingsData($db);
						$payment_gateway->isTestMode();
						//$custom_vars = $payment_gateway->getVarStatus($order_data["custom1"], $order_data["custom2"], $order_data["custom3"]);
					}
					
					if($order_data["payment_gateway_id"] == "googlecheckout") {						 
						$payment_gateway->processCustomAdvance($db, $custom_id, $oid, $post_form);
					}
					else $payment_gateway->processCustom($db, $custom_id, $oid);
						
					if ($payment_gateway->is_error)
					{
						pageHeader("Error Updating Order Payment Status");
						pageNote(array(
							array("icon"=>"ic_error.gif", "text"=>"<b>Error processing transaction. Error message: ".$payment_gateway->error_message."</b>", "url"=>"", "visible"=>true)
						));
					}
					else{
						pageHeader("Order Payment Status Changed");
						pageNote(array(
							array("icon"=>"ic_note.gif", "text"=>"<b>Order payment status has been changed</b>", "url"=>"", "visible"=>true)
						));
?>					
<script language="JavaScript">
	document.location = "admin.php?p=order&oid=<?=$oid?>";
</script>
<?
					}
					pageWhat(array(
						array("text"=>"View Edited Order", "url"=>"admin.php?p=order&oid=".$oid),
						array("text"=>"Browse Orders", "url"=>"admin.php?p=orders")
					));

					break;
				}
				
				/**
			 	 * Insure ship
			 	 */
				case "insureship_cancel" :
				{
					require_once("content/classes/class.insureship.php");
					$insureShip = new InsureShip($settings["InsureShipAccountId"]);
					$insureShip->cancel($_REQUEST["oid"], $db);
					echo '<script type="text/javascript">document.location = "admin.php?p=order&oid='.$oid.'";</script>';
					break;
				}
				
				/**
				 * Update order data
				 */
				case "update" : 
				{
					$order_num = $order_data["order_num"];
					
					$payment_status = isset($payment_status)?trim($payment_status):"";
					$order_status = isset($order_status)?trim($order_status):"";
					$order_editable = isset($order_editable)?trim($order_editable):false;
					$order_editable = $order_editable == "yes" ? true : false;
					$shipping_error_message = "";
					
					if (isset($shipping_tracking_number))
					{
						$db->reset();
						$db->assignStr("shipping_tracking_number", $shipping_tracking_number);
						$db->assignStr("shipping_tracking_number_type", $shipping_tracking_number_type);
						$db->update(DB_PREFIX."orders", "WHERE oid='".$oid."'");
					}
					
					if ($order_editable)
					{
						$prices = isset($prices)?$prices:array();
						$prices = is_array($prices)?$prices:array();
						$quantities = isset($quantities)?$quantities:array();
						$quantities = is_array($quantities)?$quantities:array();
						//update quantity / price
						reset($prices);
						foreach ($prices as $ocid=>$price)
						{
							if (!DEMO_LOCK)
							{
								$db->reset();
								$db->assign("admin_price", round($price, 2));
								$db->assign("admin_quantity", intval($quantities[$ocid]));
								$db->update(DB_PREFIX."orders_content", "WHERE oid='".$oid."' AND ocid='".$ocid."'");
							}
						}
						//change discounts
						$new_discount_value = isset($new_discount_value)?$new_discount_value:"0";
						$new_discount_type = isset($new_discount_type)?trim($new_discount_type):"none";
						$new_discount_value = $new_discount_type == "percent"?$new_discount_value:round($new_discount_value, 2);
						
						$new_promo_discount_value = isset($new_promo_discount_value)?$new_promo_discount_value:"0";
						$new_promo_discount_type = isset($new_promo_discount_type)?trim($new_promo_discount_type):"none";
						$new_promo_discount_value = $new_promo_discount_type == "percent"?$new_promo_discount_value:round($new_promo_discount_value, 2);
						
						//update amounts
						$subtotal_amount = 0;
						$shipping_amount = 0;
						$handling_amount = 0;
						$tax_amount = 0;
						
						$shipping_price_at_product_level = 0;
						$shipping_amount_for_price_based = 0;
						$shipping_amount_for_price_based_exists = false;
						$shipping_weight = 0;
						$shipping_items_count = 0;
						$shipping_price_dollar_days = 0;
						$shipping_digital = 1;
						
						$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."'");
						while ($db->moveNext())
						{
							if ($db->col["digital_product"] == "No")
							{
								$shipping_digital = 0;
							}
							//calc vars for shipping
							if ($db->col["is_dollar_days"] == "Yes")
							{
								$shipping_price_dollar_days = $shipping_price_dollar_days + $db->col["admin_price"] * $db->col["admin_quantity"];
							}
							else
							{
								if ($db->col["is_shipping_price"] == "Yes" && $db->col["free_shipping"] == "No" && $db->col["digital_product"] == "No")
								{
									$shipping_price_at_product_level = $shipping_price_at_product_level + $db->col["shipping_price"] * $db->col["admin_quantity"];
									$order_content_shipping_price[$db->col["ocid"]] = array("is_shipping_price"=>"Yes", "shipping_price"=>$db->col["shipping_price"]);
								}
								if ($db->col["is_shipping_price"] == "No" && $db->col["free_shipping"] == "No" && $db->col["digital_product"] == "No")
								{
									$shipping_items_count = $shipping_items_count + $db->col["admin_quantity"];
									$shipping_weight = $shipping_weight + $db->col["weight"] * $db->col["admin_quantity"];
									$shipping_amount_for_price_based = $shipping_amount_for_price_based + $db->col["admin_price"] * $db->col["admin_quantity"];
									$shipping_amount_for_price_based_exists = true;
								}
							}
							
							//subtotal amount
							$subtotal_amount = $subtotal_amount + ($db->col["admin_price"] * $db->col["admin_quantity"]);
						}
						
						//discount
						if ($new_discount_type == "percent")
						{
							$discount_amount = $subtotal_amount / 100 * $new_discount_value;
						}
						else
						{
							$discount_amount = $new_discount_value;
						}
						$discount_amount = round($discount_amount, 2);
						
						//promo discount
						if ($new_promo_discount_type == "percent")
						{
							$promo_discount_amount = $subtotal_amount / 100 * $new_promo_discount_value;
						}
						else
						{
							$promo_discount_amount = $new_promo_discount_value;
						}
						$promo_discount_amount = round($promo_discount_amount, 2);
						
						//tax
						$dp = 0;
						if ($subtotal_amount > 0)
						{
							if ($new_discount_type == "percent")
							{
								$dp = $dp + $new_discount_value;
							}
							else
							{
								$dp = $dp + $discount_amount / ($subtotal_amount / 100);
							}
							if ($new_promo_discount_type == "percent")
							{
								$dp = $dp + $new_promo_discount_value;
							}
							else
							{
								$dp = $dp + $promo_discount_amount / ($subtotal_amount / 100);
							}
						}
						
						//$db->query("SELECT SUM(quantity * IF(is_taxable='Yes', price / 100 * tax_rate, 0) AS tax_amount FROM ".DB_PREFIX."orders_content WHERE oid='".$this->oid."'");
						$db->query("SELECT SUM(admin_quantity * IF(is_taxable='Yes', (price - price / 100 * ".$dp.") * IF(tax_rate>0, tax_rate, 0), 0)) / 100 AS tax_amount FROM ".DB_PREFIX."orders_content WHERE oid='".$oid."'");
						if ($db->moveNext())
						{
							$tax_amount = $db->col["tax_amount"];
							$tax_amount = $tax_amount > 0 ? $tax_amount : 0.00;
						}
						else
						{
							$tax_amount = 0.00;
						}
						
						//handling amount
						if (!$shipping_digital)
						{
							if ($order_data["handling_fee_type"] == "percent")
							{
								$handling_amount = ($subtotal_amount - $discount_amount - $promo_discount_amount) / 100 * $order_data["handling_fee"];
							}
							else
							{
								$handling_amount = $order_data["handling_fee"];
							}
						}
						else
						{
							$handling_amount = 0;
						}
						$handling_amount = round($handling_amount, 2);
						
						$handling_tax_amount = $order_data["handling_tax_amount"];
						if ($order_data["handling_taxable"] && $order_data["handling_separated"])
						{
							$handling_tax_amount = round($handling_amount / 100 * $order_data["handling_tax_rate"], 2);
							$tax_amount = $tax_amount + $handling_tax_amount;
						}
						
						///////////////////////////////////////////////////
						//calc shipping price
						if ($shipping_price_dollar_days > 0)
						{
							$shipping_amount_dollar_days = $shipping_price_dollar_days / 100 * $dollar_days_shipping_percent;
							if ($shipping_amount_dollar_days < $dollar_days_shipping_min_amount)
							{
								$shipping_amount_dollar_days = 	$dollar_days_shipping_min_amount;
							}
							$shipping_amount_dollar_days = round($shipping_amount_dollar_days, 2);
							
							$product_level_method_used = true;
							$shipping_price_at_product_level = $shipping_price_at_product_level + $shipping_amount_dollar_days;
						}
						
						if ($promo_discount_amount > 0)
						{
							$promo_discount_percent = $new_promo_discount_type == "percent" ? $new_promo_discount_value : $new_promo_discount_value / ($subtotal_amount / 100);
						}
						else
						{
							$promo_discount_percent = 0;
						}
		
						if ($discount_amount > 0)
						{
							$discount_percent = $new_discount_type == "percent" ? $new_discount_value : $new_discount_value / ($subtotal_amount / 100);
						}
						else
						{
							$discount_percent = 0;
						}
						
						if ($shipping_amount_for_price_based_exists)
						{
							$shipping_amount_for_price_based = 
								$shipping_amount_for_price_based - 
								$shipping_amount_for_price_based / 100 * $promo_discount_percent -
								$shipping_amount_for_price_based / 100 * $discount_percent;
						}
						$shipping_amount_for_price_based = round($shipping_amount_for_price_based, 2);
						
						$result_shipping_price = 0.00;
						$shipping_error_message = "";
						if ($order_data["shipping_carrier_id"] == "custom" && $order_data["shipping_method_id"] == "product_level")
						{
							//shipping price already know - price is at product level
							$result_shipping_price = $shipping_price_at_product_level;
						}
						else
						{
							//shipping price is unknown
							////////////////////////////////////////
							//prepare from(origin) shipping address
							$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='".$settings["ShippingOriginCountry"]."'");
							if ($db->moveNext())
							{
								$address_from = array("country" => $db->col["name"], "country_iso_a2" => $db->col["iso_a2"], "country_iso_a3" => $db->col["iso_a3"], "country_iso_number" => $db->col["iso_number"], "zip" => $settings["ShippingOriginCountry"]=="1"?substr(trim($settings["ShippingOriginZip"]), 0, 5):trim($settings["ShippingOriginZip"]));
							}
							else
							{
								$address_from = array("country" => "United States", "country_iso_a2" => "US", "country_iso_a3" => "USA", "country_iso_number" =>"840", "zip" => $settings["ShippingOriginCountry"]=="1"?substr(trim($settings["ShippingOriginZip"]), 0, 5):trim($settings["ShippingOriginZip"]));
							}
							////////////////////////////////////////
							//prepare to(destination) shipping address
							$db->query("
								SELECT ".DB_PREFIX."orders.shipping_country, ".DB_PREFIX."orders.shipping_zip, ".DB_PREFIX."countries.name, ".DB_PREFIX."countries.iso_a2, ".DB_PREFIX."countries.iso_a3, ".DB_PREFIX."countries.iso_number
								FROM ".DB_PREFIX."orders INNER JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."orders.shipping_country
								WHERE oid='".$oid."'
							");
							$db->moveNext();
							$address_to = array("country" => $db->col["name"], "country_iso_a2" => $db->col["iso_a2"], "country_iso_a3" => $db->col["iso_a3"], "country_iso_number" => $db->col["iso_number"], "zip" => $db->col["shipping_country"]=="1"?substr(trim($db->col["shipping_zip"]), 0, 5):trim($db->col["shipping_zip"]));
			
							////////////////////////////////////////
							//try to calc
			
							$shipping_error_message = "";
							$result_shipping_price = getShippingPrice($db, $address_from, $address_to, 
								$shipping_weight, 
								$shipping_items_count,
								$shipping_amount_for_price_based, //price based
								$order_data["shipping_ssid"],
								$shipping_error_message
							) + $shipping_price_at_product_level;
						}
						
						if (!$order_data["handling_separated"])
						{
							$result_shipping_price = $result_shipping_price + $handling_amount;
						}
						
						if ($shipping_error_message != "")
						{
							$result_shipping_price = 0.00;
						}
						
						$result_shipping_price = round($result_shipping_price, 2);
						$shipping_tax_amount = $order_data["shipping_tax_amount"];
						if ($order_data["shipping_taxable"])
						{
							$shipping_tax_amount = round($result_shipping_price / 100 * $order_data["shipping_tax_rate"], 2);
							$tax_amount = $tax_amount + $shipping_tax_amount;
						}
						$shipping_amount = $result_shipping_price;
						
						//calc total
						
						$total_amount = 
							round(
								$subtotal_amount - 
								$discount_amount - 
								$promo_discount_amount + 
								$tax_amount + 
								$shipping_amount + 
								($order_data["handling_separated"]?$handling_amount:0) +
								($order_data["insureship_active"]?$order_data["insureship_amount"]:0),
								2);
						$total_amount = $total_amount > 0 ? $total_amount : 0;
							
						if (!DEMO_LOCK)
						{
							$db->reset();
							$db->assign("subtotal_amount", $subtotal_amount*1);
							$db->assign("discount_amount", $discount_amount*1);
							$db->assign("discount_value", $new_discount_value*1);
							$db->assignStr("discount_type", $new_discount_type);
							$db->assign("promo_discount_amount", $promo_discount_amount*1);
							$db->assign("promo_discount_value", $new_promo_discount_value*1);
							$db->assignStr("promo_discount_type", $new_promo_discount_type);
							$db->assign("subtotal_amount", $subtotal_amount*1);
							$db->assign("handling_tax_amount", $handling_tax_amount*1);
							$db->assign("shipping_tax_amount", $shipping_tax_amount*1);
							$db->assign("tax_amount", $tax_amount*1);
							$db->assign("shipping_amount", $shipping_amount*1);
							$db->assign("handling_amount", $handling_amount*1);
							$db->assign("total_amount", $total_amount*1);
							$db->update(DB_PREFIX."orders", "WHERE oid='".$oid."'");
						}
					}
					//////////////////////
					//update orders status
					if (($order_status != "" || $payment_status != "") && !DEMO_LOCK)
					{
						$db->reset();
						if($order_status != ""){
							$db->assignStr("status", $order_status);
						}
						if($payment_status != ""){
							$db->assignStr("payment_status", $payment_status);
						}
						$db->assign("status_date", "NOW()");
						$db->update(DB_PREFIX."orders", "WHERE oid='".$oid."'");
					}
					
					// *** GIFT CERTIFICATE
					if ($payment_status == "Received" && $order_data["payment_status"] != "Received" )
					{
						require_once("content/engine/engine_notifications.php");
						require_once("content/classes/class.gift_certificates.php");
						require_once("content/admin/admin_init_smarty.php");
						$gift_cert = new GiftCertificates($db);
						$gift_data = $gift_cert->GetGiftCertificate($oid);
						if ($gift_data !== false) {
							// the user has ordered a gift certificate
							$gift_cert->OrderGiftCertificate($gift_data['ocid'], $gift_data['first_name'], $gift_data['last_name'], $gift_data['gift_amount'], $gift_data['voucher']);
							if ($gift_data['email_gift'] == '1')
								$gift_cert->SendNotification($oid);
						}
						if($settings["InventoryStockUpdateAt"]=="Payment Received"){		
							stockControl($db, $oid);
						}
					}

					if ($order_status == "Completed" && $order_data["status"] != "Completed" )
					{
						if (isset($send_notification_email))
						{
							require_once("content/engine/engine_notifications.php");
							require_once("content/admin/admin_init_smarty.php");
							// *** GIFT CERTIFICATE
							view()->assign("payment_method_name", "Gift Certificate");
							view()->assign("gift_cert_amount", $order_data['gift_cert_amount']);
							// *** GIFT CERTIFICATE
							emailOrderCompleted($db, $oid);
						}

						if ($settings["InventoryStockUpdateAt"]=="Order Completed")
						{		
							stockControl($db, $oid);
						}
						
						//Set google server a notification for order status change
						if ($order_data["payment_gateway_id"] == "googlecheckout") 
						{
							require_once("content/engine/payment/payment_".$order_data["payment_gateway_id"].".php");
							eval("\$payment_gateway = new ".strtoupper("PAYMENT_".$order_data["payment_gateway_id"])."();");
							if ($payment_gateway)
							{
								$payment_gateway->getSettingsData($db);
							}
							$post_form["carrier"] = $order_data["shipping_cm_name"];
							$post_form["tracking_id"] = $order_data["shipping_tracking_number"];							
							$payment_gateway->processCustomAdvance($db, 4, $oid, $post_form);
						}
						
						if ($settings["ProductsLocationsSendOption"] == "admin" || ($payment_status == "Received" && $order_data["payment_status"] != "Received"))
						{
							emailProductsLocationsNotify($db, $oid);
						}
					}
					
					$return_to_inventory = true;
					$make_visible = true;
					if(($order_status == "Canceled" && $order_data["status"] != "Canceled") && isset($return_to_inventory)){
						returnToInventory($db, $oid, isset($make_visible));
					}
					
					if(($order_status == "Canceled" && $order_data["status"] != "Canceled") && $order_data["buysafe_wants_bond"] == "true"){
						require_once("content/classes/class.buysafe.php");
						$buysafe = new BuySafeAPI($settings);
						$buysafe->setShoppingCartCancelOrder($oid);
					}
					
					//Send admin note email 
					$send_email =  isset($send_email)?trim($send_email):"No"; 
					$note_text = isset($note_text)?$note_text:""; 
					$note_title = isset($note_title)?$note_title:"";
					$send_email_to = isset($send_email_to)?$send_email_to:"";
					$order_invoice = isset($order_invoice)?$order_invoice:"0";
					if($send_email == "Yes" && $send_email_to != ""){
						require_once("content/engine/engine_notifications.php");
						require_once("content/admin/admin_init_smarty.php");						
						emailToCustomer($db, $oid, $order_invoice, $send_email_to, $note_text, $note_title);
					}
					if(!DEMO_LOCK){
						if($note_text !=""){
							$db->reset();
							$db->assign("oid", $oid);
							$db->assignStr("note_for", "order");
							$db->assignStr("send_email", $send_email);
							$db->assign("created_at", "NOW()");
							$db->assignStr("note_title", $note_title);
							$db->assignStr("note_text", $note_text);							
							$anid = $db->insert(DB_PREFIX."admin_notes");
						}
					}
					
					//End of Send admin note email   								
					//PayPal changes for DoCapture and DoAuthorization	
					$paypal_payment_status = isset($paypal_payment_status)? $paypal_payment_status : "";
					if(strlen(trim($paypal_payment_status))>0){
						require_once("admin_order_paypal.php");
						if(!$paypal_ec->is_error){
							pageHeader("Updating Order Payment Status for PayPal");
							pageNote(array(
							array("icon"=>"ic_hint.gif", "text"=>"<b>PayPal payment status has been successfully updated. </b>", "url"=>"", "visible"=>true)
							));
						}
					}
					
					$datacash_payment_status = isset($datacash_payment_status)? $datacash_payment_status : "";
					if(strlen(trim($datacash_payment_status))>0){
						require_once("admin_order_datacash.php");
						if(!$datacash->is_error){
							pageHeader("Updating Order Payment Status for DataCash");
							pageNote(array(
							array("icon"=>"ic_hint.gif", "text"=>"<b>DataCash payment status has been successfully updated. </b>", "url"=>"", "visible"=>true)
							));
						}
					}					
					
					pageHeader("Order Updated", "", "");
					pageNote(array(
						array("icon"=>"ic_hint.gif", "text"=>"<b>Order has been successfully updated</b>", "url"=>"", "visible"=>true),
						array("icon"=>"ic_error.gif", "text"=>"<b>PLEASE NOTE: UNABLE TO UPDATE SHIPPING COSTS.<br>Shipping Server response Is: ".$shipping_error_message."</b>", "url"=>"", "visible"=>($shipping_error_message != ""))
					));
					pageWhat(array(
						array("text"=>"View Edited Order", "url"=>"admin.php?p=order&oid=".$oid),
						array("text"=>"Browse Orders", "url"=>"admin.php?p=orders")
					));
					break;
				}
				
				//visrtually delete order
				case "delete" : 
				{
					if (!DEMO_LOCK)
					{
						$db->query("UPDATE ".DB_PREFIX."orders SET removed='Yes' WHERE oid='".$oid."'");
					}
					pageHeader("Order Deleted", "", "");
					pageNote(array(
						array("icon"=>"ic_hint.gif", "text"=>"<b>Selected order has been successfully deleted</b>", "url"=>"", "visible"=>true)
					));
					pageWhat(array(
						array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
					));
					break;
				}
				
				//incorrect
				default : 
				{
					pageHeader("Incorrect Action", "", "");
					pageNote(array(
						array("icon"=>"ic_error.gif", "text"=>"<b>Can't apply changes by specified action ID</b>", "url"=>"", "visible"=>true)
					));
					pageWhat(array(
						array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
					));
					break;
				}
			}
		}
		else{
			pageHeader("Incorrect Order ID", "", "");
			pageNote(array(
				array("icon"=>"ic_error.gif", "text"=>"<b>Can't select order by specified ID</b>", "url"=>"", "visible"=>true)
			));
			pageWhat(array(
				array("text"=>"Browse orders", "url"=>"admin.php?p=orders")
			));
		}
	}
?>