<?php
	if (!defined("ENV")) exit();
	
	$stamps_db = null; # don't use $db here to prevent the Stampscom class from accessing in directly
	$stamps = new Stampscom($stamps_db, $settings);

	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : false;
	$stamps_rate_ship_date = isset($_REQUEST["stamps_rate_ship_date"]) ? trim($_REQUEST["stamps_rate_ship_date"]) : "";
	$stamps_rate_weight_lbs = isset($_REQUEST["stamps_rate_weight_lbs"]) ? trim($_REQUEST["stamps_rate_weight_lbs"]) : "";
	$stamps_rate_weight_oz = isset($_REQUEST["stamps_rate_weight_oz"]) ? trim($_REQUEST["stamps_rate_weight_oz"]) : "";
	$stamps_insured_value = isset($_REQUEST["stamps_insured_value"]) ? trim($_REQUEST["stamps_insured_value"]) : "";

	$stamps_supported_addons = array();

	loadJS('order_stamps.js');
?>
<div id="admin-tab-sheet-stamps-label-print" class="admin-tab-sheet <?php echo $last_active_tab == "stamps-label-print" ? "" : "hidden"?>">
	<div class="admin-tab-sheet-wrap">
		<form name="form_stamps_get_rates" id="form_stamps_get_rates" action="admin.php?p=order&amp;oid=<?php echo intval($oid); ?>" method="post">
			<input type="hidden" name="action" value="stamps_get_rates">
			<input type="hidden" name="last_active_tab" value="stamps-label-print">
			<div class="admin-form-header first"><span class="icon ic-icon ic-invoice"></span>Address</div>
			<div style="padding:10px 10px 10px 31px;">
				<strong>Shipping Address &amp; Shipping Method</strong><br>
<?php
	if ($order_data["shipping_digital"])
	{
?>
				There is no shipping information available<br>
				Digital Download
<?php
	}
	else
	{
?>
				<?php echo gs($order_data['shipping_name']); ?> <i>(<?php echo gs($order_data['shipping_address_type']); ?>)</i><br>
				<?php echo(trim($order_data['shipping_company'])!=''?(gs($order_data['shipping_company']).'<br>'):''); ?>
				<?php echo gs($order_data['shipping_address1']).(trim($order_data['shipping_address2'])!=''?gs(', '.$order_data['shipping_address2']):''); ?><br>
				<?php echo gs($order_data['shipping_city'].', '.$order_data['shipping_province'].', '.$order_data['shipping_zip']); ?><br>
				<?php echo gs($order_data['country_name']); ?>
<?php
	}
?>
				<br><br>
				<strong><?php echo gs($order_data['shipping_cm_name']); ?></strong>
			</div>

			<div class="admin-form-header"><span class="icon ic-icon ic-invoice"></span>Get Rates</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption required">Shipping date</td>
					<td class="formItemControl">
						<select name="stamps_rate_ship_date">
<?php
	for ($stamps_tmp_i=0; $stamps_tmp_i<4; ++$stamps_tmp_i)
	{
		$stamps_tmp_ts = mktime(date("H"), date("i"), date("s"), date("n"), date("j") + $stamps_tmp_i, date("Y"));
		$stamps_tmp_date = date('Y-m-d', $stamps_tmp_ts);
		$stamps_tmp_date_viewable = 'Today';

		if ($stamps_tmp_i > 0)
		{
			$stamps_tmp_date_day = $stamps_tmp_i==1 ? 'Tomorrow' : date('D', $stamps_tmp_ts);
			$stamps_tmp_date_viewable = $stamps_tmp_date_day . date(' (m/d)', $stamps_tmp_ts);
		}
?>
							<option value="<?php echo gs($stamps_tmp_date); ?>" <?php echo $stamps_tmp_date == $stamps_rate_ship_date ? "selected" : "";?>><?php echo gs($stamps_tmp_date_viewable); ?></option>
<?php
	}
?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Shipping weight</td>
					<td class="formItemControl">
						<input type="text" name="stamps_rate_weight_lbs" class="short" value="<?php echo $stamps_rate_weight_lbs != '' ? floatval($stamps_rate_weight_lbs) : '';?>">
						<input type="text" name="stamps_rate_weight_oz" class="short" value="<?php echo $stamps_rate_weight_oz != '' ? floatval($stamps_rate_weight_oz) : '';?>"><br>
						<span style="display:inline-block;width:130px;">lbs</span>
						<span style="display:inline-block;width:125px;">oz</span>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required" colspan="2">
						Special services requested for this package
					</td>
				</tr>
				<tr valign="top" id="stamps-insured-value-row">
					<td class="formItemCaption">Insured value</td>
					<td class="formItemControl">
						<input type="text" name="stamps_insured_value" class="short"  value="<?php echo $stamps_insured_value != '' ? floatval($stamps_insured_value) : '';?>">
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input id="button-save" type="submit" value="Get Available Shipping Rates">
				<input type="reset" value="Reset form">
			</div>
		</form>

<?php

	/**
	 * Cancel Label Action
	 */
	if ($action === 'stamps_label_cancel')
	{
		$stamps_label_oid = (isset($stamps_label_oid) && $stamps_label_oid!='') ? $stamps_label_oid : 0;
		$stamps_label_olid = (isset($stamps_label_olid) && $stamps_label_olid!='') ? $stamps_label_olid : 0;
		$stamps_msg_view_labels = '';

		$db->reset();
		$db->query("SELECT oid, olid, url, transaction_id, tracking_number FROM ".DB_PREFIX."orders_labels WHERE oid=".intval($db->escape($stamps_label_oid))." AND olid=".intval($db->escape($stamps_label_olid))." AND type='stampscom'");

		if ($db->moveNext())
		{
			$stamps_cancel_arguments = array('StampsTxID' => $db->col['transaction_id']);

			$stamps_cancel_result = $stamps->apiCall('CancelIndicium', $stamps_cancel_arguments);

			if (isset($stamps_cancel_result['faultcode']))
			{
				$stamps_cancel_msg = "An error occurred when trying to cancel the label";

				if (isset($stamps_cancel_result['faultstring']))
				{
					$stamps_cancel_msg .= ": ".$stamps_cancel_result['faultstring'];
				}
			}
			else
			{
				$db->reset();
				$db->assignStr('status', 'Canceled');
				$db->update(DB_PREFIX."orders_labels","WHERE oid=".intval($stamps_label_oid)." AND olid=".intval($stamps_label_olid)." AND type='stampscom'");
				$stamps_cancel_msg = "Canceled the label successfully";
			}
		}
		else
		{
			$stamps_cancel_msg = "Cannot find label using provided data";
		}

		Admin_Flash::setMessage($stamps_cancel_msg);
	}

	/**
	 * Get Rates Action
	 */
	if ($action === 'stamps_get_rates')
	{
?>
		<div id="dialog_stamps_get_label" style="display:none;">
			<form name="form_stamps_get_label" id="form_stamps_get_label" method="POST" action="admin.php?p=order&oid=<?=$oid;?>">
				<input type="hidden" name="action" value="stamps_get_label">
				<input type="hidden" name="order_editable" value=" <?php echo($order_editable?'yes':'no'); ?>">
				<input type="hidden" name="last_active_tab" value="stamps-label-print">
<?php
		$regions = new Regions($db);

		if ($isBongoOrder)
		{
			$stamps_state = $regions->getStateById($settings['bongocheckout_State']);
			$stamps_country = $regions->getCountryById(1);
			$stamps_rates_address = array(
				'FullName' => $settings['bongocheckout_Attention_To'],
				'Address1' => $settings['bongocheckout_Address1'],
				'Address2' => $settings['bongocheckout_Address2'],
				'City' => $settings['bongocheckout_City'],
				'State' =>  $stamps_state['short_name'],
				'Country' => $stamps_country['iso_a2'],
				'ZIPCode' => $settings['bongocheckout_Zip_Code'],
				'PhoneNumber' => $settings['bongocheckout_Phone']
			);
		}
		else
		{
			$stamps_country = $regions->getCountryById($order_data['shipping_country']);
			$stamps_rates_address = array(
				'FullName' => $order_data['shipping_name'],
				'Address1' => $order_data['shipping_address1'],
				'Address2' => $order_data['shipping_address2'],
				'City' => $order_data['shipping_city'],
				'PhoneNumber' => $user_data['phone'],
				'Country' => $stamps_country['iso_a2']
			);

			// set state data
			if ($order_data['shipping_carrier_id'] == 'usps_international')
			{
				$stamps_rates_address['PostalCode'] = $order_data['shipping_zip'];
				if (isset($order_data['shipping_province']) && $order_data['shipping_province'] != '')
				{
					$stamps_rates_address['Province'] = $order_data['shipping_province'];
				}
			}
			else
			{
				$zipCodeParts = explode('-', trim($order_data['shipping_zip']));
				$stamps_rates_address['ZIPCode'] = substr($zipCodeParts[0], 0, 5);
				if (isset($zipCodeParts[1]) && $zipCodeParts[1] != '')
				{
					$stamps_rates_address['ZIPCodeAddOn'] = substr($zipCodeParts[1], 0, 4);
				}

				$stamps_state = $regions->getStateById($order_data['shipping_state']);
				if ($stamps_state)
				{
					$stamps_rates_address['State'] = $stamps_state['short_name'];
				}
			}
		}

		/**
		 * Clean up address
		 */
		$stamps_address_cleanse_result = $stamps->apiMethodCleanseAddress($stamps_rates_address);

		$stamps_rates_address = $stamps_address_cleanse_result['original'];
		$stamps_cleansed_address = $stamps_address_cleanse_result['cleansed'];

		if (isset($stamps_cleansed_address['Address1']))
		{
			$stamps_rates_address['Address1'] = $stamps_cleansed_address['Address1'];
			$stamps_rates_address['Address2'] = $stamps_cleansed_address['Address2'];
			$stamps_rates_address['City'] = $stamps_cleansed_address['City'];
			$stamps_rates_address['State'] = $stamps_cleansed_address['State'];
			$stamps_rates_address['ZIPCode'] = $stamps_cleansed_address['ZIPCode'];

			if (isset($stamps_cleansed_address['ZIPCodeAddOn']) && $stamps_cleansed_address['ZIPCodeAddOn'] !== '0000')
			{
				$stamps_rates_address['ZIPCodeAddOn'] = $stamps_cleansed_address['ZIPCodeAddOn'];
			}

			if (isset($stamps_cleansed_address['Country']))
			{
				$stamps_rates_address['Country'] = $stamps_cleansed_address['Country'];
			}
		}

		/**
		 * Check weight
		 */
		$stamps_weight = $order_weight;

		if ($settings['LocalizationWeightUnits'] == 'kg')
		{
			$stamps_weight = $stamps_weight * 2.2046226; // 1 kg = 2.2046226 lbs
		}

		if ($stamps_rate_weight_lbs != "" || $stamps_rate_weight_oz != "")
		{
			$stamps_weight_lbs = isset($stamps_rate_weight_lbs) ? floatval($stamps_rate_weight_lbs) : 0;
			$stamps_weight_oz = isset($stamps_rate_weight_oz) ? floatval($stamps_rate_weight_oz) : 0;
		}
		else
		{
			$stamps_weight_lbs = 0;
			$stamps_weight_oz = sprintf('%0.2f', (16.00 * $stamps_weight)); // only allows precision of hundreths of an ounce
		}

		$stamps_get_rates_arguments = array(
			'Rate' => array(
				'ShipDate' => $stamps_rate_ship_date,
				'FromZIPCode' => $settings['ShippingOriginZip'],
				'ToZIPCode' => $stamps_rates_address['ZIPCode'],
				'WeightLb' => $stamps_weight_lbs,
				'WeightOz' => $stamps_weight_oz,
				'FromCountry' => 'US',
				'ToCountry' => $stamps_rates_address['Country']
			)
		);

		if ($stamps_insured_value != "")
		{
			$stamps_get_rates_arguments['Rate']['InsuredValue'] = floatval($stamps_insured_value);
		}

		//TODO: Check is this statement correct - it does not use discounts
		$db->query("SELECT SUM(price*quantity) as total_value FROM ".DB_PREFIX."orders_content WHERE oid=".intval($oid));
		if ($db->moveNext())
		{
			$stamps_get_rates_arguments['Rate']['DeclaredValue'] = $db->col['total_value'];
		}

		// call the GetRates Stamps.com API method
		$stamps_get_rates_result = $stamps->apiMethodGetRates($stamps_get_rates_arguments);

		if ($stamps_get_rates_result && isset($stamps_get_rates_result['Rates']))
		{
			$stamps_rates = $stamps_get_rates_result['Rates'];

			if (isset($stamps_rates['Rate'])) $stamps_rates = $stamps_rates['Rate'];
			if (!isset($stamps_rates[0])) $stamps_rates = array($stamps_rates);

			$stamps_rates_service_type_names = array(
				'US-XM' => 'USPS Express Mail',
				'US-FC' => 'USPS First Class Mail',
				'US-PM' => 'USPS Priority Mail',
				'US-PP' => 'USPS Parcel Post',
				'US-MM' => 'USPS Media Mail',
				#'US-BPM' => 'USPS BPM',
				#'US-LM' => 'USPS Library',
				'US-EMI' => 'USPS Express Mail International',
				'US-PMI' => 'USPS Priority Mail International',
				'US-FCI' => 'USPS First Class Mail International',
			);

			$stamps_rates_options = array();
			$stamps_rates_add_ons_costs = array();
			$stamps_rates_array = array();

			$stamps_available_add_ons = array(
				'US-A-DC' => 'USPS Tracking',
				'US-A-SC' => 'USPS Signature Confirmation',
				'US-A-INS' => 'USPS Insurance',
				'SC-A-INS' => 'Stamps.com Insurance',
				'US-A-CM' => 'USPS Certified Mail',
				'US-A-RD' => 'USPS Restricted Delivery',// (delivery to specifically named person only)',
				'US-A-NDW' => 'Express Mail item cannot be delivered on Saturdays',
				'US-A-RR' => 'USPS Return Receipt Requested',
				'SC-A-HP' => 'Generate label with Hidden Postage'
			);

			foreach ($stamps_rates as $stamps_rate_id => $stamps_rate)
			{
				// skip some rates
				if ($stamps_rate['ServiceType'] == 'US-PM' || $stamps_rate['ServiceType'] == 'US-XM' || $stamps_rate['ServiceType'] == 'US-FC')
				{
					if ($stamps_rate['PackageType'] == 'Letter' || $stamps_rate['PackageType'] == 'Postcard')
					{
						continue;
					}
				}

				$stamps_rates_array[$stamps_rate_id] = serialize($stamps_rate);

				$stamps_service_type = $stamps_rate['ServiceType'];
				$stamps_service_name =
					(isset($stamps_rates_service_type_names[$stamps_service_type]) ? $stamps_rates_service_type_names[$stamps_service_type] : $stamps_service_type).': '.
					$stamps_rate['PackageType'].($stamps_rate['Amount'] > 0 ? ' ($'.sprintf('%.2f',$stamps_rate['Amount']).')' : '');

				$stamps_rates_options[$stamps_rate_id] = array(
					'name' => $stamps_service_name,
					'type' => $stamps_service_type,
					'addons' => array()
				);

				if (isset($stamps_rate['AddOns']) && isset($stamps_rate['AddOns']['AddOnV2']) && is_array($stamps_rate['AddOns']['AddOnV2']))
				{
					$stamps_rate_add_ons = $stamps_rate['AddOns']['AddOnV2'];
					$stamps_rate_add_ons = isset($stamps_rate_add_ons[0]) ? $stamps_rate_add_ons : array($stamps_rate_add_ons);

					foreach ($stamps_rate_add_ons as $stamps_rate_add_on)
					{
						if (isset($stamps_rate_add_on['AddOnType']))
						{
							$stamps_rate_add_on_type = $stamps_rate_add_on['AddOnType'];

							if (array_key_exists($stamps_rate_add_on_type, $stamps_available_add_ons))
							{
								if (isset($stamps_rate_add_on['RequiresAllOf']['RequiresOneOf']['AddOnTypeV2']))
								{
									$requires = $stamps_rate_add_on['RequiresAllOf']['RequiresOneOf']['AddOnTypeV2'];
									$requires = isset($requires[0]) ? $requires : array($requires);
								}
								else
								{
									$requires = array();
								}

								if (isset($stamps_rate_add_on['ProhibitedWithAnyOf']['AddOnTypeV2']))
								{
									$prohibited = $stamps_rate_add_on['ProhibitedWithAnyOf']['AddOnTypeV2'];
									$prohibited = isset($prohibited[0]) ? $prohibited : array($prohibited);
								}
								else
								{
									$prohibited = array();
								}

								$stamps_rates_options[$stamps_rate_id]['addons'][$stamps_rate_add_on_type] = array(
									'code' => $stamps_rate_add_on_type,
									'name' => $stamps_available_add_ons[$stamps_rate_add_on_type],
									'amount' => isset($stamps_rate_add_on['Amount']) ? $stamps_rate_add_on['Amount'] : 0,
									'requires' => $requires,
									'prohibited' => $prohibited
								);
							}
						}
					}
				}
			}

			$_SESSION["stamps_rates_array"] = $stamps_rates_array;
			$_SESSION["stamps_rates_address"] = $stamps_rates_address;
?>
				<script type="text/javascript"><!--
					var stampsRates = <?php echo json_encode($stamps_rates_options); ?>;
				--></script>

				<table cellpadding="0" cellspacing="0" border="0" width="100%" style="margin-top:10px;">
					<tr valign="top">
						<td class="formItemCaption required">Shipping rate</td>
						<td class="formItemControl">
							<select name="stamps_rate_id" id="stamps_rate_select" class="large">
<?php		foreach ($stamps_rates_options as $stamps_rate_id => $stamps_rates_option) { ?>
								<option value="<?php echo gs($stamps_rate_id);?>"><?php echo gs($stamps_rates_option['name']);?></option>
<?php		} ?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Additional services</td>
						<td class="formItemControl">
							<div id="stamps-available-addons"></div>
						</td>
					</tr>
				</table>

				<input type="hidden" name="stamps_rates_address" value="<?php echo gs(serialize($stamps_rates_address)); ?>">
				<input type="hidden" name="stamps_label_unique_id" value="<?php echo gs('order-'.$oid.'-'.uniqid()); ?>">
				<input type="hidden" name="stamps_test_mode" value="<?php echo $settings['StampscomTestMode']; ?>">

				<input type="hidden" name="stamps_rate_ship_date" value="<?php echo gs($stamps_rate_ship_date);?>">
				<input type="hidden" name="stamps_rate_weight_lbs" value="<?php echo gs($stamps_rate_weight_lbs);?>">
				<input type="hidden" name="stamps_rate_weight_oz" value="<?php echo gs($stamps_rate_weight_oz);?>">
				<input type="hidden" name="stamps_insured_value" value="<?php echo gs($stamps_insured_value);?>">
			</form>
		</div>
<?php
		}
	}

	/**
 	 * Get Label Action
 	 */
	if ($action === 'stamps_get_label')
	{
		$stamps_label_url = false;
		$stamps_rate_id = isset($_REQUEST["stamps_rate_id"]) ? $_REQUEST["stamps_rate_id"] : false;
		$stamps_label_unique_id = isset($_REQUEST['stamps_label_unique_id']) ? $_REQUEST['stamps_label_unique_id'] : 'order-'.$oid.'-'.uniqid();

		$stamps_rates = isset($_SESSION["stamps_rates_array"]) ? is_array($_SESSION["stamps_rates_array"]) ? $_SESSION["stamps_rates_array"] : false : false;
		$stamps_rates_address = isset($_SESSION["stamps_rates_address"]) ? is_array($_SESSION["stamps_rates_address"]) ? $_SESSION["stamps_rates_address"] : false : false;

		unset($_SESSION["stamps_rates_array"]);
		unset($_SESSION["stamps_rates_address"]);

		if ($stamps_rate_id && $stamps_rates && isset($stamps_rates[$stamps_rate_id]))
		{
			$stampsErrorMessage = '';

			$stamps_rate = unserialize($stamps_rates[$stamps_rate_id]);

			$stamps_get_label_arguments = array();
			$stamps_get_label_arguments['IntegratorTxID'] = $stamps_label_unique_id; // we use this to ensure the user does not try to create duplicate labels
			//$stamps_get_label_arguments['TrackingNumber'] = '';
			$stamps_get_label_arguments['Rate'] = $stamps_rate;
			$stamps_get_label_arguments_rate_add_ons = array();

			/**
			 * Check and filter selected add-ons
			 */
			$stamps_rate_add_ons = isset($_REQUEST["stamps_rate_addons"]) ? is_array($_REQUEST["stamps_rate_addons"]) ? $_REQUEST["stamps_rate_addons"] : array() : array();

			if (isset($stamps_rate_add_ons['confirmation']) && $stamps_rate_add_ons['confirmation'] === '_NONE')
			{
				unset($stamps_rate_add_ons['confirmation']);
			}

			if (isset($stamps_rate_add_ons['insurance']) && $stamps_rate_add_ons['insurance'] === '_NONE')
			{
				unset($stamps_rate_add_ons['insurance']);
			}

			if (isset($stamps_get_label_arguments['Rate']['AddOns']['AddOnV2']))
			{
				if (isset($stamps_get_label_arguments['Rate']['AddOns']['AddOnV2']) && is_array($stamps_get_label_arguments['Rate']['AddOns']['AddOnV2']))
				{
					if (is_array($stamps_rate_add_ons) && !empty($stamps_rate_add_ons))
					{
						foreach ($stamps_get_label_arguments['Rate']['AddOns']['AddOnV2'] as $v)
						{
							foreach ($stamps_rate_add_ons as $stamps_rate_add_on)
							{
								if ($v['AddOnType'] == $stamps_rate_add_on)
								{
									$stamps_get_label_arguments_rate_add_ons[$v['AddOnType']] = 1;
								}
							}
						}
					}
				}

				unset($stamps_get_label_arguments['Rate']['AddOns']);
			}

			$stamps_get_label_arguments['Rate']['AddOns'] = array( 'AddOnV2' => array() );
			foreach ($stamps_get_label_arguments_rate_add_ons as $k=>$v)
			{
				$stamps_get_label_arguments['Rate']['AddOns']['AddOnV2'][] = array('AddOnType'=>$k);
			}

			/**
			 * Get from addresses
			 */
			$stamps_get_label_arguments_from_state = $settings['ShippingOriginProvince'];

			$db->query('SELECT short_name FROM '.DB_PREFIX.'states WHERE coid='.intval($settings['ShippingOriginCountry']).' AND stid='.intval($settings['ShippingOriginState']));

			if ($db->moveNext())
			{
				$stamps_get_label_arguments_from_state = $db->col['short_name'];
			}

			$stamps_get_label_arguments['From'] = array();
			$stamps_get_label_arguments['From']['FullName'] = $settings['ShippingOriginName'];
			$stamps_get_label_arguments['From']['Address1'] = $settings['ShippingOriginAddressLine1'];

			if (strlen($settings['ShippingOriginAddressLine2']))
			{
				$stamps_get_label_arguments['From']['Address2'] = $settings['ShippingOriginAddressLine2'];
			}

			$stamps_get_label_arguments['From']['City'] = $settings['ShippingOriginCity'];
			$stamps_get_label_arguments['From']['State'] = $stamps_get_label_arguments_from_state;
			$stamps_get_label_arguments['From']['ZIPCode'] = $settings['ShippingOriginZip'];
			$stamps_get_label_arguments['From']['PhoneNumber'] = preg_replace("/[^0-9]/","", $settings['ShippingOriginPhone']);

			$stamps_get_label_arguments_to_keys = array(
				'FullName', 'NamePrefix', 'FirstName', 'MiddleName', 'LastName',
				'NameSuffix', 'Title', 'Department', 'Company',
				'Address1', 'Address2', 'Address3',
				'City', 'Country', 'PhoneNumber', 'Extension',
			);

			if ($order_data['shipping_carrier_id'] == 'usps_international')
			{
				$stamps_get_label_arguments_to_keys[] = 'Province';
				$stamps_get_label_arguments_to_keys[] = 'PostalCode';
				$stamps_get_label_arguments_to_keys[] = 'Urbanization';
			}
			else
			{
				$stamps_get_label_arguments_to_keys[] = 'State';
				$stamps_get_label_arguments_to_keys[] = 'ZIPCode';
				$stamps_get_label_arguments_to_keys[] = 'ZIPCodeAddOn';
				$stamps_get_label_arguments_to_keys[] = 'CheckDigit';
				$stamps_get_label_arguments_to_keys[] = 'DPB';
			}

			$stamps_get_label_arguments['To'] = array();
			foreach ($stamps_get_label_arguments_to_keys as $k)
			{
				if (array_key_exists($k, $stamps_rates_address))
				{
					$stamps_get_label_arguments['To'][$k] = $stamps_rates_address[$k];
				}
				else
				{
					$stamps_get_label_arguments['To'][$k] = '';
				}
			}

			if (isset($stamps_rates_address['OverrideHash']))
			{
				$stamps_get_label_arguments['To']['OverrideHash'] = $stamps_rates_address['OverrideHash'];
			}

			if ($order_data['shipping_carrier_id'] == 'usps_international')
			{
				$stamps_get_label_arguments_customs = array('ContentType' => 'Other', 'OtherDescribe' => 'Hardgoods', 'CustomsLines' => array('CustomsLine' => array()) );
				$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid=".intval($oid)." ORDER BY product_id");

				# most international methods only allow a maximum of 5 CustomsLines
				while (5 > count($stamps_get_label_arguments_customs['CustomsLines']['CustomsLine']) && $db->moveNext())
				{
					$stamps_get_label_weight = $db->col['weight'];
					if ($settings['LocalizationWeightUnits'] == 'kg')
					{
						$stamps_get_label_weight = $stamps_tmp_weight * 2.2046226; // 1 kg = 2.2046226 lbs
					}

					$stamps_get_label_argument_weight_oz = sprintf('%0.2f',(16.00 * $stamps_get_label_weight));

					$stamps_get_label_arguments_customs['CustomsLines']['CustomsLine'][] = array(
						'Description' => $db->col['title'],
						'Quantity' => $db->col['quantity'],
						'Value' => $db->col['price'],
						'WeightOz' => $stamps_get_label_argument_weight_oz,
					);
				}

				$stamps_get_label_arguments['Customs'] = $stamps_get_label_arguments_customs;
			}

			$stamps_get_label_arguments['SampleOnly'] = false;

			if (preg_match('/^US-(?:EM|PM|FC)I$/', $stamps_get_label_arguments['Rate']['ServiceType']))
			{
				$stamps_get_label_arguments['ImageType'] = 'Pdf';
			}
			else
			{
				$stamps_get_label_arguments['ImageType'] = 'Png';
			}

			$stamps_label_olid = 0;

			$db->query("SELECT unique_id FROM ".DB_PREFIX."orders_labels WHERE oid=".intval($oid)." AND unique_id='".$db->escape($stamps_label_unique_id)."'");

			if (!strlen($stamps_label_unique_id))
			{
				$stampsErrorMessage = 'There was an error generating a unique ID for this label. Please try again.';
			}
			elseif ($db->moveNext())
			{
				$stampsErrorMessage = 'You have already tried to generate this label.  Please check for the label on the "View Stamps.com Shipping Labels for this Order" tab or try again.';
			}
			else
			{
				if ($settings['StampscomTestMode'] == 'Yes' && 1>2)
				{
					$stamps_get_label_result = $stamps->apiCall('CreateTestIndicium', $stamps_get_label_arguments);
				}
				else
				{
					$stamps_get_label_result = $stamps->apiCall('CreateIndicium', $stamps_get_label_arguments);
				}

				$db->reset();
				$db->assignStr('oid', $oid);
				$db->assignStr('unique_id', $stamps_label_unique_id);
				$db->assignStr('type', 'stampscom');
				$db->assign('date_created', 'NOW()');

				$db->assignStr('shipping_date', $stamps_rate_ship_date);
				$db->assignStr('shipping_weight', $stamps_rate_weight_lbs + ($stamps_rate_weight_oz / 16));
				$db->assignStr('shipping_insurance', $stamps_insured_value);
				$db->assignStr('data', serialize($stamps_get_label_result));

				if (isset($stamps_get_label_result['faultcode']))
				{
					$stampsErrorMessage = 'There was an error generating the label. ';
					$db->assignStr('status', 'Failed');

					if ( !($stampscom_tmp_olid=$db->insert(DB_PREFIX."orders_labels")))
					{
						$stampsErrorMessage .= 'Additionally, there was an error updating the label entry database. ';
					}

					if (isset($stamps_get_label_result['faultstring']))
					{
						$stampsErrorMessage .= 'Message: '.$stamps_get_label_result['faultstring'];
					}
				}
				elseif (isset($stamps_get_label_result['URL']))
				{
					$stamps_label_url = $stamps_get_label_result['URL'];
					$db->assignStr('status', 'Created');
					$db->assignStr('url', $stamps_label_url);
					$db->assignStr('shipping_service_type', $stamps_get_label_result['Rate']['ServiceType']);
					$db->assignStr('shipping_package_type', $stamps_get_label_result['Rate']['PackageType']);

					if (isset($stamps_get_label_result['StampsTxID']))
					{
						$db->assignStr('transaction_id', $stamps_get_label_result['StampsTxID']);
					}

					if (isset($stamps_get_label_result['TrackingNumber']))
					{
						$db->assignStr('tracking_number', $stamps_get_label_result['TrackingNumber']);
					}

					if (!($stamps_label_olid = $db->insert(DB_PREFIX."orders_labels")))
					{
						$stampsErrorMessage = 'There was an error updating the labels database';
					}
					else
					{
						if ($settings['StampscomTestMode'] == 'Yes')
						{
							Admin_Flash::setMessage('Your test label was successfully created');
						}
						else
						{
							Admin_Flash::setMessage('Your label was successfully purchased and generated');
						}
					}
				}
			}

			if ($stampsErrorMessage)
			{
				Admin_Flash::setMessage($stampsErrorMessage, Admin_Flash::TYPE_ERROR);
			}

			if ($stamps_label_olid > 0 && $stamps_label_url)
			{
?>
			<div id="dialog_stamps_label_result" style="display:none;">
				<div id="dialog_stamps_label_result_preview" style="overflow:auto;">
					<img src="<?php echo $stamps_label_url;?>" style="display:none;">
				</div>
			</div>
<?php
			}
		}
	}
?>
	</div>
</div>

<div id="admin-tab-sheet-stamps-label-view" class="admin-tab-sheet" style="display:none;">
	<div class="admin-tab-sheet-wrap">
		<div class="admin-form-header first">
			<span class="icon ic-icon ic-truck"></span>Current Shipping Labels for this Order
		</div>
<?php

	$db->reset();
	$db->query("SELECT oid, olid, status, url, transaction_id, tracking_number, data FROM ".DB_PREFIX."orders_labels WHERE oid=".intval($oid)." AND type='stampscom' ORDER BY olid");

	if ($db->numRows() > 0)
	{
?>
		<table class="admin-list-table" width="100%" cellpadding="0" cellspacing="0" border="0">
			<thead>
				<tr>
					<th class="icon"></th>
					<th>Tracking Number</th>
					<th>Status</th>
					<th style="width:250px;"></th>
				</tr>
			</thead>
			<tbody>
<?php
		while ($db->moveNext())
		{
			$stamps_data = array();
			$stamps_expired = true;

			if ($db->col['data'] != '')
			{
				$stamps_expired = false;
				$stamps_data = @unserialize($db->col['data']);

				if (!is_array($stamps_data))
				{
					$stamps_data = array();
				}

				if (isset($stamps_data['Rate']) && is_array($stamps_data['Rate']) && isset($stamps_data['Rate']['ShipDate']))
				{
					$stamps_expired = true;
					$stamps_ship_date = $stamps_data['Rate']['ShipDate'];
					$stamps_ts_ship_date = strtotime($stamps_ship_date);
					$stamps_ts_current_date = mktime(0, 0, 0);

					if ($stamps_ts_ship_date >= $stamps_ts_current_date)
					{
						$stamps_expired = false;
					}
				}
			}

			echo '<tr>';
			echo '<td class="icon"></td>';
			echo '<td>'.(trim($db->col['tracking_number']) != '' ? gs($db->col['tracking_number']) : 'n/a').' - <a href="javascript:return false;" class="stamps-label-track" rel="stampscom-label-'.gs($oid.'-'.$db->col['olid']).'">Track</a></td>';
			echo '<td>'.gs($db->col['status'] . ($stamps_expired?' / Expired':'')).'</td>';
			echo '<td>';

			if (!$stamps_expired && $db->col['status'] != 'Failed')
			{
				echo '<a href="admin.php?p=order_stampscom_ajax&printing&action=label_view_iframe&oid='.$oid.'&olid='.$db->col['olid'].'" class="stamps-label-view">View / Print</a>';
			}

			if (!$stamps_expired && $db->col['status'] == 'Created')
			{
				echo ' | <a onclick="cancelStampsLabel(\''.intval($oid).'\', \''.intval($db->col['olid']).'\');" href="javascript:return false;">Cancel</a>';
			}

			echo '</td>';
			echo '</tr>';

		}
?>
			</tbody>
		</table>
<?php
	}
	else
	{
?>
		<div>There are no labels generated for this order</div>
<?php
	}
?>
	</div>
</div>

<div id="dialog-stampscom-view" style="display:none;">
	<div>
		<iframe id="iframe-stampscom-view-label" name="iframe-stampscom-view-label" src="" scrolling="no" style="overflow:hidden;border:none;width:100%;height:580px"></iframe>
	</div>
</div>

<div id="dialog-stampscom-track" style="display:none;">
	<div>
		<iframe id="iframe-stampscom-track" name="iframe-stampscom-track" src="" scrolling="no" style="overflow:hidden;border:none;width:100%;"></iframe>
	</div>
</div>
