<?php
	if (!defined("ENV")) exit();
	
	loadJS("orders.js");
	loadJS("cd_order.js");

	//check variable
	$uid = isset($uid)?$uid*1:0;
	$action = isset($action)?trim($action):"search";
	$order_num = isset($order_num)?intval($order_num):0;
	
	$lname = isset($lname)?trim($lname):"";
	$status = isset($status)?$status:"Process";
	$payment_status = isset($payment_status)?$payment_status:"any";
	$period = isset($period)?$period*1:0;
	
	/////////////////////////////////////////
	//prepare select orders
	$where = ($status!="Abandon"?"(".DB_PREFIX."orders.status <> 'Abandon' AND ".DB_PREFIX."orders.status <> 'New') AND ":"")." (".DB_PREFIX."orders.removed='No')";
	
	//check user id
	$is_user = false;
	$show_orders = false;
	if($uid > 0){
		$db->query("SELECT * FROM ".DB_PREFIX."users WHERE uid='".$uid."'");
		if($db->moveNext()){
			$is_user = true;
			$user_name = $db->col["fname"]." ".$db->col["lname"];
			$where .= " AND (".DB_PREFIX."orders.uid='".$uid."')";
			$show_orders = true;
		}
	}
	/////////////////////////////////////////////////
	//if user id is not set, try to use fileters data
	if(!$is_user && $action == "search"){
		$show_orders = true;
		if($order_num > 0){
			$where .= " AND (".DB_PREFIX."orders.order_num = '".$order_num."')";
		}
		if($lname != ""){
			$where .= " AND (".DB_PREFIX."users.lname LIKE '%".$db->escape($lname)."%')";
		}
		if($status != "any"){
			$where .= " AND (".DB_PREFIX."orders.status='".$status."')";
		}
		if($payment_status != "any"){
			$where .= " AND (".DB_PREFIX."orders.payment_status='".$payment_status."')";
		}
		if($period != 0){
			$where .= " AND (DATE_ADD(".DB_PREFIX."orders.status_date, INTERVAL ".$period." HOUR) >= NOW())";
		}
	}
	
	////////////////////////////
	//and finally, select orders
	pageHeader("Orders", $is_user?("user: ".gs($user_name)):"", "ic_order.gif");
	if(!$is_user){
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>Please enter in your search criteria.</b><br>You need to enter at least one search criteria for search to be effective", "url"=>"", "visible"=>true)
		));
	}
	else{
		echo "&nbsp;";
	}
	/////////////////////////////////////////////////
	//show search form if here no user selected by id
	if(!$is_user){
?>

<div class="searchFormTitle">Search Orders</div>
<form action="admin.php?p=orders" method="GET" style="padding:0px;margin:0px;">
	<input type="hidden" name="p" value="orders">
	<input type="hidden" name="action" value="search">
	
<div class="searchFormBody">
	<div class="searchFormLine">
		<div class="searchFormItem">
			Order ID:<br/>
			<input type="text" name="order_num" style="width:210px;" value="<?=$order_num > 0 ? htmlspecialchars($order_num) : ""?>"/>
		</div>
		<div class="searchFormItem">
			Order status :<br>
			<select style="width:210px;" name="status">
				<option value="any">Any</option>
				<option value="Process" <?=$status=="Process"?"selected":""?>>Process</option>
				<option value="Backorder" <?=$status=="Backorder"?"selected":""?>>Backorder</option>
				<option value="Canceled" <?=$status=="Canceled"?"selected":""?>>Cancelled</option>
				<option value="Completed" <?=$status=="Completed"?"selected":""?>>Completed</option>
				<option value="Failed" <?=$status=="Failed"?"selected":""?>>Failed</option>
				<option value="Abandon" <?=$status=="Abandon"?"selected":""?>>Abandoned</option>
			</select>
		</div>
	</div>
	<div class="searchFormLine">
		<div class="searchFormItem">
			Customer's Last Name:<br/>
			<input type="text" name="lname" style="width:210px;" value="<?=htmlspecialchars($lname)?>"/>
		</div>
		<div class="searchFormItem">
			Order payment status :<br>
			<select style="width:210px;" name="payment_status">
				<option value="any">Any</option>
				<option value="Pending" <?=$payment_status=="Pending"?"selected":""?>>Pending</option>
				<option value="Partial" <?=$payment_status=="Partial"?"selected":""?>>Partial</option>
				<option value="Received" <?=$payment_status=="Received"?"selected":""?>>Received</option>
				<option value="Refunded" <?=$payment_status=="Refunded"?"selected":""?>>Refunded</option>
				<option value="Declined" <?=$payment_status=="Declined"?"selected":""?>>Declined</option>
				<option value="Canceled" <?=$payment_status=="Canceled"?"selected":""?>>Canceled</option>
				<option value="Error" <?=$payment_status=="Error"?"selected":""?>>Error</option>
			</select>
		</div>
	</div>
	<div class="searchFormLine">
		<div class="searchFormItem">
			Order period :<br>
			<select name="period" style="width:210px;">
				<option value="any">Any</option>
				<option value="24" <?=$period=="24"?"selected":""?>>Last 24 hours</option>
				<option value="72" <?=$period=="72"?"selected":""?>>Last 3 days</option>
				<option value="168" <?=$period=="168"?"selected":""?>>Last week</option>
				<option value="336" <?=$period=="336"?"selected":""?>>Last 2 weeks</option>
				<option value="744" <?=$period=="744"?"selected":""?>>Last month</option>
			</select>
		</div>
		<div class="searchFormItem">
			&nbsp;
		</div>
	</div>
	<div class="searchFormBottom">
		<div class="searchFormItem">
			<input type="submit" value="Search" style="width:120px;height:25px;"/>
		</div>
		<div class="searchFormItem">
			<a href="admin.php?p=orders">Reset Search</a>
		</div>
	</div>
</div>
</form>

<?	}//end if "is_user"

	if($show_orders){
		$db->query("
			SELECT ".DB_PREFIX."orders.oid, ".DB_PREFIX."users.uid
			FROM ".DB_PREFIX."orders 
			LEFT JOIN ".DB_PREFIX."users ON ".DB_PREFIX."users.uid=".DB_PREFIX."orders.uid
			WHERE ".$where."
			ORDER BY ".DB_PREFIX."orders.oid DESC
		");
		$ccc = 20;
		$items_count = $db->numRows();
		$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
		$pg = isset($pg)?($pg*1):1;
		$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
		if($is_user){
			$pages_line = format_pages_line(
				$pg, // current pare
				$pages_count, // total pages
				7, 
				"admin.php?p=orders&uid=".$uid					
			);
		}
		else{
			$pages_line = format_pages_line(
				$pg, // current pare
				$pages_count, // total pages
				7, 
				"admin.php?p=orders".
					"&action=search".
					"&order_num=".urlencode($order_num).
					"&lname=".urlencode($lname).
					"&status=".urlencode($status).
					"&payment_status=".$payment_status.
					"&period=".$period
			);
		}
		$db->query("
			SELECT ".DB_PREFIX."orders.*, ".DB_PREFIX."users.*, DATE_FORMAT(status_date, '".$settings["LocalizationDateTimeFormat"]."') AS sd 
			FROM ".DB_PREFIX."orders 
			LEFT JOIN ".DB_PREFIX."users ON ".DB_PREFIX."users.uid=".DB_PREFIX."orders.uid
			WHERE ".$where."
			ORDER BY ".DB_PREFIX."orders.oid DESC
			LIMIT ".(($pg-1)* $ccc).", ".$ccc."
		");
?>


<div class="listHeader">
	<div class="listHeaderIcon"><img src="images/icons/ic_search.gif"/></div>
	<div class="listHeaderCaption">
		Orders Search Results
	</div>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Orders found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:70px;"><?=$status=="Abandon"?"Abandon":"Order"?> ID</div>
	<div class="listHeaderCaption" style="width:140px;">Customer's Name</div>
	<div class="listHeaderCaption" style="width:170px;">Last Update</div>
	<div class="listHeaderCaption" style="width:80px;">Status</div>
	<div class="listHeaderCaption" style="width:80px;">Payment</div>
	<div class="listHeaderCaption" style="width:110px;">Amount</div>
</div>
	
<form name="frmOrders" action="" onSubmit="return false;" style="margin:0px;padding:0px;">
<?php	if($db->numRows()>0){
			$uid = "";
			while($db->moveNext()){
?>
	
<div class="listItem">
	<div class="listItemIcon" style="padding-top:2px;">
		<input type="checkbox" name="order_<?=$db->col["oid"]?>">
		<input type="hidden" name="order_<?=$db->col["oid"]?>_hidden" value="<?=$db->col["oid"]?>">
	</div>
	<div class="listItemText" style="width:70px;">
		<a href="admin.php?p=order&oid=<?=$db->col["oid"]?>">
<?				if($db->col["status"]=="Abandon"){?>
					A<?=$db->col[$status!="Abandon"?"order_num":"oid"]?>
<?				}
				else{
					echo $db->col["order_num"];
					if(isset($first_A))	echo " / A".$db->col["oid"];
				}
?>
		</a>
	</div>
	<div class="listItemText" style="width:140px;"><a href="admin.php?p=order&oid=<?=$db->col["oid"]?>"><?=htmlspecialchars($db->col["fname"]." ".$db->col["lname"])?></a></div>
	<div class="listItemText" style="width:170px;"><?=$db->col["sd"]?></div>
	<div class="listItemText" style="width:80px;"><?=$db->col["status"]?></div>
	<div class="listItemText" style="width:80px;"><?=$db->col["payment_status"]?></div>
	<div class="listItemText" style="width:110px;"><?=($db->col["total_amount"] - $db->col['gift_cert_amount'])?></div>
	<div class="listItemButtons">
		<a href="admin.php?p=order&oid=<?=$db->col["oid"]?>"><img title="Order Details" src="images/icons/ic_change_text.gif" border="0"></a>
		<a href="admin.php?p=order_invoice&orders=<?=$db->col["oid"]?>&printing" target="_print"><img title="Print Invoice" src="images/icons/ic_print.gif" border="0"></a>
<? 				if ($db->col["shipping_carrier_id"]=="usps_domestic" || $db->col["shipping_carrier_id"]=="usps_international"){ ?>
		<a href="admin.php?p=shipping_label_usps&oid=<?=$db->col["oid"]?>" target="_new"><img title="Print Label" src="images/icons/ic_printer.gif" border="0"></a>
<? 				}?>	
		<a href="JavaScript:ConfirmDeleteOrder(<?=$db->col["oid"]?>)"><img title="Delete Order" src="images/icons/ic_delete.gif" border="0"></a>
	</div>
</div>
<?			}?>
<div class="listItem">
	<div class="listItemIcon" style="padding-left:3px;padding-top:3px;">
		<img src="images/icons/ic_arrow_topa.gif">
	</div>
	<div class="listItemText">
		<a href="javascript:checkBoxes('check')">check all</a> | 
		<a href="javascript:checkBoxes('uncheck')">uncheck all</a>
	</div>
</div>
</form>
<form name="frmOrdersStatus" onSubmit="return false;" style="margin:0px;padding:0px;">
<div style="clear:both;">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formItemCaption">Set New Order Status</td>
		<td class="formItemControl">
			<select name="order_status" style="width:123px;">
				<option value="">Keep current</option>
				<option value="Process">Process</option>
				<option value="Backorder">Backorder</option>
				<option value="Canceled">Canceled</option>
				<option value="Completed">Completed</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Set New Payment Status</td>
		<td class="formItemControl">
			<select name="payment_status" style="width:123px;">
				<option value="">Keep current</option>
				<option value="Pending">Pending</option>
				<option value="Received">Received</option>
				<option value="Declined">Declined</option>
				<option value="Canceled">Canceled</option>
				<option value="Error">Error</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">&nbsp;</td>
		<td class="formItemControl">
			<input type="checkbox" checked id="send_notification_email" name="send_notification_email" value="yes">
			<label for="send_notification_email">Send notification to user when order completed?</label>
		</td>
	</tr>
	</form>
	<tr>
		<td class="admin-form-buttons" colspan="2">
			<input type="button" value="Print selected" onClick="printSelectedOrders();"> &nbsp;
			<input type="button" value="Update status" onClick="changeOrdersStatus();"> &nbsp;
			<input type="button" value="Delete checked" onClick="deleteCheckedOrders();">
		</td>
	</tr>
</table>
</div>
<div class="listFooter">
	<div class="listFooterCaption" style="float:left;font-weight:normal;">
	<form action="admin.php?p=search_export&chart=true" method="POST" target="_blank" style="padding:0px;margin:0px;">
		<input type="hidden" name="where" value="<?=$where?>">
		<input type="hidden" name="action" value="export">
		<input type="hidden" name="export_what" value="orders">
		<input type="submit" style="width: 120px; height: 25px;" value="Export to CSV"/>
	</form>
	</div>
	<div class="listFooterCaption" style="float:right;font-weight:normal;">
		Orders found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>
<?		}
		else{?>
<div class="listEmpty">
	No results were found. Please check search criteria<br/>
	<a href="admin.php?p=orders">Reset Search</a>
</div>
<?		}

	}
?>