<?php

	$adminView = Ddm_AdminView::getInstance();

	/**
	 * Handle actions 
	 */
	if (isset($_REQUEST["action"]))
	{
		switch ($_REQUEST["action"])
		{
			/**
			 * Insert a new payment method 
			 */
			case "insertCustom" :
			{
				$data = $_REQUEST["payment_method"];
				$db->reset();
				$db->assignStr('type', 'custom');
				$db->assignStr('solution_type', 'custom');
				$db->assignStr('active', $data['active']);
				$db->assignStr('priority', $data['priority']);
				$db->assignStr('name', $data['name']);
				$db->assignStr('gateway_name', $data['name']);
				$db->assignStr('title', $data['title']);
				$db->assignStr('message_payment', $data['message_payment']);
				$db->assignStr('message_thankyou', $data['message_thankyou']);
				$pid = $db->insert(DB_PREFIX.'payment_methods');

				$db->reset();
				$db->assignStr('id', $payment_method_id = 'custom-'.$pid);
				$db->update(DB_PREFIX.'payment_methods', 'WHERE pid="'.intval($pid).'"');

				/**
				 * Check for PayPal Express Checkout Boarding
				 */
				if (!DEMO_LOCK && (AccessManager::checkAccess('PAYMENT_PAYPAL_BASIC') || AccessManager::checkAccess('PAYMENT_PAYPAL_ALL')) && isset($_POST["paypalEC"]))
				{
					if (isset($_POST["paypalECEmail"]))
					{
						$ecParams = array(
							"paypalec_Email" => $_POST["paypalECEmail"],
							"paypalec_Payment_Action" => "Sale"
						);

						foreach ($ecParams as $ecOptionName=>$ecOptionValue)
						{
							$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($ecOptionValue)."' WHERE name='".$db->escape($ecOptionName)."'");
						}
					}

					$db->reset();
					$db->assignStr("active", "Yes");
					$db->update(DB_PREFIX."payment_methods", "WHERE id='paypalec'");
				}
				
				header('Location: admin.php?p=payment_method_custom&mode=update&payment_method_id='.$payment_method_id);
				die();
			}
			
			/**
			 * Updated custom payment method 
			 */
			case "updateCustom" :
			{
				$payment_method_id = isset($_REQUEST["payment_method_id"]) ? trim($_REQUEST["payment_method_id"]) : null;
				$data = $_REQUEST["payment_method"];
				$db->reset();
				$db->assignStr('active', $data['active']);
				$db->assignStr('priority', $data['priority']);
				$db->assignStr('name', $data['name']);
				$db->assignStr('gateway_name', $data['name']);
				$db->assignStr('title', $data['title']);
				$db->assignStr('message_payment', $data['message_payment']);
				$db->assignStr('message_thankyou', $data['message_thankyou']);
				$db->update(DB_PREFIX.'payment_methods', 'WHERE id="'.$db->escape($payment_method_id).'"');
				header('Location: admin.php?p=payment_method_custom&mode=update&payment_method_id='.$payment_method_id);
				die();
			}
			
			/**
			 * Delete custom payment solution 
			 */
			case "deleteCustom" :
			{
				$payment_method_id = isset($_REQUEST["payment_method_id"]) ? trim($_REQUEST["payment_method_id"]) : null;
				$db->query("DELETE FROM ".DB_PREFIX."payment_methods WHERE `id`='".$db->escape($payment_method_id)."'");
				header("Location: admin.php?p=payment_methods".(isset($_REQUEST["last_active_tab"]) ? "&last_active_tab=".urlencode($_REQUEST["last_active_tab"]) : ""));
				break;
			}
		}
	}
	
	/**
	 * Mode 
	 */
	$mode = isset($_REQUEST["mode"]) ? trim($_REQUEST["mode"]) : "insert";
	
	$paymentMethod = null;
	$adminView->assign('action', 'insertCustom');
	
	if ($mode == "update")
	{
		$payment_method_id = isset($_REQUEST["payment_method_id"]) ? trim($_REQUEST["payment_method_id"]) : null;
		
		if (!is_null($payment_method_id))
		{
			$paymentMethod = DataAccess_Repository::get('PaymentMethodRepository')->getPaymentMethodById($payment_method_id);

			if ($paymentMethod != null)
			{
				$adminView->assign('paymentMethod', $paymentMethod);
				$adminView->assign('action', 'updateCustom');
			}
			else
			{
				$mode == "insert";
			}
		}
	}
	
	if ($mode == "update")
	{
		pageHeader("Update Custom Method");
	}
	else
	{
		pageHeader("Add a New Custom Method");
	}
	
	/**
	 * Build form 
	 */
	$customFormBuilder = new core_Form_FormBuilder('custom-solution', array('label'=>'Custom Gateway Settings', 'class'=>'ic-document', 'first'=>true));

	$priorityOptions = array();

	for ($i=1; $i<=10; $i++) $priorityOptions[] = new core_Form_Option($i, $i);

	$customFormBuilder->add('payment_method[priority]', 'choice', array(
		'label'=>'Priority',
		'options'=>$priorityOptions,
		'value'=>!is_null($paymentMethod) ? $paymentMethod['priority'] : '1',
		'attr'=>array('class'=>'short'),
		'note'=>'Priority is used to sort available payment methods in the Select Payment Method drop-down box'
	));

	$customFormBuilder->add('payment_method[active]', 'choice', array(
		'label'=>'Is this method active?',
		'options'=>array(new core_Form_Option('Yes', 'Yes'), new core_Form_Option('No', 'No')), 
		'value'=>!is_null($paymentMethod) ? $paymentMethod['active'] : 'No',
		'attr'=>array('class'=>'short')
	));

	$customFormBuilder->add('payment_method[name]', 'text', array(
		'label'=>'Payment method name',
		'value'=>!is_null($paymentMethod) ? $paymentMethod['name'] : '',
		'note'=>'This is the text that will help customers identify this payment method. It will appear in the Payment Selection area.',
		'required'=>true
	));

	$customFormBuilder->add('payment_method[title]', 'text', array(
		'label'=>'Payment form title',
		'value'=>!is_null($paymentMethod) ? $paymentMethod['title'] : '',
		'note'=>'This is the text that will help customers identify this payment method if it is selected. It will appear on the Payment Form.',
		'required'=>true
	));

	$customFormBuilder->add('payment_method[message_payment]', 'textarea', array(
		'label'=>'Payment page message / instructions',
		'value'=>!is_null($paymentMethod) ? $paymentMethod['message_payment'] : '',
		'note'=>'Message you would like to appear on the Payment Page'
	));

	$customFormBuilder->add('payment_method[message_thankyou]', 'textarea', array(
		'label'=>'Thank you page message / instructions',
		'value'=>!is_null($paymentMethod) ? $paymentMethod['message_thankyou'] : '',
		'note'=>'Message you would like to appear on the Thank You Page'
	));

	// Render advance settings form
	$customForm = $customFormBuilder->getForm();
	$adminView->assign('customForm', $customForm);

	/**
	 * PayPal EC Crosssell 
	 */
	$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='paypalec' AND active='Yes'");
	$paypalExpressCheckoutActive = $db->moveNext();

	if (!$paypalExpressCheckoutActive && (AccessManager::checkAccess('PAYMENT_PAYPAL_BASIC') || AccessManager::checkAccess('PAYMENT_PAYPAL_ALL')))
	{
		$adminView->assign('admin_email', $admin["email"]);
		$paypalECForm = $adminView->fetch('pages/payment/paypal-ec-form');

		$adminView->assign("paypalECForm", $paypalECForm);
	}
	
	echo "&nbsp;";

	echo '<div id="tabs-payment-method" class="admin-tabs admin-tabs-framed">';

	pageTabs(array(
		array("title"=>"Custom Method Properties", "id"=>"main")
	), 'tabs-payment-method');

	$adminView->render('pages/payment/method-custom');

	echo '</div>';