<?php
	if (!defined("ENV")) exit();
	
	/**
	 * Check for PayPal Express Checkout Boarding
	 */
	if(isset($_POST["paypalEC"]) && isset($_POST["paypalECSetupMode"]) && $_POST["paypalECSetupMode"] == "accelerated" && isset($_POST["paypalECTestMode"]))
	{
		$ecParams = array(
			"paypalec_Email" => $_POST["paypalECEmail"],
			"paypalec_Payment_Action" => "Sale",
			"paypalec_Mode" => $_POST["paypalECTestMode"] == "live" ? "Live" : "Test"
		);
		
		foreach ($ecParams as $ecOptionName=>$ecOptionValue)
		{
			$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($ecOptionValue)."' WHERE name='".$db->escape($ecOptionName)."'");
		}
		
		$db->reset();
		$db->assignStr("url_to_gateway", $_POST["paypalECTestMode"] == "live" ? "https://api.paypal.com/2.0/" : "https://api.sandbox.paypal.com/2.0/");
		$db->assignStr("active", "Yes");
		$db->update(DB_PREFIX."payment_methods", "WHERE id='paypalec'");
	}
	
	/**
	 * Setup gateway
	 */
	$pid = isset($pid)?$pid*1:0;
	$mode = isset($mode)?trim($mode):"insert";
	
	$active = isset($active)?trim($active):"No";
	$proto = isset($proto)?trim($proto):"https";
	$url_to_gateway = isset($url_to_gateway)?trim($url_to_gateway):"";
	$priority = isset($priority)?$priority * 1:10;
	$name = isset($name)?trim($name):"No name";
	$title = isset($title)?trim($title):"No title";
	$message_payment = isset($message_payment)?trim($message_payment):"No data";
	$message_thankyou = isset($message_thankyou)?trim($message_thankyou):"No data";
	$gate_settings = isset($gate_settings)?$gate_settings:array();
	$enable_ccs = isset($enable_ccs)?$enable_ccs:0;

	switch($mode){
		case "insert" : {
			if(!DEMO_LOCK){
				adminLog("Payment method added: ".$name);
				$db->reset();
				$db->assignStr("active", $active);
				$db->assignStr("proto", $proto);
				$db->assignStr("url_to_gateway", $url_to_gateway);
				$db->assignStr("priority", $priority);
				$db->assignStr("gateway_name", $name);
				$db->assignStr("name", $name);
				$db->assignStr("title", $title);
				$db->assignStr("message_payment", $message_payment);
				$db->assignStr("message_thankyou", $message_thankyou);
				$db->assignStr("enable_ccs", $enable_ccs);
				$pid = $db->insert(DB_PREFIX."payment_methods");
			}
			break;
		}
		case "add_cc" : {
			$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE pid='".$pid."'");
			if($db->moveNext() && !DEMO_LOCK){
				$new_enable = isset($new_enable)?trim($new_enable):"No";
				$new_code = isset($new_code)?trim($new_code):"";
				$new_name = isset($new_name)?trim($new_name):"";
				$new_enable_cvv2 = isset($new_enable_cvv2)?trim($new_enable_cvv2):"No";
				$db->reset();
				$db->assignStr("pid", $pid);
				$db->assignStr("enable", $new_enable);
				$db->assignStr("code",  $new_code);
				$db->assignStr("name",  $new_name);
				$db->assignStr("enable_cvv2", $new_enable_cvv2);
				$db->insert(DB_PREFIX."payment_accepted_cc");
			}
		}
		case "update" : {
			$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE pid='".$pid."'");
			if($db->moveNext()){
				if(!DEMO_LOCK){
					adminLog("Payment method changed - ".$db->col["id"]." (".$db->col["name"].")");
					$gateway_type = $db->col["type"];
					if($gateway_type != "custom"){
						reset($gate_settings);
						foreach($gate_settings as $param_name=>$param_value){
							if(strstr($param_name,"googlecheckout_Merchant_ID") || strstr($param_name,"googlecheckout_Merchant_Key")){
								//$param_value = trim($param_value," ");									
								$param_value = str_replace (" ", "", $param_value);								
							}
							$db->reset();
							$db->assignStr("value", $param_value);
							$db->update(DB_PREFIX."settings", "WHERE name='".$db->escape($param_name)."'");
						}
					}
					$db->reset();
					$db->assignStr("active", $active);
					$db->assignStr("proto", $proto);
					$db->assignStr("url_to_gateway", $url_to_gateway);
					$db->assignStr("priority", $priority);
					if($gateway_type == "custom"){
						$db->assignStr("gateway_name", $name);
					}
					$db->assignStr("name", $name);
					$db->assignStr("title", $title);
					$db->assignStr("message_payment", $message_payment);
					$db->assignStr("message_thankyou", $message_thankyou);
					$db->assignStr("enable_ccs", $enable_ccs);
					$db->update(DB_PREFIX."payment_methods", "WHERE pid='".$pid."'");
					
					if($db->col["type"] != "custom"){
						//update current cc 
						$cc_enable = isset($cc_enable)?$cc_enable:array();
						$cc_enable = is_array($cc_enable)?$cc_enable:array();
						$cc_code = isset($cc_code)?$cc_code:array();
						$cc_code = is_array($cc_code)?$cc_code:array();
						$cc_name = isset($cc_name)?$cc_name:array();
						$cc_name = is_array($cc_name)?$cc_name:array();
						$cc_enable_cvv2 = isset($cc_enable_cvv2)?$cc_enable_cvv2:array();
						$cc_enable_cvv2 = is_array($cc_enable_cvv2)?$cc_enable_cvv2:array();
						foreach($cc_code as $ccid=>$_cc_code){
							$db->reset();
							$db->assignStr("enable", array_key_exists($ccid, $cc_enable)?"Yes":"No");
							$db->assignStr("code", $cc_code[$ccid]);
							$db->assignStr("name", $cc_name[$ccid]);
							$db->assignStr("enable_cvv2",  array_key_exists($ccid, $cc_enable_cvv2)?"Yes":"No");
							$db->update(DB_PREFIX."payment_accepted_cc", "WHERE ccid='".$ccid."'");
						}
						if(array_key_exists("certificate_file", $_FILES) && file_exists($_FILES["certificate_file"]["tmp_name"])){
							$certificate_path = isset($certificate_path)?trim($certificate_path):"";
							if($certificate_path != "" && is_writable($certificate_path)){
								copy($_FILES["certificate_file"]["tmp_name"], $certificate_path);
							}
						}
					}
				}
				
			}
			
			break;
		}
		case "remove_cc" : { 
			$ccid = isset($ccid)?intval($ccid):0;
			$db->query("SELECT pid FROM payment_accepted_cc WHERE ccid='".$ccid."'");
			if($db->moveNext()){
				$pid = $db->col["pid"];
				if(!DEMO_LOCK){
					$db->query("DELETE FROM ".DB_PREFIX."payment_accepted_cc WHERE ccid='".$ccid."'");
				}
			}
			break;
		}
		case "delete" : {
			
			$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE pid='".$pid."'");
			if($db->moveNext()){
				adminLog("Payment method deleted - ".$db->col["id"]." (".$db->col["name"].")");
				
				if($db->col["type"] == "custom"){
					if(!DEMO_LOCK){
						$db->query("DELETE FROM ".DB_PREFIX."payment_accepted_cc WHERE pid='".$pid."'");
						$db->query("DELETE FROM ".DB_PREFIX."payment_methods WHERE pid='".$pid."'");
					}
				}
				else{
					if(!DEMO_LOCK){
						$db->query("UPDATE ".DB_PREFIX."payment_methods SET active='No' WHERE pid='".$pid."'");
					}					
				}
			}
			break;
		}
	}
?>

<?php
	if ($mode == "add_cc" || $mode == "remove_cc")
	{
?>
<script type="text/javascript">
	document.location = "admin.php?p=payment_method&mode=update&pid=<?=$pid?>";
</script>
<?php
	}
	elseif(isset($_POST["paypalEC"]) && isset($_POST["paypalECSetupMode"]) && $_POST["paypalECSetupMode"] == "api")
	{
?>
<script type="text/javascript">
	document.location = "admin.php?p=payment_method&mode=update&pid=18";
</script>
<?php
	}
	else
	{
		pageHeader("Set Up Other Payment Options");
		pageNote(array(
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Are there additional payment methods you would like to add to your cart?", "visible"=>true)
		));
		
		require_once("content/admin/admin_paypal_ec_form.php");
?>
		<form action="admin.php?p=payment_method&mode=update" method="POST">
			<div style="margin:20px 0px 20px 24px;">
			<select id="selectActivateGateway" name="pid">
<?php
		$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE type <> 'Custom' AND active='No' ORDER BY gateway_name, type");
		while($db->moveNext()){?>
				<option value="<?=$db->col["pid"]?>" <?=$db->col["id"]=="paypalec"?'selected="selected"':''?>><?=gs($db->col["gateway_name"])?></option>
<?php
		}
?>
				<option value="custom">Custom Payment Method</option>
			</select>
			<input type="submit" value="Configure gateway" />
		</div>
<?php
		pageNote(array(
			array("icon"=>"ic_hint.gif","url"=>"","text"=>"Go to payment methods page", "url"=>"admin.php?p=payment_methods", "visible"=>true),

		));
	}
?>
