<?php

if (!defined('ENV')) exit();

$paypalEnabled = Payment_PayPal_PayPalApi::isPayPalEnabled();

if (isset($_REQUEST['action']))
{

	if ($_REQUEST['action'] == 'request_publisher_id')
	{
		verify_nonce($_REQUEST['nonce'], 'paypalbml_request_publisher_id');

		$email = isset($_REQUEST['paypalEmail']) ? trim($_REQUEST['paypalEmail']) : '';

		$isValid = true;
		if (trim($email) == '')
		{
			Admin_Flash::setMessage('PayPal Account email is required', Admin_Flash::TYPE_ERROR);
			$isValid = false;
		}

		if ($isValid)
		{
			$financingApi = new Payment_PayPal_FinancingApi(defined('DEV_PAYPALFINANCING') && DEV_PAYPALFINANCING ? false : true);
			try
			{
				$publisherId = $financingApi->getPublisherId($email, '', '');

				$db->query('UPDATE '.DB_PREFIX.'settings SET value = \''.$db->escape($publisherId).'\' WHERE name = \'paypal_publisher_id\'');
				$db->query('UPDATE '.DB_PREFIX.'settings SET value = \''.$db->escape($email).'\' WHERE name = \'paypal_publisher_email\'');

				Admin_Flash::setMessage('Successfully accepted the Advertising Program Terms.', Admin_Flash::TYPE_SUCCESS);

				$settings['paypal_publisher_id'] = $publisherId;
				$settings['paypal_publisher_email'] = $email;
			}
			catch (Payment_PayPal_FinancingApiException $ex)
			{
				foreach ($ex->errors as $error)
				{
					Admin_Flash::setMessage('Error: '.$error, Admin_Flash::TYPE_ERROR);
				}
			}
			catch (Exception $ex)
		{
				Admin_Flash::setMessage($ex->getMessage(), Admin_Flash::TYPE_ERROR);
			}
		}
	}
}

$adminView = Ddm_AdminView::getInstance();

$last_active_tab = isset($_REQUEST['last_active_tab']) ? $_REQUEST['last_active_tab'] : 'about';

$requestPubIdNonce = create_nonce('paypalbml_request_publisher_id');

$adminView->assign('last_active_tab', $last_active_tab);

$adminView->assign('paypalEnabled', $paypalEnabled);
$adminView->assign('requestPubIdNonce', $requestPubIdNonce);

$generalFormBuilder = new core_Form_FormBuilder('general');
if ($settings['paypal_publisher_id'] != '')
{
	$generalFormBuilder->add('paypalPublisherId', 'static', array('label' => 'Publisher Id', 'value' => $settings['paypal_publisher_id']));
}

$email = $settings['paypal_publisher_email'];

if (trim($email) == '' && trim($settings['paypalec_Email']) != '')
{
	$email = $settings['paypalec_Email'];
}

if (isset($_POST['paypalEmail']) && trim($_POST['paypalEmail']) != '')
{
	$email = $_POST['paypalEmail'];
}

$generalFormBuilder->add('paypalEmail', 'text', array('label' => 'Your PayPal email address', 'value' => $email, 'required'=>true));
$generalFormBuilder->add('paypalAgree', 'checkbox', array('label' => 'I agree to the terms of the PayPal Advertising Program. <a id="paypal-financing-terms" href="javascript:void();" onclick="return displayFinancingTerms()">See Terms</a>', 'required'=>true));
$adminView->assign('requestIdForm', $generalFormBuilder->getForm());
$adminView->assign('paypal_publisher_id', $settings['paypal_publisher_id']);

$adminView->render('pages/paypal/about-bml');