<?php
	if (!defined("ENV")) exit();

	$foafLocation = 'paypal';

	$country = isset($_POST['country']) ? trim($_POST['country']) : '';
	$state = isset($_POST['state']) ? trim($_POST['state']) : '';
	$city = isset($_POST['city']) ? trim($_POST['city']) : '';
	$org = isset($_POST['org']) ? trim($_POST['org']) : '';
	$email = isset($_POST['email']) ? trim($_POST['email']) : '';

	$download = false;
	if (isset($_POST['action']) && $_POST['action'] == 'generate')
	{
		require_once 'content/engine/payment/paypal/gencsr.php';

		$foafLocation = 'paypal';

		if ($data = createIdentityCertificate($country, $state, $city, $org, $org, $org, $email, $foafLocation))
		{
			file_put_contents('content/engine/payment/paypal/'.$foafLocation.'.cer', $data['cer']);
			file_put_contents('content/engine/payment/paypal/'.$foafLocation.'.pem', $data['pem']);
			file_put_contents('content/engine/payment/paypal/'.$foafLocation.'_signature.txt', $data['signature']);

			$download = true;
		}
	}
	else if (isset($_POST['action']) && $_POST['action'] == 'download')
	{
		$download = true;
	}

	if ($download)
	{
		header("Pragma: public");
		header("Expires: 0"); // set expiration time
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
		// browser must download file from server instead of cache

		// force download dialog
		header("Content-Type: application/force-download");
		header("Content-Type: application/octet-stream");
		header("Content-Type: application/download");

		// use the Content-Disposition header to supply a recommended filename and 
		// force the browser to display the save dialog. 
		header("Content-Disposition: attachment; filename=$foafLocation.cer;");
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".filesize('content/engine/payment/paypal/'.$foafLocation.'.cer'));

		if (!safe_mode()) set_time_limit(360000000);
	
		$f = fopen('content/engine/payment/paypal/'.$foafLocation.'.cer', "r");
		while ($s = fread($f, 1024)) echo $s;
		fclose($f);

		exit();
	}
?>
<div style="font-size:16px;font-weight:bold;margin-bottom:5px;">Regenerate public key</div>
<form method="POST" action="admin.php?p=paypalipn_gencsr&chart=1">
	<input type="hidden" name="action" value="generate"/>
	<div>
		<div class="field">
			<label class="caption required">Country</label>
			<div class="control"><input type="text" name="country" maxlength="2" value="<?php echo $country; ?>"/></div>
		</div>
		<div class="field">
			<label class="caption required">State / Province Name</label>
			<div class="control"><input type="text" name="state" value="<?php echo $state; ?>"/></div>
		</div>
		<div class="field">
			<label class="caption required">City / Locality Name</label>
			<div class="control"><input type="text" name="city" value="<?php echo $city; ?>"/></div>
		</div>
		<div class="field">
			<label class="caption required">Organization</label>
			<div class="control"><input type="text" name="org" value="<?php echo $org; ?>"/></div>
		</div>
		<div class="field">
			<label class="caption required">Email</label>
			<div class="control"><input type="text" name="email" value="<?php echo $email; ?>"/></div>
		</div>
		<div class="admin-form-buttons">
			<input type="submit" value="Generate"/>
			<input type="button" value="Download" id="btnDownload"/>
		</div>
	</div>
</form>

<form id="frmDownload" method="POST" action="admin.php?p=paypalipn_gencsr&chart=1">
	<input type="hidden" name="action" value="generate"/>
</form>
<script type="text/javascript">
$('#btnDownload').click(function(){
	$('#frmDownload').submit();
});
</script>