<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	require_once("content/classes/class.taxes.php");
	require_once("content/classes/class.products_locations.php");

	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;

	$productsLocations = new ProductsLocations($db);

	$last_active_tab = isset($last_active_tab) ? $last_active_tab : "main";

	$categories = array();
	$prev_pid = false;
	$next_pid = false;
	$google_co_active = false;
	//Check if google checkout is enaled
	$db->query("SELECT active FROM ".DB_PREFIX."payment_methods WHERE id='googlecheckout'");
	if ($db->moveNext())
	{
		if ($db->col["active"] =="Yes")
		{
			$google_co_active = true;
		}
	}

	class OptionNode extends DB_TREE_NODE
	{
		public function getValue()
		{
			return $this->id;
		}
		public function getLabel()
		{
			$temp = str_repeat('&nbsp;', ($this->level - 1) * 4);
			$temp .= gs($this->caption);

			return $temp;
		}
	}

	//$category_options = array();

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OptionNode(TREE_ROOT, -1, 0, "Yes",  "None selected"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	while ($db->moveNext())
	{
		$tree->addNode(
			new OptionNode(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	$mode = isset($_REQUEST['mode']) ? trim($_REQUEST['mode']) : "insert";
	$mode = in_array($mode, array("insert", "update")) ? $mode : "insert";
	
	$db->query('SELECT COUNT(*) AS c FROM '.DB_PREFIX.'products');
	$db->moveNext();
	$productsCount = $db->col['c'];
	
	if (
		count($tree->collection) > 1 && 
		AccessManager::checkAccess('MAX_PRODUCTS') > 1 && 
		(($mode != 'insert') || ($mode == 'insert' && $productsCount < AccessManager::checkAccess('MAX_PRODUCTS')))
	)
	{
		$pid = isset($pid) ? $pid*1 : "";

		switch ($mode)
		{
			case "update" : 
			{
				$db->query("SELECT gift_max_quantity FROM ".DB_PREFIX."products_gifts WHERE pid='".$pid."'");
				if ($db->moveNext())
				{
					$gift_max_quantity = $db->col["gift_max_quantity"];
					$gift_max_quantity=isset($gift_max_quantity)?$gift_max_quantity*1:"";
				}
				else
				{
					$gift_max_quantity = 999;
				}

				$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".$pid."'");

				if ($db->moveNext())
				{
					$cid = $db->col["cid"];
					$is_visible = $db->col["is_visible"];
					$is_hotdeal = $db->col["is_hotdeal"];
					$is_home = $db->col["is_home"];
					$is_google_co = $db->col["is_google_co"];
					$is_taxable = $db->col["is_taxable"];
					$is_dollar_days = $db->col["is_dollar_days"];
					$is_doba = $db->col["is_doba"];
					$is_locked = $db->col["is_locked"];
					$inventory_control  = $db->col["inventory_control"];
					$inventory_rule  = $db->col["inventory_rule"];
					$stock = $db->col["stock"];
					$stock_warning = $db->col["stock_warning"];
					$weight = $db->col["weight"];
					$free_shipping = $db->col["free_shipping"];
					$digital_product = $db->col["digital_product"];
					$digital_product_file = $db->col["digital_product_file"];
					$cost = $db->col["cost"];
					
					if ($db->col["price2"]>0)
					{
						$price = $db->col["price2"];
						$price2 = $db->col["price"];
					}
					else
					{
						$price = $db->col["price"];
						$price2 = "";
					}
					
					$call_for_price = $db->col["call_for_price"];
					$price_level_1 = $db->col["price_level_1"];
					$price_level_2 = $db->col["price_level_2"];
					$price_level_3 = $db->col["price_level_3"];
					$tax_rate = $db->col["tax_rate"];
					$tax_class_id = $db->col["tax_class_id"];
					$min_order = $db->col["min_order"];
					$max_order = $db->col["max_order"];
					$product_id = $db->col["product_id"];
					$product_sku = $db->col["product_sku"];
					$product_upc = $db->col["product_upc"];
					$estimated_shipping_price = $db->col["estimated_shipping_price"];
					$product_gtin = $db->col["product_gtin"];
					$product_mpn = $db->col["product_mpn"];
					$case_pack = $db->col["case_pack"];
					$inter_pack = $db->col["inter_pack"];
					$gift_quantity = $db->col["gift_quantity"];

					$ebay_cat_id = $db->col["ebay_cat_id"];
					$pricegrabber_category = $db->col["pricegrabber_category"];
					$pricegrabber_item_condition = $db->col["pricegrabber_item_condition"];
					$pricegrabber_part_number = $db->col["pricegrabber_part_number"];
					$amazon_id = $db->col["amazon_id"];
					$amazon_id_type = $db->col["amazon_id_type"];
					$amazon_item_condition = $db->col["amazon_item_condition"];
					$yahoo_path = $db->col["yahoo_path"];
					$google_item_condition = $db->col["google_item_condition"];
					$google_product_type = $db->col["google_product_type"];
					$google_availability = $db->col["google_availability"];
					$google_online_only = $db->col["google_online_only"];
					$google_gender = $db->col['google_gender'];
					$google_age_group = $db->col['google_age_group'];
					$google_color = $db->col['google_color'];
					$google_size = $db->col['google_size'];
					$google_material = $db->col['google_material'];
					$google_pattern = $db->col['google_pattern'];
					
					$nextag_category = $db->col["nextag_category"];
					$nextag_item_condition = $db->col["nextag_item_condition"];
					$nextag_part_number = $db->col["nextag_part_number"];

					$title = $db->col["title"];
					$meta_keywords = $db->col["meta_keywords"];
					$meta_title = $db->col["meta_title"];
					$meta_description = $db->col["meta_description"];
					$url_default = $db->col["url_default"];
					$url_custom = $db->col["url_custom"];
					$manufacturer_id = $db->col["manufacturer_id"];
					$overview = $db->col["overview"];
					$description = $db->col["description"];
					$dimension_width = $db->col["dimension_width"];
					$dimension_length = $db->col["dimension_length"];
					$dimension_height = $db->col["dimension_height"];
					$priority = $db->col["priority"];
					$image_location = $db->col["image_location"];
					$image_url = $db->col["image_url"];
					$image_alt_text = $db->col["image_alt_text"];
					$zoom_option = $db->col["zoom_option"];

					$lock_fields = explode(",", $db->col["lock_fields"]);

					$lock_fields = is_array($lock_fields) ? $lock_fields : array();

					$lock_fields = normalizeProductLockFields($lock_fields);

					$products_location_id = $db->col["products_location_id"];

					//////////////////////////////
					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."' AND pid<>'".$pid."'");
					if ($db->moveNext())
					{
						$dw = true;
					}
					$db->query("SELECT * FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."' AND is_primary=0");
					while ($db->moveNext())
					{
						if ($db->col["cid"] != $cid)
						{
							$categories[] = $db->col["cid"];
						}
					}
					$db->query("SELECT MAX(pid) AS c FROM ".DB_PREFIX."products WHERE pid<'".$pid."'");
					$db->moveNext();
					$prev_pid = $db->col["c"];
					$db->query("SELECT MIN(pid) AS c FROM ".DB_PREFIX."products WHERE pid>'".$pid."'");
					$db->moveNext();
					$next_pid = $db->col["c"];
					break;
				}
			}
			default :
			case "insert" : 
			{
				if ($pid > 0 && $mode != "update")
				{
					$db->query("SELECT gift_max_quantity FROM ".DB_PREFIX."products_gifts WHERE pid='".intval($pid)."'");
					
					if ($db->moveNext())
					{
						$gift_max_quantity = $db->col["gift_max_quantity"];
					}
					else
					{
						$gift_max_quantity = 999;
					}
					$gift_max_quantity = " ";

					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".intval($pid)."'");
					
					if ($db->moveNext())
					{
						$cid = $db->col["cid"];
						$is_visible = $db->col["is_visible"];
						$is_hotdeal = $db->col["is_hotdeal"];
						$is_home = $db->col["is_home"];
						$is_google_co = $db->col["is_google_co"];
						$is_taxable = $db->col["is_taxable"];
						$is_dollar_days = "No";
						$is_doba = "No";
						$is_locked = "No";
						$inventory_control  = $db->col["inventory_control"];
						$inventory_rule  = $db->col["inventory_rule"];
						$stock = $db->col["stock"];
						$stock_warning = $db->col["stock_warning"];
						$weight = $db->col["weight"];
						$free_shipping = $db->col["free_shipping"];
						$digital_product = $db->col["digital_product"];
						$digital_product_file = $db->col["digital_product_file"];
						$cost = $db->col["cost"];
						
						if ($db->col["price2"]>0)
						{
							$price = $db->col["price2"];
							$price2 = $db->col["price"];
						}
						else
						{
							$price = $db->col["price"];
							$price2 = "";
						}
						$call_for_price = $db->col["call_for_price"];
						$price_level_1 = $db->col["price_level_1"];
						$price_level_2 = $db->col["price_level_2"];
						$price_level_3 = $db->col["price_level_3"];
						$tax_rate = $db->col["tax_rate"];
						$tax_class_id = $db->col["tax_class_id"];
						$min_order = $db->col["min_order"];
						$max_order = $db->col["max_order"];
						$url_default = "will be generated after product saved";
						$url_custom = "";
						$product_id = "";
						$product_sku = "";
						$product_upc = "";
						$estimated_shipping_price = -1.00;
						$product_gtin = "";
						$product_mpn = "";
						$case_pack = $db->col["case_pack"];
						$inter_pack = $db->col["inter_pack"];
						$gift_quantity = $db->col["gift_quantity"];

						$amazon_id = $db->col["amazon_id"];
						$amazon_id_type = $db->col["amazon_id_type"];
						$amazon_item_condition = $db->col["amazon_item_condition"];
						$ebay_cat_id = $db->col["ebay_cat_id"];
						$pricegrabber_category = $db->col["pricegrabber_category"];
						$pricegrabber_item_condition = $db->col["pricegrabber_item_condition"];
						$pricegrabber_part_number = $db->col["pricegrabber_part_number"];
						$yahoo_path = $db->col["yahoo_path"];
						$google_item_condition = $db->col["google_item_condition"];
						$google_product_type = $db->col["google_product_type"];
						$google_availability = $db->col["google_availability"];
						$google_online_only = $db->col["google_online_only"];
						$google_gender = $db->col['google_gender'];
						$google_age_group = $db->col['google_age_group'];
						$google_color = $db->col['google_color'];
						$google_size = $db->col['google_size'];
						$google_material = $db->col['google_material'];
						$google_pattern = $db->col['google_pattern'];
					
						$nextag_category = $db->col["nextag_category"];
						$nextag_item_condition = $db->col["nextag_item_condition"];
						$nextag_part_number = $db->col["nextag_part_number"];

						$title = $db->col["title"];
						$meta_keywords = $db->col["meta_keywords"];
						$meta_title = $db->col["meta_title"];
						$meta_description = $db->col["meta_description"];
						$manufacturer_id = $db->col["manufacturer_id"];
						$overview = $db->col["overview"];
						$description = $db->col["description"];
						$dimension_width = $db->col["dimension_width"];
						$dimension_length = $db->col["dimension_length"];
						$dimension_height = $db->col["dimension_height"];
						$priority = $db->col["priority"];
						$image_location = $db->col["image_location"];
						$image_url = $db->col["image_url"];
						$image_alt_text = $db->col["image_alt_text"];
						$zoom_option = $db->col["zoom_option"];
						
						$lock_fields = explode(",", $db->col["lock_fields"]);
						$lock_fields = is_array($lock_fields) ? $lock_fields : array();

						$lock_fields = normalizeProductLockFields($lock_fields);

						$products_location_id = $db->col["products_location_id"];

						$db->query("SELECT * FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."' AND is_primary=0");
						while ($db->moveNext())
						{
							$categories[] = $db->col["cid"];
						}
					}
				}
				else
				{
					$mode = "insert";
					$cid = isset($cid)?$cid*1:TREE_ROOT;
					$is_visible = "Yes";
					$is_hotdeal = "No";
					$is_home = "No";
					$is_google_co = "Yes";
					$is_taxable = "Yes";
					$is_dollar_days = "No";
					$is_doba = "No";
					$is_locked = "No";
					$inventory_control = "No";
					$inventory_rule  = "Hide";
					$stock = 0;
					$stock_warning = 0;
					$weight = "0.00";
					$amazon_id = "";
					$amazon_id_type = 0;
					$amazon_item_condition = 0;
					$google_item_condition = "";
					$google_product_type = "";
					$google_availability = "";
					$google_gender = "";
					$google_age_group = "";
					$google_color = "";
					$google_size = "";
					$google_material = "";
					$google_pattern = "";
			
					$google_online_only = "";
					$nextag_category = "";
					$nextag_item_condition = "";
					$nextag_part_number = "";
					$ebay_cat_id = 0;
					$pricegrabber_category = "";
					$pricegrabber_item_condition = "New";
					$pricegrabber_part_number = "";
					$yahoo_path = "";
					$free_shipping = "No";
					//$shipping_price = "0.00";
					$digital_product = "No";
					$digital_product_file = "";
					$cost = "";
					$price = "";
					$price2 = "";
					$call_for_price = "No";
					$price_level_1 = 0;
					$price_level_2 = 0;
					$price_level_3 = 0;
					$tax_rate = 0;
					$tax_class_id = 1;  //Add all products to default tax class
					$min_order = 1;
					$max_order = 0;
					$product_id = "";
					$product_sku = "";
					$product_upc = "";
					$estimated_shipping_price = -1.00;
					$product_gtin = "";
					$product_mpn = "";
					$case_pack = -1;
					$inter_pack = -1;
					$gift_quantity = 1;
					$gift_max_quantity = 999;
					$title = "";
					$meta_keywords = "";
					$meta_title = "";
					$meta_description = "";
					$url_default = "will be generated after product saved";
					$url_custom = "";
					$manufacturer_id = 0;
					$overview = "";
					$description = "";
					$dimension_width = 0;
					$dimension_length = 0;
					$dimension_height = 0;
					$priority = 0;
					$image_location = "Local";
					$image_url = "";
					$image_alt_text = "";
					$zoom_option = "";
					$lock_fields = array();
					$products_location_id = 0;
				}
				$pid = 0;
			}
		}

		$stock = $stock < 0 ? 0 : $stock;

		loadJS("cf_product.js");
		loadJS("cd_product.js");
		loadJS("product_gifts.js");

		pageHeader("Product", ucfirst(strtolower($mode)), "icb-product");

		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"",  "visible"=>true),
			array("class"=>"ic-info", "text"=>"Decimal points and commas are accepted in the Product Price and Weight fields.", "url"=>"",  "visible"=>true),
			array("class"=>"ic-trash-can", "text"=>"Delete this product", "url"=>"JavaScript:ConfirmDeleteProduct('".$pid."')",  "visible"=>$mode=="update"),
			array("class"=>"ic-info", "text"=>"<span style=\"color:#990000\"><b>Please note: There are currently no product categories in database.</b><br>Please add product categories first</span>", "url"=>"", "visible"=>$cats_count < 1),
			array("class"=>"ic-currency-sign-dollar2", "text"=>"Product source: DollarDays.com", "url"=>"",  "visible"=>$is_dollar_days == "Yes"),
			array("class"=>"ic-record", "text"=>"Product source: Doba.com", "url"=>"",  "visible"=>$is_doba == "Yes"),
		));
?>

<form name="frmProduct" id="frmProduct" action="admin.php?p=product_process" method="post" onsubmit="return CheckProductForm(this, '<?=$settings["WholesaleCasePack"]?>', '<?=$settings["WholesaleInterPack"]?>');" enctype="multipart/form-data">
	<input type="hidden" id="nonce-product-delete" name="nonce-product-delete" value="<?php echo create_nonce('product_delete'); ?>" />
	<input type="hidden" name="pid" value="<?=$pid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="nonce" value="<?=create_nonce('product_'.$mode)?>" />
	<input type="hidden" name="last_active_tab" value="<?=gs($last_active_tab)?>" id="idActiveTabHidden">

	<div class="admin-tabs admin-tabs-framed" id="tabs-product">
<?php
		pageTabs(array(
			array("title"=>"Product Info", "id"=>"main"),
			//array("title"=>"Advanced", "id"=>"advanced"),
			array("title"=>"Attributes", "id"=>"attributes"),
			array("title"=>"Inventory", "id"=>"inventory"),
			array("title"=>"Recommended", "id"=>"families"),
			array("title"=>"Product Promotions", "id"=>"gifts"),
			array("title"=>"Quantity Discounts", "id"=>"discounts"),
			array("title"=>"Secondary Images", "id"=>"images"),
			array("title"=>"Data Export Attributes", "id"=>"export-mapping"),
			array("title"=>"QR Codes", "id"=>"qr", "visible" => $settings["qr_active"] == "Yes" && $mode != 'insert'),
			array("title"=>"Widgets", "id"=>"widgets", "visible" => $settings["widgets_active"] == "Yes" && $mode != 'insert')
		), 'tabs-product', $last_active_tab);

		if (isset($dw) && $mode=="update")
		{
?>
		<table width="100%" cellpadding="2" cellspacing="1" border="0" bgcolor="black">
			<tr>
				<td bgcolor="#ffffCC" style="color:red;font-weight:bold;" height="60" align="center">
					Warning: Entered Product ID "<?=gs($product_id)?>" Already Exists in the Database.<br>
					Please Enter a Different Product ID.
				</td>
			</tr>
		</table>	
		&nbsp;
<?php
		}
		
		require_once("content/admin/admin_product_tab_info.php");
		//require_once("content/admin/admin_product_tab_advanced.php");
		require_once("content/admin/admin_product_tab_attributes.php");
		require_once("content/admin/admin_product_tab_inventory.php");
		require_once("content/admin/admin_product_tab_families.php");
		require_once("content/admin/admin_product_tab_images.php");
		require_once("content/admin/admin_product_tab_gifts.php");
		require_once("content/admin/admin_product_tab_discounts.php");
		require_once("content/admin/admin_product_tab_export_mapping.php");
		
		if ($settings["qr_active"] == "Yes" && $mode != "insert")
		{
			require_once("content/admin/admin_product_tab_qr.php");
		}
		
		if ($settings["widgets_active"] == "Yes" && $mode != "insert")
		{
			require_once("content/admin/admin_product_tab_widgets.php");
		}
?>
	</div>
	<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td width="25%" align="left">
<?php
		if ($prev_pid)
		{
?>
      		<img src="images/admin/arr_prev.gif"> <a href="admin.php?p=product&mode=update&pid=<?=$prev_pid?>">Edit previous product</a>
<?php
		}
?>
				&nbsp;
    		</td>
			<td width="50%" class="admin-form-buttons">
				<input type="hidden" name="do_apply" value="no">
				<input id="product-submit-button" type="submit" value="Save changes" default="default"/>
				<input type="reset" value="Reset form"/>
			</td>
			<td width="25%" align="right">
				&nbsp;
<?php
		if ($next_pid)
		{
?>
				<a href="admin.php?p=product&mode=update&pid=<?=$next_pid?>">Edit next product</a> <img src="images/admin/arr_next.gif">
<?php
		}
?>
			</td>
		</tr>
	</table>
</form>

<?php
	}
	else
	{
		pageHeader("Error Adding New Product", "", "ic-cross");
		
		if ($mode == 'insert' && $productsCount >= AccessManager::checkAccess('MAX_PRODUCTS'))
		{
			AccessManager::notAllowed("Your current license agreement only allows ".AccessManager::checkAccess('MAX_PRODUCTS')." products.");
		}
		else
		{
			pageNote(array(
				array("class"=>"ic-cross", "text"=>"<b>Can't add a new product. Please add a new category first.</b>", "url"=>"",  "visible"=>true),
				array("class"=>"ic-add", "text"=>"Click here to add a New Category", "url"=>"admin.php?p=category&mode=insert",  "visible"=>true)
			));
		}
	}
