<?php
	if (!defined("ENV")) exit();

	$availabilities = array(
		array('value' => 'inventory_control', 'label' => 'Inventory Control'),
		array('value' => 'in stock', 'label' => 'In Stock'),
		array('value' => 'available for order', 'label' => 'Available for Order'),
		array('value' => 'out of stock', 'label' => 'Out of Stock'),
		array('value' => 'preorder', 'label' => 'Pre-Order'),
	);
	$online_values = array(
		array('value' => 'n', 'label' => 'No'),
		array('value' => 'y', 'label' => 'Yes'),
	);
	$gender_values = array(
		array('value' => '', 'label' => ''),
		array('value' => 'unisex', 'label' => 'Unisex'),
		array('value' => 'male', 'label' => 'Male'),
		array('value' => 'female', 'label' => 'Female'),
	);
	$age_values = array(
		array('value' => '', 'label' => ''),
		array('value' => 'adult', 'label' => 'Adult'),
		array('value' => 'kids', 'label' => 'Kids'),
	);

	$adminView = Ddm_AdminView::getInstance();

	$adminView->assign('can_access_export', AccessManager::checkAccess('PRODUCT_EXPORT'));

	$basicFormBuilder = new core_Form_FormBuilder('basic');

	$formBuilder = new core_Form_FormBuilder('google-base', array('label' => 'Google Base', 'class' => 'ic-google', 'collapsable' => true, 'first' => true));
	$basicFormBuilder->add($formBuilder);

	$formBuilder->add('google_item_condition', 'choice', array('label' => 'Item Condition', 'value' => $google_item_condition, 'options' => array(
			new core_Form_Option('new', 'New'),
			new core_Form_Option('used', 'Used'),
			new core_Form_Option('refurbished', 'Refurbished'),
		),
		'tooltip' => 'Google requires the product condition (new, used, etc)',
	));
	$formBuilder->add('google_product_type', 'text', array('label' => 'Google Product Category', 'value' => $google_product_type, 'tooltip' => 'For more information <a target="_new" href="http://www.google.com/support/merchants/bin/answer.py?answer=160081">click here</a>',));
	$formBuilder->add('google_availability', 'choice', array('label' => 'Google Availability', 'value' => $google_availability, 'options' => array(
			new core_Form_Option('inventory_control', 'Inventory Control'),
			new core_Form_Option('in stock', 'In Stock'),
			new core_Form_Option('available for order', 'Available for Order'),
			new core_Form_Option('out of stock', 'Out of Stock'),
			new core_Form_Option('preorder', 'Pre-Order'),
		),
		'tooltip' => 'For more information <a target="_new" href="http://www.google.com/support/merchants/bin/answer.py?answer=160081">click here</a><br/> Note: Inventory Control uses the inventory levels defined in the cart to automatically set the correct value in the export.  Change this setting to manually override the inventory setting.',
	));
	$formBuilder->add('google_online_only', 'choice', array('label' => 'Online Only', 'value' => $google_online_only, 'options' => array(
			new core_Form_Option('n', 'No'),
			new core_Form_Option('y', 'Yes'),
		)
	));
	$formBuilder->add('google_gender', 'choice', array('label' => 'Gender', 'value' => $google_gender, 'options' => array(
			new core_Form_Option('', ''),
			new core_Form_Option('unisex', 'Unisex'),
			new core_Form_Option('male', 'Male'),
			new core_Form_Option('female', 'Female'),
		)
	));
	$formBuilder->add('google_age_group', 'choice', array('label' => 'Age Group', 'value' => $google_age_group, 'options' => array(
			new core_Form_Option('', ''),
			new core_Form_Option('adult', 'Adult'),
			new core_Form_Option('kids', 'Kids'),
		)
	));
	$formBuilder->add('google_color', 'text', array('label' => 'Color', 'value' => $google_color));
	$formBuilder->add('google_size', 'text', array('label' => 'Size', 'value' => $google_size));
	$formBuilder->add('google_material', 'text', array('label' => 'Material', 'value' => $google_material));
	$formBuilder->add('google_pattern', 'text', array('label' => 'Pattern', 'value' => $google_pattern));

	$formBuilder = new core_Form_FormBuilder('amazon', array('label' => 'Amazon', 'collapsable' => true));
	$basicFormBuilder->add($formBuilder);

	$formBuilder->add('amazon_id', 'text', array('label' => 'Product Id', 'value' => $amazon_id, 'tooltip' => 'Amazon uses UPCs, ISBNs, or other codes to identify their product pages.'));
	$formBuilder->add('amazon_id_type', 'choice', array('label' => 'Id Type', 'value' => $amazon_id_type, 'options' => array(
			new core_Form_Option('1', 'ASIN'),
			new core_Form_Option('2', 'ISBN'),
			new core_Form_Option('3', 'UPC'),
			new core_Form_Option('4', 'EAN'),
		),
		'tooltip' => 'Select the type of ID you have entered',
	));
	$formBuilder->add('amazon_item_condition', 'choice', array('label' => 'Item Condition', 'value' => $amazon_item_condition, 'options' => array(
			new core_Form_Option('1','Used, Like New'),
            new core_Form_Option('2','Used, Very Good'),
            new core_Form_Option('3','Used, Good'),
            new core_Form_Option('4','Used, Acceptable'),
            new core_Form_Option('5','Collectible; Like New'),
            new core_Form_Option('6','Collectible; Very Good'),
            new core_Form_Option('7','Collectible; Good'),
            new core_Form_Option('8','Collectible; Acceptable'),
            new core_Form_Option('9','Not Used'),
            new core_Form_Option('10','Refurbished (for computers, kitchen & housewares, electronics, and camera & photo only)'),
            new core_Form_Option('11','New'),
		),
		'tooltip' => 'Amazon requires a special code to mark the product condition ',
	));

	$formBuilder = new core_Form_FormBuilder('ebay', array('label' => 'Ebay', 'collapsable' => true));
	$basicFormBuilder->add($formBuilder);
	$formBuilder->add('ebay_cat_id', 'integer', array('label' => 'Category', 'value' => $ebay_cat_id, 
		'tooltip' => 'enter the numeric eBay category id (example, for antiques enter: 20081) <a href="http://listings.ebay.com/_W0QQloctZShowCatIdsQQsacatZQ2d1QQsalocationZatsQQsocmdZListingCategoryList?loct=2" target="_blank">See a list of eBay categories</a>'
	));

	$formBuilder = new core_Form_FormBuilder('yahoo', array('label' => 'Yahoo!', 'collapsable' => true));
	$basicFormBuilder->add($formBuilder);
	$formBuilder->add('yahoo_path', 'text', array('label' => 'Path', 'value' => $yahoo_path, 
		'tooltip' => 'a Yahoo! <em>path</em> is a grouping of products'
	));

	$formBuilder = new core_Form_FormBuilder('price-grabber', array('label' => 'PriceGrabber', 'collapsable' => true));
	$basicFormBuilder->add($formBuilder);

	$formBuilder->add('pricegrabber_category', 'text', array('label' => 'Category', 'value' => $pricegrabber_category, 'tooltip' => 'enter the full breadcrumb to the PriceGrabber category (example: Appliances › Air Cleaners, Heating & Cooling › Air Conditioners) <a href="http://www.pricegrabber.com/home_channelindex.php" target="_blank">See a list of PriceGrabber categories</a>'
	));
	$formBuilder->add('pricegrabber_part_number', 'text', array('label' => 'Part Number', 'value' => $pricegrabber_part_number, 'tooltip' => 'manufacturer model/part#'));
	$formBuilder->add('pricegrabber_item_condition', 'choice', array('label' => 'Item Condition', 'value' => $pricegrabber_item_condition, 'options' => array(
			new core_Form_Option('New', 'New'),
			new core_Form_Option('Like New', 'Like New'),
			new core_Form_Option('Used', 'Used'),
			new core_Form_Option('Refurbished', 'Refurbished'),
			new core_Form_Option('Generic', 'Generic'),
		),
		'tooltip' => 'PriceGrabber requires the product condition (new, used, etc) '
	));

	$formBuilder = new core_Form_FormBuilder('nextag', array('label' => 'Nextag', 'collapsable' => true));
	$basicFormBuilder->add($formBuilder);

	$formBuilder->add('nextag_category', 'text', array('label' => 'Category', 'value' => $nextag_category, 'tooltip' => 'Enter the Nextag category.  You may also use your own although Nextag does not recommend it. <a href="http://merchants.nextag.com/serv/main/buyer/BulkCategoryCodes.jsp" target="_blank">See a list of Nextag categories</a>'));
	$formBuilder->add('nextag_part_number', 'text', array('label' => 'Part Number', 'value' => $nextag_part_number, 'tooltip' => 'manufacturer model/part#. (required only if this product does not have a UPC)'));
	$formBuilder->add('nextag_item_condition', 'choice', array('label' => 'Item Condition', 'value' => $nextag_item_condition, 'options' => array(
			new core_Form_Option('New', 'New'),
			new core_Form_Option('Open Box', 'Open Box'),
			new core_Form_Option('OEM', 'OEM'),
			new core_Form_Option('Refurbished', 'Refurbished'),
			new core_Form_Option('Pre-Owne', 'Pre-Owne'),
			new core_Form_Option('Like New', 'Like New'),
			new core_Form_Option('Good', 'Good'),
			new core_Form_Option('Very Good', 'Very Good'),
			new core_Form_Option('Acceptable', 'Acceptable'),
		),
		'tooltip' => 'the product condition (new, used, etc)',
	));

	$form = $basicFormBuilder->getForm();
	$adminView->assign('form', $form);

	$adminView->render('pages/product/data-export-attributes-tab');
