<?php
	if (!defined("ENV")) exit();

	$adminView = Ddm_AdminView::getInstance();

	$adminView->assign('can_access_inventory', AccessManager::checkAccess('INVENTORY'));

	$formBuilder = new core_Form_FormBuilder('inventory-control');
	$formBuilder->add('inventory_control', 'choice', array('label' => 'Do you want inventory tracking for this item?', 'expanded' => true, 'options' => array(
			new core_Form_Option('No', 'No Inventory Tracking'),
			new core_Form_Option('Yes', 'Track Inventory at product level'),
			new core_Form_Option('AttrRuleInc', 'Track Inventory at attribute level - Track only defined combinations'),
			new core_Form_Option('AttrRuleExc', 'Track Inventory at attribute level - Sell only defined combinations'),
		),
		'value' => $inventory_control,
	));
	$formBuilder->add('inventory_rule', 'choice', array('label' => 'If product / attribute is out of stock', 'options' => array(
			new core_Form_Option('OutOfStock', 'Show "Out of Stock" message'),
			new core_Form_Option('Hide', 'Do not display'),	
		),
		'value' => $inventory_rule,
	));

	$inventoryControlForm = $formBuilder->getForm();
	$adminView->assign('inventoryControlForm', $inventoryControlForm);

	$formBuilder = new core_Form_FormBuilder('inventory-control-product');
	$formBuilder->add('stock', 'integer', array('label' => 'Number of items in inventory', 'value' => $stock));
	$formBuilder->add('stock_warning', 'numeric', array('label' => 'Notify me when inventory is equal to or less than', 'value' => $stock_warning));

	$inventoryControlProductForm = $formBuilder->getForm();
	$adminView->assign('inventoryControlProductForm', $inventoryControlProductForm);

	$adminView->assign('inventory_control', $inventory_control);
	$adminView->assign('inventory_rule', $inventory_rule);
	$adminView->assign('stock', $stock);
	$adminView->assign('stock_warning', $stock_warning);

	$db->query("
		SELECT * FROM ".DB_PREFIX."products_attributes 
		WHERE pid='".$pid."' AND is_active='Yes' AND track_inventory=1 AND (attribute_type='radio' OR attribute_type='select') 
		ORDER BY priority, name, is_modifier
	");
	$inventory_attributes = $db->getRecords();

	$options = array();
	foreach ($inventory_attributes as $attribute)
	{
		$temp = array();
		parseOptions($attribute["options"], $price, $weight, $temp, true);

		$options[] = $temp;
	}

	foreach ($options as $key => $value)
	{
		$inventory_attributes[$key]['options'] = $value;
	}

	$adminView->assign('inventory_attributes', $inventory_attributes);

	$formBuilder = new core_Form_FormBuilder('inventory-control-attribute');

	foreach ($inventory_attributes as $key => $attribute)
	{
		$attribute_options = array();
		foreach ($attribute['options'] as $option_key => $option_data)
		{
			$attribute_options[] = new core_Form_Option(gs($option_key), gs($option_key));
		}

		$formBuilder->add('inv_attribute_option['.$attribute['paid'].']', 'choice', array('label' => 'Attribute "<b>'.gs($attribute['name']).'</b>"', 'options' => $attribute_options,
		));
	}

	$formBuilder->add('inv_attr_subid', 'text', array('label' => 'Product Sub Id'));
	$formBuilder->add('inv_attr_stock', 'integer', array('label' => 'Number of items in inventory', 'value' => 10));
	$formBuilder->add('inv_attr_stock_warning', 'numeric', array('label' => 'Notify me when inventory is equal to or less than', 'value' => 0));
	$formBuilder->add('inv_attr_active', 'checkbox', array('label' => 'Activate these settings?', 'value' => '1', 'current_value' => '1'));

	$inventoryControlAttributeForm = $formBuilder->getForm();
	$adminView->assign('inventoryControlAttributeForm', $inventoryControlAttributeForm);


	$db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pid='".intval($pid)."'");
	$sub_products = $db->getRecords();

	$adminView->assign('sub_products', $sub_products);
	$adminView->assign('product_delete_inv_record_nonce', create_nonce('product_delete_inv_record'));

	$adminView->render('pages/product/product-inventory-tab');