<?php
	if (!defined("ENV")) exit();
	///////////////////////////////////////////
	// inherit basic niode & override drawNode
	class OPTION_PARAM{
		var $parent_id;
		var $level;
		function OPTION_PARAM($parent_id, $level){
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE{
		function drawNode($param){
			echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':'').'>';
			for($i=0; $i<$param->level*4; $i++){
				echo "&nbsp;";
			}
			echo gs($this->caption).'</option>';
			if(count($this->nodes)>0){
				reset($this->nodes);
				while(list($id, $node) = each($this->nodes)){
					$node->drawNode(
						new OPTION_PARAM($param->parent_id, $param->level+1)
					);
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Any"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	if($cats_count > 0){
		while($db->moveNext()){
			$tree->addNode(
				new OPTION_NODE(
					$db->col["cid"],
					$db->col["parent"],
					$db->col["level"],
					$db->col["is_visible"],
					$db->col["name"]
				)
			);
		}
	}

	loadJS("cd_product.js");
	pageHeader("Products List", "", "ic_product.gif");

	pageNote(array(
		array("icon"=>"ic_insert_row.gif", "text"=>"<b><a href=\"admin.php?p=product&mode=insert\">Click to Add a New Product</a></b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please enter your search criteria.</b><br>You need to enter at least one search criteria for search results to appear.", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<span style=\"color:#990000\"><b>Please note: There are currently no product categories in database.</b><br>Please add product categories first</span>", "url"=>"", "visible"=>$cats_count < 1)
	));

	$action = isset($action)?trim($action):"";
	$product_id = isset($product_id)?trim($product_id):"";
	$title = isset($title)?trim($title):"";
	$status = isset($status)?trim($status):"";
	$status = in_array($status, array("Yes", "No", "OutOfStock", "StockWarning"))?$status:"";
	$cid = isset($cid)?$cid*1:TREE_ROOT;
	$where = "";
	$sort_products_by = isset($sort_products_by)?$sort_products_by:"title";
	$sort_products_by = in_array($sort_products_by, array("title", "price_minmax", "price_maxmin", "product_id", "priority", "stock"))?$sort_products_by:"title";

	if (isset($_GET['action']) && $_GET['action'] == "search")
	{
		$_SESSION["admin_search_product_url"] = $_SERVER["QUERY_STRING"];
		switch($sort_products_by){
			case "price_minmax" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.call_for_price, ".DB_PREFIX."products.price, ".DB_PREFIX."products.title ";
				break;
			}
			case "price_maxmin" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.call_for_price, ".DB_PREFIX."products.price DESC, ".DB_PREFIX."products.title ";
				break;
			}
			case "product_id" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.product_id ";
				break;
			}
			case "priority" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.priority DESC, ".DB_PREFIX."products.title ";
				break;
			}
			case "stock" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.inventory_control, ".DB_PREFIX."products.stock, ".DB_PREFIX."products.title ";
				break;
			}
			default :
			case "title" : {
				$order_sql = "ORDER BY ".DB_PREFIX."products.title ";
			}
		}

		if($product_id != ""){
			$where .= ($where==""?"WHERE ":" AND ")." product_id LIKE '%".$db->escape($product_id)."%' ";
		}
		if($title != ""){
			$where .= ($where==""?"WHERE ":" AND ")." title LIKE '%".$db->escape($title)."%' ";
		}
		if($status != ""){
			switch($status){
				case "Yes" :
				case "No" : {
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.is_visible = '".$status."' ";
					break;
				}
				case "OutOfStock" : {
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.inventory_control != 'No' AND ".DB_PREFIX."products.stock = 0 ";
					break;
				}
				case "StockWarning" : {
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.inventory_control != 'No' AND ".DB_PREFIX."products.stock <= stock_warning ";
					break;
				}
			}
		}

		//preselect
		$db->query("
			SELECT * FROM ".DB_PREFIX."products
			".($cid != TREE_ROOT?"INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid=".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".$cid."'":"")."
			".$where."
			GROUP BY ".DB_PREFIX."products.pid
		");

		//$db->query("SELECT * FROM ".DB_PREFIX."products ".$where);
		//calc page breaks
		$ccc = 20;
		$items_count = $db->numRows();
		$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
		$pg = isset($pg)?($pg*1):1;
		$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
		$pages_line = format_pages_line(
			$pg, // current pare
			$pages_count, // total pages
			7,
			"admin.php?p=products".
				"&action=search".
				"&cid=".urlencode($cid).
				"&product_id=".urlencode($product_id).
				"&title=".urlencode($title).
				"&status=".$status.
				"&sort_products_by=".$sort_products_by
		);
		//select
		$db->query("
			SELECT * FROM ".DB_PREFIX."products
			".($cid != TREE_ROOT?"INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid=".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".$cid."'":"")."
			".$where."
			GROUP BY ".DB_PREFIX."products.pid
			".$order_sql."
			LIMIT ".(($pg-1)* $ccc).", ".$ccc
		);
	}
	else{
		$reset_search = isset($_REQUEST["reset_search"])?true:false;

		if($reset_search && session_is_registered("admin_search_product_url"))
		{
			session_unregister("admin_search_product_url");
		}
		elseif(session_is_registered("admin_search_product_url") && trim($_SESSION["admin_search_product_url"]) != "")
		{
			header("Location: admin.php?".$_SESSION["admin_search_product_url"]);
		}
	}
?>
<div class="searchFormTitle">Search Products</div>
<form action="admin.php?p=products" method="GET" style="padding:0px;margin:0px;">
	<input type="hidden" name="p" value="products">
	<input type="hidden" name="action" value="search">

<div class="searchFormBody">
	<div class="searchFormLine">
		<div class="searchFormItem">
			Product ID:<br/>
			<input type="text" name="product_id" style="width:210px;" value="<?=htmlspecialchars($product_id)?>"/>
		</div>
		<div class="searchFormItem">
			Product Name:<br/>
			<input type="text" name="title" style="width:210px;" value="<?=htmlspecialchars($title)?>"/>
		</div>
	</div>
	<div class="searchFormLine">
		<div class="searchFormItem">
			Category:<br/>
			<select name="cid" style="width:210px;">
<?	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM($cid, 0)
	);?>
			</select>
		</div>
		<div class="searchFormItem">
			Status :<br>
			<select name="status" style="width:210px;">
				<option value="any">Any</option>
				<option value="Yes" <?=$status=="Yes"?"selected":""?>>Available</option>
				<option value="No" <?=$status=="No"?"selected":""?>>Unavailable</option>
				<option value="OutOfStock" <?=$status=="OutOfStock"?"selected":""?>>Out of stock</option>
				<option value="StockWarning" <?=$status=="StockWarning"?"selected":""?>>Stock warning</option>
			</select>
		</div>
	</div>
	<div class="searchFormLine">
		<div class="searchFormItem">
			Sort by :<br>
			<select name="sort_products_by" style="width:210px;">
				<option value="title">Product name</option>
				<option value="price_minmax" <?=$sort_products_by=="price_minmax"?"selected":""?>>Unit price (min-max)</option>
				<option value="price_maxmin" <?=$sort_products_by=="price_maxmin"?"selected":""?>>Unit price (max-min)</option>
				<option value="product_id" <?=$sort_products_by=="id"?"selected":""?>>Product ID</option>
				<option value="priority" <?=$sort_products_by=="priority"?"selected":""?>>Priority</option>
				<option value="stock" <?=$sort_products_by=="stock"?"selected":""?>>Stock</option>
			</select>
		</div>
		<div class="searchFormItem">
			&nbsp;
		</div>
	</div>
	<div class="searchFormBottom">
		<div class="searchFormItem">
			<input type="submit" value="Search" style="width:120px;height:25px;"/>
		</div>
		<div class="searchFormItem">
			<a href="admin.php?p=products&reset_search=true">Reset Search</a>
		</div>
	</div>
</div>
</form>

<?	if($action == "search"){?>
<div class="listHeader">
	<div class="listHeaderIcon"><img src="images/icons/ic_search.gif"/></div>
	<div class="listHeaderCaption">
		Product Search Results
	</div>
<?php	if($db->numRows() > 0){?>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Products found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
<?php	}?>
</div>
<?php	if($db->numRows() > 0){?>
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:120px;">Product ID</div>
	<div class="listHeaderCaption" style="width:300px;">Product Name</div>
	<div class="listHeaderCaption" style="width:100px;">Available</div>
	<div class="listHeaderCaption" style="width:100px;">Price</div>
	<div class="listHeaderCaption" style="width:100px;">Stock</div>
</div>
<?php		while ($db->moveNext()) {?>

<div class="listItem">
	<div class="listItemIcon"><img src="images/icons/<?=$db->col["is_doba"] == "Yes"?"ic_doba":"ic_product"?>.gif"/></div>
	<div class="listItemText" style="width:120px;"><a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><?=htmlspecialchars($db->col["product_id"])?></a></div>
	<div class="listItemText" style="width:300px;"><a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><?=htmlspecialchars($db->col["title"])?></a></div>
	<div class="listItemText" style="width:100px;"><?=$db->col["is_visible"]?></div>
	<div class="listItemText" style="width:100px;"><?=$db->col["call_for_price"]=="Yes"?"Call for price":getAdminPrice($db->col["price"])?></div>
	<div class="listItemText" style="width:100px;"><?=$db->col["inventory_control"]=="Yes"?$db->col["stock"]:"-"?></div>
	<div class="listItemButtons">
		<a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><img src="images/icons/ic_change_text.gif" border="0" title="Edit Product"></a>
		<a href="admin.php?p=product&mode=insert&pid=<?=$db->col["pid"]?>"><img src="images/icons/ic_product_add.gif" border="0" title="Use as a Template"></a>
		<a href="javascript:ConfirmDeleteProduct(<?=$db->col["pid"]?>)"><img src="images/icons/ic_delete.gif" border="0" title="Delete Product"></a>
	</div>
</div>
<?			}?>

<div class="listFooter">
	<div class="listFooterCaption" style="float:left;font-weight:normal;">
	<form action="admin.php?p=search_export&chart=true" method="POST" target="_blank" style="padding:0px;margin:0px;">
		<input type="hidden" name="where" value="<?=$where?>">
		<input type="hidden" name="action" value="export">
		<input type="hidden" name="cid" value="<?=$cid?>">
		<input type="hidden" name="export_what" value="products">
		<input type="submit" style="width: 120px; height: 25px;" value="Export to CSV"/>
	</form>
	</div>
	<div class="listFooterCaption" style="float:right;font-weight:normal;">
		Products found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>

<?		}
		else{?>
<div class="listEmpty">
	Your search did not produce any results. Please try again with a different search criteria.<br/>
	<a href="admin.php?p=products&reset_search=true">Reset Search</a>
</div>
<?
		}
	}
?>