<?php
/**
 * Product attribute
 */
	if (!defined("ENV")) exit();

	loadJS("cf_attribute.js");
	$mode = isset($mode)?trim($mode):"insert";
	pageHeader("Global Product Attributes", $mode, "ic_attribute.gif");

	if (_ACCESS_ATTRIBUTES && _ACCESS_ALL)
	{

		if ($settings["CatalogCategorySpecificAttribute"] == "YES")
		{
			///////////////////////////////////////////
			// inherit basic node & override drawNode
			class OPTION_PARAM
			{
				var $categories;
				var $level;
				function OPTION_PARAM(&$categories, $level)
				{
					$this->categories = $categories;
					$this->level = $level;
					return $this;
				}
			}
	
			class OPTION_NODE extends DB_TREE_NODE
			{
				function drawNode($param)
				{
					echo '<option value="'.$this->id.'" '.(in_array($this->id, $param->categories)?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					for ($i=0; $i<$param->level*4; $i++)
					{
						echo "&nbsp;";
					}
					echo htmlspecialchars($this->caption);
					echo '</option>';
					if (count($this->nodes)>0)
					{
						reset($this->nodes);
						while (list($id, $node) = each($this->nodes))
						{
							$node->drawNode(
								new OPTION_PARAM($param->categories, $param->level+1)
							);
						}
					}
				}
			}
		}
	
		$gaid = isset($gaid)?$gaid*1:0;
		switch ($mode)
		{
			case "update" : 
			{
				$db->query("SELECT * FROM ".DB_PREFIX."global_attributes WHERE gaid='".$gaid."'");
				if ($db->moveNext())
				{
					$is_active = $db->col["is_active"];
					$priority = $db->col["priority"];
					$name = $db->col["name"];
					$caption = $db->col["caption"];
					$options = $db->col["options"];
					$attribute_type = $db->col["attribute_type"];
					$text_length = $db->col["text_length"];
					if ($settings["CatalogCategorySpecificAttribute"] == "YES")
					{
						$is_global = $db->col["is_global"];
						if ($is_global == "Yes")
						{
							$categories = array("global");
						}
						else
						{
							$categories = array();
							$db->query("SELECT * FROM ".DB_PREFIX."catalog_attributes WHERE gaid='".$gaid."'");
							while ($db->moveNext())
							{
								$categories[count($categories)] = $db->col["cid"];
							}
						}
					}
					else
					{
						$is_global = "Yes";
					}
					break;
				}
			}
			case "insert" : 
			{
				$is_global = "Yes";
				$is_active = "No";
				$priority = 5;
				$name = "";
				$caption = "";
				$options = "";
				$attribute_type = "select";
				$text_length = 20;
				if ($settings["CatalogCategorySpecificAttribute"] == "YES")
				{
					$categories = array("global");
				}
				break;
			}
		}
	
		if ($settings["CatalogCategorySpecificAttribute"] == "YES")
		{
			//load categories
			$tree = new DB_TREE();
			$tree->collection[TREE_ROOT] = (new OPTION_NODE("global", -1, 0, "Yes",  "Global attribute"));
	
			$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
			while ($db->moveNext())
			{
				$tree->addNode(
					new OPTION_NODE(
						$db->col["cid"], 
						$db->col["parent"], 
						$db->col["level"], 
						$db->col["is_visible"],
						$db->col["name"]
					)
				);
			}
		}
	
		if ($settings["CatalogCategorySpecificAttribute"] == "YES")
		{
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"<b>This section allows you to create an attribute that will appear every time you add a product.<br/>This attribute WILL NOT be active until you select it under the Global Attribute section on the Add Product page</b>", "url"=>"", "visible"=>true),
				array("icon"=>"ic_hint.gif", "text"=>"<b>Note: please select the parent and children categories for attributes.</b>", "url"=>"", "visible"=>true),
			));
		}
		else
		{
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"This section allows you to create an attribute that will appear every time you add a product. This attribute WILL NOT be active until you select it under the Global Attribute section on the Add Product page", "url"=>"", "visible"=>true)
			));
		}
?>
<form name="frmAttribute" action="admin.php?p=products_attribute_process" method="post" onsubmit="return CheckAttributeForm(this)">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="gaid" value="<?=$gaid?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-attr">
<?php 
		pageTabs(array(
			array("title"=>"Product Attribute Properties", "id"=>"main"),
		), "tabs-attr", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<table width="100%" cellpadding="0" cellspacing="5" border="0">

<?php
		if ($settings["CatalogCategorySpecificAttribute"] == "YES")
		{
?>
					<tr>
						<td class="formHeader" colspan="2">
							<div class="formHeaderIcon"><img src="images/icons/ic_folder.gif"></div>
							<div class="formHeaderText">Product Categories</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Select Categories Attribute Will Be Applied To</b></td>
						<td class="formItemControl">
							<select name="categories[]" style="width:100%;" size="10" multiple>
<?php
			$tree->collection[TREE_ROOT]->drawNode(
				new OPTION_PARAM($categories, 0)
			);
?>
							</select>
							<div class="formItemComment">Use Ctrl button to select multiple categories</div>
						</td>
					</tr>
<?php
		}
		else
		{
?>
					<input type="hidden" name="categories[]" value="global">
<?php
		}
?>
					<tr>
						<td class="formHeader" colspan="2">
							<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
							<div class="formHeaderText">Global Product Attributes Settings</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Attribute Name</b></td>
						<td class="formItemControl">
							<input type="text" name="name" style="width:250px;" maxlength="255" value="<?=htmlspecialchars($name)?>">
						</td>
					</tr>
						<tr valign="top">
						<td class="formItemCaption"><b>Input Caption</b></td>
						<td class="formItemControl"><input type="text" name="caption" style="width:250px;" maxlength="255" value="<?=htmlspecialchars($caption)?>"></td>
					</tr>
					<tr>
						<td class="formItemCaption">Default Priority (used for sorting)</td>
						<td class="formItemControl">
							<select name="priority" style="width:123px;">
<?php
		for ($i=1; $i<=10; $i++)
		{
?>
					<option value="<?=$i?>" <?=$i==$priority?"selected":""?>><?=$i?></option>
<?php
		}
?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Is this attribute active for products?</td>
						<td class="formItemControl">
							<select name="is_active" style="width:123px;">
								<option value="Yes">Yes</option>
								<option value="No" <?=$is_active=="No"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Choose an Attribute Type</b></td>
						<td class="formItemControl">
							<select name="attribute_type" style="width:123px;" onChange="switchAttrType(this)">
								<option value="select">Drop-Down Box</option>
								<option value="radio" <?=$attribute_type=="radio"?"selected":""?>>Radio buttons</option>
								<option value="text" <?=$attribute_type=="text"?"selected":""?>>Text Input</option>
								<option value="textarea" <?=$attribute_type=="textarea"?"selected":""?>>Textarea Input</option>
							</select>
						</td>
					</tr>
				</table>
				
				<div id="attrDivSelect" style="display:<?=$attribute_type=="select"?"block":"none"?>">
					<table width="100%" cellpadding="0" cellspacing="5" border="0">
						<tr>
							<td class="formHeader" colspan="2">
								<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
								<div class="formHeaderText">Drop-Down Box Attribute Parameters</div>
							</td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption"><b>Options list </b> (value per line) :</td>
							<td class="formItemControl">
								<textarea wrap="off" class="no-mce" name="options" style="width:100%;height:100px;"><?=htmlspecialchars($options)?></textarea>
							</td>
						</tr>
					</table>
					<table width="100%" cellpadding="0" cellspacing="5" border="0">
						<tr valign="top">
							<td colspan="2" style="padding-left:26px;padding-top:5px;padding-bottom:10px;padding-right:15px;text-align:justify" class="formHelp" align="justify">
								You are allowed to enter an unlimited number of attributes to any product. 
								Attributes allow you to give your customer's choices for any product. 
								Examples include size, color, or type. Each new selection must be entered on a new line for it to appear correctly. 
								If the attribute is a price modifier, you need to tell the system to increase or decrease the price (+ or -) 
								between parenthesis ( ) at the end of each attribute. You may use actual amounts or percentages. 
								You can also modify shipping weight on an attribute by entering the increase or decrease after the price and 
								separated by a comma. Examples below.<br/><br/>
								<table width="100%" cellpadding="0" cellspacing="0">
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;" width="40%">Small(-25,-0.25)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Decrease price by 25, decrease weight by 0.25</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">Medium(-10%,+1)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Decrease price by 10%, increase weight by 1</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">Large(0,+2)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Price will remain the same, increase weight 2</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">X-Large(+10.00)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Increase price by 10</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</div>
				<div id="attrDivRadio" style="display:<?=$attribute_type=="radio"?"block":"none"?>">
					<table width="100%" cellpadding="0" cellspacing="5" border="0">
						<tr>
							<td class="formHeader" colspan="2">
								<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
								<div class="formHeaderText">Radio Button Parameters</div>
							</td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption"><b>Options list </b> (value per line) :</td>
							<td class="formItemControl">
								<textarea wrap="off" class="no-mce" name="options_radio" style="width:100%;height:100px;"><?=htmlspecialchars($options)?></textarea>
							</td>
						</tr>
					</table>
					<table width="100%" cellpadding="0" cellspacing="5" border="0">
						<tr valign="top">
							<td colspan="2" style="padding-left:26px;padding-top:5px;padding-bottom:10px;padding-right:15px;text-align:justify" class="formHelp" align="justify">
								You are allowed to enter an unlimited number of attributes to any product. 
								Attributes allow you to give your customer's choices for any product. 
								Examples include size, color, or type. Each new selection must be entered on a new line for it to appear correctly. 
								If the attribute is a price modifier, you need to tell the system to increase or decrease the price (+ or -) 
								between parenthesis ( ) at the end of each attribute. You may use actual amounts or percentages. 
								You can also modify shipping weight on an attribute by entering the increase or decrease after the price and 
								separated by a comma. Examples below.<br/><br/>
								<table width="100%" cellpadding="0" cellspacing="0">
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;" width="40%">Small(-25,-0.25)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Decrease price by 25, decrease weight by 0.25</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">Medium(-10%,+1)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Decrease price by 10%, increase weight by 1</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">Large(0,+2)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Price will remain the same, increase weight 2</td>
									</tr>
									<tr>
										<td style="font-family:Courier;border-bottom:1px dashed #d0d0d0;">X-Large(+10.00)</td>
										<td style="border-bottom:1px dashed #d0d0d0;" class="formHelp">Increase price by 10</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</div>
				<div id="attrDivText" style="display:<?=$attribute_type=="text"?"block":"none"?>">
					<table width="100%" cellpadding="0" cellspacing="5" border="0">
						<tr>
							<td class="formHeader" colspan="2">
								<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
								<div class="formHeaderText">	Text Input Attribute Parameters</div>
							</td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption"><b>Text Length</b></td>
							<td class="formItemControl">
								<input type="text" name="text_length" value="<?=$text_length?>" style="width:123px;">
							</td>
						</tr>
					</table>
				</div>
<?php
		if($settings["CatalogCategorySpecificAttribute"] == "YES")
		{
?>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formHeader" colspan="2">
							<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
							<div class="formHeaderText">Choose Update Mode</div>
						</td>
					</tr>
					<tr valign="top">
						<td style="width:20px;padding-left:26px;padding-top:7px;"><input type="radio" name="update_mode" value="save" checked></td>
						<td style="padding-top:10px;padding-bottom:10px;">
							<b>Just Save Attribute</b> - 
							attribute data will saved into your database, but it will not make any effects on product attributes.
						</td>
					</tr>
					<tr valign="top">
						<td style="width:20px;padding-left:26px;padding-top:7px;"><input type="radio" name="update_mode" value="rewrite"></td>
						<td style="padding-top:10px;padding-bottom:10px;">
							<b>Bulk Update</b> - 
							attribute will be updated or/and assigned with all products globally or in selected categories.
							Attribute data will be updated, too.
						</td>
					</tr>
<?php
			if($mode=="update")
			{
?>
					<tr valign="top">
						<td style="width:20px;padding-left:26px;padding-top:7px;"><input type="radio" name="update_mode" value="reassign"></td>
						<td style="padding-top:10px;padding-bottom:10px;">
							<b>Re-assign Attribute</b> - 
							attribute data will be saved, and will be assigned with products whose currently <i>do not have</i>	this attribute assigned.
						</td>
					</tr>
					<tr valign="top">
						<td style="width:20px;padding-left:26px;padding-top:7px;"><input type="radio" name="update_mode" value="convert"></td>
						<td style="padding-top:10px;padding-bottom:10px;">
							<b>Remove From List</b> - 
							attribute will be removed from global attributes list, but for products, whose<br> currently have this attribute assigned, 
							data will be saved and attribute will be converted to "Product-Specific"
						</td>
					</tr>
					<tr valign="top">
						<td style="width:20px;padding-left:26px;padding-top:7px;"><input type="radio" name="update_mode" value="delete"></td>
						<td style="padding-top:10px;padding-bottom:10px;">
							<b>Delete Attribute</b> - 
							attribute data will be totally removed as from global attributes list, 
							as from assigned<br> products attributes, too
						</td>
					</tr>
<?php
			}
		}
		else
		{
?>
					<input type="hidden" name="update_mode" value="save">
<?php
		}
?>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes" /> &nbsp;
		<input type="reset" value="Reset form" />
	</div>
</form>
<script type="text/javascript"><!--
	function switchAttrType(sel){
		dSelect = document.getElementById('attrDivSelect');
		dText = document.getElementById('attrDivText');
		dRadio = document.getElementById('attrDivRadio');
		dSelect.style.display = sel.value == "select"?"block":"none";
		dRadio.style.display = sel.value == "radio"?"block":"none";		
		dText.style.display = sel.value == "text"?"block":"none";
	}
--></script>
<?php
	}
	else
	{
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>This feature is not available under your license agreement. Please contact your provider to upgrade your application.</b>", "url"=>"", "visible"=>true)
		));
	}
?>