<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.productgroup.php");
	$mode = isset($_REQUEST["mode"])?trim($_REQUEST["mode"]):"";
	$action = isset($_REQUEST["action"])?trim($_REQUEST["action"]):"";
	$groupid = isset($_REQUEST["group_id"])?trim($_REQUEST["group_id"]):"";
	
	if ($groupid)
	{
		$group = ProductGroup::LoadById($db, $groupid);
		if ($action == "saveGroup")
		{
			$title = isset($_REQUEST["group_title"])?$_REQUEST["group_title"]:null;
			$group->SetTitle($title);
			$group->Save();
		}
	}
	else
	{
		$group = new ProductGroup($db);
	}

	if (DEMO_MODE) $mode = "";
		
	switch ($mode)
	{
		case "getAssignedProducts" :
		{
			$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
			$categories = trim($categories) == "" ? "0" : $categories;
			$categories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";
			$q = "SELECT pid, title FROM ".DB_PREFIX."products where pid in (select pid from ".DB_PREFIX."products_groups_products where group_id = " . $group->GetGroupId() . ") ORDER BY title";
			$db->query($q);
			echo json_encode(array("count"=>$db->numRows(), "products"=>$db->getRecords()));
			exit;
		}
		case "getProducts" :
		{
			$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
			$categories = trim($categories) == "" ? "0" : $categories;
			$categories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";

			if ($categories == "0")
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products where pid not in (select pid from  ".DB_PREFIX."products_groups_products where group_id = " . $group->GetGroupId() . ") ORDER BY title";
			}
			else
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products  where pid not in (select pid from  ".DB_PREFIX."products_groups_products where group_id = " . $group->GetGroupId() . ") and cid IN (".$categories.") ORDER BY title";
			}
			$db->query($q);
			echo json_encode(array("count"=>$db->numRows(), "products"=>$db->getRecords()));
			exit;
		}
		case "assignProducts" :
		{
			if ($group && $group->GetGroupId())
			{
				$products = isset($_GET["products"]) ? $_GET["products"] : "";
				$products = trim($products);
				$products = explode(",",$products);
				foreach ($products as $product)
				{
					$db->reset();
					$db->query("insert into ".DB_PREFIX."products_groups_products (group_id,pid) values(".$group->GetGroupId().",$product)");
				}

				echo json_encode(array("result"=>1));
			}
			else
			{
				echo json_encode(array("result"=>0));
			}
			exit;
		}
		case "unassignProducts" :
		{
			if ($group && $group->GetGroupId())
			{
				$products = isset($_GET["products"]) ? $_GET["products"] : "";
				$products = trim($products);
				$products = explode(",",$products);
				foreach ($products as $product)
				{
					$db->query($q = "delete from ".DB_PREFIX."products_groups_products where group_id=".$group->GetGroupId()." and pid = $product");
				}
				echo json_encode(array("result"=>1));
			}
			else
			{
				echo json_encode(array("result"=>0));
			}
			exit;
		}
	}

	if ($group)
	{
		pageHeader("Product Group Editor: ".$group->GetTitle(),"","ic_folder.gif");
	}
	else
	{
		pageHeader("New Product Group","","ic_folder.gif");
	}
	
	pageNote(array(
		array("icon"=>"ic_globe.gif", "text"=>"Back to Product Groups", "url"=>"admin.php?p=products_groups&amp;", "visible"=>true),
	));
	
	$tree = array(0=>array("cid" => 0, "level" => 0, "is_visible" => "Yes", "key_name" => "", "name" => "All categories"));
	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	
	while($node = $db->moveNext())
	{
			$node["children"] = array();
			$tree[$node["cid"]] = $node;
			$tree[$node["parent"]]["children"][$node["cid"]] = &$tree[$node["cid"]];
	}
	
	function drawTree(&$tree, $level)
	{
		foreach ($tree as $node)
		{
			if (!isset($node["level"]))
			{
				print_r($node);
			}
			if ($node["level"] == $level)
			{
				echo '<option value="'.$node["cid"].'">'.str_repeat("&nbsp;", $node["level"] * 4).htmlspecialchars($node["name"]).'</option>'."\n";
				if (count($node["children"]) > 0)
				{
					drawTree($node["children"], $level + 1);
				}
			}
		}
	}
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-group">
<?php 
	pageTabs(array(
		array("title"=>"Product Group Details", "id"=>"main"),
	), "tabs-group", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
<?php
	if ($group)
	{
?>
			<div class="admin-form-header">Change Group Name</div>
			<form style="padding:0px;margin:0px;" name="frmProductGroups" method="POST" action="admin.php?p=products_group">
				<input type="hidden" name="action" value="saveGroup"/>
				<input type="hidden" name="group_id" id="group_id" value="<?=$groupid?>"/>
				<table cellpadding="0" cellspacing="5" border="0" width="100%">
					<tr valign="top">
						<td class="formItemCaption">Group Name</td>
						<td class="formItemControl">
							<input type="text" name="group_title" style="width:250px" maxlength="255" value="<?=htmlspecialchars($group->GetTitle())?>"/>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes" /> &nbsp;
					<input type="reset" value="Reset form" />
				</div>
			</form>

			<div class="admin-form-header">Manage Group Products</div>
			<table cellpadding="0" cellspacing="10" border="0" width="100%">
				<tr>
					<td width="31%">
						Categories:<br/>
						<select size="24" style="width:100%;" id="selectCategories" name="categories" multiple="multiple">
							<option value="0" selected="selected">All Categories</option>
<?php
		drawTree($tree, 1);
?>
						</select>
					</td>
					<td width="31%">
						Products in selected categories:<br/>
						<select size="24" style="width:100%" id="selectProducts" name="products" multiple="multiple"></select>
					</td>
					<td width="7%" style="text-align:center;">
						<button id="btnAddProduct" style="width:100px;">Add &gt;&gt;</button> <br/> <br/>
						<button id="btnRemoveProduct" style="width:100px;">&lt;&lt; Remove</button> <br/> <br/>
						<button id="btnSaveGroup" disabled="disabled" style="width:100px;">Save</button>
					</td>
					<td width="31%">
						Products in this group:
						<select size="24" style="width:100%" id="selectedProducts" name="selectedProducts" multiple="multiple"></select>
					</td>
				</tr>
			</table>
			<script type="text/javascript" src="content/admin/javascript/products_groups_class.js"></script>
<?php
	}
?>
		</div>
	</div>
</div>