<?php
	if (!defined("ENV")) exit();

	pageHeader("Product Groups", "", "icb-osi-model2");

	pageNote(array(
		array("class"=>"ic-info", "text"=>"<em>Product Groups</em> allow you to group products together for exporting.", "visible"=>true),
		array("class"=>"ic-info", "text"=>"Once the product group has been created, select the Apps Tab to the left and go to Products Import / Export &gt;&gt; Datafeeds and select the group you have created, along with the site you’d like it exported to.", "visible"=>true)
	));
	
	loadJS("cf_product_group.js");
	loadJS("cd_product_group.js");

	require_once("content/classes/class.productgroup.php");
	$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";

	switch ($action)
	{
		case "deleteGroup" :
		{
			if (!DEMO_LOCK)
			{
				$group_id = isset($_REQUEST["group_id"])?intval($_REQUEST["group_id"]):null;
                if ($group_id)
				{
					ProductGroup::DeleteById($db, $group_id);
				}
			}
			break;
		}
		case "addGroup" :
		{
			if (!DEMO_LOCK)
			{
				$title = isset($_REQUEST["group_title"])?$_REQUEST["group_title"]:null;
				$productGroup = new ProductGroup($db);
				$productGroup->SetTitle($title);
				$productGroup->Save();
			}
			header("Location: admin.php?p=products_group&mode=edit&group_id=".$productGroup->GetGroupId());
			_session_write_close();
			die();
			break;
		}
	}

	$productGroups = ProductGroup::LoadAll($db);
	$lastTab = isset($_REQUEST["lastTab"])?$_REQUEST["lastTab"]:null;
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-groups">
<?php 

	pageTabs(array(
		array("title"=>"Product Groups", "id"=>"main"),
		array("title"=>"Add Product Group", "id"=>"add"),
	), "tabs-groups", false);
?>

	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-osi-model2"></span>Manage Product Groups</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th>Group Name</th>
						<th style="width:50px;">&nbsp;</th>
					</tr>
				</thead>
				<tbody>
<?php
	if ($productGroups)
	{
		foreach ($productGroups as $productGroup)
		{
?>
					<tr>
						<td class="icon">&nbsp;</td>
						<td>
							<a href="admin.php?p=products_group&mode=edit&group_id=<?=$productGroup->GetGroupId()?>"><?=htmlspecialchars($productGroup->GetTitle())?></a>
						</td>
						<td>
							<a href="admin.php?p=products_group&mode=edit&group_id=<?=$productGroup->GetGroupId()?>"><img border="0" src="images/icons/a/pencil.png" alt="Click to edit group" title="Edit"/></a>
							<a href="javascript: void(0)" onclick="confirmDeleteGroup('<?=$productGroup->GetGroupId()?>')"><img src="images/icons/a/delete.png" alt="Click to delete group" border="0" title="Delete"/></a>
						</td>
					</tr>
<?php
		}
	}
	else
	{
?>
					<tr>
						<td class="icon">&nbsp;</td>
						<td colspan="2">You do not have any product groups setup.</td>
					</tr>
<?php
	}
?>
				</tbody>
			</table>
		</div>
	</div>
	<div id="admin-tab-sheet-add" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form id="frmAddGroup" action="admin.php?p=products_groups" method="POST" style="margin:0px;padding:0px;" onsubmit="return checkAddProductGroup(this)">
				<input type="hidden" name="action" value="addGroup"/>
				<div class="admin-form-header first"><span class="icon ic-icon ic-add"></span>Product Group Properties</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Product Group Name</td>
						<td class="formItemControl">
							<input type="text" name="group_title" maxlength="255" value=""/>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes" />
					<input type="reset" value="Reset form" />
				</div>
			</form>
		</div>
	</div>
</div>