<?php

	require_once("content/classes/class.products_locations.php");
	require_once("content/classes/class.regions.php");
	
	$productsLocations = new ProductsLocations($db);
	$regions = new Regions($db);
	$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$countries = $regions->getCountriesList();
	
	$countriesStates = $regions->getCountriesStates(true); 
	$mode = isset($_REQUEST["mode"]) ? $_REQUEST["mode"] : "new";
	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	
	$productsLocationId = isset($_REQUEST["products_location_id"]) ? intval($_REQUEST["products_location_id"]) : 0;

	$data = isset($_POST["data"]) ? $_POST["data"] : array();
	
	$message = "";
	/**
	 * Add/update record
	 */
	if (!DEMO_LOCK)
	{
		switch ($action)
		{
			/**
			 * Add a new record
			 */
			case "add" :
			{
				if ($productsLocations->validate($data))
				{
					$productsLocationId = $productsLocations->add($data);
					$mode = "update";
					$message = "New record has been created";
				}
				break;		
			}
			/**
			 * Update record
			 */
			case "update" :
			{
				if ($productsLocations->validate($data, $productsLocationId))
				{
					$productsLocations->update($productsLocationId, $data);
					$message = "Record has been updated";
				}
				break;
			}
		}
	}
	
	/**
	 * Get data for form
	 */
	switch ($mode)
	{
		case "update" :
		{
			if ($data = $productsLocations->getById($productsLocationId))
			{
				$action = "update";
				break;
			}
		}
		default :
		case "add" :
		{
			if ($action != "add")
			{
				$mode = "add";
				$data = array();
				$data["location_type"] = "";
				$data["country"] = "1";
				$data["send_notification"] = "1";
				$data["is_active"] = 1;
				$action = "add";
			}
			break;		
		}
	}
	
	pageHeader("Products Location - ".ucfirst($mode));
	
	$errors = $productsLocations->errors();
	pageNote(array(
		array("text" => "Go back to product locations", "icon"=>"ic_hint.gif", "url"=>"admin.php?p=products_locations", "visible"=>true),
		array("text" => $message, "icon"=>"ic_hint.gif", "url"=>"", "visible"=>$message != ""),
		array("text" => "<b>Please check errors below:</b><br/>".implode("<br/>", $errors?$errors:array()), "icon"=>"ic_error.gif", "url"=>"", "visible"=>$errors)
	));
?>
<form name="frmProductsLocation" action="admin.php?p=products_location" method="post">
	<input type="hidden" name="mode" value="<?=htmlspecialchars($mode)?>"/>
	<input type="hidden" name="action" value="<?=htmlspecialchars($action)?>"/>
	<input type="hidden" name="products_location_id" value="<?=$productsLocationId?>"/>
	<div class="admin-tabs admin-tabs-framed" id="tabs-location">
<?php 
	pageTabs(array(
		array("title"=>"Common Information", "id"=>"common"),
		array("title"=>"Notes &amp; Custom Text, etc", "id"=>"notes")
	), "tabs-location", false);
?>
<script type="text/javascript" src="content/admin/javascript/products_locations.js"></script>
<script type="text/javascript"><!--
	var countriesStates = <?=json_encode($countriesStates)?>;
	var stateId = '<?=isset($data["state"]) ? intval($data["state"]) : 0 ?>';
--></script>
		<div id="admin-tab-sheet-common" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formHeader" colspan="2">
							<div class="formHeaderIcon"><img src="images/icons/ic_globe.gif"></div>
							<div class="formHeaderText">Product Location</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Status</b></td>
						<td class="formItemControl">
							<select name="data[is_active]" style="width:220px;">
								<option value="1" <?=$data["is_active"]=="1"?"selected":""?>>Active</option>
								<option value="0" <?=$data["is_active"]=="0"?"selected":""?>>Disabled</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Name</b></td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[name]" value="<?=htmlspecialchars(isset($data["name"])?$data["name"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Unique ID / Code</b></td>
						<td class="formItemControl"><input style="width:220px;" type="text" name="data[code]" maxlength="100" value="<?=htmlspecialchars(isset($data["code"])?$data["code"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Type</td>
						<td class="formItemControl">
							<select name="data[location_type]" style="width:220px;">
								<option value="drop-shipper" <?=$data["location_type"]=="drop-shipper"?"selected":""?>>Drop shipper</option>
								<option value="warehouse" <?=$data["location_type"]=="warehouse"?"selected":""?>>Warehouse</option>
								<option value="store" <?=$data["location_type"]=="store"?"selected":""?>>Store</option>
								<option value="manufacturer" <?=$data["location_type"]=="manufacturer"?"selected":""?>>Manufacturer</option>
								<option value="distributor" <?=$data["location_type"]=="distributor"?"selected":""?>>Distributor</option>
								<option value="other" <?=$data["location_type"]=="other"?"selected":""?>>Other</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Contact name</b></td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[contact_name]" value="<?=htmlspecialchars(isset($data["contact_name"])?$data["contact_name"]:"")?>"></td>
					</tr>
					
					<tr valign="top">
						<td class="formItemCaption">Address line 1</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[address1]" value="<?=htmlspecialchars(isset($data["address1"])?$data["address1"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Address line 2</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[address2]" value="<?=htmlspecialchars(isset($data["address2"])?$data["address2"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">City / Town</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[city]" value="<?=htmlspecialchars(isset($data["city"])?$data["city"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Country</b></td>
						<td class="formItemControl">
							<select name="data[country]" id="locationCountry">
			<?php				foreach($countries as $countryId => $country)
								{
									echo '<option value="'.$country["coid"].'" '.($country["coid"] == $data["country"] ? 'selected="selected"' : "").'>'.htmlspecialchars($country["name"]).'</option>';
									
								} 
			?>
							</select>
						</td>
					</tr>
					<tr valign="top" id="stateRow">
						<td class="formItemCaption"><b>State / Prov / Trtry</b></td>
						<td class="formItemControl">
							<select name="data[state]" id="locationState"></select>
						</td>
					</tr>
					<tr valign="top" id="provinceRow">
						<td class="formItemCaption"><b>State / Prov / Trtry</b></td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[province]" value="<?=htmlspecialchars(isset($data["province"])?$data["province"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Zip / Postal Code</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[zip]" value="<?=htmlspecialchars(isset($data["zip"])?$data["zip"]:"")?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Phone</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[phone]" value="<?=htmlspecialchars(isset($data["phone"])?$data["phone"]:"")?>"></td>
					</tr>
                    
                    <tr valign="top">
						<td class="formItemCaption">Mobile</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[mobile]" value="<?=htmlspecialchars(isset($data["mobile"])?$data["mobile"]:"")?>"></td>
					</tr>
                    
					<tr valign="top">
                    						<td class="formItemCaption">Contact email address</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[contact_email]" value="<?=htmlspecialchars(isset($data["contact_email"])?$data["contact_email"]:"")?>"></td>
					</tr>
                    <tr valign="top">
                    						<td class="formItemCaption">Location Website</td>
						<td class="formItemControl"><input style="width:220px;" maxlength="100" type="text" name="data[web_location]" value="<?=htmlspecialchars(isset($data["web_location"])?$data["web_location"]:"")?>"></td>
					</tr>
                    
                    
					<tr>
						<td class="formHeader" colspan="2">
							<div class="formHeaderIcon"><img src="images/icons/ic_email.gif"></div>
							<div class="formHeaderText">Notification settings</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Notify facility about new orders?</td>
						<td class="formItemControl">
							<select name="data[send_notification]" style="width:220px;">
								<option value="1" <?=$data["send_notification"]=="1"?"selected":""?>>Yes</option>
								<option value="0" <?=$data["send_notification"]=="0"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Notification email address</td>
						<td class="formItemControl">
							<input style="width:220px;" maxlength="100" type="text" name="data[notify_email]" value="<?=htmlspecialchars(isset($data["notify_email"])?$data["notify_email"]:"")?>">
						</td>
					</tr>
				</table>
			</div>
		</div>
		<div id="admin-tab-sheet-notes" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formHeader">
							<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
							<div class="formHeaderText">Product Location Notes</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemBig">
							<textarea class="no-mce" style="width:100%;height:200px;" name="data[notes]"><?=isset($data["notes"])?htmlspecialchars($data["notes"]):""?></textarea>
						</td>
					</tr>
					<tr>
						<td class="formHeader">
							<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"></div>
							<div class="formHeaderText">Notification Email Custom Text</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemBig">
							<textarea class="no-mce" style="width:100%;height:200px;" name="data[email_text]"><?=isset($data["email_text"])?htmlspecialchars($data["email_text"]):""?></textarea>
							<div class="formItemComment">
								To edit notification email template <a href="admin.php?p=email_notification&id=products_location_notification">please click here</a>.
							</div>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes" /> &nbsp;
		<input type="button" value="Reset Form" />
	</div>
</form>

