<?php
	if (!defined("ENV")) exit();
	
	// If q is set wrong, just go back to the
	// discounts page. -- Ricky26
	if(!isset($q) || $q == NULL)
	{
		header("Location: admin?p=discounts");
		exit();
	}
	
	pageHeader("Edit Local Promotion", "", "icb-cutter");
	
	if(isset($save))
	{
		// Load our post variables -- Ricky26
		$promo_categories = isset($promo_categories) && is_array($promo_categories) ? $promo_categories:array();
		$promo_products = $promo_products == "" ? array() : explode(",", $promo_products);
		
		// Clear out all of the current restraints for this
		// promotion, as we have a new definitive list from the
		// post variables. -- Ricky26
		$db->query("DELETE FROM ".DB_PREFIX."promo_products WHERE pid='".$db->escape($q)."';");
		$db->query("DELETE FROM ".DB_PREFIX."promo_categories WHERE pid='".$db->escape($q)."';");
	
		// Insert the categories -- Ricky26
		$db->reset();
		$db->assignStr("pid", $q);
		foreach ($promo_categories as $v)
		{
			if ($v != "")
			{
				$db->assignStr("cid", $v);
				$db->insert(DB_PREFIX."promo_categories");	
			}		
		}
		
		// Insert the individual products -- Ricky26
		$db->reset();
		$db->assignStr("pid", $q);
		foreach ($promo_products as $v)
		{
			if ($v != "")
			{
				$db->assignStr("prid", $v);
				$db->insert(DB_PREFIX."promo_products");
			}			
		}
	}
	
	// Load the existing categories -- Ricky26
	$categories = array();
	$myPID = $db->escape($q);
	$db->reset();
	$db->query("SELECT * FROM `".DB_PREFIX."promo_categories` WHERE pid='$myPID';");
	while ($db->moveNext())
	{
		$categories[] = $db->col["cid"];
	}
	
	// These classes are helpers that understand the class heirarchy,
	// (basically we get pretty indentation). -- Ricky26
	class OPTION_PARAM
	{
		var $parent_id;
		var $level;
		var $categories;
		
		function OPTION_PARAM($parent_id, $level, $categories = array())
		{
			$this->parent_id = $parent_id;
			$this->level = $level;
			$this->categories = $categories;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			if ($this->id != TREE_ROOT)
			{
				echo '<option value="'.$this->id.'" '.(in_array($this->id, $param->categories)?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
				for ($i=0; $i<$param->level*4; $i++)
				{
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
			}
			if (count($this->nodes)>0)
			{
				reset($this->nodes);
				foreach ($this->nodes as $id => $node)
				{
					$node->drawNode(
						new OPTION_PARAM($param->parent_id, $param->level+1, $param->categories)
					);
				}
			}
		}
	}
	
	// Create the category tree -- Ricky26
	$cats = new DB_TREE();
	$cats->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes",  "None selected"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	while ($db->moveNext())
	{
		$cats->addNode(
			new OPTION_NODE(
				$db->col["cid"], 
				$db->col["parent"], 
				$db->col["level"], 
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	loadJS("cf_promo_edit.js");
	loadJS("cd_product.js");
	loadJS("product_promos.js");
	
	pageNote(array(
		array("class"=>"ic-info", "text"=>"Choose which categories and products apply to this promotion.", "url"=>"",  "visible"=>true),
		array("class"=>"ic-cutter", "text"=>"Go back to the promotions page.", "url"=>"admin.php?p=discounts&last_active_tab=idTabPromo",  "visible"=>true),
	));

	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"cat";
?>
<form id="promoForm" action="admin.php?p=promo_edit&q=<?= urlencode($q) ?>" method="post" onsubmit="return CheckPromoForm(this);">
	<input type="hidden" name="save" value="true" />
	<div class="admin-tabs admin-tabs-framed" id="tabs-promo">
<?php 
	pageTabs(array(
		array("title"=>"Applicable Categories", "id"=>"cat"),
		array("title"=>"Applicable Products", "id"=>"prod"),
	), "tabs-promo", $last_active_tab);
?>
		<div id="admin-tab-sheet-cat" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Category(s) Promotion Will Be Valid In</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Categories</td>
						<td class="formItemControl">
							<select name="promo_categories[]" multiple class="multiselect">
								<? $cats->collection[TREE_ROOT]->drawNode(new OPTION_PARAM(0, -1, $categories)); ?>
							</select>
						</td>
					</tr>
				</table>
			</div>
		</div>
		
		<div id="admin-tab-sheet-prod" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Individual Product(s) That Qualify For The Promotion</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Products</td>
						<td class="formItemControl">
							Type in part of the product name or ID: <br/>
							<div id="inDiv">
								<input type="text" name="searchStr" id="searchStr">
								<input type="hidden" name="searchLimit" id="searchLimit" value="10">
							</div>
							
							<div class="formHelp">
								Our auto search feature will attempt to search your product database as you are entering in the product data
							</div>
							
							<br/>
							
							<input type="hidden" name="promo_products" value="" style="padding:0px;margin:0px;width:1px;height:1px;">
							
							Current products included in the promotion: <br/>
							<select name="select_products[]" class="multiselect" multiple id="select_products">
							<?php
								$db->query("
									SELECT  p.pid, p.product_id, p.title 
									FROM ".DB_PREFIX."promo_products pp
									INNER JOIN ".DB_PREFIX."products p ON p.pid = pp.prid
									WHERE pp.pid='".$db->escape($q)."'
								");
								while ($db->moveNext())
								{
									echo '<option value="'.$db->col["pid"].'">'.gs($db->col["product_id"]." - ".$db->col["title"]).'</option>';
								}
							?>							
							</select>
							<br/>
							<a href="javascript:removeProducts();">Remove Selected</a>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>