<?php
/**
 * Category
 */

	if (!defined("ENV")) exit();

	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			if ($this->id!=$param->id)
			{
				echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?"style='color:gray;'":"").'>';
				for ($i=0; $i<$param->level*4; $i++)
				{
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
				if (count($this->nodes)>0)
				{
					while (list($id, $node) = each($this->nodes))
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	$db->query("SELECT * FROM ".DB_PREFIX."PTIC_catalog ORDER BY ptic_level, ptic_priority, ptic_name");
	while ($db->moveNext())
	{
		$tree->addNode(
			new OPTION_NODE(
				$db->col["ptic_id"],
				$db->col["ptic_parent"],
				$db->col["ptic_level"],
				$db->col["ptic_is_visible"],
				$db->col["ptic_name"]
			)
		);
	}
	//print_r($tree);
	$cid = isset($cid)?$cid*1:"";
	$mode = isset($mode)?trim($mode):"";
	switch ($mode)
	{
		case "update" : 
		{
			//echo "SELECT * FROM ".DB_PREFIX."PTIC_catalog WHERE ptic_id='".$cid."'";
			$db->query("SELECT * FROM ".DB_PREFIX."PTIC_catalog WHERE ptic_id='".$cid."'");
			if ($db->moveNext())
			{

				$name = $db->col["ptic_name"];
				$parent = $db->col["ptic_parent"];
				$description = $db->col["ptic_description"];
				$description_bottom = $db->col["ptic_description_bottom"];
				$priority = $db->col["ptic_priority"];
				$is_visible = $db->col["ptic_is_visible"];
				$list_subcats = $db->col["ptic_list_subcats"];
				$key_name = $db->col["ptic_key_name"];
				$meta_keywords = $db->col["ptic_meta_keywords"];
				$meta_title = $db->col["ptic_meta_title"];
				$meta_description = $db->col["ptic_meta_description"];
				$category_header = $db->col["ptic_category_header"];
				$url_default = $db->col["ptic_url_default"];
				$url_custom = $db->col["ptic_url_custom"];

				break;
			}
		}
		default :
		case "insert" : 
		{
			$mode = "insert";
			$cid = -1;
			$name = "";
			$parent = isset($parent)?$parent:TREE_ROOT;
			$description = "";
			$description_bottom = "";
			$key_name = "";
			$priority = 5;
			$is_visible = "Yes";
			$list_subcats = "No";
			$meta_keywords = "";
			$meta_title = "";
			$meta_description = "";
			$category_header = "";
			$url_default = "will be generated after category saved";
			$url_custom = "";
		}
	}
	loadJS("cf_pticcategory.js");
	loadJS("cd_pticcategory.js");

	pageHeader("Product", ucfirst(strtolower($mode)), "ic_folder_".($mode == "update" ? "edit" : "add").".gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_delete.gif", "text"=>"Remove this PTIC category", "url"=>"JavaScript:ConfirmDeletePticCategory('".$cid."')", "visible"=>$mode=="update")
	));
?>
<form name="frmCategory" action="admin.php?p=pticcategory_process" method="post" onsubmit="return CheckPTICCategoryForm(this)" enctype="multipart/form-data">
	<input type="hidden" name="cid" value="<?=$cid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">

<div class="admin-tabs admin-tabs-framed" id="tabs-category">
<?php 
	pageTabs(array(
		array("title"=>"PTIC Category Properties", "id"=>"main"),
	), "tabs-category", false);
?>
<div id="admin-tab-sheet-main" class="admin-tab-sheet">
	<div class="admin-tab-sheet-wrap">
		<table width="100%" cellpadding="0" cellspacing="0" border="0">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_open_folder.gif"></div>
					<div class="formHeaderText">PTIC Parent Category</div>
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>Select PTIC Parent Category</b></td>
				<td class="formItemControl">
					<select name="parent" style="width:100%;" size="10">
<?php
	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM($cid, $parent, 0)
	);
?>
					</select>
					<div class="formItemComment">
						To add a parent category, highlight Category Root at the top.
						To assign a child category, highlight the category you want the new category appear under
					</div>
				</td>
			</tr>
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"></div>
					<div class="formHeaderText">PTIC Category Properties</div>
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>PTIC Category Name</b></td>
				<td class="formItemControl">
					<input style="width:250px;" type="text" name="name" maxlength="255" value="<?=htmlspecialchars($name)?>">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>PTIC Category Key / ID</b></td>
				<td class="formItemControl">
					<input style="width:250px;" type="text" name="key_name" maxlength="255" value="<?=htmlspecialchars($key_name)?>">
					<div class="formItemComment">
						This will be used for bulk loading products. This might be
						the same as the Category name, but without spaces.
						Example: digital_recorders.
					</div>
				</td>
			</tr>
		</table>
	</div>
</div>
</div>
<div class="admin-form-buttons">
	<input type="submit" value="Save changes" default="default"> &nbsp;
	<input type="reset" value="Reset form">
</div>
</form>
