<?php
/**
 * Handle quick start guide actions
 */

	if (!defined("ENV")) exit();

	if (isset($_REQUEST['action']))
	{
		require_once('content/classes/class.quick_start_guide.php');
		QuickStartGuide::init();

		$form_data = array();
		$post_data = preg_split('/&/', $_REQUEST['data']);

		if (count($post_data) > 1)
		{
			foreach ($post_data as $field)
			{
				list($setting, $value) = preg_split('/=/', $field);
				$form_data[$setting] = urldecode($value);
			}
		}

		switch ($_REQUEST['action'])
		{
			case 'getDialogHTML' :
			{
				echo json_encode(
					array(
						'result' => QuickStartGuide::load()
					)
				);
				break;
			}

			/**
			 * Changes the admin's settings to display the Quick Start Guide on startup or not
			 */
			case 'setDisplayOnStartup' :
			{
				QuickStartGuide::setDisplayOnStartup($_REQUEST['data']);
				break;
			}

			case 'setActivateSearchEngineUrl':
			{
				QuickStartGuide::setActivateSearchEngineUrl($_REQUEST['data']);
			}

			case 'saveCompanyInformation':
			{
				QuickStartGuide::saveCompanyInformation($form_data);
				break;
			}

			case 'saveSeoInformation':
			{
				QuickStartGuide::saveSeoInformation($form_data);
				break;
			}

			case 'saveCategoryLayout':
			{
				$category_layouts = QuickStartGuide::getCategoryLayoutKeys();
				$saveData = array();
				/**
				foreach ($category_layouts as $key)
				{
					//$saveData[$key] =  (array_key_exists($key, $form_data) && $form_data[$key] == '1') ? 'YES' : 'NO';
				}
				**/

				$saveData['CatalogDefaultView'] = $form_data['CatalogDefaultView'];

				QuickStartGuide::saveCategoryLayout($saveData);
				break;
			}

			case 'saveProductLayout':
			{
				QuickStartGuide::saveProductLayout($form_data['CatalogProductPage']);
				break;
			}

			case 'saveCheckoutProcess':
			{
				QuickStartGuide::saveCheckoutProcess($form_data['checkout_process']);
				break;
			}

			case 'removeTestItems':
			{
				echo json_encode(
					array(
						'result' => QuickStartGuide::removeTestItems()
					)
				);

				break;
			}

			case 'addTestItems':
			{
				echo json_encode(
					array(
						'result' => QuickStartGuide::addTestItems()
					)
				);

				break;
			}
		}
	}
