<?php
	if (!defined("ENV")) exit();
?>
<div class="admin-form-header">
	<div class="admin-form-header-buttons">
		<a href="<?php echo $_SERVER["PHP_SELF"]."?".($_SERVER["QUERY_STRING"]);?>&printing" target="_blank" title="Print Report"><span class="icon ic-icon ic-printer"></span></a>
	</div>
	<span class="icon ic-icon ic-list"></span>Payment Types (<?php echo GetReportDate();?>)
</div>
<?php
	$db->query("
		SELECT 
			".DB_PREFIX."orders.*,
			SUM(subtotal_amount) AS subtotal_sum,
			SUM(tax_amount) AS tax_sum,
			SUM(discount_amount + promo_discount_amount) AS discount_sum,
			SUM(shipping_amount + IF(handling_separated='1', handling_amount, 0)) AS shipping_sum,
			SUM(total_amount) AS total_sum,
			COUNT(oid) AS orders_count,
			DATE_FORMAT(".DB_PREFIX."orders.placed_date, '%M %e, %Y') AS report_date
		FROM ".DB_PREFIX."orders 
		LEFT JOIN ".DB_PREFIX."payment_methods ON ".DB_PREFIX."orders.payment_method_id = ".DB_PREFIX."payment_methods.pid
		WHERE 
			".DB_PREFIX."orders.removed='No' AND
			".DB_PREFIX."orders.placed_date >= '".$mysql_from."' AND 
			".DB_PREFIX."orders.placed_date <= '".$mysql_to."' AND 
			".DB_PREFIX."orders.status='Completed' AND 
			".DB_PREFIX."orders.payment_status='Received'
		GROUP BY payment_method_id
		ORDER BY total_sum DESC
	");
	
	if ($db->numRows()>0)
	{
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table admin-stat-table">
	<thead>
		<tr>
			<th class="item-num">#</th>
			<th>Payment Type</th>
			<th class="text-align-right" width="10%">Orders</th>
			<th class="text-align-right" width="10%">Subtotal</th>
			<th class="text-align-right" width="10%">Discount</th>
			<th class="text-align-right" width="10%">Tax</th>
			<th class="text-align-right" width="10%">Shipping</th>
			<th class="text-align-right" width="10%">Total</th>
		</tr>
	</thead>
	<tbody>
<?php
		$subtotal = 0;
		$discount = 0;
		$tax = 0;
		$shipping = 0;
		$total = 0;
		$i = 0;
		
		while ($db->moveNext())
		{
			$subtotal += $db->col["subtotal_sum"];
			$discount += $db->col["discount_sum"];
			$tax += $db->col["tax_sum"];
			$shipping += $db->col["shipping_sum"];
			$total += $db->col["total_sum"];
?>
			<tr>
				<td class="item-num"><?php echo $i+1;?></td>
				<td><?php echo ucfirst($db->col["payment_method_name"]);?></td>
				<td class="text-align-right"><?php echo $db->col["orders_count"];?></td>
				<td class="text-align-right"><?php echo getAdminPrice($db->col["subtotal_sum"]);?></td>
				<td class="text-align-right">-<?php echo getAdminPrice($db->col["discount_sum"]);?></td>
				<td class="text-align-right"><?php echo getAdminPrice($db->col["tax_sum"]);?></td>
				<td class="text-align-right"><?php echo getAdminPrice($db->col["shipping_sum"]);?></td>
				<td class="text-align-right"><?php echo getAdminPrice($db->col["total_sum"]);?></td>
			</tr>
<?php
			$i++;
		}
?>
	</tbody>
	<tfoot>
		<tr>
			<td colspan="3" class="text-align-right">Total:</td>
			<td class="text-align-right"><?php echo getAdminPrice($subtotal);?></td>
			<td class="text-align-right">-<?php echo getAdminPrice($discount);?></td>
			<td class="text-align-right"><?php echo getAdminPrice($tax);?></td>
			<td class="text-align-right"><?php echo getAdminPrice($shipping);?></td>
			<td class="text-align-right"><?php echo getAdminPrice($total);?></td>
		</tr>
	</tfoot>
</table>
<?php
		pageNote(array(
			array("class"=>"ic-info", "text"=>"Discount here is sum of Global Discount and Promo Code Discount", "url"=>"", "visible"=>true),
			array("class"=>"ic-info", "text"=>"Shipping here is sum of Shipping and Handling Amounts", "url"=>"", "visible"=>true)
		));
	}	
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"No data available for selected period", "url"=>"", "visible"=>true)
		));
	}
