<?php
if (!defined("ENV")) exit();

global $settings;

$cc_type = isset($_REQUEST['shift4_cc_type']) ? $_REQUEST['shift4_cc_type'] : '';

$sql = 'SELECT t.extra,
	DATE_FORMAT(t.completed, \''.$settings["LocalizationDateTimeFormat"].'\') as completed,
	t.payment_response,
	t.order_total_amount as processed_amount,
	o.total_amount as order_total_amount,
	CONCAT(CONCAT(u.fname, \' \'), u.lname) as customer_name,
	o.order_num
FROM '.DB_PREFIX.'orders o
	INNER JOIN '.DB_PREFIX.'payment_transactions t on o.oid = t.oid
	LEFT OUTER JOIN '.DB_PREFIX.'users u on o.uid = u.uid
WHERE o.payment_gateway_id = \'shift4i4go\' and t.completed >= \''.$mysql_from.'\' and t.completed <= \''.$mysql_to.'\'
and t.extra <> \'\' and payment_response <> \'timeout\'';

	if (trim($cc_type) != '')
	{
		$sql .= ' and t.payment_response like "%cardtype = '.$cc_type.'%"';
	}
	$sql .= '
order by t.completed
';

$rows = $db->selectAll($sql);

$brandsMap = array(
	'AX' => 'American Express',
	'DC' => 'Diners Club',
	'JC' => 'JC',
	'JCB' => 'JCB',
	'MC' => 'MasterCard',
	'NS' => 'Discover',
	'VS' => 'Visa',
	'DB' => 'Debit',
	'SR' => 'Sears',
	'SC' => 'Sears Canada',
);
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
	<thead>
		<tr>
			<th>Order ID</th>
			<th class="item-num">Invoice</th>
			<th>Customer</th>
			<th>Transaction Date</th>
			<th>Card Type</th>
			<th>CC Last 4</th>
			<th>Transaction Type</th>
			<th>Amount</th>
			<th>Order Total</th>
		</tr>
	</thead>
	<tbody>
<?php
	$processedTotal = 0;
	$ordersTotal = 0;

	$ordersMap = array();

	if (count($rows) > 0)
	{
		foreach ($rows as $row) {
			$cardNumber = '';
			$cardType = '';
			$saleFlag = '';
			$functionRequestCode = '';
			$processedAmount = 0;


			$response_values = explode("\n", $row['payment_response']);
			foreach ($response_values as  $response_value)
			{
				$kvPair = explode(' = ', $response_value);

				if ($kvPair[0] == 'cardnumber')
				{
					$cardNumber = $kvPair[1];
				}
				else if ($kvPair[0] == 'cardtype')
				{
					$cardType = $kvPair[1];
				}
				else if ($kvPair[0] == 'saleflag')
				{
					$saleFlag = $kvPair[1];
				}
				else if ($kvPair[0] == 'functionrequestcode')
				{
					$functionRequestCode = $kvPair[1];
				}
				else if ($kvPair[0] == 'primaryamount')
				{
					$processedAmount = $kvPair[1];
				}
			}

			if ($saleFlag == 'C')
			{
				$processedAmount = 0 - $processedAmount;
			}
			else if (!isset($ordersMap[$row['order_num']]))
			{
				$ordersMap[$row['order_num']] = true;
				$ordersTotal += $row['order_total_amount'];
			}
			$processedTotal += $processedAmount;
	?>
		<tr>
			<td><?php echo $row['order_num']; ?></td>
			<td><?php echo $row['extra']; ?></td>
			<td><?php echo $row['customer_name']; ?></td>
			<td><?php echo $row['completed']; ?></td>
			<td><?php echo array_key_exists($cardType, $brandsMap) ? $brandsMap[$cardType] : $cardType; ?></td>
			<td><?php echo $cardNumber; ?></td>
			<td><?php if ($functionRequestCode == '1B') { ?>
				Authorization
				<?php } else if ($functionRequestCode == '1D') { ?>
					<?php echo $saleFlag == 'C' ? 'Refund' : 'Capture'; ?>
				<?php } else if ($functionRequestCode == '07') { ?>
				Get Invoice
				<?php } else if ($functionRequestCode == '08') { ?>
				Void
				<?php } ?>
			</td>
			<td><?php echo getAdminPrice($processedAmount); ?></td>
			<td><?php echo getAdminPrice($row['order_total_amount']); ?></td>
		</tr>
<?php
		}
	}
	else
	{
?>
		<tr>
			<td colspan="9">
				There are no transactions for the current filter.
			</td>
		</tr>
<?php
	}
?>
		<tr>
			<td colspan="7" style="text-align:right;"><strong>Totals:</strong></td>
			<td>
				<strong><?php echo getAdminPrice($processedTotal); ?></strong>
			</td>
			<td>
				<strong><?php echo getAdminPrice($ordersTotal); ?></strong>
			</td>
		</tr>
	</tbody>
</table>