<?php
	if (!defined("ENV")) exit();

	$group = isset($group)?intval($group):0;
	$settings_groups = array(
		"Company Information" => "",
		"Global Site Settings" => "",
		"Order/Cart Settings" => "",
		"Security Settings" => "",
		"Search Engines Settings" => "",
		"Bestsellers Settings" => "",
		"Wholesale Settings" => "This page is for businesses selling wholesale. Information here will be viewed on the \"Add a Product\" page as well as appearing to buyers on the front end of the website. ".$label_app_name." will calculate pricing using the following method. Case pack x(times) Unit Price",
		"Gift Message" => "",
		"Digital Products" => "",
		"Printable Invoice Settings" => "",
		"Proxy Settings" => "",
		"PCI-DSS/PA-DSS compliance" => "",
		"Captcha" => "",
		//"buySAFE Settings" => "buySAFE Settings"
		"Mobile Site Settings" => "",
	);

	$settings_groups_short = array(
		"Company Information" => "Company contact information that appears<br> in customer communications on your website.",
		"Global Site Settings" => "Administration e-mails, support e-mails, path to SSL and other information about your cart.",
		"Order/Cart Settings" => "Website settings for how visitors interact with your cart.",
		"Security Settings" => "Cookie, timeout and gateway settings.",
		"Search Engines Settings" =>"Set your search engine Meta tags.",
		"Bestsellers Settings" => "Website settings for your most popular products.",
		"Wholesale Settings" => "Advance wholesale settings.",
		"Gift Message" => "Enable or disable gift messaging.",
		"Digital Products" => "Enable or disable digital produces and set download limits.",
		"Printable Invoice Settings" => "Edit company information from the printable invoice page.",
		"Proxy Settings" => "CURL Proxy Settings",
		"PCI-DSS/PA-DSS compliance" => "PCI-DSS/PA-DSS compliance",
		"Captcha" => "Captcha settings",
		//"buySAFE Settings" => "Setup buySAFE features"
		"Mobile Site Settings" => "Mobile site settings"
	);

	$settings_groups_icons = array(
		"Company Information" => "company",
		"Global Site Settings" => "audio-equalizer",
		"Order/Cart Settings" => "shopping-cart",
		"Security Settings" => "security",
		"Bestsellers Settings" => "trophy",
		"Gift Message" => "gift",
		"Digital Products" => "bit",
		"Printable Invoice Settings" => "printer",
		"Proxy Settings" => "proxy-server",
		"PCI-DSS/PA-DSS compliance" => "pci-dss",
		"Captcha" => "eye-open",
		//"buySAFE Settings" => "ic_settings.gif"
		"Mobile Site Settings" => "mobile"
	);

	if ($group == 20 && !(AccessManager::checkAccess('DOWNLOADS')))
	{
		pageHeader("Site Settings", "Digital Downloads", "icb-bit");
		AccessManager::notAllowed();
	}
	else if ($group == 101 && !(AccessManager::checkAccess('MOBILE')))
	{
		pageHeader("Site Settings", "Mobile Site Settings", "icb-mobile");
		AccessManager::notAllowed();
	}
	else
	{
		//check group
		$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' AND group_id='".$group."'");
		if	($db->moveNext())
		{
			$group_name = $db->col["group_name"];
			//prepare page header / descriptions
			$a = array(
				0=>array("class"=>"ic-info", "text"=>"Please note: required fields are in <b>bold</b>.", "url"=>"", "visible"=>true)
			);

			//add settings group description
			if (array_key_exists($group_name, $settings_groups))
			{
				if ($settings_groups[$group_name] != "")
				{
					$a[2] = array("class"=>"ic-info", "text"=>$settings_groups[$group_name], "url"=>"", "visible"=>true);
				}
			}

			if (isset($action))
			{
				if ($action != '')
				{
					$nonce = isset($nonce) ? $nonce : '';
					$nonce_valid = verify_nonce($nonce, 'settings_update_'.intval($group));
					if (!$nonce_valid)
					{
						invalid_nonce_message();
						exit;
					}
				}
				
				//save settings
				if ($action == "update" && !DEMO_LOCK)
				{
					$form = isset($form)?$form:array();
					$check_weak_passwd = false;
					reset($form);

					foreach ($form as $key=>$value)
					{
						if ($key == 'session_save_path' && trim($value) != '')
						{
							if (!is_dir($value) || !is_writable($value))
							{
								$a[]= array("class"=>"ic-warning", "text"=>"<b><span style=\"color:#FF0000;\">PLEASE NOTE: Session Save Path must be a directory and writable. Please ensure the directory is writable.</span></b><br/>".$value, "url"=>"", "visible"=>true);
								continue;  // Ensure can access directory, or won't be able to login
							}
						}

						$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name LIKE '".$db->escape($key)."'");

						if($key == "SecurityForceCompliantAdminPasswords" && $value == "YES")
						{
							$check_weak_passwd = true;
						}
	
						if ($key == "SecurityAdminActivyLogging")
						{
							if ($settings["SecurityAdminActivyLogging"] != $value)
							{
								adminLog("Logging is turned ".($value == "YES" ? "on" : "off"), false, true);
							}
						}

						$settings[$key] = $value;
					}
					$a[]= array("class"=>"ic-info", "text"=>"<b><span style=\"color:#990000;\">Settings has been successfully saved</span></b>", "url"=>"", "visible"=>true);

					if ($check_weak_passwd)
					{
						$weaks = "";
						$db->query("SELECT * FROM ".DB_PREFIX."admins");
						while ($db->moveNext())
						{
							if($db->col["password_history"] != "")
							{
								$ph = unserialize(base64_decode($db->col["password_history"]));

								$ps = array_pop($ph);

								if ($ps["s"] != 1)
								{
									if ($admin_auth_id != $db->col["aid"])
									{
										$weaks .=
											($weaks == "" ? "" : ", ").
											'<a target="_blank" href="admin.php?p=admin&aid='.$db->col["aid"].'">'.htmlspecialchars($db->col["name"]).'</a>';
									}
									else
									{
										$weaks .=
											($weaks == "" ? "" : ", ").
											'<a target="_blank" href="admin.php?p=profile"><b>Your account</b></a>';
									}
								}
							}
						}

						if ($weaks != "")
						{
							 $a[]= array("class"=>"ic-warning", "text"=>"<b><span style=\"color:#FF0000;\">PLEASE NOTE: One or more administrator(s) in the system has a weak password. Please make sure all passwords are updated to stronger passwords.</span></b><br/>".$weaks, "url"=>"", "visible"=>true);
						}
					}
				}
			}

			//display page header
			pageHeader($group_name, '', "icb-".$settings_groups_icons[$group_name]);

			//display page messages
			pageNote($a);
?>
<script type="text/javascript" language="JavaScript" src="content/admin/javascript/jquery.ddm.core.js"></script>
<script type="text/javascript" language="JavaScript">
// checks IP address for Security Settings
function validateMultipleIps(ips)
{
	// flag used for return
	var found_error = false;

	// flag used to check if ip is valid
	var valid = true;

	// holds the ips to validate
	var ipArray = new Array();

	var sanitizedList = new Array();

	// used to determine if the user has entered their IP
	var found_user_ip = false;

	// trim whitespace
	ips = ips.replace(/ /, '');
	ipArray = ips.split(",");
	for (var i = 0; i < ipArray.length; i++)
	{
		var ip = $.trim(ipArray[i]);
		if (ip != '')
		{
			valid = $.ddm.validateIpFormat(
				{
					'ip': $.trim(ipArray[i]),
					'wildcard': true,
					'match_ip': true,
					'user_ip': '<?php echo $_SERVER["REMOTE_ADDR"];?>'
				});
			sanitizedList[sanitizedList.length] = ip;

			// if we receive -1, it means the admin IP matches the IP passed to validate
			if (valid === -1) {
				found_user_ip = true;
			}
			else if (!valid)
			{
				found_error = true;
			}
		}
	}

	if ((found_user_ip && $('select[name="form[SecurityAdminIpRestriction]"]').val() == 'Deny') || (!found_user_ip && $('select[name="form[SecurityAdminIpRestriction]"]').val() == 'Allow' && $.trim($('input[name="form[SecurityAdminIps]"]').val()) != ''))
	{
		alert('You cannot restrict access to yourself. Please check the Security Admin Ips setting.');
		return false;
	} else if (found_error) {
		alert('Please enter correct IP format for Security Admin Ips. if you are unsure, leave blank.');
	}

	$('input[name="form[SecurityAdminIps]"]').val(sanitizedList.join(','));
	return !found_error;
}

$(document).ready(function(){
	if ($('input[name="form[SecurityAdminIps]"]').get(0))
	{
		$('#btn_save_changes').click(function(){
			return validateMultipleIps($('input[name="form[SecurityAdminIps]"]').val());
		});
	}
});

function CheckSettingsForm(frm){
<?php
			$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' ".(trim($group)!=""?(" AND group_id='".$group."'"):"")." ORDER BY group_id, priority");
			while ($db->moveNext())
			{
				//echo $db->col["validation"];
				if (trim($db->col["validation"]) != "")
				{
					switch ($db->col["validation"])
					{
						case "url" : $func = "isText"; break;
						case "string" : $func = "isText"; break;
						case "phone" : $func = "isText"; break;
						case "int" : $func = "isInt"; break;
						case "email" : $func = "isEmail"; break;
						case "number" : $func = "checkNumber"; break;
						case "ip" : $func = 'checkIpAddress'; break;
						case "ordernum" : $func = 'isOrderNumInRange'; break;
					}
?>	if(!<?=$func?>(frm.elements["form[<?=trim($db->col["name"])?>]"].value)){
		alert("Please enter valid value for <?=trim($db->col["name"])?>");
		frm.elements["form[<?=trim($db->col["name"])?>]"].focus();
		return false;
	}
<?php			}
			}
?>
	return true;
}
</script>
<form name="frmSettings" action="admin.php?p=settings&group=<?=urlencode($group)?>" method="post" onSubmit="return CheckSettingsForm(this)">
	<div class="admin-tabs admin-tabs-framed" id="tabs-settings">
<?php 
			pageTabs(array(
					array("title"=>$group_name, "id"=>"settings")
			), "tabs-settings", false);
			//generate script to check form values
?>
		
		<input type="hidden" name="action" value="update">
		<input type="hidden" name="nonce" value="<?=create_nonce('settings_update_'.intval($group));?>" />

		<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
<?php
			$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' ".(trim($group)!=""?(" AND group_id='".$group."'"):"")." ORDER BY group_id, priority");
			$group_name = false;
			$first = true;
			while ($db->moveNext())
			{
				if ($first)
				{
?>
					<div class="admin-form-header first"><span class="icon ic-icon"></span><?=htmlspecialchars($db->col["group_name"])?></div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
<?php
				}
				
				$group_name = $db->col["group_name"];
				$it = strtolower($db->col["input_type"]);
?>
					<tr valign="top">
						<td class="formItemCaption <?=trim($db->col["validation"])!=""?"required":""?>">
							<?=normalizeSettingsName($db->col["name"], $db->col["caption"])?>
						</td>
						<td class="formItemControl">
<?php
				switch($it)
				{
					case "select" : 
					{
						$v = explode(",", $db->col["options"]);
						$short = strtolower($db->col["options"]) == 'yes, no' || strtolower($db->col["options"]) == 'yes,no';
?>							<select name="form[<?=$db->col["name"]?>]" <?php echo $short ? 'class="short"':'';?>>

<?php					for ($i=0; $i<count($v); $i++)
						{
							$v[$i] = trim($v[$i]);
							if ($v[$i] != "")
							{
								echo '<option value="'.$v[$i].'" '.($db->col["value"]==$v[$i]?"selected=\"selected\"":"").'>'.ucfirst(strtolower($v[$i])).'</option>';
							}
						}
?>
							</select>
<?php
						break;
					}
					case "textarea" : 
					{
?>
						<textarea name="form[<?=$db->col["name"]?>]"><?=gs($db->col["value"])?></textarea>
<?php					break;
					}
					
					default :
					case "text" : 
					{
?>
						<input type="text" name="form[<?=$db->col["name"]?>]" value="<?=gs($db->col["value"])?>">
<?php					break;
					}
					
				}
				if (trim($db->col["description"] != ""))
				{
?>
							<div class="formItemComment">
							<?=str_replace("\n",'<br/>', htmlspecialchars(str_replace("<br/>", "\n", $db->col["description"])))?>
							</div>
<?php
				}
?>
						</td>
					</tr>
<?php
				$first = false;
			}
?>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input id="btn_save_changes" type="submit" value="Save changes" />
		<input type="reset" value="Reset form" />
	</div>
</form>
<?php
		}
		else
		{
		pageHeader("Global Cart Settings");
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Please select the cart setting you would like to adjust:</b>", "url"=>"", "visible"=>true)
		));

		$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' GROUP BY group_name ORDER BY group_id");
		$a = array();
?>
<div class="settingsSpace">
	<ul>
<?php
		while ($db->moveNext())
		{
			if ($db->col["group_name"] == "buySAFE Settings") continue;
?>
		<li style="background-image:url('images/icons/<?=$settings_groups_icons[$db->col["group_name"]]?>')">
			<a href="admin.php?p=settings&group=<?=$db->col["group_id"]?>"><?=$db->col["group_name"]?></a>
			<div class="settingsItemComment">
				<?=$settings_groups_short[$db->col["group_name"]]?>
			</div>
		</li>
<?php
			}
?>
		<li style="background-image:url('images/icons/a/world.png')">
			<a href="admin.php?p=settings_intuit">Intuit Anywhere Settings</a>
			<div class="settingsItemComment">Enable / disable Intuit Anywhere, set default settings, etc</div>
		</li>

		<li style="background-image:url('images/icons/a/raster.png')">
			<a href="admin.php?p=settings_qr">QR Codes Settings</a>
			<div class="settingsItemComment">Enable / disable QR Codes, set default settings, etc</div>
		</li>

		<li style="background-image:url('images/icons/a/raster.png')">
			<a href="admin.php?p=settings_widgets">Off-Site Widgets Settings</a>
			<div class="settingsItemComment">Enable / disable Off-Site Widgets, set default settings, etc</div>
		</li>
		
		<li style="background-image:url('images/icons/a/zoom.png')">
			<a href="admin.php?p=settings_search">Search Engine Settings</a>
			<div class="settingsItemComment">Search engine meta tags settings.</div>
		</li>

		<li style="background-image:url('images/icons/a/world.png')">
			<a href="admin.php?p=products_locations">Products Locations Settings</a>
			<div class="settingsItemComment">Setup products shipment notifications for drop shippers, warehouses, stores, etc</div>
		</li>

		<li style="background-image:url('images/icons/a/gear.png')">
			<a href="admin.php?p=settings_wholesale">Wholesale Settings</a>
			<div class="settingsItemComment">Advanced Wholesale Support.</div>
		</li>

		<li style="background-image:url('images/icons/a/envelope.png')">
			<a href="admin.php?p=settings_email">POP3 and SMTP Email Settings</a>
			<div class="settingsItemComment">E-mail settings for SMTP server and for<br> deleting bounced e-mail messages.</div>
		</li>

		<li style="background-image:url('images/icons/a/world.png')">
			<a href="admin.php?p=countries">Country List</a>
			<div class="settingsItemComment">Enable or disable countries you sell your products to. </div>
		</li>

		<li style="background-image:url('images/icons/a/world.png')">
			<a href="admin.php?p=localization">Localization, Languages &amp; Currencies</a>
			<div class="settingsItemComment">Set-up cart date/time, site currencies, change standard messages and add different languages.</div>
		</li>
<?php
			if(IsPrivilege(array("ccs", "all"), $auth_rights))
			{
?>
		<li style="background-image:url('images/icons/a/gear.png')">
			<a href="admin.php?p=settings_ccs">CCS Settings</a>
			<div class="settingsItemComment">Setup payment storage, update password</div>
		</li>
<?php
			}
?>
   		<li style="background-image:url('images/icons/a/gear.png')">
			<a href="admin.php?p=compliance">PCI-DSS/PA-DSS compliance</a>
			<div class="settingsItemComment">PCI-DSS/PA-DSS compliance</div>
		</li>
	</ul>
</div>
<?php
		}
	}
?>
