<?php
	if (!defined("ENV")) exit();

	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	$nonce = isset($_REQUEST["nonce"]) ? $_REQUEST["nonce"] : "";
	
	require_once('content/classes/class.offsite_commerce_campaigns.php');
	
	$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
	
	switch ($action)
	{
		/**
		 * Update ajax status
		 */
		case "update_status" :
		{
			$widgets_active = isset($_REQUEST["widgets_active"]) ? $_REQUEST["widgets_active"] : "";
			if (in_array($widgets_active, array("Yes", "No")))
			{
				$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($widgets_active)."' WHERE name='widgets_active'");
			}
			echo ""; die();
			break;
		}
		
		/**
		 * Update settings
		 */
		case "update_settings" :
		{
			if (!verify_nonce($nonce, "widgets_update_settings"))
			{
				invalid_nonce_message();
				exit;
			}
			$form = isset($_POST["form"]) ? $_REQUEST["form"] : array();
			$form = is_array($form) ? $form : array();
			
			foreach ($form as $name=>$value)
			{
				$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name='".$db->escape($name)."'");
				$settings[$name] = $value;
			}
			$message = "Settings are updated";
			break;
		}
		
		/**
		 * Add a new campaign
		 */
		case "add_campaign" :
		{
			if (!verify_nonce($nonce, "widgets_add_campaign"))
			{
				invalid_nonce_message();
				exit;
			}
			$campaign = isset($_POST["campaign"]) ? $_REQUEST["campaign"] : array();
			$campaign = is_array($campaign) ? $campaign : array();
			$offsite_commerce_campaigns->addCampaign($campaign, "wg");
			$message = "Campaign has been added";
			break;
		}
		
		/**
		 * Update campaigns
		 */
		case "update_campaigns" :
		{
			if (!verify_nonce($nonce, "widgets_update_campaigns"))
			{
				invalid_nonce_message();
				exit;
			}
			$campaigns = isset($_POST["campaigns"]) ? $_REQUEST["campaigns"] : array();
			$campaigns = is_array($campaigns) ? $campaigns : array();
			$offsite_commerce_campaigns->updateCampaigns($campaigns);
			$message = "Campaigns have been update";
			break;
		}
		
		/**
		 * Delete campaign
		 */
		case "delete_campaign" :
		{
			$campaign_id = isset($_REQUEST["campaign_id"]) ? $_REQUEST["campaign_id"] : 0;
			$offsite_commerce_campaigns->deleteCampaign($campaign_id);
			echo ""; die();
			break;
		}
	}
	
	$campaigns = $offsite_commerce_campaigns->getCampaigns("wg");
	
	pageHeader("Widgets Settings", "", "icb-window-gear");
	
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Enable / disable Widgets, set default settings</b>", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>isset($message) ? $message : "", "url"=>"", "visible"=>isset($message))
	));
	
   loadJS("widgets-settings.js");
   loadJS("widgets-marketing.js");
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-widgets">
<?php
	$last_active_tab = isset($_REQUEST["last_active_tab"]) ? $_REQUEST["last_active_tab"] : "main";
	pageTabs(array(
		array("title"=>"Enable / Disable", "id"=>"main"),
		array("title"=>"Campaigns", "id"=>"campaigns"),
		array("title"=>"Settings", "id"=>"settings")
	), "tabs-widgets", $last_active_tab);
?>

	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon"></span>What are Widgets?</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td>
						<div style="padding-left:30px;padding-bottom:10px;">
							The <?php echo $label_app_name;?> widget is designed to help you sell just about anywhere online with ease. 
							Think about it like a really good looking link you can use to drive sales back to your site. 
							Rather than a boring blue hyperlink, this widget allows you to place a bit of code that displays key information about a 
							product (including a photo!) anywhere html can be posted. When a customer sees it, then can click and purchase directly from your site.
							Best of all, if you know a little HTML you can modify these widgets to meet the needs of your business.
							<br/>
							<br/>
							Sizes:<br/>
							<img src="images/admin/widget-sizes.jpg" alt="Widget Sizes"/>
							<br/>
							<br/>
							Below is an example of a widget in a blog:<br/>
							<img src="images/admin/widget-example.jpg" alt="Widget Sizes"/>
						</div>
					</td>
					<td style="min-width:400px;width:400px;" width="300">
						<div class="div-widgets-activate">
							Activate Widgets for your store?<br/>
							<input id="button-widgets-activate" class="<?php echo $settings["widgets_active"] == "Yes" ? "disable" : "";?>" type="button" value="<?php echo $settings["widgets_active"] == "Yes" ? "Disable" : "Activate";?>">
						</div>
						<ol>
							<li>Click the ACTIVATE button above</li>
							<li>Click on the "Campaign" tab</li>
							<li>Create a new Campaign</li>
							<li>Go to "edit product" to grab widget code specific product / campaign</li>
							<li>
								To view results from a campaign, click the
								<a href="admin.php?p=reports&report_type=widgets_campaigns">Statistics &amp; Reports / Reports By Type / Widgets Campaigns</a>
								in the main menu.
							</li>
						</ol>
					</td>
				</tr>
			</table>
		</div>
	</div>
		
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon"></span>Widgets Settings</div>
			<form name="form-qr-settings" id="form-widgets-settings" action="admin.php?p=settings_widgets&last_active_tab=settings" method="post">
				<input type="hidden" name="action" value="update_settings" />
				<input type="hidden" name="nonce" value="<?php echo create_nonce('widgets_update_settings');?>" />
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Default widget type</td>
						<td class="formItemControl">
							<select name="form[widgets_type]">
								<option value="page" <?php echo $settings["widgets_type"] == "page" ? "selected" : "";?>>URL to a product page</option>
								<option value="cart" <?php echo $settings["widgets_type"] == "cart" ? "selected" : "";?>>Add product to a cart link</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Default product image</td>
						<td class="formItemControl">
							<select name="form[widgets_image_type]">
								<option value="product" <?php echo $settings["widgets_image_type"] == "product" ? "selected" : "";?>>Product page image</option>
								<option value="thumb" <?php echo $settings["widgets_image_type"] == "thumb" ? "selected" : "";?>>Thumbnail</option>
								<option value="none" <?php echo $settings["widgets_image_type"] == "none" ? "selected" : "";?>>No image</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Default widget style</td>
						<td class="formItemControl">
							<select name="form[widgets_style]">
								<option value="1" <?php echo $settings["widgets_style"] == "1" ? "selected" : "";?>>Style 1</option>
								<option value="2" <?php echo $settings["widgets_style"] == "2" ? "selected" : "";?>>Style 2</option>
								<option value="3" <?php echo $settings["widgets_style"] == "3" ? "selected" : "";?>>Style 3</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>	
		</div>
	</div>
	
	<div id="admin-tab-sheet-campaigns" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon"></span>Off-Site Commerce Widgets Campaigns</div>
			
			<form name="form-widgets-campaign-new" action="admin.php?p=settings_widgets&last_active_tab=campaigns" method="post">
				<input type="hidden" name="action" value="add_campaign" />
				<input type="hidden" name="nonce" value="<?php echo create_nonce('widgets_add_campaign');?>" />
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table" <?php if ($campaigns) echo 'style="border-radius:5px 5px 0px 0px;border-bottom:none;"'?>>
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th style="width:200px;min-width:200px;">Name</th>
							<th style="min-width:200px;">Description</th>
							<th style="width:200px;min-width:200px;">Date Added</th>
							<th style="width:100px;">&nbsp;</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td>&nbsp;</td>
							<td colspan="4">
								<a href="#" id="link-widgets-campaign-add">Add a new campaign</a>
							</td>
						</tr>
						<tr id="form-widgets-campaign-new" <?php echo $campaigns ? 'class="hidden"' : '';?> style="background:none;">
							<td class="icon"><img src="images/icons/a/add.png"/></td>
							<td><input type="text" name="campaign[name]" style="width:180px;"/></td>
							<td><input type="text" style="width:95%;" name="campaign[description]"/></td>
							<td>&nbsp;</td>
							<td style="text-align:right;"><input type="submit" value="Add" style="width:80px;min-width:80px;padding:3px;"/></td>
						</tr>
					</tbody>
				</table>
			</form>
<?php
	if ($campaigns)
	{
?>
			<form name="form-widgets-campaigns" id="form-widgets-campaigns" action="admin.php?p=settings_widgets&last_active_tab=campaigns" method="post">
				<input type="hidden" name="action" value="update_campaigns" />
				<input type="hidden" name="nonce" value="<?php echo create_nonce('widgets_update_campaigns');?>" />
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table" style="border-radius:0px 0px 5px 5px;border-top:0px;">
					<tbody>
<?php
		foreach ($campaigns as $c)
		{
?>						<tr id="widgets-campaign-<?php echo $c["campaign_id"];?>">
							<td class="icon">
								<input type="hidden" name="campaigns[<?php echo $c["campaign_id"];?>][campaign_id]" value="<?php echo $c["campaign_id"];?>"/>
								<img src="images/icons/a/document.png"/>
							</td>
							<td style="width:200px;">
								<input type="text" class="campaign-name" name="campaigns[<?php echo $c["campaign_id"];?>][name]" value="<?php echo htmlspecialchars($c["name"]);?>" style="width:180px;"/>
							</td>
							<td style="min-width:200px;">
								<input type="text" class="campaign-description" name="campaigns[<?php echo $c["campaign_id"];?>][description]" value="<?php echo htmlspecialchars($c["description"]);?>" style="width:95%;"/>
							</td>
							<td style="width:200px;">
								<?php echo $c["created"];?>
							</td>
							<td style="width:100px;text-align:right;">
								<a href="#" class="link-widgets-campaign-delete" id="link-delete-<?php echo $c["campaign_id"];?>"><img src="images/icons/a/delete.png" border="0" title="Delete Campaign"></a>
								<a href="admin.php?p=reports&report_type=widgets_campaigns"><img src="images/icons/a/list.png" border="0" title="Campaign Statistics"></a>
							</td>
						</tr>
<?php
		}
?>
					</tbody>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
<?php
	}
?>			
		</div>
	</div>
</div>
