<?php
	if (!defined("ENV")) exit();

	$allow_product_level_shipping_price = false;
	$action = isset($action)?trim($action):"";
	$method_names = array(
		"base_weight"=>"Base + Weight",
		"weight"=>"Weight",
		"flat"=>"Flat (per item)",
		"price"=>"Price-based"
	);

	if($allow_product_level_shipping_price){
		$method_names["product_level"] = "At Product Level";
	}

	///////////////////////////////
	//INSERT NEW CUSTOM METHOD
	if($action == "insert_custom" && !DEMO_LOCK){
		$new_carrier_name = isset($new_carrier_name)?trim($new_carrier_name):"Unnamed";
		$new_method_id = isset($new_method_id)?trim($new_method_id):"Unnamed";
		$new_method_name = $method_names[$new_method_id];
		$new_countries = isset($new_countries)?$new_countries:array();
		if(in_array("0", $new_countries) || count($new_countries) == 0){
			$cl = "0";
		}
		else{
			$cl = "";
			for($i = 0; $i < count($new_countries); $i++) $cl = $cl.$new_countries[$i].",";
			if($cl == "") $cl = "0";
		}
		$new_states = isset($new_states)?$new_states:array();
		if(in_array("0", $new_states) || count($new_states) == 0){
			$sl = "0";
		}
		else{
			$sl = "";
			for($i = 0; $i < count($new_states); $i++) $sl = $sl.$new_states[$i].",";
			if($sl == "") $sl = "0";
		}
		$new_priority = isset($new_priority)?$new_priority*1:5;
		$new_hidden = isset($new_hidden)?trim($new_hidden):"Yes";
		$autofill = isset($autofill)?trim($autofill):"No";
		$db->reset();
		$db->assignStr("carrier_id", "custom");
		$db->assignStr("carrier_name", $new_carrier_name);
		$db->assignStr("method_id", $new_method_id);
		$db->assignStr("method_name", $new_method_name);
		$db->assignStr("priority", $new_priority);
		$db->assignStr("country", $cl);
		$db->assignStr("state", $sl);
		$db->assignStr("hidden", $new_hidden);
		$db->assignStr("notes", "");
		$ssid = $db->insert(DB_PREFIX."shipping_selected");
		if($autofill == "Yes" && $new_method_id != "product_level"){
			for($i=0; $i<=3; $i++){
				$db->reset();
				$db->assign("ssid", $ssid);
				$db->assign("rate_min", $i * 10 + 0.01);
				$db->assign("rate_max", ($i+1) * 10);
				if($new_method_id == "price"){
					$db->assign("base", 0);
					$db->assign("price", $i);
				}
				else{
					$db->assign("base", 10 - $i);
					$db->assign("price", 4 - $i);
				}
				$db->insert(DB_PREFIX."shipping_custom_rates");
			}
		}
		if($new_method_id == "product_level"){
			$db->query("UPDATE ".DB_PREFIX."settings SET value='YES' WHERE name='ShippingAtProductLevel'");
		}
		if(in_array($new_method_id, array("base_weight", "weight", "flat", "price"))){?>
<script language="javascript">
	document.location="admin.php?p=shipping_custom_rates&ssid=<?=$ssid?>";
</script>
<?		}
		$show_message = "New custom shipping method has been successfully added!";

	}

	///////////////////////////////
	//UPDATE CUSTOM METHOD
	if($action == "update_custom" && !DEMO_LOCK){
		$carrier_name = isset($carrier_name)?$carrier_name:array();
		$method_id = isset($method_id)?$method_id:array();
		$priority = isset($priority)?$priority:array();
		$hidden = isset($hidden)?$hidden:array();
		$pr_l = false;
		reset($carrier_name);
		foreach($carrier_name as $ssid=>$data){
			$db->reset();
			$db->assignStr("priority", $priority[$ssid]);
			$db->assignStr("hidden", $hidden[$ssid]);
			$db->assignStr("carrier_name", $carrier_name[$ssid]);
			$db->assignStr("method_id", $method_id[$ssid]);
			if($method_id[$ssid] == "product_level"){
				$pr_l = true;
			}
			$db->assignStr("method_name", $method_names[$method_id[$ssid]]);
			$db->assignStr("notes", "");
			$db->update(DB_PREFIX."shipping_selected", "WHERE ssid='".$ssid."'");
		}
		if($pr_l){
			$db->query("UPDATE ".DB_PREFIX."settings SET value='YES' WHERE name='ShippingAtProductLevel'");
		}
		$show_message = "Changes have been successfully saved!";
	}

	///////////////////////////////
	//DELETE CUSTOM METHOD
	if($action == "delete_custom" && !DEMO_LOCK){
		$ssid = isset($ssid)?$ssid*1:0;
		$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE carrier_id='custom' AND ssid='".$ssid."'");
		if($db->moveNext()){
			$db->query("DELETE FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$ssid."'");
			$db->query("DELETE FROM ".DB_PREFIX."shipping_selected WHERE ssid='".$ssid."'");

			$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE method_id='product_level'");
			if($db->moveNext()){
				$db->query("UPDATE ".DB_PREFIX."settings SET value='YES' WHERE name='ShippingAtProductLevel'");
			}
			else{
				$db->query("UPDATE ".DB_PREFIX."settings SET value='NO' WHERE name='ShippingAtProductLevel'");
			}
			$show_message = "Selected custom shipping method has been successfully removed!";
		}
		else{
			$show_message = "Can not remove custom shipping method! Incorrect method ID.";
		}
	}
?>
<div id="idTabSheetCustom" class="<?=$last_active_tab == "idTabCustom"?"sheetActive":"sheetUnactive"?>">
<script type="text/javascript" language="JavaScript">
	statesCustom = new Array();
<?
	$db->query("SELECT * FROM ".DB_PREFIX."states ORDER BY coid, name");
	$i = 0;
	while($db->moveNext()){?>
	statesCustom[<?=$i++?>] = new Array(<?=$db->col["stid"]?>, <?=$db->col["coid"]?>, "<?=$db->col["name"]?>");
<?	}?>
</script>

<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_insert_row.gif"/></div>
			<div class="formHeaderText"><a href="javascript:showHideDiv(document.images.arr2, 'divNewCustom')">Add a new custom shipping method</a></div>
			<div class="formHeaderButtons"><img src="images/icons/ic_arrow_down.gif" style="cursor:pointer;" onClick="showHideDiv(this, 'divNewCustom')" id="arr2" align="right"></div>
		</td>
	</tr>
</table>

<div id="divNewCustom" style="display:none">
<form name="frmNewCustom" action="admin.php?p=shipping" method="post" onSubmit="return CheckNewCustomShippingForm(this)">
	<input type="hidden" name="action" value="insert_custom">
	<input type="hidden" name="last_active_tab" value="idTabCustom">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr valign="top">
		<td class="formItemCaption">Carrier Name</td>
		<td class="formItemControl"><input type="text" name="new_carrier_name"  style="width:250px;"></td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Calculation Method</td>
		<td class="formItemControl">
			<select name="new_method_id" style="width:123px;">
				<option value="base_weight">Base + Weight</option>
				<option value="weight">Weight</option>
				<option value="flat">Flat (per item)</option>
<?	if($allow_product_level_shipping_price){?>
				<option value="product_level">At product level</option>
<?	}?>
				<option value="price">Price-based</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Countries</td>
		<td class="formItemControl">
			<select name="new_countries[]" onChange="updateCustomStates()" multiple size="7" style="width:100%;">
				<option value="0" selected>ALL COUNTRIES</option>
<?	$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE ".DB_PREFIX."countries.available = 'Yes' ORDER BY country_priority DESC, name");
	while($db->moveNext()){?>
				<option value="<?=$db->col["coid"]?>"><?=gs($db->col["name"])?></option>
<?	}?>
			</select>
			<div class="formHelp">Hold down the control key to select multiple categories.</div>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">States/Provinces</td>
		<td class="formItemControl"><select name="new_states[]" style="width:100%;" multiple size="7"></select></td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Priority</td>
		<td class="formItemControl">
			<select name="new_priority" style="width:123px;">
<?		for($i=1; $i<=10; $i++){?>
				<option value="<?=$i?>" <?=$i==5?"selected":""?>><?=$i?></option>
<?		}?>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Hidden</td>
		<td class="formItemControl">
			<select name="new_hidden" style="width:123px;">
				<option value="Yes">Yes</option>
				<option value="No" selected>No</option>
			</select>
		</td>
	</tr>
	<input type="hidden" name="autofill" value="No">
</table>
<div class="formButtons">
	<input type="image" src="images/admin/bt_add_method.gif">
</div>
</form>
</div>

<form name="frmCustom" action="admin.php?p=shipping" method="post" onsubmit="return CheckCustomForm(this)">
	<input type="hidden" name="action" value="update_custom">
	<input type="hidden" name="last_active_tab" value="idTabCustom">

<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_shipping.gif"></div>
			<div class="formHeaderText">Custom shipping costs calculation settings</div>
		</td>
	</tr>
</table>
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption">Carrier name</td>
		<td class="formListHeaderCaption">Calculation method</td>
		<td class="formListHeaderCaption">Country/State</td>
		<td class="formListHeaderCaption">Priority</td>
		<td class="formListHeaderCaption">Hidden</td>
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>
<?	/////////////////////////////////////
	// SELECT STORE CUSTOM METHODS
	$db->query("
		SELECT
			".DB_PREFIX."shipping_selected.*
		FROM ".DB_PREFIX."shipping_selected
		WHERE carrier_id='custom'
		".(!$allow_product_level_shipping_price?" AND method_id <> 'product_level'":"")."
	");

	//////////////////////////////////////
	//IF THERE ARE RESULTS - SHOW THEM
	if($db->numRows()>0){
		$ml = $db->getRecords();
		$j = 0;
		for($i = 0; $i<count($ml); $i++){
			$m = $ml[$i];
			if($m["country"]=="0"){
				$m["country_name"] = "All";
			}
			else{
				$coids = explode(",", $m["country"]);
				$where = "";
				for($k=0; $k<count($coids); $k++){
					if($where != "") $where.=" OR ";
					$where.=" coid = '".$coids[$k]."' ";
				}
				$db->query("SELECT name FROM ".DB_PREFIX."countries WHERE ".$where." ORDER BY country_priority DESC, name");
				$m["country_name"] = "";
				while($db->moveNext()){
					if($m["country_name"] != "") $m["country_name"].=", ";
					$m["country_name"].= $db->col["name"];
				}
			}
			if($m["state"]=="0"){
				$m["state_name"] = "All";
			}
			else{
				$stids = explode(",", $m["state"]);
				$where = "";
				for($k=0; $k<count($stids); $k++){
					if($where != "") $where.=" OR ";
					$where.=" stid = '".$stids[$k]."' ";
				}
				$db->query("SELECT name FROM ".DB_PREFIX."states WHERE ".$where." ORDER BY name");
				$m["state_name"] = "";
				while($db->moveNext()){
					if($m["state_name"] != "") $m["state_name"].=", ";
					$m["state_name"].= $db->col["name"];
				}
			}
?>

	<tr valign="top">
		<input type="hidden" name="cm_id_<?=$m["ssid"]?>" value="<?=$m["ssid"]?>">
		<td class="formListItemIcon"><img src="images/icons/ic_server.gif"></td>
		<td class="formListItemText" width="40%"><input type="text" name="carrier_name[<?=$m["ssid"]?>]" value="<?=htmlspecialchars($m["carrier_name"])?>" style="width:95%;"></td>
		<td class="formListItemText">
			<select name="method_id[<?=$m["ssid"]?>]" style="width:123px;">
				<option value="base_weight">Base + Weight</option>
				<option value="weight" <?=$m["method_id"]=="weight"?"selected":""?>>Weight</option>
				<option value="flat" <?=$m["method_id"]=="flat"?"selected":""?>>Flat (per item)</option>
<?	if($allow_product_level_shipping_price){?>
				<option value="product_level" <?=$m["method_id"]=="product_level"?"selected":""?>>At product level</option>
<?	}?>
				<option value="price" <?=$m["method_id"]=="price"?"selected":""?>>Price-based</option>
			</select>
		</td>
		<td class="formListItemText">
			<i><?=$m["country"]==0?"ALL":$m["country_name"]?> -	<?=$m["state"]==0?"ALL":$m["state_name"]?></i>
		</td>
		<td class="formListItemText">
			<select name="priority[<?=$m["ssid"]?>]" style="width:70px;">
<?			for($pri=1; $pri<=10; $pri++){?>
				<option value="<?=$pri?>" <?=$m["priority"]==$pri?"selected":""?>><?=$pri?></option>
<?			}?>
			</select>
		</td>
		<td class="formListItemText">
			<select name="hidden[<?=$m["ssid"]?>]" style="width:70px;">
				<option value="Yes">Yes</option>
				<option value="No" <?=$m["hidden"]=="No"?"selected":""?>>No</option>
			</select>
		</td>
		<td class="formListItemButtons">
<?			if($m["method_id"]!="product_level"){?>
			<a href="admin.php?p=shipping_custom_rates&ssid=<?=$m["ssid"]?>"><img src="images/icons/ic_shipping_edit.gif" border="0" alt="Edit Shipping Rates for This Method"></a>
<?			}
			else{?>
			<img src="images/zerro.gif" width="16">
<?			}?>
			<a href="javascript:ConfirmDeleteCustomShipping(<?=$m["ssid"]?>)"><img src="images/icons/ic_delete.gif" border="0" alt="Delete Custom Method"></a>
		</td>

	</tr>

<?			$j++;
		}
?>
</table>
<div class="formButtons">
	<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="document.forms['frmCustom'].reset();return false;">
</div>
<?	}
	else{?>
</table>
<div class="formListEmpty">
	<img src="images/icons/ic_hint.gif" align="left" hspace="4">
	<b>No results were found. Please check search criteria</b>
</div>
<?	}?>

</form>
</div>
<script type="text/javascript" language="JavaScript">
	updateCustomStates();
</script>