<?php
	if (!defined("ENV")) exit();

	$ssid = isset($ssid)?$ssid:0;
	
	$method_names = array(
		"base_weight"=>"Base + Weight",
		"weight"=>"Weight",
		"flat"=>"Flat (per item)",
		"price"=>"Price-based"
	);
	$db->query("
		SELECT 
			".DB_PREFIX."shipping_selected.*,
			".DB_PREFIX."countries.name AS country_name,
			".DB_PREFIX."states.name AS state_name
		FROM ".DB_PREFIX."shipping_selected 
		LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."shipping_selected.country
		LEFT JOIN ".DB_PREFIX."states ON ".DB_PREFIX."states.stid = ".DB_PREFIX."shipping_selected.state
		WHERE carrier_id='custom' AND ssid='".$ssid."'
	");
	if($db->moveNext()){
		$method_id = $db->col["method_id"];
		pageHeader("Custom Shipping Rates", "", "ic_shipping_edit.gif");
		loadJS("cf_shipping.js");
		loadJS("cd_shipping.js");
		pageNote(array(
			array("icon"=>"ic_shipping.gif", "text"=>"Carrier Name: <b>".gs($db->col["carrier_name"])."</b><br>Method Name: <b>".gs($method_names[$db->col["method_id"]])."</b>", "url"=>"", "visible"=>true),
			array("icon"=>"ic_globe.gif", "text"=>"Country - State: <b>".gs($db->col["country"]==0?"ALL":$db->col["country_name"])." - ".gs($db->col["state"]==0?"ALL":$db->col["state_name"])."</b>", "url"=>"", "visible"=>true),
		));
		
		
		$action = isset($action)?trim($action):"";
		
		if($action == "insert" && !DEMO_LOCK){
			$new_rate_min = isset($new_rate_min)?$new_rate_min*1:0;
			$new_rate_max = isset($new_rate_max)?$new_rate_max*1:0;
			$new_base = isset($new_base)?$new_base*1:0;
			$new_price = isset($new_price)?$new_price*1:0;
			$new_price_type = isset($new_price_type)?$new_price_type:"amount";
			$db->reset();
			$db->assign("ssid", $ssid);
			$db->assign("rate_min", $new_rate_min);
			$db->assign("rate_max", $new_rate_max);
			$db->assign("base", $new_base);
			$db->assign("price", $new_price);
			$db->assignStr("price_type", $new_price_type);
			$db->insert(DB_PREFIX."shipping_custom_rates");
		}
		
		if($action == "update" && !DEMO_LOCK){
			$rate_min = isset($rate_min)?($rate_min):array();
			$rate_max = isset($rate_max)?($rate_max):array();
			$base = isset($base)?($base):array();
			$price = isset($price)?($price):array();
			reset($rate_min);
			foreach($rate_min as $srid=>$data){
				$db->reset();
				$db->assign("rate_min", $rate_min[$srid]);
				$db->assign("rate_max", $rate_max[$srid]);
				$db->assign("base", $base[$srid]);
				$db->assign("price", $price[$srid]);
				$db->assignStr("price_type", $price_type[$srid]);
				$db->update(DB_PREFIX."shipping_custom_rates", "WHERE srid='".$srid."' AND ssid='".$ssid."'");
			}
		}
		
		if($action == "delete" && !DEMO_LOCK){
			$srid = isset($srid)?$srid:0;
			$db->query("DELETE FROM ".DB_PREFIX."shipping_custom_rates WHERE srid='".$srid."' AND ssid='".$ssid."'");
		}
		pageTabs(array(
			array("title"=>"Please enter rates below", "id"=>"Main", "active"=>true, "width"=>140),
		));
		
?>

<div id="idTabSheetMain" class="admin-tab-sheet" style="padding:0px;margin:0px;">
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<form name="frmCustomRates" action="admin.php?p=shipping_custom_rates&ssid=<?=$ssid?>" method="post" onsubmit="return CheckCustomRatesForm(this)">
	<input type="hidden" name="action" value="update">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
<?		if($method_id == "base_weight"){?>
		<td class="formListHeaderCaption">Min Weight</td>
		<td class="formListHeaderCaption">Max Weight</td>
		<td class="formListHeaderCaption">Base Price</td>
		<td class="formListHeaderCaption">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></td>
<?		}
		if($method_id == "weight"){?>
		<td class="formListHeaderCaption">Min Weight</td>
		<td class="formListHeaderCaption">Max Weight</td>
		<td class="formListHeaderCaption">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></td>
<?		}
		if($method_id == "flat"){?>
		<td class="formListHeaderCaption">Min Items</td>
		<td class="formListHeaderCaption">Max Items</td>
		<td class="formListHeaderCaption">Price Per Item</td>
<?		}
		if($method_id == "price"){?>
		<td class="formListHeaderCaption">Min Amount</td>
		<td class="formListHeaderCaption">Max Amount</td>
		<td class="formListHeaderCaption">Shipping Price</td>
		<td class="formListHeaderCaption">Type</td>
<?		}?>
		<td  class="formListHeaderCaption">&nbsp;</td>
	</tr>

<?
		$db->query("SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$ssid."' ORDER BY rate_min");
		if($db->numRows()>0){
			$j = 0;
			while($db->moveNext()){
?>
	<tr>
		<input type="hidden" name="sr_id_<?=$db->col["srid"]?>" value="<?=$db->col["srid"]?>">
		<td class="formListItemIcon">&nbsp;</td>
		<td class="formListItemText"><input type="text" name="rate_min[<?=$db->col["srid"]?>]" value="<?=$method_id=="flat"?round($db->col["rate_min"]):myNum($db->col["rate_min"])?>" style="width:95%;"></td>
		<td class="formListItemText"><input type="text" name="rate_max[<?=$db->col["srid"]?>]" value="<?=$method_id=="flat"?round($db->col["rate_max"]):myNum($db->col["rate_max"])?>" style="width:95%;"></td>
<?				if($method_id == "base_weight"){?>
		<td class="formListItemText"><input type="text" name="base[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["base"])?>" style="width:95%;"></td>
<?				}
				else{?>
		<input type="hidden" name="base[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["base"])?>">
<?				}?>
		<td class="formListItemText"><input type="text" name="price[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["price"])?>" style="width:95%;"></td>
<?				if($method_id == "price"){?>
		<td class="formListItemText">
			<select name="price_type[<?=$db->col["srid"]?>]" style="width:95%;">
				<option value="amount"><?=$admin_currency["code"]?> (amount)</option>
				<option value="percentage" <?=$db->col["price_type"]=="percentage"?"selected":""?>>% (percentage)</option>
			</select>
		</td>				
<?				}
				else{?>
		<input type="hidden" name="price_type[<?=$db->col["srid"]?>]" value="<?=$db->col["price_type"]?>">
<?				}?>
		<td class="formListItemButtons">
			<a href="javascript:ConfirmDeleteCustomRange(<?=$db->col["ssid"]?>, <?=$db->col["srid"]?>)"><img src="images/icons/ic_delete.gif" border="0"></a>
		</td>
	</tr>
<?				$j++;
			}
?>
	<tr>
		<td class="admin-form-buttons" colspan="<?=$method_id=="base_weight" || $method_id=="price"?"6":"5"?>">
			<input type="submit" value="Save changes" default="default"> &nbsp;
			<input type="reset" value="Reset form">
		</td>
	</tr>
<?
		}
		else{
?>
	<tr>
		<td class="listEmpty" colspan="<?=$method_id=="base_weight"?"6":"5"?>">
			<img src="images/icons/ic_hint.gif" align="left" hspace="4">
			<b>No rates defined yet</b>
		</td>
	</tr>
<?
		}
?>
</form>

	<tr>
		<td colspan="<?=$method_id=="base_weight" || $method_id=="price"?"6":"5"?>" >
			<div class="formHeader" style="width:100%">
				<div class="formHeaderIcon"><img src="images/icons/ic_insert_row.gif"></div>
				<div class="formHeaderText">Add a New Rates Range</div>
			</div>
		</td>
	</tr>
	<tr>
<form name="frmNewCustomRate" action="admin.php?p=shipping_custom_rates&ssid=<?=$ssid?>" method="post" onSubmit="return CheckNewCustomRatesForm(this)">
	<input type="hidden" name="action" value="insert">
		<td class="tt">&nbsp;</td>
		<td class="tt"><input type="text" name="new_rate_min" value="" style="width:95%;"></td>
		<td class="tt"><input type="text" name="new_rate_max" value="" style="width:95%;"></td>
<?		if($method_id == "base_weight"){?>
		<td class="tt"><input type="text" name="new_base" value="" style="width:95%;"></td>
<?		}
		else{?>
		<input type="hidden" name="new_base" value="0">
<?		}?>
		<td class="tt"><input type="text" name="new_price" value="" style="width:95%;"></td>
<?				if($method_id == "price"){?>		
		<td class="tt">
			<select name="new_price_type" style="width:95%;">
				<option value="amount"><?=$admin_currency["code"]?> (amount)</option>
				<option value="percentage">% (percentage)</option>
			</select>
		</td>				
<?				}
				else{?>
		<input type="hidden" name="new_price_type" value="amount">
<?				}?>
		<td class="tt">
			<input type="submit" value=" Add ">
		</td>
</form>
	</tr>
</table>
</div>
<?
		pageNote(array(
			array("icon"=>"ic_settings.gif", "text"=>"Back to Shipping Management page", "url"=>"admin.php?p=shipping", "visible"=>true)
		));
	}
?>