<?php
	if (!defined("ENV")) exit();

	$ssid = isset($_REQUEST['ssid']) ? $_REQUEST['ssid'] : 0;
	
	$method_names = array(
		"base_weight"=>"Base + Weight",
		"weight"=>"Weight",
		"flat"=>"Flat (per item)",
		"price"=>"Price-based"
	);
	
	$db->query("
		SELECT 
			".DB_PREFIX."shipping_selected.*,
			".DB_PREFIX."countries.name AS country_name,
			".DB_PREFIX."states.name AS state_name
		FROM ".DB_PREFIX."shipping_selected 
		LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."shipping_selected.country
		LEFT JOIN ".DB_PREFIX."states ON ".DB_PREFIX."states.stid = ".DB_PREFIX."shipping_selected.state
		WHERE carrier_id='custom' AND ssid='".intval($ssid)."'
	");
	
	if ($db->moveNext())
	{
		$method_id = $db->col["method_id"];
		$carrier_name = isset($_REQUEST['carrier_name']) ? $_REQUEST['carrier_name'] : $db->col['carrier_name'];
		$method_calc_mode = isset($_REQUEST['method_calc_mode']) ? $_REQUEST['method_calc_mode'] : $db->col['method_calc_mode'];
		$new_hidden = isset($_REQUEST['new_hidden']) ? $_REQUEST['new_hidden'] : $db->col['hidden'];
		$new_priority = isset($_REQUEST['new_priority']) ? $_REQUEST['new_priority'] : $db->col['priority'];

		$method_name = $method_names[$db->col["method_id"]];

		pageHeader("Custom Shipping Rates", "", "icb-truck");
		pageNote(array(
			array("class"=>"ic-truck", "text"=>"Back to Shipping Management page", "url"=>"admin.php?p=shipping", "visible"=>true)
		));
		loadJS("cf_shipping.js");
		loadJS("cd_shipping.js");		
		
		$action = isset($action)?trim($action):"";
		
		if (!DEMO_LOCK)
		{
			switch ($action)
			{
				case "insert" :
				{
					$new_rate_min = isset($_REQUEST['new_rate_min']) ? $_REQUEST['new_rate_min'] * 1 : 0;
					$new_rate_max = isset($_REQUEST['new_rate_max']) ? $_REQUEST['new_rate_max'] * 1 : 0;
					$new_base = isset($_REQUEST['new_base']) ? $_REQUEST['new_base'] * 1 : 0;
					$new_price = isset($_REQUEST['new_price']) ? $_REQUEST['new_price'] * 1 : 0;
					$new_price_type = isset($_REQUEST['new_price_type']) ? $_REQUEST['new_price_type'] : "amount";

					$db->reset();
					$db->assign("ssid", $ssid);
					$db->assign("rate_min", $new_rate_min);
					$db->assign("rate_max", $new_rate_max);
					$db->assign("base", $new_base);
					$db->assign("price", $new_price);
					$db->assignStr("price_type", $new_price_type);
					$db->insert(DB_PREFIX."shipping_custom_rates");
					
					break;
				}
				
				case "update-method" :
				{
					$db->reset();
					$db->assignStr('carrier_name', $carrier_name);
					$db->assignStr('method_calc_mode', $method_calc_mode);
					$db->assignStr('priority', $new_priority);
					$db->assignStr('hidden', $new_hidden);
					$db->update(DB_PREFIX."shipping_selected", "WHERE ssid=".$ssid);
				}
				
				case "update-rates" :
				{
					$rate_min = isset($_REQUEST['rate_min']) ? ($_REQUEST['rate_min']) : array();
					$rate_max = isset($_REQUEST['rate_max']) ? ($_REQUEST['rate_max']) : array();
					$base = isset($_REQUEST['base']) ? ($_REQUEST['base']) : array();
					$price = isset($_REQUEST['price']) ? ($_REQUEST['price']) : array();

					reset($rate_min);

					foreach ($rate_min as $srid=>$data)
					{
						if ($method_id == "flat")
						{
							if ($rate_min[$srid] < 1) $rate_min[$srid] = 1;
							if ($rate_max[$srid] < 1) $rate_max[$srid] = 1;
						}
						
						$db->reset();
						$db->assign("rate_min", $rate_min[$srid]);
						$db->assign("rate_max", $rate_max[$srid]);
						$db->assign("base", $base[$srid]);
						$db->assign("price", $price[$srid]);
						$db->assignStr("price_type", $price_type[$srid]);
						$db->update(DB_PREFIX."shipping_custom_rates", "WHERE srid='".intval($srid)."' AND ssid='".intval($ssid)."'");
					}
				}
				
				case "delete" :
				{
					$srid = isset($_REQUEST['srid']) ? $_REQUEST['srid'] : 0;
					$db->query("DELETE FROM ".DB_PREFIX."shipping_custom_rates WHERE srid='".$srid."' AND ssid='".intval($ssid)."'");
				}
			}
		}
	
?>

<div class="admin-tabs admin-tabs-framed" id="tabs-rates">
<?php 
		$last_active_tab = isset($_REQUEST['last_active_tab']) ? trim($_REQUEST['last_active_tab']) : "idTabSettings";
		pageTabs(array(
			array("title"=>"Basic Settings", "id"=>"settings"),	
			array("title"=>"Shipping Rates", "id"=>"rates")
		), "tabs-rates", $last_active_tab);
?>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			
			<form name="frmCustomRates" action="admin.php?p=shipping_custom_rates&ssid=<?php echo intval($ssid);?>" method="post">
				<input type="hidden" name="action" value="update-method"/>
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Shipping Method Settings</div>
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					
					<tr valign="top">
						<td class="formItemCaption">Carrier Name</td>
						<td class="formItemControl"><input type="text" name="carrier_name" value="<?php echo gs($carrier_name) ?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Method Name</td>
						<td class="formItemControl"><?php echo gs($method_name);?></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Calculate shipping based on</td>
						<td class="formItemControl">
							<select name="method_calc_mode">
								<option value="before_discount" >Subtotal before discount</option>
								<option value="after_discount" <?php echo $method_calc_mode == 'after_discount' ? 'selected="selected"' : '';?>>Subtotal after discount</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Country - State</td>
						<td class="formItemControl"><?php echo gs($db->col["country"]==0?"ALL":$db->col["country_name"])." - ".gs($db->col["state"]==0?"ALL":$db->col["state_name"]);?></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Priority</td>
						<td class="formItemControl">
							<select name="new_priority" style="width:123px;">
<?php
		for ($i=1; $i<=10; $i++)
		{
?>
								<option value="<?php echo $i;?>" <?php echo $i==$new_priority?"selected":"";?>><?php echo $i;?></option>
<?php
		}
?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Hidden</td>
						<td class="formItemControl">
							<select name="new_hidden" class="short">
								<option value="Yes" <?php echo $new_hidden != 'No' ? 'selected="selected"' : '';?>>Yes</option>
								<option value="No" <?php echo $new_hidden == 'No' ? 'selected="selected"' : '';?>>No</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes" />
					<input type="reset" value="Reset form" />
				</div>
			</form>
		</div>
	</div>
	<div id="admin-tab-sheet-rates" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form name="frmCustomRates" action="admin.php?p=shipping_custom_rates&ssid=<?php echo intval($ssid);?>&last_active_tab=rates" method="post" onsubmit="return CheckCustomRatesForm(this)">
				<input type="hidden" name="action" value="update-rates"/>
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Shipping Method Rates</div>				
<?php
		$db->query("SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$ssid."' ORDER BY rate_min");
		if ($db->numRows()>0)
		{
?>
				<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
<?php
		if ($method_id == "base_weight")
		{
?>
							<th width="20%">Min Weight</th>
							<th width="20%">Max Weight</th>
							<th width="20%">Base Price</th>
							<th width="20%">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></th>
<?php
		}
		if ($method_id == "weight")
		{
?>
							<th width="20%">Min Weight</th>
							<th width="20%">Max Weight</th>
							<th width="20%">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></th>
<?php
		}
		if ($method_id == "flat")
		{
?>
							<th width="20%">Min Items</th>
							<th width="20%">Max Items</th>
							<th width="20%">Price Per Item</th>
<?php
		}
		if ($method_id == "price")
		{
?>
							<th width="20%">Min Amount</th>
							<th width="20%">Max Amount</th>
							<th width="20%">Shipping Price</th>
							<th width="20%">Type</th>
<?php
		}
?>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
<?php
			$j = 0;
			while ($db->moveNext())
			{
?>
						<tr>
							<td class="icon"><input type="hidden" name="sr_id_<?=$db->col["srid"]?>" value="<?=$db->col["srid"]?>"></td>
							<td><input type="text" name="rate_min[<?=$db->col["srid"]?>]" value="<?=$method_id=="flat"?round($db->col["rate_min"]):myNum($db->col["rate_min"])?>" style="width:95%;"></td>
							<td><input type="text" name="rate_max[<?=$db->col["srid"]?>]" value="<?=$method_id=="flat"?round($db->col["rate_max"]):myNum($db->col["rate_max"])?>" style="width:95%;"></td>
<?php			
				if ($method_id == "base_weight")
				{
?>
							<td><input type="text" name="base[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["base"])?>" style="width:95%;"></td>
<?php
				}
				else
				{
?>
							<input type="hidden" name="base[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["base"])?>">
<?php
				}
?>
							<td><input type="text" name="price[<?=$db->col["srid"]?>]" value="<?=myNum($db->col["price"])?>" style="width:95%;"></td>
<?php
				if ($method_id == "price")
				{
?>
							<td>
								<select name="price_type[<?=$db->col["srid"]?>]" style="width:95%;">
									<option value="amount"><?=$admin_currency["code"]?> (amount)</option>
									<option value="percentage" <?=$db->col["price_type"]=="percentage"?"selected":""?>>% (percentage)</option>
								</select>
							</td>				
<?php
				}
				else
				{
?>
							<input type="hidden" name="price_type[<?=$db->col["srid"]?>]" value="<?=$db->col["price_type"]?>">
<?php
				}
?>
							<td>
								<a href="javascript:ConfirmDeleteCustomRange(<?=$db->col["ssid"]?>, <?=$db->col["srid"]?>)"><img src="images/icons/a/delete.png" alt="Delete Rate" title="Delete Rate" border="0"></a>
							</td>
						</tr>
<?php
				$j++;
			}
?>
					</tbody>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes" />
					<input type="reset" value="Reset form" />
				</div>
			</form>
<?php
		}
		else
		{
			pageNote(array(
				array("class"=>"ic-info", "text"=>"No rates defined yet")
			));
		}
?>				
			<form name="frmNewCustomRate" action="admin.php?p=shipping_custom_rates&ssid=<?php echo intval($ssid)?>&last_active_tab=rates" method="post" onSubmit="return CheckNewCustomRatesForm(this)">
				<input type="hidden" name="action" value="insert">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Add a New Shipping Method Rate</div>
				<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
<?php
		if ($method_id == "base_weight")
		{
?>
							<th width="20%">Min Weight</th>
							<th width="20%">Max Weight</th>
							<th width="20%">Base Price</th>
							<th width="20%">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></th>
<?php
		}
		if ($method_id == "weight")
		{
?>
							<th width="20%">Min Weight</th>
							<th width="20%">Max Weight</th>
							<th width="20%">Price Per <?=ucfirst(strtolower($settings["LocalizationWeightUnits"]))?></th>
<?php
		}
		if ($method_id == "flat")
		{
?>
							<th width="20%">Min Items</th>
							<th width="20%">Max Items</th>
							<th width="20%">Price Per Item</th>
<?php
		}
		if ($method_id == "price")
		{
?>
							<th width="20%">Min Amount</th>
							<th width="20%">Max Amount</th>
							<th width="20%">Shipping Price</th>
							<th width="20%">Type</th>
<?php
		}
?>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td>&nbsp;</td>
							<td><input type="text" name="new_rate_min" value="" style="width:95%;"></td>
							<td><input type="text" name="new_rate_max" value="" style="width:95%;"></td>
<?php
		if ($method_id == "base_weight")
		{
?>
							<td><input type="text" name="new_base" value="" style="width:95%;"></td>
<?php
		}
		else
		{
?>
							<input type="hidden" name="new_base" value="0">
<?php
		}
?>
							<td><input type="text" name="new_price" value="" style="width:95%;"></td>
<?php
		if ($method_id == "price")
		{
?>		
							<td>
								<select name="new_price_type" style="width:95%;">
									<option value="amount"><?=$admin_currency["code"]?> (amount)</option>
									<option value="percentage">% (percentage)</option>
								</select>
							</td>				
<?php
		}
		else
		{
?>
							<input type="hidden" name="new_price_type" value="amount">
<?php
		}
?>
							<td class="tt">
								<input type="submit" value=" Add ">
							</td>
						</tr>
					</tbody>
				</table>
			</form>
		</div>
	</div>
</div>
<?php
	}
?>