<?php
	if (!defined("ENV")) exit();

	$action = isset($action)?trim($action):"";
	
	/**
	 * Activate
	 */
	if ($action == "insureship_activate" && !DEMO_LOCK)
	{
		require_once("content/classes/class.insureship.php");
		$insureShip = new InsureShip($settings["InsureShipAccountId"], $settings["InsureShipApiURL"]);
		if (($accountId = $insureShip->activate($_POST["form"])) != false)
		{
			$action = "update_insureship";
			$form = array(
				"InsureShipActive"=>"Yes",
				"InsureShipAccountId"=>$accountId
			);
		}
		else
		{
			$insureShipError = $insureShip->error;
		}
	}
	
	/**
	 * Update settings
	 */
	if ($action == "update_insureship" && !DEMO_LOCK)
	{
		$form = isset($form)?$form:array();
		reset($form);
		foreach ($form as $name=>$value)
		{
			$db->reset();
			$db->assignStr("value", $value);
			$db->update(DB_PREFIX."settings", "WHERE name='".$name."'");
			$settings[$name] = $value;
		}
	}
	
?>
<div id="admin-tab-sheet-insureship" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
		<form name="frmSettings" action="admin.php?p=shipping" method="post">
			<input type="hidden" name="action" value="update_settings"/>
			<input type="hidden" name="last_active_tab" value="insureship"/>
			
			<div class="admin-form-header first"><span class="icon ic-icon ic-gear"></span>InsureShip</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr>
					<td style="padding:0px 30px;width:100%;">
						<img src="images/admin/insureship-logo.jpg" alt="InsureShip" align="right" />
						<p><b>InsureShip</b> provides shipping insurance to your customers for the full retail value of their purchase if the shipment is lost, damaged or stolen. With over 13 years of experience, <b>InsureShip</b> has been providing discounted shipping insurance worldwide. When your customers purchase shipping insurance from us they will get the Best Rates, Fast & Easy online claims processing and the Peace of Mind that comes when they insure their shipment with a trusted name such as <b>InsureShip</b>.</p>
						<p>
							Benefits to Customers:
							<ul>
			    				<li>Full coverage if package is lost, stolen or damaged</li>
				    			<li>Insurance for the full purchase price</li>
			    				<li>Theft Protection</li>
			    				<li>No Hassle, fast & Easy Claims Processing</li>
			    				<li>No Deductibles</li>
				    			<li>Receive insurance policy and ability to make a claim</li>
			    				<li>Total Peace of mind with Purchase</li>
							</ul>
						</p>
						<p>When getting shipping Insurance from InsureShip you can have peace of mind that your customers shipment is insured and if anything happens in the delivery of their order they will be protected. InsureShip shipping insurance makes your customer feel more comfortable with their online purchase.</p>
						<p>
							<a target="_blank" href="https://www.insureship.com/terms-policy.php">Policy Terms - Learn more</a>
						</p> 
						
					</td>
				</tr>
<?php 
	if (isset($insureShipError))
	{
?>
				<tr>
					<td>
<?php 
		pageNote(array(
			array("class"=>"ic-cross", "text"=>$insureShipError, "url"=>"", "visible"=>true)
		));
?>
					</td>
				</tr>
<?php 	
	}

?>
			</table>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption">Enable InsureShip?</td>
					<td class="formItemControl">
						<select name="form[InsureShipActive]" class="short">
							<option value="Yes">Yes</option>
							<option value="No" <?=$settings["InsureShipActive"]=="No"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">InsureShip Account ID</td>
					<td class="formItemControl">
						<input name="form[InsureShipAccountId]" type="text" value="<?=htmlspecialchars($settings["InsureShipAccountId"])?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">InsureShip API URL</td>
					<td class="formItemControl">
						<input name="form[InsureShipApiURL]" type="text" value="<?=htmlspecialchars($settings["InsureShipApiURL"])?>">
						<div class="formItemComment">
							Can be found in your InsureShip merchant area
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">InsureShip activated by default?</td>
					<td class="formItemControl">
						<select name="form[InsureShipActiveByDefault]" class="short">
							<option value="Yes">Yes</option>
							<option value="No" <?=$settings["InsureShipActiveByDefault"]=="No"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							Do you want to auto-activate InsureShip insurance for each new order?
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">InsureShip Seal</td>
					<td class="formItemControl">
						<select name="form[InsureShipSealType]" class="short">
							<option value="None">None</option>
							<option value="Standard" <?=$settings["InsureShipSealType"]=="Standard"?"selected":""?>>Standard</option>
							<option value="PremiumLeft" <?=$settings["InsureShipSealType"]=="PremiumLeft"?"selected":""?>>Premium Left</option>
							<option value="PremiumRight" <?=$settings["InsureShipSealType"]=="PremiumRight"?"selected":""?>>Premium Right</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">InsureShip Seal Color</td>
					<td class="formItemControl">
						<select name="form[InsureShipSealColor]" class="short">
							<option value="Navy">Navy</option>
							<option value="Red" <?=$settings["InsureShipSealColor"]=="Red"?"selected":""?>>Red</option>
						</select>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
		</form>

		
		<form name="frmSettings" action="admin.php?p=shipping" method="post">
			<input type="hidden" name="action" value="insureship_activate"/>
			<input type="hidden" name="last_active_tab" value="insureship"/>
			
			<div class="admin-form-header slide-manager">	
				<span class="icon ic-icon"></span>Activate InsureShip
			</div>
			
			<div class="slide-area">
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr>
						<td colspan="2" style="padding:0px 30px;">
							<p>If you don't have an account with InsureShip, please complete the information below and we will create an account for you instantly and you can start using the InsureShip service right away.</p>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Your email</td>
						<td class="formItemControl">
							<input name="form[email]" type="text" value="<?=htmlspecialchars($admin["email"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">First name</td>
						<td class="formItemControl">
							<input name="form[first_name]" type="text" value="<?=htmlspecialchars($admin["name"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Last name</td>
						<td class="formItemControl">
							<input name="form[last_name]" type="text" value="<?=htmlspecialchars($admin["name"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Company name</td>
						<td class="formItemControl">
							<input name="form[company_name]" type="text" value="<?=htmlspecialchars($settings["CompanyName"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Site URL</td>
						<td class="formItemControl">
							<input name="form[site_url]" type="text" value="<?=htmlspecialchars($settings["CompanyWebsite"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Address1</td>
						<td class="formItemControl">
							<input name="form[address1]" type="text" value="<?=htmlspecialchars($settings["CompanyAddressLine1"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Address2</td>
						<td class="formItemControl">
							<input name="form[address2]" type="text" value="<?=htmlspecialchars($settings["CompanyAddressLine2"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">City</td>
						<td class="formItemControl">
							<input name="form[city]" type="text" value="<?=htmlspecialchars($settings["CompanyCity"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Country</td>
						<td class="formItemControl">
							<input name="form[country]" type="text" value="<?=htmlspecialchars($settings["CompanyCountry"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">State</td>
						<td class="formItemControl">
							<input name="form[state]" type="text" value="<?=htmlspecialchars($settings["CompanyState"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">ZIP</td>
						<td class="formItemControl">
							<input name="form[zip]" type="text" value="<?=htmlspecialchars($settings["CompanyZip"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Phone</td>
						<td class="formItemControl">
							<input name="form[phone]" type="text" value="<?=htmlspecialchars($settings["CompanyPhone"])?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Accounting name</td>
						<td class="formItemControl">
							<input name="form[accounting_name]" type="text" value="">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Accounting email</td>
						<td class="formItemControl">
							<input name="form[accounting_email]" type="text" value="">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Accounting phone</td>
						<td class="formItemControl">
							<input name="form[accounting_phone]" type="text" value="">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Tech name</td>
						<td class="formItemControl">
							<input name="form[tech_name]" type="text" value="">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Tech email</td>
						<td class="formItemControl">
							<input name="form[tech_email]" type="text" value="">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Tech phone</td>
						<td class="formItemControl">
							<input name="form[tech_phone]" type="text" value="">
						</td>
					</tr>
				</table>	
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</div>
		</form>
	</div>
</div>

