<?php
/**
 * Print shipping label
 */
if (!defined("ENV")) exit();

$chart = isset($chart) ? $chart : false;
$oid = isset($oid) ? intval($oid) : 0;

if (!$chart)
{ 
	
	//select order data
	$db->query("
		SELECT ".DB_PREFIX."orders.*,
			DATE_FORMAT(placed_date, '".$settings["LocalizationDateTimeFormat"]."') AS cd,
			DATE_FORMAT(status_date, '".$settings["LocalizationDateTimeFormat"]."') AS sd,
			IF(DATE_ADD(placed_date, INTERVAL 3 DAY) < NOW(), '3', '1') AS auth_exp,
			".DB_PREFIX."countries.name AS country_name,
			".DB_PREFIX."countries.iso_a2 AS country_iso_a2,
			".DB_PREFIX."countries.iso_a3 AS country_iso_a3,
			".DB_PREFIX."countries.iso_number AS country_iso_number,
			".DB_PREFIX."states.short_name As shipping_state_code
		FROM ".DB_PREFIX."orders 
		LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."orders.shipping_country
		LEFT JOIN ".DB_PREFIX."states ON ".DB_PREFIX."states.stid=".DB_PREFIX."orders.shipping_state
		WHERE 
			".DB_PREFIX."orders.oid='".$oid."' AND (".DB_PREFIX."orders.removed='No')
	");
	
	if ($db->moveNext())
	{
		$order_data = $db->col;
		if ($error_str = generateShippingLabel($order_data))
		{
			$error_str = $error_str.'<br/>You can verify address with <a href="http://zip4.usps.com/zip4/welcome.jsp">USPS</a>.';
			pageHeader("Can not Generate Label", "", "ic_order.gif");
			pageNote(array(
					array("icon"=>"ic_error.gif", "text"=>$error_str, "url"=>"", "visible"=>true)
			));
			pageWhat(array(
			array("text"=>"Browse Orders", "url"=>"admin.php?p=orders")
			));	
		}
		else
		{
			pageHeader("Shipping Label is Generated", "", "ic_order.gif");
			pageWhat(array(
				array("text"=>"Browse Orders", "url"=>"admin.php?p=orders")
			));	
		}
	}
	else
	{
		pageHeader("Can't Select Order", "", "ic_order.gif");
		pageNote(array(
			array("icon"=>"ic_error.gif", "text"=>"<b>Can't select order by specified ID</b>", "url"=>"", "visible"=>true)
		));
		pageWhat(array(
			array("text"=>"Browse Orders", "url"=>"admin.php?p=orders")
		));
	}
}
else
{
	if (isset($_SESSION["USPS_PRINT_LABEL_".$oid]))
	{
		header("Content-type: application/pdf");
		header("Content-Disposition: attachment; filename=usps_label_order_".$_REQUEST['order_num'].".pdf;");
		echo base64_decode($_SESSION["USPS_PRINT_LABEL_".$oid]);
		unset($_SESSION["USPS_PRINT_LABEL_".$oid]);
	}
	session_write_close();
	die();
}



function generateShippingLabel($order_data)
{
	global $settings, $db, $shipping_labels;
	$xmlpostdata = '
		<DeliveryConfirmationV3.0Request USERID="'.$settings['ShippingUSPSUserID'].'">
			<Option>1</Option>
			<ImageParameters />
			<FromName>'.$settings['CompanyName'].'</FromName>
			<FromFirm></FromFirm>
			<FromAddress1></FromAddress1>
			<FromAddress2>'.$settings["CompanyAddressLine1"].', '.$settings["CompanyAddressLine2"].'</FromAddress2>
			<FromCity>'.$settings['CompanyCity'].'</FromCity>
		    <FromState>'.$settings['CompanyState'].'</FromState>
			<FromZip5>'.substr(preg_replace('/\D/', '', $settings['CompanyZip']), 0, 5).'</FromZip5>
			<FromZip4 />
	';
	
	if (trim($order_data["shipping_name"]) != "") $xmlpostdata.='<ToName>'.$order_data["shipping_name"].'</ToName>'; else $xmlpostdata.='<ToName/>';
	if (trim($order_data["shipping_company"]) != "") $xmlpostdata.='<ToFirm>'.$order_data["shipping_company"].'</ToFirm>'; else $xmlpostdata.='<ToFirm />';
	
	$xmlpostdata.='
		<ToAddress1></ToAddress1>
		<ToAddress2>'.$order_data["shipping_address1"].', '.$order_data["shipping_address2"].'</ToAddress2>
		<ToCity>'.$order_data["shipping_city"].'</ToCity>
		<ToState>'.$order_data["shipping_state_code"].'</ToState>
		<ToZip5>'.substr(preg_replace('/\D/', '', $order_data["shipping_zip"]), 0, 5).'</ToZip5>
		<ToZip4 />
		<WeightInOunces>2</WeightInOunces>
		<ServiceType>Priority</ServiceType>
		<POZipCode />
		<ImageType>PDF</ImageType>
		<LabelDate />
		</DeliveryConfirmationV3.0Request>';
	
	
	$ch = curl_init($settings["ShippingUSPSLabelingUrl"]);    // initialize curl handle 
	if ($settings["ProxyAvailable"] == "YES")
	{
		////curl_setopt($ch, CURLOPT_VERBOSE, 1);
		if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
		{
			curl_setopt($ch, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
		}
		curl_setopt($ch, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
		if ($settings["ProxyRequiresAuthorization"] == "YES")
		{
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
		}

		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
	}
	curl_setopt($ch, CURLOPT_FAILONERROR, 1); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1); // return into a variable 
	curl_setopt($ch, CURLOPT_TIMEOUT, 3); // times out after 4s 
	curl_setopt($ch, CURLOPT_POST, 1); // set POST method 
	curl_setopt($ch, CURLOPT_POSTFIELDS, 'API=DeliveryConfirmationV3&XML='.$xmlpostdata); // add POST fields 
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($ch, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
	curl_setopt($ch, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
	
	$result = curl_exec($ch); // run the whole process 
	curl_close($ch);  
	
	$xmlresult = new SimpleXMLElement($result);
			
	if ($xmlresult->DeliveryConfirmationNumber != "")
	{
		$_SESSION["USPS_PRINT_LABEL_".$order_data["oid"]] = trim($xmlresult->DeliveryConfirmationLabel." ");
		header("Location: admin.php?p=shipping_label_usps&chart=true&order_num=".$order_data['order_num']."&oid=".$order_data["oid"]);
		session_write_close();
		die();
	}
	else
	{
		$xmlerrot = new SimpleXMLElement($result);					
		$error_str = 'Error code:-'.$xmlerrot->Number.':: '.$xmlerrot->Description;
		return($error_str);			
	}
	return;
}