<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	require_once("content/classes/class.taxes.php");

	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;

	$action = isset($action)?trim($action):"";
	if ($action == "update_settings" && !DEMO_LOCK)
	{
		$form = isset($form)?$form:array();
		reset($form);
		foreach ($form as $name=>$value)
		{
			$db->reset();
			$db->assignStr("value", $value);
			$db->update(DB_PREFIX."settings", "WHERE name='".$name."'");
			$settings[$name] = $value;
		}
	}
?>
<script type="text/javascript" language="JavaScript">
	statesSettings = new Array();
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."states ORDER BY coid, name");
	$i = 0;
	while($db->moveNext())
	{
?>
	statesSettings[<?=$i++?>] = new Array(<?=$db->col["stid"]?>, <?=$db->col["coid"]?>, "<?=$db->col["name"]?>");
<?php
	}
?>
</script>
<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
	<div class="admin-tab-sheet-wrap">
		<form name="frmSettings" action="admin.php?p=shipping" method="post">
			<input type="hidden" name="action" value="update_settings"/>
			<input type="hidden" name="last_active_tab" value="settings"/>
			<table cellpadding="0" cellspacing="5" border="0" width="100%">
				<tr>
					<td class="formHeader" colspan="2">
						<div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"/></div>
						<div class="formHeaderText">Enable/Disable Shipping Calculation</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Enable Shipping?</td>
					<td class="formItemControl">
						<select name="form[ShippingCalcEnabled]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingCalcEnabled"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Allow international shipping?</td>
					<td class="formItemControl">
						<select name="form[ShippingInternational]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingInternational"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Display shipping prices on checkout pages?</td>
					<td class="formItemControl">
						<select name="form[ShippingPreCalcEnabled]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingPreCalcEnabled"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Should the cart display the shipping price on the product page?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowPriceAtProductLevel]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowPriceAtProductLevel"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Allow orders to be completed if no shipping methods are available?</td>
					<td class="formItemControl">
						<select name="form[ShippingWithoutMethod]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingWithoutMethod"]=="NO"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If "No" is selected the cart will not allow an order to be completed if it cannot calculate a shipping price.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Display the shipping weight on the product / catalog pages?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowWeight]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowWeight"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Enable "Shipping Quote" feature?</td>
					<td class="formItemControl">
						<select name="form[ShippingAllowGetQuote]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingAllowGetQuote"]=="NO"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If enabled, customers will be able to get a shipping quote for products within their cart before they register.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Display alternative shipping methods when shipping is free?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowAlternativeOnFree]" style="width:123px;">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowAlternativeOnFree"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Is shipping taxable?</td>
					<td class="formItemControl">
						<select name="form[ShippingTaxable]" style="width:123px;">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingTaxable"]=="0"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Shipping tax class</td>
					<td class="formItemControl">
<?php
	$tax_classes = $taxes->getTaxClassesList();
	if (count($tax_classes) > 0)
	{
?>
						<select name="form[ShippingTaxClassId]" style="width:250px;">
							<option value="0">Tax class is not assigned</option>
<?php
		for ($i=0; $i<count($tax_classes); $i++)
		{
?>
							<option value="<?=$tax_classes[$i]["class_id"]?>" <?=$settings["ShippingTaxClassId"]==$tax_classes[$i]["class_id"]?'selected="selected"':''?>><?=htmlspecialchars($tax_classes[$i]["class_name"])?></option>
<?php
		}
?>
						</select>
<?php
	}
	else
	{
		echo "There are no taxes classes defined";
	}
?>
					</td>
				</tr>
				<tr>
					<td class="formHeader" colspan="2">
						<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"/></div>
						<div class="formHeaderText">Shipping Label</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Text for shipping line-item </b></td>
					<td class="formItemControl">
						<input name="form[ShippingLabel]" style="width:250px;" value="<?=htmlspecialchars($settings["ShippingLabel"])?>">
						<div class="formItemComment">
							This is the name for the shipping line item on the order and invoice page.
							The default is "Shipping".
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Free shipping title</b></td>
					<td class="formItemControl">
						<input name="form[ShippingFreeDescription]" style="width:250px;" value="<?=htmlspecialchars($settings["ShippingFreeDescription"])?>">
						<div class="formItemComment">
							This is the name for the free shipping method on the order and invoice page.
							The default is "Free Shipping" but you can use something like "Free ground shipping" or "Free delivery".
						</div>
					</td>
				</tr>
				<tr>
					<td class="formHeader" colspan="2">
						<div class="formHeaderIcon"><img src="images/icons/ic_handling.gif"/></div>
						<div class="formHeaderText">Handling Fee</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">&nbsp;</td>
					<td class="formItemControl">
						<div class="formItemComment">
							Handling fees are optional. You may set up a handling fee as a percentage of the sale or a flat rate.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Charge per-order handling fee</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingHandlingFee]" value="<?=number_format($settings["ShippingHandlingFee"], 2, ".", "")?>" style="width:123px;">
						<select name="form[ShippingHandlingFeeType]" style="width:123px;">
							<option value="percent">%</option>
							<option value="amount" <?=$settings["ShippingHandlingFeeType"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Is handling fee taxable?</td>
					<td class="formItemControl">
						<select name="form[ShippingHandlingTaxable]" style="width:123px;">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingHandlingTaxable"]=="0"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Handling tax class</td>
					<td class="formItemControl">
<?php
	if (count($tax_classes) > 0)
	{
?>
						<select name="form[ShippingHandlingTaxClassId]" style="width:250px;">
							<option value="0">Tax class is not assigned</option>
<?php
		for ($i=0; $i<count($tax_classes); $i++)
		{
?>
							<option value="<?=$tax_classes[$i]["class_id"]?>" <?=$settings["ShippingHandlingTaxClassId"]==$tax_classes[$i]["class_id"]?'selected="selected"':''?>><?=htmlspecialchars($tax_classes[$i]["class_name"])?></option>
<?php
		}
?>
						</select>
<?php
	}
	else
	{
		echo "There are no taxes classes defined";
	}
?>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Show handling separately?</td>
					<td class="formItemControl">
						<select name="form[ShippingHandlingSeparated]" style="width:123;">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingHandlingSeparated"]=="0"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If handling is not separated then shipping tax will be applied
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Text for handling line-item</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingHandlingText]" value="<?=gs($settings["ShippingHandlingText"])?>" style="width:250px;">
					</td>
				</tr>
				<tr>
					<td class="formHeader" colspan="2">
						<div class="formHeaderIcon"><img src="images/icons/ic_globe.gif"/></div>
						<div class="formHeaderText">Shipping Origin Settings (real-time)</div>
					</td>
				</tr>
				<tr valign="top">
					<td>&nbsp;</td>
					<td class="formItemControl">
						<div class="formItemComment">
							This information will be used to calculate real-time shipping costs. Please enter in the origin information for all shipments from your store.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>City</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginCity]" style="width:250px;" value="<?=gs($settings["ShippingOriginCity"])?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">State/Province name</td>
					<td class="formItemControl">
						<select name="form[ShippingOriginState]" style="width:250px;"><option>All States</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>ZIP/Postal Code</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginZip]" style="width:123px;" value="<?=gs($settings["ShippingOriginZip"])?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Country of origin</td>
					<td class="formItemControl">
						<select name="form[ShippingOriginCountry]" style="width:250px;" onChange="updateSettingsStates('<?=$settings["ShippingOriginState"]?>')">
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE ".DB_PREFIX."countries.available = 'Yes' ORDER BY country_priority DESC, name");
	while ($db->moveNext())
	{
?>
							<option value="<?=$db->col["coid"]?>" <?=$settings["ShippingOriginCountry"]==$db->col["coid"]?"selected":""?>><?=gs($db->col["name"])?></option>
<?php
	}
?>
						</select>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/> &nbsp;
				<input type="reset" value="Reset form"/>
			</div>
		</form>
	</div>
</div>

<script type="text/javascript" language="javascript">
	updateSettingsStates('<?=$settings["ShippingOriginState"]?>');
</script>