<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);	

	$coid = isset($_REQUEST["coid"])?intval($_REQUEST["coid"]):0;
	$country = $regions->getCountryById($coid);
	
	if(!$country){
		pageHeader("States Listing", "", "");
		pageNote(array(
			array("icon"=>"ic_error.gif", "text"=>"<b>Can not find country with specified ID</b>", "url"=>"", "visible"=>true),
			array("icon"=>"ic_globe.gif", "text"=>"Back to Countries Listing", "url"=>"admin.php?p=countries", "visible"=>true)
		));
	}
	else{
		pageHeader("States/Provinces Listing - ".$country["name"], "", "");

		
		$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
	
		$added_country_id = "";
	
		switch($action){
			case "add" : {
				$added_state_id = $regions->addState($_REQUEST);
				//$_REQUEST["showby"] = "abc";
				//$_REQUEST["letter"] = $_REQUEST["name"][0];
				break;
			}
			case "save" : {
				$regions->saveStatesData($_REQUEST);
				break;
			}
			case "delete" : {
				$regions->deleteState($_REQUEST["stid"]);
				break;
			}
		}
	
		$states_abc = $regions->getStatesABC($coid);
		
		$showby = isset($_REQUEST["showby"])?$_REQUEST["showby"]:"page";
		$showby = ($showby == "page" || $showby == "abc")?$showby:"page";
	
		$sortorder = isset($_REQUEST["sortorder"])?$_REQUEST["sortorder"]:"asc";
		$sortorder = in_array($sortorder, array("name_asc", "name_desc", "priority_asc", "priority_desc"))?$sortorder:"name_asc";
	
		switch($showby){
			default :
			case "page" : {
				$ccc = 20;
				$_states = $regions->getStatesList($coid, $sortorder);
				$items_count = count($_states);
				$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
				$pg = isset($pg)?($pg*1):1;
				$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
				$pages_line = format_pages_line(
					$pg, // current pare
					$pages_count, // total pages
					16, 
					"admin.php?p=states&coid=".$coid."&showby=page&sortorder=".$sortorder
				);
				$states = array();
				$start = ($pg-1)* $ccc;
				$finish = $start + $ccc;
				$finish = $finish > $items_count ? $items_count : $finish;
				for($i=$start; $i<$finish; $i++){
					$states[] = $_states[$i];
				}
				$letter = "";
				break;
			}
			case "abc" : {
				$pg = 1;
				$letter = isset($_REQUEST["letter"])?$_REQUEST["letter"]:$countries_abc[0];
				$letter = in_array($letter, $states_abc)?$letter:$states_abc[0];
				$states = $regions->getStatesListByLetter($coid, $letter, $sortorder);
				break;
			}
		}

		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"This page is for enabling / disabling states within your cart. When the country (enter in country selected) is selected, the state / province listed below will appear to your customers", "url"=>"", "visible"=>true),
			array("icon"=>"ic_globe.gif", "text"=>"Back to Countries Listing", "url"=>"admin.php?p=countries", "visible"=>true)
		));
		loadJS("regions.js");
		pageTabs(array(
			array("title"=>"New State / Province", "id"=>"Main", "active"=>true, "width"=>150),
		));
?>
<script type="text/javascript" src="content/vendors/jquery/ddaccordion/ddaccordion.js"></script>
<script type="text/javascript">
ddaccordion.init({
	headerclass:"sliderButton", //Shared CSS class name of headers group
	contentclass:"sliderDiv", //Shared CSS class name of contents group
	collapseprev:false, //Collapse previous content (so only one open at any time)? true/false 
	defaultexpanded:[], //index of content(s) open by default [index1, index2, etc]. [] denotes no content.
	animatedefault:false, //Should contents open by default be animated into view?
	persiststate:false, //persist state of opened contents within browser session?
	toggleclass:["", ""], //Two CSS classes to be applied to the header when it's collapsed and expanded, respectively ["class1", "class2"]
	togglehtml:["src", "images/icons/ic_arrow_down.gif", "images/icons/ic_arrow_up.gif"], //Additional HTML added to the header when it's collapsed and expanded, respectively  ["position", "html1", "html2"] (see docs)
	animatespeed:"fast" //speed of animation: "fast", "normal", or "slow"
})
</script>
<form style="padding:0px;margin:0px;" name="frmNewState" method="POST" action="admin.php?p=states&coid=<?=$coid?>" onsubmit="return checkAddStateForm(this)">
	<input type="hidden" name="action" value="add"/>
<div id="idTabSheetMain" class="sheetActive">
<table width="100%" cellpadding="0" cellspacing="5" border="0" style="clear:both;">
	<tr>
		<td class="formHeader" colspan="2">
			<div class="formHeaderIcon"><img src="images/icons/ic_insert_row.gif"/></div>
			<div class="formHeaderText">Add New State / Province</div>
			<div class="formHeaderButtons"><img src="images/icons/ic_arrow_down.gif" class="sliderButton" style="cursor:pointer;"></div>
		</td>
	</tr>
</table>
<div class="sliderDiv" style="display:none">
<table width="100%" cellpadding="0" cellspacing="5" border="0" style="clear:both;">
	<tr>
		<td class="formItemCaption"><b>State/ Province Name</b></td>
		<td class="formItemControl"><input type="text" name="name" value="" style="width:250px;"/></td>
	</tr>
	<tr>
		<td class="formItemCaption"><b>Short Name / Code</b></td>
		<td class="formItemControl"><input type="text" name="short_name" maxlength="3" value="" style="width:123px;"/></td>
	</tr>
	<tr>
		<td class="formButtons" colspan="2">
			<input type="image" src="images/admin/bt_save_changes.gif"/>
			<input type="image" src="images/admin/bt_reset_form.gif" onclick="document.forms['frmCountries'].reset();return false;"/>
		</td>
	</tr>
</table>
</div>
</div>
<br/>
</form>



<div class="listHeader">
	<div class="listHeaderIcon"><img src="images/icons/ic_globe.gif"/></div>
	<div class="listHeaderCaption">States / Provinces Listing</div>
<?	if(count($states)>0){?>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Browse alphabetically: 
<?		for($i=0; $i<count($states_abc); $i++){
			if($letter == $states_abc[$i]){
				echo '&nbsp; <span class="pageNavItemActive">'.$states_abc[$i].'</span>';
			}
			else{
				echo '&nbsp; <span class="pageNavItem"><a href="admin.php?p=states&coid='.$coid.'&showby=abc&letter='.$states_abc[$i].'&sortorder='.$sortorder.'">'.$states_abc[$i].'</a></span>';
			}
		}
?>
	</div>
<?	}?>
</div>
<?	if(count($states)>0){?>
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Browse by page:
<?		if($showby == "page"){
			echo $pages_line;
		}
		else{
			echo '<a href="admin.php?p=states&coid='.$coid.'&sortorder='.$sortorder.'">Back to Pages View</a>';
		}
?>
	</div>
</div>
<?	}?>
<div class="listHeader">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:300px;">State, Province or County Name</div>
	<div class="listHeaderCaption" style="width:180px;">Code</div>
</div>


<?		if(count($states)>0){?>

<form name="frmStates" style="padding:0px;margin:0px;" action="admin.php?p=states&coid=<?=$coid?>&showby=<?=$showby?>&letter=<?=$letter?>&pg=<?=$pg?>&sortorder=<?=$sortorder?>" method="POST">
<input type="hidden" name="action" value="save"/>
<?			for($i=0; $i<count($states); $i++){
				$state = $states[$i];
?>
	<div class="listItem">
		<div class="listItemIcon"><img src="images/icons/ic_globe.gif"/></div>
		<div class="listItemText" style="width:300px;">
			<input type="text" name="name[<?=$state["stid"]?>]" value="<?=htmlspecialchars($state["name"])?>" style="width:290px;"/>
		</div>
		<div class="listItemText" style="width:180px;">
			<input type="text" name="short_name[<?=$state["stid"]?>]" maxlength="3" value="<?=htmlspecialchars($state["short_name"])?>" style="width:170px;"/>
		</div>
		<div class="listItemButtons">
			<a href="javascript:confirmDeleteState('<?=$state["stid"]?>.', '<?=$state["coid"]?>', '<?=$showby?>', '<?=$sortorder?>', '<?=$letter?>', '<?=$pg?>')"><img src="images/icons/ic_delete.gif" alt="Click to delete state" border="0"/></a>
		</div>
	</div>
<?			}
?>
	
	<div class="formButtons">
		<input type="image" src="images/admin/bt_save_changes.gif">
		<input type="image" src="images/admin/bt_reset_form.gif" onclick="document.forms['frmStates'].reset();return false;">
	</div>
</form>

<?
		}
		else{?>
	<div class="listEmpty">
		Here are no states / provinces yet
	</div>
<?		}
	}
?>