<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;	

	$coid = isset($_REQUEST["coid"])?intval($_REQUEST["coid"]):0;
	$country = $regions->getCountryById($coid);
	
	if (!$country)
	{
		pageHeader("States Listing", "", "");
		pageNote(array(
			array("icon"=>"ic_error.gif", "text"=>"<b>Can not find country with specified ID</b>", "url"=>"", "visible"=>true),
			array("icon"=>"ic_globe.gif", "text"=>"Back to Countries Listing", "url"=>"admin.php?p=countries", "visible"=>true)
		));
	}
	else
	{
		pageHeader("States/Provinces Listing - ".$country["name"], "", "");
		
		$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
	
		$added_country_id = "";
	
		if (!DEMO_LOCK)
		{
			switch($action)
			{
				case "add" : 
				{
					$added_state_id = $regions->addState($_REQUEST);
					//$_REQUEST["showby"] = "abc";
					//$_REQUEST["letter"] = $_REQUEST["name"][0];
					break;
				}
				case "save" :
				{
					$regions->saveStatesData($_REQUEST);
					break;
				}
				case "delete" :
				{
					$regions->deleteState($_REQUEST["stid"]);
					break;
				}
			}
		}
	
		$states_abc = $regions->getStatesABC($coid);
		
		$showby = isset($_REQUEST["showby"])?$_REQUEST["showby"]:"page";
		$showby = ($showby == "page" || $showby == "abc")?$showby:"page";
	
		$sortorder = isset($_REQUEST["sortorder"])?$_REQUEST["sortorder"]:"asc";
		$sortorder = in_array($sortorder, array("name_asc", "name_desc", "priority_asc", "priority_desc"))?$sortorder:"name_asc";
	
		switch ($showby)
		{
			default :
			case "page" : 
			{
				$ccc = 20;
				$_states = $regions->getStatesList($coid, $sortorder);
				$items_count = count($_states);
				$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
				$pg = isset($pg)?($pg*1):1;
				$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
				$pages_line = format_pages_line(
					$pg, // current pare
					$pages_count, // total pages
					16, 
					"admin.php?p=states&coid=".$coid."&showby=page&sortorder=".$sortorder
				);
				$states = array();
				$start = ($pg-1)* $ccc;
				$finish = $start + $ccc;
				$finish = $finish > $items_count ? $items_count : $finish;
				for($i=$start; $i<$finish; $i++){
					$states[] = $_states[$i];
				}
				$letter = "";
				break;
			}
			case "abc" : 
			{
				$pg = 1;
				$letter = isset($_REQUEST["letter"])?$_REQUEST["letter"]:$countries_abc[0];
				$letter = in_array($letter, $states_abc)?$letter:$states_abc[0];
				$states = $regions->getStatesListByLetter($coid, $letter, $sortorder);
				break;
			}
		}

		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"This page is for enabling / disabling states within your cart. When the country (enter in country selected) is selected, the state / province listed below will appear to your customers", "url"=>"", "visible"=>true),
			array("icon"=>"ic_globe.gif", "text"=>"Back to Countries Listing", "url"=>"admin.php?p=countries", "visible"=>true)
		));
		loadJS("regions.js");
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-states">
<?php 
		pageTabs(array(
			array("title"=>"States / Provices", "id"=>"list"),
			array("title"=>"New State / Province", "id"=>"new")
		), "tabs-states", false);
?>
	<div id="admin-tab-sheet-list" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-globe">States / Provinces Listing</div>

<?php
		if (count($states)>0)
		{
?>
			<div class="listHeaderCaption" style="float:right;font-weight:normal;">
				Browse alphabetically: 
<?php
			for ($i=0; $i<count($states_abc); $i++)
			{
				if ($letter == $states_abc[$i])
				{
					echo '&nbsp; <span class="pageNavItemActive">'.$states_abc[$i].'</span>';
				}
				else
				{
					echo '&nbsp; <span class="pageNavItem"><a href="admin.php?p=states&coid='.$coid.'&showby=abc&letter='.$states_abc[$i].'&sortorder='.$sortorder.'">'.$states_abc[$i].'</a></span>';
				}
			}
?>
			</div>
			<div class="listHeader">
				<div class="listHeaderIcon">&nbsp;</div>
				<div class="listHeaderCaption" style="float:right;font-weight:normal;">
					Browse by page:
<?php
			if ($showby == "page")
			{
				echo $pages_line;
			}
			else
			{
				echo '<a href="admin.php?p=states&coid='.$coid.'&sortorder='.$sortorder.'">Back to Pages View</a>';
			}
?>
				</div>
			</div>
<?php
		}
?>
			<div class="listHeader">
				<div class="listHeaderIcon">&nbsp;</div>
				<div class="listHeaderCaption" style="width:300px;">State, Province or County Name</div>
				<div class="listHeaderCaption" style="width:180px;">Code</div>
			</div>
<?php
		if (count($states)>0)
		{
?>

			<form name="frmStates" style="padding:0px;margin:0px;" action="admin.php?p=states&coid=<?=$coid?>&showby=<?=$showby?>&letter=<?=$letter?>&pg=<?=$pg?>&sortorder=<?=$sortorder?>" method="POST">
				<input type="hidden" name="action" value="save"/>
				<div class="clearfix">
<?php
			for ($i=0; $i<count($states); $i++)
			{
				$state = $states[$i];
?>
					<div class="listItem clearfix">
						<div class="listItemIcon"><img src="images/icons/ic_globe.gif"/></div>
						<div class="listItemText" style="width:300px;">
							<input type="text" name="name[<?=$state["stid"]?>]" value="<?=htmlspecialchars($state["name"])?>" style="width:290px;"/>
						</div>
						<div class="listItemText" style="width:180px;">
							<input type="text" name="short_name[<?=$state["stid"]?>]" maxlength="3" value="<?=htmlspecialchars($state["short_name"])?>" style="width:170px;"/>
						</div>
						<div class="listItemButtons">
							<a href="javascript:confirmDeleteState('<?=$state["stid"]?>.', '<?=$state["coid"]?>', '<?=$showby?>', '<?=$sortorder?>', '<?=$letter?>', '<?=$pg?>')"><img src="images/icons/ic_delete.gif" alt="Click to delete state" border="0"/></a>
						</div>
					</div>
<?php
			}
?>
				</div>
				<div class="admin-form-buttons clearfix">
					<input type="submit" value="Save changes"/> &nbsp;
					<input type="reset" value="Reset form"/>
				</div>
			</form>
<?php
		}
		else
		{
?>
			<div class="listEmpty">
				Here are no states / provinces yet
			</div>
<?php
		}
	}
?>
		</div>
	</div>
	<div id="admin-tab-sheet-new" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form style="padding:0px;margin:0px;" name="frmNewState" method="POST" action="admin.php?p=states&coid=<?=$coid?>" onsubmit="return checkAddStateForm(this)">
				<input type="hidden" name="action" value="add"/>
				<div class="admin-form-header">Add a New State / Province</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0" style="clear:both;">
					<tr>
						<td class="formItemCaption"><b>State/ Province Name</b></td>
						<td class="formItemControl"><input type="text" name="name" value="" style="width:250px;"/></td>
					</tr>
					<tr>
						<td class="formItemCaption"><b>Short Name / Code</b></td>
						<td class="formItemControl"><input type="text" name="short_name" maxlength="3" value="" style="width:123px;"/></td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/> &nbsp;
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>
</div>