<?php
	if (!defined("ENV")) exit();
	
	pageHeader("Charts", "", "ic_report.gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "url"=>"", "text"=>"Graphical representation of Page Views, Unique Hosts and Dollars Spent. To view this data, select a month, year and chart type.", "visible"=>true),
		array("icon"=>"ic_hint.gif", "url"=>"", "text"=>"Please select statistics period and chart type and click Update button.", "visible"=>true),
		array("icon"=>"ic_error.gif", "url"=>"", "text"=>"<b>Note: charts are not displayed because your PHP installation does not support GD Lib</b>.<br>To get more information, please refer to PHP documentation.", "visible"=>!function_exists("imagepng"))
	));

	$year = isset($year) ? $year*1 : date("Y");
	$month = isset($month) ? $month*1 : date("m");
	$chart_view = isset($chart_view) ? trim($chart_view) : "Column3D";
?>
<script type="text/javascript" src="content/vendors/fusioncharts/jquery.fusioncharts.js"></script>
<script type="text/javascript">
	function resizeGraph()
	{
		var chartOptions = {
			type: <?php echo '"'.$chart_view.'"'; ?>,
			width: ($('#divTopLine').width() - $('#quickLinks').attr('width') - 100),
			height: "300",
			dataFormat: "URIData",
			swfPath: 'content/vendors/fusioncharts/Charts',
			wMode: "transparent"
		};
		
		// reset the charts
		$('#chartHits').html('Loading Statistics!');
		$('#chartTraffic').html('Loading Statistics!');
		$('#chartSales').html('Loading Statistics!');
		
		
		<?php echo 'chartOptions.data = "admin.php?p=charts&chart=true&mode=usage_by_month_hits&year='.$year.'&month='.$month.'&chart_view='.$chart_view.'";'; ?>
		$('#chartHits').insertFusionCharts(chartOptions);
		
		<?php echo 'chartOptions.data = "admin.php?p=charts&chart=true&mode=usage_by_month_hosts&year='.$year.'&month='.$month.'&chart_view='.$chart_view.'";'; ?>
		$('#chartTraffic').insertFusionCharts(chartOptions);
		
		<?php echo 'chartOptions.data = "admin.php?p=charts&chart=true&mode=sales_by_month&year='.$year.'&month='.$month.'&chart_view='.$chart_view.'";'; ?>
		$('#chartSales').insertFusionCharts(chartOptions);
	}

	$(document).ready(function()
	{
		resizeGraph();
	});

	$(window).resize(function()
	{
		resizeGraph();
	});
</script>

<form name="frmCharts" action="admin.php?p=stats_charts" method="get">
	<input type="hidden" name="p" value="stats_charts">
	<div class="admin-tabs admin-tabs-framed" id="tabs-charts">
<?php 
	pageTabs(array(
		array("title"=>"Charts", "id"=>"main"),
	), "tabs-charts", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header">Select Period &amp; Charts Type</div>
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr valign="top">
						<td class="formItemCaption"><b>Month &amp; Year</b></td>
						<td class="formItemControl">
							<select name="month" style="width:123px;">
<?php
	for ($i=1; $i<=12; $i++)
	{
?>
								<option value="<?=$i?>" <?=$month==$i?"selected":""?>><?=$months[$i]?></option>
<?php
	}
?>			
							</select>
							<select name="year" style="width:123px;">
<?php
	for ($i=2004; $i<=date("Y"); $i++)
	{
?>
								<option value="<?=$i?>" <?=$year==$i?"selected":""?>><?=$i?></option>
<?php
	}
?>			
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption"><b>Type</b></td>
						<td class="formItemControl">
							<select name="chart_view" style="width:123px;">
								<option value="Column3D">Columns</option>
								<option value="Area2D" <?=$chart_view=="Area2D"?"selected":""?>>Area</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Show reports">
				</div>
				<div style="padding:20px;">
					<div id="chartHits">Loading Statistics!</div>
					<div id="chartTraffic">Loading Statistics!</div>
					<div id="chartSales">Loading Statistics!</div>
				</div>
			</div>
		</div>
	</div>
</form>