<?php
	if (!defined("ENV")) exit();
	
	pageHeader("Charts", "", "icb-stats-bar-chart");
	
	pageNote(array(
		array("class"=>"ic-info", "text"=>"Graphical representation of Page Views, Unique visitors and Dollars Spent. To view this data, select a month, year and chart type.", "visible"=>true),
		array("class"=>"ic-info", "text"=>"Please select statistics period and chart type and click Update button.", "visible"=>true),
		array("class"=>"ic-cross", "text"=>"<b>Note: charts are not displayed because your PHP installation does not support GD Lib</b>.<br>To get more information, please refer to PHP documentation.", "visible"=>!function_exists("imagepng"))
	));

	$year = isset($year) ? intval($year) : date("Y");
	$month = isset($month) ? intval($month) : date("m");
	$chart_view = isset($chart_view) ? trim($chart_view) : "Column3D";
?>
	<script type="text/javascript">
		var chartDate = new Date();
		chartDate.setDate(1);
		chartDate.setFullYear(<?=$year;?>);
		chartDate.setMonth(<?=($month-1);?>);
		var chartType = "<?php echo gs($chart_view); ?>";
	</script>
<?php
	loadJS('charts.js');
?>
<style type="text/css">
	.chart { height: 230px; margin-bottom: 30px; }
	.chart-title { font-size: 1.3em; margin: 10px 0; padding: 10px; background: #eeeeee; }
</style>

<form name="frmCharts" action="admin.php?p=stats_charts" method="get">
	<input type="hidden" name="p" value="stats_charts">
	<div class="admin-tabs admin-tabs-framed" id="tabs-charts">
<?php 
	pageTabs(array(
		array("title"=>"Charts", "id"=>"main"),
	), "tabs-charts", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Select Period &amp; Charts Type</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Month &amp; Year</td>
						<td class="formItemControl">
							<select name="month" class="date-month">
<?php
	for ($i=1; $i<=12; $i++)
	{
?>
								<option value="<?=$i?>" <?=$month==$i?"selected":""?>><?=$months[$i]?></option>
<?php
	}
?>			
							</select>
							<select name="year" class="date-year">
<?php
	for ($i=2004; $i<=date("Y"); $i++)
	{
?>
								<option value="<?=$i?>" <?=$year==$i?"selected":""?>><?=$i?></option>
<?php
	}
?>			
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Type</td>
						<td class="formItemControl">
							<select name="chart_view" class="short">
								<option value="Area2D">Area</option>
								<option value="Column3D" <?=$chart_view=="Column3D"?"selected":""?>>Columns</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Show reports"/>
				</div>
				<div style="padding:20px;">
					
					<div class="chart-title">Monthly Pageviews</div>
					<div class="chart" id="chartHits"></div>
					
					<div class="chart-title">Monthly Unique Visitors</div>
					<div class="chart" id="chartTraffic"></div>
					
					<div class="chart-title">Monthly Sales</div>
					<div class="chart" id="chartSales"></div>
				</div>
			</div>
		</div>
	</div>
</form>