<?php
	if (!defined("ENV")) exit();
	
	$tax_mode = isset($tax_mode)?$tax_mode:"";
	$tax_mode = in_array($tax_mode, array("simple", "advanced"))?$tax_mode:"simple";
	
	pageHeader("Taxes Settings", "", "icb-tax");
	
	pageNote(array(
		array("class"=>"ic-info", "text"=>$tax_mode=="advanced"?"Switch to Simple Mode":"Switch to Advanced Mode", "url"=>$tax_mode=="advanced"?"admin.php?p=taxes&tax_mode=simple":"admin.php?p=taxes&tax_mode=advanced", "visible"=>true),
		array("class"=>"ic-info", "text"=>"This page is for adding tax rates. Only the zone selected will be considered for tax calculations. Use Priority to control what order taxes will be applied to a order.", "url"=>"", "visible"=>true)
	));
	
	loadJS("regions.js");

	require_once("content/classes/class.regions.php");
	require_once("content/classes/class.taxes.php");
	
	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$regions = new Regions($db);
	$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
	
	if ($action != '')
	{
		$nonce = isset($nonce) ? $nonce : '';
		$nonce_valid = verify_nonce($nonce, 'tax_'.$action);
		if (!$nonce_valid)
		{
			invalid_nonce_message();
			exit;
		}
	}
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-taxes">
<?php 
	if ($tax_mode == "advanced")
	{
		$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"idTabSettings";
		pageTabs(array(
			array("title"=>"Edit Tax Settings", "id"=>"settings"),	
			array("title"=>"Edit Tax Zones", "id"=>"zones"),
			array("title"=>"Edit Tax Classes", "id"=>"classes"),
			array("title"=>"Edit Tax Rates", "id"=>"rates")
		), "tabs-taxes", $last_active_tab);
		
		require_once("content/admin/admin_taxes_settings.php");
		require_once("content/admin/admin_taxes_zones.php");
		require_once("content/admin/admin_taxes_classes.php");
		require_once("content/admin/admin_taxes_rates.php");
		

	}
	else
	{
		require_once("content/admin/admin_taxes_simple.php");
	}
?>
</div>