<?php
	if (!defined("ENV")) exit();
?>
<div id="admin-tab-sheet-classes" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
<?php

	$sortorder = isset($_REQUEST["sortorder"])?$_REQUEST["sortorder"]:"asc";
	$added_country_id = "";
	
	$add_class_error = false;
	$save_classes_errors = array();
	
	$add_key_name = '';
	$add_class_name = '';
	$add_class_description = '';
	
	switch ($action)
	{
		case "addClass" :
		{
			$add_key_name = $_REQUEST['key_name'];
			$add_class_name = $_REQUEST['class_name'];
			$add_class_description = $_REQUEST['class_description'];
			
			if (!$taxes->isValidClassKey($_REQUEST['key_name']))
			{
				$add_class_error = true;
			}
			else
			{
				$added_class_id = $taxes->addClass($_REQUEST);
				$_REQUEST["showby"] = "abc";

				$add_key_name = '';
				$add_class_name = '';
				$add_class_description = '';
			}
			
			break;
		}
		case "saveClassesData" :
		{
			foreach ($_REQUEST['key_name'] as $class_id => $key_name)
			{
				if (!$taxes->isValidClassKey($key_name, $class_id))
				{
					$save_classes_errors[$class_id] = gs($key_name);
				}
			}
			if (count($save_classes_errors) == 0) $taxes->saveClassesData($_REQUEST);
			break;
		}
		case "deleteClass" :
		{
			$taxes->deleteClass($_REQUEST["class_id"]);
			break;
		}
	}
	
	$tax_classes = $taxes->getTaxClassesList();
	
?>
		<div class="admin-form-header first"><span class="icon ic-icon"></span>Taxes Classes</div>
		<div id="div-add-class" class="<?php echo count($tax_classes) ? "hidden" : "";?>">
			<form name="frmNewClass" method="POST" action="admin.php?p=taxes&tax_mode=advanced&last_active_tab=classes" onsubmit="return checkAddTaxClassForm(this)">
				<input type="hidden" name="action" value="addClass" />
				<input type="hidden" name="nonce" value="<?=create_nonce('tax_addClass');?>" />
<?php
	// display add class error
	if ($add_class_error)
	{
		print '<div style="clear: both;">';
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<strong>Tax class key  <em>".gs($_REQUEST['key_name'])."</em> already exists. Please assign a unique name or leave blank.</strong>", "url"=>"", "visible"=>true)
		));
		print '</div>';
	}
?>
				
				<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th style="width:260px;">Tax Class Key</th>
							<th style="width:260px;">Tax Class Name</th>
							<th style="width:260px;">Tax Class Description</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td class="icon">&nbsp;</td>
							<td style="width:260px;">	
								<input type="text" name="key_name" value="<?php echo gs($add_key_name)?>" maxlength="255"/>
							</td>
							<td style="width:260px;">
								<input type="text" name="class_name" value="<?php echo gs($add_class_name)?>" maxlength="128"/>
							</td>
							<td style="width:260px;">
								<input type="text" name="class_description" maxlength="255" value="<?php echo gs($add_class_description)?>"/>
							</td>
							<td style="text-align:right;">
<?php	
	if (count($tax_classes) > 0)
	{
?>
								<img style="cursor:pointer;" src="images/icons/a/arrow_up.png" onclick="$('#div-add-class').slideUp('fast');$('#add-class-button-add').show();return false;" alt="Close form" border="0"/>
<?php
	}
?>
							</td>
						</tr>
					</tbody>
				</table>		
				<div class="admin-form-buttons">
					<input type="submit" value="Add tax class" />
					<input type="reset" value="Reset form" />
				</div>
			</form>
		</div>

<?php	
	if (count($tax_classes) > 0)
	{
		
		// display add class error
		if (count($save_classes_errors) > 0)
		{
			print '<div style="clear: both;">';
			pageNote(array(
				array("class"=>"ic-cross", "text"=>"<strong>Settings not saved. Invalid tax class key name(s) entered below. Please enter a unique name or leave blank.</strong>", "url"=>"", "visible"=>true)
			));
			print '</div>';
		}
?>
		<form name="frmTaxesClasses" action="admin.php?p=taxes&tax_mode=advanced&last_active_tab=classes" method="POST">
			<input type="hidden" name="action" value="saveClassesData"/>
			<input type="hidden" name="nonce" value="<?=create_nonce('tax_saveClassesData');?>" />
			<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th style="width:260px;">Tax Class Key</th>
						<th style="width:260px;">Tax Class Name</th>
						<th style="width:260px;">Tax Class Description</th>
						<th style="text-align:right;">
							<a href="#new-tax-class" id="add-class-button-add" onclick="$('#div-add-class').slideDown('fast');$('#add-class-button-add').hide();return false;">
								Add a new tax class
								<img align="right" src="images/icons/a/add.png" alt="Click to add new class" title="Click to add new class" border="0"/>
							</a>
						</th>
					</tr>
				</thead>
				<tbody>
		
<?php
		
		for ($i=0; $i<count($tax_classes); $i++)
		{
			$tax_class = $tax_classes[$i];
			
			// display add class error
			if (in_array($tax_class["class_id"], array_keys($save_classes_errors)))
			{
				print '<div style="clear: both;">';
				pageNote(array(
					array("class"=>"ic-cross", "text"=>"<strong>Please enter a unique name or leave blank below. ".gs($save_classes_errors[$tax_class["class_id"]])." already exists.</strong>", "url"=>"", "visible"=>true)
				));
				print '</div>';
				$tax_class["key_name"] = $save_classes_errors[$tax_class["class_id"]];
			}
?>	
					<tr>
						<td class="icon">&nbsp;</td>
						<td style="width:260px;">
							<input type="text" name="key_name[<?=$tax_class["class_id"]?>]" maxlength="255" value="<?=htmlspecialchars($tax_class["key_name"])?>"/>
						</td>
						<td style="width:260px;">
							<input type="text" name="class_name[<?=$tax_class["class_id"]?>]" maxlength="128" value="<?=htmlspecialchars($tax_class["class_name"])?>"/>
						</td>
						<td style="width:260px;">
							<input type="text" name="class_description[<?=$tax_class["class_id"]?>]" maxlength="255" value="<?=htmlspecialchars($tax_class["class_description"])?>"/>
						</td>
						<td style="text-align:right;">
							<a href="admin.php?p=taxes_class&class_id=<?=$tax_class["class_id"]?>"><img border="0" src="images/icons/a/pencil.png" alt="Click to edit product class" title="Click to edit product class" /></a>
<?php
			if($tax_class["class_id"] != 1)
			{
?>
							<input type="hidden" id="tax-delete-tax-class-<?=$tax_class["class_id"]?>" name="tax-delete-tax-class-<?=$tax_class["class_id"]?>" value="<?=create_nonce('tax_deleteClass')?>" />
							<a href="javascript:confirmDeleteTaxClass('<?=$tax_class["class_id"]?>', '<?=$sortorder?>')"><img src="images/icons/a/delete.png" alt="Click to delete tax class" title="Click to delete tax class" border="0"/></a> 
<?php			
			}
?>
						</td>
					</tr>		
<?php	
		}
?>
				</tbody>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes" />
				<input type="reset" value="Reset form" />
			</div>
		</form>
<?php
	}
?>
	</div>
</div>
