<?php
	if (!defined("ENV")) exit();

	$added_country_id = "";
	
	switch ($action)
	{
		case "addRate" : 
		{
			$rate_id = $taxes->addRate($_REQUEST); 
			$_REQUEST["rate_id"] = $rate_id;
			$_REQUEST["mode"] = "listRate";
			break;
		}
		case "saveRate" : 
		{
			$rate_id = isset($_REQUEST["rate_id"])?intval($_REQUEST["rate_id"]):0;
			$taxes->saveRate($rate_id, $_REQUEST);
			$_REQUEST["mode"] = "listRate";
			break;
		}
		case "deleteRate" : 
		{
			$taxes->deleteRate($_REQUEST["rate_id"]);
			break;
		}
	}
	
	$tax_rates = $taxes->getTaxRatesList();
?>
<div id="admin-tab-sheet-rates" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
		<div class="admin-form-header">Taxes Rates</div>
<?php	
	
	if (count($tax_rates) > 0)
	{
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"This tab allows to manage taxes rates. Please note: Rates at the same priority are added, others are compounded", "url"=>"", "visible"=>true),
			array("icon"=>"ic_insert_row.gif", "text"=>"Add a New Tax Rate", "url"=>"admin.php?p=taxes_rate&amp;mode=add", "visible"=>true)
		));
?>	
		<input type="hidden" name="action" value="saveRate"/>
		<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
			<thead>
				<tr>
					<th class="icon">&nbsp;</th>
					<th style="width:100px;">Priority</th>
					<th style="width:100px;">Tax Rate</th>
					<th style="width:150px;">Class Name</th>
					<th style="width:150px;">Zone Name</th>
					<th>Rate Descriptoin</th>
					<th style="width:50px;">&nbsp;</th>
				</tr>
			</thead>
			<tbody>
		
<?php
		for ($i=0; $i<count($tax_rates); $i++)
		{
			$tax_rate = $tax_rates[$i];
?>
				<tr>
					<td class="icon">&nbsp;</div>
					<td><?=htmlspecialchars($tax_rate["rate_priority"])?></td>
					<td><?=myNum($tax_rate["tax_rate"])?>%</td>
					<td><?=htmlspecialchars($tax_rate["class_name"])?></td>
					<td><?=htmlspecialchars($tax_rate["zone_name"])?></td>
					<td><?=htmlspecialchars($tax_rate["rate_description"])?></td>
					<td style="text-align:right;">
						<a href="admin.php?p=taxes_rate&mode=edit&rate_id=<?=$tax_rate["rate_id"]?>"><img border="0" src="images/icons/ic_change_text.gif" alt="Click to edit rate"/></a>
						<a href="javascript:confirmDeleteRate('<?=$tax_rate["rate_id"]?>')"><img src="images/icons/ic_delete.gif" alt="Click to delete tax zone" border="0"/></a>
					</td>
				</tr>
<?php
		}
?>
			</tbody>
		</table>
<?php 
	}
	else
	{
		if (count($tax_zones) < 1 || count($tax_classes) < 1)
		{
			pageNote(array(
				array("icon"=>"ic_error.gif", "text"=>"Please setup Tax classes and Tax zones", "url"=>"", "visible"=>true)
			));
		}
		else
		{
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"This page allows to manage taxes rates. Please note: Rates at the same priority are added, others are compounded", "url"=>"", "visible"=>true),
				array("icon"=>"ic_insert_row.gif", "text"=>"Add a New Tax Rate", "url"=>"admin.php?p=taxes_rate&amp;mode=new", "visible"=>true)
			));
		}		
	}
?>
	</div>
</div>