<?php
	if (!defined("ENV")) exit();
	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$zone_id = isset($_REQUEST["zone_id"])?intval($_REQUEST["zone_id"]):0;
	$tax_zone = $taxes->getTaxZoneById($zone_id);
		
	if (!$tax_zone)
	{
		pageHeader("Can not find Tax Zone", "", "icb-tax");
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>Can not select tax zone by specified ID</b>", "url"=>"", "visible"=>true)
		));
		pageWhat(array(
			array("text"=>"Back to tax zones", "url"=>"admin.php?p=taxes&tax_mode=advanced&last_active_tab=zones")
		));	
	}
	else
	{
		pageHeader("Edit Tax Zone Regions - ".htmlspecialchars($tax_zone["zone_name"]), "", "icb-tax");
		pageNote(array(
			array("class"=>"ic-world", "text"=>"Back to Taxes Zones", "url"=>"admin.php?p=taxes&tax_mode=advanced&last_active_tab=zones", "visible"=>true)
		));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-zone">
<?php 
		pageTabs(array(
			array("title"=>"Tax Zone Properties", "id"=>"main")
		), "tabs-zone", false);
		
		$countries_states = $taxes->getCountriesStates(false);
			
		$action = isset($_REQUEST["action"])?$_REQUEST["action"]:"";
		$added_zr_id = "";
		
		if ($action != '')
		{
			$nonce = isset($nonce) ? $nonce : '';
			$nonce_valid = verify_nonce($nonce, 'tax_'.$action);
			if (!$nonce_valid)
			{
				invalid_nonce_message();
				exit;
			}
		}
		
		
		switch($action)
		{
			case "addZoneRegion" :
			{
				$added_zr_id = $taxes->addZoneRegion($zone_id, $_REQUEST["coid"], $_REQUEST["stid"]);
				Admin_Flash::setMessage('New tax zone region has been added');
				break;
			}
			case "deleteZoneRegion" :
			{
				$taxes->deleteZoneRegion($_REQUEST["zr_id"]);
				Admin_Flash::setMessage('Tax zone region has been deleted');
				break;
			}
		}
		
		$tax_zone_regions = $taxes->getTaxZoneRegions($zone_id);
			
		$sortorder = isset($_REQUEST["sortorder"])?$_REQUEST["sortorder"]:"asc";
		$sortorder = in_array($sortorder, array("name_asc", "name_desc"))?$sortorder:"name_asc";
		
		loadJS("regions.js");
?>
<script language="javascript" type="text/javascript">
function setZoneStates(){
	var c = $('#selectZoneCountry').val();
	var options = '<option value="0">All States / Provinces</option>';
	countries_states = <?=json_encode($countries_states)?>;
	if (c > 0 && countries_states[c]["states"])
	{
		$.each(countries_states[c]["states"], function(stid, name){
			options = options + '<option value="' + stid + '">' + name + '</option>';
		});	
	}
	$("#selectZoneState").html(options);
}
</script>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon"></span>Add a New Tax Zone Region</div>
			<form name="frmNewZoneRegion" method="POST" style="margin:0px;" action="admin.php?p=taxes_zone&zone_id=<?=$zone_id?>">
				<input type="hidden" name="action" value="addZoneRegion"/>
				<input type="hidden" name="nonce" value="<?=create_nonce('tax_addZoneRegion')?>" />
				<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th style="width:350px;">Country</th>
							<th>State / Province / Region</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td class="icon">&nbsp;</td>
							<td>
								<select id="selectZoneCountry" name="coid" onchange="setZoneStates()" style="width:340px;">
									<option value="0">All Countries</option>
<?php
		foreach ($countries_states as $coid=>$country)
		{
			echo '<option value="'.$coid.'">'.htmlspecialchars($country["country_name"]).'</option>';
		}
?>		
								</select>
							</td>
							<td>
								<select id="selectZoneState" name="stid">
									<option value="0">All States / Provinces</option>
								</select>
							</td>
							<td>&nbsp;</td>
						</tr>
					</tbody>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
<?php
		if ($tax_zone_regions)
		{
?>
			<div class="admin-form-header"><span class="icon ic-icon"></span>Tax Zone Regions</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
				<tbody>
<?php 
			for ($i=0; $i<count($tax_zone_regions); $i++)
			{
				$tax_zone_region = $tax_zone_regions[$i];
?>
					<tr>
						<td class="icon">&nbsp;</td>
						<td style="width:350px;"><?=$tax_zone_region["coid"] == "0" ? "All Countries" : htmlspecialchars($tax_zone_region["country_name"])?></td>
						<td><?=$tax_zone_region["stid"] == "0" ? "All States / Provinces" : htmlspecialchars($tax_zone_region["state_name"])?></td>
						<td style="text-align:right;">
							<input type="hidden" id="tax-delete-zone-region-<?=$tax_zone["zone_id"].'-'.$tax_zone_region['zr_id']?>" name="tax-delete-zone-region-<?=$tax_zone["zone_id"].'-'.$tax_zone_region['zr_id']?>" value="<?=create_nonce('tax_deleteZoneRegion')?>" />
							<a href="javascript:confirmDeleteTaxZoneRegion('<?=$tax_zone["zone_id"]?>', '<?=$tax_zone_region["zr_id"]?>')"><img src="images/icons/a/delete.png" alt="Click to delete tax zone region" title="Delete tax zone region" border="0"/></a>
						</td>
					</tr>
<?php
			}
		}
?>
				</tbody>
			</table>
		</div>
	</div>
</div>
<?php 
	}
?>