<?php 
	if (!defined("ENV")) exit();
	
	require_once("content/engine/engine_images.php");
	
	set_time_limit(1000);
	
	$action = isset($_GET["action"]) ? $_GET["action"] : "";
	$generateType = isset($_GET["generateType"]) ? $_GET["generateType"] : "all";
	$generateTarget = isset($_GET["generateTarget"]) ? $_GET["generateTarget"] : "new";
	
	$pathImages = "images/products/";
	$pathImagesThumbs = "images/products/thumbs/";
	$pathImagesProductPage = "images/products/preview/";
	$pathImagesSecondary = "images/products/secondary/";
	$pathImagesSecondaryThumbs = "images/products/secondary/thumbs/";

	$pathCatalogImages = "images/catalog/";
	$pathCatalogThumbs = "images/catalog/thumbs/";

	$pathManufacturerImages = "images/manufacturers/";

	switch($action)
	{
		/**
		 * Synchronize secondary images
		 */
		case "syncSecondaryImages" :
		{
			// get products data
			$db->query("SELECT product_id, pid FROM ".DB_PREFIX."products");
			$productsIds = array();
			while ($db->movenext()) $productsIds[imageFileName($db->col["product_id"])] = $db->col["pid"];
			
			// get current images
			$db->query("SELECT * FROM ".DB_PREFIX."products_images");
			$productsImages = array();
			while ($db->movenext()) $productsImages[imageFileName($db->col["filename"])] = $db->col["pid"];
			
			$counter = 0;
			
			// scan folder
			$imagesSecondary = array();
			// get images from database
			//$db->query("SELECT *")
			$d = dir($pathImagesSecondary);
			while (false !== ($entry = $d->read()))
			{
  				$filePath = $pathImagesSecondary.$entry;

  				if (is_file($filePath))
  				{
   					$fileInfo = pathinfo(strtolower($filePath));
   					$imgInfo = getimagesize($filePath);
   						
   					//check image type
   					if (in_array($imgInfo[2], array(IMAGETYPE_GIF, IMAGETYPE_PNG, IMAGETYPE_JPEG, IMAGETYPE_JPG)))
   					{
   						$filename = isset($fileInfo['filename']) ? $fileInfo['filename'] : rtrim($fileInfo['basename'], '.'.$fileInfo['extension']);
   						if (!isset($productsImages[imageFileName($filename)]))
   						{
   							//potentially new file, try to parse and find product_id for it
   							$p = strrpos($filename, "-");
   							if ($p > 1)
   							{
   								$_productId = substr($filename, 0, $p);
   								
   								if (isset($productsIds[$_productId]))
   								{
   									$_types = array(IMAGETYPE_GIF=>"gif", IMAGETYPE_PNG=>"png", IMAGETYPE_JPEG=>"jpg", IMAGETYPE_JPG=>"jpg");
   									$db->reset();
   									$db->assignStr("pid", $productsIds[$_productId]);
   									$db->assignStr("width", $imgInfo[0]);
   									$db->assignStr("height", $imgInfo[1]);
   									$db->assignStr("type", $_types[$imgInfo[2]]);
   									$db->assignStr("filename", $filename);
									$db->assignStr("is_visible", 'Yes');
   									$db->insert(DB_PREFIX."products_images");
   									$counter++;
   								}
   							}
   						}
   					}
   				}
			}
			$d->close();
			
			$response = array(
				"assignedCount" => $counter
			);
			
			echo json_encode($response);
			
			break;		
		}
		
		/**
		 * Scan folder for images, and cache secondary images
		 */
		case "scanImages" :
		{
			/**
			 * Scan for primary images
			 */
			$imagesPrimary = array();
			$imagesCatalog = array();
			$imagesManufacturer = array();

			if (in_array($generateType, array("all", "thumbs", "products")))
			{
				$d = dir($pathImages);
				while (false !== ($entry = $d->read()))
				{
   					$filePath = $pathImages.$entry;
   					if (is_file($filePath))
   					{
   						$fileInfo = pathinfo(strtolower($filePath));
   						if (in_array($fileInfo["extension"], array("jpg", "jpeg", "png", "gif")))
   						{
   							$imagesPrimary[] = $filePath;
   						}
   					}
				}
				$d->close();

				if (in_array($generateType, array("all", "thumbs")))
				{
					$d = dir($pathCatalogImages);
					while (false !== ($entry = $d->read()))
					{
	   					$filePath = $pathCatalogImages.$entry;
	   					if (is_file($filePath))
	   					{
	   						$fileInfo = pathinfo(strtolower($filePath));
	   						if (in_array($fileInfo["extension"], array("jpg", "jpeg", "png", "gif")))
	   						{
	   							$imagesCatalog[] = $filePath;
	   						}
	   					}
					}
					$d->close();
					if ($generateType == 'all')
					{
						$d = dir($pathManufacturerImages);
						while (false !== ($entry = $d->read()))
						{
		   					$filePath = $pathManufacturerImages.$entry;
		   					if (is_file($filePath))
		   					{
		   						$fileInfo = pathinfo(strtolower($filePath));
		   						if (in_array($fileInfo["extension"], array("jpg", "jpeg", "png", "gif")))
		   						{
		   							$imagesManufacturer[] = $filePath;
		   						}
		   					}
						}
						$d->close();
					}
				}
			}
			
			/**
			 * Scan for secondary images
			 */
			$imagesSecondary = array();
			if (in_array($generateType, array("all", "secondary")))
			{
				$db->query("SELECT filename, type FROM ".DB_PREFIX."products_images");
				while (($img = $db->movenext()) != false) $imagesSecondary[] = $pathImagesSecondary.$img["filename"].".".$img["type"];
			}
			
			/**
			 * SAVE SCAN RESULT
			 */
			$primaryCount = count($imagesPrimary);
			$catalogCount = count($imagesCatalog);
			$manufacturerCount = count($imagesManufacturer);
			$secondaryCount = count($imagesSecondary);
			
			$response = array(
				"imagesFound"=>($primaryCount+$secondaryCount+$catalogCount+$manufacturerCount),
			);
			
			if (($primaryCount+$secondaryCount+$catalogCount+$manufacturerCount) > 0)
			{
				$_SESSION["thumb_generator"] = array(
					"primaryCount" => $primaryCount,
					"secondaryCount" => $secondaryCount,
					"imagesPrimary" => $imagesPrimary,
					"imagesSecondary" => $imagesSecondary,
					"generateType" => $generateType,
					"generateTarget" => $generateTarget,
					"totalCount" => $primaryCount + $secondaryCount,
					"primaryPosition" => 0,
					"secondaryPosition" => 0,
					"catalogCount" => $catalogCount,
					"catalogPosition" => 0,
					"imagesCatalog" => $imagesCatalog,
					"manufacturerCount" => $manufacturerCount,
					"manufacturerPosition" => 0,
					"imagesManufacturer" => $imagesManufacturer,
				);
			}
			
			echo json_encode($response);
			break;
		}
		
		/**
		 * GENERATE THUMBS
		 */
		case "generateThumbs" :
		{
			$atOnce = rand(10, 25);
			
			// Get data from session
			$primaryPosition = $_SESSION["thumb_generator"]["primaryPosition"];
			$secondaryPosition = $_SESSION["thumb_generator"]["secondaryPosition"];
			$catalogPosition = $_SESSION["thumb_generator"]["catalogPosition"];
			$manufacturerPosition = $_SESSION["thumb_generator"]["manufacturerPosition"];

			$primaryCount =$_SESSION["thumb_generator"]["primaryCount"];
			$secondaryCount = $_SESSION["thumb_generator"]["secondaryCount"];
			$catalogCount = $_SESSION["thumb_generator"]["catalogCount"];
			$manufacturerCount = $_SESSION["thumb_generator"]["manufacturerCount"];
			
			$generateType = $_SESSION["thumb_generator"]["generateType"];
			$generateTarget = $_SESSION["thumb_generator"]["generateTarget"];
			
			//Check what is already done
			$primaryDone = $primaryPosition >= $primaryCount;
			$secondaryDone = $secondaryPosition >= $secondaryCount;
			$catalogDone = $catalogPosition >= $catalogCount;
			$manufacturerDone = $manufacturerPosition >= $manufacturerCount;

			//Preload all products ids from database
			$products = array();
			$db->query("SELECT pid, product_id FROM ".DB_PREFIX."products");
			while (($product = $db->movenext()) != false)
			{
				$products[strtolower(trim($product["product_id"]))] = $product["pid"];
			}

			$run = true;
			
			/**
			 * Generate product primary images
			 */
			if (!$primaryDone)
			{
				$run = false;

				$fileToProcess = array();
				
				$where = "";
				
				//Loop images to be processed
				$limit = $primaryPosition + $atOnce;
				$limit = $limit > $primaryCount ? $primaryCount : $limit;

				for ($i = $primaryPosition; $i < $limit ; $i++)
				{
					$filePath = $_SESSION["thumb_generator"]["imagesPrimary"][$i];
					
					$pathInfo = pathinfo($filePath);
					if (!isset($pathInfo["name"])) $pathInfo["name"] = substr($pathInfo["basename"], 0, strlen($pathInfo["basename"]) - strlen($pathInfo["extension"]) - 1);
				
					if (isset($products[$pathInfo["name"]]))
					{
						$error = "";
						$pid = $products[$pathInfo["name"]];
						
						//generate thumb image
						if (!DEMO_LOCK)
						{
							$addToWhere = true;

							if (($generateType == "all" || $generateType == "thumbs"))
							{
								if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathImagesThumbs.$pathInfo["name"].".jpg"))))
								{
									if (generateProductThumb($filePath, $pathImagesThumbs.$pathInfo["name"].".jpg"))
									{
										$addToWhere = false;
										$where .= ($where == "" ? "" : " OR ")."pid='".$pid."'";								
									}
								}
							}

							//generate product page image
							if (($generateType == "all" || $generateType == "products"))
							{
								if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathImagesProductPage.$pathInfo["name"].".jpg"))))
								{
									if (generateProductPreview($filePath, $pathImagesProductPage.$pathInfo["name"].".jpg"))
									{
										if ($addToWhere) $where .= ($where == "" ? "" : " OR ")."pid='".$pid."'";
									}
								}			
							}
						}
					}
				}
				
				//update producs locations
				if (!DEMO_LOCK && $where != "")
				{
					$db->query("UPDATE ".DB_PREFIX."products SET image_location='Local', image_url='' WHERE ".$where);
				}

				$primaryPosition = $i;

				//check is it time to stop
				if ($primaryPosition + 1 >= $primaryCount)
				{
					$primaryDone = true;
				}
				
			}
			unset($products);
			
			/**
			 * Product secondary images
			 */
			if ($run && $primaryDone && !$secondaryDone)
			{
				$run = false;

				$limit = $secondaryPosition + $atOnce;
				$limit = $limit > $secondaryCount ? $secondaryCount : $limit;

				for ($i = $secondaryPosition; $i < $limit; $i++)
				{
					$filePath = $_SESSION["thumb_generator"]["imagesSecondary"][$i];
					$pathInfo = pathinfo($filePath);
					if (!isset($pathInfo["name"])) $pathInfo["name"] = substr($pathInfo["basename"], 0, strlen($pathInfo["basename"]) - strlen($pathInfo["extension"]) - 1);
					
					$fileName = $pathInfo["name"];
						
					//generate thumb image
					if (($generateType == "all" || $generateType == "secondary"))
					{
						$pathGenerated = $pathImagesSecondaryThumbs.$fileName.".jpg";
						if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathGenerated))))
						{
							$error = "";
							if (!DEMO_LOCK)
							{
								generateProductSecondaryThumb($filePath, $pathGenerated);
							}
						}
					}					
				}

				$secondaryPosition = $i;

				if ($secondaryPosition + 1 >= $secondaryCount)
				{
					$secondaryDone = true;
				}
			}

			/**
			 * Category images
			 */
			if ($run && $primaryDone && $secondaryDone && !$catalogDone)
			{
				$run = false;

				$limit = $catalogPosition + $atOnce;
				$limit = $limit > $catalogCount ? $catalogCount : $limit;

				for ($i = $catalogPosition; $i < $limit; $i++)
				{
					$filePath = $_SESSION["thumb_generator"]["imagesCatalog"][$i];
					$pathInfo = pathinfo($filePath);
					
					if (!isset($pathInfo["name"])) $pathInfo["name"] = substr($pathInfo["basename"], 0, strlen($pathInfo["basename"]) - strlen($pathInfo["extension"]) - 1);
					
					$fileName = $pathInfo["name"];

					//regenerate image image
					if ($generateType == "all")
					{
						$pathGenerated = $pathCatalogThumbs.$fileName.".jpg";
						if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathGenerated))))
						{
							$error = "";
							if (!DEMO_LOCK)
							{
								generateCategoryImage($filePath, $pathGenerated);
							}
						}
					}

					//generate thumb image
					if (($generateType == "all" || $generateType == "thumb"))
					{
						$pathGenerated = $pathCatalogThumbs.$fileName.".jpg";
						if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathGenerated))))
						{
							$error = "";
							if (!DEMO_LOCK)
							{
								generateCategoryThumb($filePath, $pathGenerated);
							}
						}
					}
				}

				$catalogPosition = $i;

				if ($catalogPosition + 1 >= $catalogCount)
				{
					$catalogDone = true;
				}
			}

			/**
			 * Manufacturer images
			 */ 
			if ($run && $primaryDone && $secondaryDone && $catalogDone && !$manufacturerDone)
			{
				$run = false;
				$limit = $manufacturerPosition + $atOnce;
				$limit = $limit > $manufacturerCount ? $manufacturerCount : $limit;

				for ($i = $manufacturerPosition; $i < $limit; $i++)
				{
					$filePath = $_SESSION["thumb_generator"]["imagesManufacturer"][$i];
					$pathInfo = pathinfo($filePath);
					if (!isset($pathInfo["name"])) $pathInfo["name"] = substr($pathInfo["basename"], 0, strlen($pathInfo["basename"]) - strlen($pathInfo["extension"]) - 1);
					
					$fileName = $pathInfo["name"];
						
					//generate thumb image
					if (($generateType == "all"))
					{
						$pathGenerated = $pathManufacturerImages.$fileName.".jpg";
						if (($generateTarget == "all" || ($generateTarget == "new" && !is_file($pathGenerated))))
						{
							$error = "";
							if (!DEMO_LOCK)
							{
								generateManufacturerImage($filePath, $pathGenerated);
							}
						}
					}
				}

				$manufacturerPosition = $i;

				if ($manufacturerPosition + 1 >= $manufacturerCount)
				{
					$manufacturerDone = true;
				}
			}

			if ($primaryDone && $secondaryDone && $catalogDone && $manufacturerDone)
			{
				unset($_SESSION["thumb_generator"]);
			}
			else
			{
				$_SESSION["thumb_generator"]["primaryPosition"] = $primaryPosition;
				$_SESSION["thumb_generator"]["secondaryPosition"] = $secondaryPosition;
				$_SESSION["thumb_generator"]["catalogPosition"] = $catalogPosition;
				$_SESSION["thumb_generator"]["manufacturerPosition"] = $manufacturerPosition;
			}
			
			$response = array(
				"done" => $primaryDone && $secondaryDone && $catalogDone && $manufacturerDone,
				"progress" =>  round(100 / ($primaryCount + $secondaryCount + $catalogCount + $manufacturerCount) * ($primaryPosition + $secondaryPosition + $catalogPosition + $manufacturerPosition), 2),
				"progressCount" => $primaryPosition + $secondaryPosition + $catalogPosition + $manufacturerPosition,
				"totalCount" => $primaryCount + $secondaryCount + $catalogCount + $manufacturerCount,
				"rand" => rand(1000, 9999)
			);

			echo json_encode($response);
			
			break;
		}
	}
