<?php
	if (!defined("ENV")) exit();

	//groups and privileges
	$admin_pages = array(
		//common privileges
		"any"=>array("home", "profile", "profile_process", "auto_complete", "plugins", "plugin", "search_export","test"),
		//edit categories
		"categories"=>array("categories", "category", "category_process"),
		//manage products
		"products"=>array(
			"products", "product", "pticcategories", "pticcategory_process","pticcategory", "product_process", "bulk_categories",
			"bulk_products", "bulk_images", "thumbs_generator", "thumbs_generator_json",
			"products_attributes", "products_attribute", "products_attribute_process",
			"products_families", "products_family", "products_family_process",
			"manufacturers", "manufacturer_process", "products_groups","products_group",
			"products_reviews_info", "products_reviews", "products_reviews_process",
			"products_info", "ajax", "conditions", "condition", "user_products", "user_product", "dropdown"
		),
		//users
		"users"=>array("users", "user", "user_shipping", "user_process", "user_profile"),
		//salesperson
		"salesperson"=>array("salespersons", "salesperson", "salesperson_process", "salesperson_edit"),
		//orders
		"orders"=>array("orders", "order", "order_process", "order_invoice", "export_quickbooks", "export_quickbooks_process", "shipping_label_usps"),
		//emails
		"emails"=>array(
			"email_top_bottom", 
			"email_archive", "email_archive_preview",
			"email_newsletter", "email_updates",
			"email_process", "email_preview", 
			"users_emails", "emails_import",
			"email_notifications", "email_notification", 
			"email_list", "email_edit", "email_check"
		),
		//admins
		"admins"=>array("admins", "admin", "admin_process", "admins_log"), 
	// below step added by mahesh.k.s on 13-06-2011
		"add-ons"=>array("admins", "admin", "admin_process", "admins_log","home_slider","ebrochures","emailreports","notificationreports","featured_products"),
	//------end--------//
		//global
		"global"=>array(
			"settings", 
			"settings_search",
			"countries","states",
			"settings_wholesale",
			"products_locations",
			"products_location",
			"express_setup",
			"settings_email",
			"settings_dollar_days",
			"languages", "language", "language_process",
			"update",
			"localization", 
			"info","compliance"
		),
		"ccs"=>array("settings_ccs"),
		//business data
		"business"=>array(
			"taxes", "taxes_zones", "taxes_zone", "taxes_classes", "taxes_class", "taxes_rates", "taxes_rate", "taxes_settings",
			"payment_methods", "payment_method", "payment_method_process", "payment_cardinal", "merchant_signup",
			"shipping", "shipping_realtime_settings", "shipping_custom_rates",
			"discounts", "promo_edit"
		),
		//content
		"content"=>array(
			"pages", "page", "page_process", 
			"design_layout", "design_settings", "design_images",
			"design_catalog",
			"filemanager", "site_home",
			"forms_control", "custom_field", "custom_field_process",
			'design_mode', 'quick_start_guide', 'layout_helper', 'charthelper'
		),
		//export
		"database"=>array("backup_restore"),
		//statistis
		"stats"=>array("stats_charts", "charts", "reports"),
		"marketing"=>array(
			"export_froogle", "export_froogle_process", "google_marketing", 		
			"export_shopzilla", "export_shopzilla_process", "export_shopzilla_data",
			"sale_prices", "affiliate", "drift_marketing",
			"plugins", "plugin", "doba", "doba_json", "mailchimp","marketing_product_import","marketing_product_export","site_feedback","site_feedback_info","site_feedback_process"
		),
	);
	$zones_names = array(
		"any"=>"Admin Area",
		"categories"=>"Manage Categories",
		"products"=>"Manage Products",
		"users"=>"Users & Orders",
		"orders"=>"Users & Orders",
		"emails"=>"Manage Emails",
		"admins"=>"Administrators",
		"global"=>"Global Cart Settings",
		"business"=>"Order Settings",
		"content"=>"Content Management",
		"database"=>"Database & Backup",
		"stats"=>"Statistics",
		"marketing"=>"Marketing",
		"ccs"=>"CCS",
		"help"=>"Help area"
	);
	$is_page = false;
	$body = "admin_home.php";
	reset($admin_pages);
	$current_zone = "any";
	while(list($zone_name, $zone_pages) = each($admin_pages)){
		if(in_array($p, $zone_pages)){
			$is_page = true;
			//check privileges
			if(in_array($zone_name, $auth_rights) || ($zone_name == "any") || in_array("all", $auth_rights)){
				$body = "admin_".$p.".php";
				$current_zone = $zone_name;
			}
			else{
				$body = "admin_security_error.php";
			}
		}
	}
	$zone_title = $zones_names[$current_zone];
?>