<?php
    require_once("cron_init.php");
    echo date("c")." - Drift marketing emails cron job started\n";

    require_once(BASE_PATH."/content/classes/class.drift_email_campaign.php");
    require_once(BASE_PATH."/content/classes/class.phpmailer.php");
    require_once(BASE_PATH."/content/classes/class.products.php");

    require_once(BASE_PATH."content/admin/admin_init_smarty.php");

    $productUtil = new ShoppingCartProducts($db, $settings);

    $allCampaigns = DriftEmailCampaign::LoadAll($db);
    foreach ($allCampaigns as $campaign)
    {
        $timeframe = $campaign->GetTimeframe()*60;
        $sql = "select
                    a.*, b.*
                from
                    ".DB_PREFIX."orders a, ".DB_PREFIX."users b
                where
                    a.status = 'Abandon'
                    and
                    a.uid is not null
                    and
                    b.uid = a.uid
                    and
                    a.oid not in (select oid from ".DB_PREFIX."drift_email_history where campaign_id = " . $campaign->GetCampaignId() . ")";

        $db->query($sql);
        $orderRows = $db->getRecords();

        foreach ($orderRows as $orderRow)
        {
            $orderStatusDate = strtotime($orderRow["status_date"]);

            if ((time() - $orderStatusDate) > $timeframe)
            {
                $oid = $orderRow["oid"];

                $sql = "select a.*, b.image_url, b.image_location from ".DB_PREFIX."orders_content a, ".DB_PREFIX."products b where
                        a.oid = $oid
                        and
                        b.pid = a.pid";
                $db->query($sql);
                $orderItemRows = $db->getRecords();

                foreach ($orderItemRows as &$orderItemRow)
                {
                    $thumbPath = $productUtil->getProductThumb($orderItemRow["product_id"], $orderItemRow["image_location"], $orderItemRow["image_url"]);
                    if ($thumbPath)
                    {
                        $thumbImage = $settings["GlobalHttpUrl"] . "/" . $thumbPath;
                        $orderItemRow["thumb_image_url"] = $thumbImage;
                    }
                }
                //send mail to the customer
                if ($orderRow["email_mode"] == "html")
                {
                    emailCartAbandoned($db, $orderRow, $orderItemRows, $orderRow, $campaign->GetHtmlEmail(), $campaign->GetEmailSubject());
                } 
                else 
                {
                    emailCartAbandoned($db, $orderRow, $orderItemRows, $orderRow, $campaign->GetPlainEmail(), $campaign->GetEmailSubject());
                }

                //save it into the history that we sent this email
                $db->reset();
                $db->assign("oid",$oid);
                $db->assign("campaign_id",$campaign->GetCampaignId());
                $db->insert(DB_PREFIX."drift_email_history");
            }
        }
    }
    echo date("c")." - Drift marketing emails cron job completed\n";

?>