$(document).ready(function(){
	//$("#side-menu ul").sortable();

	/**
	 * Menu search
	 */
	jQuery.expr[':'].hasText = function(a, i, m){
		return jQuery(a).text().toUpperCase().indexOf(m[3].toUpperCase())>=0;
	};

	var sideMenuSearchResultsCount = 0;

	$("#side-menu .search input[type='text']").keyup(function(event){
		var keyCode = event.which;
		
		if (keyCode == 40 || keyCode == 38 || keyCode == 13)
		{
			if (sideMenuSearchResultsCount > 0)
			{
				event.stopPropagation();
				var selectedItem = $('#side-menu .menu .search-results ul li.selected');
				if (keyCode == 13)
				{
					document.location = $(selectedItem).find('a').attr('href');
				}
				else
				{
					var newSelectedItem = keyCode == 40 ? $(selectedItem).next() : $(selectedItem).prev();
					if ($(newSelectedItem).length > 0)
					{
						$(selectedItem).removeClass('selected');
						$(newSelectedItem).addClass('selected');
					}
				}
			}
		}
		else
		{
			$("#side-menu .menu .search-results").html('<ul class="level_1"></ul>');
			
			var t = $.trim($(this).val())
			
			if (t != '')
			{
				var c = 0;
				var t = t.replace('\"', '\\\"');
				$("#side-menu .menu .menu-items li:hasText('" + $(this).val() + "')").each(function(i){
					var li = $(this).clone();
					if (c < 5 && $(li).find('ul').length == 0)
					{
						$(li).attr('id', 'search-' + $(li).attr('id'));
						$(li).appendTo('#side-menu .search-results ul');
						$(li).removeClass('active');
						c++;
					}
				});

				sideMenuSearchResultsCount = c;

				if (c > 0)
				{
					$('#side-menu .menu .search-results').slideDown('fast', 'linear');
					$('#side-menu .menu .search-results ul li:first').addClass('selected');
				}
				else
				{
					$('#side-menu .menu .search-results').slideUp('fast', 'linear');
				}
			}
		}
	});
	
	/**
	 * Menu items
	 */ 
	$("#side-menu .menu ul li").each(function(i){
		var li = this;
		
		if ($(li).hasClass('target-blank'))
		{
			$(li).find('a').attr('target', '_blank');
		}
		
		$(this).click(function(e){
			e.stopPropagation();
			
			var ul = $(this).find('ul:first');
			
			if ($(ul).length > 0)
			{
				if ($(ul).is(':visible'))
				{
					$(li).addClass('animate_up');
					$(ul).slideToggle(150, 'linear', function(){
						$(li).removeClass('animate_up');
						$(li).removeClass('open');
					});
				}
				else
				{
					$(li).addClass('animate_down');
					$(ul).slideToggle(150, 'linear', function(){
						$(li).removeClass('animate_down');
						$(li).addClass('open');
					});
				}
			}
		});
	});
	
	/**
	 * Slider area
	 */
	$('.admin-form-header.slide-manager').each(function(){
		var manager = this;
		
		if ($(manager).find('.admin-form-header-buttons').length == 0)
		{
			$(manager).prepend('<div class="admin-form-header-buttons"></div>');
		}
		
		$(manager).find('.admin-form-header-buttons').append('<span class="icon ic-icon ic-arrow-down slide-switch"></span>');
		
		$(manager).click(function(){
			var area = $(manager).nextAll('.slide-area:first');
			if ($(area).length > 0)
			{
				var swtch = $(manager).find('.slide-switch');
				
				
				if ($(area).is(':visible'))
				{
					$(swtch).removeClass('ic-arrow-up').addClass('animate-down');
				}
				else
				{
					$(swtch).removeClass('ic-arrow-down').addClass('animate-up');		
				}
				
				$(area).slideToggle('fast', 'linear', function(){
					
					if ($(area).is(':visible'))
					{
						$(swtch).removeClass('animate-up').addClass('ic-arrow-up');		
						
					}
					else
					{
						$(swtch).removeClass('animate-down').addClass('ic-arrow-down');
					}
				});
			}
		});
	});
	
	/**
	 * Text editor
	 */
	$('.admin-form-header.editor-manager').each(function(){
		var manager = this;
		
		if ($(manager).find('.admin-form-header-buttons').length == 0)
		{
			$(manager).prepend('<div class="admin-form-header-buttons"></div>');
		}
		$(manager).find('.admin-form-header-buttons').append('<span class="icon ic-icon ic-pencil editor-switch"></span>');
		$(manager).find('.editor-switch').click(function(e){
			e.stopPropagation();
			var area = $(manager).next().find('.editor-area:first');
			if ($(area).length > 0)
			{
				toggleEditorMode($(area).attr('id'), false);
			}
		});
	});
	
	/**
	 * Image Preview
	 */
	$('.field.field-image-preview').each(function(){
		$(this).find('a').click(function(e){
			if ($(this).is('.delete_image'))
			{
				return false;
			}

			e.stopPropagation();
			
			if ($('#image-preview-dialog').length == 0)
			{
				$('<div id="image-preview-dialog"><div><div class="image-preview-dialog-image"><img/></div><div class="image-preview-dialog-description"></div></div></div>').appendTo('body');
				
				$('#image-preview-dialog').dialog({
					title: 'Image Preview',
					autoOpen: false,
					modal: true,
					width: 700,
					height: 500,
					open: function(){
						$(this).dialog('option', 'width', 700);
						$(this).dialog('option', 'height', 500);
						//correctDialogPosition("#image-preview-dialog");
					}
				});
				
				$('#image-preview-dialog .image-preview-dialog-image img').load(function(){
					adminHideSpinner();
					$('#image-preview-dialog').dialog('open');
				});
			}
			
			adminShowSpinner('Loading image preview');
			$('#image-preview-dialog .image-preview-dialog-description').html($(this).parent().parent().find('.image-preview-info').html());
			$('#image-preview-dialog .image-preview-dialog-image img').attr('src', $(this).attr('href'));
			
			return false;
		});
	});
	
	/**
	 * Color picker
	 */
	$('.field-color input[type="text"]').each(function(){
		var input = this;
		$(input).ColorPicker({
			onSubmit: function(hsb, hex, rgb, el) {$(el).val('#'+hex);$(el).ColorPickerHide();},
			onBeforeShow: function() {$(input).ColorPickerSetColor(input.value);return false;},
			onChange: function (hsb, hex, rgb) {
				$(input).val('#' + hex);
				$(input).parent().find('.color-preview-inner').css({backgroundColor:'#' + hex});
			}
		})
		.change(function(){
			$(input).ColorPickerSetColor(this.value);
		});
	});
	
	/**
	 * Loader
	 */
	$(window).unload(function(){
		adminShowSpinner('Loading data from a server');
	});
});
