function toggleAdvancedProperties() 
{
	if ($("#advanced:visible").size() > 0)
	{
		$("#advanced").hide();
		$("#basic_save_row").hide();
		$("#advBtn input").val('Advanced Properties');
	}
	else
	{
		$("#advanced").show();
		$("#basic_save_row").show();
		$("#advBtn input").val('Hide Advanced Properties');		
	}
}

$(document).ready(function(){
	/**
	 * Loock fields
	 */ 
	$(".field .lock").each(function(){
		$(this).click(function(){
			lockValue = $(this).find('input').attr('value');
			locks = $('.field .lock input[value="'+lockValue+'"]');
			locked = $(this).hasClass('locked');

			for (i = 0; i < locks.size(); i++)
			{
				lockElement = $(locks.get(i)).parent();

				if (locked)
				{
					lockField_unlock(lockElement);
				}
				else
				{
					lockField_lock(lockElement);
				}
			}
		});
	});
	
	/**
	 * Check Inventory Sub Ids to be unique
	 */
	$('#add-new-inventory-control').click(function(){
		return checkInventorySubIds(true);
	});
	
	$('#update-inventory-control').click(function(){
		return checkInventorySubIds(false);
	});
});

function lockField_unlock(theField){
	$(theField).find('input').attr('name', 'unlock_fields[]');
	$(theField).parent().find('.control input,.control textarea').removeAttr('readonly').removeClass('readonly');
	$(theField).parent().find('.control select').removeAttr('disabled').removeClass('readonly').removeClass('locked');
	$(theField).removeClass('locked');
}

function lockField_lock(theField){
	$(theField).find('input').attr('name', 'lock_fields[]');
	$(theField).parent().find('.control input,.control textarea').attr('readonly', 'readonly').addClass('readonly');
	$(theField).parent().find('.control select').attr('disabled', 'disabled').addClass('readonly').addClass('locked');
	$(theField).addClass('locked');
}

function checkInventorySubIds(checkNewSubId)
{
	if ($('input[name="inventory_control"]:checked').length && $.inArray($('input[name="inventory_control"]:checked').val(), ['AttrRuleInc','AttrRuleExc']) != -1)
	{
		hasError = false;
		inventoryMap = [];

		if ($('input.inventory-attribute-sub-id').length > 0)
		{
			$('input.inventory-attribute-sub-id').each(function(){

				var subId = $.trim($(this).val().toLowerCase());

				if (subId == '') hasError = true;
				if ($.inArray(subId, inventoryMap) == -1)
					inventoryMap.push(subId);
				else
					hasError = true;
			});
		}

		if (checkNewSubId && $('#inv-attr-subid').length > 0)
		{
			newProductSubId = $.trim($('#inv-attr-subid').val().toLowerCase());
			if (newProductSubId == '' || $.inArray(newProductSubId, inventoryMap) > -1) hasError = true;
		}

		if (hasError)
		{
			alert('All Product Sub IDs must be unique and cannot be blank. Please correct and try again.');
			return false;
		}
	}
	
	return true;
}

function ShowHideOverview(){
	el = document.getElementById("dvOverview");
	el.style.display = el.style.display == "none"?"block":"none";
}

function ShowHideInventory(){
	el = document.getElementById("dvInventory");
	el.style.display = el.style.display == "none"?"block":"none";
}

function moveFamily(source_id, destination_id){
	var src = document.getElementById(source_id);
	var des = document.getElementById(destination_id);
	var a = new Array();
	for(var i=0; i<src.options.length; i++){
		if(src.options[i].selected){
			des.options[des.options.length] = new Option(src.options[i].text, src.options[i].value);
		}
		else{
			a[a.length] = new Option(src.options[i].text, src.options[i].value);
		}
	}
	src.options.length = a.length;
	for(var i=0; i<a.length; i++){
		src.options[i] = new Option(a[i].text, a[i].value);
	}
}

function CheckProductForm(frm, is_case_pack, is_inter_pack)
{
	var error_num = 
		"Accepted values are\n"+
		"numbers with (or without) period comma separators\n"+
		"and with . (dot) decimal separator. Examples:\n"+
		"12,199.90; 12.23; 8900; 23,179";
	
	if (frm.elements["cid"].value=="0")
	{
		alert("Please select primary category");
		setActiveTab('tabs-product', 'main');
		frm.elements["cid"].focus();
		return false;
	}
	
	if (frm.elements["product_id"].value=="")
	{
		alert("Please enter product ID");
		setActiveTab('tabs-product', 'main');
		frm.elements["product_id"].focus();
		return false;
	}
	
	if (frm.elements["title"].value=="")
	{
		alert("Please enter product title");
		setActiveTab('tabs-product', 'main');
		frm.elements["title"].focus();
		return false;
	}
	
	if (!checkNumber(frm.elements["price"].value))
	{
		alert("Please enter valid product price!" + error_num);
		setActiveTab('tabs-product', 'main');
		frm.elements["price"].focus();
		return false;
	}
	
	if (frm.elements["price2"].value != "")
	{
		if (!checkNumber(frm.elements["price2"].value))
		{
			alert("Please enter valid product Sale Price!" + error_num);
			setActiveTab('tabs-product', 'main');
			frm.elements["price2"].focus();
			return false;
		}
		else
		{
			var spr = normalizeNumber(frm.elements["price2"].value);
			var ppr = normalizeNumber(frm.elements["price"].value);
			if (spr >= ppr)
			{
				alert("Please enter valid Sale Price!\nSale price must be less than the Unit Price");
				setActiveTab('tabs-product', 'main');
				frm.elements["price2"].focus();
				return false;
			}
		}
	}
	
	if ((frm.elements["weight"].value != "") && (!checkNumber(frm.elements["weight"].value)))
	{
		alert("Please enter valid product weight! " + error_num);
		setActiveTab('tabs-product', 'main');
		frm.elements["weight"].focus();
		return false;
	}
	
	var prex_shipping_price = /^shipping_price\[(\w{1,100})\]$/;
	
	for (i=0; i<frm.elements.length; i++)
	{
		el = frm.elements[i];
		if(prex_shipping_price.test(el.name)){
			if((el.value != "") && (!checkNumber(el.value))){
				alert("Please enter valid shipping price! " + error_num);
				setActiveTab('tabs-product', 'main');
				el.focus();
				return false;
			}
		}
	}
	
	if (is_inter_pack == "YES")
	{
		if((frm.elements["inter_pack"].value != "") && (!checkNumber(frm.elements["inter_pack"].value))){
			alert("Please enter valid Inter Pack value or leave this field blank!");
			setActiveTab('tabs-product', 'main');
			frm.elements["inter_pack"].focus();
			return false;
		}
	}

	if (is_case_pack == "YES")
	{
		if((frm.elements["case_pack"].value != "") && (!checkNumber(frm.elements["case_pack"].value))){
			alert("Please enter valid Case Pack value or leave this field blank!");
			setActiveTab('tabs-product', 'main');
			frm.elements["case_pack"].focus();
			return false;
		}
	}
	
	if (!checkNumber(frm.elements["min_order"].value))
	{
		alert("Please enter valid Min Order value.\nBy default it is 1.");
		setActiveTab('tabs-product', 'main');
		frm.elements["min_order"].focus();
		return false;
	}
	
	if ((frm.elements["max_order"].value != "") && (!checkNumber(frm.elements["max_order"].value)))
	{
		alert("Please enter valid Max Order value or leave this field blank!");
		setActiveTab('tabs-product', 'main');
		frm.elements["max_order"].focus();
		return false;
	}
	
	/**
	 * Check attributes
	 */
	var product_attribute_error = false;
	$('#product_attributes tbody tr input[type="text"], #product_attributes tbody tr textarea').each(function(){
		if (!product_attribute_error && $(this).val() == '' && $(this).is(':visible'))
		{
			product_attribute_error = true;
			alert('Please enter attribute property!');
			setActiveTab('tabs-product', 'attributes');
			$(this).focus();
		}
	});
	if (product_attribute_error) return false;
	
	
	if (frm.elements["inventory_control"].value == "Yes")
	{
		el = document.getElementById("divInventory");

		if(!checkNumber($('#field-stock').val())){
			alert("Please enter valid Number of items in inventory!");
			setActiveTab('tabs-product', 'main');
			if(el.style.display != "block") el.style.display = "block";
			frm.elements["stock"].focus();
			return false;
		}
		if($.trim($('#field-stock_warning').val()) != '' && !checkNumber($('#field-stock_warning').val()))
		{
			alert("Please enter valid \"Stock Warning Notification\" value!");
			setActiveTab('tabs-product', 'main');
			if(el.style.display != "block") el.style.display = "block";
			frm.elements["stock_warning"].focus();
			return false;
		}
	}
	
	/**
	 * Check Inventory Sub Ids
	 */
	if (checkInventorySubIds(false) == false)
	{
		setActiveTab('tabs-product', 'inventory');
		return false;
	}
	
	/**
	 * 
	 */
	var prex_min = /^qd_min\[(\w{1,100})\]$/;
	var prex_max = /^qd_max\[(\w{1,100})\]$/;
	var prex_dis = /^qd_discount\[(\w{1,100})\]$/;
	for(i=0; i<frm.elements.length; i++){
		if(prex_min.test(frm.elements[i].name)){
			if(!checkNumber(frm.elements[i].value)){
				alert("Please enter valid miniman range value! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements[i].focus();
				return false;
			}
		}
		if(prex_max.test(frm.elements[i].name)){
			if(!checkNumber(frm.elements[i].value)){
				alert("Please enter valid miniman range value! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements[i].focus();
				return false;
			}
		}
		if(prex_dis.test(frm.elements[i].name)){
			if(!checkNumber(frm.elements[i].value)){
				alert("Please enter valid discount value! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements[i].focus();
				return false;
			}
		}
	}
	
	if(frm.elements["qdnew_active"]){
		if(frm.elements["qdnew_min"].value != ""){
			if(!checkNumber(frm.elements["qdnew_min"].value)){
				alert("Please enter valid minimal range! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements["qdnew_min"].focus();
				return false;
			}
			if(!checkNumber(frm.elements["qdnew_max"].value)){
				alert("Please enter valid maximal range! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements["qdnew_max"].focus();
				return false;
			}
			if(!checkNumber(frm.elements["qdnew_discount"].value)){
				alert("Please enter valid discount value! " + error_num);
				setActiveTab('tabs-product', 'discounts');
				frm.elements["qdnew_discount"].focus();
				return false;
			}
		}
	}
	
	pf = document.getElementById("families_p");
	var s = "";
	if(pf){
		for(i = 0; i < pf.options.length; i++){
			s = s + pf.options[i].value + ',';
		}
		frm.elements["product_families"].value = s;
	}
	pg = document.getElementById("pr_gifts");
	var s = "";
	if(pg){
		for(i = 0; i < pg.options.length; i++){
			s = s + pg.options[i].value + ',';
		}
		frm.elements["product_gifts"].value = s;
	}

	$('select.locked').removeAttr('disabled').removeClass('locked');

	return true;
}

function setInvControlType()
{
	var selected_opt = $('input[name="inventory_control"]:checked').val();

	switch(selected_opt)
	{
		case "No" :
		{
			$('#divInvProdLevel').hide();
			$('#divInvAttrLevel').hide();
			break;
		}
		case "Yes" :
		{
			$('#divInvProdLevel').show();
			$('#divInvAttrLevel').hide();
			break;
		}
		case "AttrRuleInc" :
		case "AttrRuleExc" :
		{
			$('#divInvProdLevel').hide();
			$('#divInvAttrLevel').show();
			break;
		}
	}
}

$(document).ready(function() {
	
	$('.attribute-type-select').each(function(){
		$(this).change(function(){
			var p = $(this).parent().parent();
			$(p).find('.type-select,.type-radio,.type-text,.type-textarea').hide();
			$(p).find('.type-' + $(this).val()).show();
		});
	});
	
	
	$("#dialog-add-global-attribute-button-add").click(function(){
		var selected = '';
		$('input[name^="global_attributes"]:checked').each(function(index, input){
			if (selected.length > 0) selected += ',';

			selected += $(input).attr('name').replace('global_attributes[', '').replace(']', '');
		});
		$.ajax({
			type: 'POST',
			url: 'admin.php?p=attribute_json&chart=true',
			data: {
				pid: $('input[name="pid"]').val(),
				mode: 'add_globals',
				global_aids: selected
			}
		}).success(function(data){
			adminShowSpinner('Adding global attribute', true);
			document.location = 'admin.php?p=product&mode=update&pid=' + $('input[name="pid"]').val() + '&last_active_tab=attributes';
		});
	});
	
	$("#dialog-add-attribute-button-add").click(function(){
		// validate form
		if ($('input[name="new_attribute[name]"]').val() == '')
		{
			alert('Please enter attribute name!');
			$('input[name="new_attribute[name]"]').focus();
			return;
		}
		if ($('input[name="new_attribute[caption]"]').val() == '')
		{
			alert('Please enter attribute caption!');
			$('input[name="new_attribute[caption]"]').focus();
			return;
		}
		switch ($('select[name="new_attribute[attribute_type]"]').val())
		{
			case 'select' :
			case 'radio' :
			{
				if ($('textarea[name="new_attribute[options]"]').val() == '')
				{
					alert('Please enter attribute options!');
					$('textarea[new_attribute[options]"]').focus();
					return;
				}
				break;
			}
		}
		
		is_active = $('input[name="new_attribute[is_active]"]:checked').size() > 0 ? 'Yes' : 'No';
		track_inventory = $('input[name="new_attribute[track_inventory]"]:checked').size() > 0 ? '1' : '0';

		$.ajax(
			{
				type: 'POST',
				url: 'admin.php?p=attribute_json&chart=true',
				data: {
					pid: $('input[name="pid"]').val(),
					mode: 'add',
					name: $('input[name="new_attribute[name]"]').val(),
					caption: $('input[name="new_attribute[caption]"]').val(),
					priority: $('select[name="new_attribute[priority]"]').val(),
					attribute_type: $('select[name="new_attribute[attribute_type]"]').val(),
					options: $('textarea[name="new_attribute[options]"]').val(),
					text_length: $('input[name="new_attribute[text_length]"]').val(),
					is_active: is_active,
					track_inventory: track_inventory
				}
			})
			.success(function(data){
				adminShowSpinner('Adding attribute', true);
				document.location = 'admin.php?p=product&mode=update&pid=' + $('input[name="pid"]').val() + '&last_active_tab=attributes';
			});
	});
	
	$('#dialog-add-attribute').dialog({
		'title'          : 'Add Attribute',
		'autoOpen'       : false,
		'modal'          : true,
		'closeOnEscape'  : false,
		'resizable'      : false,
		'width'          : 800,
		'open': function(e, ui)
		{
			$('#dialog-add-attribute select[name="new_attribute[attribute_type]"]').change();
		}
	});
	
	$('#dialog-add-attribute select[name="new_attribute[attribute_type]"]').change(function(){
		switch ($(this).val())
		{
			case 'select' :
			case 'radio' :
			{
				$('#dialog-add-attribute .field').has('#field-new_attribute-text_length').hide();
				$('#dialog-add-attribute .field').has('#field-new_attribute-track_inventory').show();
				$('#dialog-add-attribute .field').has('#field-new_attribute-options').show();
				$('#dialog-add-attribute .dialog-add-attribute-help').show();
				break;
			}
			case 'textarea' :
			case 'text' :
			{
				$('#dialog-add-attribute .field').has('#field-new_attribute-track_inventory').hide();
				$('#dialog-add-attribute .field').has('#field-new_attribute-options').hide();
				$('#dialog-add-attribute .dialog-add-attribute-help').hide();
				$('#dialog-add-attribute .field').has('#field-new_attribute-text_length').show();
				break;
			}
		}
	});
	
	$('#dialog-add-global-attribute').dialog({
		'title'          : 'Add Global Attribute',
		'autoOpen'       : false,
		'modal'          : true,
		'closeOnEscape'  : false,
		'resizable'      : false,
		'width'          : 800
	});
	
	$("#lnkAddAttribute").click(function(){
		$('#dialog-add-attribute').dialog('open');
		return false;
	});
	
	$("#lnkAddGlobalAttribute").click(function(){
		$('#dialog-add-global-attribute').dialog('open');
		return false;
	});
	
	$('input[name="inventory_control"]').click(function() {
		setInvControlType();
	});
	
	setInvControlType();

});