var lastProductItemId = false;
var pleaseWait = 'Please wait, loading data...';
var watchlistsPages = new Array();
var updateQueue = new Array();

var updateInProgress = false;
var cancelInterval = false;
var threadsCount = 0;

var productsUpdated = 0;
var productsPerPage = 25;
var pagesInList = 10;

$(document).ready(function(){
	$("#dobaWatchlists").addClass('load_spinner').html(pleaseWait);
	$("#dobaOrders").addClass('load_spinner').html(pleaseWait);
	
	/**
	 * Load watch lists
	 */
	$.getJSON('admin.php?p=doba_json&chart=true&action=getWatchlists', function(data){
		$("#dobaWatchlists").removeClass('load_spinner').html("");
		if (data.status == 1)
		{ 
			if (data.count > 0)
			{
				$("#dobaWatchlists").html('<table cellpadding="0" cellspacing="0" border="0"><thead>' + $("#dobaWatchlistsPrototype thead").html() + "</thead><tbody></tbody></table>");
				$.each(data.data.watchlist, function(i, item){
					var id = item.watchlist_id.toString();
					var watchlist = $("#dobaWatchlistsPrototype tbody .watchlist").clone();
					$(watchlist).attr("id", "watchlist_" + id);
					$(watchlist).data("itemsCount", item.item_count.toString());
					$(watchlist).find("td.colCheckbox input").attr("value", id).attr("id", "cbwl_" + id);
					$(watchlist).find("td.colShowProducts div").click(function(){
						eval('getWatchlistProducts(' + id + ', false, true, 1);');
					});
					$(watchlist).find("td.colName label").attr('for', "cbwl_" + id).html(item.name.toString());
					$(watchlist).find("td.colItemCount").html(item.item_count.toString());
					$(watchlist).appendTo("#dobaWatchlists table tbody");
				});
				
				$("#buttonUpdateProducts").removeAttr("disabled");
				$("#watchlists-check-uncheck").show();
			}
			else
			{
				$("#dobaWatchlists").html('<div class="message">You do not have watchlists yet. Please log in into your Doba account, create a watchlist and add there products.</div>');
			}
		}
		else
		{
			$("#dobaWatchlists").html('<div class="message">Server returned error: ' + data.message + '</div>');
		}
	});
	
	/**
	 * Check - uncheck all
	 */
	$("#watchlists-check-all").click(function(){
		$("#dobaWatchlists .watchlist input[type='checkbox']").each(function(){
			$(this).attr('checked', 'checked');
		});
		return false;
	});
	
	$("#watchlists-uncheck-all").click(function(){
		$("#dobaWatchlists .watchlist input[type='checkbox']").each(function(){
			$(this).removeAttr('checked');
		});
		return false;
	});
	
	/**
	 * Request Partner Permission Activation link
	 */
	$('#requestActivation').click(function(){
		$.getJSON('admin.php?p=doba_json&chart=true&action=requestPartnerPermission', function(data){
			if (data.status)
			{
				// show a notification the status was successfully sent
				alert('Activation request has been sent!\n\nPlease log into your Doba account to complete the activation process.');
			}
			else
			{
				alert('There was an error processing your request.\n\n'+data.message);
			}
		});
		return false;
	});
	
	/**
	 * Controls the Activation Status for the Retailer ID
	 */
	if ('tr.activation-link:visible')
	{
		$('span#doba-activation-status').show();
		
		$.getJSON('admin.php?p=doba_json&chart=true&action=hasPartnerPermission', function(data){
			var status = $('span#doba-activation-status');
			switch (data.message)
			{
				case 'accepted':status.css({'color':'green'}).html('Activated');break;
				case 'pending':status.css({'color':'green'}).html('Pending Activation');break;
				case 'declined':status.css({'color':'red'}).html('Declined');break;
				case 'missing request':status.html('');break;
			}	
		});
	}
	 
	/**
	 * Handle save prices settings click
	 */
	$("#buttonSavePriceSettings").click(function(){
		var priceOption = $("#dobaPriceOption").val();
		var priceModifier = parseFloat($("#dobaPriceModifier").val());
		var dobaPriceOption99 = $("#dobaPriceOption99").val();
		$.getJSON(
			'admin.php?p=doba_json&chart=true&action=savePriceSettings' + 
			'&price_option=' + escape(priceOption) +
			'&price_option99=' + escape(dobaPriceOption99) +
			'&price_modifier=' + escape(priceModifier),
			function(data){
				if (data.status == 1)
				{
					alert('Settings are saved');
				}
			}
		);
	});
	
	/**
	 * Handle products remapping
	 */
	$("#buttonRemapSettings").click(function(){
		var mappingOption = $("#dobaMappingOption").val();
		var mappingKeepCategories = $("#dobaMappingKeepCategories").val();
		$.getJSON(
			'admin.php?p=doba_json&chart=true&action=remapProducts' + 
			'&mapping_option=' + escape(mappingOption) +
			'&mapping_keep_categories=' + escape(mappingKeepCategories),
			function(data){
				if (data.status == 1)
				{
					alert('Products have been remapped');
				}
			}
		);
	});
	
	/**
	 * Handle set prices click action
	 */
	/**
	$("#buttonSetPrices").attr("disabled", true).click(function(){
		$(".watchlistProduct").each(function(){
			var item_price = parseFloat($(this).find(".colProdPrice input[type='hidden']").val());
			var msrp = parseFloat($(this).find(".colProdMSRP input[type='hidden']").val());
			$(this).find(".colProdSalePrice input[type='text']").val(getItemSalePrice(item_price, msrp));
		});
	});
	**/
	
	/**
	 * Handle update / cancel button
	 */
	$("#buttonUpdateProducts").attr("disabled", true).click(function()
	{
		//if already updating, cancel
		if (updateInProgress)
		{
			$(this).val("Cancelling, please wait...");
			$(this).attr("disabled", true); 
			updateInProgress = false;
			cancelInterval = setInterval('cancelCheckThreads();', 1000);
		}
		//or start a new update process
		else
		{
			$(this).attr("disabled", true); 
			setTimeout('$("#buttonUpdateProducts").removeAttr("disabled");', 1000);

			updateInProgress = true;
			$(this).val("Cancel Update");
			
			//save settings first
			var post_str = 
				'data[doba_price_option]=' + escape($("#dobaPriceOption").val()) + '&' +
				'data[doba_price_modifier]=' + escape($("#dobaPriceModifier").val()) + '&' +
				'data[doba_price_option99]=' + escape($("#dobaPriceOption99").val()) + '&' +
				'data[doba_min_stock]=' + escape($("#dobaMinStock").val());
			
			threadsCount++;
			$.post("admin.php?p=doba_json&chart=true&action=updateImportSettings", post_str, function(response){
				threadsCount--;
				//after settings saved, do update product
				var result = JSON.parse(response);
			
				if(result.status)
				{
					var watchlistsSelected = 0;
					$(".colCheckbox input").each(function(){
						if($(this).attr("checked"))
						{
							var watchlistId = $(this).val();
							//getWatchlistProducts(watchlistId, false, false, 1);
							doUpdateProducts(watchlistId);
							watchlistsSelected++;
						}
					});
					//check are there watclists selected
					if(watchlistsSelected == 0)
					{
						cancelUpdate();
						cancelCheckThreads();
						alert("Please select at least one watchlist to update!");
					}
				}
			});
		}
	});
	
	/**
	 * Init categories mapper
	 **/
	$('#dobaMappingDialog').dialog({
		'autoOpen': false, 
		'modal': true,
		'width': 700,
		'height': 500,
		'resizable' : false,
		'buttons':
		{
			'Save' : function()
			{
				adminShowSpinner('Saving data');
				
				var categories = '';
				var doba_cid = $("#dobaMappingDialog").data('doba_cid');
				var primary_cid = $("#dobaMappingDialogPrimaryCategory").val();
				var subcats = $("#dobaMappingDialogIncludeSubCategories").is(':checked') ? 1 : 0;
				
				$("#dobaMappingDialogCategories option").each(function(){
					if ($(this).is(':selected'))
					{
						if ($(this).attr('value') != primary_cid)
						{
							categories = 
								categories + (categories == "" ? "" : ",") +
								$(this).attr('value');
						}
					}
				});
				
				$.post(
					"admin.php?p=doba_json&chart=true&action=setMappedCategories", 
					{
						'doba_cid' : doba_cid,
						'primary_cid' : primary_cid,
						'categories' : categories,
						'subcats' : subcats
					},
					function(_response){
						//parse response
						var response = JSON.parse(_response);
						if (response.status == 1)
						{
							if (categories != '' || primary_cid > 0)
							{
								$('#doba-node-' + doba_cid).addClass('doba-category-mapped');
							}
							else
							{
								$('#doba-node-' + doba_cid).removeClass('doba-category-mapped');
							}
							
							if (subcats == 1)
							{
								$('#doba-node-' + doba_cid).addClass('doba-include-subcats');
							}
							else
							{
								$('#doba-node-' + doba_cid).removeClass('doba-include-subcats');
							}
							
							$('#dobaMappingDialog').dialog("close");
							adminHideSpinner();
						}
					}
				);
			},
			'Cancel': function()
			{
				$(this).dialog("close");
			}
		}
	});
	
	$('#dobaCategories .admin-tree-node .admin-icon-clickable').each(function(){
		$(this).click(function(event){
			event.stopPropagation();
			//var icon = $(this);
			var children = $(this).parent().parent().next();
			if ($(children).hasClass('hidden'))
			{
				$(children).removeClass('hidden');
				$(this).removeClass('admin-icon-east').addClass('admin-icon-south');
			}
			else
			{
				$(children).addClass('hidden');
				$(this).removeClass('admin-icon-south').addClass('admin-icon-east');
			}
		});
	});
	
	/**
	 * Tree node click
	 */
	$('#dobaCategories .admin-tree-node').each(function(){
		$(this).mouseover(function(){
			$(this).find('.doba-category-name').css({textDecoration:'underline'});
		});
		
		$(this).mouseout(function(){
			$(this).find('.doba-category-name').css({textDecoration:'none'});
		});
		
		$(this).click(function(){
			adminShowSpinner('Loading category data');
			var doba_cid = $(this).find('input[type="hidden"]').val();
			$("#dobaMappingDialog").data('doba_cid', doba_cid);
			var node = this;
			$.post(
				"admin.php?p=doba_json&chart=true&action=getMappedCategories", 
				{
					'doba_cid' : $(this).find('input[type="hidden"]').val()
				}, 
				function(_response){
					//parse response
					var response = JSON.parse(_response);
					
					if (response.status == 1)
					{
						if ((response.data != null) && (response.data.primary_cid != null))
						{
							$('#dobaMappingDialogPrimaryCategory').val(response.data.primary_cid);
						}
						else
						{
							$('#dobaMappingDialogPrimaryCategory').val(0);
						}
						
						$("#dobaMappingDialogCategories option").each(function(){

							$(this).removeAttr('selected');
						
							var value = $(this).attr('value');
							var in_array = false;
							
							if ((response.data != null) && (response.data.categories != null))
							{
								for (i = 0; i < response.data.categories.length; i++)
								{
									if (value == response.data.categories[i])
									{	
										in_array = true;
										break;
									}
								}
							
								if (in_array) $(this).attr('selected', 'selected');
							}
						});
						
						if ((response.data != null) && (response.data.subcats != null) && response.data.subcats == 1)
						{
							$('#dobaMappingDialogIncludeSubCategories').attr('checked', 'checked');
						}
						else
						{
							$('#dobaMappingDialogIncludeSubCategories').removeAttr('checked');							
						}
						
						$('#dobaMappingDialog').dialog({title:'"' + $(node).find('.doba-category-name').html() + '" Doba Category Mapping'});
						$('#dobaMappingDialog').dialog('open');
					}
					adminHideSpinner();
				}
			);
		})
	});
	
	/**
	 * Search categories
	 */
	$('#dobaMappingDialogSearch').keyup(function(){
		var str = $(this).val();
		str = str.toLowerCase();
		
		$("#dobaMappingDialogCategories option").each(function(){
			var val = $(this).text();
			val = val.toLowerCase();
			
			if (val.indexOf(str) >= 0)
			{
				$(this).show();	
			}
			else
			{
				$(this).hide();
			}
		});
		
	});
	
	/**
	 * Expand / collapse categories
	 */
	$("#dobaCategoriesExpandAll").click(function(e){
		e.stopPropagation();
		$("#dobaCategories .admin-tree-node .admin-icon-clickable").removeClass('admin-icon-east').addClass('admin-icon-south');
		$("#dobaCategories .doba-children").removeClass('hidden');
		return false;
	});
	
	$("#dobaCategoriesCollapseAll").click(function(e){
		e.stopPropagation();
		$("#dobaCategories .admin-tree-node .admin-icon-clickable").removeClass('admin-icon-south').addClass('admin-icon-east');
		$("#dobaCategories .doba-children").addClass('hidden');
		return false;
	});
});

/**
 * Cancels update process
 * @return
 */
function cancelUpdate()
{
	updateInProgress = false;
	
	//clear queue
	for(var i=0; i < updateQueue.length; i++)
	{
		watchlistId = updateQueue[i];
		if (watchlistProducts[watchlistId]["interval"]) clearInterval(watchlistProducts[watchlistId]["interval"]);
	}
	
	//reset arrays
	updateQueue = new Array();
	watchlistProducts = new Array();
	
	//set messages
	$('.watchlist .colProgress').each(function(){
		if($(this).html() != "&nbsp;")
		{
			$(this).html("Cancelling...");
		}
	});
	
	//disable button
	$("#buttonUpdateProducts").attr("disabled", true).val("Cancelling " + threadsCount + " thread(s)");
}

/**
 * Check are all thread completed
 * @return
 */
function cancelCheckThreads()
{
	if (threadsCount == 0) 
	{
		if(cancelInterval)
		{
			clearInterval(cancelInterval);
		}
		
		$("#buttonUpdateProducts").removeAttr("disabled").val("Update Products");
		$('.watchlist .colProgress').html("&nbsp;");
	}
	else
	{	
		$("#buttonUpdateProducts").attr("disabled", true).val("Cancelling " + threadsCount + " thread(s)");
	}
}

/**
 * Download watch list product, show it, and update
 * @param id
 * @param reloadProducts
 * @param showProducts
 * @param updateProducts
 * @return
 */
function getWatchlistProducts(id, reloadProducts, showProducts, page)
{
	if ($("#watchlist_" + id + " .colItemCount").html() == '0') return;
	
	var insertAfter = null;
	if($("#watchlist_" + id).hasClass("open") && !reloadProducts)
	{
		//if open and don't need to refresh, then just hide products
		if (showProducts)
		{
			$("#watchlist_" + id).removeClass("open")
			$("#watchlist_" + id + " .colShowProducts div").removeClass("hideProducts").addClass("showProducts");
			$(".parentWatchlist_" + id).hide();
			$("#watchlistPaginator_" + id).hide();
		}
	}
	else if($("#watchlist_" + id).hasClass("loaded") && !reloadProducts)
	{
		//if is not open and loaded and don't need to refreshm then show
		if (showProducts)
		{
			$("#watchlist_" + id).addClass("open");
			$("#watchlist_" + id + " .colShowProducts div").removeClass("showProducts").addClass("hideProducts");
			$(".parentWatchlist_" + id).show();
			$("#watchlistPaginator_" + id).show();
		}
	}
	else
	{
		if($("#watchlist_" + id).hasClass("loading")) return;
		
		$("#watchlist_" + id + ' .colProgress').html("Loading products list...");
		
		//remove loaded and open state
		$("#watchlist_" + id).removeClass("loaded");
		$("#watchlist_" + id).removeClass("open");
		$("#watchlist_" + id).addClass("loading");
		
		//remove current products
		$(".parentWatchlist_" + id).remove();
		
		//show minus button now
		$("#watchlist_" + id + " .colShowProducts div").removeClass("hideProducts").addClass("showProducts");
		
		//show loader
		var watchlistLoader = $("#dobaWatchlistsPrototype tbody .watchlistLoader").clone();
		$(watchlistLoader).attr("id", "watchlistLoader_" + id);
		$(watchlistLoader).insertAfter("#watchlist_" + id);
		
		insertAfter = "#watchlist_" + id;
		
		threadsCount++;
		//get products data
		$.getJSON('admin.php?p=doba_json&chart=true&action=getWatchlistProducts&id=' + id + '&page=' + page + '&limit=' + productsPerPage, function(data){
			threadsCount--;
			
			//hide loader
			$("#watchlistLoader_" + id).remove();
			$("#buttonSetPrices").removeAttr("disabled");
			
			if(data.status == 1)
			{
				/**
				 * Paginator
				 */
				$("#watchlistPaginator_" + id).remove();

				var pagesCount = Math.ceil(data.items_count / productsPerPage);

				var pagesHTML = '<ul><li>Pages (displaying ' + page + ' of ' + pagesCount + ') :</li>';

				if (page > pagesInList)
				{
					pagesHTML += '<li class="page page-1" value="1">First</li>><li>-</li>';
				}

				if (page > 1)
				{
					pagesHTML += '<li class="page page-' + (page-1) + '" value="' + (page-1) + '">Prev</li><li>-</li>';
				}

				var pageStart = Math.floor(page/pagesInList) * pagesInList + 1;
				var pageFinish = (Math.floor(page/pagesInList)+1) * pagesInList;

				pageStart = pageStart < 1 ? 1 : pageStart;
				pageFinish = pageFinish > pagesCount ? pagesCount : pageFinish;

				for (var i=pageStart; i <= pageFinish; i++)
				{
					pagesHTML += '<li class="page page-' + i + '" value="' + i + '">' + i + '</li>';
				}

				if (page < pagesCount)
				{
					pagesHTML += '<li>-</li><li class="page page-' + (page+1) + '" value="' + (page+1) + '">Next</li>';
					pagesHTML += '<li>-</li><li class="page page-' + pagesCount + '" value="' + pagesCount + '">Last</li>';
				}
				
				pagesHTML += '</ul>';

				var paginator = $("#dobaWatchlistsPrototype tbody .watchlistPaginator").clone();
				$(paginator).find('td.colPaginator').html(pagesHTML);
				$(paginator).attr("id", "watchlistPaginator_" + id);
				$("#watchlist_" + id).after(paginator);

				$("#watchlistPaginator_" + id + ' li.page-' + page).addClass('active');
				$("#watchlistPaginator_" + id + ' li.page').each(function(i, item){
					$(item)
						.data('watchlistId', id)
						.click(function(){
							if ($(this).hasClass('active')) return;
							getWatchlistProducts($(this).data('watchlistId'), true, true, $(this).attr('value'));
						});
				});

				//show product header
				var watchlistProductsHeader = $("#dobaWatchlistsPrototype tbody .watchlistProductsHeader").clone();
				$(watchlistProductsHeader).attr("id", "watchlistProductsHeader_" + id).addClass("parentWatchlist_" + id).insertAfter(insertAfter);
				
				//show when needed
				if(!showProducts) $("#watchlistProductsHeader_" + id).hide();
				
				insertAfter = "#watchlistProductsHeader_" + id;
				
				//add products
				$.each(data.items, function(i, item)
				{
					var item_id = item["item_id"];
					var watchlistProduct = $("#dobaWatchlistsPrototype tbody .watchlistProduct").clone();
					$(watchlistProduct).attr("id", "watchlistProduct_" + item_id).addClass("parentWatchlist_" + id);
					$(watchlistProduct).find("td.colProdCheckbox input").attr("value", item_id);
					$(watchlistProduct).find("td.colProdInfo img").click(function(){getItemDetailFromCache(item_id);});
					$(watchlistProduct).find("td.colProdName").html(item["name"]);
					$(watchlistProduct).find("td.colProdPrice div").html("$" + item["price"]);
					$(watchlistProduct).find("td.colProdMSRP div").html("$" + item["msrp"]);
					$(watchlistProduct).find("td.colProdMSRP input[type='hidden']").val(item["msrp"]);
					$(watchlistProduct).find("td.colProdShippingCost div").html("$" + item["ship_cost"]);
					$(watchlistProduct).find("td.colProdDropFee div").html("$" + item["drop_ship_fee"]);
					$(watchlistProduct).find("td.colProdSalePrice").html("<div>$" + getItemSalePrice(item["price"], item["msrp"])).attr("id", "input_price_" + item_id + '</div>');
					$(watchlistProduct).find("td.colProdStock").html(item["stock"] + " (" + item["qty_avail"] + ")");
					$(watchlistProduct).insertAfter(insertAfter);
					if (!showProducts) $(watchlistProduct).hide();
					insertAfter = "#watchlistProduct_" + item_id;
						
					//add popup preview
					$(insertAfter).find(".colProdInfo img").css("cursor", "pointer").qtip(
					{
						content: 
							'<b>' + item["name"] + '</b><br/>' +
							'<img src="' + item["thumb_url"] + '" vspace="5"/>',
						position:{
							my: 'bottom right',
							at: 'top left',
							target:'mouse'
						},
						show:{solo:true},
	         			style:{tip:true,name:'light'}
	      			});
				});
					
				
				$("#watchlist_" + id + ' .colProgress').html("&nbsp;");
				$("#watchlistPaginator_" + id).show();
				
				//set statuses to loaded, and if show products, to open
				$("#watchlist_" + id).addClass("loaded");
				if (showProducts)
				{
					$("#watchlist_" + id).addClass("open");
					$("#watchlist_" + id + " .colShowProducts div").removeClass("showProducts").addClass("hideProducts");
				}
			}
			else
			{
				alert(products.message);
				$("#watchlist_" + id + ' .colProgress').html("&nbsp;");
			}
			
			$("#watchlist_" + id).removeClass("loading");
			products = null;
		});
	}
}

/**
 * Pre-set item price
 * @param item_price
 * @param msrp
 * @return
 */
function getItemSalePrice(item_price, msrp)
{
	var priceOption = $("#dobaPriceOption").val();
	var priceModifier = parseFloat($("#dobaPriceModifier").val());
	var dobaPriceOption99 = $("#dobaPriceOption99").val();
	
	var result = 0;
	
	var i = parseFloat(item_price);
	var m = parseFloat(msrp)
	
	switch (priceOption)
	{
		case "item_price" :result = i;break; 
		case "item_price_inc" :result = i + (i / 100) * priceModifier;break;
		case "item_price_dec" :result = i - (i / 100) * priceModifier;break;;
		case "msrp_price" :result = m;break;;
		case "msrp_price_inc" :result = m + (m / 100) * priceModifier;break;
		case "msrp_price_dec" :result = m - (m / 100) * priceModifier;break;;
	}
	
	result = Math.round(result*100)/100;
	
	if (dobaPriceOption99 == "Yes")
	{
		result = Math.ceil(result) - 0.01;
	}
	
	return result;
}

/**
 * Get items details
 * @param item_id
 * @return
 */
function getItemDetailFromCache(item_id)
{
	
	$("#dobaProductDetail").addClass("load_spinner").html(pleaseWait);
	tb_show("Product details", "#TB_inline?height=700&width=900&inlineId=dobaProductDetailOuter", false, false);
	
	threadsCount++;
	$.getJSON('admin.php?p=doba_json&chart=true&action=getItemDetailFromCache&item_id=' + item_id, function(data){
		threadsCount--;
		if (data.status)
		{
			$("#dobaProductDetail").removeClass("load_spinner").html(
				'<div>' + 
					'<h1 style="font-weight:bold;font-size:18px;color:orange;padding:0px 10px 0px 10px;">' + data.item["name"] + '</h1>' +

					'<div class="clearfix">' +
						'<div style="float:left;padding:10px;width:45%;text-align:center;"><img style="' + (data.item["image_width"] > 400 ? "width:400px;" : "") + '" align="center" src="' + data.item["image_url"] + '"/></div>' +
						'<div style="float:left;padding:10px 10px 10px 0px;width:45%;">' +
							'Product ID: ' + data.item["product_id"] + '<br/>' +
							'Product SKU: ' + data.item["product_sku"] + '<br/>' +
							'Brand: ' + data.item["brand"] + '<br/><br/>' +
					
							'Weight: ' + data.item["ship_weight"] + '<br/>' +
							'Shipping cost: $' + data.item["ship_cost"] + '<br/><br/>' +
							'Supplier: ' + data.item["supplier_name"] + '<br/>' +
							'Supplier notes: ' + data.item["supplier_notes"] + '<br/><br/>' +
					
							'Item ID: ' + data.item["item_id"] + '<br/>' +
							'Item SKU: ' + data.item["item_sku"] + '<br/>' +
							'Item  UPC: ' + data.item["item_upc"] + '<br/>' +
							
							'Price: <span style="color:#AA0000">$' + data.item["price"] + '</span><br/>' +
							'MSRP: <span style="color:#AA0000">$' + data.item["msrp"] + '</span><br/>' +
							'Min. advertised price: <span style="color:#0000AA">' + (data.item["map"] ? (data.item["map"] > 0 ? "$" + data.item["map"] : "-" ) : '-') + '</span><br/>' +
							'Prepay price: <span style="color:#0000AA">' + (data.item["prepay_price"] ? (data.item["prepay_price"] > 0 ? "$" + data.item["prepay_price"] : "-" ) : '-') + '</span><br/><br/>' +
							'Stock: ' + data.item["stock"] + '</span><br/>' +
							'Quantity available: ' + data.item["qty_avail"] + '</span><br/><br/>' +
							'Category: ' + data.item["category"] + "<i>undefined</i>" +
							'<div style="clear:both;padding-top:20px;">' + data.item["description"] + '</div>' +
						'</div>' +
					'</div>' +
				'</div>'
			);
		}
	});
}

/**
 * Start updating watchlist product
 * @param watchlistId
 * @return
 */
function doUpdateProducts(watchlistId)
{
	if (updateInProgress)
	{
		updateQueue.push(watchlistId);
	
		var itemsCount = $('#watchlist_' + watchlistId).data('itemsCount');
		var pagesCount = Math.ceil(itemsCount / productsPerPage);
		
		watchlistsPages[watchlistId] = new Array();
		watchlistsPages[watchlistId]["pages"] = new Array(); // products ids 
		watchlistsPages[watchlistId]["count"] = pagesCount; // pages count
		watchlistsPages[watchlistId]["index"] = 1; // current index
		watchlistsPages[watchlistId]["running"] = true;
	
		for (var i = 1; i <= pagesCount; i++)
		{
			watchlistsPages[watchlistId]["pages"][i] = i;;
		}
	
		$("#watchlist_" + watchlistId + ' .colProgress').html("Please wait, queued...");
	
		watchlistsPages[watchlistId]["interval"] = setInterval('queueUpdateProducts("' + watchlistId + '");', 1000);
	}
	else
	{
		cancelUpdate();
	}
}

/**
 * Check queue
 * @param watchlistId
 * @return
 */
function queueUpdateProducts(watchlistId)
{
	//window.status = window.status + ' - Still waiting ' + watchlistId;
	if(updateQueue.length > 0 && updateQueue[0] == watchlistId && watchlistsPages.length > 0)
	{
		clearInterval(watchlistsPages[watchlistId]["interval"]);
		if (updateInProgress)
		{
			$("#watchlist_" + watchlistId + ' .colProgress').html('<div class="progress" style="width:120px;height:15px;"></div>');
			$("#watchlist_" + watchlistId + ' .colProgress .progress').progressbar({value:1});
			doUpdateProductSet(watchlistId);
		}
	}
}

/**
 * Update individual product
 * @param watchlistId
 * @return
 */
function doUpdateProductSet(watchlistId)
{
	if (updateInProgress)
	{
		var page = watchlistsPages[watchlistId]["index"];
		
		//("#watchlistProduct_" + item_id + " .colProdCheckbox").addClass("load_spinner");
		threadsCount++;
		$.post(
			'admin.php?p=doba_json&chart=true&action=updateProductsSet',
			{
				'id': watchlistId,
				'page': page,
				'limit': productsPerPage
			},
			function(data)
			{
				threadsCount--;
				//$("#watchlistProduct_" + item_id + " .colProdCheckbox").removeClass("load_spinner");
				if (updateInProgress)
				{
					//increase index
					var index = watchlistsPages[watchlistId]["index"] = watchlistsPages[watchlistId]["index"] + 1;
					var count = watchlistsPages[watchlistId]["count"];
				
					//$("#watchlist_" + watchlistId + ' .colProgress').html(index + " of " + count + " done");
					if (index < count)
					{
						var progress = Math.round(100 / count * index);
						$("#watchlist_" + watchlistId + ' .colProgress .progress').progressbar('option', 'value', progress);
						doUpdateProductSet(watchlistId);
					}
					else
					{
						//remove current queued watchlist
						updateQueue.shift();
						$("#watchlist_" + watchlistId + ' .colProgress .progress').progressbar('option', 'value', 100);
						setTimeout('$("#watchlist_' + watchlistId + ' .colProgress").html("Done");', 500);
						setTimeout('$("#watchlist_' + watchlistId + ' .colProgress").html("&nbsp;");', 5000);
					
						if(updateQueue.length == 0)
						{
							updateInProgress = false;
							$("#buttonUpdateProducts").removeAttr("disabled").val("Update Products");
						}
					}
				}
				else
				{
					cancelUpdate();
				}
			}
		);
	}
	else
	{
		cancelUpdate();
	}
}
