var lastProductItemId = false;
var pleaseWait = 'Please wait, loading data...';
var wishlistsProducts = new Array();
var updateQueue = new Array();

var updateInProgress = false;
var cancelInterval = false;
var threadsCount = 0;

var productsUpdated = 0;

$(document).ready(function(){
	$("#dobaWatchlists").addClass('load_spinner').html(pleaseWait);
	$("#dobaOrders").addClass('load_spinner').html(pleaseWait);
	
	/**
	 * Load watchlists
	 */
	$.getJSON('admin.php?p=doba_json&chart=true&action=getWatchlists', function(data){
		$("#dobaWatchlists").removeClass('load_spinner').html("");
		if(data.status == 1)
		{
			if(data.count > 0)
			{
				$("#dobaWatchlists").html('<table cellpadding="0" cellspacing="0" border="0"><thead>' + $("#dobaWatchlistsPrototype thead").html() + "</thead><tbody></tbody></table>");
				$.each(data.data, function(i, item){
					var id = item.watchlist_id.toString();
					var watchlist = $("#dobaWatchlistsPrototype tbody .watchlist").clone();
					$(watchlist).attr("id", "watchlist_" + id);
					$(watchlist).find("td.colCheckbox input").attr("value", id).attr("id", "cbwl_" + id).click(function(){
						if ($(this).is(':checked'))
						{
							getWishlistProducts($(this).val(), false, false, false);
						}
					});
					$(watchlist).find("td.colShowProducts div").click(function(){
						eval('getWishlistProducts(' + id + ', false, true, false);');
					});
					$(watchlist).find("td.colName label").attr('for', "cbwl_" + id).html(item.name.toString());
					$(watchlist).find("td.colItemCount").html(item.item_count.toString());
					$(watchlist).appendTo("#dobaWatchlists table tbody");
				});
				$("#buttonUpdateProducts").removeAttr("disabled");
			}
			else
			{
				$("#dobaWatchlists").html('<div class="message">You do not have watchlists yet. Please log in into your Doba account, create a watchlist and add there products.</div>');
			}
		}
		else
		{
			$("#dobaWatchlists").html('<div class="message">Server returned error: ' + data.message + '</div>');
		}
	});
	 
	/**
	 * Request Partner Permission Activation link
	 */
	$('#requestActivation').click(function(){
			$.getJSON('admin.php?p=doba_json&chart=true&action=requestPartnerPermission', function(data){
				if (data.status)
				{
					// show a notification the status was successfully sent
					alert('Activation request has been sent!\n\nPlease log into your Doba account to complete the activation process.');
				}
				else
				{
					alert('There was an error processing your request.\n\n'+data.message);
				}
			});
		return false;
	});
	
	/**
	 * Controls the Activation Status for the Retailer ID
	 */
	if ('tr.activation-link:visible')
	{
		$('span#doba-activation-status').show();
		
		$.getJSON('admin.php?p=doba_json&chart=true&action=hasPartnerPermission', function(data){
			var status = $('span#doba-activation-status');
			switch (data.message)
			{
				case 'accepted': status.css({
						'color': 'green'
					}).html('Activated'); break;
					
				case 'pending': status.css({
						'color': 'green'
					}).html('Pending Activation'); break;
					
					break;
				case 'declined': status.css({
						'color': 'red'
					}).html('Declined'); break;
					
					break;
				case 'missing request':
					// print nothing
					status.html('');
					break;
			}	
		});
	}
	 
	/**
	 * Load orders
	 */
	/**
	$.getJSON('admin.php?p=doba_json&chart=true&action=getOrders', function(data){
		$("#dobaOrders").removeClass('load_spinner').html("");
		if(data.status == 1)
		{
			if(data.count > 0)
			{
				$("#dobaOrders").html('<table cellpadding="0" cellspacing="0" border="0"><thead>' + $("#dobaOrdersPrototype thead").html() + "</thead><tbody></tbody></table>");
				$.each(data.data, function(i, item){
					var id = item.order_id.toString();
					var order = $("#dobaOrdersPrototype tbody .order").clone();
					$(order).attr("id", "order_" + id);
					$(order).find("td.colCheckbox input").attr("value", id).attr("id", "cborder_" + id);
					$(order).find("td.colShowItems div").click(function(){eval('getOrderItems(' + id + ');');});
					$(order).find("td.colOrderId label").attr('for', "cborder_" + id).html(item.order_id.toString());
					$(order).find("td.colShipTo").html(item.ship_name.toString());
					$(order).find("td.colOrderDate").html(item.date_placed.toString());
					$(order).find("td.colOrderStatus").html(item.status.toString());
					$(order).find("td.colOrderTotal").html(item.order_total.toString());
					$(order).appendTo("#dobaOrders table tbody");
				});
			}
			else
			{
				$("#dobaOrders").html('<div class="message">Can not find orders</div>');
			}
		}
		else
		{
			$("#dobaOrders").html('<div class="message">Server returned error: ' + data.message + '</div>');
		}
	});
	**/
	
	/**
	 * Handle set prices click action
	 */
	$("#buttonSetPrices").attr("disabled", true).click(function(){
		$(".watchlistProduct").each(function(){
			var item_price = parseFloat($(this).find(".colProdPrice input[type='hidden']").val());
			var msrp = parseFloat($(this).find(".colProdMSRP input[type='hidden']").val());
			$(this).find(".colProdSalePrice input[type='text']").val(getItemSalePrice(item_price, msrp));
		});
	});
	
	/**
	 * Handle update / cancel button
	 */
	$("#buttonUpdateProducts").attr("disabled", true).click(function()
	{
		//if already updating, cancel
		if (updateInProgress)
		{
			$(this).val("Cancelling, please wait...");
			$(this).attr("disabled", true); 
			updateInProgress = false;
			cancelInterval = setInterval('cancelCheckThreads();', 1000);
		}
		//or start a new update process
		else
		{
			$(this).attr("disabled", true); 
			setTimeout('$("#buttonUpdateProducts").removeAttr("disabled");', 1000);

			updateInProgress = true;
			$(this).val("Cancel Update");
			
			//save settings first
			var post_str = 
				'data[doba_price_option]=' + escape($("#dobaPriceOption").val()) + '&' +
				'data[doba_price_modifier]=' + escape($("#dobaPriceModifier").val()) + '&' +
				'data[doba_price_option99]=' + escape($("#dobaPriceOption99").val()) + '&' +
				'data[doba_min_stock]=' + escape($("#dobaMinStock").val());
			threadsCount++;
			$.post("admin.php?p=doba_json&chart=true&action=updateImportSettings", post_str, function(response){
				threadsCount--;
				//after settings saved, do update product
				var result = JSON.parse(response);
			
				if(result.status)
				{
					var watchlistsSelected = 0;
					$(".colCheckbox input").each(function(){
						if($(this).attr("checked"))
						{
							var watchlistId = $(this).val();
							getWishlistProducts(watchlistId, false, false, true);
							watchlistsSelected++;
						}
					});
					
					//check are there watclists selected
					if(watchlistsSelected == 0)
					{
						cancelUpdate();
						cancelCheckThreads();
						alert("Please select at least one watchlist to update!");
					}
				}
			});
		}
	});
});

/**
 * Cancels update process
 * @return
 */
function cancelUpdate()
{
	updateInProgress = false;
	
	//clear queue
	for(var i=0; i < updateQueue.length; i++)
	{
		wishlistId = updateQueue[i];
		if (wishlistsProducts[wishlistId]["interval"]) clearInterval(wishlistsProducts[wishlistId]["interval"]);
	}
	
	//reset arrays
	updateQueue = new Array();
	wishlistsProducts = new Array();
	
	//set messages
	$('.watchlist .colProgress').each(function(){
		if($(this).html() != "&nbsp;")
		{
			$(this).html("Cancelling...");
		}
	});
	
	//disable button
	$("#buttonUpdateProducts").attr("disabled", true).val("Cancelling " + threadsCount + " thread(s)");
}

/**
 * Check are all thread completed
 * @return
 */
function cancelCheckThreads()
{
	if (threadsCount == 0) 
	{
		if(cancelInterval)
		{
			clearInterval(cancelInterval);
		}
		
		$("#buttonUpdateProducts").removeAttr("disabled").val("Update Products");
		$('.watchlist .colProgress').html("&nbsp;");
	}
	else
	{
		
		$("#buttonUpdateProducts").attr("disabled", true).val("Cancelling " + threadsCount + " thread(s)");
	}
}

/**
 * Download watchlist product, show it, and update
 * @param id
 * @param reloadProducts
 * @param showProducts
 * @param updateProducts
 * @return
 */
function getWishlistProducts(id, reloadProducts, showProducts, updateProducts)
{
	
	var insertAfter = null;
	if($("#watchlist_" + id).hasClass("open") && !reloadProducts)
	{
		//if open and don't need to refresh, then just hide products
		if (showProducts)
		{
			$("#watchlist_" + id).removeClass("open")
			$("#watchlist_" + id + " .colShowProducts div").removeClass("hideProducts").addClass("showProducts");
			$(".parentWatchlist_" + id).hide();
		}
		
		if (updateProducts)
		{
			doUpdateProducts(id);
		}
	}
	else if($("#watchlist_" + id).hasClass("loaded") && !reloadProducts)
	{
		//if is not open and loaded and don't need to refreshm then show
		if (showProducts)
		{
			$("#watchlist_" + id).addClass("open");
			$("#watchlist_" + id + " .colShowProducts div").removeClass("showProducts").addClass("hideProducts");
			$(".parentWatchlist_" + id).show();
		}
		
		if (updateProducts)
		{
			doUpdateProducts(id);
		}
	}
	else
	{
		if($("#watchlist_" + id).hasClass("loading")) return;
		
		$("#watchlist_" + id + ' .colProgress').html("Loading products list...");
		
		//remove loaded and open state
		$("#watchlist_" + id).removeClass("loaded");
		$("#watchlist_" + id).removeClass("open");
		$("#watchlist_" + id).addClass("loading");
		
		
		//remove current products
		$(".parentWatchlist_" + id).remove();
		
		//show minus button now
		$("#watchlist_" + id + " .colShowProducts div").removeClass("hideProducts").addClass("showProducts");
		
		//show loader
		var watchlistLoader = $("#dobaWatchlistsPrototype tbody .watchlistLoader").clone();
		$(watchlistLoader).attr("id", "watchlistLoader_" + id)
		$(watchlistLoader).insertAfter("#watchlist_" + id);
		
		insertAfter = "#watchlist_" + id;
		
		threadsCount++;
		//get products data
		$.getJSON('admin.php?p=doba_json&chart=true&action=getWatchlistProductsExtended&id=' + id, function(products){
			threadsCount--;
		
			//hide loader
			$("#watchlistLoader_" + id).remove();
			$("#buttonSetPrices").removeAttr("disabled");
			
			if(products.status == 1)
			{
				//show product header
				var watchlistProductsHeader = $("#dobaWatchlistsPrototype tbody .watchlistProductsHeader").clone();
				$(watchlistProductsHeader).attr("id", "watchlistProductsHeader_" + id).addClass("parentWatchlist_" + id).insertAfter(insertAfter);
				
				//show when needed
				if(!showProducts) $("#watchlistProductsHeader_" + id).hide();
				
				insertAfter = "#watchlistProductsHeader_" + id;
				
				//add products
				$.each(products.data, function(i, item){
					
					var item_id = item.item_id.toString();
					var watchlistProduct = $("#dobaWatchlistsPrototype tbody .watchlistProduct").clone();

					$(watchlistProduct).attr("id", "watchlistProduct_" + item_id).addClass("parentWatchlist_" + id);
					$(watchlistProduct).find("td.colProdCheckbox input").attr("value", item_id);
					
					$(watchlistProduct).find("td.colProdInfo img").click(function(){
						getItemDetail(item_id);
					});
					
					$(watchlistProduct).find("td.colProdName").html(item.item_name.toString());
					$(watchlistProduct).find("td.colProdPrice div").html("$" + item.price.toString());
					//TODO: investigave why this code here
					//$(watchlistProduct).find("td.colProdPrice input[type='hidden']").val(item.price.toString()).attr("id", "input_price_" + item_id);
					
					$(watchlistProduct).find("td.colProdMSRP div").html("$" + item.msrp.toString());
					$(watchlistProduct).find("td.colProdMSRP input[type='hidden']").val(item.msrp.toString());
					$(watchlistProduct).find("td.colProdShippingCost div").html("$" + item.ship_cost.toString());
					$(watchlistProduct).find("td.colProdDropFee div").html("$" + item.supplier_drop_fee.toString());
					
					$(watchlistProduct).find("td.colProdSalePrice input[type='text']").val(getItemSalePrice(item.price.toString(), item.msrp.toString())).attr("id", "input_price_" + item_id);
					$(watchlistProduct).find("td.colProdStock").html(item.stock.toString() + " (" + item.qty_avail.toString() + ")");
					
					$(watchlistProduct).insertAfter(insertAfter);
					
					if (!showProducts) $(watchlistProduct).hide();
					
					insertAfter = "#watchlistProduct_" + item_id;
					
					//add popup preview
					$(insertAfter).find(".colProdInfo img").css("cursor", "pointer").qtip(
					{
						content: '<div class="load_spinner">' + pleaseWait + '</div>',
						position: {
							target : 'mouse',
							corner: { tooltip: 'bottomRight', target: 'topLeft' }
						},
						show: {	solo: true },
         				style: {
							tip: true, // Give it a speech bubble tip with automatic corner detection
							name: 'light'
						},
						api: {
							onRender: function()
							{
								var self = this;

								$.getJSON('admin.php?p=doba_json&chart=true&action=getItemDetail&id=' + item_id, function(item_data){
									if(item_data.status == 1)
									{
										var item = item_data.data;
										self.updateContent(
											'<div>' + 
												'<div style="font-weight:bold;">' + item.product_title[0] + '</div>' +
												'<img src="' + item.images[0].image[0].thumb_url[0] + '" vspace="5"/>' +
												'<div>' + 
													'Price: $' + item.price[0] + '<br/>' +
													'MSRP: $' + item.msrp[0] +
												'</div>' +
											'</div>'
										);
									
									}
									else
									{
										alert(item_data.message);
									}
								});
								
							}
						}
      				});
      			});
				
				$("#watchlist_" + id + ' .colProgress').html("&nbsp;");
				
				//set statuses to loaded, and if show products, to open
				$("#watchlist_" + id).addClass("loaded");
				if (showProducts)
				{
					$("#watchlist_" + id).addClass("open");
					$("#watchlist_" + id + " .colShowProducts div").removeClass("showProducts").addClass("hideProducts");
				}
				
				if (updateProducts)
				{
					doUpdateProducts(id);
				}
			}
			else
			{
				alert(products.message);
				$("#watchlist_" + id + ' .colProgress').html("&nbsp;");
			}
			
			$("#watchlist_" + id).removeClass("loading");
		});
	}
}

/**
 * Pre-set item price
 * @param item_price
 * @param msrp
 * @return
 */
function getItemSalePrice(item_price, msrp)
{
	var priceOption = $("#dobaPriceOption").val();
	var priceModifier = parseFloat($("#dobaPriceModifier").val());
	var dobaPriceOption99 = $("#dobaPriceOption99").val();
	
	var result = 0;
	
	var i = parseFloat(item_price);
	var m = parseFloat(msrp)
	
	switch (priceOption)
	{
		case "item_price" : result = i; break; 
		case "item_price_inc" : result = i + (i / 100) * priceModifier; break;
		case "item_price_dec" : result = i - (i / 100) * priceModifier; break;;
		case "msrp_price" : result = m; break; ;
		case "msrp_price_inc" : result = m + (m / 100) * priceModifier; break;
		case "msrp_price_dec" : result = m - (m / 100) * priceModifier; break;;
	}
	
	result = Math.round(result*100)/100;
	
	if (dobaPriceOption99 == "Yes")
	{
		result = Math.ceil(result) - 0.01;
	}
	
	return result;
}

/**
 * Get items details
 * @param item_id
 * @return
 */
function getItemDetail(item_id)
{
	if (lastProductItemId != item_id)
	{
		lastProductItemId = item_id;
		$("#dobaProductDetail").addClass("load_spinner").html(pleaseWait);
	
		tb_show("Product details", "#TB_inline?height=700&width=900&inlineId=dobaProductDetailOuter", false, false);
	
		threadsCount++;
		$.getJSON('admin.php?p=doba_json&chart=true&action=getItemDetail&id=' + item_id, function(item_data){
			threadsCount--;
			lastProductItemId = false;
			$("#dobaProductDetail").removeClass("load_spinner");
			if(item_data.status == 1)
			{
				var item = item_data.data;
				
				var category_name = "";
				
				if (item.categories && item.categories[0] && item.categories[0].category)
				{
					var categories = item.categories[0].category;
					$(categories).each(function(){
						category_name = category_name + (category_name == "" ? "" : " / ") + this.name[0]
					});
				}
				
				$("#dobaProductDetail").html(
					'<div>' + 
						'<h1 style="font-weight:bold;font-size:18px;color:orange;">' + item.product_title[0] + '</h1>' +
						'<div style="clear:both">' +
							'<div style="float:left;"><img src="' + item.images[0].image[0].url[0] + '" vspace="5"/></div>' +
							'<div style="float:left;margin-left:20px;">' + 
								'Item ID: ' + item.item_id[0] + '<br/>' +
								'Item SKU: ' + item.sku[0] + '<br/>' +
								'UPC: ' + item.upc[0] + '<br/>' +
								'Brand: ' + item.brand[0] + '<br/><br/>' +
								'Weight: ' + item.ship_weight[0] + '<br/>' +
								'Shipping cost: $' + item.ship_cost[0] + '<br/><br/>' +
								'Supplier: ' + item.supplier_name[0] + '<br/><br/>' +
								'Price: <span style="color:#AA0000">$' + item.price[0] + '</span><br/>' +
								'MSRP: <span style="color:#AA0000">$' + item.msrp[0] + '</span><br/>' +
								'Min. advertised price: <span style="color:#0000AA">' + (item.map ? (item.map[0] > 0 ? "$" + item.map[0] : "-" ) : '-') + '</span><br/>' +
								'Prepay price: <span style="color:#0000AA">' + (item.pre_pay_price ? (item.pre_pay_price[0] > 0 ? "$" + item.pre_pay_price[0] : "-" ) : '-') + '</span><br/><br/>' +
								'Stock: ' + item.stock [0] + '</span><br/>' +
								'Quantity available: ' + item.qty_avail[0] + '</span><br/><br/>' +
								'Category: ' + (category_name != "" ? category_name : "<i>undefined</i>") + 
							'</div>' +
						'</div>' +
						'<div style="clear:both;padding-top:20px;">' + item.description[0] + '</div>' +
					'</div>'
				);
			}
			else
			{
				alert(item_data.message);
			}	
		});
	}
}

/**
 * Start updating wishlist product
 * @param wishlistId
 * @return
 */
function doUpdateProducts(wishlistId)
{
	if (updateInProgress)
	{
		updateQueue.push(wishlistId);
	
		wishlistsProducts[wishlistId] = new Array();
		wishlistsProducts[wishlistId]["ids"] = new Array(); // products ids 
		wishlistsProducts[wishlistId]["count"] = 0; //current indes
		wishlistsProducts[wishlistId]["index"] = 0; //current indes
		wishlistsProducts[wishlistId]["running"] = true;
	
		var i = 0;
		$(".parentWatchlist_" + wishlistId + " td.colProdCheckbox input").each(function(){
			wishlistsProducts[wishlistId]["ids"][i] = $(this).val();
			i++;
		});
	
		$("#watchlist_" + wishlistId + ' .colProgress').html("Please wait, queued...");
	
		wishlistsProducts[wishlistId]["count"] = i;
		wishlistsProducts[wishlistId]["interval"] = setInterval('queueUpdateProducts("' + wishlistId + '");', 1000);
	}
	else
	{
		cancelUpdate();
	}
}

/**
 * Check queue
 * @param wishlistId
 * @return
 */
function queueUpdateProducts(wishlistId)
{
	//window.status = window.status + ' - Still waiting ' + wishlistId;
	if(updateQueue.length > 0 && updateQueue[0] == wishlistId && wishlistsProducts.length > 0)
	{
		clearInterval(wishlistsProducts[wishlistId]["interval"]);
		if (updateInProgress)
		{
			$("#watchlist_" + wishlistId + ' .colProgress').html('<div class="progress" style="width:120px;height:15px;"></div>');
			$("#watchlist_" + wishlistId + ' .colProgress .progress').progressbar({value:1});
			doUpdateProduct(wishlistId);
		}
	}
}

/**
 * Update individual product
 * @param wishlistId
 * @return
 */
function doUpdateProduct(wishlistId)
{
	if (updateInProgress)
	{
		var item_id = wishlistsProducts[wishlistId]["ids"][wishlistsProducts[wishlistId]["index"]];
		var item_price = $("#input_price_" + item_id).val();
		
		$("#watchlistProduct_" + item_id + " .colProdCheckbox").addClass("load_spinner");
		threadsCount++;
		$.getJSON('admin.php?p=doba_json&chart=true&action=updateProduct&id=' + item_id + '&price=' + item_price, function(data){
			threadsCount--;
			$("#watchlistProduct_" + item_id + " .colProdCheckbox").removeClass("load_spinner");
			if (updateInProgress)
			{
				//increase index
				var index = wishlistsProducts[wishlistId]["index"] = wishlistsProducts[wishlistId]["index"] + 1;
				var count = wishlistsProducts[wishlistId]["count"];
		
				//window.status = index + ' - ' + count;
				
				//$("#watchlist_" + wishlistId + ' .colProgress').html(index + " of " + count + " done");
				if(index < count)
				{
					var progress = Math.round(100 / count * index);
					$("#watchlist_" + wishlistId + ' .colProgress .progress').progressbar('option', 'value', progress);
					doUpdateProduct(wishlistId);
				}
				else
				{
					//remove current queued wishlist
					updateQueue.shift();
					$("#watchlist_" + wishlistId + ' .colProgress .progress').progressbar('option', 'value', 100);
					setTimeout('$("#watchlist_' + wishlistId + ' .colProgress").html("Done");', 500);
					setTimeout('$("#watchlist_' + wishlistId + ' .colProgress").html("&nbsp;");', 5000);
					
					if(updateQueue.length == 0)
					{
						updateInProgress = false;
						$("#buttonUpdateProducts").removeAttr("disabled").val("Update Products");
					}
				}
			}
			else
			{
				cancelUpdate();
			}
		});
	}
	else
	{
		cancelUpdate();
	}
}

/**
 * Load order items
 * @param order_id
 * @return
 */
function getOrderItems(order_id)
{
	//show loader
	var ordertLoader = $("#dobaOrdersPrototype tbody .orderLoader").clone();
	$(ordertLoader).attr("id", "orderLoader_" + order_id)
	$(ordertLoader).insertAfter("#order_" + order_id);
	var insertAfter = "#order_" + order_id;

	threadsCount++;
	$.getJSON('admin.php?p=doba_json&chart=true&action=getOrderItems&id=' + order_id, function(data){
		threadsCount--;
		
		//hide loader
		$("#orderLoader_" + order_id).remove();
			
		if(data.status)
		{
			var orderData = data.data;
			
			/**
			 * Show order details
			 */
			var orderDetails = $("#dobaOrdersPrototype tbody tr.orderDetails").clone();
			$(orderDetails).find("td.orderDetailsAddress").html(
				orderData.ship_street.toString() + '<br/>' +
				orderData.ship_city.toString() + ', ' +
				orderData.ship_state.toString() + ' ' +
				orderData.ship_postal.toString() + ', ' +
				orderData.ship_country.toString()
			);
			$(orderDetails).attr("id", "orderDetails_" + order_id).addClass("parentOrder_" + order_id).insertAfter(insertAfter);
			
			insertAfter = "#orderDetails_" + order_id;
			
			/**
			 * Show order items header
			 */
			var orderItemsHeader = $("#dobaOrdersPrototype tbody tr.orderItemsHeader").clone();
			$(orderItemsHeader).attr("id", "orderItemsHeader_" + order_id).addClass("parentOrder_" + order_id).insertAfter(insertAfter);
			insertAfter = "#orderItemsHeader_" + order_id;
		}
	});
}


