$(document).ready(function(){
	
	// make the middle container in preview pane sortable by x axis only
	$('#previewPane div.middleContainer ul').sortable({ opacity: 0.6, tolerance: 'pointer' });
	$('#previewPane div.middleContainer ul').disableSelection();
	
	$('#previewPane ul').sortable({ opacity: 0.6, tolerance: 'pointer', cancel: 'li.ui-state-disabled' });
	$('#previewPane ul').disableSelection();
	
	// make the widgets draggable
	$('#widgetPane ul > li.widget').draggable({
		revert: true
	}).bind('mousedown', function(){
		$(this).css('cursor','move');
	});
	$('#widgetPane ul').disableSelection();
	
	// make the layout zones droppable for widgets only
	$('div.zone').droppable({
		accept: 'li.widget',
		drop: function(event, ui){
			ui.draggable.fadeOut();
		}
	}).bind('mousedown', function(){
	
	});
	
	// set controls when changing/adding states
	$('#layoutState').change(function(){
		if ($(this).val() === '0')
		{
			
		}
	});
	
	// save the changes based on the tab that you're on
	$('#saveChanges').click(function(){
		
		
		// override default behavior
		return false;
	});
	
	$('div.zone').each(function(){
		$(this).qtip({
			style: { tip: 'bottomMiddle' },
			content: {
				prerender: true,
				text: $('#previewPaneControls').html()
			},
			position: {
				corner: {
					target: 'topLeft',
					tooltip: 'bottomLeft'
				}
			},
			hide: {
				when: {
					event: 'unfocus'
				},
				effect: { length: 0 }
			},
			show: {
				solo: true,
				effect: { length: 0 }
			}
		});
		
		var zone = $(this).attr('zone');
		
		var api = $(this).qtip('api');
		
		api.elements.content.children('a').each(function(){
			
			if ($(this).attr('control') == 'edit')
			{
				var href = GlobalHttpUrl + '/admin.php?p=layout_helper&printing=true&zone='+zone;
				$(this).attr('href', href);
				$(this).addClass('iframe');
				
				var width = 800;
				var height = 490;
				switch (zone)
				{
					case 'left':
					case 'right':
						height = 600;
						break;
				}
		
				$(this).fancybox({
					'hideOnContentClick': false,
					'frameWidth': width,
					'frameHeight': height
				});
				
				$(this).click(function(){
					api.hide();
				});
			}
		});
	})
});