var stampsTestMode = false;

function cancelStampsLabel(orderId, labelId)
{
	if (confirm('Are you sure you wish to cancel this label?'))
	{
		adminShowSpinner('Canceling shipping label', true);

		document.location =
			'admin.php?p=order&oid=' + orderId +
				'&last_active_tab=stamps-label-view' +
				'&action=stamps_label_cancel' +
				'&stamps_label_oid=' + orderId + '&stamps_label_olid=' + labelId;
	}

	return false;
}

function stampsCheckDependencies(addOnOptionCode, isChecked)
{
	var rateId = $('#stamps_rate_select').val();
	var stopped = false;
	if (addOnOptionCode != '_NONE' && stampsRates[rateId]['addons'] != undefined)
	{
		if (isChecked)
		{
			// check if there selected option for which one is prohibited
			$.each(stampsRates[rateId]['addons'], function(addOnCode, addOnData){
				if (stopped) return;
				if (addOnOptionCode != addOnCode && $('#stamps-option-' + addOnCode).prop('checked') && $.inArray(addOnOptionCode, addOnData['prohibited']) > -1)
				{
					alert('You cannot select this option as it may not be used\nin combination with ' + addOnData.name);
					$('#stamps-option-' + addOnOptionCode).prop('checked', false);

					if ((addOnOptionCode == 'US-A-DC') || (addOnOptionCode == 'US-A-SC'))
					{
						$('#stamps-option-confirmation-none').prop('checked', true);
					}

					if ((addOnOptionCode == 'US-A-INS') || (addOnOptionCode == 'SC-A-INS'))
					{
						$('#stamps-option-insurance-none').prop('checked', true);
					}

					stopped = true;
				}
			});
		}
//		else
//		{
//			// check if there selected option for which one is prohibited
//			$.each(stampsRates[rateId]['addons'], function(addOnCode, addOnData){
//				if (stopped) return;
//				if (addOnOptionCode != addOnCode && $('#stamps-option-' + addOnCode).prop('checked') && $.inArray(addOnOptionCode, addOnData['requires']) > -1)
//				{
//					alert('You cannot uncheck this option as it is required\nfor ' + addOnData.name);
//					$('#stamps-option-' + addOnOptionCode).prop('checked', true);
//					stopped = true;
//				}
//			});
//		}
	}
	return true;
}

function setStampsRateOptions(rateId)
{
	if (stampsRates == undefined) return;

	var insuranceHtml = '';
	var confirmationHtml = '';
	var addOnsHtml = '';

	if (stampsRates[rateId] != undefined)
	{
		var rateServiceType = stampsRates[rateId]['type'];

		if (stampsRates[rateId]['addons'] != undefined)
		{
			$.each(stampsRates[rateId]['addons'], function(addOnCode, addOnData){
				var addOnRate = parseFloat(addOnData.amount);

				if (addOnCode == 'US-A-INS' || addOnCode == 'SC-A-INS')
				{
					if (insuranceHtml == '')
					{
						insuranceHtml =
							'Insurance:<br/>' +
							'<input type="radio" class="stamps-add-on-option" id="stamps-option-insurance-none" name="stamps_rate_addons[insurance]" value="_NONE"> ' +
							'<label for="stamps-option-insurance-none">None</label><br/>';

					}
					insuranceHtml += '<input type="radio" class="stamps-add-on-option" id="stamps-option-' + addOnCode + '" name="stamps_rate_addons[insurance]" value="' + addOnCode + '"> ' +
						'<label for="stamps-option-' + addOnCode + '">' + addOnData.name + (addOnRate > 0 ? ' - $'  + addOnRate.toFixed(2) : '') + '</label><br/>';
				}
				else if (addOnCode == 'US-A-DC' || addOnCode == 'US-A-SC')
				{
					if (confirmationHtml == '')
					{
						confirmationHtml =
							'Confirmation:<br/>';

						if (rateServiceType != 'US-PM')
						{
							'<input type="radio" class="stamps-add-on-option" id="stamps-option-confirmation-none" name="stamps_rate_addons[confirmation]" value="_NONE"> ' +
							'<label for="stamps-option-confirmation-none">None</label><br/>';
						}
					}
					confirmationHtml += '<input type="radio" class="stamps-add-on-option" id="stamps-option-' + addOnCode + '" name="stamps_rate_addons[confirmation]" value="' + addOnCode + '"> ' +
						'<label for="stamps-option-' + addOnCode + '">' + addOnData.name + (addOnRate > 0 ? ' - $'  + addOnRate.toFixed(2) : '') + '</label><br/>';
				}
				else
				{
					if (addOnsHtml == '') addOnsHtml = 'Other Options:<br/>';
					addOnsHtml += '<input type="checkbox" class="stamps-add-on-option" id="stamps-option-' + addOnCode + '" name="stamps_rate_addons[]" value="' + addOnCode + '"> ' +
						'<label for="stamps-option-' + addOnCode + '">' + addOnData.name + (addOnRate > 0 ? ' - $'  + addOnRate.toFixed(2) : '') + '</label><br/>';
				}
			});
		}
	}

	$('#stamps-available-addons').html(confirmationHtml + (confirmationHtml != '' ? '<br/>' : '') + insuranceHtml + (confirmationHtml + insuranceHtml != '' ? '<br/>' : '') + addOnsHtml);

	$('#stamps-available-addons input[name="stamps_rate_addons[insurance]"]:first').attr('checked', 'checked').prop('checked', 1);

	$('#stamps-available-addons input[name="stamps_rate_addons[confirmation]"]:first').attr('checked', 'checked').prop('checked', 1);

	$('.stamps-add-on-option').each(function(index, addOnOption){
		$(addOnOption).click(function(){
			stampsCheckDependencies($(this).attr('value'), $(this).prop('checked'));
		});
	});
}

$(document).ready(function(){

	$("form#form_stamps_get_rates").submit(function(){
		adminShowSpinner('Getting rates from server', true);
	});

	stampsTestMode = $('input[name="stamps_test_mode"]').attr('value') == 'Yes';

	if ($('#stamps_rate_select').length)
	{
		$('#stamps_rate_select')
			.change(function(){
				setStampsRateOptions($(this).prop('value'));
			})
			.click(function(){
				setStampsRateOptions($(this).prop('value'));
			})
			.keyup(function(){
				setStampsRateOptions($(this).prop('value'));
			});

		setStampsRateOptions($('#stamps_rate_select').prop('value'));
	}

	if ($("#dialog_stamps_get_label").length > 0)
	{
		if ($('#stamps_rate_select option').length == 0)
		{
			alert('There are no shipping rates available for your request.\nPlease check shipping address, weight and insured value.');
		}
		else
		{
			var stampGetRatesSubmitButton = (stampsTestMode ? "Create Test Label for Rate" : "Purchase Label for Rate");

			$("#dialog_stamps_get_label").dialog({
				autoOpen: true,
				width: 700,
				height: 500,
				title: 'Rate Selection and Label ' + (stampsTestMode ? 'Generation' : 'Purchase'),
				modal: true,
				resizable: false,
				buttons: [
					{
						text: (stampsTestMode ? "Create Test Label for Rate" : "Purchase Label for Rate"),
						click: function(){
							if (stampsTestMode || confirm('Are you sure you wish to purchase this label?  Your account will be charged.'))
							{
								var allDependenciesSatisfied = true;
								var rateId = $('#stamps_rate_select').val();
								var requiredAddons = [];

								$('.stamps-add-on-option:checked').each(function(index, addOnOption){
									addOnId = $(this).val();
									if (addOnId != "_NONE")
									{
										if ($.inArray(addOnId, stampsRates[rateId]['addons']))
										{
											addOnOptions = stampsRates[rateId]['addons'][addOnId];

											if (addOnOptions['requires'].length > 0)
											{
												hasRequirement = false;
												$.each(addOnOptions['requires'], function(idx, requiredOption){
													isSelected = $('.stamps-add-on-option[value='+requiredOption+']:checked').size() > 0;
													if (isSelected)
													{
														hasRequirement = true;
													}
												});

												if (!hasRequirement)
												{
													allDependenciesSatisfied = false;
													requiredAddons = addOnOptions['requires'];
												}
											}
										}
									}
								});

								if (!allDependenciesSatisfied)
								{
									message = 'You must select one of the following:\n';
									$.each(requiredAddons, function(idx, requiredAddon){
										if ($('label[for=stamps-option-'+requiredAddon+']:visible').size() > 0)
										{
											message += '- '+$.trim($('label[for=stamps-option-'+requiredAddon+']').text())+'\n';
										}
									});
									alert($.trim(message));
								}
								else
								{
									adminShowSpinner('Generating shipping label', true);
									$("#form_stamps_get_label").submit();
								}
							}
						}
					},
					{
						text: "Cancel",
						click: function(){
							$("#dialog_stamps_get_label").dialog('close');
						}
					}
				]
			});
		}
	}

	if ($("#dialog_stamps_label_result").length  > 0)
	{
		$("#dialog_stamps_label_result").dialog({
			autoOpen: true,
			width: 400,
			height: 700,
			title: 'Label Generation Result',
			modal: true,
			resizable: false,
			buttons: [
				{
					text: "Print",
					click: function(){
						window.frames["dialog_stamps_label_result_preview_iframe"].focus();
						window.frames["dialog_stamps_label_result_preview_iframe"].print();
					}
				},
				{
					text: "Close",
					click: function(){
						$("#dialog_stamps_label_result").dialog('close');
					}
				}
			],
			open : function(){
				var labelImgSrc = $("#dialog_stamps_label_result_preview img").prop('src');
				$('<iframe id="dialog_stamps_label_result_preview_iframe" name="dialog_stamps_label_result_preview_iframe" scrolling="no" style="overflow:hidden;border:none;width:100%;height:580px;"></iframe>').appendTo('#dialog_stamps_label_result_preview');
				$('#dialog_stamps_label_result_preview_iframe').attr('src', 'about:blank');
				$('#dialog_stamps_label_result_preview_iframe').load(function(){

					adminHideSpinner();

					var iframeBody = $('#dialog_stamps_label_result_preview_iframe').contents().find('body');
					var iframeHead = $('#dialog_stamps_label_result_preview_iframe').contents().find('head');

					$(iframeHead).append('<link rel="stylesheet" type="text/css" href="content/admin/styles/print.css?3714r1">');

					if ($.browser.msie)
					{
						var doc = document.getElementById("dialog_stamps_label_result_preview_iframe").contentDocument;
						if (!doc || doc == null)
						{
							var doc = document.getElementById("frame").contentWindow.document;
						}
						doc.createStyleSheet('content/admin/styles/print.css?3714r1');
						var printCss = doc.createStyleSheet('content/admin/styles/print-ie.css?3714r1');
						printCss.media = "print";
					}
					else if(/chrom(e|ium)/.test(navigator.userAgent.toLowerCase()))
					{
						$(iframeHead).append('<link rel="stylesheet" type="text/css" href="content/admin/styles/print-chrome.css?3714r1" media="print">');
					}

					$(iframeBody).css({'padding':'0px','margin':'0px'});
					$(iframeBody).html('').append('<img class="print-label-image" src="' + labelImgSrc + '">');
				});
			}
		});
	}
});

$(document).ready(function(){
	/**
	 * Add click handler for the 'View' button
	 */
	$("a.stamps-label-view").click(function(e){
		e.stopPropagation();
		$('#iframe-stampscom-view-label').attr('src', $(this).attr('href'));
		$("#dialog-stampscom-view").dialog('open');
		return false;
	});

	/**
	 * Generated dialog for viewing labels
	 */
	$("#dialog-stampscom-view").dialog({
		autoOpen: false,
		modal: true,
		resizable: false,
		width: 400,
		height: 700,
		title: 'Stamps.com Label',
		buttons: {
			'Print': function(){
				window.frames["iframe-stampscom-view-label"].focus();
				window.frames["iframe-stampscom-view-label"].print();
				return;
			},
			'Close': function(){

				$("#dialog-stampscom-view").dialog('close');
			}
		}
	});

	$('#iframe-stampscom-view-label').load(function(){adminHideSpinner();});

	/**
	 * Add click handler for the 'Track' button
	 */
	$("a.stamps-label-track").click(function(){
		var $button = $(this);
		stampscom_dialog_oid = $button.attr('rel').replace(/^stampscom-label-(\d+)-\d+$/,'$1');
		stampscom_dialog_olid = $button.attr('rel').replace(/^stampscom-label-\d+-(\d+)$/,'$1');
		var iframe_url = 'admin.php?p=order_stampscom_ajax&printing&action=label_track_iframe&oid='+stampscom_dialog_oid+'&olid='+stampscom_dialog_olid;
		var iframe_height_px = $(window).height() / 2;
		$('#iframe-stampscom-track')
			.attr('width', 600)
			.attr('height', iframe_height_px)
			.attr('src', iframe_url);
		$("#dialog-stampscom-view").dialog('close');
		$("#dialog-stampscom-track")
			.dialog('option', 'minWidth', 350)
			.dialog('option', 'width', 650)
			.dialog('option', 'height', iframe_height_px+120)
			.dialog('open');
	});

	/**
	 * Generated dialog for viewing label tracking information
	 */
	$("#dialog-stampscom-track").dialog({
		autoOpen: false,
		resizable: false,
		title: 'Stamps.com Label Tracking',
		buttons: {
			'Close': function(){
				$('#iframe-stampscom-track').get(0).src = '';
				$("#dialog-stampscom-track").dialog('close');
			}
		}
	});
});
