$(document).ready(function(){
	// checkall checkboxes
	$('#check_all').click(function(){
		$('input.review').each(function(){
			this.checked = true;
		})
		return false;
	});
	
	// uncheck all checkboxes
	$('#uncheck_all').click(function(){
		$('input.review').each(function(){
			this.checked = false;
		})
		return false;
	});
	
	$('#apply_changes').click(function(){
		if (!$("input.review:checkbox:checked").length)
		{
			alert('Please select one or more reviews and try again.');
			return false;
		}
	});
	
	// deletes reviews
	$('#delete_reviews').click(function(){
		if (!$("input.review:checkbox:checked").length || !confirm('Are you sure you want to delete the selected reviews?'))
		{
			return false;
		}
	});
	
	// shows rating as stars
	$('div.rating').each(function(){
		$(this).rater({
			'curvalue': this.title,
			'style': 'small',
			'disable': true
		});
	});
	
	// read reviews
	$('a.read-review').click(function(){
		$.getJSON($(this).attr('href'), function(data){
			$('#dialog-read-review .reviewer_name').html(data.reviewer_fname + ' ' + data.reviewer_lname);
			$('#dialog-read-review .review_title strong').html(data.review_title);
			$('#dialog-read-review .review_text').html(data.review_text);
			// shows rating as stars
			$('#dialog-read-review .review-rating').remove();
			$('<blockquote class="review-rating"></blockquote>').insertAfter('#dialog-read-review .review_text').rater({
				'curvalue': data.review_rating,
				'disable': true
			});

			$('#dialog-read-review').dialog('open');
		});
		return false;
	});
	
	$("#dialog-read-review").dialog({
		'modal'			: true,
		'resizable'     : false,
		'autoOpen'      : false,
		'draggable'     : true,
		'width'         : 600,
		'height'        : 400,
		'stack'         : false,
		'overlay'       : 0.9,
		'title'			: 'Product Review',
		'buttons':
		{
			'Close': function()
			{
				$(this).dialog('close');
			}
		}
	});
});