$(document).ready(function() {
	$("#searchStr").autocomplete({
		source: function(request, response) {
			$.ajax({
				url: 'admin.php?p=auto_complete&chart=true&mode=products_family',
				dataType: 'json',
				data: {
					q: request.term,
					l: escape($("#searchLimit").val())
				},
				success: function(data) {
					response($.map(data, function(item) {
						return {
							label: item.product_id + ' - ' + item.title,
							value: item.pid
						}
					}));
				}
			});
		},
		select: function(event, ui) {
			if (ui.item) {
				addProduct(ui.item.value, ui.item.label);
			}
			event.preventDefault();
			event.stopPropagation();
		}
	});
});

function addProduct(pid, title){
	var s = document.getElementById('pr_family');
	if(s){
		code = pid;
		exists = false;
		for(i=0; i < s.options.length; i++){
			var _pid = s.options[i].value;
			if(_pid.substring(0, pid.length) == pid){
				exists = i+1;
				break;
			}
		}
		var nm = title;
		if(exists){
			alert("This product is already in family.");
			s.options[exists-1] = new Option(nm, code);
			return false;
		}
		else{
			var k = s.options.length;
			s.options[k] = new Option(nm, code);
		}
	}
}

function removeFromFamily(){
	var s = document.getElementById('pr_family');
	var a = Array();
	var isSelected = false;
	for(i = 0; i<s.options.length; i++){
		if(!s.options[i].selected){
			a[a.length] = s.options[i];
		}
		else{
			isSelected = true;
		}
	}
	if(isSelected && confirm("Do you really want to remove products")){
		s.options.length = 0;
		for(i=0; i<a.length; i++){
			s.options[s.length] = a[i];
		}
	}
}

function checkFamilyForm(frm){
	if(frm.elements["name"].value==""){
		alert("Please enter products family name!");
		frm.elements["name"].focus();
		return false;
	}
	var str = "";
	s = frm.elements["pr_family"];
	for(i = 0; i<s.options.length; i++){
		str = str + s.options[i].value + ',';
	}
	pif = frm.elements["products_in_family"];
	pif.value = str;
	//alert(frm.elements["products_in_family"].value);
	return true;
}