$(document).ready(function(){
	if (typeof(stateId) != "undefined" && stateId != null)
	{
		$("#locationCountry").change(function(){
			setLocationStateProvice($(this).val());
		});
		//remember current state and province
		$("#locationState").data("value", stateId);
		$("#locationProvince").data("value", $("#locationProvince").val());
	
		//set states / province
		setLocationStateProvice($("#locationCountry").val());
	}
});

/**
 * Delete product location 
 * @param id
 * @return
 */
function ConfirmDeleteProductsLocation(id)
{
	if (confirm("Do you really want to delete this location?"))
	{
		document.location = "admin.php?p=products_locations&action=delete&products_location_id=" + id;
	}
}

/**
 * Set states / provinces
 * @param countryId
 * @return
 */
function setLocationStateProvice(countryId)
{
	var countryData = countriesStates[countryId];
	
	if (countryData.states)
	{
		//get previous value of state and restore stae if applicable
		var stateId = $("#locationState").data("value");
		
		var options = "";
		for (var _stateId in countryData.states)
		{
			options += '<option value="' + _stateId + '" ' + (stateId == _stateId ? "selected" :"") + '>' + countryData.states[_stateId] + '</option>'; 
		}
		$("#locationState").html(options);
		
		//remember current province to resent it later
		$("#locationProvince").data("value", $("#locationProvince").val());
		$("#locationProvince").val("");
		
		//show-hide boxes
		$("#provinceRow").hide();
		$("#stateRow").show();
	}
	else
	{
		//remember old value of state and empty it
		$("#locationState").data("value", $("#locationState option:selected").val());
		$("#locationState").html("<option value=\"0\">None selected</option>");
		
		//restore old value of province		
		$("#locationProvince").val($("#locationProvince").data("value"));
		
		//show-hide boxes
		$("#stateRow").hide();
		$("#provinceRow").show();
	}
}