$(document).ready(function(){
	
	/**
	 * Generate custom
	 */
	$('#qr-generate-media').change(function(){
		$('#qr-generate-error-check').removeAttr("disabled");
		$('#qr-generate-default-size').removeAttr("disabled");
		
		var e = $('#qr-generate-error-check').val();
		var s = $('#qr-generate-default-size').val();
		switch ($(this).val())
		{
			case "1" :e = "L";s = "4";break;
			case "2" :e = "L";s = "8";break;
			case "3" :e = "M";s = "8";break;
			case "4" :e = "M";s = "12";break;
			case "5" :e = "Q";s = "4";break;
			case "6" :e = "H";s = "4";break;
		}
		$('#qr-generate-error-check').val(e);
		$('#qr-generate-default-size').val(s);
		if ($(this).val() != "0")
		{
			$('#qr-generate-error-check').attr("disabled", "disabled");
			$('#qr-generate-default-size').attr("disabled", "disabled");
		}
	});
	$('#qr-generate-media').change();
	
	$("#qr-generate-button").click(function(){
		adminShowSpinner('Generating QR Code');
		$("#qr-generate-button").val('Please wait...').attr('disabled', 'disabled');
		$.ajax({
			url: "admin.php?p=marketing_qr_ajax&chart=true",
			dataType: 'json',
			data: {
				action: 'generate_custom',
				image_type: $("#qr-generate-image-type").val(),
				text: $("#qr-generate-text").val(),
				media: $("#qr-generate-media").val(),
				error_check: $("#qr-generate-error-check").val(),
				default_size: $("#qr-generate-default-size").val()
			},
			success: function(data){
				adminHideSpinner();
				$("#qr-generate-button").val('Generate').removeAttr('disabled');		
				$("#dialog-qr-generated").data('path', data.path);
				$("#dialog-qr-generated").dialog('option', 'width', data.width + 100);
				$("#dialog-qr-generated").dialog('option', 'height', data.height + 120);
				$("#dialog-qr-generated-image").attr("src", data.url);
				$("#dialog-qr-generated-image").attr("src", data.url);				
				$("#dialog-qr-generated").dialog('open');
			}
		});
	});
	
	/**
	 * Generated dialog
	 */
	$("#dialog-qr-generated").dialog({
		autoOpen: false,
		resizable: false,
		modal: true,
		title: 'Generated QR Code',
		buttons: {
			'Download': function(){
				var src = 'admin.php?p=marketing_qr_ajax&chart=true&action=download_qr&path=' + $("#dialog-qr-generated").data('path');
				$('#iframe-qr-download').attr('src', src);
			},
			'Close': function(){
				$("#dialog-qr-generated").dialog('close');
			}
		}
	});
	
	$("#dialog-qr-generated-image").load(function(){
		if ($("#dialog-qr-generated-image").hasClass('show-dialog'))
		{
			//$("#dialog-qr-generated").dialog('open');
		}
		$("#dialog-qr-generated-image").addClass('show-dialog');
	});
	
	/**
	 * Show/hide new campaign
	 */
	$("#link-qr-campaign-add").click(function(){
		if ($("#form-qr-campaigns").length > 0)
		{
			$("#form-qr-campaign-new").toggle("fast");
		}
	});
	
	/**
	 * Validate new campaign form
	 */
	$("#form-qr-campaign-new").submit(function(){
		if ($(this).find('input[name="campaign[name]"]').val() == "")
		{
			alert('Please enter campaign name');
			$(this).find('input[name="campaign[name]"]').focus();
			return false;
		}
		
		if ($(this).find('input[name="campaign[description]"]').val() == "")
		{
			alert('Please enter campaign description');
			$(this).find('input[name="campaign[description]"]').focus();
			return false;
		}
		return true;
	});
	
	/**
	 * Validate campaigns form
	 */
	$("#form-qr-campaigns").submit(function(){
		var problem = false;
		$(this).find('.campaign-name').each(function(){
			if (!problem)
			{
				if ($(this).val() == '')
				{
					alert('Please enter campaign name');
					$(this).focus();
					problem = true;
				}
			}
		});
		$(this).find('.campaign-description').each(function(){
			if (!problem)
			{
				if ($(this).val() == '')
				{
					alert('Please enter campaign description');
					$(this).focus();
					problem = true;
				}
			}
		});
		return !problem;
	});
	
	/**
	 * Delete campaign
	 */
	$(".link-qr-campaign-delete").each(function(){
		$(this).click(function(){
			if (confirm('Do ypu really want to delete campaign?'))
			{
				var campaign_id = $(this).attr('id');
				campaign_id = campaign_id.replace(/[^0-9]/g, ''); 

				$.ajax({
					url: "admin.php?p=marketing_qr&chart=true",
					dataType: 'json',
					data: {
						action: 'delete_campaign',
						campaign_id: campaign_id
					},
					success: function() {
						$("#qr-campaign-"+campaign_id).hide('fast', function(){
							$(this).remove();
							if ($("#form-qr-campaigns table.admin-list-table td").length == 0)
							{
								$("#form-qr-campaigns").remove();
								$("#form-qr-campaign-new").show();
							}
						});
					}
				});
			}
			return false;
		});
	});
});