$(document).ready(function(){
	
	/**
	 * Enable/disable QR code
	 */
	$("#button-qr-activate").click(function(){
		var active = $("#button-qr-activate").hasClass('disable');

		adminShowSpinner((active ? 'Deactivating' : 'Activating') + ' QR codes');
		
		$("#button-qr-activate").attr('disabled', 'disabled').addClass('disabled');
		$.ajax({
			url: "admin.php?p=settings_qr&chart=true",
			dataType: 'json',
			data: {
				action: 'update_status',
				qr_active: active ? "No" : "Yes"
			},
			success: function() {

				$("#button-qr-activate").removeAttr('disabled').removeClass('disabled');
				if (active)
				{
					$("#button-qr-activate").removeClass('disable').attr('value', 'Activate');
					$("#menu_item_marketing_qr").hide();
				}
				else
				{
					$("#button-qr-activate").addClass('disable').attr('value', 'Disable');	
					$("#menu_item_marketing_qr").show();
				}
				adminHideSpinner();
			}
		});
	});
	
	/**
	 * Settings
	 */
	$('#qr-settings-media').change(function(){
		$('#qr-settings-error-check').removeAttr("disabled");
		$('#qr-settings-default-size').removeAttr("disabled");
		
		var e = $('#qr-settings-error-check').val();
		var s = $('#qr-settings-default-size').val();
		
		switch ($(this).val())
		{
			case "1" : e = "L"; s = "4"; break;
			case "2" : e = "L"; s = "8"; break;
			case "3" : e = "M"; s = "8"; break;
			case "4" : e = "M"; s = "12"; break;
			case "5" : e = "Q"; s = "4"; break;
			case "6" : e = "H"; s = "4"; break;
		}
		
		$('#qr-settings-error-check').val(e);
		$('#qr-settings-default-size').val(s);
		
		if ($(this).val() != "0")
		{
			$('#qr-settings-error-check').attr("disabled", "disabled");
			$('#qr-settings-default-size').attr("disabled", "disabled");
		}
	});
	
	$('#qr-settings-media').change();
});