$(document).ready(function(){

	$('#pickup_autofill_pieces').click(function(){
		document.location =
			'admin.php?p=settings_stampscom&last_active_tab=pickup&action=pickup_autofill_piecec' +
			'&pickup_date[month]' + $('#form_stampscom_scanform_generate input[name="pickup_date[month]"]').val() +
			'&pickup_date[day]' + $('#form_stampscom_scanform_generate input[name="pickup_date[day]"]').val() +
			'&pickup_date[year]' + $('#form_stampscom_scanform_generate input[name="pickup_date[year]"]').val();
		return false;
	});

	$('#field-pickup_location').change(function(){
		if ($(this).val() == 'Other')
		{
			$('#field-pickup_instructions').parent().parent().find('label').addClass('required');
			$('#field-pickup_instructions').prop('data-required', 1).attr('data-required', 1);
		}
		else
		{
			$('#field-pickup_instructions').parent().parent().find('label').removeClass('required');
			$('#field-pickup_instructions').prop('data-required', 0).attr('data-required', 0);
		}
	});

	$('#field-pickup_total_weight').change(function(){
		var n = Math.ceil($(this).val());
		$(this).val(isNaN(n) ? 0 : n);
	});

	$('#form_stampscom_carrier_pickup').submit(function(e){

		var expressPieces = $('#field-pickup_express_mail_pieces').val();
		var priorityPieces = $('#field-pickup_priority_mail_pieces').val();
		var internationalPieces = $('#field-pickup_international_mail_pieces').val();
		var otherPieces = $('#field-pickup_other_mail_pieces').val();
		var totalWeight = $('#field-pickup_total_weight').val();

		var numRegExp = /^\d*\.{0,1}\d+$/;

		var isError = false;
		var errorMsg = '';

		if (!numRegExp.test(expressPieces)) { $('#field-pickup_express_mail_pieces').addClass('error').focus(); isError = true; }
		if (!numRegExp.test(priorityPieces)) { $('#field-pickup_priority_mail_pieces').addClass('error').focus(); isError = true; }
		if (!numRegExp.test(internationalPieces)) { $('#field-pickup_international_mail_pieces').addClass('error').focus(); isError = true; }
		if (!numRegExp.test(otherPieces)) { $('#field-pickup_other_mail_pieces').addClass('error').focus(); isError = true; }

		if (isError)
		{
			errorMsg = 'Please enter valid numerical values';
		}
		else
		{
			if (expressPieces + priorityPieces + internationalPieces + otherPieces < 1)
			{
				isError = true;
				errorMsg = 'Please enter at least one number of mail pieces';
				$('.mail-piece').addClass('error');
			}
			else if (!numRegExp.test(totalWeight) || totalWeight <= 0)
			{
				isError = true;
				errorMsg = 'Please enter correct total weight';
				$('#field-pickup_total_weight').addClass('error').focus();
			}
		}

		if (isError)
		{
			$.jGrowl(
				errorMsg,
				{
					life:12000,
					speed: 'slow',
					sticky: true,
					theme: 'alert alert-error',
					position: 'center',
					width: '300px'
				}
			);
			return false;
		}

		return confirm('Please confirm that you want to request a carrier pickup');
	});
});