$(document).ready(function(){
	
	$('input[name="generateType"]').each(function(){
		$(this).click(function(e){
			if ($(this).attr('disabled') != 'disabled') $("#divOptions #buttonScan").removeAttr('disabled');
			e.stopPropagation();
		});
	});
	
	$('div.option.disabled input').each(function(){
		$(this).attr('disabled', 'disabled');
	});
	
	$("#divOptions #buttonScan").click(function(e){
		e.stopPropagation();
		if ($('input[name="generateType"]:checked').attr('disabled'))
		{
			alert('Please correct folder permissions and try again.');
			return false;
		}
		
		$(".divStep").hide();
		$("#divScanImages .divSpacer").html('<div class="load_spinner">Please wait, getting data...</div>');
		$("#divScanImages").show();
		var generateType = $("#divOptions input[name='generateType']:checked").val();
		var generateTarget = $("#divOptions input[name='generateTarget']:checked").val();

		$.ajax({
			'url': 'admin.php?p=thumbs_generator_json&chart=true&action=scanImages&generateType=' + generateType + '&generateTarget=' + generateTarget, 
			'dataType' : 'json',
			'success': function(data){
				var imagesFound = data.imagesFound;
				if (imagesFound > 0)
				{
					$("#divScanImages .divSpacer").html(
						'There are <u>' + imagesFound + '</u> images found. Please click button below to generate images.<br/><br/><br/>' +
						'<input type="button" value="Generate" id="buttonGenerate"/> &nbsp; ' + 
						'<input type="button" value="Back" id="buttonBack"/>'
					);
					$("#divScanImages #buttonGenerate").click(function(){
						$(".divStep").hide();
						$("#divProgress #divProgressBar").html('<div class="progress" style="width:500px;height:20px;"></div>');
						$("#divProgress #divProgressBar .progress").progressbar({value:1});
						$("#divProgress").show();
						timerLogoutActive = false;
						generateImages();
					});
					$("#divScanImages #buttonBack").click(function(){
						$(".divStep").hide();
						$("#divOptions").show();
					});
				}
				else
				{
					$("#divScanImages .divSpacer").html(
						'<b>There are no images found.</b><br/><br/><br/>' +
						'<input type="button" value="Back" id="buttonBack"/>'
					);
					$("#divScanImages #buttonBack").click(function(){
						$(".divStep").hide();
						$("#divOptions").show();
					});
				}
			}
		});
	});
	
	$("#sync-secondary-images").click(function(){
		$.ajax({
			'url': 'admin.php?p=thumbs_generator_json&chart=true&action=syncSecondaryImages',
			'dataType' : 'json',
			'success': function(data){
				alert(data.assignedCount + ' secondary images have been synchronized');
			}
		});
	});
	
});

function generateImages()
{
	$.ajax({
		'url': 'admin.php?p=thumbs_generator_json&chart=true&action=generateThumbs',
		'dataType' : 'json',
		'success': function(data){
			if (data.done)
			{
				$(".divStep").hide();
				$("#divDone").show();
			}
			else
			{
				$("#divProgress #divProgressBar .progress").progressbar('option', 'value', data.progress);
				$("#divProgress #divProgressText").html(data.progressCount + ' of ' + data.totalCount + ' images processed');
				setTimeout('generateImages()', 100);
			}
			genActive = false;
		}
	});
}