<?php

	function om_normalize($s){
		return htmlspecialchars(utf8_encode(($s)));
	}

	$include_path = "../../../";
	require($include_path."engine/engine_config.php");
	require($include_path."engine/engine_mysql.php");
	require($include_path."classes/class.openssl.php");
		
	require($include_path."engine/engine_localization.php");
	require($include_path."engine/engine_order.php");
	require($include_path."classes/class.plugins.php");
	$db = new DB;
	$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
		
	require($include_path."engine/engine_settings.php");
	require($include_path."engine/engine_url_".($settings["USE_MOD_REWRITE"] == "YES" ? "rewrite" : "default").".php");
	
	$function = isset($_REQUEST["action"])?trim($_REQUEST["action"]):"";
	$username = isset($_REQUEST["username"])?trim($_REQUEST["username"]):"";
	$password = isset($_REQUEST["password"])?trim($_REQUEST["password"]):"";
	$token = isset($_REQUEST["token"])?trim($_REQUEST["token"]):"";
		
	// check auth
	$plugin_auth = true;
		
	if ($function != "getVersion")
	{
		$plugin_active = $settings["plugin_api_active"];
		$plugin_username = $settings["plugin_api_username"];
		$plugin_password =$settings["plugin_api_password"];
		$plugin_token =$settings["plugin_api_token"];
		$global_http_url = $settings["GlobalHttpUrl"];
		
		if ($plugin_active == "NO" || $plugin_username != $username || $plugin_password != $password || $plugin_token != $token)
		{
			$plugin_auth = false;
		}
	}
		
	if ($plugin_auth)
	{
		if ($_SERVER["SERVER_PORT"] != 443 && !defined("DEVMODE"))
		{
			$plugin_auth = false;
		}
	}
	
	echo '<?xml version="1.0"?>'."\n";
	echo '<Response>'."\n";
	if ($plugin_auth)
	{
		switch ($function)
		{
			/**
			 * Requesting API Version
			 */
			case "getVersion" :
			{
				echo "<Status>OK</Status>";
				echo "<ResponseType>getVersion</ResponseType>";
				echo "<ResponseBody><Version>1.0</Version></ResponseBody>";
				break;
			}

			/**
			 * Determining the number of orders to download
			 */
			case "getOrdersCount" : 
			{
				$lastorder = isset($_REQUEST["lastOrder"]) ? trim($_REQUEST["lastOrder"]) : "";
				$lastdate = isset($_REQUEST["lastDate"]) ? trim($_REQUEST["lastDate"]) : "";
				$sql = "SELECT COUNT(*) AS ordercount FROM ".DB_PREFIX."orders WHERE status <> 'Abandon' AND status <>  'New'";
				if (is_numeric($lastorder)) $sql.=" AND order_num >= ".intval($lastorder);
				if ($lastdate != "all")
				{
					//transorm from mm/dd/yyyy to yyyy-mm-dd
					$_date = explode("/", $lastdate);
					if (count($_date) == 3 && is_numeric($_date[0]) && is_numeric($_date[1])&& is_numeric($_date[2]))
					{
						$sql.=" AND create_date>='".$_date[2]."-".$_date[0]."-".$_date[1]." 00:00:01'";
					}
				}
				$db->query($sql);
				$result = $db->moveNext();
				$ordercount = $result["ordercount"];
				echo "<Status>OK</Status>";
				echo "<ResponseType>getOrdersCount</ResponseType>";
				echo "<ResponseBody><OrdersCount>".$ordercount."</OrdersCount></ResponseBody>";
				break;
			}
				
			/**
			 * Downloading Orders
			 */
			case "getOrders" : 
			{
				$lastorder = isset($_REQUEST["lastOrder"]) ? trim($_REQUEST["lastOrder"]) : "";
				$lastdate = isset($_REQUEST["lastDate"]) ? trim($_REQUEST["lastDate"]) : "all";
				$startnum = isset($_REQUEST["startNumber"]) ? trim($_REQUEST["startNumber"]) : "";
				$batchsize = isset($_REQUEST["batchSize"]) ? trim($_REQUEST["batchSize"]) : "";

				//get orders SQL
				$sql = 
					"SELECT ".DB_PREFIX."orders.*, ".DB_PREFIX."users.*, ".
					"IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name, ".
					"IF(".DB_PREFIX."orders.shipping_country=1 OR ".DB_PREFIX."orders.shipping_country=2, sstate.short_name, ".DB_PREFIX."orders.shipping_province) AS shipping_state_name, scountry.iso_a2 AS shipping_country_name ".
					"FROM ".DB_PREFIX."orders ".
					"INNER JOIN ".DB_PREFIX."users ON ".DB_PREFIX."orders.uid=".DB_PREFIX."users.uid ".
					"LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
					"INNER JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
					"LEFT JOIN ".DB_PREFIX."states AS sstate ON sstate.stid=".DB_PREFIX."orders.shipping_state ".
					"INNER JOIN ".DB_PREFIX."countries AS scountry ON scountry.coid=".DB_PREFIX."orders.shipping_country ".
					"WHERE status <> 'Abandon' AND status <> 'New' ";
				if (is_numeric($lastorder)) $sql.=" AND order_num > ".intval($lastorder);
				if ($lastdate != "all")
				{
					$_date = explode("/", $lastdate);
					if (count($_date) == 3 && is_numeric($_date[0]) && is_numeric($_date[1])&& is_numeric($_date[2]))
					{
						$sql.=" AND create_date >='".$_date[2]."-".$_date[0]."-".$_date[1]." 00:00:01'";
					}
				}
				if (is_numeric($startnum)) $sql.=" AND order_num > ".$startnum;
				if (is_numeric($batchsize)) $sql.=" LIMIT ".$batchsize;
				
				echo '<Status>OK</Status>'."\n";
				echo '<ResponseType>getOrders</ResponseType>'."\n";
				echo '<ResponseBody>'."\n";
				
				$db->query($sql);
				$ordercount = $db->numRows();	
				echo '<OrdersCount>'.$ordercount.'</OrdersCount>'."\n";
				if ($ordercount > 0)
				{
					$orders = $db->getRecords();	
					echo "<Orders>";
					foreach ($orders as $order)
					{
						echo '<Order>';
						echo '<OID>'.$order["oid"].'</OID>'."\n";
						echo '<OrderNumber>'.om_normalize($order["order_num"]).'</OrderNumber>'."\n";
						echo '<OrderDate>'.om_normalize($order["create_date"]).'</OrderDate>'."\n";
						echo '<Status>'.om_normalize($order["status"]).'</Status>'."\n";
						echo '<StatusDate>'.om_normalize($order["create_date"]).'</StatusDate>'."\n";
						echo '<PaymentMethod>'.om_normalize($order["payment_method_name"]).'</PaymentMethod>'."\n";
						echo '<PaymentStatus>'.om_normalize($order["payment_status"]).'</PaymentStatus>'."\n";
						echo '<ShippingCarrierId>'.om_normalize($order["shipping_carrier_id"]).'</ShippingCarrierId>'."\n";
						echo '<ShippingMethodId>'.om_normalize($order["shipping_method_id"]).'</ShippingMethodId>'."\n";
						echo '<ShippingMethodName>'.om_normalize($order["shipping_cm_name"]).'</ShippingMethodName>'."\n";
						echo '<ShippingAmount>'.round($order["shipping_amount"], 2).'</ShippingAmount>'."\n";                
						echo '<ShippingTaxable>'.om_normalize($order["shipping_taxable"]).'</ShippingTaxable>'."\n";                
						echo '<ShippingTaxRate>'.round($order["shipping_tax_rate"], 2).'</ShippingTaxRate>'."\n";                
						echo '<ShippintTaxAmount>'.round($order["shipping_tax_amount"], 2).'</ShippintTaxAmount>'."\n";                
						echo '<ShippingTaxDescription>'.om_normalize($order["shipping_tax_description"]).'</ShippingTaxDescription>'."\n";
						echo '<HandlingSeparated>'.om_normalize($order["handling_separated"]).'</HandlingSeparated>'."\n";                
						echo '<HandlingFee>'.round($order["handling_fee"], 2).'</HandlingFee>'."\n";                
						echo '<HandlingFeeType>'.om_normalize($order["handling_fee_type"]).'</HandlingFeeType>'."\n";                
						echo '<HandlingAmount>'.round($order["handling_amount"], 2).'</HandlingAmount>'."\n";                
						echo '<HandlingTaxable>'.om_normalize($order["handling_taxable"]).'</HandlingTaxable>'."\n";                
						echo '<HandlingTaxRate>'.round($order["handling_tax_rate"], 2).'</HandlingTaxRate>'."\n";                
						echo '<HandlingTaxAmount>'.round($order["handling_tax_amount"], 2).'</HandlingTaxAmount>'."\n";                
						echo '<HandlingTaxDescription>'.om_normalize($order["handling_tax_description"]).'</HandlingTaxDescription>'."\n";                
						echo '<HandlingText>'.om_normalize($order["handling_text"]).'</HandlingText>'."\n";
						echo '<SubtotalAmount>'.round($order["subtotal_amount"], 2).'</SubtotalAmount>'."\n";                
						echo '<DiscountAmount>'.round($order["discount_amount"], 2).'</DiscountAmount>'."\n";                
						echo '<DiscountValue>'.round($order["discount_value"], 2).'</DiscountValue>'."\n";                
						echo '<DiscountType>'.om_normalize($order["discount_type"]).'</DiscountType>'."\n";
						echo '<PromoDiscountAmount>'.round($order["promo_discount_amount"], 2).'</PromoDiscountAmount>'."\n";                
						echo '<PromoDiscountValue>'.round($order["promo_discount_value"], 2).'</PromoDiscountValue>'."\n";                
						echo '<PromoDiscountType>'.om_normalize($order["promo_discount_type"]).'</PromoDiscountType>'."\n";
						echo '<TaxAmount>'.round($order["tax_amount"], 2).'</TaxAmount>'."\n";                
						echo '<TotalAmount>'.round($order["total_amount"], 2).'</TotalAmount>'."\n";
						echo '<GiftMessage>'.om_normalize($order["gift_message"]).'</GiftMessage>'."\n";
						echo '<Billing>'."\n";
						echo '<FullName>'.om_normalize($order["fname"].' '.$order["lname"]).'</FullName>'."\n";
						echo '<Email>'.om_normalize($order["email"]).'</Email>'."\n";
						echo '<Company>'.om_normalize($order["company"]).'</Company>'."\n";
						echo '<Phone>'.om_normalize($order["phone"]).'</Phone>'."\n";
						echo '<Address>'."\n";
						echo '<Street1>'.om_normalize($order["address1"]).'</Street1>'."\n";
						echo '<Street2>'.om_normalize($order["address2"]).'</Street2>'."\n";
						echo '<City>'.om_normalize($order["city"]).'</City>'."\n";
						echo '<State>'.om_normalize($order["billing_state_name"]).'</State>'."\n";
						echo '<Zip>'.om_normalize($order["zip"]).'</Zip>'."\n";
						echo '<Country>'.om_normalize($order["billing_country_name"]).'</Country>'."\n";
						echo '</Address>'."\n";
						echo '</Billing>'."\n";
						
						
						echo '<Shipping>'."\n";
						if ($order["shipping_digital"])
						{
							echo '<ShippingDigital>Yes</ShippingDigital>'."\n";
						}
						else
						{	
							echo '<ShippingDigital>No</ShippingDigital>'."\n";
							echo '<FullName>'.om_normalize($order["shipping_name"]).'</FullName>'."\n";
							echo '<Company>'.om_normalize($order["shipping_company"]).'</Company>'."\n";
							echo '<Address>'."\n";
							echo '<Street1>'.om_normalize($order["shipping_address1"]).'</Street1>'."\n";
							echo '<Street2>'.om_normalize($order["shipping_address2"]).'</Street2>'."\n";
							echo '<City>'.om_normalize($order["shipping_city"]).'</City>'."\n";
							echo '<State>'.om_normalize($order["shipping_state_name"]).'</State>'."\n";
							echo '<Zip>'.om_normalize($order["shipping_zip"]).'</Zip>'."\n";
							echo '<Country>'.om_normalize($order["shipping_country_name"]).'</Country>'."\n";
							echo '</Address>'."\n";
						}
						echo '</Shipping>'."\n";
						
						echo '<OrderItems>'."\n";
								
						$order_weight = 0;
						$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$order["oid"]."'");
						while (($product = $db->moveNext()) != 0)
						{
							$sku = $product["product_sub_id"]!=""?$product["product_sub_id"]:$product["product_id"];
							echo '<OrderItem>'."\n";
							echo '<PID>'.om_normalize($product["pid"]).'</PID>'."\n";
							echo '<Quantity>'.om_normalize($product["quantity"]).'</Quantity>'."\n";
							echo '<Price>'.round($product["price"], 2).'</Price>'."\n";
							echo '<Taxable>'.($product["is_taxable"]).'</Taxable>'."\n";
							echo '<Weight>'.round($product["weight"], 2).'</Weight>'."\n";
							echo '<FreeShipping>'.om_normalize($product["free_shipping"]).'</FreeShipping>'."\n";
							echo '<ShippingPrice>'.round($product["shipping_price"], 2).'</ShippingPrice>'."\n";
							echo '<TaxRate>'.round($product["tax_rate"], 2).'</TaxRate>'."\n";
							echo '<TaxDescription>'.om_normalize($product["tax_description"]).'</TaxDescription>'."\n";
							echo '<DigitalProduct>'.om_normalize($product["digital_product"]).'</DigitalProduct>'."\n";
							echo '<UpdatedQuantity>'.om_normalize($product["admin_quantity"]).'</UpdatedQuantity>'."\n";
							echo '<UpdatedPrice>'.round($product["admin_price"], 2).'</UpdatedPrice>'."\n";
							echo '<ProductId>'.om_normalize($product["product_id"]).'</ProductId>'."\n";
							echo '<ProductSubId>'.om_normalize($product["product_id"]).'</ProductSubId>'."\n";
							echo '<SKU>'.om_normalize($product["product_sku"]).'</SKU>'."\n";
							echo '<UPC>'.om_normalize($product["product_upc"]).'</UPC>'."\n";
							echo '<Name>'.om_normalize($product["title"]).'</Name>'."\n";
							
							$order_weight = $order_weight + $product["weight"] * $product["admin_quantity"];
							if (trim($product["options_clean"]) != "")
							{
								$options = explode("\n", $product["options_clean"]);
								echo '<Options>';
								for ($j=0; $j<count($options); $j++)
								{
									$option = explode(":", $options[$j]);
									$option_name = trim($option[0]);
									//check for modifiers
									$option_part2 = $option[1];
									if (strstr($option_part2, "(") && strstr($option_part2, ")"))
									{
										$option_part3 = explode("(", $option_part2);
										$option_value = trim($option_part3[0]);
										$option_modifier = str_replace(")", " ", $option_part3[1]);
										if (strstr($option_modifier, ","))
										{
											$option_modifier_parts = explode(",", $option_modifier);
											$option_modifier_price = $option_modifier_parts[0];
											$option_modifier_weight = $option_modifier_parts[1];
										}
										else
										{
											$option_modifier_price = $option_modifier;
											$option_modifier_weight = 0;
										}
									}
									else
									{
										$option_value = trim($option_part2);
										$option_modifier_price = 0;
										$option_modifier_weight = 0;
									}
											
									echo '<Option>'."\n";
										echo '<OptionName>'.om_normalize($option_name).'</OptionName>'."\n";
										echo '<SelectedOption>'.om_normalize($option_value).'</SelectedOption>'."\n";
										echo '<OptionPrice>'.om_normalize($option_modifier_price).'</OptionPrice>'."\n";
										echo '<OptionType>select</OptionType>'."\n";
										echo '<OptionWeight>'.om_normalize($option_modifier_weight).'</OptionWeight>'."\n";
										echo '<OptionCost>+0.00</OptionCost>'."\n";
									echo '</Option>'."\n";
								}
								echo '<Options>';
							}
							echo '</OrderItem>'."\n";
						}
						
						echo '</OrderItems>'."\n";
							
						$db->query("SELECT * FROM ".DB_PREFIX."payment_transactions WHERE oid='".$order["oid"]."'");
						if (!($transaction = $db->moveNext()))
						{
							$transaction["extra"] = "";
							$transaction["payment_gateway"] = "";
						}
							
						echo '</Order>';
					}
					echo '</Orders>'."\n";
				}
				echo '</ResponseBody>'."\n";
				break;
			}
				
			/**
			 * Determining the number of customers to download
			 */
			case "getCustomersCount" : 
			{
				$sql = "SELECT COUNT(*) AS usercount FROM ".DB_PREFIX."users";
				$db->query($sql);
				$result = $db->moveNext();
				$usercount = $result["usercount"];
				echo "<Status>OK</Status>";
				echo "<ResponseType>getCustomersCount</ResponseType>";
				echo "<ResponseBody><CustomersCount>".$usercount."</CustomersCount></ResponseBody>";
				break;
			}
				
			/**
			 * Downloading Customer Data
			 */
			case "getCustomers" :
			{
				echo "<Status>OK</Status>";
				echo "<ResponseType>getCustomers</ResponseType>";
				echo "<ResponseBody>";
				$startnum = isset($_REQUEST["startNumber"]) ? trim($_REQUEST["startNumber"]) : "";
				$batchsize = isset($_REQUEST["batchSize"]) ? trim($_REQUEST["batchSize"]) : "";
				
				$sql = 
					"SELECT ".DB_PREFIX."users.*, ".
					"IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name ".
					"FROM users ".
					"LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
					"LEFT JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
					"WHERE ".DB_PREFIX."users.uid>0 ";
					
				if (is_numeric($startnum)) $sql.=" AND ".DB_PREFIX."users.uid >= ".intval($startnum);
				$sql.=" GROUP BY ".DB_PREFIX."users.uid ORDER BY uid ";
					
				if (is_numeric($batchsize)) $sql.=" LIMIT ".intval($batchsize);
					
				$db->query($sql);
				$usercount = $db->numRows();	
				echo '<CustomersCount>'.$usercount.'</CustomersCount>'."\n";
				if ($db->numRows() > 0)
				{
				
					$customers = $db->getRecords();
					echo '<Customers>'."\n";
					foreach($customers as $customer)
					{
						echo '<Customer>'."\n";
						echo '<UID>'.$customer["uid"].'</UID>'."\n";
						echo '<UserName>'.om_normalize($customer["login"]).'</UserName>'."\n";
						echo '<BillingAddress>'."\n";
						echo '<FirstName>'.om_normalize($customer["fname"]).'</FirstName>'."\n";
						echo '<LastName>'.om_normalize($customer["lname"]).'</LastName>'."\n";
						echo '<Email>'.om_normalize($customer["email"]).'</Email>'."\n";
						echo '<Company>'.om_normalize($customer["company"]).'</Company>'."\n";
						echo '<Phone>'.om_normalize($customer["phone"]).'</Phone>'."\n";
						echo '<AddressLine1>'.om_normalize($customer["address1"]).'</AddressLine1>'."\n";
						echo '<AddressLine2>'.om_normalize($customer["address2"]).'</AddressLine2>'."\n";
						echo '<City>'.om_normalize($customer["city"]).'</City>'."\n";
						echo '<State>'.om_normalize($customer["billing_state_name"]).'</State>'."\n";
						echo '<Zip>'.om_normalize($customer["zip"]).'</Zip>'."\n";
						echo '<Country>'.om_normalize($customer["billing_country_name"]).'</Country>'."\n";
						echo '</BillingAddress>'."\n";
						
						$db->query(
							"SELECT ".
							"IF(".DB_PREFIX."users_shipping.country=1 OR ".DB_PREFIX."users_shipping.country=2, sstate.short_name, ".DB_PREFIX."users_shipping.province) AS shipping_state_name, ". 
							"scountry.iso_a2 AS shipping_country_name, ".
							DB_PREFIX."users_shipping.name AS shipping_name, ".
							DB_PREFIX."users_shipping.company AS shipping_company, ".
							DB_PREFIX."users_shipping.address1 AS shipping_address1, ".
							DB_PREFIX."users_shipping.address2 AS shipping_address2, ".
							DB_PREFIX."users_shipping.city AS shipping_city, ".
							DB_PREFIX."users_shipping.zip AS shipping_zip ". 
							"FROM ".DB_PREFIX."users_shipping ". 
							"LEFT JOIN ".DB_PREFIX."states AS sstate ON sstate.stid=".DB_PREFIX."users_shipping.state ".
							"LEFT JOIN ".DB_PREFIX."countries AS scountry ON scountry.coid=".DB_PREFIX."users_shipping.country ".
							"WHERE uid='".$customer["uid"]."'"
						);
						
						$addresses = $db->getRecords();
						echo '<AddressBook>'."\n";
						
						foreach ($addresses as $address)
						{
							echo '<ShippingAddress>'."\n";
							echo '<USID>'.om_normalize($address["usid"]).'</USID>'."\n";
							echo '<Name>'.om_normalize($address["shipping_name"]).'</Name>'."\n";
							echo '<AddressLine1>'.om_normalize($address["shipping_address1"]).'</AddressLine1>'."\n";
							echo '<AddressLine2>'.om_normalize($address["shipping_address2"]).'</AddressLine2>'."\n";
							echo '<City>'.om_normalize($address["shipping_city"]).'</City>'."\n";
							echo '<State>'.om_normalize($address["shipping_state_name"]).'</State>'."\n";
							echo '<Zip>'.om_normalize($address["shipping_zip"]).'</Zip>'."\n";
							echo '<Country>'.om_normalize($address["shipping_country_name"]).'</Country>'."\n";
							echo '</ShippingAddress>'."\n";
						}
						echo '</AddressBook>'."\n";
						
						echo '</Customer>'."\n";
					}

					echo '</Customers>'."\n";
				}
				echo "</ResponseBody>";
				break;
			}
			
			/**
			 * Determining the number of products to download
			 */
			case "getProductsCount" :
			{
				//$sql = "SELECT COUNT(*) AS productscount FROM ".DB_PREFIX."products";
				//To find max value of the table instead of count fix from ticket ticketid=8950
				$sql = "SELECT MAX(pid) AS productscount FROM ".DB_PREFIX."products"; 
				$db->query($sql);
				$result = $db->moveNext();
				$productscount = $result["productscount"];
				echo "<Status>OK</Status>";
				echo "<ResponseType>getProductsCount</ResponseType>";
				echo "<ResponseBody><ProductsCount>".$productscount."</ProductsCount></ResponseBody>";
				break;
			}
			/**
			 * Downloading Product Data
			 */
			case "getProducts" :
			{
				$startnum = isset($_REQUEST["startNumber"])?($_REQUEST["startNumber"]):"";
				$batchsize = isset($_REQUEST["batchSize"])?trim($_REQUEST["batchSize"]):"";
				$sql = 
					"SELECT ".DB_PREFIX."products.*, ".
					" IF(url_custom='',url_default,url_custom) AS url ".
					"FROM ".DB_PREFIX."products ".
					"WHERE ".DB_PREFIX."products.pid > 0 ";
				if (is_numeric($startnum))
				{
					$sql.=" AND ".DB_PREFIX."products.pid >= ".$startnum;
				}
				$sql.=" ORDER BY pid";
					
				if (is_numeric($batchsize))
				{
					$sql.=" LIMIT ".$batchsize;
				}
				
				$db->query($sql);
				
				echo "<Status>OK</Status>";
				echo "<ResponseType>getProducts</ResponseType>";
				echo '<ResponseBody><Products>'."\n";
				$products = $db->getRecords();
				foreach ($products as $product)
				{
					echo '<Product>'."\n";
					echo '<PID>'.$product["pid"].'</PID>'."\n";
				 	echo '<ProductId>'.$product["product_id"].'</ProductId>'."\n";
					echo '<UPC>'.$product["product_id"].'</UPC>'."\n";
					echo '<ProductId>'.$product["product_id"].'</ProductId>'."\n";
					echo '<Name>'.om_normalize($product["title"]).'</Name>'."\n";
					echo '<Price>'.number_format($product["price"], 2, ".", "").'</Price>'."\n";
					echo '<Cost>'.number_format($product["price"], 2, ".", "").'</Cost>'."\n";
					echo '<Description>'.om_normalize($product["description"]).'</Description>'."\n";
					echo '<Weight>'.number_format($product["weight"], 2, ".", "").'</Weight>'."\n";
					
					echo '<URL>'.om_normalize(getProductUrl($product["url"], $product["pid"], $product["cid"]))."</URL>";
						
					//thumb & image
					$thumb = "";
					$image = "";
					if ($product["image_location"] == "Web" && $product["image_url"] != "")
					{
						$thumb = $product["image_url"];
						$image = $product["image_url"];
					}
					else
					{
						$product_id = strtolower(trim($product["product_id"]));
						for ($k=0; $k<strlen($product_id); $k++)
						{
							if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "_";
						}
						//thumb
						$tf = "../../../images/products/thumbs/".$product_id.".jpg";
						if (file_exists($tf))
						{
							$thumb = $global_http_url."/images/products/thumbs/".$product_id.".jpg";
						}
						//image(s)
						if (file_exists("../../../images/products/".$product_id.".png"))
						{
							$image = $global_http_url."/images/products/".$product_id.".png";
						}
						if (file_exists("../../../images/products/".$product_id.".gif"))
						{
							$image = $global_http_url."/images/products/".$product_id.".gif";
						}
						if (file_exists("../../../images/products/".$product_id.".jpg"))
						{
							$image = $global_http_url."/images/products/".$product_id.".jpg";
						}
					}
						
					echo '<Thumb>'.$thumb.'</Thumb>'."\n";
					echo '<Image>'.$image.'</Image>'."\n";
					echo '<Taxable>'.$product["is_taxable"].'</Taxable>'."\n";
					echo '<Discontinued>No</Discontinued>'."\n";
							
					if ($product["inventory_control"] == "Yes")
					{
						$qoh = $product["stock"] > 0 ? $product["stock"] : 0;
					}
					else
					{
						$qoh = "0";
					}
					
					echo '<Stock>'.$qoh.'</Stock>'."\n";
							
					//options
					$db->query("SELECT * FROM ".DB_PREFIX."products_attributes WHERE pid='".$product["pid"]."' ORDER BY priority");
					if ($db->numRows() > 0)
					{
						echo '<OptionLists>'."\n";
						while (($option = $db->moveNext()) != false)
						{
							echo '<ProductOption>'."\n";
							echo '<PAID>'.$option["paid"].'</PAID>'."\n";
							echo '<Name>'.om_normalize($option["name"]).'</Name>'."\n";
							echo '<Title>'.om_normalize($option["caption"]).'</Title>'."\n";
							echo '<Type>'.$option["attribute_type"].'</Type>'."\n";
							echo '<Price>0.00</Price>'."\n";
							echo '<Cost>0.00</Cost>'."\n";
							echo '<Image></Image>'."\n";
							echo '<Priority>'.$option["priority"].'</Priority>'."\n";
							if (in_array($option['attribute_type'], array('select','radio')))
							{
								$optionValues = array();
								if(parseOptions($option["options"], $product["price"], $product["weight"], $optionValues)){
									$sort_order = 1;
									foreach($optionValues as $opt_name=>$opt_value){
										echo '<OptionValue>'."\n";
										echo '<ID>'.$option["paid"]."-".om_normalize($opt_value["name"]).'</ID>'."\n";
										echo '<Name>'.om_normalize($opt_value["name"]).'</Name>'."\n";
										echo '<Price>'.number_format($opt_value["price_difference"], 2, ".", "").'</Price>'."\n";
										echo '<Cost>'.number_format($opt_value["price_difference"], 2, ".", "").'</Cost>'."\n";
										echo '<Weight>'.number_format($opt_value["weight_difference"], 2, ".", "").'</Weight>'."\n";
										echo '<Priority>'.$sort_order.'</Priority>'."\n"; $sort_order++;
										echo '</OptionValue>'."\n";
									}
								}
							}
							
							echo '</ProductOption>'."\n";
						}
						echo '</OptionLists>'."\n";
					}
					echo '</Product>'."\n";
				}
				echo '</Products></ResponseBody>';
				
				break;
			}

			//Downloading Quantity on Hand (Inventory) Data
			case "getInventory" :
			{
				$startnum = isset($_REQUEST["startNumber"])?trim($_REQUEST["startNumber"]):"";
				$batchsize = isset($_REQUEST["batchSize"])?trim($_REQUEST["batchSize"]):"";
				$sql = 
					"SELECT ".DB_PREFIX."products.* ".
					"FROM ".DB_PREFIX."products ".
					"WHERE ".DB_PREFIX."products.pid>0 ";
				if (is_numeric($startnum))
				{
					$sql.=" AND ".DB_PREFIX."products.pid >= ".$startnum;
				}
					
				$sql.=" ORDER BY pid";
					
				if (is_numeric($batchsize))
				{
					$sql.=" LIMIT ".$batchsize;
				}
					
				$db->query($sql);
				
				echo "<Status>OK</Status>";
				echo "<ResponseType>getInventory</ResponseType>";
				echo "<ResponseBody>";
				while (($product = $db->moveNext()) != false)
				{
					echo '<Product>'."\n";
					echo '<PID>'.om_normalize($product["pid"]).'</PID>'."\n";
					echo '<ProductId>'.om_normalize($product["product_id"]).'</ProductId>'."\n";
					if ($product["inventory_control"] == "Yes")
					{
						$qoh = $product["stock"] > 0 ? $product["stock"] : 0;
					}
					else
					{
						$qoh = "";
					}
					echo '<Stock>'.$qoh.'</Stock>'."\n";
					echo '</Product>'."\n";
				}
				echo '</ResponseBody>'."\n";
				break;
			}
			/**
			 * Uploading Bulk Inventory Data
			 */
			case "updateInventoryBulk" :
			{
				//echo urlencode("4722~10|4880~20");
				$update = isset($_REQUEST["update"])?$_REQUEST["update"]:"";
				$products = explode("|", $update);
				echo 'Response'."\n";
				for ($i=0; $i<count($products); $i++)
				{
					$p = explode("~", $products[$i]);
					$product_id = trim($p[0]);
					$product_stock = intval($p[1]);
					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($product_id)."'");
						
					if (($product = $db->moveNext()) != false)
					{
						if ($product["inventory_control"] == "Yes")
						{
							$db->query("UPDATE ".DB_PREFIX."products SET stock='".$product_stock."' WHERE pid='".$product["pid"]."'");
							echo $product_id."=OK\n";
						}
						else
						{
							echo $product_id."=NA\n";
						}
					}
					else
					{
						echo $product_id."=NF\n";
					}
				}
				echo 'Response'."\n";
				break;
			}

			/**
			 * Uploading Individual Inventory Data
			 */
			case "updateInventory" :
			{
				$update = isset($_REQUEST["update"])?$_REQUEST["update"]:"";
				$p = explode("~", $update);
				$product_id = trim($p[0]);
				$product_stock = intval($p[1]);
				$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($product_id)."'");
				if (($product = $db->moveNext()) != false)
				{
					if ($product["inventory_control"] == "Yes")
					{
						$stock = $product["stock"] + $product_stock;
						$db->query("UPDATE ".DB_PREFIX."products SET stock=".$stock." WHERE pid='".$product["pid"]."'");
						echo "Response=OK;SKU=".$product_id.";QOH=".$stock.";NOTE=";
					}
					else
					{
						echo "Response=False;ProductId=".$product_id.";Stock=NA;NOTE=NotTracking";
					}
				}
				else
				{
					echo "Response=False;ProductId=".$product_id.";Stock=NF;NOTE=NotFound";
				}
				break;
			}
			default :
			{
				echo '<Status>Error</Status>'."\n";
				echo '<Error><Code>2</Code><Message>Unknown action.</Message></Error>'."\n";
			}
		}
	}
	else
	{
		echo '<Status>Error</Status>'."\n";
		echo '<Error><Code>1</Code><Message>Auth failed.</Message></Error>'."\n";
	}
	echo '</Response>'."\n";
	die();