<?php 

//plugin class
class plugin_api extends cartPlugin {
	//protected
	var $plugin_id = "api";
	var $plugin_group = "export";
	var $plugin_caption = "Cart API";
	var $plugin_description = "Allows to export product, user &amp; order data from a cart, update inventory";
	
	//constructor
	function plugin_api(){
		return $this;
	}
	
	//run API plugin
	function runPlugin(&$db, &$settings, &$request){
		parent::runPlugin($db, $settings, $request);
		
		//check settings
		if(!array_key_exists("plugin_api_active", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_api");
			$db->assignStr("name", "plugin_api_active");
			$db->assignStr("value", "NO");
			$db->assignStr("options", "YES,NO");
			$db->insert(DB_PREFIX."settings");
			$settings["plugin_api_active"] = "NO";
		}
		
		if(!array_key_exists("plugin_api_username", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_api");
			$db->assignStr("name", "plugin_api_username");
			$db->assignStr("value", "");
			$db->insert(DB_PREFIX."settings");
			$settings["plugin_api_username"] = "";
		}
		
		if(!array_key_exists("plugin_api_password", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_api");
			$db->assignStr("name", "plugin_api_password");
			$db->insert(DB_PREFIX."settings");
			$db->assignStr("value", "");
			$settings["plugin_api_password"] = "";
		}
		
		if(!array_key_exists("plugin_api_token", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_api");
			$db->assignStr("name", "plugin_api_token");
			$db->assignStr("value", "");
			$db->insert(DB_PREFIX."settings");
			$settings["plugin_api_token"] = "";
		}
		
		//save settings
		if(isset($_REQUEST["action"]) && $_REQUEST["action"] == "update_settings" && !DEMO_LOCK){
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_api_active"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_api_active'");
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_api_username"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_api_username'");
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_api_password"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_api_password'");
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_api_token"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_api_token'");
			$settings["plugin_api_active"] = $_REQUEST["plugin_api_active"];
			$settings["plugin_api_username"] = $_REQUEST["plugin_api_username"];
			$settings["plugin_api_password"] = $_REQUEST["plugin_api_password"];
			$settings["plugin_api_token"] = $_REQUEST["plugin_api_token"];

		}
		
		//form header
		echo '<script type="text/javascript" src="content/admin/plugins/api/api.js"></script>';
		pageHeader("Shopping Cart API");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"API allows to export cart data into external applications.<br/>Please enter access informaiton below.", "visible"=>true),
			array("icon"=>"ic_hint.gif", "text"=>"Connection URL is ".$settings["GlobalHttpsUrl"]."/content/admin/plugins/api/index.php", "url"=>"", "visible"=>true),
			array("icon"=>"ic_hint.gif", "text"=>"<b>Your information has been updated</b>", "url"=>"", "visible"=>isset($_REQUEST["action"]) && $_REQUEST["action"] == "update_settings")
			
		));
		
		//form table
		echo '<form name="frmPlugin" action="admin.php?p=plugin&plugin_id='.$this->plugin_id.'" method="POST" style="padding:0px;spacing:0px;margin:0px;">';
		echo '<input type="hidden" name="action" value="update_settings">';
		
		echo '<div class="admin-tabs admin-tabs-framed" id="tabs-api">';
		
		pageTabs(array(array("title"=>"Plugin Settings", "id"=>"main")), "tabs-api", false);
		
		echo '<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden"><div class="admin-tab-sheet-wrap">';
		echo '<div class="admin-form-header">Cart API Settings</div>';
		
		echo '<table width="100%" cellpadding="0" cellspacing="5" border="0">';
		echo '<tr valign="top"><td class="formItemCaption">Enable Cart API?</td>';
		echo '<td class="formItemControl">';
		echo '<select name="plugin_api_active" style="width:123px;">';
		echo '<option value="YES">Yes</option>';
		echo '<option value="NO" '.($settings["plugin_api_active"]=="NO"?"selected":"").'>No</option>';
		echo '</select><div class="formItemComment">Selecting NO will disable export. Authentification failed message will be returned.</div>';
		echo '</td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Username</td>';
		echo '<td class="formItemControl">';
		echo '<input type="text" style="width:250px;" name="plugin_api_username" value="'.htmlspecialchars($settings["plugin_api_username"]).'">';
		echo '</td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Password</td>';
		echo '<td class="formItemControl">';
		echo '<input type="password" style="width:250px;" name="plugin_api_password" value="'.htmlspecialchars($settings["plugin_api_password"]).'">';
		echo '</td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Security Token</td>';
		echo '<td class="formItemControl">';
		echo '<input type="text" style="width:250px;" id="plugin_api_token" name="plugin_api_token" value="'.htmlspecialchars($settings["plugin_api_token"]).'">';
		echo '&nbsp;<input type="button" id="button-token" value="Generate"/>';
		echo '</td></tr>';
		
		echo '</table></div></div></div>';
		
		echo '<div class="admin-form-buttons">';
		echo '<input type="submit" value="Save changes"> &nbsp;';
		echo '<input type="reset" value="Reset value">';
		echo '</div>';
		
		echo '</form>';
			
	}//end of runPlugin procedure
}//end of class
