<?php

class plugin_bulk_image extends cartPlugin
{
	//protected
	var $plugin_id = "bulk_image";
	var $plugin_group = "export"; /* Group Name */
	var $plugin_caption = "Bulk Image Upload";
	var $plugin_description = "This plugin is used for uploading bulk products images .";

	//constructor
	function plugin_bulk_image()
	{
		$this->interface = array();
		$this->interface["title"] = $this->plugin_caption;
		$this->interface["url"] = 'admin.php?p=plugin&plugin_id='.$this->plugin_id;
		$this->interface["icon"] = "ic_plugin";
		$this->interface["group"] = "products";

		return $this;
	}
	function setupPlugin(&$db)
	{	 
		// used so frontend can pass db and settings
		$this->db = $db;	
	}
	function runPlugin(&$db, &$settings, &$request)
	{
		parent::runPlugin($db, $settings, $request);
		extract($request);
		
?>
<link rel="stylesheet" href="content/admin/plugins/bulk_image/plupload.queue.css" type="text/css" media="screen" />
<script type="text/javascript" src="http://www.google.com/jsapi"></script>
<script type="text/javascript">
	google.load("jquery", "1.3");
</script>
<script type="text/javascript" src="content/admin/plugins/bulk_image/js/gears_init.js"></script>
<script type="text/javascript" src="content/admin/plugins/bulk_image/js/browserplus-min.js"></script>
<script type="text/javascript" src="content/admin/plugins/bulk_image/js/plupload.full.min.js"></script>
<script type="text/javascript" src="content/admin/plugins/bulk_image/js/jquery.plupload.queue.min.js"></script>
<script>
$(function() {
	

	// Setup html5 version
	$("#html5_uploader").pluploadQueue({
		// General settings
		runtimes : 'html5',
		url : 'content/admin/plugins/bulk_image/upload.php',
		max_file_size : '10mb',
		max_file_count : 100,
		chunk_size : '1mb',
		unique_names : true,
		filters : [
			{title : "Image files", extensions : "jpg,gif,png"},
			{title : "Zip files", extensions : "zip"}
		],

		// Resize images on clientside if we can
		//resize : {width : 320, height : 240, quality : 90}
		

	});
	

});
function showText(val)
{

	if(val==1)
	{
		document.getElementById("div_text").innerHTML="Please mention the Product ID <input type=\"text\" name=\"product_id\" />";
	}
}
</script>
<!-- <script type="text/javascript"  src="http://getfirebug.com/releases/lite/1.2/firebug-lite-compressed.js"></script> -->
</head>

<?php
	if($_REQUEST['step']==2)
	{
		$error="";
		if($error==""){
			if($option_select==0){
			pageNote(array(
				array("icon"=>"ic_import.gif", "text"=>"Click here to upload images again", "url"=>"", "visible"=>true, "url"=>"admin.php?p=plugin&plugin_id=".$this->plugin_id)
			));
?>
		<div class="admin-tabs admin-tabs-framed" id="tabs-images">
		<?php 
			pageTabs(array(
				array("title"=>"Images Loader", "id"=>"main"),
			), "tabs-images", false);
		?>

	
	<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-upload">Images upload result</div>
			<table width="100%" cellpadding="5" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th style="width:100px;">Images</th>
						<th>Result</th>
					</tr>
				</thead>
				<tbody>
<?php
			$counter = 0;
			$product_images_dir="images/products";
			$product_thumbs_dir = "images/products/thumbs";
			$imageTypes = array(1,2,3);
			for($i=0;$i<$_POST['html5_uploader_count'];$i++){
				//echo $_POST['html5_uploader_'.$i.'_name']."<br />";
				$message = "<i>File was not uploaded.</i>";
				$targetDir = 'images/products/';
				
				if (!empty($_POST['html5_uploader_'.$i.'_tmpname']))
				{
					
					//check is image type correct
					$image_val = $targetDir.$_POST['html5_uploader_'.$i.'_tmpname'];
					$image_data = @getImageSize($image_val);
					
					//echo "<img src='".$image_val."' />";
					if ($image_data && in_array($image_data[2], $imageTypes))
					{
						$file_data = pathinfo($_POST['html5_uploader_'.$i.'_name']);
						$product_id = strtolower(trim(substr($file_data["basename"], 0, strlen($file_data["basename"]) - strlen($file_data["extension"]) - 1)));
						for ($k=0; $k<strlen($product_id); $k++)
						{
							if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "%";
						}

						$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."'");

						if (!DEMO_LOCK && ($product = $db->moveNext()) != false)
						{
							$pid = $product["pid"];
							$destination = $product_images_dir."/".imageFileName($product_id).".";
							
							//remove existing image & thumbs
							@unlink($destination."jpg");
							@unlink($destination."png");
							@unlink($destination."gif");
							@unlink($product_thumbs_dir."/".imageFileName($product_id).".jpg");
							//add new fil extension
							switch ($image_data[2])
							{
								case IMAGETYPE_GIF: $destination.="gif"; break;
								case IMAGETYPE_JPEG: $destination.="jpg"; break;
								case IMAGETYPE_PNG: $destination.="png"; break;
							}
							if (@rename($image_val, $destination))
							{
								$counter++;
								//in case of JPG and PNG image generate thumb
								if (!DEMO_LOCK)
								{
									if (in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG)))
									{
										getImageThumb($destination, $product_thumbs_dir."/".imageFileName($product_id).".jpg", $settings["CatalogThumbSize"], $settings["CatalogThumbType"], $error);
									}
									$db->query("UPDATE ".DB_PREFIX."products SET image_url='', image_location='Local' WHERE pid='".$pid."'");
								}
								$message = "<b>".$_POST['html5_uploader_'.$i.'_name']." - File has been successfully uploaded.</b><br>Product Name: ".gs($product["title"])."<br>Image Dimensions: ".$image_data["0"]."x".$image_data["1"]."<br>File Size: ".number_format($_FILES["image"]["size"][$i]/1024, 2, ".", ",")." KB";
							}
							else
							{
								$message = "<font color=red>".$_POST['html5_uploader_'.$i.'_name']." - Can't copy file to the destination folder. Please check free space and permissions.</font>";
							}
						}
						else
						{
							$message = "<font color=red>".$_POST['html5_uploader_'.$i.'_name']." - Can't assign image with product by Product ID.</font>";
						}
					}
					else
					{
						$message = "<font color=red>".$_POST['html5_uploader_'.$i.'_name']." - Incorrect image type: ".$_FILES["image"]["type"][$i].".</font>";
					}
				}
?>
					<tr>
						<td class="icon"></td>
						<td>Image #<?=$i+1?></td>
						<td><?=$message?></td>
					</tr>
<?php
			}
		  }
		  else
		  {
			pageNote(array(
				array("icon"=>"ic_import.gif", "text"=>"Click here to upload images again", "url"=>"", "visible"=>true, "url"=>"admin.php?p=plugin&plugin_id=".$this->plugin_id)
			));
			?>
		<div class="admin-tabs admin-tabs-framed" id="tabs-images">
		<?php 
			pageTabs(array(
				array("title"=>"Images Loader", "id"=>"main"),
			), "tabs-images", false);
		?>

	
	<div id="admin-tab-sheet-main" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header admin-icon-upload">Images upload result</div>
			<table width="100%" cellpadding="5" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th style="width:100px;">Images</th>
						<th>Result</th>
					</tr>
				</thead>
				<tbody>
<?php
			if(isset($_REQUEST['product_id'])) $id_product = $_REQUEST['product_id']; else $id_product = "";
		if(isset($_REQUEST['option_select'])) $option_select = $_REQUEST['option_select']; else $option_select = "";
		if($id_product){
			$db->query("SELECT pid FROM ".DB_PREFIX."products WHERE product_id='".$id_product."'");
			if($db->numRows()==0){
				$error = " No Primary image for this particular ID! Please create one and Upload."."<br />";
			}
			else{
				while($db->moveNext()){
					$pid=$db->col["pid"];
				}
				$db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".$pid."' ORDER BY iid");
				if($db->numRows()>0){
				//echo $imgFileName = imageFileName($pid);
					
					$product_images_dir="images/products/";
					$product_secondary_images_dir = "images/products/secondary";
					
					//$product_thumbs_dir = "images/products/thumbs";
					
					for($i=0;$i<$_POST['html5_uploader_count'];$i++){
						
						$imageTypes = array(1,2,3);
						$image_val = $product_images_dir.$_POST['html5_uploader_'.$i.'_tmpname'];
						$image_data = getImageSize($image_val);
						$extension = '';
						if (in_array($image_data[2], $imageTypes))
						{
							switch($image_data[2]){
								case IMAGETYPE_GIF: $extension.="gif"; break;
								case IMAGETYPE_JPEG: $extension.="jpg"; break;
								case IMAGETYPE_PNG: $extension.="png"; break;
							}
							$id_product = strtolower($id_product);
							$db->query("SELECT filename FROM ".DB_PREFIX."products_images WHERE pid='".intval($pid)."'");
							while ($db->movenext()) $imagesNames[$db->col["filename"]] = true;
							for ($imageNum=1; $imageNum<=10000; $imageNum++)
							{
								if (!isset($imagesNames[$id_product."-".$imageNum])) break;
							}
				
							$imagesNames[$id_product."-".$imageNum] = true;
						//print_r($imagesNames);exit;
							$db->reset();
							$db->assignStr("pid", $pid);
							$db->assignStr("is_visible", "Yes");
							$db->assignStr("width", $image_data[0]);
							$db->assignStr("height", $image_data[1]);
							$db->assignStr("type", $extension);
							$db->assignStr("filename", $id_product."-".$imageNum);
							$db->assignStr("caption", $id_product);
							$db->assignStr("alt_text", $id_product);
							$db->assignStr("image_priority", "1");
							$secondary_image_id = $db->insert(DB_PREFIX."products_images");
							$destination = $product_secondary_images_dir."/".$id_product."-".$imageNum.".".$extension;

							if (@copy($image_val, $destination))
							{
								@unlink($image_val);
						//in case of JPG and PNG image generate thumb
								if (in_array($image_data[2], array(IMAGETYPE_JPEG, IMAGETYPE_PNG)))
								{
									getImageThumb($destination, $product_secondary_images_dir."/thumbs/".$id_product."-".$imageNum.".jpg", $settings["CatalogThumbSize"], $settings["CatalogThumbType"], $error);
								}
								$message = "<b>".$_POST['html5_uploader_'.$i.'_name']." - File has been successfully uploaded.</b><br>Product Name: ".gs($product["title"])."<br>Image Dimensions: ".$image_data["0"]."x".$image_data["1"]."<br>File Size: ".number_format($_FILES["image"]["size"][$i]/1024, 2, ".", ",")." KB";
							}
							else
							{
								pageNote(array(
									array("icon"=>"ic_error.gif", "text"=>"<b>Can't upload secondary product image #".$i.". Please check free disk space and permissions</b>", "url"=>"",  "visible"=>true)
								));
							}
						}
						else
						{
							pageNote(array(
							array("icon"=>"ic_error.gif", "text"=>"<b>Can't upload secondary product image #".$i.". Incorrect image type: ".$_FILES["secondary_image_".$i]["type"]."</b>", "url"=>"",  "visible"=>true)
							));
						}
					?>
					<tr>
						<td class="icon"></td>
						<td>Image #<?=$i+1?></td>
						<td><?=$message?></td>
					</tr>
<?php
					
					}
					
				}

			}
			
		}
		  
		  }
		  
		}
		else
		{
		?>
		<body>

<form method="post" action="">
<input type="hidden" name="step" value="2">
	<?php
	 if(isset($error)){
	?>
	<div style="float: left; margin-right: 20px"><font color="red"><?php echo $error ?></font></div><?php }?>
		<br style="clear: both" />
	<br style="clear: both" />
	<div style="float: left; margin-right: 20px" id="uploader">

		<h3></h3>
		<div id="html5_uploader" style="width: 450px; height: 330px;">You browser doesn't support native upload. Try Firefox 3 or Safari 4.</div>
	</div>


	<br style="clear: both" />
	<br style="clear: both" />
	<label  style="float: left; padding:0 0 0 10px; margin-right: 20px">Please select the images category before upload </label>
	<select name="option_select" style="float: left; margin-right: 20px" >
	<option name="primary" value="0"  <?php if($option_select==0 || $option_select==""){ echo "checked";}?>> Primary Images </option>
	<option name="secondary" value="1" <?php if($option_select==1) { echo "checked";}?>> Secondary Images </option>
	</select>
	<br style="clear: both" />
	<br style="clear: both" />
	 <label style="float: left; padding:0 0 0 10px; margin-right: 20px">Please mention the Product ID if it is Secondary </label><input type="text" name="product_id" /> 
	 	<br style="clear: both" />
	<br style="clear: both" />
	<input class="plupload_button" type="submit" value="Upload" />
</form>

</body>
		<?php
		
		}
	}else{
?>

<body>

<form method="post" action="">
<input type="hidden" name="step" value="2">
	<?php
	 if(isset($error)){
	?>
	<div style="float: left; margin-right: 20px"><font color="red"><?php echo $error ?></font></div><?php }?>
	<div style="float: left; margin-right: 20px" id="uploader">

		<h3></h3>
		<div id="html5_uploader" style="width: 450px; height: 330px;">You browser doesn't support native upload. Try Firefox 3 or Safari 4.</div>
	</div>


	<br style="clear: both" />
	<br style="clear: both" />
	<label  style="float: left; padding:0 0 0 10px; margin-right: 20px">Please select the images category before upload </label>
	<select name="option_select" style="float: left; margin-right: 20px" >
	<option name="primary" value="0"  <?php if($option_select==0 || $option_select==""){ echo "checked";}?>> Primary Images </option>
	<option name="secondary" value="1" <?php if($option_select==1) { echo "checked";}?>> Secondary Images </option>
	</select>
	<br style="clear: both" />
	<br style="clear: both" />
	 <label style="float: left; padding:0 0 0 10px; margin-right: 20px">Please mention the Product ID if it is Secondary </label><input type="text" name="product_id" /> 
	 	<br style="clear: both" />
	<br style="clear: both" />
	<input class="plupload_button" type="submit" value="Upload" />
</form>

</body>
</html>
<?php
}
		
		
	}
	
}	

?>