<?php
	///////////////////////////////////////////////////////////////////////
	// INIT
	echo date("Y/m/d H:i:s")." - Start\n";
	$base_path = $_SERVER["argv"][1];
	if(!is_dir($base_path)){
		echo $base_path." can not be found on that server\r\n";
		die();
	}

	define("BASE_PATH", $base_path);
	
	//include libraries
	require_once(BASE_PATH."/content/engine/engine_config.php");
	require_once(BASE_PATH."/content/engine/engine_mysql.php");
	require_once(BASE_PATH."/content/engine/engine_functions.php");
	
	//init db
	$db = new DB;
	$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
		
	//get settings
	require_once(BASE_PATH."/content/engine/engine_settings.php");
	
	$price_option = $settings["plugin_dollar_days_import_price_option"];
	$price_value = $settings["plugin_dollar_days_import_price_value"];
	
	$datafeed_cats_url = "http://www.nextlevelsavings.com/pinnlist.asp";
	$datafeed_cats_file = "content/cache/tmp/dollar-days-categories.csv";
	
	$datafeed_prod_url = "http://www.nextlevelsavings.com/pinnfeed.asp?cid=0";
	$datafeed_prod_file = "content/cache/tmp/dollar-days-products.csv";
		
	///////////////////////////////////////////////////////////////////////
	// GET CATEGORIES LIST
	
	//if old file exists then remove it
	if (is_file(BASE_PATH."/".$datafeed_cats_file))
	{
		unlink(BASE_PATH."/".$datafeed_cats_file);
	}
	
	if (is_file(BASE_PATH."/".$datafeed_prod_file))
	{
		unlink(BASE_PATH."/".$datafeed_prod_file);
	}
	
	///////////////////////////
	//download data
	$c = curl_init();
	
	if ($settings["ProxyAvailable"] == "YES")
	{
		//curl_setopt($c, CURLOPT_VERBOSE, 1);
		if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
		{
			curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
		}
		curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
		if ($settings["ProxyRequiresAuthorization"] == "YES")
		{
			curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
		}

		curl_setopt($c, CURLOPT_TIMEOUT, 120);
	}
	curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
	
	//DOWNLOAD CATEGORIES
	curl_setopt($c, CURLOPT_URL, $datafeed_cats_url);
	//curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
	//curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
	//curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
	$buffer = curl_exec($c);
	if (curl_errno($c) > 0)
	{
		echo date("Y/m/d H:i:s")." - CATEGORY CURL returned error: ".curl_error($c)."\r\n";
		die();
	}
	if ($f = fopen(BASE_PATH."/".$datafeed_cats_file, "w"))
	{
		fputs($f, $buffer, strlen($buffer));
		fclose($f);
		unset($buffer);
		echo date("Y/m/d H:i:s")." - Categories file download done\n";
	}
	else
	{
		echo date("Y/m/d H:i:s")." - Can not save categories datafeed file: ".BASE_PATH."/".$datafeed_cats_file."\r\n";
		die();
	}
	
	//DOWNLOAD PRODUCTS
	curl_setopt($c, CURLOPT_URL, $datafeed_prod_url);
	curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
	curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
	curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
	$buffer = curl_exec($c);
	if (curl_errno($c) > 0)
	{
		echo date("Y/m/d H:i:s")." - PRODUCT CURL returned error: ".curl_error($c)."\r\n";
		die();
	}
	if ($f = fopen(BASE_PATH."/".$datafeed_prod_file, "w"))
	{
		fputs($f, $buffer, strlen($buffer));
		fclose($f);
		unset($buffer);
		echo date("Y/m/d H:i:s")." - Products file download done\n";
	}
	else
	{
		echo date("Y/m/d H:i:s")." - Can not save products datafeed file: ".BASE_PATH."/".$datafeed_prod_file."\r\n";
		die();
	}
	
	curl_close($c);
	
	///////////////////////////////////////////////////////////////////////
	// PROCESS CATEGORIES
	//delete file before writing a new one

	//read CSV from file into all categories
	$f = @fopen(BASE_PATH."/".$datafeed_cats_file, "r");
	if (!$f)
	{
		echo date("Y/m/d H:i:s")." - Can not open categories datafeed file: ".BASE_PATH."/".$datafeed_cats_file."\r\n";
		die();
	}
	
	$all_categories = array();
	$saved_categories = explode(",", $settings["plugin_dollar_days_import_categories"]);
	$import_all_categories = in_array("all", $saved_categories);
	$fields_separator = ",";
	while (($line = fgetcsv($f, 4096, $fields_separator, '"')))
	{
		//"Name","URL","CategoryID","ParentCatID"
		if (is_numeric($line[2]))
		{
			$category_key = "dollar_days_".$line[2];
			$category_parent = $line[3] == "0" ? "0" : ("dollar_days_".$line[3]);
			$line[0] = str_replace("&amp;", "&", $line[0]);
			$line[2] = $category_key;
			$line[3] = $category_parent;
							
			if (array_key_exists($line[2], $all_categories))
			{
				//echo "Duplicate Key:".$line[2]."<br/>";
			}
			else
			{
				$line["cid"] = "0";
				$line["import"] = false;
				$all_categories[$line[2]] = $line;
			}
		}
	}
	fclose($f);
	echo date("Y/m/d H:i:s")." - All categories read from file completed\r\n";
	
	//select current dollar days categories from database
	$current_categories = array();
	$db->query("SELECT cid, key_name FROM ".DB_PREFIX."catalog WHERE key_name LIKE 'dollar_days_%' ORDER BY level, priority");
	while (($category = $db->moveNext()) != false)
	{
		$current_categories[$category["key_name"]] = $category["cid"];
	}
	
	//build categories tree
	foreach ($all_categories as $category_key=>$category_data)
	{
		//get parent
		$category_parent_key = $category_data[3];
					
		//set initial properties
		$all_categories[$category_key]["import_products"] = false;
		$all_categories[$category_key]["import_category"] = false;
		$all_categories[$category_key]["level"] = 1;
					
		if (array_key_exists($category_key, $current_categories))
		{
			$all_categories[$category_key]["cid"] = $current_categories[$category_key];
		}
		else
		{
			$all_categories[$category_key]["cid"] = 0;
		}

		//set children - innitially there are no children
		$all_categories[$category_key]["children"] = array();
										
		//if parent exists, add current category to its parent and update category level
		if (array_key_exists($category_parent_key, $all_categories))
		{
			$all_categories[$category_parent_key]["children"][$category_key] = &$all_categories[$category_key];
			$all_categories[$category_key]["level"] = $all_categories[$category_parent_key]["level"] + 1;
			
			if ($all_categories[$category_parent_key]["import_products"])
			{
				$all_categories[$category_key]["import_products"] = true;
				$all_categories[$category_key]["import_category"] = true;
			}
		}
					
		//check is this category selected for import by user
		if ($import_all_categories || in_array($category_key, $saved_categories))
		{
			$all_categories[$category_key]["import_products"] = true;
			$all_categories[$category_key]["import_category"] = true;
						
			//set parent category to be imported too
			$_category_parent_key = $category_parent_key;
			if (!$import_all_categories)
			{
				while (array_key_exists($_category_parent_key, $all_categories))
				{
					$all_categories[$_category_parent_key]["import_category"] = true;
					$_category_parent_key = $all_categories[$_category_parent_key][3];
				}
			}
		}
	}

	echo date("Y/m/d H:i:s")." - All categories build tree completed\r\n";
	
	//update categories in database
	$categories_cid = array();
	$categories_added = 0;
	$categories_updated = 0;
	foreach ($all_categories as $category_key=>$category_data)
	{
		if ($all_categories[$category_key]["import_category"])
		{
			//mark category to do not delete it
			$current_categories[$category_key] = 0;
			//update or insert category
			$db->reset();
			$db->assignStr("parent", $category_data["level"] > 1 ? $all_categories[$category_data[3]]["cid"]:0);
			$db->assignStr("level", $category_data["level"]);
			$db->assignStr("name", $category_data[0]);
			$db->assignStr("is_visible", "Yes");
			if ($category_data["cid"] == 0)
			{
				//add new category
				$db->assignStr("key_name", $category_key);
				$all_categories[$category_key]["cid"] = $db->insert(DB_PREFIX."catalog");
				$categories_cid[$category_key] = $all_categories[$category_key]["cid"];
				$categories_added++;
			}
			else
			{
				//update category
				$db->update(DB_PREFIX."catalog", "WHERE cid='".$category_data["cid"]."'");
				$categories_cid[$category_key] = $category_data["cid"];
				$categories_updated++;
			}
		}
	}

	unset($all_categories);
				
	//delete old categories
	$where = "";
	$categories_deleted = 0;
	foreach ($current_categories as $category_key=>$cid)
	{
		if ($cid > 0)
		{
			$where .= ($where == ""?"":" OR ")." (cid='".$cid."') ";
			$categories_deleted++;
		}
	}
	
	if ($where != "")
	{
		$db->query("DELETE FROM ".DB_PREFIX."catalog WHERE ".$where);
		$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE ".$where);
	}
	echo date("Y/m/d H:i:s")." - All categories update database completed\r\n";
	
	//IMPORT RPODUCTS
	$db->query("SELECT pid, product_id FROM ".DB_PREFIX."products WHERE is_dollar_days='Yes'");
	$current_products = array();
					
	while (($product = $db->moveNext()) != false)
	{
		$current_products[$product["product_id"]] = $product["pid"];
	}
	
	
	//prepare step
	$price_option = $settings["plugin_dollar_days_import_price_option"];
	$price_value = $settings["plugin_dollar_days_import_price_value"];
					
	$products_added = 0;
	$products_updated = 0;
	$products_removed = 0;
					
	//open datafeed file
	$f = fopen(BASE_PATH."/".$datafeed_prod_file, "r");
	if (!$f)
	{
		echo date("Y/m/d H:i:s")." - Can not open product file: ".BASE_PATH."/".$datafeed_prod_file."\r\n";
		die();
	}
	
	while ($line = fgetcsv($f, 4096, ","))
	{
		if (floatval($line[2]) && array_key_exists("dollar_days_". $line[3], $categories_cid))
		{
			//get category id
			$cid = $categories_cid["dollar_days_". $line[3]];
			//get price
			if ($price_option == "inc")
			{
				$product_price = round($line[2] + $line[2] / 100 * $price_value, 2);
			}
			else
			{
				$product_price = round($line[2] - $line[2] / 100 * $price_value, 2);
			}
			
			//process product
			$db->reset();
			$db->assignStr("cid", $cid);
			$db->assignStr("product_id", $line[0]);
			$db->assignStr("title", $line[1]);
			$db->assignStr("price", $product_price);
			$db->assignStr("case_pack", $line[4]);
			$db->assignStr("description", $line[5]);
			$db->assignStr("image_url", $line[6]);
			
			if (array_key_exists($line[0], $current_products))
			{
				//product exists, update it
				$pid = $current_products[$line[0]];
				$current_products[$line[0]] = 0;
				$db->update(DB_PREFIX."products", "WHERE pid='".$pid."'");
				$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."'");
				$products_updated++;
			}
			else
			{
				//product does not exist, add it
				$db->assignStr("is_dollar_days", "Yes");
				$pid = $db->insert(DB_PREFIX."products");
				$products_added++;
			}
			$db->query("INSERT INTO ".DB_PREFIX."products_categories(pid,cid,is_primary) VALUES ('".$pid."','".$cid."',1)");
		}
	}
	fclose($f);

	//delete old products
	$where = "";
	foreach ($current_products as $product_id=>$pid)
	{
		if ($pid > 0)
		{
			$where .= ($where == ""?"":" OR ")." (pid='".$pid."') ";
			$products_removed++;
			if ($products_removed % 100 == 0)
			{
				$db->query("UPDATE ".DB_PREFIX."orders_content SET product_removed='Yes' WHERE ".$where);
				$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE ".$where);
				$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE ".$where);
				$db->query("DELETE FROM ".DB_PREFIX."products_shipping_price WHERE ".$where);
				$db->query("DELETE FROM ".DB_PREFIX."products WHERE ".$where);
				$where = "";
			}
		}
	}
	if ($where != "")
	{
		$db->query("UPDATE ".DB_PREFIX."orders_content SET product_removed='Yes' WHERE ".$where);
		$db->query("DELETE FROM ".DB_PREFIX."products_attributes WHERE ".$where);
		$db->query("DELETE FROM ".DB_PREFIX."products_categories WHERE ".$where);
		$db->query("DELETE FROM ".DB_PREFIX."products_shipping_price WHERE ".$where);
		$db->query("DELETE FROM ".DB_PREFIX."products WHERE ".$where);
	}
							
	unset($current_products);
	unset($categories_cid);
							
	//final update 
	$db->query("UPDATE ".DB_PREFIX."products SET meta_title=title, image_location='Web' WHERE is_dollar_days='Yes'");
	$db->query("UPDATE ".DB_PREFIX."settings SET value='".date("Y/m/d H:i:s")."' WHERE name='plugin_dollar_days_import_last_update'");
	
	//and after final bug fix for issue 1010
	updateSeoURLs($db, $settings, true, true, false, true);
	 
	
	@unlink(BASE_PATH."/".$datafeed_cats_file);
	@unlink(BASE_PATH."/".$datafeed_prod_file);
	
	echo date("Y/m/d H:i:s")." - Done\r\n".
		"New products added: ".$products_added."\r\n".
		"Products updated: ".$products_updated."\r\n".
		"Products removed: ".$products_removed."\r\n".
		"New categories created: ".$categories_added."\r\n".
		"Categories updated: ".$categories_updated."\r\n".
		"Categories deleted: ".$categories_deleted."\r\n"."\r\n";
?>