<?php
class ApiCalls
{
    static function GetVersion($args)
    {
        return 1;
    }

    static function GetOrderCount($args)
    {
        global $db;
        $lastOrder = isset($args["LastOrder"])?$args["LastOrder"]:0;
        $lastDate =  isset($args["LastDate"])?$args["LastDate"]:"1/1/1969";
        $status =  isset($args["Status"])?$args["Status"]:null;
        $customerid =  isset($args["CustomerId"])?$args["CustomerId"]:null;

        $sql = "SELECT COUNT(*) AS ordercount FROM ".DB_PREFIX."orders ";
        if ($status)
        {
            $status = $db->escape($status);
            $sql .= " WHERE status == '$status'";
        } else {
            $sql .= " WHERE status <> 'Abandon' AND status <> 'New' ";
        }
        if ($customerid)
        {
            $customerid = $db->escape($customerid);
            $sql .= " and orders.uid == '$customerid'";
        }
        if (is_numeric($lastOrder)) $sql.=" AND order_num >= ".intval($lastOrder);
        if ($lastDate != "all")
        {
            try
            {
                $lastDate = $db->escape($lastDate);
                $lastDateTimeStamp = strtotime($lastDate);
                $lastDate = date("Y-m-d H:i:s", $lastDateTimeStamp);
                $sql.=" AND placed_date>='". $lastDate . "'";
            }
            catch (Exception $e)
            {
                //invalid date string passed
            }
        }
        $db->query($sql);
        $result = $db->moveNext();
        return $result["ordercount"];
    }

    static function GetOrders($args)
    {
        global $db;
        require_once("lib/ApiOrder.php");
        $lastOrder = isset($args["LastOrder"])?$args["LastOrder"]:0;
        $lastDate =  isset($args["LastDate"])?$args["LastDate"]:"1/1/1969";
        $startNum =  isset($args["StartNumber"])?$args["StartNumber"]:0;
        $batchSize =  isset($args["BatchSize"])?$args["BatchSize"]:1000;
        $status =  isset($args["Status"])?$args["Status"]:null;
        $customerid =  isset($args["CustomerId"])?$args["CustomerId"]:null;
        $sql = 
            "SELECT ".DB_PREFIX."orders.*, ".DB_PREFIX."users.*, ".
            "IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name, ".
            "IF(".DB_PREFIX."orders.shipping_country=1 OR ".DB_PREFIX."orders.shipping_country=2, sstate.short_name, ".DB_PREFIX."orders.shipping_province) AS shipping_state_name, scountry.iso_a2 AS shipping_country_name ".
            "FROM ".DB_PREFIX."orders ".
            "INNER JOIN ".DB_PREFIX."users ON ".DB_PREFIX."orders.uid=".DB_PREFIX."users.uid ".
            "LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
            "INNER JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
            "LEFT JOIN ".DB_PREFIX."states AS sstate ON sstate.stid=".DB_PREFIX."orders.shipping_state ".
            "INNER JOIN ".DB_PREFIX."countries AS scountry ON scountry.coid=".DB_PREFIX."orders.shipping_country ";
        if ($status)
        {
            $status = $db->escape($status);
            $sql .= " WHERE status == '$status'";
        } else {
            $sql .= " WHERE status <> 'Abandon' AND status <> 'New' ";
        }
        if ($customerid)
        {
            $customerid = $db->escape($customerid);
            $sql .= " and orders.uid == '$customerid'";
        }
        if (is_numeric($lastOrder)) $sql.=" AND order_num > ".intval($lastOrder);
        if ($lastDate != "all")
        {
                $_date = explode("/", $lastDate);
                if (count($_date) == 3 && is_numeric($_date[0]) && is_numeric($_date[1])&& is_numeric($_date[2]))
                {
                        $sql.=" AND placed_date >='".$_date[2]."-".$_date[0]."-".$_date[1]." 00:00:01'";
                }
        }
        if (is_numeric($startNum)) $sql.=" AND order_num > ".$startNum;
        if (is_numeric($batchSize)) $sql.=" LIMIT ".$batchSize;
        $db->query($sql);
        $orderRecords = $db->getRecords();
        $returnArray = array();
        foreach ($orderRecords as $orderRecord)
        {
            $order=ApiOrder::LoadFromDataRecord($orderRecord);
            array_push($returnArray, $order);
        }
        return $returnArray;
    }

    static function GetCustomerCount($args)
    {
        global $db;
        $sql = "SELECT COUNT(*) AS usercount FROM ".DB_PREFIX."users";
        $db->query($sql);
        $result = $db->moveNext();
        return $result["usercount"];
    }

    
    static function GetCustomers($args)
    {
        global $db;
        require_once("lib/ApiCustomer.php");
        $startNum =  isset($args["StartNumber"])?$args["StartNumber"]:0;
        $batchSize =  isset($args["BatchSize"])?$args["BatchSize"]:1000;
        $sql = 
                "SELECT ".DB_PREFIX."users.*, ".
                "IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name ".
                "FROM ".DB_PREFIX."users ".
                "LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
                "LEFT JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
                "WHERE ".DB_PREFIX."users.uid>0 ";

        if (is_numeric($startNum)) $sql.=" AND ".DB_PREFIX."users.uid >= ".intval($startNum);
        $sql.=" GROUP BY ".DB_PREFIX."users.uid ORDER BY uid ";
        if (is_numeric($batchSize)) $sql.=" LIMIT ".intval($batchSize);
        $db->query($sql);
        $customerRecords = $db->getRecords();
        $returnArray = array();
        foreach ($customerRecords as $customerRecord)
        {
            $customer=ApiCustomer::LoadFromDataRecord($customerRecord);
            array_push($returnArray, $customer);
        }
        return $returnArray;
    }

    static function GetProductCount($args)
    {
        global $db;
        $sql = "SELECT COUNT(*) AS productscount FROM ".DB_PREFIX."products";
        $db->query($sql);
        $result = $db->moveNext();
        return $result["productscount"];
    }


    static function GetProducts($args)
    {
        global $db;
        global $include_path;
        global $settings;

        require_once($include_path."classes/class.products.php");
        require_once($include_path."classes/class.ddm_product_reviews.php");
        $curdir = getcwd();
        chdir("../../../../");
        $o = new ShoppingCartProducts($db,$settings);
        $itemsPerPage =  isset($args["BatchSize"])?$args["BatchSize"]:1000;
        $currentPage =  isset($args["BatchPage"])?$args["BatchPage"]:1;
        $primaryCategory =  isset($args["PrimaryCategory"])?$args["PrimaryCategory"]:null;

        if ($primaryCategory)
        {
            $productRecords = $o->getItemsCatalog(array("mode"=>"catalog", "categories"=>array($primaryCategory),"nested"=>true,"CatalogSortBy"=>"title","Page"=>$currentPage,"CatalogItemsOnPage"=>$itemsPerPage),1);
        } else {
            $passArgs = array();
            if (isset($args["ExtraArgs"]))
            {
                $args=$args["ExtraArgs"];
            }
            foreach ($args as $argKey=>$argValue)
            {
                if (strstr($argValue,","))
                {
                    $passArgs[$argKey] = explode(",", $argValue) ;
                } else {
                    $passArgs[$argKey] = $argValue;
                }
            }
            $passArgs["Page"]=$currentPage;
            $passArgs["CatalogItemsOnPage"]=$itemsPerPage;
            $productRecords = $o->getItemsCatalog($passArgs,1);
        }
        chdir($curdir);
        require_once("lib/ApiProduct.php");
        $returnArray = array();
        if ($productRecords)
        {
            foreach ($productRecords as $productRecord)
            {
                $product=ApiProduct::LoadFromDataRecord($productRecord);
                array_push($returnArray, $product);
            }
        }
        return $returnArray;
    }

    static function GetInventory($args)
    {
        global $db;
        require_once("lib/ApiProductQoh.php");
        $startNum =  isset($args["StartNumber"])?$args["StartNumber"]:0;
        $batchSize =  isset($args["BatchSize"])?$args["BatchSize"]:1000;
        $sql =
                "SELECT ".DB_PREFIX."products.* ".
                "FROM ".DB_PREFIX."products ".
                "WHERE ".DB_PREFIX."products.pid>0 ";
        if (is_numeric($startNum))
        {
                $sql.=" AND ".DB_PREFIX."products.pid >= ".$startNum;
        }
        $sql.=" ORDER BY pid";

        if (is_numeric($batchSize))
        {
                $sql.=" LIMIT ".$batchSize;
        }


        $db->query($sql);
        $productRecords = $db->getRecords();
        $returnArray = array();
        foreach ($productRecords as $productRecord)
        {
            $product=ApiProductQoh::LoadFromDataRecord($productRecord);
            array_push($returnArray, $product);
        }
        return $returnArray;
    }

    static function UpdateInventoryBulk($args)
    {
        global $db;
        $returnQuery = array();
        $update = isset($args["Update"])?$args["Update"]:"";
        $products = explode("|", $update);
        foreach ($products as $product)
        {
            $productInfo = explode("~", $product);
            $productId = trim($productInfo[0]);
            $newQoh = intval($productInfo[1]);
            $db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($productId)."'");

            if (($productRecord = $db->moveNext()) != false)
            {
                if ($productRecord["inventory_control"] == "Yes")
                {
                    $db->query("UPDATE ".DB_PREFIX."products SET stock='".$newQoh."' WHERE pid='".$productRecord["pid"]."'");
                    $returnQuery[$productId]="Updated new qoh is $newQoh";
                }
                else
                {
                    $returnQuery[$productId]="Product is not an inventory item";
                }
            }
            else
            {
                $returnQuery[$productId]="Invalid Product Id";
            }
        }
        return $returnQuery;
    }

    static function UpdateInventory($args)
    {
        global $db;
        $returnInfo = array();
        $update = isset($args["Update"])?$args["Update"]:"";
        $productInfo = explode("~", $update);
        $productId = trim($productInfo[0]);
        $newQoh = intval($productInfo[1]);
        $db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($productId)."'");

        if (($productRecord = $db->moveNext()) != false)
        {
            if ($productRecord["inventory_control"] == "Yes")
            {
                $db->query("UPDATE ".DB_PREFIX."products SET stock='".$newQoh."' WHERE pid='".$productRecord["pid"]."'");
                $returnInfo = "$productId updated new qoh is $newQoh";
            }
            else
            {
                $returnInfo = "$productId is not an inventory item";
            }
        }
        else
        {
            $returnInfo = "$productId is an invalid Product Id";
        }
        return $returnInfo;
    }

    static function ErrorHandler($errno, $errstr, $errfile, $errline, $errcontext)
    {
        //error_log("There was an error executing an api call: $errstr");
    }
}
?>