<?php
require_once("lib/ApiItemBase.php");
class ApiProductGroup extends ApiItemBase
{
	public function GetItemType()
	{
		return "ProductGroup";
	}

	public $Title;
	public $GroupId;
	public $ProductCount;

	public static function LoadFromDataRecord($dataRecord)
	{
		global $db;
		$returnProductGroup = new ApiProductGroup();
		$returnProductGroup->Title = $dataRecord["name"];
		$returnProductGroup->GroupId = $dataRecord["id"];
		$returnProductGroup->ProductCount = ApiProductGroup::GetProductCount($dataRecord["id"]);
		return $returnProductGroup;
	}

	public static function LoadById($id)
	{
		global $db;
		$sql = "SELECT * FROM ".DB_PREFIX."products_groups WHERE id = ".$db->escape($id);
		$db->query($sql);
		$rows = $db->getRecords();
		$returnArray = array();
		foreach ($rows as $row)
		{
			array_push($returnArray,ApiProductGroup::LoadFromDataRecord($row));
		}
		return $returnArray;
	}

	public static function GetProductGroups()
	{
		global $db;
		$sql = "SELECT * FROM ".DB_PREFIX."products_groups";
		$db->query($sql);
		$rows = $db->getRecords();
		$returnArray = array();
		foreach ($rows as $row)
		{
			array_push($returnArray,ApiProductGroup::LoadFromDataRecord($row));
		}
		return $returnArray;
	}
	
	public static function GetProductCount($id)
	{
		global $db;
		$db->query('SELECT COUNT(0) AS product_count FROM '.DB_PREFIX.'products WHERE pid IN (SELECT pid FROM '.DB_PREFIX.'products_groups_products WHERE group_id = '.$db->escape($id).') AND is_visible = "Yes"');
		$db->movenext();
		return $db->col['product_count'];
	}
}