<?php

require_once("IProcessor.php");

abstract class ProcessorBase implements IProcessor
{
	static function Process($httpRaw,$httpPost,$httpGet,$httpFile,$httpRequest,$template)
	{
		try
		{
			$call = isset($httpRequest["call"])?$httpRequest["call"]:null;
			if ($call)
			{
				if (method_exists("ApiCalls",$call))
				{
					$apiOutput = call_user_func(array("ApiCalls",$call), $_REQUEST);
				}
				else
				{
					throw new InvalidArgumentException("Invalid call");
				}
			}
			else
			{
				throw new InvalidArgumentException("Missing argument: call");
			}
		}
		catch (Exception $e)
		{
			$apiOutput = "error: " . $e->getMessage();
		}
		return $apiOutput;
	}

	static function ProcessNotAuthenticated($httpRaw,$httpPost,$httpGet,$httpFile,$httpRequest,$template)
	{
		return "Plugin is not active or authentication failed";
	}

	static function Get_FileExtension()
	{
		return "api";
	}

	static function Get_FileMimeType()
	{
		return "text/plain";
	}
}