<?php
require_once("ProcessorBase.php");
class SoapProcessor extends ProcessorBase
{
    static function Process($httpRaw,$httpPost,$httpGet,$httpFile,$httpRequest,$template)
    {
        $request = isSet($httpRaw) ? $httpRaw : '';
        $callname="unknown";
        $server = new nusoap_server();
        $server->configureWSDL('PinnacleApi', 'urn:PinnacleApi');

        $server->wsdl->addComplexType(
                'ApiAddress',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'Name' => array('name' => 'Name',
                                'type' => 'xsd:string'),
                        'Street1' => array('name' => 'Street1',
                                'type' => 'xsd:string'),
                        'Street2' => array('name' => 'Street2',
                                'type' => 'xsd:string'),
                        'City' => array('name' => 'City',
                                'type' => 'xsd:string'),
                        'State' => array('name' => 'State',
                                'type' => 'xsd:string'),
                        'Zip' => array('name' => 'Zip',
                                'type' => 'xsd:string'),
                        'Country' => array('name' => 'Country',
                                'type' => 'xsd:string')
                )
        );
        $server->wsdl->addComplexType(
                'ApiAddressArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiAddress[]')
                ),
                'tns:ApiAddress'
        );

        $server->wsdl->addComplexType(
                'ApiBillingInfo',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'FullName' => array('name' => 'OrderId',
                                'type' => 'xsd:string'),
                        'FirstName' => array('name' => 'FirstName',
                                'type' => 'xsd:string'),
                        'LastName' => array('name' => 'LastName',
                                'type' => 'xsd:string'),
                        'Email' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Company' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Phone' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Address' => array('name' => 'Billing',
                                'type' => 'tns:ApiAddress')
                )
        );

        $server->wsdl->addComplexType(
                'ApiCustomer',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'UserId' => array('name' => 'UserId',
                                'type' => 'xsd:integer'),
                        'UserName' => array('name' => 'Username',
                                'type' => 'xsd:string'),
                        'Billing' => array('name' => 'Billing',
                                'type' => 'tns:ApiBillingInfo'),
                        'AddressBook' => array('name' => 'AddressBook',
                                'type' => 'tns:ApiAddressArray')
                )
        );


        $server->wsdl->addComplexType(
                'ApiCustomerArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiCustomer[]')
                ),
                'tns:ApiCustomer'
        );

        $server->wsdl->addComplexType(
                'ApiShippingInfo',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'FullName' => array('name' => 'OrderId',
                                'type' => 'xsd:string'),
                        'Email' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Company' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Phone' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'Address' => array('name' => 'Billing',
                                'type' => 'tns:ApiAddress')
                )
        );



        $server->wsdl->addComplexType(
                'ApiProductOption',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'Title' => array('name' => 'Title',
                                'type' => 'xsd:string'),
                        'Caption' => array('name' => 'Caption',
                                'type' => 'xsd:string'),
                        'OptionId' => array('name' => 'OptionId',
                                'type' => 'xsd:string'),
                        'Price' => array('name' => 'Price',
                                'type' => 'xsd:float'),
                        'Type' => array('name' => 'Type',
                                'type' => 'xsd:string'),
                        'Weight' => array('name' => 'Weight',
                                'type' => 'xsd:float'),
                        'Cost' => array('name' => 'Cost',
                                'type' => 'xsd:string'),
                        'Priority' => array('name' => 'Priority',
                                'type' => 'xsd:string'),
                        'Options' => array('name' => 'Options',
                                'type' => 'tns:ApiProductOptionArray')
                )
        );

        $server->wsdl->addComplexType(
                'ApiProductOptionArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiProductOption[]')
                ),
                'tns:ApiProductOption'
        );


        $server->wsdl->addComplexType(
                'ApiProductQoh',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'PID' => array('name' => 'PID',
                                'type' => 'xsd:integer'),
                        'Qoh' => array('name' => 'Qoh',
                                'type' => 'xsd:integer'),
                        'ProductId' => array('name' => 'ProductId',
                                'type' => 'xsd:string')
                )
        );
        $server->wsdl->addComplexType(
                'ApiProductQohArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiProductQoh[]')
                ),
                'tns:ApiProductQoh'
        );

        $server->wsdl->addComplexType(
                'ApiProduct',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'PID' => array('name' => 'PID',
                                'type' => 'xsd:integer'),
                        'ProductId' => array('name' => 'ProductId',
                                'type' => 'xsd:string'),
                        'Qoh' => array('name' => 'Qoh',
                                'type' => 'xsd:integer'),
                        'Price' => array('name' => 'Price',
                                'type' => 'xsd:float'),
                        'Cost' => array('name' => 'Cost',
                                'type' => 'xsd:float'),
                        'Taxable' => array('name' => 'Taxable',
                                'type' => 'xsd:string'),
                        'Weight' => array('name' => 'Weight',
                                'type' => 'xsd:float'),
                        'UPC' => array('name' => 'UPC',
                                'type' => 'xsd:string'),
                        'Title' => array('name' => 'Title',
                                'type' => 'xsd:string'),
                        'URL' => array('name' => 'URL',
                                'type' => 'xsd:string'),
                        'ThumbnailImageUrl' => array('name' => 'ThumbnailImageUrl',
                                'type' => 'xsd:string'),
                        'ImageUrl' => array('name' => 'ImageUrl',
                                'type' => 'xsd:string'),
                        'Discontinued' => array('name' => 'Discontinued',
                                'type' => 'xsd:string'),
                        'Options' => array('name' => 'Options',
                                'type' => 'tns:ApiProductOptionArray')
                )
        );
        $server->wsdl->addComplexType(
                'ApiProductArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiProduct[]')
                ),
                'tns:ApiProduct'
        );




        $server->wsdl->addComplexType(
                'ApiProductCategory',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'Title' => array('name' => 'Title',
                                'type' => 'xsd:string'),
                        'CategoryId' => array('name' => 'CategoryId',
                                'type' => 'xsd:integer'),
                        'Children' => array('name' => 'Children',
                                'type' => 'tns:ApiProductCategoryArray')
                )
        );
        $server->wsdl->addComplexType(
                'ApiProductCategoryArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiProductCategory[]')
                ),
                'tns:ApiProductCategory'
        );






        $server->wsdl->addComplexType(
                'ApiOrderItemOption',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'Title' => array('name' => 'Title',
                                'type' => 'xsd:string'),
                        'SelectedOption' => array('name' => 'SelectedOption',
                                'type' => 'xsd:string'),
                        'Price' => array('name' => 'Price',
                                'type' => 'xsd:float'),
                        'Weight' => array('name' => 'Weight',
                                'type' => 'xsd:float')
                )
        );

        $server->wsdl->addComplexType(
                'ApiOrderItemOptionArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiOrderItemOption[]')
                ),
                'tns:ApiOrderItemOption'
        );

        $server->wsdl->addComplexType(
                'ApiOrderItem',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'PID' => array('name' => 'PID',
                                'type' => 'xsd:integer'),
                        'Quantity' => array('name' => 'Quantity',
                                'type' => 'xsd:integer'),
                        'Price' => array('name' => 'Price',
                                'type' => 'xsd:float'),
                        'Taxable' => array('name' => 'Taxable',
                                'type' => 'xsd:string'),
                        'Weight' => array('name' => 'Weight',
                                'type' => 'xsd:float'),
                        'FreeShipping' => array('name' => 'FreeShipping',
                                'type' => 'xsd:string'),
                        'ShippingPrice' => array('name' => 'ShippingPrice',
                                'type' => 'xsd:float'),
                        'TaxRate' => array('name' => 'TaxRate',
                                'type' => 'xsd:float'),
                        'TaxDescription' => array('name' => 'TaxDescription',
                                'type' => 'xsd:string'),
                        'DigitalProduct' => array('name' => 'DigitalProduct',
                                'type' => 'xsd:string'),
                        'UpdatedQuanity' => array('name' => 'UpdatedQuanity',
                                'type' => 'xsd:integer'),
                        'UpdatedPrice' => array('name' => 'UpdatedPrice',
                                'type' => 'xsd:float'),
                        'ProductId' => array('name' => 'ProductId',
                                'type' => 'xsd:string'),
                        'ProductSubId' => array('name' => 'ProductSubId',
                                'type' => 'xsd:string'),
                        'SKU' => array('name' => 'SKU',
                                'type' => 'xsd:string'),
                        'UPC' => array('name' => 'UPC',
                                'type' => 'xsd:string'),
                        'Title' => array('name' => 'Title',
                                'type' => 'xsd:string'),
                        'LineItemWeight' => array('name' => 'LineItemWeight',
                                'type' => 'xsd:float'),
                        'ProductWeight' => array('name' => 'ProductWeight',
                                'type' => 'xsd:float'),
                        'Options' => array('name' => 'Options',
                                'type' => 'tns:ApiOrderItemOptionArray'),
                )
        );

        $server->wsdl->addComplexType(
                'ApiOrderItemArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiOrderItem[]')
                ),
                'tns:ApiOrderItem'
        );

        $server->wsdl->addComplexType(
                'ApiOrder',
                'complexType',
                'struct',
                'all',
                '',
                array(
                        'OrderId' => array('name' => 'OrderId',
                                'type' => 'xsd:integer'),
                        'OrderNumber' => array('name' => 'OrderNumber',
                                'type' => 'xsd:integer'),
                        'OrderDate' => array('name' => 'OrderDate',
                                'type' => 'xsd:string'),
                        'Status' => array('name' => 'Status',
                                'type' => 'xsd:string'),
                        'StatusDate' => array('name' => 'StatusDate',
                                'type' => 'xsd:string'),
                        'PaymentMethod' => array('name' => 'PaymentMethod',
                                'type' => 'xsd:string'),
                        'PaymentStatus' => array('name' => 'PaymentStatus',
                                'type' => 'xsd:string'),
                        'ShippingCarrierId' => array('name' => 'ShippingCarrierId',
                                'type' => 'xsd:string'),
                        'ShippingMethodId' => array('name' => 'ShippingMethodId',
                                'type' => 'xsd:string'),
                        'ShippingMethodName' => array('name' => 'ShippingMethodName',
                                'type' => 'xsd:string'),
                        'ShippingAmount' => array('name' => 'ShippingAmount',
                                'type' => 'xsd:float'),
                        'ShippingTaxable' => array('name' => 'ShippingTaxable',
                                'type' => 'xsd:string'),
                        'ShippingTaxRate' => array('name' => 'ShippingTaxRate',
                                'type' => 'xsd:float'),
                        'ShippintTaxAmount' => array('name' => 'ShippintTaxAmount',
                                'type' => 'xsd:float'),
                        'ShippingTaxDescription' => array('name' => 'ShippingTaxDescription',
                                'type' => 'xsd:string'),
                        'HandlingSeparated' => array('name' => 'HandlingSeparated',
                                'type' => 'xsd:string'),
                        'HandlingFee' => array('name' => 'HandlingFee',
                                'type' => 'xsd:float'),
                        'HandlingFeeType' => array('name' => 'HandlingFeeType',
                                'type' => 'xsd:string'),
                        'HandlingAmount' => array('name' => 'HandlingAmount',
                                'type' => 'xsd:float'),
                        'HandlingTaxable' => array('name' => 'HandlingTaxable',
                                'type' => 'xsd:string'),
                        'HandlingTaxRate' => array('name' => 'HandlingTaxRate',
                                'type' => 'xsd:float'),
                        'HandlingTaxAmount' => array('name' => 'HandlingTaxAmount',
                                'type' => 'xsd:float'),
                        'HandlingTaxDescription' => array('name' => 'HandlingTaxDescription',
                                'type' => 'xsd:string'),
                        'HandlingText' => array('name' => 'HandlingText',
                                'type' => 'xsd:string'),
                        'SubtotalAmount' => array('name' => 'SubtotalAmount',
                                'type' => 'xsd:float'),
                        'DiscountAmount' => array('name' => 'DiscountAmount',
                                'type' => 'xsd:float'),
                        'DiscountValue' => array('name' => 'DiscountValue',
                                'type' => 'xsd:float'),
                        'DiscountType' => array('name' => 'DiscountType',
                                'type' => 'xsd:string'),
                        'PromoDiscountAmount' => array('name' => 'PromoDiscountAmount',
                                'type' => 'xsd:float'),
                        'PromoDiscountValue' => array('name' => 'PromoDiscountValue',
                                'type' => 'xsd:float'),
                        'PromoDiscountType' => array('name' => 'PromoDiscountType',
                                'type' => 'xsd:string'),
                        'TaxAmount' => array('name' => 'TaxAmount',
                                'type' => 'xsd:float'),
                        'TotalAmount' => array('name' => 'TotalAmount',
                                'type' => 'xsd:float'),
                        'GiftMessage' => array('name' => 'GiftMessage',
                                'type' => 'xsd:string'),
                        'Billing' => array('name' => 'Billing',
                                'type' => 'tns:ApiBillingInfo'),
                        'Shipping' => array('name' => 'Shipping',
                                'type' => 'tns:ApiShippingInfo'),
                        'OrderItems' => array('name' => 'OrderItems',
                                'type' => 'tns:ApiOrderItemArray')
                )
        );


        $server->wsdl->addComplexType(
                'ApiOrderArray',
                'complexType',
                'array',
                '',
                'SOAP-ENC:Array',
                array(),
                array(
                        array('ref'=>'SOAP-ENC:arrayType',
                        'wsdl:arrayType'=>'tns:ApiOrder[]')
                ),
                'tns:ApiOrder'
        );


        $server->register('ApiCalls.GetVersion',
                                array(),
                                array('return' => 'xsd:string'),
                                'PinnacleApi',
                                'PinnacleApi#GetVersion',
                                'rpc',
                                'literal',
                                'Get the version number of the Pinnacle Cart application'
                        );

        $server->register('ApiCalls.GetOrderCount',
                                array('Status' => 'xsd:string','CustomerId' => 'xsd:integer','LastOrder' => 'xsd:integer','LastDate' => 'xsd:string'),
                                array('return' => 'xsd:integer'),
                                'PinnacleApi',
                                'PinnacleApi#GetOrderCount',
                                'rpc',
                                'literal',
                                'Get the total number of order that match the passed criteria'
                        );
        $server->register('ApiCalls.GetOrders',
                                array('Status' => 'xsd:string','CustomerId' => 'xsd:integer','LastOrder' => 'xsd:integer','LastDate' => 'xsd:string','StartNumber' => 'xsd:integer','BatchSize' => 'xsd:integer'),
                                array('return' => 'tns:ApiOrderArray'),
                                'PinnacleApi',
                                'PinnacleApi#GetOrders',
                                'rpc',
                                'literal',
                                'Get all of your orders based on the passed criteria'
                        );

        $server->register('ApiCalls.GetCustomerCount',
                                array(),
                                array('return' => 'xsd:integer'),
                                'PinnacleApi',
                                'PinnacleApi#GetCustomerCount',
                                'rpc',
                                'literal',
                                'Get the total number of customers'
                        );

        $server->register('ApiCalls.GetCustomers',
                                array('StartNumber' => 'xsd:integer','BatchSize' => 'xsd:integer'),
                                array('return' => 'tns:ApiCustomerArray'),
                                'PinnacleApi',
                                'PinnacleApi#GetCustomers',
                                'rpc',
                                'literal',
                                'Get all of your customers'
                        );
        $server->register('ApiCalls.GetProductCount',
                                array(),
                                array('return' => 'xsd:integer'),
                                'PinnacleApi',
                                'PinnacleApi#GetProductCount',
                                'rpc',
                                'literal',
                                'Get the total number of products'
                        );

        $server->register('ApiCalls.GetProducts',
                                array('StartNumber' => 'xsd:integer','BatchSize' => 'xsd:integer','BatchPage' => 'xsd:integer','PrimaryCategory' => 'xsd:integer','ExtraArgs' => 'xsd:string'),
                                array('return' => 'tns:ApiProductArray'),
                                'PinnacleApi',
                                'PinnacleApi#GetProducts',
                                'rpc',
                                'literal',
                                'Get your products based on the passed criteria.  The <a href="https://www.YourSiteName.com/content/admin/plugins/openapi/docs/index.php#GetProducts">ExtraArgs</a> parameter provides a mechanism for passing a wide assortment of criteria for getting only the products you wish'
                        );

        $server->register('ApiCalls.GetCategories',
                                array(),
                                array('return' => 'tns:ApiProductCategoryArray'),
                                'PinnacleApi',
                                'PinnacleApi#GetCategories',
                                'rpc',
                                'literal',
                                'Get all of the product categories'
                        );

        $server->register('ApiCalls.GetInventory',
                                array('StartNumber' => 'xsd:integer','BatchSize' => 'xsd:integer'),
                                array('return' => 'tns:ApiProductQohArray'),
                                'PinnacleApi',
                                'PinnacleApi#GetInventory',
                                'rpc',
                                'literal',
                                'Get your store inventory'
                        );

        $requestedApiTypeAndAuth = $httpRequest["apiType"] . "&username=" . $httpRequest["username"] . "&password=" . $httpRequest["password"]. "&token=" . $httpRequest["token"];
        //$server->Set_RequestedApi($requestedApiTypeAndAuth);
        ob_start();
        $server->service($request);
        $apiOutput = ob_get_contents();
        ob_end_clean();
        return $apiOutput;
    }
    static function ProcessNotAuthenticated($httpRaw,$httpPost,$httpGet,$httpFile,$httpRequest,$template)
    {
        $output = parent::ProcessNotAuthenticated($httpRaw, $httpPost, $httpGet, $httpFile, $httpRequest,$template);
        $request = isSet($httpRaw) ? $httpRaw : '';
        $callname="unknown";
        $server = new nusoap_server();
        $server->configureWSDL('PinnacleApi', 'urn:PinnacleApi');
        ob_start();
        $server->fault(0,$output);
        $server->service($request);
        $apiOutput = ob_get_contents();
        ob_end_clean();
        return $apiOutput;
    }
}
