<?php

class plugin_productdownload extends cartPlugin
{
	//protected
	var $plugin_id = "productdownload";
	var $plugin_group = "export";
	var $plugin_caption = "Product Data Feeds";
	var $plugin_description = "Upload your products to various popular formats including Google Product Search, eBay, Amazon, Yahoo and more.";

	function runPlugin(&$db, &$settings, &$request)
	{
		parent::runPlugin($db, $settings, $request);

		//form header
		pageHeader("Data Export, product downloads");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"Download files compatible with the largest catalog systems including Ebay, Amazon, Google, Yahoo.", "visible"=>true)
			//array("icon"=>"ic_hint.gif", "text"=>"Due to current API limitations you can export only up to 5000 products at a time", "visible"=>true),
		));

		//form table
		$sql = "select * from ".DB_PREFIX."products_groups";
		$db->query($sql);
		$productGroups = $db->getRecords();

		$sql = "select cid,name,level from ".DB_PREFIX."catalog";
		$db->query($sql);
		$categories = $db->getRecords();
		
		echo '<div class="admin-tabs admin-tabs-framed" id="tabs-downloads">';
		pageTabs(array(array("title"=>"Downloads", "id"=>"Main")), "tabs-downloads", false);
		echo '<div id="admin-tab-sheet-main" class="admin-tab-sheet"><div class="admin-tab-sheet-wrap">';
		echo '<div class="admin-form-header">Download product files</div>';
		echo '<table width="100%" cellpadding="0" cellspacing="5" border="0">';
		echo '<tr valign="top"><td class="formItemCaption">Include products from this category</td>';
		echo '<td>';
		echo '<select id="product_category"><option value="-1">All Categories</option>';
		foreach ($categories as $category)
		{
			echo '<option value="'.$category['cid'].'">'. str_replace(" ","&nbsp;",str_pad("", ($category['level']*3)," ",STR_PAD_LEFT).$category['name']).'</option>';
		}
		echo '</selsect>';
		echo '</td></tr>';
		echo '<tr valign="top"><td class="formItemCaption">Include products from this product group</td>';
		echo '<td>';
		echo '<select id="product_group"><option value="0">All Groups</option>';

		foreach ($productGroups as $productGroup)
		{
			echo '<option value="'.$productGroup['id'].'">'.$productGroup['name'].'</option>';
		}

		echo '</select>';
		echo '<a href="admin.php?p=products_groups" style="margin-left: 20px;">Add/Edit product Groups</a>';
		echo '</td></tr>';
		echo '<tr valign="top"><td class="formItemCaption">Max # of Products</td>';
		echo '<td>';
		echo '<select id="product_count">';
		echo '<option value="1">1</option>';

		for ($i=100; $i<=5000; $i=$i+100)
		{
			echo '<option value="'.$i.'" '.($i==1000?'selected':'').'>'.$i.'</option>';
		}

		echo '</select>';
		echo '</td></tr>';

		echo '</td></tr>';
		echo '<tr valign="top"><td class="formItemCaption">File Format</td>';
		echo '<td>';
		echo '<select id="download_link">';
		echo '<option value="&template=googlebase_products&apiType=rss&call=GetProducts">Google Base</option>';
		echo '<option value="&template=amazon_products&apiType=tsv&call=GetProducts">Amazon Seller</option>';
		echo '<option value="&template=yahoo_products&apiType=csv&call=GetProducts">Yahoo! Store</option>';
		echo '<option value="&apiType=zip&call=GetProductImagesZip&outfile=img">Yahoo! Store Product Images Zip</option>';
		echo '<option value="&template=ebay_products&apiType=csv&call=GetProducts">Ebay Store</option>';
		echo '<option value="&template=goshopping_products&apiType=psv&call=GetProducts">Goshopping.com</option>';
		echo '<option value="&template=pricegrabber_products&apiType=csv&call=GetProducts">PriceGrabber.com</option>';
		echo '<option value="&template=nextag_products&apiType=csv&call=GetProducts">NexTag.com</option>';
		echo '</select>';
		echo '</td></tr>';
		echo '</table></div></div></div>';
		echo '<div class="admin-form-buttons">';
		echo '<button onclick="window.location=\''.$settings["GlobalHttpsUrl"].'/content/admin/plugins/openapi/index.php?BatchPage=1\'+$(\'#download_link\').val()+\'&BatchSize=\'+$(\'#product_count\').val()+\'&PrimaryCategory=\'+$(\'#product_category\').val()+\'&ProductGroup=\'+$(\'#product_group\').val()+\'&download=1\'">Download file</button>';
		echo '</div>';
	}
}
?>