<?php

class plugin_productdownload extends cartPlugin
{
	//protected
	var $plugin_id = "productdownload";
	var $plugin_group = "export";
	var $plugin_caption = "Product Data Feeds";
	var $plugin_description = "Upload your products to various popular formats including Google Product Search, eBay, Amazon, Yahoo and more.";

	function runPlugin(&$db, &$settings, &$request)
	{
		parent::runPlugin($db, $settings, $request);

		//form header
		pageHeader("Data Export, product downloads", '', 'icb-organizational-chart');
		
		if (!AccessManager::checkAccess('PRODUCT_EXPORT'))
		{
			AccessManager::notAllowed();
			return;
		}
		
		
		pageNote(array(
			array("class"=>"ic-info", "text"=>"Download files compatible with the largest catalog systems including Ebay, Amazon, Yahoo.", "visible"=>true),
			array("class"=>"ic-info", "text"=>"Looking for Google Base feeds, please use the updated tool under <a href='admin.php?p=google_marketing'>Google Tools</a>", "visible"=>true),
			//array("class"=>"ic-info", "text"=>"Due to current API limitations you can export only up to 5000 products at a time", "visible"=>true),
		));

		//form table
		$sql = "select * from ".DB_PREFIX."products_groups";
		$db->query($sql);
		$productGroups = $db->getRecords();

		$sql = "select cid,name,level from ".DB_PREFIX."catalog WHERE name <> 'gift_cert' ORDER BY category_path";
		$db->query($sql);
		$categories = $db->getRecords();
		
		echo '<div class="admin-tabs admin-tabs-framed" id="tabs-downloads">';
		pageTabs(array(array("title"=>"Downloads", "id"=>"main")), "tabs-downloads", false);
		echo '<div id="admin-tab-sheet-main" class="admin-tab-sheet"><div class="admin-tab-sheet-wrap">';
		echo '<div class="admin-form-header first"><span class="icon ic-icon"></span>Download product files</div>';
		
		echo '<div class="fieldset">'.
				'<div class="field field-select">'.
					'<div class="caption">Include products from this category</div>'.
					'<div class="control">'.
						'<select id="product_category">'.
							'<option value="-1">All Categories</option>';
		
		foreach ($categories as $category)
		{
			echo '<option value="'.$category['cid'].'">'. str_replace(" ","&nbsp;",str_pad("", ($category['level']*3)," ",STR_PAD_LEFT).gs($category['name'])).'</option>';
		}
		echo			'</select>'.
					'</div>'.
				'</div>'.
				
				'<div class="field field-select">'.
					'<div class="caption">Include products from this product group</div>'.
					'<div class="control">'.
						'<select id="product_group">'.
							'<option value="0">All Groups</option>';

		foreach ($productGroups as $productGroup)
		{
			echo '<option value="'.$productGroup['id'].'">'.gs($productGroup['name']).'</option>';
		}

		echo			'</select><a href="admin.php?p=products_groups" style="margin-left: 20px;">Add/Edit product Groups</a>'.
					'</div>'.
				'</div>'.
				
				'<div class="field field-select">'.
					'<div class="caption">Max # of Products</div>'.
					'<div class="control">'.
						'<select id="product_count">'.
							'<option value="1">1</option>';

		for ($i=100; $i<=5000; $i=$i+100)
		{
			echo '<option value="'.$i.'" '.($i==1000?'selected':'').'>'.$i.'</option>';
		}

		echo			'</select>'.
					'</div>'.
				'</div>'.
				'<div class="field field-select">'.
					'<div class="caption">File Format</div>'.
					'<div class="control">'.
						'<select id="download_link">'.
							'<option value="&template=amazon_products&apiType=csv&call=GetProducts">Amazon Seller</option>'.
							'<option value="&template=yahoo_products&apiType=csv&call=GetProducts">Yahoo! Store</option>'.
							'<option value="&apiType=zip&call=GetProductImagesZip&outfile=img">Yahoo! Store Product Images Zip</option>'.
							'<option value="&template=ebay_products&apiType=csv&call=GetProducts">Ebay Store</option>'.
							'<option value="&template=goshopping_products&apiType=psv&call=GetProducts">Goshopping.com</option>'.
							'<option value="&template=pricegrabber_products&apiType=csv&call=GetProducts">PriceGrabber.com</option>'.
							'<option value="&template=nextag_products&apiType=csv&call=GetProducts">NexTag.com</option>'.
						'</select>'.
					'</div>'.
				'</div>'.
			'</div>'.
			'<div class="admin-form-buttons">'.
				'<input type="button" onclick="document.getElementById(\'iframe-download\').src=\''.$settings["GlobalHttpsUrl"].'/content/admin/plugins/openapi/index.php?BatchPage=1\'+$(\'#download_link\').val()+\'&BatchSize=\'+$(\'#product_count\').val()+\'&PrimaryCategory=\'+$(\'#product_category\').val()+\'&ProductGroup=\'+$(\'#product_group\').val()+\'&download=1\'" value="Download file">'.
			'</div>';
	}
}
?>