<script type="text/javascript">

	var themesInstallable = {$themesInstallable};
	var existingThemes = {$existingThemes};
	var themeRepository = document.location.protocol + '//www.cartmanual.com/themes';

	{literal}
	$(document).ready(function(){

		$('#myThemesFilter').filterList({ list: '#idTabSheetmyThemes ul.themes' });
		$('#freeThemesFilter').filterList({ list: '#idTabSheetfreeThemes ul.themes' });
		$('#premiumThemesFilter').filterList({ list: '#idTabSheetpremiumThemes ul.themes' });

		$('a.preview').fancybox({
			'zoomSpeedIn': 500,
			'zoomSpeedOut': 300,
			'transactionIn': 'elastic',
			'showCloseButton': true,
			'titlePosition': 'inside',
			'titleFormat': formatTitle
		});

		$('#confirmSkinDialog').bind('onActivationSuccess', function(e, activatedSkin){
			document.location = 'admin.php?p=design_settings';
		});
		
		$('#confirmSkinDialog').dialog({
			'title'          : 'Switch Themes',
			'autoOpen'       : false,
			'modal'          : true,
			'dialogClass'    : 'skin-selection-dialog',
			'closeOnEscape'  : false,
			'resizable'      : false,
			'width'          : 500,
			'buttons':
			{ 
				'Cancel': function(){
					// close the dialog box
					$('#confirmSkinDialog').dialog('close');
					// reset the selected radio button
					$('#confirmSkinDialog #useLayout_default').attr('checked', true);
				},
				'Save': function(){
					adminShowSpinner('Activating theme');
					var selectedSkin = $('#confirmSkinDialog').data('target');
					selectedSkin.addClass('activated');
					var activatedSkin = $('li.theme:has(button.activated)');

					// Attempt to set the theme in $settings
					$.getJSON('admin.php?p=design_settings&chart=true', {
						'skinName': activatedSkin.attr('title'),
						'layoutConfig': $('#confirmSkinDialog input:checked').val()
					}, function(response){
						
						if (response.result == 'success')
						{
							$('#confirmSkinDialog').trigger('onActivationSuccess', [activatedSkin]);
							adminHideSpinner();
						}
					});

					selectedSkin.removeClass('activated');

					// close the dialog box
					$('#confirmSkinDialog').dialog('close');
					
					if (typeof(DesignMode) != 'undefined' && $('#confirmSkinDialog #useLayout_default').attr('checked'))
					{
						if (confirm("Some of changes you just made require page refresh.\nDo you want to do it now?"))
						{
							DesignMode().showSpinner('Refreshing...');
							document.location.reload();
						}
					}
					
					// reset the selected radio button
					$('#confirmSkinDialog #useLayout_default').attr('checked', true);
				}
			},
			'open': function(e, ui)
			{
				$('#confirmSkinDialog span.selectedSkin').html($('#confirmSkinDialog').data('target').attr('title'));
				$('#confirmSkinDialog').height('170px');
			}
		});
		
		setControls();
		
		
		$('#installedThemes button.delete').each(function(){
			$(this).click(function(){
				var themeName = $(this).attr('data-id');
				
				if (confirm('Are you sure you want to delete '+themeName+'?', 'Yes'))
				{
					deleteTheme(themeName);
				}
				
				return false;
			});
		});
		
		$('.button-refresh-theme').click(function(){
			if (confirm('Click OK to refresh your theme now'))
			{
				adminShowSpinner('Refreshing theme');
				$.get($(this).attr('href'), function(){
					adminHideSpinner();
				});
			}
			return false;
		});


		// External themes
		$.ajax({
			url: themeRepository+'/list?/v='+cartVersion,
			dataType: 'jsonp',
			success: function (data)
			{
				var n = 1;
				$.each(data.themes, function(key, entry){
					var action = '<button data-external="'+themeRepository+'/downloads/' + entry.key + '.zip" class="download"></button>';
					
					if ($.inArray(entry.key, existingThemes) == -1)
					{
						
						var html = generateThemeItem({
							'key': entry.key,
							'title': entry.name,
							'action': (themesInstallable ? 'install' : 'download'),
							'actionUrl': (themesInstallable ? 'admin.php?p=design_settings&chart=true&install=' + entry.key : themeRepository+'/downloads/' + entry.key + '.zip'),
							'thumbnailImageUrl': themeRepository+'/downloads/' + entry.thumbnail,
							'fullsizeImageUrl': themeRepository+'/downloads/' + entry.preview
						});

						$('#theme-selection ul.themes').append(html);
					}
				});

				setControls();
				$('button.install').each(function(){
					$(this).click(function(){
						var button = this;
						// Show installing graphic...
						if (confirm('Are you sure you want to install this theme?'))
						{
							$.get($(this).attr('data-external'), function(response){
								//document.location = 'admin.php?p=design_settings';
								$('#confirmSkinDialog').data('target', $(button));
								$('#confirmSkinDialog').dialog('open');
							});
						}
					});
				});
		
				$('#theme-selection ul.themes a.preview').fancybox({
					'zoomSpeedIn': 500,
					'zoomSpeedOut': 300,
					'transactionIn': 'elastic',
					'showCloseButton': true,
					'titlePosition': 'inside',
					'titleFormat': formatTitle
				}); 
				
				$('#theme-selection ul.themes a.preview_link').click(function(){
					$('#'+$(this).attr('rel')).click();
					return false;
				});
			}
		});
	}); // end $(document).ready()
	
	
	function generateThemeItem(settings)
	{
		var defaults = {
			'title': 'Theme Title',
			'thumbnailImageUrl': 'images/admin/no-thumbnail.jpg',
			'fullsizeImageUrl': 'images/admin/no-preview.jpg',
			'action': 'activate',
			'key': null,
			'themeRepository': '',
			'actionUrl': null,
			'images': []
		};
		
		settings = $.extend(defaults, settings);
		
		switch (settings.action)
		{
			case 'download':
				action = '<button class="download" data-external="' + settings.actionUrl + '"></button>';
				break;
				
			case 'install': 
				action = '<button data-external="' + settings.actionUrl + '" class="install" title="'+settings.title+'"></button>';
				break;
				
			case 'activate': 
			default:
				action = '<button class="activate" title="'+settings.title+'"></button>';
				break;
		}
		
		var imagesHtml = '';
		for (var i = 0; i < settings.images.length; i++)
		{
			imagesHtml += '<a href="'+settings.images[i]+'" rel="group_'+settings.key+'" title="'+settings.title+'" class="preview"></a>'
		}
		
		var html =
			'<li class="theme" title="'+settings.key+'">'+
			'	<div class="theme">'+
			'		<p class="title">'+settings.title+'</p>'+
			'		<div class="controls '+settings.key+'">'+
			'			<button class="preview_link" data-rel="preview_'+settings.key+'" title="'+settings.title+'"></button> '+action+
			'		</div>'+
			'		<a id="preview_'+settings.key+'" href="'+settings.fullsizeImageUrl + '" class="preview"><img class="thumbnail" data-theme="'+settings.key+'" src="'+settings.thumbnailImageUrl+ '" /></a>'+
			'		'+imagesHtml+
			'		<div class="reflection">'+
			'			<div class="fade"></div>'+
			'			<div class="mirror">'+
			'				<img class="thumbnail" src="'+settings.thumbnailImageUrl+ '" />'+
			'			</div>'+
			'		</div>'+
			'		<span class="tags">'+settings.key+'</span>'+
			'	</div>'+
			'</li>';
			
		return html;
	}
	
	function setControls()
	{
		$('ul.themes .preview_link').click(function(){
			$('#'+$(this).attr('data-rel')).click();
			return false;
		});

		// Controls for activating a theme
		$('li.theme .activate').live('click', function(){
			$('#confirmSkinDialog').data('target', $(this));
			$('#confirmSkinDialog').dialog('open');
			return false;
		});

		$('li.theme .download').live('click', function() {
			url = $(this).attr('data-external');
			$('#downloadFrm').attr('action', url);
			$('#downloadFrm').submit();
			return false;
		});

		$('#fancybox-left,#fancybox-right').hover(function(){
			$(this).css({
				'background-color': '#000000',
				'opacity': 0.2
			});
		}, function(){
			$(this).css({
				'background-color': 'transparent',
				'opacity': 1
			});
		});

		$('li.theme .thumbnail').each(function(){
			$(this).hover(function(){
				$('.controls').hide();
				$('.controls.'+$(this).attr('data-theme')).show();
			});
			
			$('.controls.'+$(this).attr('data-theme')).mouseleave(function(){
				$('.controls').hide();
			});
		});
	}

	function formatTitle(title, currentArray, currentIndex, currentOpts)
	{
	    return '<div>' + (title && title.length ? '<strong>' + title + '</strong>' : '' ) + '</div>';
	}

	function deleteCheckedThemes()
	{
		if (confirm('Are you sure you want to delete the selected themes?'))
		{
			var themes = [];
			$('#installedThemes input[name="themes[]"]:checked').each(function(){
				themes.push($(this).val());
			});
			
			deleteTheme(themes);
		}
	}
	
	function deleteTheme(themes)
	{
		var response = null;
		if (!$.isArray(themes)) themes = [themes];
		
		$.getJSON('admin.php?p=design_settings&deleteTheme='+themes.join(',')+'&chart=true', function(data){
			
			if (data.status == 'success')
			{
				document.location = 'admin.php?p=design_settings&last_active_tab=manage';
			}
			else
			{
				alert('The following theme(s) could not be removed and must be deleted manually.\n\n'+themes.join('\n'));
			}
		});
	}
	
	{/literal}
</script>
