<?php

class Admin_Flash
{
	const TYPE_SUCCESS = 'success';
	const TYPE_ERROR = 'error';
	const TYPE_INFO = 'info';

	/**
	 * Set flash message
	 *
	 * @param $message
	 * @param string $status
	 */
	public static function setMessage($message, $status = self::TYPE_SUCCESS)
	{
		$_SESSION['flash'][] = array($message, $status);
	}

	/**
	 * Check does flash message exist
	 *
	 * @return bool
	 */
	public static function hasMessages()
	{
		return isset($_SESSION['flash']) && is_array($_SESSION['flash']) && count($_SESSION['flash']) > 0;
	}

	/**
	 * Returns flash message
	 *
	 * @param bool $reset
	 * @return mixed
	 */
	public static function getMessages($reset = true)
	{
		$messages = $_SESSION['flash'];
		if ($reset) unset($_SESSION['flash']);
		return $messages;
	}
}