<?php
/**
 * Discount amount calculator
 */
class Calculator_AdminDiscount extends Calculator_Discount
{
	/**
	 * Calculate discount
	 *
	 * @param ORDER $order
	 * @param bool $reset
	 *
	 * @return string
	 */
	public function calculate(ORDER $order, $reset = true)
	{
		$subtotal = $order->calculateSubtotal(false, true);

		$discountAmount = 0;

		$dp = $this->getDiscountPercentage($subtotal, $order->getDiscountType(), $order->getDiscountValue());

		foreach ($order->lineItems as $item)
		{
			/* @var $item Model_LineItem */
			if ($item->getProductId() == 'gift_certificate')
				continue;

			$lineSubTotal = $item->getSubtotal();

			$lineDiscountAmount = PriceHelper::round($lineSubTotal * $dp / 100);
			$item->setDiscountAmount($lineDiscountAmount);
			$discountAmount += $lineDiscountAmount;

			$this->orderRepository->updateLineItemDiscount($order->getId(), $item->getId(), $lineDiscountAmount, $item->getPromoDiscountAmount());
		}

		$order->setDiscountAmount($discountAmount);

		return $order->getDiscountAmount();
	}

	public function reset(ORDER $order)
	{
		$this->orderRepository->resetLineItemDiscounts($order->getId());
	}
}