<?php

class DataAccess_PromoCodeRepository implements DataAccess_PromoCodeRepositoryInterface
{
	protected $db;

	/**
	 * Class constructor
	 *
	 * @param DB $db
	 */
	public function __construct(DB $db)
	{
		$this->db = $db;
	}

	/**
	 * Get promo code from database
	 *
	 * @param string $promoCode
	 *
	 * @return mixed
	 */
	public function getPromoCode($promoCode)
	{
		$result = $this->db->selectOne($this->getActivePromoCodeQuery()." AND promo_code='".$this->db->escape($promoCode)."'", MYSQL_ASSOC);

		return $result ? $result : null;
	}

	/**
	 * Get promo campaign by id
	 *
	 * @param int $promoCampaignId
	 *
	 * @return mixed
	 */
	public function getPromoCodeByPromoCampaignId($promoCampaignId)
	{
		$result = $this->db->selectOne($this->getActivePromoCodeQuery()." AND pid = ".intval($promoCampaignId), MYSQL_ASSOC);

		return $result ? $result :null;
	}

	/**
	 * Get promo products
	 *
	 * @param int $oid
	 * @param int $promoCampaignId
	 *
	 * @return mixed
	 */
	public function getPromoProducts($oid, $promoCampaignId)
	{
		return $this->db->selectAll("
			SELECT o.pid
			FROM ".DB_PREFIX."orders_content o
				INNER JOIN ".DB_PREFIX."orders oz ON o.oid = oz.oid
				INNER JOIN ".DB_PREFIX."products_categories c ON o.pid = c.pid
				LEFT JOIN ".DB_PREFIX."promo_categories pc ON c.cid = pc.cid AND pc.pid = ".intval($promoCampaignId)."
				LEFT JOIN ".DB_PREFIX."promo_products pp ON o.pid = pp.prid AND pp.pid = ".intval($promoCampaignId)."
			WHERE o.oid = ".intval($oid)." AND (pp.pid IS NOT NULL OR pc.pid IS NOT NULL)
			GROUP BY o.pid
		");
	}

	/**
	 * Return query
	 *
	 * @return string
	 */
	protected function getActivePromoCodeQuery()
	{
		return "SELECT * FROM ".DB_PREFIX."promo_codes WHERE date_start <= NOW() AND date_stop >= NOW() AND is_active='Yes'";
	}
}
