<?php
/**
 * Provides mechanism to set message and retrieve it later
 */
class FlashMessages
{
	protected $sessionVarName = "FlashMessageStorage";
	
	/**
	 * Class constructor
	 * @param mixed $messages 
	 */
	public function __construct($messages = null)
	{
		if (!is_null($messages)) $this->setMessages($messages);
		return $this;
	}
	
	/**
	 * Set message to be returned in getMessage function
	 * @param mixed $messages 
	 */
	public function setMessages($messages)
	{
		$newMessages = (array)$messages;
		
		$currentMessages = $this->getMessages(false);
		$currentMessages = is_null($currentMessages) ? array() : $currentMessages;
		
		// had issue with array_merge keys overlapping. this is why doing manually
		foreach ($newMessages as $newMessage)
		{
			$currentMessages[] =  $newMessage;
		}
		
		$_SESSION[$this->sessionVarName] = $currentMessages;
	}
	
	/**
	 * Returns messages set int setMessages function and remove thems when needed
	 * @param boolean $cleanUp
	 * @return mixed 
	 */
	public function getMessages($cleanUp = true)
	{
		$messages = isset($_SESSION[$this->sessionVarName]) ? $_SESSION[$this->sessionVarName] : null;
		
		if ($cleanUp && !is_null($messages)) unset($_SESSION[$this->sessionVarName]);
		
		return $messages;
	}
}