<?php

class Payment_Bongo_BongoUtil
{
	/**
	 * Filter shipping method to be used with Bongo
	 *
	 * @param $shippingMethods
	 * @param $bongoShippingMethod
	 * @param $msg
	 *
	 * @return mixed
	 */
	public static function filterShippingMethods($shippingMethods, $bongoShippingMethod, &$msg)
	{
		$cheapestMethod = null;
		$cheapestMethodRate = INF;

		$defaultMethod = null;

		foreach ($shippingMethods['shipping_methods'] as $shippingMethod)
		{
			if ($shippingMethod['ssid'] == $bongoShippingMethod)
			{
				$defaultMethod = $shippingMethod;
			}

			if ($shippingMethod['shipping_price'] < $cheapestMethodRate)
			{
				$cheapestMethod = $shippingMethod;
				$cheapestMethodRate = $shippingMethod['shipping_price'];
			}
		}

		if ($bongoShippingMethod == 'auto')
		{
			if (!is_null($cheapestMethod))
			{
				$cheapestMethod['carrier_name'] = $cheapestMethod['method_name'] = $msg['shipping']['international_shipping'];
				$shippingMethods['shipping_methods'] = array($cheapestMethod);
			}
		}
		else
		{
			if (!is_null($defaultMethod))
			{
				$defaultMethod['carrier_name'] = $defaultMethod['method_name'] = $msg['shipping']['international_shipping'];
				$shippingMethods['shipping_methods'] = array($defaultMethod);
			}
			else if (!is_null($cheapestMethod))
			{
				$cheapestMethod['carrier_name'] = $cheapestMethod['method_name'] = $msg['shipping']['international_shipping'];
				$shippingMethods['shipping_methods'] = array($cheapestMethod);
			}
		}

		// TODO: determinate what to do when there no shipping methods found

		return $shippingMethods;
	}
}