<?php

class Shipping_Provider
{
	protected $defaultCurrency = 'USD';
	protected $currencyExchangeRates = array();
	
	/**
	 * Set default currency
	 * @param string $defaultCurrency
	 */
	public function setDefaultCurrency($defaultCurrency)
	{
		$this->defaultCurrency = $defaultCurrency;
	}
	
	/**
	 * Set currency exchange rates
	 * @param array $currencyExchangeRates 
	 */
	public function setCurrencyExchangeRates($currencyExchangeRates)
	{
		$this->currencyExchangeRates = $currencyExchangeRates;
	}
	
	/**
	 * Get amount in defautl currency
	 * @param type $currency
	 * @param type $amount
	 * @return type 
	 */
	protected function getAmountInDefaultCurrency($currency, $amount)
	{
		if ($currency == $this->defaultCurrency) return $amount;
		
		if (isset($this->currencyExchangeRates[$currency]))
		{
			return (float) $amount / $this->currencyExchangeRates[$currency];
		}
		
		// TODO: possibly trow error or return null?
		return $amount;
	}
}