<?php 

/**
 * @class ShoppingCartCatalog
 */
 
class ShoppingCartCatalog{
	public $db;
	public $catalog_images_dir = "images/catalog";
	public $tree = array();
	
	/* CONSTRUCTOR
	*/
	function ShoppingCartCatalog(&$db){
		$this->db = $db;
		return false;
	}
	
	/* Get Category data by ID
	*/
	function getCategoryById($id, $get_subcats = true){
		if($id){
			$this->db->query("SELECT *, IF(url_custom='',url_default,url_custom) AS url FROM ".DB_PREFIX."catalog WHERE cid ='".$id."' AND is_visible='Yes'");
			if($this->db->moveNext()){
				$data = $this->db->col;
				$data["url"] = getCatalogUrl($data["url"], $data["cid"]);
				// get subcats
				if($data["list_subcats"] == "Yes"){
					$data["subcategories"] = $this->getSubCategoriesById($id);
				}
				else{
					$data["subcategories"] = false;
				}
				// check image here
				$f = $this->catalog_images_dir."/category".$id.".";
				if(file_exists($f."jpg")){
					$data["img"] = $f."jpg";
				}
				elseif(file_exists($f."png")){
					$data["img"] =  $f."png";
				}
				elseif(file_exists($f."gif")){
					$data["img"] =  $f."gif";
				}
				else{
					$data["img"] = false;
				}
				// check image in thumbs folder by mahesh on 19 Dec 2011
				$t = $this->catalog_images_dir."/thumbs/category".$id.".";
				if(file_exists($t."jpg")){
					$data["img_thumb"] = $t."jpg";
				}
				elseif(file_exists($t."png")){
					$data["img_thumb"] =  $t."png";
				}
				elseif(file_exists($t."gif")){
					$data["img_thumb"] =  $t."gif";
				}
				else{
					$data["img_thumb"] = false;
				}
				
				
				$t = $this->catalog_images_dir."/carousel/thumbs_category".$id.".";
				if(file_exists($t."jpg")){
					$data["cimg_thumb"] = $t."jpg";
				}
				elseif(file_exists($t."png")){
					$data["cimg_thumb"] =  $t."png";
				}
				elseif(file_exists($t."gif")){
					$data["cimg_thumb"] =  $t."gif";
				}
				else{
					$data["cimg_thumb"] = false;
				}
				
				//     -------  end    -------   //
				
				return $data;
			}
		}
		return false;
	}
	
	/* Return direct subcategories for selected category
	*/
	function getSubCategoriesById($id){
		if($id == 0)
			$this->db->query("SELECT cid,parent FROM ".DB_PREFIX."catalog WHERE is_visible='Yes' AND (parent='1' OR parent='2') GROUP BY name");
		else
			$this->db->query("SELECT cid,parent FROM ".DB_PREFIX."catalog WHERE parent='".$id."' AND is_visible='Yes' ORDER BY priority, name");
			
		if($this->db->numRows() > 0){
			$subcats = $this->db->getRecords();
			for($i = 0; $i < count ($subcats); $i++){
				$subcats[$i] = $this->getCategoryById($subcats[$i]["cid"], false);
			}
			return $subcats;
		}
		else{
			return false;
		}
	}
	
	
	
	
	// 2010-07-10 pkolas display number of products in each category
	// this might be bad for performance, but the client wants count next to each category.. so be it.
	function pkUpdateProductCount() {
		$this->db->reset();
		$this->db->query("
			SELECT `cid`
			FROM `".DB_PREFIX."catalog`
			WHERE `parent` = 0
		");
		while ($this->db->movenext()) {
			$this->pkUpdateProductCount2($this->db->col['cid']);
		}
	}
	function pkUpdateProductCount2($cid) {
		if (is_array($this->tree[$cid]["children"])){
			foreach($this->tree[$cid]["children"] as $child_id=>$child_data){
				$this->tree[$cid]["pk_product_ids"] = array_merge($this->tree[$cid]["pk_product_ids"], $this->pkUpdateProductCount2($child_id));
			}
			$this->tree[$cid]['pk_product_ids'] = array_unique($this->tree[$cid]['pk_product_ids']);
		}
		
		if(isset($_SESSION['UserID']))
		{
			$this->db->query("SELECT level FROM ".DB_PREFIX."users WHERE uid= ".$_SESSION['UserID']);
			if ($this->db->numRows() > 0)
			{
			$result = $this->db->getRecords();
			$level = $result[0]['level'];
			}
		}
		if($level==100 || $level==200)
		{}
		else
		{
			$this->db->reset();
			$this->db->query("
				SELECT `pid`
				FROM `".DB_PREFIX."products`
				WHERE is_private = 1 
			");
			while ($this->db->movenext()) {
				if(($key = array_search($this->db->col['pid'], $this->tree[$cid]['pk_product_ids'])) !== false) {
					unset($this->tree[$cid]['pk_product_ids'][$key]);
				}
			}
		}
		
		//echo "<pre>";
		//print_r($this->tree[$cid]['pk_product_ids']);
		$this->tree[$cid]['pk_num_products'] = count($this->tree[$cid]['pk_product_ids']);
		return $this->tree[$cid]['pk_product_ids'];
	}
	// 2010-07-10 pkolas end
	
	
	
	
	
	
	
	/**
	 * returns parse categories tree
	 *
	 * @param int $category_id
	 * @return array
	 */
	//function getParsedTree($category_id=0){
	function getParsedTree($category_id=0, $is_visible=false){   // Modified by latha to not to dispay invisible categories
		
		// 2010-07-10 pkolas display number of items in each category
		$sql = "
			SELECT `products_categories`.`cid`, `products_categories`.`pid`	
			FROM `products_categories` 
				INNER JOIN `products` ON `products_categories`.`pid` = `products`.`pid`
			WHERE `products`.`is_visible` = 'Yes' and products.product_status='approved'
		";
		$this->db->reset();
		$this->db->query($sql);
		$pk_product_ids = array();
		while ($this->db->movenext()) {
			if (!isset($pk_product_ids[$this->db->col['cid']])) {
				$pk_product_ids[$this->db->col['cid']] = array();
			}
			$pk_product_ids[$this->db->col['cid']][] = $this->db->col['pid'];
		}
		$this->db->reset();
		// 2010-07-10 pkolas end
		
		$this->tree = array();
				//$this->db->query("SELECT cid, parent, level, is_visible, key_name, name, IF(url_custom='',url_default,url_custom) AS url FROM ".DB_PREFIX."catalog ORDER BY level, priority, name"); 
		//		Modified by latha to not to dispay invisible categories
		$sql = "SELECT cid, parent, level, is_visible, key_name, name, IF(url_custom='',url_default,url_custom) AS url FROM ".DB_PREFIX."catalog";
		if ($is_visible)
		{
			$sql .= " WHERE is_visible = 'Yes'";
		}
		$sql .= " ORDER BY level, priority, name";

		$this->db->query($sql);	
		if($this->db->numRows()>0){
			while($this->db->moveNext()){
				
				$cid = $this->db->col["cid"];
				$parent = $this->db->col["parent"];
				
				$this->tree[$cid] =	array(
					"cid"=>$cid,
					"parent"=>$parent,
					"level"=>$this->db->col["level"],
					"is_visible"=>$this->db->col["is_visible"],
					"key_name"=>$this->db->col["key_name"],
					"name"=>$this->db->col["name"],
					"children"=>false,
					"category_url"=>getCatalogUrl($this->db->col["url"], $cid)
					
					// 2010-07-10 pkolas display number of items in each category
					, 'pk_product_ids' => (isset($pk_product_ids[$cid]) ? $pk_product_ids[$cid] : array())
					// 2010-07-10 pkolas end
					
				);
				
				if(array_key_exists($parent, $this->tree) && $this->tree[$parent] > 0){
					$this->tree[$parent]["children"][$cid] = &$this->tree[$cid];
				}
			}
			//prepare tree -- levels
			foreach ($this->tree as $id=>$node)
			{
				$level = 0;
				$n = $node;
				$j = 0;
				for ($j = 0; $j<count($this->tree); $j++)
				{
					if ($n["parent"] > 0 && array_key_exists($n["parent"], $this->tree))
					{
						$n = $this->tree[$n["parent"]];
					}
					else
					{
						break;
					}
				}
				$this->tree[$id]["level"] = $j + 1;
				$this->tree[$id]["alevel"] = $this->tree[$id]["level"]>1?array_fill(0, $this->tree[$id]["level"]-1, 1):false;
				$this->tree[$id]["open"] = false;
				
				if ($id == $category_id)
				{
				//echo $category_id; 
					$_id = $id;
					$this->tree[$_id]["open"] = true;
					//print_r(count($this->tree));
					for ($i=0; $i<count($this->tree); $i++)
					{
						if ($this->tree[$_id]["parent"] > 0)
						{
							$_id = $this->tree[$_id]["parent"];
							$this->tree[$_id]["open"] = true;
						}
						else
						{
							break;
						}
					}
				}
			}
			//print_r(count($this->tree)); die();
			
			// 2010-07-10 pkolas display product count
			$this->pkUpdateProductCount();
			//echo $this->pkUpdateProductCount();
			// 2010-07-10 end
			//print_r($this->tree);
			return $this->tree;
		}
		else
		{	
			return false;
		}
	}
	
	/**
	 * returns parse categories new tree
	 *
	 * @param int $category_id
	 * @return array
	 */
	 function getParsedTreeSub($category_id=array()){	
		//print_r($category_id[0]);  die(); 
		if($category_id)
			$sql = "WHERE ptic_is_visible='yes' AND (ptic_parent=";
		else
			$sql = "";
		$j=1;
		//echo $category_id[0];
		for($i=0;$i<count($category_id);$i++)
		{
			if($j==1){
				$sql .= $category_id[$i];
			}
			else
			{
				$sql .= " OR ptic_parent=".$category_id[$i];
			}
			$j++;
		}			
		//echo $sql; die();
		//echo("SELECT ptic_id, ptic_parent, ptic_level, ptic_is_visible, ptic_key_name, ptic_name FROM ".DB_PREFIX."PTIC_catalog ".$sql.") ORDER BY ptic_level, ptic_priority, ptic_name");
		$this->tree = array();		
		$this->db->query("SELECT ptic_id, ptic_parent, ptic_level, ptic_is_visible, ptic_key_name, ptic_name FROM ".DB_PREFIX."PTIC_catalog ".$sql.") ORDER BY ptic_level, ptic_priority, ptic_name");
		
		//echo("SELECT ptic_id, ptic_parent, ptic_level, ptic_is_visible, ptic_key_name, ptic_name FROM ".DB_PREFIX."PTIC_catalog ".$sql.") ORDER BY ptic_level, ptic_priority, ptic_name"); die();
		
		if($this->db->numRows()>0){
			while($this->db->moveNext()){
				
				$cid = $this->db->col["ptic_id"];
				$parent = $this->db->col["ptic_parent"];
				
				$this->tree[$cid] =	array(
					"ptic_id"=>$cid,
					"ptic_parent"=>$parent,
					"ptic_level"=>$this->db->col["ptic_level"],
					"ptic_is_visible"=>$this->db->col["ptic_is_visible"],
					"ptic_key_name"=>$this->db->col["ptic_key_name"],
					"ptic_name"=>$this->db->col["ptic_name"],
					"children"=>false
				);
			}
			
		return $this->tree;
		}
		else
		{	
			return false;
		}
	}
	function getParsedTreeNew($category_id=0){
	
		$this->tree = array();
		$this->db->query("SELECT ptic_id, ptic_parent, ptic_level, ptic_is_visible, ptic_key_name, ptic_name FROM ".DB_PREFIX."PTIC_catalog ORDER BY ptic_level, ptic_priority, ptic_name");
		if($this->db->numRows()>0){
			while($this->db->moveNext()){
				
				$cid = $this->db->col["ptic_id"];
				$parent = $this->db->col["ptic_parent"];
				
				$this->tree[$cid] =	array(
					"ptic_id"=>$cid,
					"ptic_parent"=>$parent,
					"ptic_level"=>$this->db->col["ptic_level"],
					"ptic_is_visible"=>$this->db->col["ptic_is_visible"],
					"ptic_key_name"=>$this->db->col["ptic_key_name"],
					"ptic_name"=>$this->db->col["ptic_name"],
					"children"=>false
				);
				
				if(array_key_exists($parent, $this->tree) && $this->tree[$parent] > 0){
					$this->tree[$parent]["children"][$cid] = &$this->tree[$cid];
				}
			}
			//prepare tree -- levels
			foreach ($this->tree as $id=>$node)
			{
				$level = 0;
				$n = $node;
				$j = 0;
				for ($j = 0; $j<count($this->tree); $j++)
				{
					if ($n["ptic_parent"] > 0 && array_key_exists($n["ptic_parent"], $this->tree))
					{
						$n = $this->tree[$n["ptic_parent"]];
					}
					else
					{
						break;
					}
				}
				$this->tree[$id]["ptic_level"] = $j + 1;
				$this->tree[$id]["alevel"] = $this->tree[$id]["ptic_level"]>1?array_fill(0, $this->tree[$id]["ptic_level"]-1, 1):false;
				$this->tree[$id]["open"] = false;
				
				if ($id == $category_id)
				{
					$_id = $id;
					$this->tree[$_id]["open"] = true;
					for ($i=0; $i<count($this->tree); $i++)
					{
						if ($this->tree[$_id]["ptic_parent"] > 0)
						{
							$_id = $this->tree[$_id]["ptic_parent"];
							$this->tree[$_id]["open"] = true;
						}
						else
						{
							break;
						}
					}
				}
			}
			return $this->tree;
		}
		else
		{	
			return false;
		}
	
	}
	/**
	 * Scans all nested children and set to parent category
	 *
	 * @param int $category_id
	 */
	function setCategoryNestedChildrenIds($category_id = 0){
		if(array_key_exists($category_id, $this->tree)){
			$this->tree[$category_id]["nested"] = array($category_id);
			$this->setCategoryNestedChildrenIds2($category_id, $category_id);
		}
	}
	
	/**
	 * Real scan function for setCategoryNestedChildrenIds
	 *
	 * @param int $parent_id
	 * @param int $category_id
	 */
	function setCategoryNestedChildrenIds2($parent_id, $category_id){
		if(is_array($this->tree[$parent_id]["children"])){
			foreach($this->tree[$parent_id]["children"] as $child_id=>$child_data){
				$this->tree[$category_id]["nested"][] = $child_id;
				$this->setCategoryNestedChildrenIds2($child_id, $category_id);
			}
		}
	}
	
	/**
	 * get parsed tree path from category_id node to top
	 *
	 * @param int $category_id
	 * @return array
	 */
	function getParsedPath($category_id){
		if(array_key_exists($category_id, $this->tree)){
			$parsed_path = array();
			$_category_id = $category_id;
			for($i=0; $i<count($this->tree); $i++){
				$node = $this->tree[$_category_id];
				$parsed_path[] = array("href"=>$node["category_url"], "caption"=>$node["name"]);
				if($node["parent"] > 0){
					$_category_id = $node["parent"];
				}
				else{
					break;
				}	
			}
			return array_reverse($parsed_path);
		}
		else{
			return false;
		}
	}


        function getCategories_home(){
		$this->db->query("SELECT cid FROM ".DB_PREFIX."catalog WHERE home='Active' AND is_visible='Yes' ORDER BY carousel_priority, name");
		if($this->db->numRows() > 0){
			$subcats = $this->db->getRecords();
			for($i = 0; $i < count ($subcats); $i++){
				$subcats[$i] = $this->getCategoryById($subcats[$i]["cid"], false);
			}
			return $subcats;
		}
		else{
			return false;
		}
	}

}
?>
