<?php
/**
 * 
 */
class Payment_Profile
{
	/**
	 * 
	 */
	public function getPaymentProfiles($db, $user, $active = true)
	{
		$db->query("SELECT upp.*, pm.id, pm.class FROM ".DB_PREFIX."users_payment_profiles upp
			INNER JOIN ".DB_PREFIX."payment_methods pm ON upp.pid = pm.pid AND pm.active='Yes' WHERE upp.uid=".$db->escape($user->id)."
			ORDER BY pm.id, upp.is_primary asc, upp.usid");
	
		$profiles = array();
		$lastClassName = '';
		$results = $db->getRecords();
		foreach ($results as $result_col)
		{
			if ($result_col['class'] != '')
			{
				if ($result_col['class'] != $lastClassName)
				{
					$gw_temp = $this->loadGateway($result_col['class'], $result_col['id']);
				}

				$profile = $this->parseProfile($db, $result_col, $gw_temp, $active);

				if ($profile)
				{
					$profiles[] = $profile;
				}
			}
		}
		return $profiles;
	}

	/**
	 * 
	 */
	public function getPaymentProfile($db, $user, $ext_profile_id, $active = true)
	{
		$db->query("SELECT upp.*, pm.id, pm.class FROM ".DB_PREFIX."users_payment_profiles upp
			INNER JOIN ".DB_PREFIX."payment_methods pm ON upp.pid = pm.pid AND pm.active='Yes' WHERE upp.uid=".$db->escape($user->id)."
			AND upp.ext_profile_id='".$db->escape($ext_profile_id)."'
			ORDER BY pm.id, upp.is_primary asc, upp.usid");

		$results = $db->getRecords();
		if (count($results) > 0)
		{
			$result_col = $results[0];

			$gw_temp = $this->loadGateway($result_col['class'], $result_col['id']);
			
			return $this->parseProfile($db, $result_col, $gw_temp, $active);
		}
		return null;
	}

	/**
	 * Get payment profile by internal database id
	 */
	public function getPaymentProfileById($db, $user, $profile_id, $active = true)
	{
		$db->query("SELECT upp.*, pm.id, pm.class FROM ".DB_PREFIX."users_payment_profiles upp
			INNER JOIN ".DB_PREFIX."payment_methods pm ON upp.pid = pm.pid AND pm.active='Yes' WHERE upp.uid=".$db->escape($user->id)."
			AND upp.usid='".$db->escape($profile_id)."'
			ORDER BY pm.id, upp.is_primary asc, upp.usid");

		$results = $db->getRecords();
		if (count($results) > 0)
		{
			$result_col = $results[0];

			$gw_temp = $this->loadGateway($result_col['class'], $result_col['id']);
			
			return $this->parseProfile($db, $result_col, $gw_temp, $active);
		}
		return null;
	}
	
	/**
	 *
	 * @param type $db
	 * @param type $result_col
	 * @param type $gw_temp
	 * @param type $active
	 * @return type 
	 */
	private function parseProfile($db, $result_col, $gw_temp, $active = true)
	{
		$temp = array(
			'ext_profile_id' => $result_col['ext_profile_id'],
			'is_primary' => $result_col['is_primary'] == 'Yes',
			'usid' => $result_col['usid'],
			'pid' => $result_col['pid'],
			'uid' => $result_col['uid'],
		);

		$profile = $gw_temp->getPaymentProfileDetails($db, $result_col['ext_profile_id'], $active);

		if ($profile)
		{
			$profile['cc_number'] = $this->maskCCNum($profile['cc_number']);
			$temp['data'] = $profile;

			return $temp;
		}

		return null;
	}

	/**
	 *
	 * @param type $class
	 * @param type $id
	 * @return class 
	 */
	private function loadGateway($class, $id)
	{
		require_once('content/engine/payment/payment_'.$id.'.php');
		$gw_temp = new $class;

		return $gw_temp;
	}
	
	/**
	 *
	 * @param type $db
	 * @return type 
	 */
	public function getDefaultPaymentMethodId($db)
	{
		$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE active='Yes' ORDER BY priority");
		while ($db->moveNext())
		{
			if ($db->col['class'] != '')
			{
				require_once('content/engine/payment/payment_'.$db->col['id'].'.php');
				$gw_temp = new $db->col['class'];
				if ($gw_temp->supportsPaymentProfiles())
				{
					return $db->col['pid'];
					break;
				}
			}
		}
		return null;
	}

	/**
	 *
	 * @param type $cc_number
	 * @return type 
	 */
	public function maskCCNum($cc_number)
	{
		return str_pad('', 12, 'X').substr($cc_number, 12, 4);
	}

	/**
	 *
	 * @param type $db
	 * @param type $user
	 * @param type $ext_profile_id
	 * @return type 
	 */
	public function setBillingInformation($db, $user, $ext_profile_id)
	{
		$profile = $this->getPaymentProfile($db, $user, $ext_profile_id);
		if ($profile)
		{
			$billingForm = $user->getBillingInfo();
			$customFieldsData = array();

			//TODO: Does the form need fname and lname?
			//$billingForm['fname'] = $profile['data']['fname'];
			//$billingForm['lname'] = $profile['data']['lname'];
			$billingForm['address1'] = $profile['data']['address1'];
			$billingForm['address2'] = $profile['data']['address2'];
			$billingForm['city'] = $profile['data']['city'];
			$billingForm['state'] = $profile['data']['state_id'];
			$billingForm['country'] = $profile['data']['country_id'];
			$billingForm['zip'] = $profile['data']['zip'];
			$billingForm['phone'] = $profile['data']['phone'];

			return $user->updateBillingInfo($billingForm, $cutomFieldData);
		}

		$user->errors[] = 'Payment method not found';
		return false;
	}
}