<?php 

/**
 * @class ShoppingCartProducts 
 */
class ShoppingCartProducts
{
	var $db;
	var $settings;
	var $items_count = 0;
	var $pages_count = 0;
	var $current_page = 0;
	var $bestsellersCount = 0;
	var $productImages = array();
	var $productImagesPath = "images/products/";
	var $productThumbsPath = "images/products/thumbs/";
	var $productThumbs2Path = "images/products/preview/";
	var $parent = "0";
	var $taxRates = array("0"=>array("multiplier"=>1, "tax_rate"=>0, "description"=>""));
	var $resultantarray = array();

	/**
	 * Constructor
	 * @param $db
	 * @param $settings
	 */
	function ShoppingCartProducts(&$db, &$settings)
	{
		//assign DB & settings
		$this->db = $db;
		$this->settings = $settings;
		return $this;
	}

	/**
	 * Get Product Image
	 *
	 * @param string $product_id
	 * @param string $image_location
	 * @param string $image_url
	 * @return string image path
	 */
	function getProductImage($product_id, $image_location, $image_url)
	{
		$product_id = strtolower($product_id);
		if ($image_location == "Web" && $image_url != "")
		{
			if ($_SERVER["SERVER_PORT"] == 443)
			{
				return str_replace('http://', 'https://', $image_url);//substr($image_url, 0, 5) == "https" ? $image_url : str;
			}
			else
			{
				return $image_url;
			}
		}
		else
		{
			for($k=0; $k<strlen($product_id); $k++)
			{
				if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "_";
			}
			if (is_file($this->productImagesPath.$product_id.".jpg"))
			{
				return $this->productImagesPath.$product_id.".jpg";
			}
			if (is_file($this->productImagesPath.$product_id.".gif"))
			{
				return $this->productImagesPath.$product_id.".gif";
			}
			if (is_file($this->productImagesPath.$product_id.".png"))
			{
				return $this->productImagesPath.$product_id.".png";
			}
		}
		return false;
	}
	
	/**
	 * Get Product Thumb
	 *
	 * @param string $product_id
	 * @param string $image_location
	 * @param string $image_url
	 * @return string thumb path
	 */
	function getProductThumb($product_id, $image_location, $image_url)
	{
		$product_id = strtolower($product_id);
		if ($image_location == "Web" && $image_url != "")
		{
			if ($_SERVER["SERVER_PORT"] == 443)
			{
				//return substr($image_url, 0, 5) == "https" ? $image_url : false;
				return str_replace('http://', 'https://', $image_url);
			}
			else
			{
				return $image_url;
			}
		}
		else
		{
			for ($k=0; $k<strlen($product_id); $k++)
			{
				if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "_";
			}
			if (is_file($this->productThumbsPath.$product_id.".jpg"))
			{
				return $this->productThumbsPath.$product_id.".jpg";
			}
			if (is_file($this->productThumbsPath.$product_id.".png"))
			{
				return $this->productThumbsPath.$product_id.".png";
			}
			if (is_file($this->productThumbsPath.$product_id.".gif"))
			{
				return $this->productThumbsPath.$product_id.".gif";;
			}
		}
		return false;
	}
	
	/**
	 * Get Product Thumb2
	 *
	 * @param string $product_id
	 * @param string $image_location
	 * @param string $image_url
	 * @return string thumb path
	 */
	function getProductThumb2($product_id, $image_location, $image_url){
		$product_id = strtolower($product_id);
		if($image_location == "Web" && $image_url != ""){
			return $image_url;
		}
		else{
			for($k=0; $k<strlen($product_id); $k++){
				if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "_";
			}
			if(is_file($this->productThumbs2Path.$product_id.".jpg")){
				return $this->productThumbs2Path.$product_id.".jpg";
			}
			if(is_file($this->productThumbs2Path.$product_id.".png")){
				return $this->productThumbs2Path.$product_id.".png";
			}
			if(is_file($this->productThumbs2Path.$product_id.".gif")){
				return $this->productThumbs2Path.$product_id.".gif";;
			}
		}
		return false;
	}
	
	

	function getProductByIdB($id, $level, $parent = 0)
	{
		global $settings;
			
		$r = $this->db->query("
			SELECT 
				".DB_PREFIX."products.*,
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
				IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url, 
				".DB_PREFIX."catalog.cid AS cat_id,
				".DB_PREFIX."catalog.name AS cat_name,  
				".DB_PREFIX."manufacturers.manufacturer_name AS manufacturer_name
			FROM ".DB_PREFIX."products
			INNER JOIN ".DB_PREFIX."catalog ON ".($parent > 0 ? " ".DB_PREFIX."catalog.cid='".intval($parent)."' " : " ".DB_PREFIX."products.cid = ".DB_PREFIX."catalog.cid ")."
			LEFT JOIN ".DB_PREFIX."manufacturers ON ".DB_PREFIX."products.manufacturer_id = ".DB_PREFIX."manufacturers.manufacturer_id AND ".DB_PREFIX."manufacturers.is_visible='1'
			WHERE ".DB_PREFIX."products.pid='".intval($id)."' AND ".$this->_getInventorySql()."
		");
	
		if ($this->db->moveNext($r, MYSQL_ASSOC))
		{
			$product = $this->db->col;
			
			$product["price_no_tax"] = $product["price"];
			$product["price2_no_tax"] = $product["price2"];
			
			if ($settings["DisplayPricesWithTax"] == "YES" && $product["is_taxable"] == "Yes")
			{
				$_price = $product["price"];
				$_price2 = $product["price2"];
				$_tax_rate = -1;
				if ($product["tax_rate"] >= 0)
				{
					$_price = $_price + ($_price / 100 * $product["tax_rate"]);
					$_price2 = $_price2 + ($_price2 / 100 * $product["tax_rate"]);
					$_tax_rate = $product["tax_rate"];
				}
				elseif(array_key_exists($product["tax_class_id"], $this->taxRates))
				{
					$_price = $_price * $this->taxRates[$product["tax_class_id"]]["multiplier"];
					$_price2 = $_price2 * $this->taxRates[$product["tax_class_id"]]["multiplier"];
					$_tax_rate = $this->taxRates[$product["tax_class_id"]]["tax_rate"];
				}
				$product["price"] = $_price;
				$product["price2"] = $_price2;
				$product["tax_rate"] = $_tax_rate;
			}
			
			//url
			$product["url"] = getProductUrl($product["product_url"], $product["pid"], $product["cid"]);
			$product["print_url"] = $this->settings["GlobalHttpUrl"]."/".$this->settings["INDEX"]."?p=product&amp;id=".intval($product["pid"])."&amp;parent=".intval($product["cid"])."&amp;is_print_version=true";
			$product["cat_url"] = getCatalogUrl($product["cat_url"], $product["cat_id"]);
			
			//inventory, min / max order
			if ($product["inventory_control"] == "Yes" || $product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc")
			{
				$product["allowed_max"] = $product["max_order"] > 0 ? ($product["max_order"] > $product["stock"] ? $product["stock"] : $product["max_order"]) : $product["stock"];
			}
			else
			{
				$product["allowed_max"] = 0;
			}
			
			
			//product primary image & thumb
			$product["image"] = $this->getProductImage($product["product_id"], $product["image_location"], $product["image_url"]);
			$product["thumb"] = $this->getProductThumb($product["product_id"], $product["image_location"], $product["image_url"]);
			$product["preview"] = $this->getProductThumb2($product["product_id"], $product["image_location"], $product["image_url"]);
			
			if ($product["image"])
			{
				if ($product["image_location"] == "Local")
				{
					$img_data = @getimagesize($product["image"]);
					if ($img_data)
					{
						$product["image_width"] = $img_data[0];
						$product["image_height"] = $img_data[1];
						$product["image_size"] = $img_data[3];
					}
					$product["product_page_image_url"]  = $product["preview"] ? $product["preview"] : $product["image"];
				}
				else
				{
					$product["product_page_image_url"] = $product["image_url"];
					$product["image_size"] = "";
				}
			}
			
			//get secondary images
			$this->db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".intval($id)."' AND is_visible='Yes' ORDER BY image_priority DESC");
			//$product["secondary_images"] = $this->db->numRows()>0?$this->db->getRecords():false;
			if ($this->db->numRows() > 0)
			{
				$product["secondary_images"] = $this->db->getRecords();
				for ($i=0; $i<count($product["secondary_images"]); $i++)
				{
					$product["secondary_images"][$i]["img_src"] = "images/products/secondary/".$product["secondary_images"][$i]["filename"].".".$product["secondary_images"][$i]["type"];
					$tf = "images/products/secondary/thumbs/".$product["secondary_images"][$i]["filename"].".jpg";
					$product["secondary_images"][$i]["thumb_src"] = file_exists($tf)?$tf:false;
					//$product["secondary_images"][$i]["type"] = file_exists($tf)?$tf:false;
					if (!$product["secondary_images"][$i]["thumb_src"])
					{
						$product["secondary_images"][$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
					}
					else
					{
						$product["secondary_images"][$i]["thumb_size"] = '';
					}
				}
				
				$formats = explode(",", VIDEO_FORMAT);
				$product["videos"] = array();
				foreach( $product["secondary_images"] as $key =>  $each )
				{
					if( in_array($each["type"], $formats ) )
					{
						array_push($product["videos"], $each);	
						unset($product["secondary_images"][$key]);		
					}
				}
			}
			else
			{
				$product["secondary_images"] = false;
			}
			
			if ($product["attributes_count"] > 0)
			{
				//get attributes
				$this->db->query("
					SELECT * FROM ".DB_PREFIX."products_attributes
					WHERE ".DB_PREFIX."products_attributes.pid = '".intval($id)."' AND is_active='Yes'
					ORDER BY priority, name, is_modifier
				");
				while ($this->db->moveNext())
				{
					$attribute = $this->db->col;
					$attribute["options"] = array();
					parseOptions($this->db->col["options"], $product["price_no_tax"], $product["weight"], $attribute["options"]);
					$product["attributes"][$this->db->col["paid"]] = $attribute;
				}
			}
			
			$product["price_wholesale"] = $product["price"];
			if ($this->settings["WholesaleDiscountType"] == "PRODUCT")
			{
				if ($level > 0 && $product["price_level_1"] > 0 && $this->settings["WholesaleMaxLevels"] > 0) $product["price_wholesale"] = $product["price_level_1"];
				if ($level > 1 && $product["price_level_2"] > 0 && $this->settings["WholesaleMaxLevels"] > 1) $product["price_wholesale"] = $product["price_level_2"];
				if ($level > 2 && $product["price_level_3"] > 0 && $this->settings["WholesaleMaxLevels"] > 2) $product["price_wholesale"] = $product["price_level_3"];
			}
			if ($this->settings["WholesaleDiscountType"] == "GLOBAL")
			{
				if($level > 0 && $this->settings["WholesaleMaxLevels"] > 0) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount1"]);
				if($level > 1 && $this->settings["WholesaleMaxLevels"] > 1) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount2"]);
				if($level > 2 && $this->settings["WholesaleMaxLevels"] > 2) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount3"]);
			}
			
			$this->db->query("SELECT * FROM ".DB_PREFIX."products_quantity_discounts WHERE pid = '".intval($id)."' AND is_active = 'Yes' ORDER BY range_min");
			$product["quantity_discounts"] = array();
			while ($this->db->moveNext())
			{
				if (($this->db->col["apply_to_wholesale"] == "Yes" && $level > 0) || ($level < 1))
				{
					$iii = count($product["quantity_discounts"]);
					$product["quantity_discounts"][$iii] = $this->db->col;
					
					$product["quantity_discounts"][$iii]["discount"] = (strtolower($product["quantity_discounts"][$iii]["discount_type"]) == 'percent')
						? round((float) $product["quantity_discounts"][$iii]["discount"], 2)
						: $product["quantity_discounts"][$iii]["discount"];
				}
			}
			$product["quantity_discounts"] = count($product["quantity_discounts"])>0?$product["quantity_discounts"]:false;
			
			if (($product["inventory_control"] == "Yes" || $product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc") && 
				$product["inventory_rule"] == "OutOfStock" && 
				intval($product["stock"]) === 0
			){
				$product["out_of_stock"] = 1;
			}
			else
			{
				$product["out_of_stock"] = 0;
			}
			
			if ($product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc")
			{
				$this->db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pid='".intval($id)."' AND is_active=1");
				if ($this->db->numRows() > 0)
				{
					$product["inventory_hashes"] = $this->db->getRecords();
				}
				else
				{
					$product["inventory_hashes"] = false;
				}
			}
			
			//get product shipping price
			if ($product["is_dollar_days"] == "Yes")
			{
				$dollar_days_shipping_percent = 15;
				$dollar_days_shipping_min_amount = 6.95;
				
				$product["shipping_price"] = array();
				$product["shipping_price"][] = array(
					"method_name" => "Dollar Days Shipping",
					"price" => $product["price"] / 100 * $dollar_days_shipping_percent
				);
			}
			else
			{
				$this->db->query("
					SELECT 
						".DB_PREFIX."products_shipping_price.price,
						".DB_PREFIX."shipping_selected.method_name
					FROM ".DB_PREFIX."products_shipping_price
					INNER JOIN ".DB_PREFIX."shipping_selected ON ".DB_PREFIX."products_shipping_price.ssid = ".DB_PREFIX."shipping_selected.ssid
					WHERE ".DB_PREFIX."products_shipping_price.pid='".intval($id)."' AND ".DB_PREFIX."products_shipping_price.is_price='Yes' 
				");
				if ($this->db->numRows())
				{
					$product["shipping_price"] = array();
					while ($this->db->moveNext())
					{
						$product["shipping_price"][] = array(
							"method_name" => $this->db->col["method_name"],
							"price" => $this->db->col["price"]
						);
					}
				}
				else
				{
					$product["shipping_price"] = false;
				}
			}
			
			//manufacturer image begins here
			$manufacturer_image = "images/manufacturers/".$product["manufacturer_id"];
			if (file_exists($manufacturer_image.".jpg"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".jpg";
			}
			elseif (file_exists($manufacturer_image.".gif"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".gif";
			}
			elseif (file_exists($manufacturer_image.".png"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".png";
			}
			else
			{
				$product["manufacturer_image"] = "";
			}
			//manufacturer image ends here
			return $product;
		}
		else
		{
			return false;
		}
	}
	
		
	
	
	/////////////////////////////
	//Return Product By ID
	function getProductById($id, $level, $parent = 0)
	{
		global $settings;
			
		$r = $this->db->query("
			SELECT 
				".DB_PREFIX."products.*,
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
				IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url, 
				".DB_PREFIX."catalog.cid AS cat_id,
				".DB_PREFIX."catalog.name AS cat_name,  
				".DB_PREFIX."manufacturers.manufacturer_name AS manufacturer_name
			FROM ".DB_PREFIX."products
			INNER JOIN ".DB_PREFIX."catalog ON ".($parent > 0 ? " ".DB_PREFIX."catalog.cid='".intval($parent)."' " : " ".DB_PREFIX."products.cid = ".DB_PREFIX."catalog.cid ")."
			LEFT JOIN ".DB_PREFIX."manufacturers ON ".DB_PREFIX."products.manufacturer_id = ".DB_PREFIX."manufacturers.manufacturer_id AND ".DB_PREFIX."manufacturers.is_visible='1'
			WHERE ".DB_PREFIX."products.pid='".intval($id)."' AND ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
		");
		
		if ($this->db->moveNext($r, MYSQL_ASSOC))
		{
			$product = $this->db->col;
			
			$product["price_no_tax"] = $product["price"];
			$product["price2_no_tax"] = $product["price2"];
			
			if ($settings["DisplayPricesWithTax"] == "YES" && $product["is_taxable"] == "Yes")
			{
				$_price = $product["price"];
				$_price2 = $product["price2"];
				$_tax_rate = -1;
				if ($product["tax_rate"] >= 0)
				{
					$_price = $_price + ($_price / 100 * $product["tax_rate"]);
					$_price2 = $_price2 + ($_price2 / 100 * $product["tax_rate"]);
					$_tax_rate = $product["tax_rate"];
				}
				elseif(array_key_exists($product["tax_class_id"], $this->taxRates))
				{
					$_price = $_price * $this->taxRates[$product["tax_class_id"]]["multiplier"];
					$_price2 = $_price2 * $this->taxRates[$product["tax_class_id"]]["multiplier"];
					$_tax_rate = $this->taxRates[$product["tax_class_id"]]["tax_rate"];
				}
				$product["price"] = $_price;
				$product["price2"] = $_price2;
				$product["tax_rate"] = $_tax_rate;
			}
			
			//url
			$product["url"] = getProductUrl($product["product_url"], $product["pid"], $product["cid"]);
			$product["print_url"] = $this->settings["GlobalHttpUrl"]."/".$this->settings["INDEX"]."?p=product&amp;id=".intval($product["pid"])."&amp;parent=".intval($product["cid"])."&amp;is_print_version=true";
			$product["cat_url"] = getCatalogUrl($product["cat_url"], $product["cat_id"]);
			
			//inventory, min / max order
			if ($product["inventory_control"] == "Yes" || $product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc")
			{
				$product["allowed_max"] = $product["max_order"] > 0 ? ($product["max_order"] > $product["stock"] ? $product["stock"] : $product["max_order"]) : $product["stock"];
			}
			else
			{
				$product["allowed_max"] = 0;
			}
			
			
			//product primary image & thumb
			$product["image"] = $this->getProductImage($product["product_id"], $product["image_location"], $product["image_url"]);
			$product["thumb"] = $this->getProductThumb($product["product_id"], $product["image_location"], $product["image_url"]);
			$product["preview"] = $this->getProductThumb2($product["product_id"], $product["image_location"], $product["image_url"]);
			
			if ($product["image"])
			{
				if ($product["image_location"] == "Local")
				{
					$img_data = @getimagesize($product["image"]);
					if ($img_data)
					{
						$product["image_width"] = $img_data[0];
						$product["image_height"] = $img_data[1];
						$product["image_size"] = $img_data[3];
					}
					$product["product_page_image_url"]  = $product["preview"] ? $product["preview"] : $product["image"];
				}
				else
				{
					$product["product_page_image_url"] = $product["image_url"];
					$product["image_size"] = "";
				}
			}
			
			//get secondary images
			$this->db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".intval($id)."' AND is_visible='Yes' ORDER BY image_priority DESC");
			//$product["secondary_images"] = $this->db->numRows()>0?$this->db->getRecords():false;
			if ($this->db->numRows() > 0)
			{
				$product["secondary_images"] = $this->db->getRecords();
				for ($i=0; $i<count($product["secondary_images"]); $i++)
				{
					$product["secondary_images"][$i]["img_src"] = "images/products/secondary/".$product["secondary_images"][$i]["filename"].".".$product["secondary_images"][$i]["type"];
					$tf = "images/products/secondary/thumbs/".$product["secondary_images"][$i]["filename"].".jpg";
					$product["secondary_images"][$i]["thumb_src"] = file_exists($tf)?$tf:false;
					//$product["secondary_images"][$i]["type"] = file_exists($tf)?$tf:false;
					if (!$product["secondary_images"][$i]["thumb_src"])
					{
						$product["secondary_images"][$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
					}
					else
					{
						$product["secondary_images"][$i]["thumb_size"] = '';
					}
				}
				
				$formats = explode(",", VIDEO_FORMAT);
				$product["videos"] = array();
				foreach( $product["secondary_images"] as $key =>  $each )
				{
					if( in_array($each["type"], $formats ) )
					{
						array_push($product["videos"], $each);	
						unset($product["secondary_images"][$key]);		
					}
				}
			}
			else
			{
				$product["secondary_images"] = false;
			}
			
			if ($product["attributes_count"] > 0)
			{
				//get attributes
				$this->db->query("
					SELECT * FROM ".DB_PREFIX."products_attributes
					WHERE ".DB_PREFIX."products_attributes.pid = '".intval($id)."' AND is_active='Yes'
					ORDER BY priority, name, is_modifier
				");
				while ($this->db->moveNext())
				{
					$attribute = $this->db->col;
					$attribute["options"] = array();
					parseOptions($this->db->col["options"], $product["price_no_tax"], $product["weight"], $attribute["options"]);
					$product["attributes"][$this->db->col["paid"]] = $attribute;
				}
			}
			
			$product["price_wholesale"] = $product["price"];
			if ($this->settings["WholesaleDiscountType"] == "PRODUCT")
			{
				if ($level > 0 && $product["price_level_1"] > 0 && $this->settings["WholesaleMaxLevels"] > 0) $product["price_wholesale"] = $product["price_level_1"];
				if ($level > 1 && $product["price_level_2"] > 0 && $this->settings["WholesaleMaxLevels"] > 1) $product["price_wholesale"] = $product["price_level_2"];
				if ($level > 2 && $product["price_level_3"] > 0 && $this->settings["WholesaleMaxLevels"] > 2) $product["price_wholesale"] = $product["price_level_3"];
			}
			if ($this->settings["WholesaleDiscountType"] == "GLOBAL")
			{
				if($level > 0 && $this->settings["WholesaleMaxLevels"] > 0) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount1"]);
				if($level > 1 && $this->settings["WholesaleMaxLevels"] > 1) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount2"]);
				if($level > 2 && $this->settings["WholesaleMaxLevels"] > 2) $product["price_wholesale"] = $product["price"]/100*(100-$this->settings["WholesaleDiscount3"]);
			}
			
			$this->db->query("SELECT * FROM ".DB_PREFIX."products_quantity_discounts WHERE pid = '".intval($id)."' AND is_active = 'Yes' ORDER BY range_min");
			$product["quantity_discounts"] = array();
			while ($this->db->moveNext())
			{
				if (($this->db->col["apply_to_wholesale"] == "Yes" && $level > 0) || ($level < 1))
				{
					$iii = count($product["quantity_discounts"]);
					$product["quantity_discounts"][$iii] = $this->db->col;
					
					$product["quantity_discounts"][$iii]["discount"] = (strtolower($product["quantity_discounts"][$iii]["discount_type"]) == 'percent')
						? round((float) $product["quantity_discounts"][$iii]["discount"], 2)
						: $product["quantity_discounts"][$iii]["discount"];
				}
			}
			$product["quantity_discounts"] = count($product["quantity_discounts"])>0?$product["quantity_discounts"]:false;
			
			if (($product["inventory_control"] == "Yes" || $product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc") && 
				$product["inventory_rule"] == "OutOfStock" && 
				intval($product["stock"]) === 0
			){
				$product["out_of_stock"] = 1;
			}
			else
			{
				$product["out_of_stock"] = 0;
			}
			
			if ($product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc")
			{
				$this->db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pid='".intval($id)."' AND is_active=1");
				if ($this->db->numRows() > 0)
				{
					$product["inventory_hashes"] = $this->db->getRecords();
				}
				else
				{
					$product["inventory_hashes"] = false;
				}
			}
			
			//get product shipping price
			if ($product["is_dollar_days"] == "Yes")
			{
				$dollar_days_shipping_percent = 15;
				$dollar_days_shipping_min_amount = 6.95;
				
				$product["shipping_price"] = array();
				$product["shipping_price"][] = array(
					"method_name" => "Dollar Days Shipping",
					"price" => $product["price"] / 100 * $dollar_days_shipping_percent
				);
			}
			else
			{
				$this->db->query("
					SELECT 
						".DB_PREFIX."products_shipping_price.price,
						".DB_PREFIX."shipping_selected.method_name
					FROM ".DB_PREFIX."products_shipping_price
					INNER JOIN ".DB_PREFIX."shipping_selected ON ".DB_PREFIX."products_shipping_price.ssid = ".DB_PREFIX."shipping_selected.ssid
					WHERE ".DB_PREFIX."products_shipping_price.pid='".intval($id)."' AND ".DB_PREFIX."products_shipping_price.is_price='Yes' 
				");
				if ($this->db->numRows())
				{
					$product["shipping_price"] = array();
					while ($this->db->moveNext())
					{
						$product["shipping_price"][] = array(
							"method_name" => $this->db->col["method_name"],
							"price" => $this->db->col["price"]
						);
					}
				}
				else
				{
					$product["shipping_price"] = false;
				}
			}
			
			//manufacturer image begins here
			$manufacturer_image = "images/manufacturers/".$product["manufacturer_id"];
			if (file_exists($manufacturer_image.".jpg"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".jpg";
			}
			elseif (file_exists($manufacturer_image.".gif"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".gif";
			}
			elseif (file_exists($manufacturer_image.".png"))
			{
				$product["manufacturer_image"] = $manufacturer_image.".png";
			}
			else
			{
				$product["manufacturer_image"] = "";
			}
			//manufacturer image ends here
			return $product;
		}
		else
		{
			return false;
		}
	}
	
	function getConditionByproductId($id)
	{
		global $settings;
		
		
		$r = $this->db->query("select * from ".DB_PREFIX."conditionfields,".DB_PREFIX."condition_products  where ".DB_PREFIX."condition_products.condition_id=".DB_PREFIX."conditionfields.condition_id and ".DB_PREFIX."condition_products.pid='".$id."' order by conditionfields.condition_order");
			//echo("select * from ".DB_PREFIX."conditionfields,".DB_PREFIX."condition_products  where ".DB_PREFIX."condition_products.condition_id=".DB_PREFIX."conditionfields.condition_id and ".DB_PREFIX."condition_products.pid='".$id."'");
		while ($this->db->moveNext())
			$condition[] = $this->db->col;
		return $condition;
	}
	
	////////////////////////////////////////////////
	//Return products families for specific product
	function getProductFamilies($pid, $level){
		$this->db->query("
			SELECT ".DB_PREFIX."products_families.* 
			FROM ".DB_PREFIX."products_families_dependencies
			INNER JOIN ".DB_PREFIX."products_families ON ".DB_PREFIX."products_families.pf_id = ".DB_PREFIX."products_families_dependencies.pf_id
			WHERE ".DB_PREFIX."products_families_dependencies.pid='".intval($pid)."'
		");
		$f = $this->db->getRecords();
		if ($f)
		{
			for ($i=0; $i<count($f); $i++)
			{
				//get products in family
				$this->db->query("SELECT * FROM ".DB_PREFIX."products_families_content WHERE pf_id='".intval($f[$i]["pf_id"])."' AND pid <> '".intval($pid)."' ORDER BY RAND()");
				$a = $this->db->getRecords();
				$f[$i]["products"] = array();
				if ($a)
				{
					for ($j = 0; $j < count($a); $j++)
					{
						$pr = $this->getProductById($a[$j]["pid"], $level);
						if ($pr)
						{
							$f[$i]["products"][] = $pr;
							if(count($f[$i]["products"]) >= intval($this->settings["RecommendedProductsCount"]))
							{
									break;
							}
						}
					}
				}
				$f[$i]["products"] = count($f[$i]["products"]) > 0 ? $f[$i]["products"] : false;
			}
		}
		return $f;
	}
	
	/**
	 * Select produts from the same category
	 * @param $pid
	 * @param $level
	 * @param $parent
	 * @param $count
	 */
	function getProductSiblings($pid, $level, $parent, $count = 10)
	{
		$this->db->query("SELECT * FROM ".DB_PREFIX."products WHERE cid='".intval($parent)."' AND pid <> '".intval($pid)."' AND is_visible='Yes' ORDER BY RAND() LIMIT ".intval($count));
		$a = $this->db->getRecords();
		$siblings = false;
		if ($a)
		{
			$siblings = array();
			for ($j = 0; $j < count($a); $j++)
			{
				$pr = $this->getProductById($a[$j]["pid"], $level);
				if ($pr)
				{
					$siblings[] = $pr;
				}
			}
		}
		return $siblings;
	}
	
/* for future usage, query is working :)	
	function getOrderRecommendedProducts($oid){
		$this->db->query("
			SELECT products.*
			FROM ".DB_PREFIX."orders_content
			INNER JOIN products_families_dependencies ON products_families_dependencies.pid = orders_content.pid
			INNER JOIN products_families ON products_families.pf_id = products_families_dependencies.pf_id
			INNER JOIN products_families_content ON products_families_content.pf_id = products_families.pf_id
			INNER JOIN products ON products.pid = products_families_content.pid AND products.is_visible='Yes'

			LEFT JOIN orders_content AS products ON oc.pid = products.pid
			WHERE orders_content.oid = '1' AND oc.pid IS NULL
		");
	}
*/
	
	///////////////////////////////////////
	//Get Free Products
	function getFreeProducts($pid, $level){
		$this->db->query("SELECT ".DB_PREFIX."products_gifts.* FROM ".DB_PREFIX."products_gifts WHERE pid='".intval($pid)."'");
		if($this->db->numRows()>0){
			$a = $this->db->getRecords();
			$b = array();
			for($i = 0; $i < count($a); $i++){
				$pr = $this->getProductById($a[$i]["gift_pid"], $level);
				if ($pr)
				{
					$pr["free_product_quantity"] = $a[$i]["gift_quantity"];
					$b[] = $pr;
				}
			}
			return count($b) > 0 ? $b : false;
		}
		else{
			return false;
		}
	}
	
	/**
     * Returns array for products updates email
     *
     * @param product added - start date
     * @param product added - end date
     * @param price level (0, wholesalers - 1,2,3)
     * @param limit amount of returned products (false or number)
     */
	function getItemsProductUpdates($from, $to, $level, $limit = false)
	{
		global $settings;
		$this->db->query("
			SELECT ".DB_PREFIX."products.*, 
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
				".DB_PREFIX."catalog.name AS cat_name,
				IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url
			FROM ".DB_PREFIX."products 
			INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid = ".DB_PREFIX."catalog.cid
			WHERE ".DB_PREFIX."products.is_visible = 'Yes' AND ".DB_PREFIX."products.added BETWEEN '".$from." 00:00:01' AND '".$to." 23:59:59' 
			ORDER BY ".DB_PREFIX."products.is_hotdeal, ".DB_PREFIX."products.title
			".($limit?("LIMIT ".intval($limit)):"")."
		");
		
		if ($this->db->numRows() > 0)
		{

			$result = $this->db->getRecords();
			
			for ($i=0; $i<count($result); $i++)
			{
				
				if ($settings["DisplayPricesWithTax"] == "YES" && $result[$i]["is_taxable"] == "Yes")
				{
					$_price = $result[$i]["price"];
					$_price2 = $result[$i]["price2"];
					$_tax_rate = -1;
					if ($result[$i]["tax_rate"] >= 0)
					{
						$_price = $_price + ($_price / 100 * $result[$i]["tax_rate"]);
						$_price2 = $_price2 + ($_price2 / 100 * $result[$i]["tax_rate"]);
						$_tax_rate = $result[$i]["tax_rate"];
					}
					elseif (array_key_exists($result[$i]["tax_class_id"], $this->taxRates))
					{
						
						$_price = $_price * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
						$_price2 = $_price2 * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
						$_tax_rate = $this->taxRates[$result[$i]["tax_class_id"]]["tax_rate"];
					}
					$result[$i]["price"] = $_price;
					$result[$i]["price2"] = $_price2;
					$result[$i]["tax_rate"] = $_tax_rate;
				}
				
				$result[$i]["url"] = getProductUrl($result[$i]["product_url"], $result[$i]["pid"], $this->parent);
				$result[$i]["cat_url"] = getCatalogUrl($result[$i]["cat_url"], $result[$i]["cid"]);
				//inventory, min / max order
				if ($result[$i]["inventory_control"] == "Yes")
				{
					$result[$i]["allowed_max"] = $result[$i]["max_order"] > 0 ? ($result[$i]["max_order"] > $result[$i]["stock"] ? $result[$i]["stock"] : $result[$i]["max_order"]) : $result[$i]["stock"];
				}
				else
				{
					$result[$i]["allowed_max"] = 0;
				}
				if (($result[$i]["image"] = $image_path = $this->getProductImage($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"])) != false)
				{
					$result[$i]["thumb"] = $thumb_path = $this->getProductThumb($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"]);
					$result[$i]["thumb"] = $result[$i]["thumb"]?$result[$i]["thumb"]:$result[$i]["image"];
					
					if ($result[$i]["image_location"] == "Web" || $settings["CatalogThumbType"] == "Square")
					{
						$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" height="'.$settings["CatalogThumbSize"].'" ';
					}
					else
					{
						$is = @getImageSize($thumb_path);
						if ($is)
						{
							if ($is[0] > $is[1])
							{
								$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" ';
							}
							else
							{
								$result[$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
							}
						}
					}
					
					if ($result[$i]["image_location"] == "Local")
					{
						$result[$i]["thumb"] = $settings["GlobalHttpUrl"]."/".$result[$i]["thumb"];
					}
				}
				else
				{
					$result[$i]["thumb"] = false;
				}
				$result[$i]["price_wholesale"] = $result[$i]["price"];
			}
			return $result;
		}
		else
		{
			return false;
		}
	}
	
	/**
     * Returns array of bestseller products 
     *
     * @param order id (oid)
     */
	function getItemsBestSellersByOrderContent($oid){
		global $settings;
		//get current order items
		$this->db->query("SELECT pid FROM ".DB_PREFIX."orders_content WHERE oid='".intval($oid)."' GROUP BY pid");
		$order_items = array();
		while($this->db->moveNext()){
			$order_items[] = $this->db->col["pid"];
		}
		
		//select completed orders whose have these products
		$this->db->query("
			SELECT ".DB_PREFIX."orders_content.oid
			FROM ".DB_PREFIX."orders_content 
			INNER JOIN ".DB_PREFIX."orders ON ".DB_PREFIX."orders.oid = ".DB_PREFIX."orders_content.oid AND ".DB_PREFIX."orders.status = 'Completed' AND ".DB_PREFIX."orders.payment_status = 'Received'
			WHERE pid IN (".implode(",", $order_items).")
			GROUP BY ".DB_PREFIX."orders_content.oid	
		");
		$orders_with_items = array();
		while($this->db->moveNext()){
			$orders_with_items[] = $this->db->col["oid"];
		}
		if(count($orders_with_items) > 0 && count($order_items) > 0){
			//select other products from these orders
			$this->db->query("
				SELECT 
					".DB_PREFIX."products.*,
					IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
					".DB_PREFIX."catalog.name AS cat_name,
					IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url,
					SUM(".DB_PREFIX."orders_content.admin_price * ".DB_PREFIX."orders_content.admin_quantity) AS product_amount,
					SUM(".DB_PREFIX."orders_content.admin_quantity) AS product_quantity
				FROM ".DB_PREFIX."orders_content
				INNER JOIN ".DB_PREFIX."products ON ".DB_PREFIX."products.pid = ".DB_PREFIX."orders_content.pid AND ".DB_PREFIX."products.is_visible = 'Yes'
				INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."catalog.cid = ".DB_PREFIX."products.cid
				WHERE ".DB_PREFIX."orders_content.oid IN (".implode(",", $orders_with_items).")
					AND ".DB_PREFIX."orders_content.pid NOT IN (".implode(",", $order_items).")
				GROUP BY ".DB_PREFIX."products.pid
				ORDER BY product_quantity DESC, product_amount DESC
				LIMIT ".intval($settings["CustomerAlsoBoughtCount"])."
			");
			$this->bestsellersCount = $this->db->numRows();
			if($this->db->numRows()>0){
				$result = $this->db->getRecords();
				for($i=0; $i<count($result); $i++){
					
					//recalc prices with tax (like VAT)
					if($settings["DisplayPricesWithTax"] == "YES" && $result[$i]["is_taxable"] == "Yes"){
						$_price = $result[$i]["price"];
						$_price2 = $result[$i]["price2"];
						$_tax_rate = -1;
						if($result[$i]["tax_rate"] >= 0){
							$_price = $_price + ($_price / 100 * $result[$i]["tax_rate"]);
							$_price2 = $_price2 + ($_price2 / 100 * $result[$i]["tax_rate"]);
							$_tax_rate = $result[$i]["tax_rate"];
						}
						elseif(array_key_exists($result[$i]["tax_class_id"], $this->taxRates)){
							$_price = $_price * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
							$_price2 = $_price2 * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
							$_tax_rate = $this->taxRates[$result[$i]["tax_class_id"]]["tax_rate"];
						}
						$result[$i]["price"] = $_price;
						$result[$i]["price2"] = $_price2;
						$result[$i]["tax_rate"] = $_tax_rate;
					}
					
					$result[$i]["url"] = getProductUrl($result[$i]["product_url"], $result[$i]["pid"], $result[$i]["cid"]);
					$result[$i]["cat_url"] = getCatalogUrl($result[$i]["cat_url"], $result[$i]["cid"]);
					//inventory, min / max order
					if($result[$i]["inventory_control"] == "Yes"){
						$result[$i]["allowed_max"] = $result[$i]["max_order"] > 0 ? ($result[$i]["max_order"] > $result[$i]["stock"] ? $result[$i]["stock"] : $result[$i]["max_order"]) : $result[$i]["stock"];
					}
					else{
						$result[$i]["allowed_max"] = 0;
					}
					if($result[$i]["image"] = $image_path = $this->getProductImage($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"])){
						$result[$i]["thumb"] = $thumb_path = $this->getProductThumb($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"]);
						$result[$i]["thumb"] = $result[$i]["thumb"]?$result[$i]["thumb"]:$result[$i]["image"];
						
						if($result[$i]["image_location"] == "Web" || $settings["CatalogThumbType"] == "Square"){
							$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" height="'.$settings["CatalogThumbSize"].'" ';
						}
						else{
							$is = @getImageSize($thumb_path);
							if($is){
								if($is[0] > $is[1]){
									$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" ';
								}
								else{
									$result[$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
								}
							}
						}
					}
					else{
						$result[$i]["thumb"] = false;
					}
					/*
					$result[$i]["price_wholesale"] = $result[$i]["price"];
					if($this->settings["WholesaleDiscountType"] == "PRODUCT"){
						if($level > 0 && $result[$i]["price_level_1"] > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price_level_1"];
						if($level > 1 && $result[$i]["price_level_2"] > 0 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price_level_2"];
						if($level > 2 && $result[$i]["price_level_3"] > 0 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price_level_3"];
					}
					if($this->settings["WholesaleDiscountType"] == "GLOBAL"){
						if($level > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount1"]);
						if($level > 1 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount2"]);
						if($level > 2 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount3"]);
					} */
				}
				return $result;
			}
			else{
				return false;
			}
		}
		else{
			return false;
		}
	
	}
	
	///////////////////////////////
	//Return BestSellers products
	function getItemsBestSellers($params, $level){
		global $settings;
		
		extract($params);
		//choose term
		switch($CatalogBestsellersPeriod){
			case "Year" : $period = "1 YEAR"; break;
			case "6 Months" : $period = "6 MONTH"; break;
			case "3 Months" : $period = "3 MONTH"; break;
			case "2 Months" : $period = "2 MONTH"; break;
			default:
			case "Month": $period = "1 MONTH"; break;
		}
		//build categories select
		$where = "";
		$categories = isset($categories)?$categories:array();
		$categories = is_array($categories)?$categories:array();
		$categories = $categories[0]=0?$categories:array();
		reset($categories);
		if(count($categories) > 0){// && !array_key_exists(0, $categories)){
			$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND (";
			for($i=0; $i< count($params["categories"]); $i++){
				$inner.=($i>0?"OR ":"")." ".DB_PREFIX."products_categories.cid='".intval($categories[$i])."' ";
			}
			$inner.=")";
		}
		else{
			$inner = "";
		}
		$this->db->query("
			SELECT 
				".DB_PREFIX."products.*,
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
				".DB_PREFIX."catalog.name AS cat_name,
				IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url,
				SUM(".DB_PREFIX."orders_content.admin_price * ".DB_PREFIX."orders_content.admin_quantity) AS product_amount,
				SUM(".DB_PREFIX."orders_content.admin_quantity) AS product_quantity
			FROM ".DB_PREFIX."orders_content
			INNER JOIN ".DB_PREFIX."orders ON ".DB_PREFIX."orders.oid=".DB_PREFIX."orders_content.oid
			INNER JOIN ".DB_PREFIX."products ON ".DB_PREFIX."products.pid = ".DB_PREFIX."orders_content.pid
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."catalog.cid = ".DB_PREFIX."products.cid
			WHERE 
				".DB_PREFIX."catalog.key_name <> 'gift_cert' AND
				".DB_PREFIX."products.is_visible='Yes' AND
				DATE_ADD(".DB_PREFIX."orders.placed_date, INTERVAL ".($period).")>NOW() AND 
				".DB_PREFIX."orders.status='Completed' AND 
				".DB_PREFIX."orders.payment_status='Received' ".$where."
			GROUP BY ".DB_PREFIX."orders_content.pid
			ORDER BY
				product_quantity DESC
			LIMIT ".intval($CatalogBestsellersCount)."
		");
		//echo $this->db->query;
		$this->bestsellersCount = $this->db->numRows();
		if($this->db->numRows()>0){
			$result = $this->db->getRecords();
			for($i=0; $i<count($result); $i++){
				//recalc prices with tax (like VAT)
				if($settings["DisplayPricesWithTax"] == "YES" && $result[$i]["is_taxable"] == "Yes"){
					$_price = $result[$i]["price"];
					$_price2 = $result[$i]["price2"];
					$_tax_rate = -1;
					if($result[$i]["tax_rate"] >= 0){
						$_price = $_price + ($_price / 100 * $result[$i]["tax_rate"]);
						$_price2 = $_price2 + ($_price2 / 100 * $result[$i]["tax_rate"]);
						$_tax_rate = $result[$i]["tax_rate"];
					}
					elseif(array_key_exists($result[$i]["tax_class_id"], $this->taxRates)){
						$_price = $_price * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
						$_price2 = $_price2 * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
						$_tax_rate = $this->taxRates[$result[$i]["tax_class_id"]]["tax_rate"];
					}
					$result[$i]["price"] = $_price;
					$result[$i]["price2"] = $_price2;
					$result[$i]["tax_rate"] = $_tax_rate;
				}
				
				$result[$i]["url"] = getProductUrl($result[$i]["product_url"], $result[$i]["pid"], $result[$i]["cid"]);
				$result[$i]["cat_url"] = getCatalogUrl($result[$i]["cat_url"], $result[$i]["cid"]);
				//inventory, min / max order
				if($result[$i]["inventory_control"] == "Yes"){
					$result[$i]["allowed_max"] = $result[$i]["max_order"] > 0 ? ($result[$i]["max_order"] > $result[$i]["stock"] ? $result[$i]["stock"] : $result[$i]["max_order"]) : $result[$i]["stock"];
				}
				else{
					$result[$i]["allowed_max"] = 0;
				}
				if($result[$i]["image"] = $image_path = $this->getProductImage($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"])){
					$result[$i]["thumb"] = $thumb_path = $this->getProductThumb($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"]);
					$result[$i]["thumb"] = $result[$i]["thumb"]?$result[$i]["thumb"]:$result[$i]["image"];
					
					if($result[$i]["image_location"] == "Web" || $settings["CatalogThumbType"] == "Square"){
						$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" height="'.$settings["CatalogThumbSize"].'" ';
					}
					else{
						$is = @getImageSize($thumb_path);
						if($is){
							if($is[0] > $is[1]){
								$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" ';
							}
							else{
								$result[$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
							}
						}
					}
				}
				else{
					$result[$i]["thumb"] = false;
				}
				
				$result[$i]["price_wholesale"] = $result[$i]["price"];
				if ($this->settings["WholesaleDiscountType"] == "PRODUCT")
				{
					if($level > 0 && $result[$i]["price_level_1"] > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price_level_1"];
					if($level > 1 && $result[$i]["price_level_2"] > 0 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price_level_2"];
					if($level > 2 && $result[$i]["price_level_3"] > 0 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price_level_3"];
				}
				if ($this->settings["WholesaleDiscountType"] == "GLOBAL")
				{
					if($level > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount1"]);
					if($level > 1 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount2"]);
					if($level > 2 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount3"]);
				}
			}
			return $result;
		}
		else{
			return false;
		}
	}

	////////////////////////////////////////////////
	//Return Items for Catalog Page
	function getItemsCatalog($params, $level)
	{
		global $settings;
		extract($params);
		//print_r($params); "gdsf";
		//build categories select
		$where = "";
		$inner = "";
		
		//echo "fds".$model;die();
		
		switch ($mode)
		{
			case "search" : 
			{
				reset($keywords);
                              // echo "<pre>"; print_r($keywords); exit;
				if (count($keywords) > 0 && !in_array('search',$keywords))
				{
					$where = " AND (";
					for ($i=0; $i<count($keywords); $i++)
					{
						switch (strtolower($keywords[$i]))
						{
							case "(" :
							case ")" :
							case "and" :
							case "or" : 
							{
								$where.=" ".$keywords[$i]." ";
								break;
							}
							default : 
							{
								switch ($search_in)
								{
									case "id": 
									{
										$where.="(".DB_PREFIX."products.product_id LIKE '%".$this->db->escape($keywords[$i])."%')";
										break;
									}
									case "name" : 
									{
										$where.="(".DB_PREFIX."products.title LIKE '%".$this->db->escape($keywords[$i])."%')";
										break;
									}
									default : 
									{
										$where.="(".DB_PREFIX."products.title LIKE '%".$this->db->escape($keywords[$i])."%' OR ".DB_PREFIX."products.description LIKE '%".$this->db->escape($keywords[$i])."%' OR ".DB_PREFIX."products.product_id LIKE '%".$this->db->escape($keywords[$i])."%')";
										break;
									}
								}
								
								break;
							}
						}
					}
					$where.=")";
				}
				if($manufacturer!=0)
					$where .= " AND ".DB_PREFIX."products.manufacturer_id='".intval($manufacturer)."'";
				
				if($equipment!=0)
				{
					if($category==0)
					{
						$equipment_name_query = mysql_query("select * from ".DB_PREFIX."catalog where cid='".intval($equipment)."'");
						$fetch_equipment_name = mysql_fetch_array($equipment_name_query);
						$equipment_name = $fetch_equipment_name["name"];
						
						$product_categories = mysql_query("select cid from ".DB_PREFIX."catalog where name like '".$equipment_name."'");
						
						$result_cids='';
						while($fetch_product_categories = mysql_fetch_array($product_categories))
						{
							if($result_cids =='')
								$result_cids=$fetch_product_categories["cid"];
							else
								$result_cids.=",".$fetch_product_categories["cid"];
						}
						
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid IN(".$result_cids.")";
					}
					else
					{
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".intval($equipment)."'";
					}
				}
				elseif($equipment == 0)
				{
					if($category!=0)
					{
						//require_once("content/classes/class.catalog.php");
						//echo $param1; exit();
					   // if($param1!=0){
						$catalog = new ShoppingCartCatalog($this->db);
						//$sub_cat= $catalog->getSubCategoriesById($category);
						//$cat_parent = array();
						//array_push($cat_parent,$category);
						$sub_cat= $catalog->getParsedTree($category);
						
						#print_r($sub_cat[]['name']);
						#die("end");
						
						$result_cids = '';
						for($i=0;$i<count($sub_cat);$i++)
						{
							//echo $sub_cat[$i]['name']."<br>";
							if($sub_cat[$i]['cid'] == $category)
							{
								foreach($sub_cat[$i]['children'] as $ids)
								{								
									/*if($result_cids=='')
										$result_cids = $sub_cat[$i]['cid'];
									else
										$result_cids.=",".$sub_cat[$i]['cid'];*/
									if($result_cids=='')
										$result_cids = $ids['cid'];
									else
										$result_cids.=",".$ids['cid'];
									$this->getsubRoots($ids);									
								}
							}
						}
							//print_r($this->resultantarray); die();
						$resultantarrayresults = implode(",",$this->resultantarray); 
						#shreesha added if(!empty($resultantarrayresults)) line
					     if(!empty($resultantarrayresults))
						    $result_cids.=",".$resultantarrayresults;
						 
						//echo $result_cids; die();
						#shreesha added if(!empty($result_cids)) condition and else condition
						if(!empty($result_cids))
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid IN(".$result_cids.")";						
						else
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid";						
					}
				}
				if($year_from!='' || $year_to!='')
				{
					if($year_from=='')
						$where .= " AND ".DB_PREFIX."products.year='".intval($year_to)."'";
					elseif($year_to=='')
						$where .= " AND ".DB_PREFIX."products.year='".intval($year_from)."'";
					else
						$where .= " AND ".DB_PREFIX."products.year between '".intval($year_from)."' AND '".intval($year_to)."'";
				}				
				if($model!='')
					$where .= " AND ".DB_PREFIX."products.model='".$model."'";
				
				if($price_from!='' || $price_to!='')
				{
					if($price_from=='')
						$where .= " AND ".DB_PREFIX."products.price='".intval($price_to)."'";
					elseif($price_to=='')
						$where .= " AND ".DB_PREFIX."products.price='".intval($price_from)."'";
					else
						$where .= " AND ".DB_PREFIX."products.price between '".intval($price_from)."' AND '".intval($price_to)."'";
				}
				break;
			}
			case "home" : 
			{
				$where = " AND ".DB_PREFIX."products.is_home='Yes'";
				break;
			}
			case "hot" : 
			{
				$where = " AND ".DB_PREFIX."products.is_hotdeal='Yes'";
				break;
			}
			case "new" : 
			{
				$where = " AND DATE_ADD(".DB_PREFIX."products.added, INTERVAL ".intval($CatalogNewestDays)." DAY) > NOW()";
				break;
			}
			case "manufacturer" : 
			{
				$where = " AND ".DB_PREFIX."products.manufacturer_id='".intval($manufacturer_id)."'";
				break;
			}
			case "quick_search" :
				{
			//	echo $search_str; die();
			   if($search_str!='' && $search_str!='Enter Keyword')
			   $where .="AND (".DB_PREFIX."products.title LIKE '%".$search_str."%' OR ".DB_PREFIX."products.product_id LIKE  '%".$search_str."%' OR ".DB_PREFIX."products.description LIKE  '%".$search_str."%')";
				 if($manufacturer!=0)
				$where .= " AND ".DB_PREFIX."products.manufacturer_id='".intval($manufacturer)."'";
				/*if($category!=0)
				$where .= " AND ".DB_PREFIX."products.cid='".intval($category)."'"; */
				// echo $$equipment; exit;
				 if($equipment!=0)
				 {
					if($category==0)
					{
						$equipment_name_query = mysql_query("select * from ".DB_PREFIX."catalog where cid='".intval($equipment)."'");
						$fetch_equipment_name = mysql_fetch_array($equipment_name_query);
						$equipment_name = $fetch_equipment_name["name"];
						
						$product_categories = mysql_query("select cid from ".DB_PREFIX."catalog where name like '".$equipment_name."'");
						$result_cids='';
						while($fetch_product_categories = mysql_fetch_array($product_categories))
						{
							if($result_cids =='')
								$result_cids=$fetch_product_categories["cid"];
							else
								$result_cids.=",".$fetch_product_categories["cid"];
						}
						
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid IN(".$result_cids.")";
					}
					else
					{
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".intval($equipment)."'";
					}
				 }
				 elseif($equipment == 0)
				 {
					if($category!=0)
					{
						//require_once("content/classes/class.catalog.php");
						//echo $param1; exit();
					   // if($param1!=0){
						$catalog = new ShoppingCartCatalog($this->db);
						//$sub_cat= $catalog->getSubCategoriesById($category);
						//$cat_parent = array();
						//array_push($cat_parent,$category);
						$sub_cat= $catalog->getParsedTree($category);
						//print_r($sub_cat[]['name']);
						//die("end");
						$result_cids = '';
						for($i=0;$i<count($sub_cat);$i++)
						{
							//echo $sub_cat[$i]['name']."<br>";
							if($sub_cat[$i]['cid'] == $category)
							{
								foreach($sub_cat[$i]['children'] as $ids)
								{								
									/*if($result_cids=='')
										$result_cids = $sub_cat[$i]['cid'];
									else
										$result_cids.=",".$sub_cat[$i]['cid'];*/
									if($result_cids=='')
										$result_cids = $ids['cid'];
									else
										$result_cids.=",".$ids['cid'];
									$this->getsubRoots($ids);									
								}
							}
						}
							//print_r($this->resultantarray); die();
						$resultantarrayresults = implode(",",$this->resultantarray); 
						$result_cids.=",".$resultantarrayresults;
						//echo $result_cids; die();
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid IN(".$result_cids.")";						
					}
				 }
			
				
				break;
			}
			default:
			case "catalog": 
			{
				if ($nested)
				{
					reset($categories);
					if (count($categories) > 0)
					{
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND (";
						for ($i=0; $i< count($params["categories"]); $i++)
						{
							$inner.=($i>0?"OR ":"")." ".DB_PREFIX."products_categories.cid='".intval($categories[$i])."' ";
						}
						$inner.=")";
					}
					else
					{
						$inner.= "";
					}
				}
				else
				{
					$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".intval($parent)."'";
				}
				break;
			}
		}
		
		if (isset($CatalogPriceRangeMin) && isset($CatalogPriceRangeMax))
		{
			$where.= " AND price >= '".number_format($CatalogPriceRangeMin, 2, ".", "")."' AND price <= '".number_format($CatalogPriceRangeMax, 2, ".", "")."' ";
		}
		
		$where .= " ";
		
		if (isset($ProductGroup) && $ProductGroup)
		{
			$where .= " AND ".DB_PREFIX."products.pid IN (SELECT pid FROM ".DB_PREFIX."products_groups_products WHERE group_id = ".intval($ProductGroup).")";
		}
		
		//preselect
		
		$t = time();
		
		/*echo("
			SELECT ".DB_PREFIX."products.pid FROM ".DB_PREFIX."products
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid
			WHERE ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
			".$where." AND product_status='approved'
			GROUP BY ".DB_PREFIX."products.pid
		"); die("after query");*/
		
		$this->db->query("
			SELECT ".DB_PREFIX."products.pid FROM ".DB_PREFIX."products
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid
			WHERE ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
			".$where." AND product_status='approved'
			GROUP BY ".DB_PREFIX."products.pid
		");
		
		
		$this->items_count = $this->db->numRows();
		$this->pages_count = floor($this->items_count / $params["CatalogItemsOnPage"]) +  ((($this->items_count % $params["CatalogItemsOnPage"]) > 0 )?1:0);
		$this->current_page = $params["Page"];
		$this->current_page = (($this->current_page<1)||($this->current_page>$this->pages_count))?1:$this->current_page;
		
		if ($this->items_count)
		{
			//sort by
			switch ($params["CatalogSortBy"])
			{
				default:
				case "priority" : $order_by = DB_PREFIX."products.priority DESC, ".DB_PREFIX."products.title"; break;
				case "name" : $order_by = DB_PREFIX."products.title"; break;
				case "price" : $order_by = DB_PREFIX."products.price, ".DB_PREFIX."products.title"; break;
				case "price_desc" : $order_by = DB_PREFIX."products.price DESC, ".DB_PREFIX."products.title"; break;
				case "date" : $order_by = DB_PREFIX."products.added DESC, ".DB_PREFIX."products.title"; break;
			}
			//final select
			$t = time();
			
			
			
			
			$this->db->query("
				SELECT ".DB_PREFIX."products.*, 
					IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,
					".DB_PREFIX."catalog.name AS cat_name,
					IF(".DB_PREFIX."catalog.url_custom='',".DB_PREFIX."catalog.url_default,".DB_PREFIX."catalog.url_custom) AS cat_url,
					manufacturer_name
				FROM ".DB_PREFIX."products
				".$inner."
				INNER JOIN ".DB_PREFIX."catalog ON ".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid
				LEFT JOIN ".DB_PREFIX."manufacturers ON ".DB_PREFIX."manufacturers.is_visible='1' AND ".DB_PREFIX."products.manufacturer_id = ".DB_PREFIX."manufacturers.manufacturer_id
				WHERE ".DB_PREFIX."products.is_visible='Yes' 
				AND ".$this->_getInventorySql()."
				".$where." AND product_status='approved' 
				GROUP BY ".DB_PREFIX."products.pid
				ORDER BY ".$order_by."
				LIMIT ".intval(($this->current_page-1)*$params["CatalogItemsOnPage"]).", ".intval($params["CatalogItemsOnPage"])."
			");
			
			if ($this->db->numRows()>0)
			{
				$reviews = new Ddm_Product_Reviews();
				$result = $this->db->getRecords();
				for ($i=0; $i<count($result); $i++)
				{
					//recalc prices with tax (like VAT)
					if ($settings["DisplayPricesWithTax"] == "YES" && $result[$i]["is_taxable"] == "Yes")
					{
						$_price = $result[$i]["price"];
						$_price2 = $result[$i]["price2"];
						$_tax_rate = -1;
						if ($result[$i]["tax_rate"] >= 0)
						{
							$_price = $_price + ($_price / 100 * $result[$i]["tax_rate"]);
							$_price2 = $_price2 + ($_price2 / 100 * $result[$i]["tax_rate"]);
							$_tax_rate = $result[$i]["tax_rate"];
						}
						elseif (array_key_exists($result[$i]["tax_class_id"], $this->taxRates))
						{
							$_price = $_price * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
							$_price2 = $_price2 * $this->taxRates[$result[$i]["tax_class_id"]]["multiplier"];
							$_tax_rate = $this->taxRates[$result[$i]["tax_class_id"]]["tax_rate"];
						}
						$result[$i]["price"] = $_price;
						$result[$i]["price2"] = $_price2;
						$result[$i]["tax_rate"] = $_tax_rate;
					}
					
					$result[$i]["url"] = getProductUrl($result[$i]["product_url"], $result[$i]["pid"], $this->parent);
					$result[$i]["cat_url"] = getCatalogUrl($result[$i]["cat_url"], $result[$i]["cid"]);
					//inventory, min / max order
					
					// Add product reviews support
					$product_rating = $reviews->getProductRating($result[$i]['pid']);
					$result[$i]["reviews"] = array(
						'posts' => $reviews->getReviews($result[$i]['pid']),
						'product_rating' => round($product_rating['rating'], 1),
						'product_rating_total' => $product_rating['total_reviews']
					);
					
					if ($result[$i]["inventory_control"] == "Yes")
					{
						$result[$i]["allowed_max"] = $result[$i]["max_order"] > 0 ? ($result[$i]["max_order"] > $result[$i]["stock"] ? $result[$i]["stock"] : $result[$i]["max_order"]) : $result[$i]["stock"];
					}
					else
					{
						$result[$i]["allowed_max"] = 0;
					}
					if ($result[$i]["image"] = $image_path = $this->getProductImage($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"]))
					{
						$result[$i]["thumb"] = $thumb_path = $this->getProductThumb($result[$i]["product_id"], $result[$i]["image_location"], $result[$i]["image_url"]);
						$result[$i]["thumb"] = $result[$i]["thumb"] ? $result[$i]["thumb"] : $result[$i]["image"];

						if ($result[$i]["image_location"] == "Web" || $settings["CatalogThumbType"] == "Square")
						{
							$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" height="'.$settings["CatalogThumbSize"].'" ';
						}
						else
						{
							$is = @getImageSize($thumb_path);
							if ($is)
							{
								if ($is[0] > $is[1])
								{
									$result[$i]["thumb_size"] = ' width="'.$settings["CatalogThumbSize"].'" ';
								}
								else
								{
									$result[$i]["thumb_size"] = ' height="'.$settings["CatalogThumbSize"].'" ';
								}
							}
						}
					}
					else
					{
						$result[$i]["thumb"] = false;
					}
					
					$result[$i]["price_wholesale"] = $result[$i]["price"];
					if ($this->settings["WholesaleDiscountType"] == "PRODUCT")
					{
						if($level > 0 && $result[$i]["price_level_1"] > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price_level_1"];
						if($level > 1 && $result[$i]["price_level_2"] > 0 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price_level_2"];
						if($level > 2 && $result[$i]["price_level_3"] > 0 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price_level_3"];
					}
					if ($this->settings["WholesaleDiscountType"] == "GLOBAL")
					{
						if($level > 0 && $this->settings["WholesaleMaxLevels"] > 0) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount1"]);
						if($level > 1 && $this->settings["WholesaleMaxLevels"] > 1) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount2"]);
						if($level > 2 && $this->settings["WholesaleMaxLevels"] > 2) $result[$i]["price_wholesale"] = $result[$i]["price"]/100*(100-$this->settings["WholesaleDiscount3"]);
					}
					
					if ($result[$i]["inventory_control"] == "Yes" && 
						$result[$i]["inventory_rule"] == "OutOfStock" && 
						intval($result[$i]["stock"]) === 0
					)
					{
						$result[$i]["out_of_stock"] = 1;
					}
					else
					{
						$result[$i]["out_of_stock"] = 0;
					}
					
					//manufacturer image start here
					$manufacturer_image = "images/manufacturers/".$result[$i]["manufacturer_id"];
					if (file_exists($manufacturer_image.".jpg"))
					{
						$result[$i]["manufacturer_image"] = $manufacturer_image.".jpg";
					}
					elseif(file_exists($manufacturer_image.".gif"))
					{
						$result[$i]["manufacturer_image"] = $manufacturer_image.".gif";
					}
					elseif(file_exists($manufacturer_image.".png"))
					{
						$result[$i]["manufacturer_image"] = $manufacturer_image.".png";
					}
					else
					{
						$result[$i]["manufacturer_image"] = "";
					}
					
				//get secondary images
			$this->db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".intval($result[$i]["pid"])."' AND is_visible='Yes' ORDER BY image_priority DESC");
			//$product["secondary_images"] = $this->db->numRows()>0?$this->db->getRecords():false;
			if ($this->db->numRows() > 0)
			{
				$result[$i]["secondary_images"] = $this->db->getRecords();				
				
				$formats = explode(",", VIDEO_FORMAT);
				$result[$i]["videos"] = array();
				foreach( $result[$i]["secondary_images"] as $key =>  $each )
				{
					if( in_array($each["type"], $formats ) )
					{
						array_push($result[$i]["videos"], $each);	
						unset($result[$i]["secondary_images"][$key]);		
					}
				}				
				if($result[$i]["image"])
					$result[$i]["secondary_images_count"] = count($result[$i]["secondary_images"])+1;
				else
					$result[$i]["secondary_images_count"] = count($result[$i]["secondary_images"]);
					
				$result[$i]["videos_count"] = count($result[$i]["videos"]);
			}	
					
					//manufacturer image ends here
				}
				//print_r($result); 
				return $result;
			}
		}
		return false;
	}
	
	////////////////////////////////////////////////
	//Return Items for Catalog Page
	function getAdjacentProducts($params, $level)
	{
		global $settings;
		extract($params);		
		//build categories select
		$where = "";
		$inner = "";
		switch ($mode)
		{    
			default:
			case "catalog": 
			{
				$pid = $_REQUEST['pid'];
				if ($nested)
				{
					reset($categories);
					if (count($categories) > 0)
					{
						$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND (";
						for ($i=0; $i< count($params["categories"]); $i++)
						{
							$inner.=($i>0?"OR ":"")." ".DB_PREFIX."products_categories.cid='".intval($categories[$i])."' ";
						}
						$inner.=")";
					}
					else
					{
						$inner.= "";
					}
				}
				else
				{
				
					$inner = "INNER JOIN ".DB_PREFIX."products_categories ON ".DB_PREFIX."products_categories.pid = ".DB_PREFIX."products.pid AND ".DB_PREFIX."products_categories.cid='".intval($parent)."'";
				}
				break;
			}
		}
		
		if (isset($CatalogPriceRangeMin) && isset($CatalogPriceRangeMax))
		{
			$where.= " AND price >= '".number_format($CatalogPriceRangeMin, 2, ".", "")."' AND price <= '".number_format($CatalogPriceRangeMax, 2, ".", "")."' ";
		}
		
		$where .= " ";
		
		if (isset($ProductGroup) && $ProductGroup)
		{
			$where .= " AND ".DB_PREFIX."products.pid IN (SELECT pid FROM ".DB_PREFIX."products_groups_products WHERE group_id = ".intval($ProductGroup).")";
		}

		//preselect
		//$t = time();
		
		$res = array();
		
		
		$this->db->query("
			SELECT 
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url 
			FROM ".DB_PREFIX."products
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON (".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid)
			WHERE ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
			".$where." AND product_status='approved'
			AND ".DB_PREFIX."products.pid < $pid ORDER BY products.pid DESC LIMIT 1
		");
		
		if($this->db->moveNext())
			{$res['next'] =$this->db->col[product_url];}
			
		$this->db->query("
			SELECT 
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url 
			FROM ".DB_PREFIX."products
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON (".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid)
			WHERE ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
			".$where." AND product_status='approved'
			AND ".DB_PREFIX."products.pid > $pid ORDER BY products.pid LIMIT 1
		");
		if($this->db->moveNext())
			{$res['prev'] =$this->db->col[product_url];}
			
		$this->db->query("
			SELECT 
				IF(".DB_PREFIX."products.url_custom='',".DB_PREFIX."products.url_default,".DB_PREFIX."products.url_custom) AS product_url,products.pid 
			FROM ".DB_PREFIX."products
			".$inner."
			INNER JOIN ".DB_PREFIX."catalog ON (".DB_PREFIX."products.cid=".DB_PREFIX."catalog.cid)
			WHERE ".DB_PREFIX."products.is_visible='Yes'
			AND ".$this->_getInventorySql()."
			".$where." AND product_status='approved' GROUP BY ".DB_PREFIX."products.pid ORDER BY products.pid DESC
		");
		$res['count'] = $this->db->numRows();
		while($this->db->moveNext())
		{
			$res['url'][] =$this->db->col[product_url];
			$res['id'][] =$this->db->col[pid];			
		}	
		//$this->items_count = $this->db->numRows();

		return $res;
	}
	

	
	function _getInventorySql()
	{
		// pull data if
		return "
		(
			
				".DB_PREFIX."products.inventory_control = 'No'
			OR 
			
				".DB_PREFIX."products.stock > 0
			OR 
			
				".DB_PREFIX."products.inventory_rule = 'OutOfStock'
			OR
				(".DB_PREFIX."products.inventory_control = 'AttrRuleInc' AND ".DB_PREFIX."products.stock >= 0)
		)
		";
	}
	
	function generateSlideShowImageXML( $secondary_images )
	{
		global $settings;
		$matter = '<?xml version="1.0" encoding="ISO-8859-1"?>';	
		$matter .= "<gallery>" ;
		
		$lgpath = 'lgpath="images/products/videos/"';
		$tnpath = 'tnpath="images/products/videos/"';
		//$matter .= "<album ".$lgpath." ".$tnpath.">" ;
		$matter .= "<album>" ;
		foreach($secondary_images as $each)
		{ 
			$src = $each["img_src"];
			$tnpath =$each["thumb_src"];
			$src = $settings["GlobalHttpUrl"] . "/" . str_replace("secondary", "videos", $src) ;
			$tnpath = $settings["GlobalHttpUrl"] . "/images/videoicon.jpg";
			$matter .= "<img src=\"". $src ."\"  tn=\"". (( $tnpath != "" ) ? $tnpath : $src) ."\" />" ;		//tn=\"". $each["thumb_src"] ."\"
			//$tnpath = ""; $lgpath = "";
		}	
		$matter .= "</album>" ;
		$matter .= "</gallery>" ;
		echo $matter;
	}
	
	function write_to_file( $filename, $somecontent )
	{
		// Let's make sure the file exists and is writable first.
		if (is_writable($filename)) {

			if (!$handle = fopen($filename, 'w')) {
				 echo "Cannot open file ($filename)";
				 exit;
			}

			// Write $somecontent to our opened file.
			if (fwrite($handle, $somecontent) === FALSE) {
				echo "Cannot write to file ($filename)";
				exit;
			}

			//echo "Success, wrote ($somecontent) to file ($filename)";
			fclose($handle);

		} else {
			echo "The file $filename is not writable";
		}
	}
	function getsubRoots($ids=array())
	{
		if(is_array($ids['children']))
		{
			foreach($ids['children'] as $ids2)
			{
				array_push($this->resultantarray,$ids2["cid"]);
				if($ids2['children']!='')
					$this->getsubRoots($ids2);
			}
		}
	}
}
?>
