<?php
/**
 * Complete order
 */

	if (!defined("ENV")) exit();
	
	if ($user->auth_ok && $order->itemsCount)
	{
		$order->recalcOrderData();
		
		/**
		 * GIFT CERTIFICATE HANDLING
		 */
		$giftCertificates = new GiftCertificates($db);
		
		// chech has used ordered a gift certificate
		$giftCertificateData = $giftCertificates->GetGiftCertificate($order->oid);
		if ($giftCertificateData !== false)
		{
			$giftCertificates->OrderGiftCertificate(
				$giftCertificateData['ocid'], $giftCertificateData['first_name'], $giftCertificateData['last_name'], $giftCertificateData['gift_amount'], $giftCertificateData['voucher']
			);
			if ($giftCertificateData['email_gift'] == '1')
			{
				$giftCertificates->SendNotification($order->oid);	
			}
		}
						
		// check is gift certificate used to place (fund) an order
		$giftCertificateAmountUsed = 0;
		if ($order->totalAmount > 0)
		{
			$orderData = $giftCertificates->GetOrderGiftCert($order->oid);
			if ($orderData['gift_cert_valid'] == '1')
			{
				$giftCertificateData = $giftCertificates->GetOrderedGiftCert($orderData['gift_cert_first_name'], $orderData['gift_cert_last_name'], $orderData['gift_cert_voucher']);
									
				if ($giftCertificateData !== false)
				{
					$giftCertificateAmountUsed = $order->totalAmount > $giftCertificateData['balance'] ? $giftCertificateData['balance'] : $order->totalAmount;
					$giftCertificates->UpdateBalance($order->oid, $giftCertificateData['ocid'], $giftCertificateAmountUsed);
									
					//when everything was paid by Gift Certificate, update payment method
					if ($giftCertificateAmountUsed >= $order->totalAmount)
					{
						$db->reset();
						$db->assignStr("payment_method_name", "Gift Certificate");
						$db->assignStr("payment_method_description", "Gift Certificate");
						$db->assignStr("payment_gateway_id", "");
						$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
						view()->assign("payment_method_name", "Gift Certificate");	
					}
				}
			}
		}
						
		view()->assign("gift_cert_amount", $giftCertificateAmountUsed);
						
		/**
		 * GIFT CERTIFICATE FINISH
		 */
		$payment_status = "Pending";
			
		if ($order->totalAmount == 0) $payment_status = "Received";
		
		// Store the buyers IP address upon completing order
		$ipaddress = (isset($_SERVER['REMOTE_ADDR']))
			? $_SERVER['REMOTE_ADDR']
			: 'unknown';
				
		$db->reset();
		$db->assignStr('ipaddress', $ipaddress);
		$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
		
		$order->order_num = $order->closeOrder("Process", $payment_status);
		
		if (($settings["InventoryStockUpdateAt"]=="Payment Received" && $payment_status == "Received") || $settings["InventoryStockUpdateAt"]=="Order Placed")
		{
			$order->stockControl(); //do not process stock without payment
		}
	
		/**
		 * BUY SAFE
		 */
		/**
		if ($settings["buysafe_active"] == "Yes")
		{
			$buysafe = new BuySafeAPI($settings);
			$result = $buysafe->setShoppingCartCheckout($user, $order, $db);
		}
		**/
		
		/**
		 * Inseureship
		 */
		if ($settings["InsureShipActive"] == "Yes" && $order->insureShipActive && $order->insureShipAmount > 0)
		{
			require_once("content/classes/class.insureship.php");
			$insureShip = new InsureShip($settings["InsureShipAccountId"]);
			$insureShip->add($user, $order, $db);
		}	
		
		/**
		 * Doba
		 */
		if (isset($_SESSION["doba_items_in_order"]) && $_SESSION["doba_items_in_order"] && $settings["doba_autosend_orders"] == "Yes")
		{
			$doba_items = array();
			foreach ($order->items as $item)
			{
				if ($item["is_doba"] == "Yes") $doba_items[] = array("item_id"=>$item["product_id"], "quantity"=>$item["quantity"]);
			}
			
			if (count($doba_items) > 0)
			{
				require_once("content/classes/class.doba_order.php");
				$dobaOrder = new DobaOrderAPI($settings, $db);
				
			 	$doba_order_response = $dobaOrder->createOrder($order->shippingAddress, $doba_items, $order->order_num);
			 	
			 	if ($doba_order_response)
			 	{
			 		$db->query("UPDATE ".DB_PREFIX."orders SET doba_order_sent=1, doba_order_id='".$db->escape($doba_order_response->response->order_id)."' WHERE oid='".$order->oid."'");
			 	}
			}
		}
		unset($_SESSION["doba_items_in_order"]);
		
		
		/////////////////////////////////////
		// Email notifications
		emailOrderReceived($db, $order, $user, $customFields, $payment_status);
			
		/////////////////////////////////////
		// Complete order
		$payment_method_id = $order->paymentMethodId;
			
		$backurl = $url_https."p=completed";
			
		unset($_SESSION["payment_session_delay_timeout"]);
	}
