<?php
/**
 * Complete order
 */

	if (!defined("ENV")) exit();
	
	if ($user->auth_ok && $order->itemsCount)
	{
		$order->recalcOrderData();
		
		$result = "Pending";

		$form = isset($_POST["form"]) ? $_POST["form"] : array();
		
		$validBilling = true;
		$validShipping = true;
		$validPayment = true;

		if (trim($user->data['fname'] == '') || trim($user->data['lname'] == ''))
		{
			$validBilling = false;
		}

		//Ensure shipping address loaded
		if (count($order->shippingAddress) == 0) $order->getShippingAddress();

		if ($order->shippingDigital != 1 &&
			(!isset($order->shippingAddress['name']) || trim($order->shippingAddress['name']) == '' || 
			 !isset($order->shippingAddress['address1']) || trim($order->shippingAddress['address1']) == ''))
		{
			$validShipping = false;
		}

		if ($order->paymentMethodName != 'Free' && ($order->paymentMethodId == 0 || $order->paymentIsRealtime != 'No'))
		{
			$validPayment = false;
		}

		if (!$validBilling || !$validShipping || !$validPayment)
		{
			$backurl = $url_https.'p=one_page_checkout';
		}
		else
		{
			$order->closeOrder(
				"Process", 
				$result, $form, $customFields,
				MOBILE ? true : false, 
				isset($_SESSION["osc_source"]) ? $_SESSION["osc_source"] : null,
				isset($_SESSION["osc_campaign_id"]) ? $_SESSION["osc_campaign_id"] : null
			);
			
			// Complete order
			$payment_method_id = $order->paymentMethodId;
			$backurl = $url_https."p=completed";
		}
	}
