<?php
/**
 * Process payment
 */	

	if (!defined("ENV")) exit();
	
	if ($user->auth_ok && $order->itemsCount > 0)
	{		
		$payment = new PAYMENT($db);
		
		if ($payment->isMethods() && $payment->isMethod($order->paymentMethodId))
		{
			
			$pm = $payment->methods[$order->paymentMethodId];
				
			// custom payment methods
			if (trim($pm->id) != "")
			{
				$gate = $payment->methods[$order->paymentMethodId];
				$gateway_id = escapeFileName($gate->id);
				@require_once("content/engine/payment/payment_".($gateway_id).".php");
				
				$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='".$db->escape($gateway_id)."'");
				if ($db->moveNext())
				{
					$payment_processor_id = $db->col["id"];
					$payment_processor_class = $db->col["class"];
					$payment_processor_name = $db->col["name"];
				}
				
				if (isset($pp)) unset($pp);
				
				// create instance of payment processor (gateway) class
				@eval("\$pp = new ".$payment_processor_class."();");
					
				// set to true by defalt
				$is_payment_error = true;
	
				if (isset($pp) && is_object($pp))
				{
					$order->getShippingAddress();
					
					$pp->enableLog = defined('DEVMODE') && DEVMODE;
					$pp->db_id = $order->paymentMethodId;
					$pp->getSettingsData($db);
					$pp->getCommonData($user, $order);
					$pp->isTestMode(); // force test mode check to possibly update URLs
					
					if ($pp->steps == 1)
					{
						//return entered values of background
						//orders processing
						$form = isset($_POST["form"]) ? $_POST["form"] : array();
						$form = is_array($form) ? $form : array();
					}
					else
					{
						//return POST VARS passed by 
						//payment gateway
						$form = $_REQUEST;
					}

					if (isset($form['cc_type']))
					{
						$form['cc_type'] = str_replace(array('Yes~', 'No~'), array('', ''), $form['cc_type']);
					}
					
					if (isset($form['payment_profile_id']))
					{
						require_once("content/classes/class.payment_profile.php");
						$paymentProfileManager = new Payment_Profile();
						$paymentProfile = $paymentProfileManager->getPaymentProfileById($db, $user, $form['payment_profile_id']);
						$form['ext_profile_id'] = $paymentProfile['ext_profile_id'];
					}
					
					if (isset($form['cc_number']))
					{
						$form['cc_number'] = preg_replace('/\s+/', '', $form['cc_number']);
					}

					if (($result = $pp->process($db, $user, $order, $form)) != false)
					{
						/**
						 * Payment was successfull. Finish order now.
						 */
						
						$is_payment_error = false;

						$sendNotification = $pp->sendEmailNotification($result);
						
						$order->closeOrder(
							$order->shippingDigital ? "Completed" : "Process", 
							$result, $form, $customFields,
							MOBILE ? true : false, 
							isset($_SESSION["osc_source"]) ? $_SESSION["osc_source"] : null,
							isset($_SESSION["osc_campaign_id"]) ? $_SESSION["osc_campaign_id"] : null,
							$sendNotification
						);

						$backurl = $url_https."pcsid=".session_id()."&p=completed";
						$pp->success();

						if (isset($pp->reload_parent_on_process) && $pp->reload_parent_on_process)
						{
							?>
							<!DOCTYPE HTML>
							<html>
								<head>
									<script type="text/javascript">
									parent.location = "<?php echo $backurl; ?>";
									</script>
								</head>
								<body>
								</body>
							</html>
							<?php

							$db->done();
							_session_write_close();
							exit();
						}
					}
				}
				
				$payment->redirect = $pp->redirect;
				$payment->redirectURL = $pp->redirectURL;
							
				if ($is_payment_error)
				{
					$payment->is_error = true;
					$payment->error_message = (isset($pp) && $pp) ? $pp->error_message : "Critical error: Could not create gateway class instance. Please contact to site administrator.";
					
					////////////////////////////////////////////
					// Check is engine set to block users accounts
					// Possible cc hack protection
					if ($settings["SecurityAccountBlocking"] == "YES")
					{
						if (!$order->attempt($settings["SecurityAccountBlockingAttempts"]))
						{
							$user->block($settings["SecurityAccountBlockingHours"]);
							$user->logOut();
							$order->newCart(0);
							$account_blocked = true;
							$backurl = $url_https."p=blocked";;
						}
					}
				}
			}
		}
	}
