<?php
/**
 * Process payment
 */	

	if (!defined("ENV")) exit();
	
	if ($user->auth_ok && $order->itemsCount > 0)
	{
		$payment = new PAYMENT($db);
		
		if ($payment->isMethods() && $payment->isMethod($order->paymentMethodId))
		{
			
			$pm = $payment->methods[$order->paymentMethodId];
				
			// custom payment methods
			if (trim($pm->id) != "")
			{
				$gate = $payment->methods[$order->paymentMethodId];
				$gateway_id = escapeFileName($gate->id);
				@require_once("content/engine/payment/payment_".($gateway_id).".php");
				
				if (isset($pp)) unset($pp);
				
				// create instance of payment processor (gateway) class
				@eval("\$pp = new ".$payment_processor_class."();");
					
				// set to true by defalt
				$is_payment_error = true;
	
				if (isset($pp) && is_object($pp))
				{
					$order->getShippingAddress();
					
					$pp->db_id = $order->paymentMethodId;
					$pp->protocol = $pm->protocol;
					$pp->getSettingsData($db);
					$pp->getCommonData($user, $order);
					$pp->isTestMode(); // force test mode check to possibly update URLs
					
					if ($pp->steps == 1)
					{
						//return entered values of background
						//orders processing
						$form = isset($_POST["form"]) ? $_POST["form"] : array();
						$form = is_array($form) ? $form : array();
					}
					else
					{
						//return POST VARS passed by 
						//payment gateway
						$form = $_REQUEST;
					}
						
					if ($result = $pp->process($db, $user, $order, $form))
					{
						/**
						 * GIFT CERTIFICATE HANDLING
						 */
						$giftCertificates = new GiftCertificates($db);
		
						// chech has used ordered a gift certificate
						$giftCertificateData = $giftCertificates->GetGiftCertificate($order->oid);
						if ($giftCertificateData !== false)
						{
							$giftCertificates->OrderGiftCertificate(
								$giftCertificateData['ocid'], $giftCertificateData['first_name'], $giftCertificateData['last_name'], $giftCertificateData['gift_amount'], $giftCertificateData['voucher']
							);
							if ($giftCertificateData['email_gift'] == '1')
							{
								$giftCertificates->SendNotification($order->oid);	
							}
						}
						
						// check is gift certificate used to place (fund) an order
						$giftCertificateAmountUsed = 0;
						if ($order->totalAmount > 0)
						{
							$orderData = $giftCertificates->GetOrderGiftCert($order->oid);
							if ($orderData['gift_cert_valid'] == '1')
							{
								$giftCertificateData = $giftCertificates->GetOrderedGiftCert($orderData['gift_cert_first_name'], $orderData['gift_cert_last_name'], $orderData['gift_cert_voucher']);
									
								if ($giftCertificateData !== false)
								{
									$giftCertificateAmountUsed = $order->totalAmount > $giftCertificateData['balance'] ? $giftCertificateData['balance'] : $order->totalAmount;
									$giftCertificates->UpdateBalance($order->oid, $giftCertificateData['ocid'], $giftCertificateAmountUsed);
									
									//when everything was paid by Gift Certificate, update payment method
									if ($giftCertificateAmountUsed >= $order->totalAmount)
									{
										$db->reset();
										$db->assignStr("payment_method_name", "Gift Certificate");
										$db->assignStr("payment_method_description", "Gift Certificate");
										$db->assignStr("payment_gateway_id", "");
										$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
										view()->assign("payment_method_name", "Gift Certificate");	
									}
								}
							}
						}
						
						view()->assign("gift_cert_amount", $giftCertificateAmountUsed);
	
						/**
						 * GIFT CERTIFICATE FINISH
						 */
						
						$is_payment_error = false;
						
						unset($_SESSION["payment_session_delay_timeout"]);
						
						$payment_status = in_array($result, array("Pending", "Received")) ? $result : "Received";
						
						// fix for http://dev.pinnaclecart.com/mantis/view.php?id=76
						if ($order->totalAmount == 0)
						{
							$payment_status = "Received";
						}
						
						if (($settings["InventoryStockUpdateAt"]=="Payment Received" && $payment_status == "Received") || $settings["InventoryStockUpdateAt"]=="Order Placed")
						{
							$order->stockControl(); //do not process stock without payment
						}
						
						// set the payment_method_description on the order
						if (array_key_exists('cc_type', $form) && isset($form['cc_type']) && trim($form['cc_type']) != '')
						{
							$order->paymentMethodDescription = $form['cc_type'];
						}
						else
						{
							$order->paymentMethodDescription = $order->paymentMethodName;
						}
						
						$db->reset();
						$db->assignStr("payment_method_description", $order->paymentMethodDescription);
						$db->update(DB_PREFIX.'orders', 'WHERE oid="'.$order->oid.'"');
						$order->order_num = $order->closeOrder($order->shippingDigital ? "Completed" : "Process", $payment_status);
							
						/**
						 * TODO: buysafe
						 */
						/**
						if ($settings["buysafe_active"] == "Yes")
						{
							$buysafe = new BuySafeAPI($settings);
							$result = $buysafe->setShoppingCartCheckout($user, $order, $db);
						}
						**/
						
						/**
		 				 * Insureship
		 				 */
						if ($settings["InsureShipActive"] == "Yes" && $order->insureShipActive && $order->insureShipAmount > 0)
						{
							require_once("content/classes/class.insureship.php");
							$insureShip = new InsureShip($settings["InsureShipAccountId"]);
							$insureShip->add($user, $order, $db);
						}	
						
						/**
						 * DOBA
						 */
						if (isset($_SESSION["doba_items_in_order"]) && $_SESSION["doba_items_in_order"] && $settings["doba_autosend_orders"] == "Yes")
						{
							$doba_items = array();
							foreach ($order->items as $item)
							{
								if ($item["is_doba"] == "Yes") $doba_items[] = array("item_id"=>$item["product_id"], "quantity"=>$item["quantity"]);
							}
							if (count($doba_items) > 0)
							{
								require_once("content/classes/class.doba_order.php");
								$dobaOrder = new DobaOrderAPI($settings, $db);
								
			 					$doba_order_response = $dobaOrder->createOrder($order->shippingAddress, $doba_items, $order->order_num);
			 	
							 	if ($doba_order_response)
			 					{
			 						$db->query("UPDATE ".DB_PREFIX."orders SET doba_order_sent=1, doba_order_id='".$db->escape($doba_order_response->response->order_id)."' WHERE oid='".$order->oid."'");
			 					}
							}
						}
						unset($_SESSION["doba_items_in_order"]);
						
						/**
						 * Send notifications
						 */
						emailOrderReceived($db, $order, $user, $customFields, $payment_status);
						
						// Drop Shipping
						if ($payment_status == "Received" && $settings["ProductsLocationsSendOption"] == "user")
						{
							emailProductsLocationsNotify($db, $order->oid);
						}

						$backurl = $url_https."pcsid=".session_id()."&p=completed";
						$pp->success();
					}
				}
							
				if ($is_payment_error)
				{
					$account_blocked = false;
					$payment->is_error = true;
					$payment->error_message = (isset($pp) && $pp) ? $pp->error_message : "Critical error: Could not create gateway class instance. Please contact to site administrator.";
					
					////////////////////////////////////////////
					// Check is engine set to block users accounts
					// Possible cc hack protection
					if ($settings["SecurityAccountBlocking"] == "YES")
					{
						if (!$order->attempt($settings["SecurityAccountBlockingAttempts"]))
						{
							$user->block($settings["SecurityAccountBlockingHours"]);
							$user->logOut();
							$order->newCart(0);
							$backurl = $url_https."p=blocked";
							$account_blocked = true;
						}
					}
				}
			}
		}
	}