<?php
/**
 * Process payment
 */

if (!defined("ENV")) exit();

if ($user->auth_ok && $order->itemsCount > 0)
{
	$paymentProvider = new Payment_Provider($db);

	$pp = $paymentProvider->getPaymentProcessor($order);

	if ($pp)
	{
		// set to true by default
		$is_payment_error = true;

		if ($pp->steps == 1)
		{
			//return entered values of background
			//orders processing
			$form = isset($_POST["form"]) ? $_POST["form"] : array();
			$form = is_array($form) ? $form : array();
		}
		else
		{
			//return POST VARS passed by
			//payment gateway
			$form = $_REQUEST;
		}

		if (isset($form['cc_type']))
		{
			$form['cc_type'] = str_replace(array('Yes~', 'No~'), array('', ''), $form['cc_type']);
		}

		if (isset($form['payment_profile_id']))
		{
			require_once("content/classes/class.payment_profile.php");
			$paymentProfileManager = new Payment_Profile();
			$paymentProfile = $paymentProfileManager->getPaymentProfileById($db, $user, $form['payment_profile_id']);
			$form['ext_profile_id'] = $paymentProfile['ext_profile_id'];
		}

		if (isset($form['cc_number']))
		{
			$form['cc_number'] = preg_replace('/\s+/', '', $form['cc_number']);
		}

		if (($result = $pp->process($db, $user, $order, $form)) != false)
		{
			/**
			 * Payment was successfull. Finish order now.
			 */

			$is_payment_error = false;

			$sendNotification = $pp->sendEmailNotification($result);

			$orderStatus = 'Process';

			if ($result === true)
			{
				$result = 'Received';
			}

			if ($order->shippingDigital && $result === 'Received')
			{
				$orderStatus = 'Completed';
			}

			$mobileOrder = MOBILE ? true : false;
			$orderSource = isset($_SESSION["osc_source"]) ? $_SESSION["osc_source"] : null;
			$offsiteCampaignId = isset($_SESSION["osc_campaign_id"]) ? $_SESSION["osc_campaign_id"] : null;

			OrderProvider::closeOrder($order, $form, $customFields, $orderStatus, $result,
				$mobileOrder, $orderSource, $offsiteCampaignId, $sendNotification);

			$backurl = $url_https."pcsid=".session_id()."&p=completed";
			$pp->success();

			if (isset($pp->reload_parent_on_process) && $pp->reload_parent_on_process)
			{
				?>
				<!DOCTYPE HTML>
				<html>
				<head>
					<script type="text/javascript">
						parent.location = "<?php echo $backurl; ?>";
					</script>
				</head>
				<body>
				</body>
				</html>
				<?php

				$db->done();
				_session_write_close();
				exit();
			}
		}


		$payment->redirect = $pp->redirect;
		$payment->redirectURL = $pp->redirectURL;

		if ($is_payment_error)
		{
			$payment->is_error = true;
			$payment->error_message = (isset($pp) && $pp) ? $pp->error_message : "Critical error: Could not create gateway class instance. Please contact to site administrator.";

			////////////////////////////////////////////
			// Check is engine set to block users accounts
			// Possible cc hack protection
			if ($settings["SecurityAccountBlocking"] == "YES")
			{
				if (!$order->attempt($settings["SecurityAccountBlockingAttempts"]))
				{
					$user->block($settings["SecurityAccountBlockingHours"]);
					$user->logOut();
					$order->newCart(0);
					ORDER::setCookie($order->getSecurityId());
					$account_blocked = true;
					$backurl = $url_https."p=blocked";;
				}
			}
		}
	}
}