<?php
/**
 * User signup
 */

	if (!defined("ENV")) exit();

	// try captcha first of all
	$captchaError = false;
	if ($settings['captchaMethod'] != 'None')
	{
		require_once('content/vendors/recaptcha/recaptchalib.php');
		$resp = recaptcha_check_answer(
			$settings['captchaReCaptchaPrivateKey'],
			$_SERVER["REMOTE_ADDR"],
			$_POST["recaptcha_challenge_field"],
			$_POST["recaptcha_response_field"]
		);
		if (!$resp->is_valid)
		{
			$user->setError("Please enter the valid CAPTCHA words");
			$captchaError = true;
		}
	}
	
	// try to process form
	$form = isset($_POST["form"]) ? $_POST["form"] : array();
	$form = is_array($form) ? $form : array();

	$customFieldsData = isset($_POST["custom_field"]) ? $_POST["custom_field"] : array();
	
	$user_id = ($user->auth_ok && $user->express) ? $user->id : false;
	
	if (!$captchaError && $user->signUp($form, $customFieldsData, $user_id))
	{
		emailNewUserRegistered($db, $user->id, $customFields);

		$user->login($form["login"], $form["password"]);
	
		if ($user->auth_ok)
		{
			if (MOBILE)
			{
				$backurl = $url_https."p=cart";
			}
			elseif (isset($_SESSION["wl_pid"]))
			{	
				$backurl = $url_https."ua=".USER_ADD_TO_WISHLIST."&wl_action=addto_wishlist&pid=".$_SESSION["wl_pid"];

				unset($_SESSION["wl_pid"]);
			}
			elseif (isset($_SESSION["user_started_checkout"]))
			{
				$backurl = $url_https."oa=".ORDER_ONE_PAGE_CHECKOUT;
			}
			else
			{				
				$backurl = $url_https."p=account";
			}
		
			//set tracking cookie
			$user->setCookie();
			
			session_regenerate_id(true);

			// if http and https domain names are different, set cookie on http site too
			if ($user->isCrossDomainCookieRequired())
			{
				$backurl = $user->getCrossDomainCookieUrl($url_http, $backurl);
			}

			unset($_SESSION["user_started_checkout"]);
		}
	}
