$(document).ready(function(){
	OnePageCheckout().init();
});

var opc_billingDataSet = false;
var opc_paymentFormSet = false;
var opc_shippingAddressSet = false;
var opc_shippingMethodSet = true;
var opc_giftCertificateSet = true;
var opc_finalTotal = 0;
var opc_spinnerTimeout = null;
var opc_auto_show_popup = false;
var opc_bongoOnly = false;

/**
 * Init one page checkout
 */
function opc_init()
{
	if (top.location != self.location)
	{
		top.location = self.location;
	}

	try
	{
		$("#opc-error").hide();
		/**
		 * Init cart items view toggle - this works all the time.. 
		 */
		$("#cart-items-toggle").click(function(){
			$("#cart-items").toggle("fast", function(){
				var visible = $("#cart-items").is(':visible')
				if (!$.mobile)
				{
					$("#cart-items-toggle").html(visible ? msg.opc_invoice_click_to_hide : msg.opc_invoice_click_to_view);
				}
				else
				{
					$("#cart-items-toggle").attr('value', visible ? msg.opc_invoice_click_to_hide : msg.opc_invoice_click_to_view);
					$("#cart-items-toggle").parent('.ui-btn:first').find('.ui-btn-text').html(visible ? msg.opc_invoice_click_to_hide : msg.opc_invoice_click_to_view);
				}

				$.cookie('opc-cart-items-visible', visible ? '1' : '0');
			});
			return false;
		});

		// correction for slide down - works better this way
		if ($("#cb-create-account").length > 0)
		{
			$("#opc-billing-form").show();
			$("#opc-account-inner").show();
			$("#opc-account-inner").css('height', $("#opc-account-inner").height() + 10);
			$("#opc-billing-form").hide();
			$("#opc-account-inner").hide();

			$("#cb-create-account").change(function(){
				if ($(this).is(":checked"))
				{
					$("#opc-account-inner").slideDown('fast');
				}
				else
				{
					$("#opc-account-inner").slideUp('fast');
				}
			});
		}

		$("#opc-form-shipping").submit(function(){
			return false;
		})

		if ($.cookie('opc-cart-items-visible') != null && $.cookie('opc-cart-items-visible') == "1")
		{
			if (!$.mobile)
			{
				$("#cart-items-toggle").html(msg.opc_invoice_click_to_hide);
			}
			else
			{
				$("#cart-items-toggle").val(msg.opc_invoice_click_to_hide);
				$("#cart-items-toggle").parent('.ui-btn:first').find('.ui-btn-text').html(msg.opc_invoice_click_to_hide);
			}
			$("#cart-items").show();
		}
		else
		{
			if (!$.mobile)
			{
				$("#cart-items-toggle").html(msg.opc_invoice_click_to_view);
			}
			else
			{
				$("#cart-items-toggle").val(msg.opc_invoice_click_to_view);
				$("#cart-items-toggle").parent('.ui-btn:first').find('.ui-btn-text').html(msg.opc_invoice_click_to_view);
			}
			$("#cart-items").hide();
		}

		/**
		 * check "stoppers"
		 */
		if (opcData.paymentMethodsCount < 1)
		{
			$('#opc-invoice-totals').hide();
			OnePageCheckout().showError(msg.opc_error_no_payment_methods);
			return;
		}

		/**
		 * init progress dialog
		 */
		$("#opc-dialog-spinner").data('counter', 0);
		
		if (!$.mobile)
		{
			$("#opc-dialog-spinner").data('counter', 0).dialog({
				width:400,
				height:110,
				modal:true,
				autoOpen:false,
				resizable:false,
				closeOnEscape:false,
				draggable:false
			});
			$("#opc-dialog-spinner").parent().find('.ui-dialog-titlebar').remove();
		}
	
		OnePageCheckout().showSpinnerDelayed();

		/**
		 * init login dialog
		 */
		if (!$.mobile)
		{
			$("#opc-dialog-login").data('counter', 0).dialog({
				width:370,
				height:220,
				modal:true,
				autoOpen:false,
				resizable:false,
				closeOnEscape:true,
				draggable:false,
				open:function(){
					$("#opc-dialog-login .button-login").attr('default', 'default');
				}
			});

			$("#opc-dialog-login").parent().find('.ui-dialog-titlebar').remove();
		}
		
		$("#opc-form-login").submit(function(){
			OnePageCheckout().doLogin();
			return false;
		});
		
		$("#opc-link-login").click(function(){
			if (!$.mobile)
			{
				$("#opc-dialog-login").dialog('open');
			}
			else
			{
				$("#opc-dialog-login").show();
			}
			return false;
		});

		$("#opc-dialog-login .button-close").click(function(){
			if (!$.mobile)
			{
				$("#opc-dialog-login").dialog('close');
			}
			else
			{
				$("#opc-dialog-login").hide();
			}
		});

		/**
		 * Init billing form & view
		 */
		OnePageCheckout().setBillingForm(opcData.billingData);
		OnePageCheckout().setBillingView(opcData.billingData);

		if (opcData.billingIsEmpty)
		{
			//In normal conditions will be empty only for user checkout without account
			$("#opc-billing-view").hide();
			$("#opc-billing-form").show();
			$("#opc-shipping-as-billing").show();
			
			if ($('.opc-input-shipping-as-billing').attr('type') == 'radio')
			{
				$('#opc-radio-shipping-as-billing-' + (opcData.shippingAsBillingDefault ? 'yes' : 'no')).attr('checked', 'checked')
			}
			else
			{
				$('#opc-select-shipping-as-billing').val(opcData.shippingAsBillingDefault ? '1' : '0');
			}

			$("#opc-billing-form").data("changed", true);
			$("#opc-shipping-address-form .buttons").hide();

			//in this case we also have to hide everything under billing form to do not confuse user
			$("#opc-additional-inner").hide();
			$("#opc-additional h3:first").addClass('light');

			$("#opc-shipping-inner").hide();
			$("#opc-shipping h3:first").addClass('light');

			$("#opc-payment-inner").hide();
			$("#opc-payment h3:first").addClass('light');
		}
		else
		{
			$("#opc-billing-form").hide();
			$("#opc-billing-view").show();
			$("#opc-shipping-as-billing").hide();
			opc_billingDataSet = true;
		}

		$("#opc-billing-form-button-save").click(function(){
			OnePageCheckout().saveBillingData();
			return false;
		});

		/**
		 * Payment Profiles
		 */
		OnePageCheckout().setPaymentProfiles();

		/**
		 * Additional information
		 */
		if ($('#opc-add-gift-message').is(':checked'))
		{
			$("#opc-gift-message").show();
		}
		else
		{
			$("#opc-gift-message").hide();
		}
		
		$('#opc-additional-inner form').submit(function(){
			return false;
		});

		$('#opc-add-gift-message').change(function(){
			if ($('#opc-add-gift-message').is(':checked'))
			{
				$("#opc-gift-message").slideDown();
			}
			else
			{
				$("#opc-gift-message").slideUp();
			}
		});
		
		$('#opc-gift-message textarea').bind('keyup change', function(event){
			event.stopPropagation();
			var s = $(this).val();
			if (s.length > opcData.giftMessageLength)
			{
				$(this).val(s.substr(0, opcData.giftMessageLength));	
			}
		});

		$('#opc-gift-message textarea').autoResize({
			// On resize:
			onResize : function() {
				$(this).css({opacity:0.8});
			},
			// After resize:
			animateCallback : function() {
				$(this).css({opacity:1});
			},
			// Quite slow animation:
			animateDuration : 300,
			// More extra space:
			extraSpace : 40
		});

		/**
		 * Init shipping form and view
		 */
		var setPreview = true;

		if (opcData.shippingIsDigital)
		{
			$("#opc-shipping-inner,#opc-shipping,#opc-shipping-as-billing").hide();
			$("#opc-shipping h3:first").addClass('light');

			opc_shippingAddressSet = true;
			OnePageCheckout().initPayment();
		}	
		else
		{
			//get previously selected shipping method id
			if ($.cookie('opc-shipping-method-id') != null && $.cookie('opc-shipping-method-id') != undefined)
			{
				opcData.shippingMethodId = $.cookie('opc-shipping-method-id');
			}
			
			//set shipping address book 
			OnePageCheckout().setShippingAddressBook(opcData.shippingAddressBook);

			//set current shipping selection
			$("#opc-shipping-address-id-" + opcData.shippingAddressId).attr("checked", true);

			//if billing is empty - show options
			if (opcData.shippingIsEmpty)
			{
				$("#opc-shipping-address-view").hide();
				$("#opc-shipping-address-form-new").hide();
				$("#opc-shipping-address-form").show();
				$("#opc-shipping-address-form .buttons").show();
			}
			//else preset address
			else
			{
				$("#opc-shipping-address-form").hide();
				$("#opc-shipping-address-form-new").hide();
				$("#opc-shipping-address-view").show();
				opc_shippingAddressSet = true;
			}

			if ($("#opc-shipping-address-form input[type='radio'][name='shipping-address-id']:checked").length < 1)
			{
				$("#opc-shipping-address-form input[type='radio'][name='shipping-address-id']:first").attr('checked', 'checked');
			}
			else if (opcData.shippingAddressId == "new")
			{
				$("#opc-shipping-address-form-new").show();
			}
			
			//update selected shipping address in mobile app
			if ($.mobile)
			{
				$("#opc-shipping-address-form input[name='shipping-address-id']").checkboxradio('refresh');
			}

			//update shipping addresses preview
			OnePageCheckout().setShippingAddressView(opcData.shippingAddress);
			OnePageCheckout().setNewShippingAddressForm(opcData.shippingAddress);

			//handle address change
			$("#opc-shipping-address-form input[name='shipping-address-id']").each(function(){
				$(this).change(function(){
					opcData.shippingAddressId = $(this).val();

					if ($(this).val() == "billing" && $("#opc-billing-form").is(":visible"))
					{
						$("#opc-shipping-address-form .buttons").hide();
					}
					else
					{
						$("#opc-shipping-address-form .buttons").show();
					}

					if ($(this).val() == "new")
					{
						$("#opc-shipping-address-form-new").show();
					}
					else
					{
						$("#opc-shipping-address-form-new").hide();
					}
					$("#opc-shipping-address-form").data("changed", true);
					opc_shippingAddressSet = false;
				});
			});
			
			//handle new shipping address save button
			$("#opc-shipping-address-form-button-save").click(function(){
				OnePageCheckout().saveShippingAddress();
				return false;
			});
			
			//handle new shipping address edito button
			$("#opc-shipping-address-form-button-edit").click(function(){
				OnePageCheckout().editShippingAddress();
				return false;
			});

			//if country is known, trying to get shipping methods
			if (opcData.shippingAddress.country_id != null && opcData.shippingAddress.country_id != '0')
			{
				$("#opc-payment-methods,#opc-payment-methods-free").hide();
				setPreview = false;
				OnePageCheckout().getShippingMethods(function(){
					OnePageCheckout().initPayment();
				});
			}
			else
			{
				OnePageCheckout().initPayment();	
			}
		}
		
		if (!opcData.billingIsEmpty)
		{
			$("#opc-additional-inner").show();
			$("#opc-additional h3:first").removeClass('light');

			$("#opc-shipping-inner").show();
			$("#opc-shipping h3:first").removeClass('light');
		}
	}
	catch (err)
	{
		alert(err);
		OnePageCheckout().hideSpinner();
	}
}

/**
 * Init payment
 */
function opc_initPayment()
{
	OnePageCheckout().setPromoCodeForm();
	OnePageCheckout().setPaymentMethods(opcData.paymentMethods);
	OnePageCheckout().getPaymentForm(true);
	OnePageCheckout().setCompleteButton();

	$("#opc-button-complete").unbind('click');
	$("#opc-button-complete").click(function(e){
		e.stopPropagation();
		OnePageCheckout().processPayment();
	});

	OnePageCheckout().setInvoicePreview(); // or wait until shipping methods returned
	OnePageCheckout().hideSpinner();
}

/**
 * Show error message
 */
function opc_showError(errorMessage)
{
	try
	{
		$("#opc-billing").hide();
		$("#opc-shipping").hide();
		$("#opc-shipping h3:first").addClass('light');
		$("#opc-payment").hide();
		$("#opc-payment h3:first").addClass('light');
		$("#opc-error-message").html(errorMessage);
		$("#opc-error").show();
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Send request to a server
 * @param _action
 * @param _data
 * @param _handler
 * @param _message
 * @return
 */
function opc_sendRequest(_action, _data, _handler, _message)
{
	try
	{
		OnePageCheckout().showSpinnerDelayed(_message);

		$.post(
			site_https_url,
			{
				oa: 'OnePageCheckout',
				action: _action,
				data: JSON.stringify(_data)
			},
			/**
			 * Process response here
			 */
			function (response)
			{
				try
				{
					OnePageCheckout().hideSpinner();

					hasResult = true;
					if (response && response != null && $.trim(response).length >= 0 && $.trim(response).charAt(0) == '{')
					{
						response = JSON.parse(response);
						if (response.result == null)
						{
							hasResult = false;
						}
						else
						{
							if (response.result != null && !response.result)
							{
								var _msg = "";
								jQuery.each(response.errors, function(errKey, errMsg){
									_msg = _msg + (_msg == "" ? "" : "\n") + '- ' + errMsg;
								});
								alert(_msg);
							}

							if (_handler != undefined && _handler != null)
							{
								_handler(response);
							}

							if (response.data.orderData != undefined && response.data.orderData != null)
							{
								var od = response.data.orderData;
								if (od.subtotalAmount != undefined) opcData.orderData.subtotalAmount = od.subtotalAmount*1;
								if (od.subtotalAmountWithTax != undefined) opcData.orderData.subtotalAmountWithTax = od.subtotalAmountWithTax*1;
								if (od.promoDiscountAmount != undefined) opcData.orderData.promoDiscountAmount = od.promoDiscountAmount*1;
								if (od.promoDiscountValue != undefined) opcData.orderData.promoDiscountValue = od.promoDiscountValue*1;
								if (od.promoDiscountType != undefined) opcData.orderData.promoDiscountType = od.promoDiscountType;
								if (od.promoType != undefined) opcData.orderData.promoType = od.promoType;
								if (od.shippingAmount != undefined) opcData.orderData.shippingAmount = od.shippingAmount*1;
								if (od.handlingSeparated != undefined) opcData.orderData.handlingSeparated = od.handlingSeparated*1;
								if (od.handlingSeparatedWhenShippingNotFree != undefined) opcData.orderData.handlingSeparatedWhenShippingNotFree = od.handlingSeparatedWhenShippingNotFree*1;
								if (od.handlingSeparatedWhenShippingFree != undefined) opcData.orderData.handlingSeparatedWhenShippingFree = od.handlingSeparatedWhenShippingFree*1;
								if (od.handlingAmount != undefined) opcData.orderData.handlingAmount = od.handlingAmount*1;
								if (od.handlingAmountWhenShippingFree != undefined) opcData.orderData.handlingAmountWhenShippingFree = od.handlingAmountWhenShippingFree*1;
								if (od.handlingAmountWhenShippingNotFree != undefined) opcData.orderData.handlingAmountWhenShippingNotFree = od.handlingAmountWhenShippingNotFree*1;
								if (od.handlingTaxable != undefined) opcData.orderData.handlingTaxable = od.handlingTaxable*1;
								if (od.handlingTaxRate != undefined) opcData.orderData.handlingTaxRate = od.handlingTaxRate*1;
								if (od.handlingTaxDescription != undefined) opcData.orderData.handlingTaxDescription = od.handlingTaxDescription;
								if (od.taxAmount != undefined) opcData.orderData.taxAmount = od.taxAmount*1; // note - does not include shipping tax and handling tax
								if (od.totalAmount != undefined) opcData.orderData.totalAmount = od.totalAmount*1;
								if (od.subtotalAmount != undefined) opcData.orderData.subtotalAmount = od.subtotalAmount*1;
								if (od.shippingTaxable != undefined) opcData.orderData.shippingTaxable = od.shippingTaxable*1;
								if (od.shippingTaxRate != undefined) opcData.orderData.shippingTaxRate = od.shippingTaxRate*1;
								if (od.shippingTaxDescription != undefined) opcData.orderData.shippingTaxDescription = od.shippingTaxDescription;

								OnePageCheckout().setInvoicePreview();
							}
						}
					}
					else
					{
						hasResult = false;
					}

					if (!hasResult)
					{
						alert(msg.opc_error_cannot_process_response);
					}
					OnePageCheckout().setCompleteButton();
				}
				catch (err)
				{
					alert(err);
					OnePageCheckout().hideSpinner();
				}
			}//,
			//"json"
		);
	}
	catch (err)
	{
		alert(err);
		OnePageCheckout().hideSpinner();
	}
}

/**
 * Shows spinner
 * @param _msg
 */
function opc_showSpinner(_msg)
{
	try
	{
		var counter = $("#opc-dialog-spinner").data('counter');
		if (_msg == null) _msg = 'Updating data';
		$("#opc-dialog-spinner .spinner-message").html(_msg).show();
		if (!$.mobile)
		{
			$("#opc-dialog-spinner").dialog('open');
		}
		else
		{
			var offset = $(document).scrollTop()+"px";	
			$("#opc-dialog-spinner").css('top', offset);
			$("#opc-dialog-spinner").show();
		}
	}
	catch (err)
	{
		alert(err);
	}
}

function opc_showSpinnerDelayed(_msg)
{
	try
	{
		opc_showSpinner(_msg);
		//if (opc_spinnerTimeout == null) opc_spinnerTimeout = setTimeout('opc_showSpinner("' + _msg + '");', 1);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Hides spinner
 */
function opc_hideSpinner()
{
	try
	{
		if (opc_spinnerTimeout != null)
		{
			clearTimeout(opc_spinnerTimeout);
			opc_spinnerTimeout = null;
		}
		var counter = $("#opc-dialog-spinner").data('counter');
		counter = counter - 1;
		if (counter <= 0)
		{
			counter = 0;
			if (!$.mobile)
			{
				$("#opc-dialog-spinner").dialog('close');
			}
			else
			{
				$("#opc-dialog-spinner").hide();	
			}
		}
		$("#opc-dialog-spinner").data('counter', counter);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Corrects dialog position on open
 * @param selector
 */
function opc_correctDialogPosition(selector)
{
	try
	{
		var t = ($(window).height() - parseInt($(selector).parent().height())) / 2;
		if (t < 0) t = 0;
		$(selector).parent().css('top', parseInt(t) + 'px');
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Show login form and process login action
 * @return
 */
function opc_doLogin()
{
	try
	{
		OnePageCheckout().sendRequest(
			"doLogin",
			{
				'username' : $("#opc-dialog-login .login-username").val(),
				'password' : $("#opc-dialog-login .login-password").val()
			},
			function (response)
			{
				if (response.result)
				{
					if (!$.mobile)
					{
						$("#opc-dialog-login").dialog('close');
					}
					OnePageCheckout().showSpinnerDelayed(msg.opc_login_successfull);
					document.location = document.location;
				}
				else
				{
					$(".login-username").focus();
				}
			},
			msg.opc_checking_credentials
		);

		return false;
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Sets billing address from array into form
 * @param billingData
 * TODO: add html special chars
 */
function opc_setBillingForm(billingData)
{
	try
	{
		//set form
		jQuery.each(billingData, function(fieldName, fieldValue){
			$("#opc-billing-form-" + fieldName).val(fieldValue);
			$("#opc-billing-form-" + fieldName).change(function(){
				$("#opc-billing-form").data("changed", true);
				opc_billingDataSet = false;
				OnePageCheckout().setCompleteButton();
			});
		});

		//check custom fields changes
		$("#opc-billing-form .custom-field, #cb-create-account").each(function(){
			$(this).change(function(){
				$("#opc-billing-form").data("changed", true);
				opc_billingDataSet = false;
				OnePageCheckout().setCompleteButton();
			});
		});

		//set countries and states
		setCountriesStates(
			"#field-billing-country", billingData.country,
			"#field-billing-state", billingData.state,
			"#field-billing-province", billingData.province,
			countriesStates
		);
		
		//refresh mobile controls state
		if ($.mobile)
		{
			$("#opc-billing-form input[type='radio'][type='checkbox']").each(function(i, c){
				$(c).checkboxradio('refresh');
			});
			$("#opc-billing-form select").each(function(i, c){
				$(c).selectmenu('refresh');	
			});
		}

		$("#opc-billing-form").data("changed", false);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Recalculates invoice amounts and shows totals
 */
function opc_setInvoicePreview()
{
	try
	{
		// Subtotal
		$("#opc-invoice-subtotal").html(OnePageCheckout().getPrice(
			opcData.displayPricesWithTax ? opcData.orderData.subtotalAmountWithTax*1 : opcData.orderData.subtotalAmount*1
		));
		
		// Shipping amount for standard methods
		opcData.orderData.shippingAmount = 0;
		var handlingIncluded = false;
		if (opcData.shippingMethods != undefined && opcData.shippingMethods != null && opcData.shippingMethods)
		{
			// Shipping price at product level
			if (opcData.shippingMethods.shipping_price_at_product_level != undefined && opcData.shippingMethods.shipping_price_at_product_level != null && opcData.shippingMethods.shipping_price_at_product_level > 0)
			{
				opcData.orderData.shippingAmount += opcData.shippingMethods.shipping_price_at_product_level * 1;
			}

			// Shipping price based on method
			if (opcData.shippingMethods.shipping_methods != undefined && opcData.shippingMethods.shipping_methods != null)
			{
				jQuery.each(opcData.shippingMethods.shipping_methods, function(key, shippingMethod){
					if (shippingMethod.ssid == opcData.shippingMethodId)
					{
						opcData.orderData.shippingAmount += shippingMethod.shipping_price * 1;
					}
				});
			}
		}

		// Shipping amount for alternative methods
		if (opcData.shippingMethodsAlternative != undefined && opcData.shippingMethodsAlternative != null && opcData.shippingMethodsAlternative)
		{
			// Shipping price based on method
			if (opcData.shippingMethodsAlternative.shipping_methods != undefined && opcData.shippingMethodsAlternative.shipping_methods != null)
			{
				jQuery.each(opcData.shippingMethodsAlternative.shipping_methods, function(key, shippingMethod){
					if ('a' + shippingMethod.ssid == opcData.shippingMethodId)
					{
						opcData.orderData.shippingAmount += shippingMethod.shipping_price * 1;
					}
				});
			}
		}

		// Check promo discount (AFTER SHIPPING, as it may effect shipping now)
		if (opcData.orderData.promoDiscountValue != undefined && opcData.orderData.promoDiscountValue != null)
		{
			if (opcData.orderData.promoType == 'Shipping')
			{
				if (opcData.orderData.promoDiscountType == 'percent')
				{
					opcData.orderData.promoDiscountAmount = opcData.orderData.shippingAmount / 100 * opcData.orderData.promoDiscountValue;
				}
				else
				{
					opcData.orderData.promoDiscountAmount = opcData.orderData.promoDiscountValue > opcData.orderData.shippingAmount ? opcData.orderData.shippingAmount : opcData.orderData.promoDiscountValue;
				}
			}
		}

		// Discounts
		if (opcData.orderData.discountAmount > 0)
		{
			$("#opc-invoice-discount").html('-' + OnePageCheckout().getPrice(opcData.orderData.discountAmount));
			$("#opc-invoice-discount-row").show();
		}
		else
		{
			$("#opc-invoice-discount-row").hide();
		}

		// Promo discount
		if (opcData.orderData.promoDiscountAmount > 0)
		{
			$("#opc-invoice-promo,#opc-invoice-promo-shipping").html('-' + OnePageCheckout().getPrice(opcData.orderData.promoDiscountAmount));
			opcData.orderData.promoType == 'Shipping' ? $("#opc-invoice-promo-row-shipping").show() : $("#opc-invoice-promo-row").show();
		}
		else
		{
			$("#opc-invoice-promo-row").hide();
			$("#opc-invoice-promo-row-shipping").hide();
		}

		// Show shipping amount
		if (opcData.orderData.shippingAmount > 0)
		{
			opcData.orderData.handlingSeparated = opcData.orderData.handlingSeparatedWhenShippingNotFree;
			
			opcData.orderData.handlingAmount = opcData.orderData.handlingAmountWhenShippingNotFree;
			if (opcData.orderData.shippingTaxable && opcData.displayPricesWithTax)
			{
				if (opcData.orderData.handlingSeparated)
				{
					$("#opc-invoice-shipping").html(OnePageCheckout().getPrice(
						opcData.orderData.shippingAmount + opcData.orderData.shippingAmount / 100 * opcData.orderData.shippingTaxRate
					));
				}
				else
				{
					//calc shipping and handling and their taxes separately
					var shippingAmount = opcData.orderData.shippingAmount - opcData.orderData.handlingAmount;
					var totalShippingAmountWithTax = shippingAmount + shippingAmount / 100 * opcData.orderData.shippingTaxRate;
					if (opcData.orderData.handlingTaxable)
					{
						totalShippingAmountWithTax =
							totalShippingAmountWithTax + opcData.orderData.handlingAmount +
							opcData.orderData.handlingAmount / 100 * opcData.orderData.handlingTaxRate;
					}
					else
					{
						totalShippingAmountWithTax = totalShippingAmountWithTax + opcData.orderData.handlingAmount;
					}
					$("#opc-invoice-shipping").html(OnePageCheckout().getPrice(totalShippingAmountWithTax));
				}
			}
			else
			{
				$("#opc-invoice-shipping").html(OnePageCheckout().getPrice(opcData.orderData.shippingAmount));
			}
			$("#opc-invoice-shipping-row").show();
		}
		else
		{
			opcData.orderData.handlingAmount = opcData.orderData.handlingAmountWhenShippingFree;
			opcData.orderData.handlingSeparated = opcData.orderData.handlingSeparatedWhenShippingFree;
			$("#opc-invoice-shipping-row").hide();
		}

		// Show InsureShip
		if (opcData.orderData.insureShipActive && opcData.orderData.insureShipAmount > 0)
		{
			$("#opc-invoice-insureship").html(OnePageCheckout().getPrice(
				opcData.orderData.insureShipAmount
			));
			$("#opc-invoice-insureship-row").show();
		}
		else
		{
			$("#opc-invoice-insureship-row").hide();
		}

		// Handling amount
		if (opcData.orderData.handlingSeparated && opcData.orderData.handlingAmount > 0)
		{
			if (opcData.orderData.handlingTaxable && opcData.displayPricesWithTax)
			{
				$("#opc-invoice-handling").html(OnePageCheckout().getPrice(
					opcData.orderData.handlingAmount + opcData.orderData.handlingAmount / 100 * opcData.orderData.handlingTaxRate
				));
			}
			else
			{
				$("#opc-invoice-handling").html(OnePageCheckout().getPrice(opcData.orderData.handlingAmount));
			}
			$("#opc-invoice-handling-row").show();
		}
		else
		{
			$("#opc-invoice-handling-row").hide();
		}

		// Tax amount
		var shippingAmount = opcData.orderData.shippingAmount - (opcData.orderData.handlingSeparated * 1 ? 0 : opcData.orderData.handlingAmount * 1);
		var handlingTaxAmount = opcData.orderData.handlingTaxable ? opcData.orderData.handlingAmount / 100 * opcData.orderData.handlingTaxRate : 0;
		var shippingTaxAmount = opcData.orderData.shippingTaxable ? shippingAmount / 100 * opcData.orderData.shippingTaxRate : 0;
		var tax = opcData.orderData.taxAmount + handlingTaxAmount + shippingTaxAmount;

		if (tax > 0)
		{
			$("#opc-invoice-tax").html(OnePageCheckout().getPrice(tax));
			
			if (opcData.displayPricesWithTax)
			{
				$("#opc-invoice-tax-row td:first").html(msg.opc_tax_included_in_total);
				var a = $("#opc-invoice-tax-row").clone();
				$("#opc-invoice-tax-row").remove();
				$(a).insertAfter("#opc-invoice-total-row").add();
			}
			
			$("#opc-invoice-tax-row").show();
		}
		else
		{
			$("#opc-invoice-tax-row").hide();
		}

		// Total amount
		var subtotalAmount = opcData.orderData.subtotalAmount * 1 ;
		var discountAmount = opcData.orderData.discountAmount * 1;
		var promoDiscountAmount = opcData.orderData.promoDiscountAmount * 1;

		if (subtotalAmount - discountAmount - (opcData.orderData.promoType == 'Shipping' ? 0 : promoDiscountAmount) < 0)
		{
			discountAmount = 0;
			promoDiscountAmount = opcData.orderData.promoType == 'Shipping' ? promoDiscountAmount : 0;
			subtotalAmount = 0;
		}

		opcData.orderData.totalAmount =
			subtotalAmount -
			discountAmount -
			promoDiscountAmount +
			opcData.orderData.shippingAmount * 1 +
			(opcData.orderData.handlingSeparated ? opcData.orderData.handlingAmount * 1 : 0) +
			(opcData.orderData.insureShipActive ? opcData.orderData.insureShipAmount * 1 : 0) +
			opcData.orderData.taxAmount * 1 +
			(opcData.orderData.handlingTaxable ? opcData.orderData.handlingAmount / 100 * opcData.orderData.handlingTaxRate : 0) +
			(opcData.orderData.shippingTaxable && opcData.orderData.shippingAmount > 0 ? (opcData.orderData.shippingAmount - (opcData.orderData.handlingSeparated * 1 ? 0 : opcData.orderData.handlingAmount * 1)) / 100 * opcData.orderData.shippingTaxRate : 0);

		
		$("#opc-invoice-total").html(OnePageCheckout().getPrice(opcData.orderData.totalAmount));

		opc_finalTotal = opcData.orderData.totalAmount;

		if (opc_finalTotal > 0)
		{
			$("#opc-payment-methods-free").hide();
			$("#opc-payment-methods").show();
			
			// Gift certificate amount
			if (opcData.orderData.giftCertificateAmount > 0)
			{
				var giftCertificateAmountUsed = opcData.orderData.totalAmount > opcData.orderData.giftCertificateAmount ? opcData.orderData.giftCertificateAmount : opcData.orderData.totalAmount;
				var orderRemainingAmount = opcData.orderData.totalAmount - giftCertificateAmountUsed;

				$("#opc-invoice-gift-certificate").html(OnePageCheckout().getPrice(giftCertificateAmountUsed));
				$("#opc-invoice-gift-certificate-row").show();

				$("#opc-invoice-remaining").html(OnePageCheckout().getPrice(orderRemainingAmount));
				$("#opc-invoice-remaining-row").show();

				opc_finalTotal = orderRemainingAmount;

				var html =
					'<strong>' + msg.opc_gift_certificate + '</strong>' +
					'<div class="spacer">' +
						'Total  amount on your gift certificate is ' + OnePageCheckout().getPrice(opcData.orderData.giftCertificateAmount) + '.<br/>' +
						OnePageCheckout().getPrice(giftCertificateAmountUsed) + ' will be used for current order. ';

				if (orderRemainingAmount > 0)
				{
					html = html + 'You still have to pay ' + OnePageCheckout().getPrice(orderRemainingAmount) + '. Please select payment method and complete order.';
				}
				else
				{
					html = html + 'No additional payment required for this order. Please click "Place Order" button to complete.'
				}
				html = html + '</div>';

				$("#opc-gift-certificate-view").html(html);

				// Show / hide payment methods depending on remaining amount.
				if (orderRemainingAmount > 0)
				{
					opc_paymentFormSet = opcData.paymentMethodId != 'gift-certificate';
					opc_giftCertificateSet = true;
					$("#opc-payment-methods-list").show();
				}
				else
				{
					$("#opc-payment-method-gift-certificate").attr("checked", "checked");
					$("#opc-payment-methods-list").hide();
					$("#opc-payment-method-form").hide();

					$("#opc-gift-certificate-form").hide();
					$("#opc-gift-certificate-view").show();
					opc_paymentFormSet = true;
					opc_giftCertificateSet = true;
				}
			}
			else
			{
				$("#opc-invoice-gift-certificate-row").hide();
				$("#opc-invoice-remaining-row").hide();
			}

			if ($("#opc-payment-methods-form input[name='payment-method-id']:checked").length > 0)
			{
				opcData.paymentMethodId = $("#opc-payment-methods-form input[name='payment-method-id']:checked").val();
			}
			else
			{
				opcData.paymentMethodId = $("#opc-payment-methods-form input[name='payment-method-id']:first").val();
			}
		}
		else
		{
			$("#opc-payment-methods").hide();
			$("#opc-payment-methods-free").show();
			opcData.paymentMethodId = 'free';
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Sets billing address from array to view
 * @param billingData
 * TODO: add html special chars
 */
function opc_setBillingView(billingData)
{
	try
	{
		var htmlAddress =
			billingData.fname + ' ' + billingData.lname + '<br/>' +
			(jQuery.trim(billingData.company) != '' ? billingData.company + '<br/>' : '') +
			billingData.address1 + '<br/>' +
			(jQuery.trim(billingData.address2) != '' ? billingData.address2 + '<br/>' : '') +
			billingData.city + ', ' + (billingData.state > 0 ? billingData.state_name : billingData.province) + ', ' + billingData.zip + '<br/>' +
			billingData.country_name;
		
		var editLink = '';
		
		if (!$.mobile)
		{
			editLink = '<div class="gap-top gap-bottom"><a href="#" id="opc-billing-edit-link">' + msg.opc_edit_billing_address + '</a></div>';
		}
		else
		{
			editLink = '<div><a href="#" data-role="button" id="opc-billing-edit-link">' + msg.opc_edit_billing_address + '</a></div>'; 
		}

		var htmlContacts =
			(billingData.phone != "" ? 'Phone: ' + billingData.phone + '<br/>' : '') +
			billingData.email;

		$("#opc-billing-view-address").html(htmlAddress + ($.mobile ? '' : editLink));
		$("#opc-billing-view-contacts").html(htmlContacts + ($.mobile ? editLink : ''));
		$("#opc-billing-edit-link").click(function(){OnePageCheckout().editBillingData();return false;});
		if ($.mobile)
		{
			$("#opc-billing-edit-link").button();
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Validates / saves billing information
 */
function opc_saveBillingData()
{
	try
	{
		var revalidateForm = $("#opc-billing-form .required .custom-field").length > 0
		
		// check are there changes or form must be revalidated
		if ($("#opc-billing-form").data("changed") || revalidateForm)
		{
			opc_billingDataSet = false;

			// check is shipping address the same as billing
			if ($('#opc-shipping-as-billing').is(':visible'))
			{
				// check first option when billing address is empty
				if ($('.opc-input-shipping-as-billing').attr('type') == 'radio')
				{
					var shippingAsBilling = $('#opc-radio-shipping-as-billing-yes').is(':checked');
				}
				else
				{
					var shippingAsBilling = $('#opc-select-shipping-as-billing').val() == '1';
				}
			}
			else
			{
				// check second option, when selected in address select
				var shippingAsBilling = $("#opc-shipping-address-id-billing").is(":checked");
			}

			// save billing data
			OnePageCheckout().sendRequest(
				"saveBillingData",
				{
					'billingForm' : $("#opc-billing-form form").serialize(),
					'shippingAsBilling' : shippingAsBilling
				},
				function (response)
				{
					if (response.result)
					{
						$('#opc-shipping-as-billing').hide();

						// check are there address variants
						if (response.data.shippingAddressVariants != null && response.data.shippingAddressVariants)
						{
							opcData.shippingAddressVariants = response.data.shippingAddressVariants;
							OnePageCheckout().setShippingAddressVariants(opcData.shippingAddressVariants, true);
							return;
						}
						
						// check if we got back possibly corrected billing data
						if (response.data.billingData != undefined && response.data.billingData != null && response.data.billingData)
						{
							opcData.billingData = response.data.billingData;
							OnePageCheckout().setBillingForm(opcData.billingData);
							OnePageCheckout().setBillingView(opcData.billingData);
						}

						// process response - billing
						$("#opc-billing-form").slideUp('fast');
						$("#opc-billing-view").slideDown('fast');
						$("#opc-billing-form").data("changed", false);
						opc_billingDataSet = true;
						opc_bongoOnly = false;

						// process response - shipping
						$("#opc-additional-inner").slideDown('fast');
						$("#opc-additional h3:first").removeClass('light');
						$("#opc-shipping-inner").slideDown('fast');
						$("#opc-shipping h3:first").removeClass('light');
						$("#opc-payment-inner").slideDown('fast');
						$("#opc-payment h3:first").removeClass('light');

						// update shipping address as well
						if (shippingAsBilling && response.data.shippingAddress != undefined && response.data.shippingAddress != null)
						{
							opcData.shippingAddress = response.data.shippingAddress;
							OnePageCheckout().setShippingAddressView(opcData.shippingAddress);
							opc_shippingAddressSet = true;

							// check are shipping methods returned
							if (response.data.shippingMethods != undefined && response.data.shippingMethods != null)
							{
								opcData.shippingMethods = response.data.shippingMethods;
								opcData.shippingMethodsAlternative = response.data.shippingMethodsAlternative != undefined && response.data.shippingMethodsAlternative != null ? response.data.shippingMethodsAlternative : false;
								OnePageCheckout().setShippingMethodsForm(opcData.shippingMethods, opcData.shippingMethodsAlternative);
							}

							// check bongo status
							if (response.data.bongoActive != undefined && response.data.bongoUsed != undefined)
							{
								opcData.bongoActive = response.data.bongoActive;
								opcData.bongoUsed = response.data.bongoUsed;
								opc_bongoOnly = opcData.bongoActive && opcData.bongoUsed;
								if (opcData.bongoActive) OnePageCheckout().initPayment();
							}

							$("#opc-shipping-address-form").slideUp('fast');
							$("#opc-shipping-address-view").slideDown('fast');
						}
						else
						{
							if (!shippingAsBilling && $('#opc-shipping-address-id-billing').is(':checked'))
							{
								opcData.shippingAddressId = "new";
								opc_shippingAddressSet = false;
								$('#opc-shipping-address-id-new').click();
								OnePageCheckout().editShippingAddress();
							}
						}

						if (response.data.accountCreated != null && response.data.accountCreated)
						{
							$("#opc-account").remove();
							$("#opc-login,#opc-link-login").remove();
						}
						
						if (response.data.backgroundURL != null && response.data.backgroundURL)
						{
							$('<iframe style="display:none;" src="' + response.data.backgroundURL + '"></iframe>').appendTo('body');
						}
						
						OnePageCheckout().setCompleteButton();
						
						// check is payment profile changed
						if (opcData.paymentProfiles)// && opcData.paymentProfileMethodId == opcData.paymentMethodId)
						{
							OnePageCheckout().getPaymentForm(false);
						}
					}
				},
				msg.opc_saving_billing_data
			);
		}
		else
		{
			$("#opc-billing-form").slideUp('fast');
			$("#opc-billing-view").slideDown('fast');
			OnePageCheckout().setCompleteButton();
		}
	}
	catch (err)
	{
		OnePageCheckout().setCompleteButton();
		alert(err);
	}
}

/**
 * Set payment profiles addresses
 */
function opc_setPaymentProfiles()
{
	if (opcData.paymentProfiles == undefined || !opcData.paymentProfiles || opcData.paymentProfiles.length < 1) return false;
		
	if ($.mobile)
	{
		var paymentProfilesHTML = 
			'<div data-role="fieldcontain"><fieldset data-role="controlgroup">';
	
			$(opcData.paymentProfiles).each(function(index, paymentProfile){
				paymentProfilesHTML +=
					'<div><input type="radio" id="opc-payment-profile-id-' + paymentProfile.usid + '" name="payment-profile-id" value="' + paymentProfile.usid + '"/>' +
					'<label for="opc-payment-profile-id-' + paymentProfile.usid + '">' +
						'<strong>' + paymentProfile.data.first_name + ' ' + paymentProfile.data.last_name + '</strong><br/>' +
						paymentProfile.data.address1 + ', ' +
						((paymentProfile.data.address2 != '') ? paymentProfile.data.address2 + ', ' : '') + 
						paymentProfile.data.city + ', ' + paymentProfile.data.state + ' ' + 
						paymentProfile.data.zip + ', ' + paymentProfile.data.country +
					'</label></div>';
			});
			paymentProfilesHTML += 
				'<div><input type="radio" id="opc-payment-profile-id-billing" name="payment-profile-id" value="billing"/>' +
				'<label for="opc-payment-profile-id-billing">Use your billing address</label></div>' +
				'</fieldset></div>';
	}
	else
	{
		var paymentProfilesHTML = 
			'<div class="spacer no-space-top no-gap-top">' + 
			'<strong>Select Billing Address</strong>' +
			'<div class="gap-top col-wrap">';

		$(opcData.paymentProfiles).each(function(index, paymentProfile){
			paymentProfilesHTML +=
				'<div class="col-50"><table class="fieldset"><tbody><tr class="field checkbox"><td><div>' + 
					'<div class="input"><input type="radio" id="opc-payment-profile-id-' + paymentProfile.usid + '" name="payment-profile-id" value="' + paymentProfile.usid + '"></div>' +
					'<label for="opc-payment-profile-id-' + paymentProfile.usid + '">' +
						'<strong>' + 
							paymentProfile.data.first_name + ' ' + paymentProfile.data.last_name + '<br/>' +
							paymentProfile.data.cc_number + ' - ' + paymentProfile.data.cc_expiration_date + 
						'</strong>' + 
						'<br/>' +
						paymentProfile.data.address1 + '<br/>' +
						((paymentProfile.data.address2 != '') ? paymentProfile.data.address2 + '<br/>' : '') + 
						paymentProfile.data.city + ', ' + paymentProfile.data.state + ' ' + 
						paymentProfile.data.zip + '<br/>' + paymentProfile.data.country +
					'</label>' +
				'</div></td></tr></tbody></table></div>';
		});
		paymentProfilesHTML += 
				'</div><div class="gap-top"><table class="fieldset"><tbody><tr class="field checkbox"><td><div>' + 
					'<div class="input"><input type="radio" id="opc-payment-profile-id-billing" name="payment-profile-id" value="billing"></div>' +
					'<label for="opc-payment-profile-id-billing"><strong>Use your billing address</strong></label>' +
				'</div></td></tr>' +
			'</tbody></table></div></div>';
	}
	
	$("#opc-billing-form-profiles").html(paymentProfilesHTML).show();
	
	if (opcData.paymentProfileId)
	{
		$('#opc-payment-profile-id-' + opcData.paymentProfileId).attr('checked', 'checked');
	}
	
	if (opcData.paymentProfileId != 'billing')
	{
		$("#opc-billing-form-inner").hide();
	}
	
	$("input[name='payment-profile-id']").change(function(){
		$("#opc-billing-form").data("changed", true);
		opcData.paymentProfileId = $(this).val();
		
		if (opcData.paymentProfileId == 'billing')
		{
			$("#opc-billing-form-inner").show();
			opcData.paymentProfileMethodId = 0;
		}
		else
		{
			$.each(opcData.paymentProfiles, function(index, paymentProfile){
				if (opcData.paymentProfileId == paymentProfile['usid'])
				{
					opcData.paymentProfileMethodId = paymentProfile['pid'];
				}
			});
			$("#opc-billing-form-inner").hide();
		}
	});

	if ($.mobile)
	{
		$("#opc-billing-form-profiles").page();
		$("#opc-billing-form-profiles input[name='payment-profile-id']").checkboxradio('refresh');		
	}
}


/**
 * Edit billing informations
 */
function opc_editBillingData()
{
	try
	{
		if (!opcData.paymentProfiles)
		{
			$("#opc-billing-form-inner").show();
		}
		$("#opc-billing-view").slideUp('fast');
		$("#opc-billing-form").slideDown();
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Set shipping address book
 * @param addressBook
 * @return
 */
function opc_setShippingAddressBook(addressBook)
{
	try
	{
		var html = '';
		if (addressBook != undefined && addressBook != null && addressBook)
		{
			html = html + '<table class="fieldset"><tbody>'
			jQuery.each(addressBook, function(key, shippingAddress){
				html = html +
					'<tr class="field checkbox"><td><div>' +
						'<div class="input"><input type="radio" id="opc-shipping-address-id-' + shippingAddress.usid + '" name="shipping-address-id" value="' + shippingAddress.usid + '"></div>' +
						'<label for="opc-shipping-address-id-' + shippingAddress.usid + '">' +
							shippingAddress.name +  ' <i>(' + (shippingAddress.address_type == 'Business' ? msg.opc_shipping_address_type_business : msg.opc_shipping_address_type_residential) + ')</i><br/>' +
							shippingAddress.address1 + '<br/>' +
							(jQuery.trim(shippingAddress.address2) != '' ? shippingAddress.address2 + '<br/>' : '') +
							shippingAddress.city + ', ' + (shippingAddress.state > 0 ? shippingAddress.state_name : shippingAddress.province) + ', ' + shippingAddress.zip + '<br/>' +
							shippingAddress.country_name +
						'</label>' +
					'</div></td></tr>';
			});
			html = html + '</tbody></table>'
		}
		if (html != '')
		{
			$("#opc-shipping-address-book").html(html);
			if ($.mobile)
			{
				$("#opc-shipping-address-book").page();
				$("input[name='shipping-address-id']").checkboxradio('refresh');
			}
			$("#opc-shipping-address-book").show();
		}
		else
		{
			$("#opc-shipping-address-book").hide();
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Sets values into shipping form
 * @param shippingData
 */
function opc_setNewShippingAddressForm(shippingAddress)
{
	try
	{
		jQuery.each(shippingAddress, function(fieldName, fieldValue){
			$("#opc-shipping-address-form-" + fieldName).val(fieldValue);
			$("#opc-shipping-address-form-" + fieldName).change(function(){
				$("#opc-shipping-address-form").data("changed", true);
				$('#opc-shipping-address-form-use_user_address').val('0');
				opc_shippingAddressSet = false;
				OnePageCheckout().setCompleteButton();
			});
		});

		//check custom fields changes
		$("#opc-shipping-address-form .custom-field").each(function(){
			$(this).change(function(){
				$("#opc-shipping-address-form").data("changed", true);
				opc_shippingAddressSet = false;
				OnePageCheckout().setCompleteButton();
			});
		});

		$("#opc-shipping-address-form").data("changed", false);
		
		setCountriesStates(
			"#field-shipping-country", shippingAddress.country_id,
			"#field-shipping-state", shippingAddress.state_id,
			"#field-shipping-province", shippingAddress.province,
			countriesStates
		);
			
		//refresh mobile controls state
		if ($.mobile)
		{
			$("#opc-shipping-address-form input[type='radio'][type='checkbox']").each(function(i, c){
				$(c).checkboxradio('refresh');
			});
			
			$("#opc-shipping-address-form select").each(function(i, c){
				$(c).selectmenu('refresh');	
			});
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Generates shipping address preview
 * @param shippingAddress
 */
function opc_setShippingAddressView(shippingAddress)
{
	try
	{
		var html = "";
		if ($("#opc-shipping-address-id-billing").is(":checked"))
		{
			//html = msg.opc_shipping_as_billing + "<br/>";
		}

		if (shippingAddress.country_id != null && shippingAddress.country_id != '0')
		{
			html = html +
				shippingAddress.name + ' <i>(' + (shippingAddress.address_type == 'Business' ? msg.opc_shipping_address_type_business : msg.opc_shipping_address_type_residential) + ')</i><br/>' +
				shippingAddress.address1 + '<br/>' +
				(jQuery.trim(shippingAddress.address2) != '' ? shippingAddress.address2 + '<br/>' : '') +
				shippingAddress.city + ', ' + (shippingAddress.state > 0 ? shippingAddress.state_name : shippingAddress.province) + ', ' + shippingAddress.zip + '<br/>' +
				shippingAddress.country_name;
		}
		
		if (typeof(ShippingAllowSeparateAddress) == 'undefined' || ShippingAllowSeparateAddress != 0)
		{
			if (!$.mobile)
			{
				html = html +
					'<div class="gap-top gap-bottom"><a href="#" id="opc-shipping-address-edit-link">' + msg.opc_edit_shipping_address + '</a></div>';
			}
			else
			{
				html = html +
					'<div><a href="#" id="opc-shipping-address-edit-link" data-role="button">' + msg.opc_edit_shipping_address + '</a></div>';
					
			}
		}
		$("#opc-shipping-address-view div:first").html(html);
		$("#opc-shipping-address-edit-link").click(function(){OnePageCheckout().editShippingAddress();return false;});
		if ($.mobile) $("#opc-shipping-address-edit-link").button();
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Set shipping address variant
 */
function opc_setShippingAddressVariants(shippingAddressVariants, useBillingAddress)
{
	try
	{
		var html = '';

		// show address variants
		$.each(shippingAddressVariants, function (i, address){
			html = html + 
				'<li class="address-variants-li">' + 
					'<input name="opc-address-variant-index" class="address-variants-radio" id="address-variant-' + i + '" type="radio" value="' + i +'">' + 
					'<div class="address-variants-option"><label for="address-variant-' + i + '">' +
						address.address1 + '<br/>' + 
						(address.address2 != '' ? (address.address2 + '<br/>') : '') + 
						address.city + ', ' + address.state_name + ' ' + address.zip +
					'</label></div>' +
				'</li>';
		});


		// add current address
		var formPrefix = useBillingAddress ? "#opc-billing-form-" : "#opc-shipping-address-form-";
		var stateElementId = useBillingAddress ? "#opc-billing-form-state" : "#opc-shipping-address-form-state_id";
		html = html + 
			'<li class="address-variants-li">' + 
				'<input name="opc-address-variant-index" class="address-variants-radio" id="address-variant-user" type="radio" value="user">' + 
				'<div class="address-variants-option"><label for="address-variant-user">' +
					'<strong>' + msg.opc_shipping_address_variants_use_my_address + '</strong><br/>' +
					$(formPrefix + 'address1').val() + '<br/>' +  
					($(formPrefix + 'address2').val() != '' ? ($(formPrefix + 'address2').val() + '<br/>') : '') + 
					$(formPrefix + 'city').val() + ', ' + 
					$(stateElementId + ' option[value="' + $(stateElementId).val() + '"]').text() + ' '
					$(formPrefix + 'zip').val() +
				'</label></div>' +
			'</li>';
		
		// build and show dialod
		$('#opc-dialog-address-variants ul').html(html);
		$('#opc-dialog-address-variants input[type=radio]:first').attr('checked', 'checked');

		
		$('#opc-dialog-address-variants').dialog({
			'modal': true,
			'title': msg.opc_shipping_address_variants_title,
			'minWidth': 700,
			'resizable' : false,
			'buttons': [ 
				{
					text: msg.opc_shipping_address_variants_use_selected_address, 
					click: function() {
						
						$('#opc-dialog-address-variants').dialog("close");

						var selectedAddressVariant = $('#opc-dialog-address-variants input[type=radio]:checked').val();

						if (selectedAddressVariant != 'user')
						{
							var selectedAddress = opcData.shippingAddressVariants[selectedAddressVariant];

							$(formPrefix + 'address1').val(selectedAddress.address1);
							$(formPrefix + 'address2').val(selectedAddress.address2);
							$(formPrefix + 'city').val(selectedAddress.city);
							$(stateElementId).val(selectedAddress.state_id);
							$(formPrefix + 'zip').val(selectedAddress.zip);

							if (useBillingAddress)
							{
								$("#opc-billing-form").data("changed", true);
								$('#opc-billing-form-button-save').click();
							}
							else
							{
								$("#opc-shipping-address-form").data("changed", true);
								$('#opc-shipping-address-form-button-save').click();
							}
						}
						else
						{
							$('#opc-billing-form-use_user_address').val('1');
							$('#opc-shipping-address-form-use_user_address').val('1');
							$('#opc-billing-form-button-save').click();
						}
						
					}
				},
				{
					text: msg.opc_shipping_address_variants_edit_address, 
					click: function() {
						$('#opc-dialog-address-variants').dialog("close");
					}
				}
			]
		});
	}
	catch (err)
	{
		alert(err);
		OnePageCheckout().setCompleteButton();
	}
}

/**
 *  Save shipping address
 */
function opc_saveShippingAddress()
{
	try
	{
		if ($("#opc-shipping-address-form").data("changed") || opcData.shippingIsEmpty)
		{
			opc_shippingAddressSet = false;
			OnePageCheckout().sendRequest(
				"saveShippingAddress",
				{
					'shippingForm': $("#opc-shipping-address-form form").serialize()
				},
				function (response)
				{
					if (response.result)
					{
						if (response.data.shippingAddressVariants != undefined && response.data.shippingAddressVariants != null)
						{
							var shippingAsBilling = $("#opc-shipping-address-id-billing").is(":checked");
							opcData.shippingAddressVariants = response.data.shippingAddressVariants;
							OnePageCheckout().setShippingAddressVariants(opcData.shippingAddressVariants, shippingAsBilling);
						}
						else
						{
							//process response
							opcData.shippingAddress = response.data.shippingAddress;

							opc_shippingAddressSet = true;
							opc_bongoOnly = false;

							$('#opc-shipping-address-form-address1').val(opcData.shippingAddress.address1);
							$('#opc-shipping-address-form-address2').val(opcData.shippingAddress.address2);
							$('#opc-shipping-address-form-city').val(opcData.shippingAddress.city);
							$('#opc-shipping-address-form-state_id').val(opcData.shippingAddress.state_id);
							$('#opc-shipping-address-form-zip').val(opcData.shippingAddress.zip);

							OnePageCheckout().setShippingAddressView(opcData.shippingAddress);
							opc_shippingAddressSet = true;

							$("#opc-shipping-address-form").slideUp('fast');
							$("#opc-shipping-address-view").slideDown('fast');
							$("#opc-shipping-address-form").data("changed", false);

							// check are shipping methods returned
							if (response.data.shippingMethods != undefined && response.data.shippingMethods != null)
							{
								opcData.shippingMethods = response.data.shippingMethods;
								opcData.shippingMethodsAlternative = response.data.shippingMethodsAlternative != undefined && response.data.shippingMethodsAlternative != null ? response.data.shippingMethodsAlternative : false;
								OnePageCheckout().setShippingMethodsForm(opcData.shippingMethods, opcData.shippingMethodsAlternative);
							}

							// check bongo status
							if (response.data.bongoActive != undefined && response.data.bongoUsed != undefined)
							{
								opcData.bongoActive = response.data.bongoActive;
								opcData.bongoUsed = response.data.bongoUsed;
								opc_bongoOnly = opcData.bongoActive && opcData.bongoUsed;
								if (opcData.bongoActive) OnePageCheckout().initPayment();
							}
						}
						OnePageCheckout().setCompleteButton();
					}
				},
				msg.opc_saving_shipping_address
			);
		}
		else
		{
			$("#opc-shipping-address-form").slideUp('fast');
			$("#opc-shipping-address-view").slideDown('fast');
			OnePageCheckout().setCompleteButton();
		}
	}
	catch (err)
	{
		alert(err);
		OnePageCheckout().setCompleteButton();
	}
}

/**
 * Edit billing informations
 */
function opc_editShippingAddress()
{
	try
	{
		$("#opc-shipping-address-form .buttons").show();
		
		$("#opc-shipping-address-view").slideUp('fast');
		$("#opc-shipping-address-form").slideDown('fast');
		
		
		if (opcData.shippingAddressId == "new")
		{
			$("#opc-shipping-address-form-new").show();
		}
		else
		{
			$("#opc-shipping-address-form-new").hide();
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Get shipping method
 */
function opc_getShippingMethods(callback)
{
	try
	{
		OnePageCheckout().sendRequest(
			"getShippingMethods",
			{
				'data': true
			},
			function (response)
			{
				if (response.result)
				{
					opc_bongoOnly = false;

					// check are shipping methods returned
					if (response.data.shippingMethods != undefined && response.data.shippingMethods != null)
					{
						opcData.shippingMethods = response.data.shippingMethods;
						opcData.shippingMethodsAlternative = response.data.shippingMethodsAlternative != undefined && response.data.shippingMethodsAlternative != null ? response.data.shippingMethodsAlternative : false;
						OnePageCheckout().setShippingMethodsForm(opcData.shippingMethods, opcData.shippingMethodsAlternative);
					}
					else
					{
						alert(msg.opc_error_no_shipping_methods);
					}

					// check bongo status
					if (response.data.bongoActive != undefined && response.data.bongoUsed != undefined)
					{
						opcData.bongoActive = response.data.bongoActive;
						opcData.bongoUsed = response.data.bongoUsed;
						opc_bongoOnly = opcData.bongoActive && opcData.bongoUsed;
						if (opcData.bongoActive) OnePageCheckout().initPayment();
					}
					
					if (callback != undefined && callback != null)
					{
						callback();
					}
				}
			},
			msg.opc_getting_shipping_quotes
		);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Set shipping methods form
 */
function opc_setShippingMethodsForm(shippingMethods, shippingMethodsAlternative)
{
	try
	{
		/**
		 * Check is shipping disabled
		 */
		if (!opcData.shippingEnabled)
		{
			$("#opc-shipping-methods-form").html('');
			opcData.shippingMethodId = '0';
			$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
			OnePageCheckout().setCompleteButton();
			OnePageCheckout().setInvoicePreview();
			opc_shippingMethodSet = true;
			return;
		}

		if (!$.mobile)
		{
			/**
			 * Standard site part
			 */
			html = '<strong>' + msg.opc_shipping_methods_title + '</strong><div class="gap-top gap-bottom">';
		}
		else
		{
			/**
			 * Mobile site part
			 */
			html = '<div data-role="header" data-theme="c"><h3>' + msg.opc_shipping_methods_title + '</h3></div><div data-role="content">';
		}

		if (shippingMethods.bongo_active && shippingMethods.bongo_used)
		{
			html = html + msg.opc_shipping_bongo_used + '<br/><br/>';
		}

		/**
		 * Check is address is set
		 */
		if (!opc_shippingAddressSet)
		{
			html = html + msg.opc_select_shipping_address;
		}
		else
		{
			/**
			 * Check is shipping free
			 */
			if (opcData.shippingIsFree)
			{
				if (!shippingMethodsAlternative || !(shippingMethodsAlternative.shipping_methods_count > 0) || !shippingMethodsAlternative.shipping_methods)
				{
					opcData.shippingMethodId = '0';
					$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
				}
				html = html + '<div class="gap-top">' + msg.opc_shipping_is_free + '</div>';
			}
			/**
			 * 	Handle shipping when it is not free
			 */
			else
			{
				opc_shippingMethodSet = opcData.shippingWithoutMethod;

				/**
				 * Product level shipping first
				 */
				if (shippingMethods.product_level_method != undefined && shippingMethods.product_level_method && shippingMethods.shipping_price_at_product_level != undefined && shippingMethods.shipping_price_at_product_level != null)
				{
					html = html + 
						'<div class="gap-top">' + 
							msg.opc_current_shipping_price + ': ' +
							OnePageCheckout().getPrice(
								shippingMethods.shipping_price_at_product_level + 
								(opcData.orderData.shippingTaxable && opcData.displayPricesWithTax ? shippingMethods.shipping_price_at_product_level / 100 * opcData.orderData.shippingTaxRate : 0)
							) +
						'</div>';
					
					if (shippingMethods.shipping_methods_count > 1)
					{
						html = html + '<div class="gap-top">' + msg.opc_select_shipping_method_for_remaining + '</div>';
					}
					opc_shippingMethodSet = true;
					opcData.shippingMethodId = '0';
					$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
				}

				/**
				 * Display standard shipping methods
				 */
				if (shippingMethods.shipping_methods_count > 0 && shippingMethods.shipping_methods)
				{
					// Render form
					
					if (!$.mobile)
					{
						/**
						 * Standard site part
						 */
						html = html + '<table class="fieldset"><tbody>';
						jQuery.each(shippingMethods.shipping_methods, function(key, shippingMethod){
							html = html +
								'<tr class="field radio"><td><div>' +
									'<div class="input"><input type="radio" id="opc-shipping-method-' + shippingMethod.ssid + '" name="shipping-method-id" value="' + shippingMethod.ssid + '"/></div>' +
									'<label for="opc-shipping-method-' + shippingMethod.ssid + '">' +
										shippingMethod.method_name + ' - ' + OnePageCheckout().getPrice(
											shippingMethod.shipping_price + 
											(opcData.orderData.shippingTaxable && opcData.displayPricesWithTax ? shippingMethod.shipping_price / 100 * opcData.orderData.shippingTaxRate : 0)
										) +
									'</label>' +
								'</div></td></tr>';
						});
						html = html + '</tbody></table>';
					}
					else
					{
						/**
						 * Mobile site part
						 */
						html = html + '<div>';
						jQuery.each(shippingMethods.shipping_methods, function(key, shippingMethod){
							html = html +
								'<div data-role="fieldcontain">' +
									'<input type="radio" id="opc-shipping-method-' + shippingMethod.ssid + '" name="shipping-method-id" value="' + shippingMethod.ssid + '"/>' +
									'<label for="opc-shipping-method-' + shippingMethod.ssid + '">' +
										shippingMethod.method_name + ' - ' + OnePageCheckout().getPrice(
											shippingMethod.shipping_price + 
											(opcData.orderData.shippingTaxable && opcData.displayPricesWithTax ? shippingMethod.shipping_price / 100 * opcData.orderData.shippingTaxRate : 0)
										) +
									'</label>' +
								'</div>';
						});
						html = html + '</div>';
					}
					
					opc_shippingMethodSet = true;
				}
			}

			/**
			 * Display alternative shipping options for free shipping
			 */
			if (shippingMethodsAlternative && shippingMethodsAlternative.shipping_methods_count > 0 && shippingMethodsAlternative.shipping_methods)
			{
				if (!$.mobile)
				{
					/**
					 * Standard site part
					 */
					html = html +
						'<div class="space-top space-bottom clearfix">' + msg.opc_alternative_shipping + '</div><div class="space-bottom"><table class="fieldset"><tbody>';

					if (opcData.shippingIsFree)
					{
						html = html +
							'<tr class="field radio"><td><div>' +
							'<div class="input"><input type="radio" id="opc-shipping-method-0" name="shipping-method-id" value="0"/></div>' +
							'<label for="opc-shipping-method-0">' + msg.opc_free_shipping + '</label>' +
							'</div></td></tr>';
					}

					jQuery.each(shippingMethodsAlternative.shipping_methods, function(key, shippingMethod){
						html = html +
							'<tr class="field radio"><td><div>' +
								'<div class="input"><input type="radio" id="opc-shipping-method-a' + shippingMethod.ssid + '" name="shipping-method-id" value="a' + shippingMethod.ssid + '"/></div>' +
								'<label for="opc-shipping-method-a' + shippingMethod.ssid + '">' + 
									shippingMethod.method_name + ' - ' + OnePageCheckout().getPrice(
										shippingMethod.shipping_price +
										(opcData.orderData.shippingTaxable && opcData.displayPricesWithTax ? shippingMethod.shipping_price / 100 * opcData.orderData.shippingTaxRate : 0)
									) + 
								'</label>' +
							'</div></td></tr>';
					});

					html = html + '</tbody></table></div>';
				}
				else
				{
					/**
					 * Mobile site part
					 */
					html = html +
						'<div>' + msg.opc_alternative_shipping + '</div><div>';

					if (opcData.shippingIsFree)
					{
						html = html +
							'<div data-role="fieldcontain">' +
								'<input type="radio" id="opc-shipping-method-0" name="shipping-method-id" value="0"/>' +
								'<label for="opc-shipping-method-0">' + msg.opc_free_shipping + '</label>' +
							'</div>';
					}

					jQuery.each(shippingMethodsAlternative.shipping_methods, function(key, shippingMethod){
						html = html +
							'<div data-role="fieldcontain">' +
								'<input type="radio" id="opc-shipping-method-a' + shippingMethod.ssid + '" name="shipping-method-id" value="a' + shippingMethod.ssid + '"/>' +
								'<label for="opc-shipping-method-a' + shippingMethod.ssid + '">' + 
									shippingMethod.method_name + ' - ' + OnePageCheckout().getPrice(
										shippingMethod.shipping_price +
										(opcData.orderData.shippingTaxable && opcData.displayPricesWithTax ? shippingMethod.shipping_price / 100 * opcData.orderData.shippingTaxRate : 0)
									) + 
								'</label>' +
							'</div>';
					});

					html = html + '</div>';	
				}
				opc_shippingMethodSet = true;
			}

			if (!opc_shippingMethodSet)
			{
				html = '<div>' + msg.opc_no_shipping_methods_for_order + '</div>';
			}
		}

		html = html + '</div>';

		/**
		 * Set HTML
		 */
		$("#opc-shipping-methods-form").html(html);
		if ($.mobile)
		{
			$("#opc-shipping-methods-form div").each(function(){
				$(this).page();
			});
		}

		/**
		 * Set initial shipping method
		 */
		if ($.cookie('opc-shipping-method-id') != null && opcData.shippingMethodId == '0')
		{
			opcData.shippingMethodId = $.cookie('opc-shipping-method-id');
		}

		$("#opc-shipping-method-" + opcData.shippingMethodId).attr("checked", "checked");

		/**
		 * Check is current method was selected (are there active radios?)
		 */
		if ($("#opc-shipping-methods-form input[name='shipping-method-id']").length > 0)
		{
			if ($("#opc-shipping-methods-form input[name='shipping-method-id']:checked").length == 0)
			{
				$("#opc-shipping-methods-form input[name='shipping-method-id']:first").attr("checked", "checked");
				opcData.shippingMethodId = $("#opc-shipping-methods-form input[name='shipping-method-id']:first").val();
			}
		}
		else
		{
			opcData.shippingMethodId = '0';
			$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
		}

		/**
		 * Handle new shipping method selection
		 */
		$("#opc-shipping-methods-form input[name='shipping-method-id']").each(function(){
			$(this).change(function(){
				opcData.shippingMethodId = $(this).val();
				$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
				OnePageCheckout().setInvoicePreview();
				OnePageCheckout().setCompleteButton();
			});
		});
		

		// Set invoice view based on current method
		OnePageCheckout().setCompleteButton();
		OnePageCheckout().setInvoicePreview();

		$.cookie('opc-shipping-method-id', opcData.shippingMethodId);
		
		if ($.mobile)
		{
			$("input[type='radio'][name='shipping-method-id']").checkboxradio('refresh');
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * 
 * @param paymentMethods
 * @return
 */
function opc_setPaymentMethods(paymentMethods)
{
	try
	{
		if (opcData.paymentMethodsCount > 0)
		{
			var html = '';

			/**
			 * Add payment methods
			 */
			if (!$.mobile)
			{
				/**
				 * Standard site 
				 */
				html = html + '<div id="opc-payment-methods-list"><table class="fieldset"><tbody>';
				jQuery.each(opcData.paymentMethods, function(key, paymentMethod){
					if ((!opc_bongoOnly && paymentMethod.id != 'bongocheckout') || (opc_bongoOnly && paymentMethod.id == 'bongocheckout'))
					{
						html = html +
							'<tr class="field radio"><td><div>' +
								'<div class="input"><input class="payment-method-' + paymentMethod.id + '" type="radio" id="opc-payment-method-' + paymentMethod.pid + '" name="payment-method-id" value="' + paymentMethod.pid + '"/></div>' +
								'<label for="opc-payment-method-' + paymentMethod.pid + '">' + paymentMethod.title + '</label>' +
							'</div></td></tr>';
					}
				});
			}
			else
			{
				/**
				 * Mobile site
				 */
				html = html + '<div id="opc-payment-methods-list">';
				jQuery.each(opcData.paymentMethods, function(key, paymentMethod){
					html = html +
						'<div data-role="fieldcontain">' +
							'<input type="radio" id="opc-payment-method-' + paymentMethod.pid + '" name="payment-method-id" value="' + paymentMethod.pid + '"/>' +
							'<label for="opc-payment-method-' + paymentMethod.pid + '">' + paymentMethod.title + '</label>' +
						'</div><div id="opc-payment-method-form-' + paymentMethod.pid + '" class="invisible"></div>';
				});
			}

			/**
			 * Add gift certificate radio
			 */
			if (opcData.giftCertificateEnabled)
			{
				if (!$.mobile)
				{
					/**
					 * Standard site
					 */
					html = html +
						'<tr class="field radio"><td><div>' +
							'<div class="input"><input type="radio" id="opc-payment-method-gift-certificate" value="gift-certificate" name="payment-method-id"/></div>' +
							'<label for="opc-payment-method-gift-certificate">' + msg.opc_use_gift_certificate + '</label>' +
						'</div></td></tr>';
				}
				else
				{
					/**
					 * Mobile site
					 */
					html = html +
						'<div data-role="fieldcontain">' +
							'<input type="radio" id="opc-payment-method-gift-certificate" value="gift-certificate" name="payment-method-id"/>' +
							'<label for="opc-payment-method-gift-certificate">' + msg.opc_use_gift_certificate + '</label>' +
						'</div>';
				}
				$("#opc-gift-certificate-form").live('submit', function(){
					return false;
				});
			}

			if (!$.mobile)
			{
				/**
				 * Standard site
				 */
				html = html + '</tbody></table></div>';
			}
			else
			{
				/**
				 * Mobile site
				 */
				html = html + '</div>';
			}
			
			$("#opc-payment-methods-options").html(html);
			
			$("#opc-payment-methods-form").show();
		
			/**
			 * Preselect payment method
			 */
			if ($.cookie('opc-payment-method-id') != null && opcData.paymentMethodId == '0') opcData.paymentMethodId = $.cookie('opc-payment-method-id');

			if (opcData.paymentMethodId != '0')
			{
				if ($("#opc-payment-method-" + opcData.paymentMethodId).length > 0)
				{
					$("#opc-payment-method-" + opcData.paymentMethodId).attr("checked", "checked");
				}
				else
				{
					$("#opc-payment-methods-form input[name='payment-method-id']:first").attr("checked", "checked");
					opcData.paymentMethodId = $("#opc-payment-methods-form input[name='payment-method-id']:first").val();
				}
			}
			else
			{
				$("#opc-payment-methods-form input[name='payment-method-id']:first").attr("checked", "checked");
				opcData.paymentMethodId = $("#opc-payment-methods-form input[name='payment-method-id']:first").val();
			}
			
			//refresh element for mobile app
			if ($.mobile)
			{
				$("#opc-payment-methods-options div").each(function(){
					$(this).page();
				});
				
				$("#opc-payment-methods-options input[type='radio'][name='payment-method-id']").checkboxradio('refresh');
			}

			/**
			 * Handle payment methods radio buttons click
			 */
			$("#opc-payment-methods-form input[name='payment-method-id']").each(function(){
				$(this).change(function(){
					// 
					if ($(this).hasClass('payment-method-paypaladv') || $(this).hasClass('payment-method-paypalpflink'))
					{
						opc_auto_show_popup = true;	
					}
					else
					{
						opc_auto_show_popup = false;
					}
					
					$("#opc-payment-method-error").hide();

					if ($(this).val() == 'gift-certificate')
					{
						opc_giftCertificateSet = false;
						$("#opc-payment-method-form").hide();
						$("#opc-gift-certificate-form").show();
						$("#opc-gift-certificate-view").hide();
						$("#opc-button-complete").attr('disabled', 'disabled');
					}
					else
					{
						$("#opc-gift-certificate-form").hide();
						$("#opc-gift-certificate-view").hide();
						
						opc_giftCertificateSet = true;
						
						if ($(this).val() == opcData.paymentMethodId)
						{
							opc_paymentFormSet = true;
							$("#opc-payment-method-form").show();
							OnePageCheckout().setCompleteButton();
						}
						else
						{
							opcData.paymentMethodId = $(this).val();
							$.cookie('opc-payment-method-id', opcData.paymentMethodId);
							OnePageCheckout().getPaymentForm(false);
						}
					}
				});
			});

			/**
			 * Gift certificate apply button handler
			 */
			if (opcData.giftCertificateEnabled)
			{
				$("#opc-gift-certificate-apply").click(function(){
					OnePageCheckout().applyGiftCertificate();
				});
			}
			
			if ($.mobile)
			{
				$("input[type='radio'][name='payment-method-id']").checkboxradio('refresh');
			}
		}
		else
		{
			OnePageCheckout().showError(msg.opc_error_no_payment_methods);
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Get payment form
 * @return
 */
function opc_getPaymentForm(check_gift_certificate)
{
	try
	{
		opc_paymentFormSet = false;
		OnePageCheckout().setCompleteButton();
		OnePageCheckout().sendRequest(
			"getPaymentForm",
			{
				'paymentMethodsForm' : $("#opc-payment-methods-form").serialize(),
				'paymentProfileId' : opcData.paymentProfileId
			},
			function (response)
			{
				if (response.result)
				{
					opcData.paymentFormPopUp = response.data.paymentFormPopUp;
					opcData.paymentFormPopUpWidth = response.data.paymentFormPopUpWidth;
					opcData.paymentFormPopUpHeight = response.data.paymentFormPopUpHeight;
					opcData.paymentFormPopUpTitle = response.data.paymentFormPopUpTitle;
					
					$("#opc-payment-method-form").attr('action', response.data.paymentFormUrl);
					
					if (opcData.paymentFormPopUp)
					{
						$("#opc-payment-method-form").attr('target', 'opc-payment-dialog-iframe');
					}
					else
					{
						$("#opc-payment-method-form").attr('target', '');
					}
					
					if (response.data.paymentForm != undefined && response.data.paymentForm != null && response.data.paymentForm)
					{
						$("#opc-payment-method-form").html(response.data.paymentForm);
						
						$("#opc-payment-method-form").show();
						
						if (response.data.paymentFormWide != undefined && response.data.paymentFormWide != null && response.data.paymentFormWide) 
						{
							$("#opc-payment-methods div.col-50").removeClass('col-50').addClass('col-100');
						}
						else
						{
							$("#opc-payment-methods div.col-100").removeClass('col-100').addClass('col-50');
						}
												
						if (response.data.paymentFormOverride != undefined && response.data.paymentFormOverride != null && response.data.paymentFormOverride) 
						{
							$("#opc-button-complete").hide();
						}
						else
						{
							$("#opc-button-complete").show();
						}
					}
					else
					{
						$("#opc-payment-method-form").html('');
					}

					if (response.data.paymentFormValidatorJS != undefined && response.data.paymentFormValidatorJS != null && response.data.paymentFormValidatorJS)
					{
						opcData.paymentFormValidatorJS = response.data.paymentFormValidatorJS;
					}
					else
					{
						opcData.paymentFormValidatorJS = '';
					}
					
					opc_paymentFormSet = true;

					/**
					 * Show payment error (if exists)
					 */
					if (opcData.paymentError)
					{
						$("#opc-payment-method-error-message").html(opcData.paymentError);
						$("#opc-payment-method-error").slideDown('fast');
						opcData.paymentError = false;
					}
					
					/**
					 * Set mobile controlls
					 */
					$("#opc-payment-method-form #opc-payment-use-profile").click();
					if ($.mobile)
					{
						var f = $("#opc-payment-method-form").clone();
						$("#opc-payment-method-form").remove();
						$("#opc-payment-method-form-" + response.data.paymentMethodId).html('').append(f).show();
						$("#opc-payment-method-form-" + response.data.paymentMethodId + ' div').each(function(){
							$(this).page();
						});

						$ ("#opc-payment-method-form-" + response.data.paymentMethodId + " select").each(function(i, s){
							$(s).selectmenu('refresh');
						});
					}
					
					/**
					 * Handle profile change
					 */
					if ($("#opc-payment-method-form input[name='form[payment_method_way]']").length > 0)
					{
						$("#opc-payment-method-form input[name='form[payment_method_way]']").each(function(){
							$(this).change(function(){
								opcData.paymentMethodWay = $(this).val();
								if (opcData.paymentMethodWay == "card")
								{
									$("#opc-payment-method-form-profile").hide();
									$("#opc-payment-method-form-card").show();
								}
								else
								{
									$("#opc-payment-method-form-card").hide();
									$("#opc-payment-method-form-profile").show();
								}
							});
						});
					}
					else
					{
						opcData.paymentMethodWay == "card";
						$("#opc-payment-method-form-profile").hide();
						$("#opc-payment-method-form-card").show();	
					}

					/**
					 * Set gift certificates
					 */
					if (check_gift_certificate)
					{
						OnePageCheckout().setGiftCertificate();
					}

					OnePageCheckout().setCompleteButton();
					
					if (opc_auto_show_popup)
					{
						if (!$('#opc-button-complete').is(':disabled'))
						{
							$('#opc-button-complete').click();
						}
					}
				}
			},
			msg.opc_getting_payment_form
		);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Presets session-stored gift certificate
 */
function opc_setGiftCertificate()
{
	if (opcData.giftCertificate != undefined && opcData.giftCertificate != null && opcData.giftCertificate)
	{
		$("#gift_cert_first_name").val(opcData.giftCertificate.first_name);
		$("#gift_cert_last_name").val(opcData.giftCertificate.last_name);
		$("#gift_cert_voucher").val(opcData.giftCertificate.voucher);
		
		$("#opc-payment-method-gift-certificate").click();
		$("#opc-payment-methods-form input[name='payment-method-id']").change();	
		OnePageCheckout().applyGiftCertificate();
	}
}

/**
 * Check is it time to enable / disable button
 * @return
 */
function opc_setCompleteButton()
{
	try
	{
		//condition to checks
		if (opc_billingDataSet && opc_shippingAddressSet && opc_shippingMethodSet && opc_paymentFormSet && opc_giftCertificateSet)
		{
			$("#opc-button-complete").removeAttr('disabled').removeClass('button-disabled');
		}
		else
		{
			$("#opc-button-complete").attr('disabled', 'disabled').addClass('button-disabled');
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 *  Process payment
 */
function opc_processPayment()
{
	try
	{
		$("#opc-payment-method-error").slideUp('fast');
		$("#opc-button-complete").attr("disabled", "disabled");

		var validationResult = true;
		var paymentMethodType = 'free';
		var formUsed = '-free';

		/**
		 * Check is this a free order
		 */
		if (opc_finalTotal > 0)
		{
			/**
			 * Generate validator code
			 */
			var html = 
				'<script type="text/javascript">\nfunction _checkPaymentForm(){\n' +
				'var frm=document.getElementById("opc-payment-method-form");\n' + 
				(opcData.paymentFormValidatorJS != '' ? opcData.paymentFormValidatorJS : '') + '\n' +
				'// 	additionally check is there term & conditions checkbox \n' +
				'if ($("#cb_agree").length && !$("#cb_agree").is(":checked")) \n' +
				'{ alert(msg.opc_agree_to_terms_and_conditions); return false; } \n' +
				'return true;\n' + 
				'}\n' +
				'</script>';

			$("#opc-payment-form-validator").html(html);

			/**
			 * Validate payment form
			 */
			if (
				$("#opc-payment-method-form input[name='form[payment_method_way]']").length > 0 && 
				$("#opc-payment-method-form input[name='form[payment_method_way]']").val() == 'profile'
			)
			{
				validationResult = true;
			}
			else
			{
				validationResult = _checkPaymentForm();
			}

			var paymentMethod = opcData.paymentMethods['p' + opcData.paymentMethodId];
			paymentMethodType = paymentMethod.type;

			formUsed = '';
		}
		else
		{
			paymentMethodType ='free';
		}

		/**
		 * Process payment on a server
		 */
		if (validationResult)
		{
			OnePageCheckout().sendRequest(
				'processPayment',
				{
					'paymentMethodsForm' : $("#opc-payment-methods-form" + formUsed).serialize(),
					'paymentMethodForm' : $("#opc-payment-method-form" + formUsed).serialize(),
					'paymentMethodType' : paymentMethodType,
					'shippingMethodId' : opcData.shippingMethodId,
					'giftCertificateForm' : opcData.orderData.giftCertificateAmount > 0 ? $("#opc-gift-certificate-form").serialize() : false,
					'additionalInformation' : $("#opc-additional form").length > 0 ? $("#opc-additional form").serialize() : false
				},
				function (response)
				{
					if (response.result)
					{
						// Handling IPN forms
						if (response.data.paymentForm != undefined && response.data.paymentForm != null && response.data.paymentForm)
						{
							// Save user input (if any)
							var formData = new Array();

							$("#opc-payment-method-form input[type!='hidden'],#opc-payment-method-form select,#opc-payment-method-form textarea").each(function(){
								formData[$(this).attr('name')] = $(this).attr('type') == 'checkbox' ? $(this).is(':checked') : $(this).val();
							});
							
							$("#opc-payment-method-form").html(response.data.paymentForm);
							$("#opc-payment-method-form").attr('action', response.data.paymentFormUrl);
							
							$("#opc-payment-method-form input[type!='hidden'],#opc-payment-method-form select,#opc-payment-method-form textarea").each(function(){
								if ($(this).attr('type') == 'checkbox')
								{
									if (formData[$(this).attr('name')]) $(this).attr('checked', 'checked'); else $(this).removeAttr('checked');
								}
								else
								{
									$(this).val(formData[$(this).attr('name')]);
								}
							});
							
							if (opcData.paymentFormPopUp)
							{
								OnePageCheckout().hideSpinner();
								if ($.mobile)
								{
									$('#opc-payment-dialog').show();
									window.scrollTo(0, 0);
								}
								else
								{
									$('#opc-payment-dialog').dialog({
										width:opcData.paymentFormPopUpWidth,
										height:opcData.paymentFormPopUpHeight,
										title:opcData.paymentFormPopUpTitle,
										modal: true,
										open: function(event, ui)
										{
											$("#opc-payment-dialog").html(
												'<iframe style="' + 
												$('#opc-payment-dialog-iframe').attr('style') + 
												'" id="opc-payment-dialog-iframe" src="about:blank" name="opc-payment-dialog-iframe"></iframe>'
											);
											$("#opc-payment-dialog").contents().find('body').html(msg.opc_redirect_to_payment_gateway + '...');
										},
										close: function(event, ui)
										{
											OnePageCheckout().setCompleteButton();
										}
									});
								}
							}
							else
							{
								OnePageCheckout().showSpinnerDelayed(msg.opc_redirect_to_payment_gateway)
							}
							$("#opc-payment-method-form").submit();
						}
						// Processing real time, free and custom
						else
						{
							if (response.data.verification != undefined && response.data.verification != null && response.data.verification)
							{
								OnePageCheckout().showSpinnerDelayed(msg.opc_verification);
								document.location = response.data.backURL;
								return;
							}
							else if (response.data.success != undefined && response.data.success != null)
							{
								// Check for success
								if (response.data.success)
								{
									OnePageCheckout().showSpinnerDelayed(msg.opc_finishing_order);
									if (response.data.backURL != undefined && response.data.backURL != null && response.data.backURL)
									{
										document.location = response.data.backURL;
										return;
									}
								}
								// Show error message
								else
								{
									if (response.data.backURL != undefined && response.data.backURL != null && response.data.backURL)
									{
										document.location = response.data.backURL;
										return;
									}
									else if (response.data.paymentErrors != undefined && response.data.paymentErrors != null && response.data.paymentErrors)
									{
										$("#opc-payment-method-error-message").html(response.data.paymentErrors);
										$("#opc-payment-method-error").slideDown('fast');
										OnePageCheckout().setCompleteButton();
									}
								}
							}
						}
					}
				},
				msg.opc_processing_payment
			);
		}
		else
		{
			OnePageCheckout().setCompleteButton();
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Apply gift certificate
 */
function opc_applyGiftCertificate()
{
	try
	{
		OnePageCheckout().sendRequest(
			'applyGiftCertificate',
			{
				'giftCertificateForm' : $("#opc-gift-certificate-form").serialize(),
				'shippingMethodId' : opcData.shippingMethodId
			},
			function (response)
			{
				if (response.result)
				{
					opcData.orderData.giftCertificateAmount = response.data.giftCertificateAmount;
					$("#opc-gift-certificate-form").hide();
					$("#opc-gift-certificate-view").show();
					opc_giftCertificateSet = true;
				}
				else
				{
					opcData.orderData.giftCertificateAmount = 0;
					opc_giftCertificateSet = false;
				}
				
				OnePageCheckout().setInvoicePreview();
				OnePageCheckout().setCompleteButton();
			},
			msg.opc_checking_gift_certificate
		);
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Set promo code form
 */
function opc_setPromoCodeForm()
{
	try
	{
		if (opcData.promoAvailable)
		{
			$("#opc-promo-code").val(opcData.promoCode);
			$("#opc-promo-code-apply").click(function(){
				if ($.trim($("#opc-promo-code").val()) == "") return false;
				$("#opc-button-complete").attr("disabled", "disabled");
				OnePageCheckout().sendRequest(
					'checkPromoCode',
					{
						'promo' : $("#opc-promo-code").val()
					},
					function (response)
					{
						OnePageCheckout().setShippingMethodsForm(opcData.shippingMethods, opcData.shippingMethodsAlternative);
						OnePageCheckout().setCompleteButton();
						if (response.result)
						{
							OnePageCheckout().setInvoicePreview();
						}
						else
						{
							$("#opc-promo-code").focus();
						}
					},
					'Checking promo code'
				);
			});
		}
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Return formated price
 * @param amount
 * @return string
 */
function opc_getPrice(amount)
{
	try
	{
		var r = Math.round(amount * opcData.currentCurrency.exchange_rate * 100) / 100;
		var s = 
			opcData.currentCurrency.symbol_left + 
			number_format(r, opcData.currentCurrency.decimal_places, opcData.currentCurrencyDecimalSymbol, opcData.currentCurrencySeparatingSymbol) + 
			opcData.currentCurrency.symbol_right;
		return s;
	}
	catch (err)
	{
		alert(err);
	}
}

/**
 * Making OPC class
 */
function OnePageCheckout()
{	
	if (typeof OnePageCheckout.target == 'undefined') this.target = null;

	return {
		'init' : opc_init,
		'initPayment' : opc_initPayment,
		'showSpinner' : opc_showSpinner,
		'showSpinnerDelayed' : opc_showSpinnerDelayed,
		'hideSpinner' : opc_hideSpinner,
		'showError' : opc_showError,
		'doLogin' : opc_doLogin,
		'correctDialogPosition' : opc_correctDialogPosition,

		'sendRequest' : opc_sendRequest,

		'setBillingForm' : opc_setBillingForm,
		'setBillingView' : opc_setBillingView,
		'saveBillingData' : opc_saveBillingData,
		'editBillingData' : opc_editBillingData,

		'setPaymentProfiles' : opc_setPaymentProfiles,
		
		'setInvoicePreview' : opc_setInvoicePreview,

		'setNewShippingAddressForm' : opc_setNewShippingAddressForm,
		'setShippingAddressView' : opc_setShippingAddressView,
		'setShippingAddressBook' : opc_setShippingAddressBook,
		'setShippingAddressVariants' : opc_setShippingAddressVariants,
		'saveShippingAddress' : opc_saveShippingAddress,
		'editShippingAddress' : opc_editShippingAddress,

		'getShippingMethods' : opc_getShippingMethods,
		'setShippingMethodsForm' : opc_setShippingMethodsForm,

		'setPaymentMethods' : opc_setPaymentMethods,
		'getPaymentForm' : opc_getPaymentForm,

		'setGiftCertificate' : opc_setGiftCertificate,

		'applyGiftCertificate' : opc_applyGiftCertificate,

		'processPayment' : opc_processPayment,
		'setCompleteButton' : opc_setCompleteButton,

		'setPromoCodeForm' : opc_setPromoCodeForm,

		'getPrice' : opc_getPrice
	};
}
