<?php
/**
 * Cache / gzip output functions
 */

/**
 * Start output caching
 * @param bool $do_acceleration
 * @return bool
 */
function start_accelerate($do_acceleration)
{
	$result = "none";
	$method = trim(getEnv("REQUEST_METHOD"));
	if ($do_acceleration && (strtoupper($method) != "POST"))
	{
		$encoding  = getEnv("HTTP_ACCEPT_ENCODING");
   	 	$useragent = getEnv("HTTP_USER_AGENT");
	  	if (preg_match("=gzip=i", $encoding) && function_exists("gzencode"))
	  	{
			$result = "gzip";
		}
		elseif (preg_match("=deflate=i", $encoding) && function_exists("gzdeflate"))
		{
			$result = "deflate";
		}
	}
	ob_start();
	return $result;
}

/**
 * Outputs gziped content
 * @param bool $accelerated
 */
function flush_accelerate($accelerated)
{
	$content = trim(ob_get_contents());
	ob_clean();
	if ($accelerated != "none")
	{
		$content = $accelerated=="gzip" ? gzencode($content, 9) : gzdeflate($content, 9);
		header("Content-Encoding: ".$accelerated);
	}
	header("Content-Length: ".strlen($content));
	echo $content;
}