<?php 
/**
 * Process XAJAX calls 
 * @param $action
 * @param $param1
 * @param $param2
 * @param $param3
 * @param $param4
 * @return xajaxResponse
 */

	function processAjaxAction($action, $param1 = false, $param2 = false, $param3 = false, $param4 = false)
	{
		
		global $settings, $user, $order, $db, $customFields, $url_http, $url_https, $msg;
		
		$objResponse = new xajaxResponse();
		$objResponse->setCharEncoding(XAJAX_DEFAULT_CHAR_ENCODING);
		
		switch ($action)
		{
			/**
			 * Check gift certificate
			 */
			case "tc_check_gift_cert" : 
			{
				if ($user->auth_ok)
				{
					$gift_cert = split("\|", $param1);
					$gift_cert_first_name = $gift_cert[0];
					$gift_cert_last_name = $gift_cert[1];
					$gift_cert_voucher = $gift_cert[2];
					$gift_flag = $gift_cert[3];

					if (count($gift_cert) > 4) 
					{
						$shipping_method = $gift_cert[4];
						$result = $order->updateShippingMethod($shipping_method);
						if ($shipping_method > 0)
						{
							$order->getShippingAmount( $error_message);
						}
						$order->checkFreeProducts();
						$order->recalcOrderData();
					}

					$gift_error = '0';
					if ($gift_cert_first_name != '' || $gift_cert_last_name != '' || $gift_cert_voucher != '') 
					{
						$gift_cert = new GiftCertificates($db);
						$gift_data = $gift_cert->GetOrderedGiftCert($gift_cert_first_name, $gift_cert_last_name, $gift_cert_voucher);
						if ($gift_data === false) 
						{
							// provided data incorrect
							$gift_error = '1';
						}
						else 
						{
							$gift_cert->SetOrderGiftCert($order->oid, $gift_cert_first_name, $gift_cert_last_name, $gift_cert_voucher);
							if ($gift_flag == '1') 
							{
								$total_amount = $order->totalAmount; //-$order->shippingAmount-$order->taxAmount-($order->handlingSeparated?$order->handlingAmount:0.00);
								$balance = $gift_data['balance'];
								if ($total_amount > $balance) 
								{
									$gift_error = '2';
									$gift_cert->UpdateOrderGCAmount($order->oid, $balance);
								}
								else 
								{
									$gift_cert->UpdateOrderGCAmount($order->oid, $total_amount);
									$order->updatePaymentMethod("free");
								}
							}
						}
					}

					if ($gift_error == '1') 
					{
						$objResponse->addAssign("gift_cert_error", "style.display", "block");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "none");
					}
					else if ($gift_error == '2') 
					{
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "block");
						$objResponse->addScript("alert('The balance of gift certificate is less than order amount. The remainder is $".number_format($total_amount-$balance, 2)."')");
						$objResponse->addScript("altPaymentGiftCert('$total_amount', '$balance')");
					}
					else 
					{
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "none");
						$objResponse->addScript("altPaymentGiftCert('$total_amount', '$total_amount')");
						$objResponse->addScript("continueGiftCert()");
					}
				}
				else
				{
					$objResponse->addAssign("document.location", "index.php?p=auth_error");
				}
				break;
			
			}
			
			/**
			 * Set payment method
			 */
			case "tc_set_payment_method" : 
			{
				if ($user->auth_ok)
				{
					$order->updatePaymentMethod($param1);
					$_SESSION["pc_method_id"] = $order->paymentMethodId;
					if($order->gift_cert_amount > 0 && $order->totalAmount > $order->gift_cert_amount){
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "block");
						$objResponse->addScript("altPaymentGiftCert('$order->totalAmount', '$order->gift_cert_amount')");
					}
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
				}
				break;
			}

			/**
			 * Setup google checkout
			 */
			case "setup_google_checkout" :
			{
				$address =array();
				$address["name"] = "";
                $address["company"] = "";
                $address["address1"] = "";
				$address["address2"] = "";
				$address["city"] = "";
				$address["state"] = "";
				$address["province"] ="";
				$address["country"] = 1; 
				$address["country_code"] = "US";
				
				//For UK postal codes
				if (eregi('^(([A-Z]{1,2}[0-9][0-9A-Z]{0,1})\ ([0-9][A-Z]{2}))|(GIR\ 0AA)$', $param1))
				{
    				$db->query("SELECT coid,iso_a2 FROM ".DB_PREFIX."countries WHERE iso_a2='GB'");
					$address["country"] = $db->moveNext() ? $db->col["coid"] : 0;
					$address["country_code"] = $db->col["iso_a2"];
				}
				else
				{
				//For USA postal codes
   					$db->query("SELECT coid,iso_a2 FROM ".DB_PREFIX."countries WHERE iso_a2='US'");
					$address["country"] = $db->moveNext() ? $db->col["coid"] : 1;
					$address["country_code"] = $db->col["iso_a2"];
					$state = validstatezip($param1);
					$state_id = getStateId($db,$state);
					$address["state"] = $state_id;
				}
				$address["zip"] = $param1;
				
				$order->updateShippingAddress($address);
				$order->getShippingAmount($error_message);
				
				$r = getShippingQuotes($db, $user, $order);
				$shipping_methods_list = $r["shipping_methods"];
				
				@require_once("content/engine/payment/payment_googlecheckout.php");
				$payment_gateway = new PAYMENT_GOOGLECHECKOUT();
				$payment_form= $payment_gateway->getPaymentForm($db,$shipping_methods_list,$address);
				
				$objResponse->addAssign('signature', 'value', $payment_form[0]);
				$objResponse->addAssign('cart', 'value', $payment_form[1]);
				$db->reset();
				$db->assignStr("custom1", "Google Checkout order");
				$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
				$objResponse->addScript('document.forms["frmGoogle"].submit();');				
				break;
			}

			case "show_equip":
				{
				require_once("content/classes/class.catalog.php");
				//echo $param1; exit();
			   // if($param1!=0){
				$catalog = new ShoppingCartCatalog($db);
				$sub_cat= $catalog->getSubCategoriesById($param1);
			   // echo count($sub_cat); exit;
			   $prefix='';
				for($i=0;$i<count($sub_cat);$i++)
				{
					if($i==0)
				  $option="<option value='".$sub_cat[$i]['cid']."'";
					else
				   $option.="<option value='".$sub_cat[$i]['cid']."'"; 
				   
				  /*if($sub_cat[$i]['parent'] == 1)
					$prefix = 'Used';
				  elseif($sub_cat[$i]['parent'] == 2)
					$prefix = 'New';*/
					
				  if($param2==$sub_cat[$i]['cid'])
					  $option.= "selected";
					  $option.= ">".$prefix." ".$sub_cat[$i]['name']."</option>";
				 }
					

				
			   /*}
				else
					$option='<option value="0" selected>All Equipment Type</option>';*/
			//if($param1==0)
			  #$startoption = "<option value='0'>Select All</option>";
			  
			   $startoption = "<option value='0'>All Products</option>";
			   
			  
			  $objResponse->addAssign('equipment', 'innerHTML', '<select name="equipment" onclick="chkcategory();">'.$startoption.$option.'</select>');
			  break;
			}
			
			case "show_equip_adv":
				{
				require_once("content/classes/class.catalog.php");
				//echo $param1; exit();
			   // if($param1!=0){
				$catalog = new ShoppingCartCatalog($db);
				$sub_cat= $catalog->getSubCategoriesById($param1);
			   // echo count($sub_cat); exit;
			   $prefix='';
				for($i=0;$i<count($sub_cat);$i++)
				{
					if($i==0)
				  $option="<option value='".$sub_cat[$i]['cid']."'";
					else
				   $option.="<option value='".$sub_cat[$i]['cid']."'"; 
				   
				  /*if($sub_cat[$i]['parent'] == 1)
					$prefix = 'Used';
				  elseif($sub_cat[$i]['parent'] == 2)
					$prefix = 'New';*/
					
				  if($param2==$sub_cat[$i]['cid'])
					  $option.= "selected";
					  $option.= ">".$prefix." ".$sub_cat[$i]['name']."</option>";
				 }
					

				
			   /*}
				else
					$option='<option value="0" selected>All Equipment Type</option>';*/
			//if($param1==0)
			  $startoption = "<option value='0'>Select All</option>";
			  
			  $objResponse->addAssign('equipment_adv', 'innerHTML', '<select name="equipment_adv" onclick="chkcategory();">'.$startoption.$option.'</select>');
			  break;
			}
			
		}

		return $objResponse->getXML();
	}
