<?php 
	if (!defined("IMAGETYPE_GIF")) define("IMAGETYPE_GIF", 1);
	if (!defined("IMAGETYPE_JPG")) define("IMAGETYPE_JPG", 2);
	if (!defined("IMAGETYPE_PNG")) define("IMAGETYPE_PNG", 3);
	
	$product_images_dir = "images/products";
	$product_secondary_images_dir = "images/products/secondary";
	$product_pdf_dir = "images/products/pdf-files";
	$product_videos_dir = "images/products/videos";
	$product_thumbs_dir = "images/products/thumbs";
	$product_email_dir = "images/products/email";
	$product_category_dir = "images/products/category";
	$product_thumbs2_dir = "images/products/preview";
	
	$catalog_images_dir = "images/catalog";
	$catalog_thumbs_dir = "images/catalog/thumbs";
	
	function imageFileName($product_id){
		$s = strtolower(trim($product_id));
		for($i=0; $i<strlen($s); $i++){
			if(in_array($s[$i], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$s[$i] = "_";
		}
		return $s;
	}
	
	///////////////////////////////////////////
	//check does product has image
	function ProductHasImage($product_id)
	{
		global $product_images_dir;
		$pi = imageFileName($product_id);
		if (file_exists($product_images_dir."/".$pi.".jpg"))
		{
			return $product_images_dir."/".$pi.".jpg";
		}
		elseif (file_exists($product_images_dir."/".$pi.".png"))
		{
			return $product_images_dir."/".$pi.".png";
		}
		elseif (file_exists($product_images_dir."/".$pi.".gif"))
		{
			return $product_images_dir."/".$pi.".gif";
		}
		elseif (file_exists($product_images_dir."/".$pi.".JPG"))
		{
			return $product_images_dir."/".$pi.".JPG";
		}
		elseif (file_exists($product_images_dir."/".$pi.".PNG"))
		{
			return $product_images_dir."/".$pi.".PNG";
		}
		elseif (file_exists($product_images_dir."/".$pi.".GIF"))
		{
			return $product_images_dir."/".$pi.".GIF";
		}		
		else{
			return false;
		}
	}
	
	//////////////////////////////////////
	//check is there product thumb
	function ProductHasThumb($product_id)
	{
		global $product_thumbs_dir;
		$pi = imageFileName($product_id);
		if (file_exists($product_thumbs_dir."/".$pi.".jpg"))
		{
			return $product_thumbs_dir."/".$pi.".jpg";
		}
		elseif (file_exists($product_thumbs_dir."/".$pi.".png"))
		{
			return $product_thumbs_dir."/".$pi.".png";
		}
		elseif (file_exists($product_thumbs_dir."/".$pi.".gif"))
		{
			return $product_thumbs_dir."/".$pi.".gif";
		}
		else
		{
			return false;
		}
	}


	//////////////////////////////////////
	//check is there product email thumb
	function ProductHasEmail($product_id)
	{
		global $product_email_dir;
		$pi = imageFileName($product_id);
		if (file_exists($product_email_dir."/".$pi.".jpg"))
		{
			return $product_email_dir."/".$pi.".jpg";
		}
		elseif (file_exists($product_email_dir."/".$pi.".png"))
		{
			return $product_email_dir."/".$pi.".png";
		}
		elseif (file_exists($product_email_dir."/".$pi.".gif"))
		{
			return $product_email_dir."/".$pi.".gif";
		}
		else
		{
			return false;
		}
	}	
	
	//////////////////////////////////////
	//check is there product thumb
	function ProductHasThumb2($product_id){
		global $product_thumbs2_dir;
		$pi = imageFileName($product_id);
		if(file_exists($product_thumbs2_dir."/".$pi.".jpg")){
			return $product_thumbs2_dir."/".$pi.".jpg";
		}
		elseif(file_exists($product_thumbs2_dir."/".$pi.".png")){
			return $product_thumbs2_dir."/".$pi.".png";
		}
		elseif(file_exists($product_thumbs2_dir."/".$pi.".gif")){
			return $product_thumbs2_dir."/".$pi.".gif";
		}
		else{
			return false;
		}
	}
	
	function ProductHasSecondaryThumb($iid){	
		global $product_secondary_images_dir;
		if(file_exists($product_secondary_images_dir."/".$iid."_thumb.jpg")){
			return $product_secondary_images_dir."/".$iid."_thumb.jpg";
		}
		else{
			return false;
		}
	}
	
	///////////////////////////////
	//check does category has image
	//note: categories do not supports thumbnails
	function CategoryHasImage($cid){
		global $catalog_images_dir;
		$f = $catalog_images_dir."/category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}
	
	
	function CategoryHasCarouselImage($cid){
		global $catalog_images_dir;
		$f = $catalog_images_dir."/carousel/category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}
	
	
	function CategoryHasCarouselTumbImage($cid){
		global $catalog_images_dir;
		
		$f = $catalog_images_dir."/carousel/thumbs_category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}
	
	
	///////////////////////////////
	//check does category has image
	//note: categories do not supports thumbnails
	function CategoryHasThumb($cid){
		global $catalog_thumbs_dir;
		$f = $catalog_thumbs_dir."/category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}
	
	///////////////////////////////////////////////////////
	//generate thumbnail image use internal GDLib functions
	function getImageThumb($source, $destination, $size, $type, &$error)
	{
		if (function_exists("imagejpeg"))
		{
			$info = @getimagesize($source);
			if($info)
			{
				switch($info[2]){
					case IMAGETYPE_GIF : { $error = "Can't crete thumbnail image with GIF file. GDLib does not support GIF images format."; return false;}
					case IMAGETYPE_JPG : { $s = @imagecreatefromjpeg($source); break; }//jpg
					case IMAGETYPE_PNG : { $s = @imagecreatefrompng($source); break; }//png
					default : { $error = "Unsupported file type"; return false;}
				}
			}
			else
			{
				$error = "Can't read required image data";
				return false;
			}
			
			if ($s)
			{
				if ($type == "Proportionate")
				{
					$w = $info[0]; $x = 0;
					$h = $info[1]; $y = 0;
					
					if ($h > $w)
					{
						$nh = $size;
						$nw = round($nh/$h*$w);
					}
				
					if ($w > $h)
					{
						$nw = $size;
						$nh = round($nw/$w*$h);
					}
				
					if ($w == $h)
					{
						$nw = $nh = $size;
					}
				
					if	(function_exists("imagecreatetruecolor"))
					{
						$d = @imagecreatetruecolor($nw, $nh);
						if (!$d)
						{
							$d = imagecreate($nw, $nh);
						}
					}
					else
					{
						$d = imagecreate($nw, $nh);
					}
					
					if ($info[2] == IMAGETYPE_PNG)
					{
						$transparent = imagecolorallocatealpha($d, 0, 0, 0, 127);
						imagealphablending($d, false);
						imagefill($d, 0, 0, $transparent);
						imagesavealpha($d, true);
					}
				}
			
				if ($type == "Square")
				{
					if (function_exists("imagecreatetruecolor"))
					{
						$d = @imagecreatetruecolor($size, $size);
						if (!$d)
						{
							$d = imagecreate($size, $size);
						}
					}
					else
					{
						$d = imagecreate($size, $size);
					}
					
					//fill with white color
					$white = imagecolorallocate($d, 255, 255, 255);
					imagefill($d, 1, 1, $white);
					
					//prepare resample
					$w = $info[0];
					$h = $info[1];
					if ($h > $w)
					{
						$nh = $size - 2;
						$nw = round($nh/$h*$w);
						$y = 1;
						$x = round(($size - $nw) / 2);
					}
					if ($w > $h)
					{
						$nw = $size - 2;
						$nh = round($nw/$w*$h);
						$x = 1;
						$y = round(($size - $nh) / 2);
					}
					if ($w == $h)
					{
						$nw = $nh = $size - 2;	$x = $y = 1;
					}
				}
				
				if (function_exists("imagecopyresampled"))
				{
					if (!imagecopyresampled($d, $s, $x, $y, 0, 0, $nw, $nh, $info[0], $info[1]))
					{
						imagecopyresized($d, $s, $x, $y, 0, 0, $nw, $nh, $info[0], $info[1]);
					}
				}
				else
				{
					imagecopyresized($d, $s, $x, $y, 0, 0, $nw, $nh, $info[0], $info[1]);
				}
				if (is_file($destination))
				{
					@unlink($destination);
				}
				
				// save jpg
				if (($info[2] == IMAGETYPE_JPG && @imagejpeg($d, $destination, 100)) || ($info[2] == IMAGETYPE_PNG && @imagepng($d, $destination, 9)))
				{
					@chmod($destination, 0666);
					return true;
				}
				else
				{
					$error = "Can't save destination thumbnail image";
					return false;
				}
			}
			else
			{
				$error = "Can't create thumbnail image";
				return false;
			}
		}
		else
		{
			pageNote(array(
				array("icon"=>"ic_error.gif", "text"=>"<b>Can't generate thumbnail image.</b>", "url"=>"",  "visible"=>true)
			));
		}
	}
        
 ?>