<?php 

	require_once('content/classes/class.imageutility.php');

	if (!defined("IMAGETYPE_GIF")) define("IMAGETYPE_GIF", 1);
	if (!defined("IMAGETYPE_JPG")) define("IMAGETYPE_JPG", 2);
	if (!defined("IMAGETYPE_PNG")) define("IMAGETYPE_PNG", 3);
	
	$product_images_dir = "images/products";
	$product_secondary_images_dir = "images/products/secondary";
	$product_thumbs_dir = "images/products/thumbs";
	$product_thumbs2_dir = "images/products/preview";
	
	$catalog_images_dir = "images/catalog";
	$catalog_thumbs_dir = "images/catalog/thumbs";
	
	function imageFileName($product_id)
	{
		$s = str_replace(array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'"), array('_', '_', '_', '_', '_', '_', '_', '_', '_', '_'), strtolower(trim($product_id)));

		return $s;
	}
	
	/**
	 * Return image file info
	 * @param type $fileName 
	 */
	function imageInfo($fileName)
	{
		$s = getimagesize($fileName);
		return $s ? array('width'=>$s[0], 'height'=>$s[1], 'filesize'=>filesize($fileName), 'filesizekb'=>round(filesize($fileName)/1024), 2) : false;
	}
	
	///////////////////////////////////////////
	//check does product has image
	function ProductHasImage($product_id)
	{
		global $product_images_dir;
		$pi = imageFileName($product_id);
		if (file_exists($product_images_dir."/".$pi.".jpg"))
		{
			return $product_images_dir."/".$pi.".jpg";
		}
		elseif (file_exists($product_images_dir."/".$pi.".png"))
		{
			return $product_images_dir."/".$pi.".png";
		}
		elseif (file_exists($product_images_dir."/".$pi.".gif"))
		{
			return $product_images_dir."/".$pi.".gif";
		}
		elseif (file_exists($product_images_dir."/".$pi.".JPG"))
		{
			return $product_images_dir."/".$pi.".JPG";
		}
		elseif (file_exists($product_images_dir."/".$pi.".PNG"))
		{
			return $product_images_dir."/".$pi.".PNG";
		}
		elseif (file_exists($product_images_dir."/".$pi.".GIF"))
		{
			return $product_images_dir."/".$pi.".GIF";
		}		
		else{
			return false;
		}
	}
	
	//////////////////////////////////////
	//check is there product thumb
	function ProductHasThumb($product_id)
	{
		global $product_thumbs_dir;
		$pi = imageFileName($product_id);
		if (file_exists($product_thumbs_dir."/".$pi.".jpg"))
		{
			return $product_thumbs_dir."/".$pi.".jpg";
		}
		elseif (file_exists($product_thumbs_dir."/".$pi.".png"))
		{
			return $product_thumbs_dir."/".$pi.".png";
		}
		elseif (file_exists($product_thumbs_dir."/".$pi.".gif"))
		{
			return $product_thumbs_dir."/".$pi.".gif";
		}
		else
		{
			return false;
		}
	}
	
	//////////////////////////////////////
	//check is there product thumb
	function ProductHasThumb2($product_id){
		global $product_thumbs2_dir;
		$pi = imageFileName($product_id);
		if(file_exists($product_thumbs2_dir."/".$pi.".jpg")){
			return $product_thumbs2_dir."/".$pi.".jpg";
		}
		elseif(file_exists($product_thumbs2_dir."/".$pi.".png")){
			return $product_thumbs2_dir."/".$pi.".png";
		}
		elseif(file_exists($product_thumbs2_dir."/".$pi.".gif")){
			return $product_thumbs2_dir."/".$pi.".gif";
		}
		else{
			return false;
		}
	}
	
	function ProductHasSecondaryThumb($iid){	
		global $product_secondary_images_dir;
		if(file_exists($product_secondary_images_dir."/".$iid."_thumb.jpg")){
			return $product_secondary_images_dir."/".$iid."_thumb.jpg";
		}
		else{
			return false;
		}
	}
	
	///////////////////////////////
	//check does category has image
	//note: categories do not supports thumbnails
	function CategoryHasImage($cid){
		global $catalog_images_dir;
		$f = $catalog_images_dir."/category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}
	
	///////////////////////////////
	//check does category has image
	//note: categories do not supports thumbnails
	function CategoryHasThumb($cid){
		global $catalog_thumbs_dir;
		$f = $catalog_thumbs_dir."/category".$cid.".";
		if(file_exists($f."jpg")){
			return $f."jpg";
		}
		elseif(file_exists($f."png")){
			return $f."png";
		}
		elseif(file_exists($f."gif")){
			return $f."gif";
		}
		else{
			return false;
		}
	}

	function generateProductThumb($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings["CatalogThumbSize"], $settings["CatalogThumbType"], $error, $settings["CatalogThumbResizeRule"]);
	}

	function generateProductPreview($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings["CatalogThumb2Size"], $settings["CatalogThumb2Type"], $error, $settings["CatalogThumb2ResizeRule"]);
	}

	function generateCategoryImage($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings["CatalogCategoryImageSize"], $settings["CatalogCategoryImageType"], $error, $settings["CatalogCategoryImageResizeRule"]);
	}

	function generateCategoryThumb($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings['CatalogCategoryThumbSize'], $settings['CatalogCategoryThumbType'], $error, $settings['CatalogCategoryThumbResizeRule']);
	}

	function generateManufacturerImage($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings["CatalogManufacturerImageSize"], $settings["CatalogManufacturerImageType"], $error, $settings["CatalogManufacturerImageResizeRule"]);
	}

	function generateProductSecondaryThumb($source, $destination)
	{
		global $settings;

		$error = false;

		return getImageThumb($source, $destination, $settings["CatalogSecondaryThumbSize"], $settings["CatalogThumbType"], $error, $settings["CatalogThumbResizeRule"]);
	}

	///////////////////////////////////////////////////////
	//generate thumbnail image use internal GDLib functions
	function getImageThumb($source, $destination, $size, $type, &$error, $resizeRule = 'Resize')
	{
		try
		{
			return ImageUtility::resizeImage($source, $destination, $size, $type, $resizeRule);
		}
		catch (Exception $e)
		{
			$error = $e->getMessage();
		}

		return false;
	}
