<?php 

	function getShippingCountries($db){
		$db->query("SELECT country FROM ".DB_PREFIX."shipping_selected");
		$a = array();
		while($db->moveNext()){
			$cc = explode(",", $db->col["country"]);
			for($i=0; $i<count($cc); $i++){
				$cc[$i] = trim($cc[$i]);
				if($cc[$i] != ""){
					if(!in_array($cc[$i], $a)){
						$a[] = $cc[$i];
					}
				}
			}
		}
		return count($a)>0?$a:false;
	}
	
	/**
	 * Canada Post - Likuid Communication
	 * @global type $settings
	 * @global type $cp_xml_result
	 * @global type $cp_orderid
	 * @global type $cp_delivery
	 * @param type $db
	 * @param type $data
	 * @param type $from
	 * @param type $to
	 * @param type $weight
	 * @param type $items
	 * @param type $items_price_based
	 * @param string $error_message
	 * @return type 
	 */
	function getCanadaPostShippingPrice($db, $data, $from, $to, $weight, $items, $items_price_based, &$error_message)
	{
		global $settings;
    	global $cp_xml_result;
    	global $cp_orderid;
    	require_once($settings["GlobalServerPath"]."/content/engine/engine_canada_post.php");

    	if(!isset($cp_xml_result)){    
			$db->query("SELECT name FROM ".DB_PREFIX."states WHERE stid='".(isset($to["state"])?intval($to["state"]):0)."'");
			$to_state = ($db->moveNext()?$state=$db->col["name"]:" ");

			$CanadaPost = new CanadaPost($settings["ShippingCPUrlRating"], $settings["ShippingCPMerchantID"], $settings);
			$CanadaPost->setOrigin($settings["ShippingOriginZip"]);
			$CanadaPost->setDestination(" ", $to_state, $to["country_iso_a2"], $to["zip"]);
			$CanadaPost->setOption("tat", $settings["ShippingCPTAT"]);
			if($settings["ShippingCPItemsValue"] != "no"){
				$CanadaPost->setOption("itemsvalue", $items_price_based);
			}
			
			$securityId = isset($_COOKIE["_pcod"]) ? $_COOKIE["_pcod"] : "";
			$securityId = $securityId == "" ? isset($_POST["_pcod"]) ? $_POST["_pcod"] : $securityId : $securityId;
			$securityId = $securityId == "" ? isset($_GET["_pcod"]) ? $_GET["_pcod"] : $securityId : $securityId;
			
			$db->query("SELECT * FROM ".DB_PREFIX."orders_content oc JOIN ".DB_PREFIX."orders o ON (oc.oid = o.oid) WHERE security_id='".$db->escape($securityId)."'");
			
			while($db->moveNext()){
				$CanadaPost->addItem($db->col["quantity"], $db->col["weight"], 1, 1, 1, $db->col["title"]);
			}
      
			$CanadaPost->createXMLRequest();
			$cp_xml_result = $CanadaPost->getQuote();
		}

		if(is_array($cp_xml_result)){
			foreach($cp_xml_result as $cp_method){
				if($cp_method["id"] == $data["method_id"]){
					global $cp_delivery;
					$cp_delivery = $cp_method["delivery"];
					$price = $cp_method["rate"];
					if($price > 0){
						//check advanced fee
						if($data["fee_type"] == "percent"){
							$price = $price + $price / 100 * $data["fee"];
						}
						if($data["fee_type"] == "amount"){
							$price = $price + $data["fee"];
						}
					}
					return normalizeNumber($price);
				}
			}
		}
		$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
		return false;
	}
	//////////////////////////////////////////////////////////////////////////////	
	//////////////////////////////////////////////////////////////////////////////
	
	////////////////////////////////////////////////
	// USPS Domestic
	function getUSPSDomesticShippingPrice($db, $data, $from, $to, $weight, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		require_once($settings["GlobalServerPath"]."/content/engine/engine_usps.php");
		$usps = new USPS;
		$usps->setUSPSSettings();
		//$usps->setServer($settings["ShippingUSPSUrl"]);
		//$usps->setUserName($settings["ShippingUSPSUserID"]);
		//$usps->setPass($settings["ShippingUSPSUserPassword"]);
		
		$usps->setDestZip($to["zip"]); 
		$usps->setOrigZip($from["zip"]); 
		

		$weightInPounds = getWeightInPounds($weight, $settings['LocalizationWeightUnits']);

		$weight_pounds = $weightInPounds['pounds']; //floor($weight);
		$weight_ounces = $weightInPounds['ounces']; //round(($weight - floor($weight)) * 16, 1);

		if ($data["method_id"] == "First Class")
		{
			$method_name = explode(" ", $data["method_name"]);
			
			if (isset($method_name[2]))
			{
				$usps->setFirstClassMethod($method_name[2]);
			}
		}
		
		$usps->setWeight($weight_pounds, $weight_ounces); 
		$usps->setService($data["method_id"]);
		$usps->setMachinable("True");
		
		$price = $usps->getDomesticPrice();   
		
		if ($price > 0)
		{
			// apply currency exchange rate
			if ($defaultCurrencyCode != 'USD' && isset($currencyExchangeRates['USD']))
			{
				$price = (float) $price / $currencyExchangeRates['USD'];
			}
			
			//check advanced fee
			if ($data["fee_type"] == "percent")
			{
				$price = $price + $price / 100 * $data["fee"];
			}
			
			if ($data["fee_type"] == "amount")
			{
				$price = $price + $data["fee"];
			}
			
			return $price;
		}
		else
		{
			$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
			return false;
		}
	}
	
	////////////////////////////////////////////////
	// USPS International
	function getUSPSInternationalShippingPrice($db, $data, $from, $to, $weight, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		require_once($settings["GlobalServerPath"]."/content/engine/engine_usps.php");
		$usps = new USPS;
		$usps->setUSPSSettings();

		$weightInPounds = getWeightInPounds($weight, $settings['LocalizationWeightUnits']);

		$weight_pounds = $weightInPounds['pounds'];
		$weight_ounces = $weightInPounds['ounces'];
		$usps->setWeight($weight_pounds, $weight_ounces); 
		
		$usps->setCountry($to["country"]);
		$usps->setCountryCode($to["country_iso_a2"]);
		$usps->setMailType($data["method_id"]);
		$price = $usps->getInternationalPrice();
		
		if ($price > 0)
		{
			// apply currency exchange rate
			if ($defaultCurrencyCode != 'USD' && isset($currencyExchangeRates['USD']))
			{
				$price = (float) $price / $currencyExchangeRates['USD'];
			}
		
			//check advanced fee
			if ($data["fee_type"] == "percent")
			{
				$price = $price + $price / 100 * $data["fee"];
			}
			if ($data["fee_type"] == "amount")
			{
				$price = $price + $data["fee"];
			}
			
			return $price;
		}
		else
		{
			$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
			return false;
		}
	}

	function getWeightInPounds($weight, $weightUnit = 'lbs')
	{
		$weightInPounds = $weight;

		if ($weightUnit == 'kg')
		{
			$weightInPounds = $weight * 2.20462;
		}

		return array(
			'pounds' => floor($weightInPounds),
			'ounces' => round(($weightInPounds - floor($weightInPounds)) * 16, 1),
		);
	}

	/**
	 * Calculates shipping price (based on method & type)
	 * 
	 * @param DB $db
	 * @param array $from
	 * @param array $to
	 * @param float $weight
	 * @param array $itemsCount
	 * @param float $itemsPriceBasedPrice
	 * @param int $ssid
	 * @param string $error_message
	 * 
	 * @return type 
	 */
	function getShippingPrice($db, $from, $to, $weight, $itemsCount, $itemsPriceBasedPrice, $ssid, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;

		$shippingRepository = new DataAccess_ShippingRepository($db);
		
		$data = $shippingRepository->getShippingMethodData($ssid);

		if ($data)
		{
			
			$itemsPriceBasedPrice = is_array($itemsPriceBasedPrice) ? $itemsPriceBasedPrice : array('before_discount' => $itemsPriceBasedPrice, 'after_discount' => $itemsPriceBasedPrice);
			$itemsPriceBasedPrice = $itemsPriceBasedPrice[$data['method_calc_mode']];
			
			switch ($data["carrier_id"])
			{
				case "canada_post" : 
				{
					$price = getCanadaPostShippingPrice($db, $data, $from, $to, $weight, $itemsCount, $itemsPriceBasedPrice, $error_message);
					return $price;
					break;
				}
				
				case "usps_domestic" : 
				{
					$price = getUSPSDomesticShippingPrice($db, $data, $from, $to, $weight, $error_message, $defaultCurrencyCode, $currencyExchangeRates);
					return $price;
					break;
				}
				case "usps_international" : 
				{
					$price = getUSPSInternationalShippingPrice($db, $data, $from, $to, $weight, $error_message, $defaultCurrencyCode, $currencyExchangeRates);
					return $price;
					break;
				}
				
				case "ups" : 
				{
					$ups = new Shipping_Ups();
					$ups->setServer($settings["ShippingUPSUrl"]);
					$ups->setUserName($settings["ShippingUPSUserID"]);
					$ups->setPass($settings["ShippingUPSUserPassword"]);
					$ups->setAccessKey($settings["ShippingUPSAccessKey"]);
					$ups->setResidential(isset($to["address_type"]) && ($to["address_type"] == "Residential") ? 1 : 0);
					$ups->setPickupType($settings["ShippingUPSRateChart"]);
					$ups->setContainer($settings["ShippingUPSContainer"]);
					$ups->setWeightUnit(strtoupper($settings["LocalizationWeightUnits"]) == "LBS" ? "LBS" : "KGS");
					$ups->setLengthUnit($settings["LocalizationLengthUnits"]);
					$ups->setCountry($to["country_iso_a2"], $from["country_iso_a2"]);
					$ups->setDestZip($to["zip"]); 
					$ups->setOrigZip($from["zip"]); 
					$ups->setWeight($weight); 
					$ups->setService($data["method_id"]);

					$ups->setDefaultCurrency($defaultCurrencyCode);
					$ups->setCurrencyExchangeRates($currencyExchangeRates);

					$ups->setShippingFeeType($data["fee_type"]);
					$ups->setShippingFeeValue($data["fee"]);

					$price = $ups->getShippingRate();

					return $price;
					break;
				}

				case "fedex_api_express_us" :
				case "fedex_api_freight_us" :
				case "fedex_api_ground_us" :
				case "fedex_api_intr" :
				case "fedex_api_intr_freight" :
				{
					$fedex = new Shipping_Fedex();
					$fedex->setApiKey($settings['ShippingFedExApiKey']);
					$fedex->setApiPassword($settings['ShippingFedExApiPassword']);
					$fedex->setShippingAccount($settings['ShippingFedExAccountNumber']);
					$fedex->setBillingAccount($settings['ShippingFedExBillingAccountNumber']);
					$fedex->setFreightAccount($settings['ShippingFedExFreightAccountNumber']);
					$fedex->setMeterNumber($settings['ShippingFedExMeter']);

					$fedex->setWeightUnits($settings['LocalizationWeightUnits'] == 'kg' ? 'KG' : 'LB');
					$fedex->setTotalWeight($weight);
					$fedex->setOriginAddress($from);
					$fedex->setDestinationAddress($to);
					$fedex->setServiceType($data["method_id"]);
					$fedex->setRateRule($settings["ShippingFedExRateRule"]);
					$fedex->setRateRequestType($settings["ShippingFedExRateRequestType"]);

					$fedex->setFreightClass($settings['ShippingFedExFreightClass']);
					$fedex->setFreightPackaging($settings['ShippingFedExFreightPackaging']);
					$fedex->setFreightPackagingWeight($settings['ShippingFedExFreightPackagingWeight']);
					
					$fedex->setPreferredCurrency($defaultCurrencyCode);
					$fedex->setDefaultCurrency($defaultCurrencyCode);
					$fedex->setCurrencyExchangeRates($currencyExchangeRates);

					$fedex->setShippingFeeType($data["fee_type"]);
					$fedex->setShippingFeeValue($data["fee"]);

					$price = $fedex->getShippingRate();
					
					return $price;
					break;
				}

				case "custom" : 
				{
					$custom = new Shipping_Custom($shippingRepository);

					$custom->setShippingMethodId($data["ssid"]);
					$custom->setShippingMethodType($data["method_id"]);
					$custom->setWeight($weight);
					$custom->setItemsCount($itemsCount);
					$custom->setItemsPriceBasedPrice($itemsPriceBasedPrice);

					$price = $custom->getShippingRate();
					
					return $price;
					break;
				}
			}
		}
	}

	/**
	 * GET SHIPPING QUOTES, AND ASSIGN SMARTY VARS
	 * If handling included in shipping, returns data with handling included
	 * @param $db
	 * @param $user
	 * @param $order
	 * @param $shipping_quote_call
	 * @param $shipping_quote_address
	 */
	function getShippingQuotes(
		&$db, USER &$user, ORDER &$order,
		$shipping_quote_call = false, $shipping_quote_address = false, $ignore_free_shipping = false, 
		$defaultCurrencyCode = 'USD', $currencyExchangeRates = array(),
		$bongoActive = false, &$bongoUsed
	)
	{
		global $shipping_error, $shipping_error_message;
		global $settings;
		
		$bongoUsed = false;

		$method_checked = false;
		
		$product_level_method_used = false;
		$shipping_price_at_product_level = 0;
		$product_level_method = false;
		$international_error = false;
		$shipping_methods = false;
		$shipping_methods_exist = false;
		
		$dollar_days_shipping_percent = 15;
		$dollar_days_shipping_min_amount = 6.95;
		
		$shipping_price_at_product_level = 0;
		$shipping_amount_for_price_based = 0;
		$shipping_amount_for_price_based_discounted = 0;
		$shipping_amount_for_price_based_exists = false;

		$shipping_weight = 0;
		$shipping_items_count = 0;
		$dollar_days_products_price = 0;
		$shipping_amount_dollar_days = 0;
		$shipping_amount_doba = 0;
		$doba_items = array();
		$shipping_digital = 1;

		if ($shipping_quote_call)
		{
			$shipping_address = $shipping_quote_address;
		}
		else
		{
			$order->getShippingAddress();
			$shipping_address = $order->shippingAddress;
		}

		// delivery to bongo instead of international address
		if ($bongoActive && $shipping_address['country_id'] != '1')
		{
			$shipping_address["country_id"] = 1;
			$shipping_address["state_id"] = $settings['bongocheckout_State'];
		}

		$order->checkShippingDigital();
	
		$shipping_error = isset($shipping_error) ? $shipping_error : false;
		$shipping_error_message = isset($shipping_error_message) ? $shipping_error_message : "";
	
		if (($settings["ShippingInternational"] == "NO") && ($shipping_address["country_id"] != $settings["ShippingOriginCountry"]))
		{
			$international_error = true;
		}
		elseif ($settings["ShippingCalcEnabled"] == "YES")
		{

			$shippingRepository = new DataAccess_ShippingRepository($db);
			
			/**
			 * Select available shipping methods
			 */
			$activeShippingMethods = $shippingRepository->getActiveShippingMethods();

			$shipping_methods_exist = $activeShippingMethods && is_array($activeShippingMethods) && count($activeShippingMethods) > 1;
		
			$available_methods = array();
			$product_level_method = false;
		
			foreach ($activeShippingMethods as $data)
			{
				$accept_countries = explode(",", $data["country"]);
				$accept_states = explode(",", $data["state"]);
				
				/**
				 * Check do we ship to selected country
				 */
				if (($data["country"] == 0 || in_array($shipping_address["country_id"], $accept_countries)) && ($data["country_exclude"] != $shipping_address["country_id"]))
				{
					if ($data["state"] == 0 || in_array($shipping_address["state_id"], $accept_states))
					{
						if (($data["carrier_id"] == "custom") && ($data["method_id"] == "product_level") && ($product_level_method == false))
						{
							$product_level_method = $data;
						}
						else
						{
							$available_methods[] = $data;
						}
					}
				}
			}
		
			/**
			 * Check shipping on product level
			 */
			if ($product_level_method)
			{
				$orderItems = $shippingRepository->getOrderItemsWithShippingPrice($order->getId(), $product_level_method["ssid"]);
			}
			else
			{
				$orderItems = $shippingRepository->getOrderItems($order->getId());
			}
			
			//will be set to true if there are not only doba and dollar day products
			$ship_user_products = false;
			
			/**
			 * Get order items
			 */
			foreach ($orderItems as $item)
			{
				//check is there "real" items
				if ($item["digital_product"] == "No") $shipping_digital = 0;

				//check dollar days shipping
				if ($item["is_dollar_days"] == "Yes")
				{
					$dollar_days_products_price += $item["price"] * $item["quantity"];
				}
				//doba
				elseif ($item["is_doba"] == "Yes")
				{
					$doba_items[] = array(
						"item_id"=>$item["product_id"], 
						"quantity"=>$item["quantity"]
					);
				}
				//other "native cart" products
				else
				{
					$ship_user_products = true;
					
					if ($item["digital_product"] == "No")
					{
						/**
						 * Shipping price on product level
						 */
						if ($product_level_method && $item["product_is_shipping_price"] == 'Yes' && ($item["free_shipping"] == "No" || ($item["free_shipping"] == "Yes" && $ignore_free_shipping)))
						{
							$shipping_price_at_product_level += $item["product_shipping_price"] * $item["quantity"];
							$product_level_method_used = true;
						}
						
						/**
						 * Or global shipping methods
						 */
						if (($item["product_is_shipping_price"] == 'No') && ($item["free_shipping"] == "No" || ($item["free_shipping"] == "Yes" && $ignore_free_shipping)))
						{
							/**
							 * Calculate shipping total items count
							 */
							$shipping_items_count += $item["quantity"];
							
							/**
							 * Calculate shipping weight
							 */
							if ($item["weight"] > 0 )
							{
								$shipping_weight += $item["weight"] * $item["quantity"];
							}
							
							/**
							 * Calculate shipping product price
							 */
							if ($item["price"] > 0)
							{
								$shipping_amount_for_price_based += $item["price"] * $item["quantity"];
								$shipping_amount_for_price_based_exists = true;
							}
						}
					}
				}
			}
			
			/**
			 * Dollar Days
			 */
			if ($dollar_days_products_price > 0)
			{
				$shipping_amount_dollar_days = $dollar_days_products_price / 100 * $dollar_days_shipping_percent;
				
				if ($shipping_amount_dollar_days < $dollar_days_shipping_min_amount)
				{
					$shipping_amount_dollar_days = 	$dollar_days_shipping_min_amount;
				}
				
				/**
				 * Dollar days is a product-specific shipping method
				 */
				$product_level_method_used = true;
				$shipping_price_at_product_level += $shipping_amount_dollar_days;
			}

			/**
			 * Doba
			 */
			if (count($doba_items) > 0)
			{
				require_once("content/classes/class.doba_order.php");
				$dobaOrder = new DobaOrderAPI($settings, $db);
				
			 	$shipping_amount_doba = $dobaOrder->getShippingQuote($shipping_address, $doba_items);
				
				if ($shipping_amount_doba != false)
				{
					/**
					 * Doba shipping is product-specific, too
					 */
					$product_level_method_used = true;
					$shipping_price_at_product_level += $shipping_amount_doba;
				}
			}

			/**
			 * Promo and Discounts
			 */
			if ($order->promoDiscountAmount > 0)
			{
				$promo_discount_percent = $order->promoDiscountType == "percent" ? $order->promoDiscountValue : $order->promoDiscountValue / ($order->subtotalAmount / 100);
			}
			else
			{
				$promo_discount_percent = 0;
			}

			if ($order->discountAmount > 0)
			{
				$discount_percent = $order->discountType == "percent" ? $order->discountValue : $order->discountValue / ($order->subtotalAmount / 100);
			}
			else
			{
				$discount_percent = 0;
			}

			if ($shipping_amount_for_price_based_exists)
			{
				$shipping_amount_for_price_based_discounted =
					$shipping_amount_for_price_based -
					$shipping_amount_for_price_based / 100 * $promo_discount_percent -
					$shipping_amount_for_price_based / 100 * $discount_percent;
			}
			else
			{
				$shipping_amount_for_price_based_discounted = 
					$shipping_amount_for_price_based;
			}
			
			/**
			 * Add handling to shipping price at product level
			 */
			$handlingAmountToBeAdded = 0;
			if ($settings["ShippingHandlingSeparated"] != "1")
			{
				$handlingAmount = $order->calculateHandling(false, false);
				if ($product_level_method_used && $shipping_price_at_product_level > 0)// && $shipping_price_at_product_level > 0)
				{
					$shipping_price_at_product_level = $shipping_price_at_product_level + $handlingAmount;
				}
				else
				{
					$handlingAmountToBeAdded = $handlingAmount;
				}
			}

			/**
			 * And on product method level
			 */
			if (count($available_methods) > 0 && $ship_user_products)
			{
				$address_from = $shippingRepository->getShippingOriginAddress($order->getId(), $settings);

				/**
				 * Prepare to(destination) shipping address
				 */
				if ($shipping_quote_call)
				{
					$countryData = $shippingRepository->getCountryById($shipping_quote_address["country_id"]);
					$address_to = array(
						"address_type" => "Residential", 
						"country" => $countryData["name"], 
						"country_iso_a2" => $countryData["iso_a2"], 
						"country_iso_a3" => $countryData["iso_a3"], 
						"country_iso_number" => $countryData["iso_number"], 
						"zip" => $shipping_quote_address["country_id"]=="1" ? substr(trim($shipping_quote_address["shipping_zip"]), 0, 5) : trim($shipping_quote_address["shipping_zip"])
					);
				}
				else
				{
					$addressData = $shippingRepository->getOrderShippingAddress($order->getId());
					$address_to = array(
						"address_type" => $addressData["shipping_address_type"], 
						"name" => $addressData["shipping_name"],
						"address1" => $addressData["shipping_address1"],
						"address2" => $addressData["shipping_address2"],
						"city" => $addressData["shipping_city"],
						"state_name" => $addressData["state_name"] != "" ? $addressData["state_name"] : $addressData["shipping_province"],
						"state_code" => $addressData["state_code"] != "" ? $addressData["state_code"] : "",
						"country" => $addressData["country_name"], 
						"country_iso_a2" => $addressData["country_iso_a2"], 
						"country_iso_a3" => $addressData["country_iso_a3"], 
						"country_iso_number" => $addressData["country_iso_number"], 
						"zip" => $addressData["shipping_country"]=="1" ? substr(trim($addressData["shipping_zip"]), 0, 5) : trim($addressData["shipping_zip"])
					);
				}

				// delivery to bongo instead of international address
				if ($bongoActive && strtoupper($address_to['country_iso_a2']) != 'US')
				{
					$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='1'");
					$bongoCountryData = $db->moveNext();

					$db->query("SELECT * FROM ".DB_PREFIX."states WHERE stid='".intval($settings['bongocheckout_State'])."'");
					$bongoStateData = $db->moveNext();

					$address_to = array(
						"address_type" => "Business", 
						"name" => $settings["bongocheckout_Company_Name"].", attn. ".$settings["bongocheckout_Attention_To"],
						"address1" => $settings["bongocheckout_Address1"],
						"address2" => $settings["bongocheckout_Address2"],
						"city" => $settings["bongocheckout_City"],
						"state_name" => $bongoStateData["name"],
						"state_code" => $bongoStateData["short_name"],
						"country" => $bongoCountryData["name"],
						"country_iso_a2" => $bongoCountryData["iso_a2"], 
						"country_iso_a3" => $bongoCountryData["iso_a3"], 
						"country_iso_number" => $bongoCountryData["iso_number"], 
						"zip" => $settings["bongocheckout_Zip_Code"]
					);

					$bongoUsed = true;
				}

				/**
				 * Check ranges
				 */
				$shipping_methods = array();
				$shipping_method = isset($shipping_method) ? intval($shipping_method) : $order->shippingSSID;
			
				for ($i=0; $i<count($available_methods); $i++)
				{
					$available_method = $available_methods[$i];
					$available_method["shipping_price"] = 0;
					$may_be_added = false;
					
					// check custom shipping methods
					if ($available_method["carrier_id"] == "custom")
					{
						// check items count, price based and weight ranges
						if ($available_method["method_id"] == "flat")
						{
							$c = $shipping_items_count > 0 ? $shipping_items_count : 1;
							$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$c." AND rate_max >= ".$c." ORDER BY rate_min LIMIT 1");
						}
						
						if ($available_method["method_id"] == "price" && $shipping_amount_for_price_based_exists)
						{
							if ($available_method['method_calc_mode'] == 'before_discount')
							{
								$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_amount_for_price_based." AND rate_max >= ".$shipping_amount_for_price_based." ORDER BY rate_min LIMIT 1");
							}
							else
							{
								$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_amount_for_price_based_discounted." AND rate_max >= ".$shipping_amount_for_price_based_discounted." ORDER BY rate_min LIMIT 1");
							}
						}
						
						if ($available_method["method_id"] == "base_weight" || $available_method["method_id"] == "weight")
						{
							$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_weight." AND rate_max >= ".$shipping_weight." ORDER BY rate_min LIMIT 1");
						}
						
						if ($db->moveNext())
						{
							$may_be_added = true;
						}
					}
					//now for Fedex, UPS and USPS
					else
					{
						//check weight is in allowed range
						if ($available_method["weight_min"] <= $shipping_weight && $available_method["weight_max"] >= $shipping_weight && $available_method["exclude"] == "No")
						{
							$may_be_added = true;
						}
						//check weight is now in disallowed range
						if ($available_method["weight_min"] >= $shipping_weight && $available_method["weight_max"] <= $shipping_weight && $available_method["exclude"] == "Yes")
						{
							$may_be_added = true;
						}
					}

					//try to calculate shipping price
					if ($may_be_added == true)
					{
						$error_message = "";
						
						$shippingMethod = Shipping_MethodFactory::getMethod($available_method["ssid"]);
						$result_shipping_price = $shippingMethod->calculate($db, $address_from, $address_to,
							$shipping_weight,
							$shipping_items_count,
							array(
								'before_discount'=>$shipping_amount_for_price_based, 
								'after_discount'=>$shipping_amount_for_price_based_discounted
							), //price based
							$error_message,
							$defaultCurrencyCode,
							$currencyExchangeRates
						);
						
						if ($error_message != "" || $result_shipping_price === false)
						{
							$may_be_added = false;
						}
						else
						{
							$result_shipping_price = PriceHelper::round($result_shipping_price);

							if (!$shipping_digital)
							{
								// we do not check for
								$result_shipping_price = $result_shipping_price + $handlingAmountToBeAdded;
							}

							$available_method["shipping_price"] = $result_shipping_price;
						}
						
						if ($may_be_added)
						{
							if (!$shipping_method)
							{
								$shipping_method = $available_method["ssid"];
							}
							
							$available_method["ssid"] = $available_method["ssid"];
							
							if ($shipping_method == $available_method["ssid"])
							{
								$available_method["checked"] = "yes";
								$method_checked = true;
							}
							else
							{
								$available_method["checked"] = "no";
							}
							
							$available_method["method_name"] = gs($available_method["carrier_name"]).($available_method["carrier_id"]=="custom"?"":" - ".gs($available_method["method_name"]));
							$shipping_methods[] = $available_method;
						}
					}
				}
			}
		
			if ($product_level_method_used)
			{
				if (!$product_level_method)
				{
					$product_level_method = array(
						"ssid" => 0, 
						"carrie_id" => "custom", 
						"carrier_name" => "At product level",
						"method_id" => "product_level",
						"method_name" => "At product level",
						"priority" => "5",
						"country" => "0",
						"country_exclude" => "",
						"stat" => "0",
						"weight_min" => 0,
						"weight_max" => 1000000,
						"fee" => 0, 
						"fee_type" => "amount", 
						"exclude" => "No",
						"hidden" => "No"
					);
				}	
				$product_level_method["shipping_price"] = PriceHelper::round($shipping_price_at_product_level);
				$_SESSION["product_level_method"] = $product_level_method;
			}
			else
			{
				unset($_SESSION["product_level_method"]);
			}
		}
		
		if (!$method_checked && $shipping_methods && is_array($shipping_methods))
		{
			foreach ($shipping_methods as $key => $value)
			{
				$shipping_methods[$key]["checked"] = "yes";
				break;
			}
		}
		
		unset($_SESSION["USPS_InternationalCacheResponse"]);
		unset($_SESSION["USPS_InternationalCacheResponseEnvelope"]);
		unset($_SESSION["USPS_InternationalCacheResponsePackage"]);
		unset($_SESSION["USPS_InternationalCacheResponsePostcardsorAerogrammes"]);
		
		$return = 
			array(
				"shipping_price_at_product_level" => PriceHelper::round($shipping_price_at_product_level),
				"shipping_methods" => $shipping_methods,
				"shipping_methods_count" => $shipping_methods?count($shipping_methods):0,
				"product_level_method" => $product_level_method_used?$product_level_method:false,
				"international_error" => $international_error,
				"shipping_error" => $shipping_error,
				"shipping_error_message" => $shipping_error_message,
				"shipping_methods_exist" => $shipping_methods_exist,
				"shipping_weight" => $shipping_weight
			);

		return $return;
	}
	
	/**
	 * Filter alternative shipping quotes (ignored free products) by comparing to standard shipping quotes and removing duplicates 
	 * @param mixed $rates
	 * @param mixed $ratesA
	 */
	function filterAlternativeShippingQuotes($rates, $ratesA)
	{
		$_rates = false;
		if ($ratesA && is_array($ratesA) && isset($ratesA["shipping_methods"]) && is_array($ratesA["shipping_methods"]))
		{
			$_rates = array();
				
			// combine rates
			foreach ($ratesA["shipping_methods"] as $rateA)
			{
				$ssidFound = false;
						
				// add alternative method only when price is differrent or it does not existin in standard methods
				if ($rates && is_array($rates) && isset($rates["shipping_methods"]) && is_array($rates["shipping_methods"]))
				{
					foreach ($rates["shipping_methods"] as $rate)
					{
						if ($rateA["ssid"] == $rate["ssid"])
						{
							$ssidFound = true;
							if ($rateA["shipping_price"] != $rate["shipping_price"]) $_rates[] = $rateA;
						}
					}
				}
				if (!$ssidFound) $_rates[] = $rateA;
			}
			$ratesA["shipping_methods"] = $_rates;
			$ratesA["shipping_methods_count"] = count($_rates);
			return $ratesA;
		}
		return false;
	}
	
