<?php 

	if (!defined("DESIGN_MODE")) define("DESIGN_MODE", false);
	
	// return mod rewrite configured site paths
	// see also .htaccess file
	//TODO - wrap url rewrites to class???
	
	/**
	 * Get product URL
	 * @param $url
	 * @param $pid
	 * @param $parent
	 * @param $force_http
	 */
	function getProductUrl($url, $pid, $parent="0", $force_http = false)
	{
		global $settings;
		return (DESIGN_MODE && !$force_http ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"])."/".$url;
	}
	
	/**
	 * Get catalog page URL
	 * @param $url
	 * @param $cid
	 * @param $page
	 * @param $force_http
	 */
	function getCatalogUrl($url, $cid, $page=false, $force_http = false)
	{
		global $settings;
		if ($page && intval($page) != 1)
		{
			$pageNum = $settings["SearchURLCategoryPaginatorTemplate"];
			if (($l = strlen($url)) > 0)
			{
				if ($url[$l-1] == "/")
				{
					$url = substr($url, 0, $l-1).$pageNum."/";
				}
				else
				{
					$p = pathinfo($url);
					if (isset($p['extension']) && $p['extension'] != "")
					{
						$url = substr($url, 0, $l - strlen($p['extension'])-1).$pageNum.".".$p['extension'];
					}
					else
					{
						$url.=$pageNum;
					}
				}
				$url = str_replace("%PageNumber%", $page, $url);
			}
		}
		
		
		return (DESIGN_MODE && !$force_http ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"])."/".$url;
	}
	
	/**
	 * Get text page URL
	 * @param $page_id
	 * @param $page_url
	 * @param $force_http
	 */
	function getPageUrl($page_id, $page_url, $force_http = false)
	{
		global $settings;
		return (DESIGN_MODE && !$force_http ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"])."/".$page_url;
	}
	
	/**
	 * Get site map URL
	 * @param $force_http
	 */
	function getSiteMapUrl($force_http = false)
	{
		global $settings;
		return (DESIGN_MODE && !$force_http  ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"])."/site".$settings["SearchURLJoiner"]."map.html";
	}