<?php 
/**
 * @class USPS
 */
class USPS { 
    var $server = ""; 
    var $user = ""; 
    var $pass = ""; 
    var $service = ""; 
    var $dest_zip; 
    var $orig_zip; 
    var $pounds; 
    var $ounces; 
    var $container = ""; 
    var $size = "REGULAR"; 
    var $machinable; 
	var $country;
	var $mailtype;
	var $fc_type = "";
	var $display_mode;
	
	public function setUSPSSettings()
	{
		global $settings;
		//$usps->setServer($settings["ShippingUSPSUrl"]);
		//$usps->setUserName($settings["ShippingUSPSUserID"]);
		//$usps->setPass($settings["ShippingUSPSUserPassword"]);
		$this->server = $settings["ShippingUSPSUrl"]; 
		$this->user = $settings["ShippingUSPSUserID"];
		$this->pass = $settings["ShippingUSPSUserPassword"]; 
		$this->size = $settings["ShippingUSPSPackageSize"]; 
		//$this->display_mode = $settings["ShippingUSPSMethodDisplayMode"];		
		
	} 
     
    public function setServer($server)
    { 
        $this->server = $server; 
    } 

    public function setUserName($user)
    { 
        $this->user = $user; 
    } 

    public function setPass($pass)
    { 
        $this->pass = $pass; 
    } 

    public function setService($service)
    { 
        /* Must be: Express, Priority, or Parcel */ 
        $this->service = $service; 
    } 
	
	public function setFirstClassMethod($fc_type)
	{
		$this->fc_type = $fc_type;
	}
    
	public function setMailType($mailtype)
	{
		$this->mailtype = $mailtype;
	}

	public function setCountry($country)
	{
		$this->country = $country;
	}

    public function setDestZip($sending_zip)
    { 
        /* Must be 5 digit zip (No extension) */ 
        $this->dest_zip = $sending_zip; 
    } 

    public function setOrigZip($orig_zip)
    { 
        $this->orig_zip = $orig_zip; 
    } 

    public function setWeight($pounds, $ounces=0)
    { 
        /* Must weight less than 70 lbs. */ 
        $this->pounds = $pounds; 
        $this->ounces = $ounces; 
    } 

    public function setContainer($cont)
    { 
        /* 
        Valid Containers 
                Package Name             Description 
        Express Mail 
                None                For someone using their own package 
                0-1093 Express Mail         Box, 12.25 x 15.5 x 
                0-1094 Express Mail         Tube, 36 x 6 
                EP13A Express Mail         Cardboard Envelope, 12.5 x 9.5 
                EP13C Express Mail         Tyvek Envelope, 12.5 x 15.5 
                EP13F Express Mail         Flat Rate Envelope, 12.5 x 9.5 

        Priority Mail 
                None                For someone using their own package 
                0-1095 Priority Mail        Box, 12.25 x 15.5 x 3 
                0-1096 Priority Mail         Video, 8.25 x 5.25 x 1.5 
                0-1097 Priority Mail         Box, 11.25 x 14 x 2.25 
                0-1098 Priority Mail         Tube, 6 x 38 
                EP14 Priority Mail         Tyvek Envelope, 12.5 x 15.5 
                EP14F Priority Mail         Flat Rate Envelope, 12.5 x 9.5 
         
        Parcel Post 
                None                For someone using their own package 
        */ 

        $this->container = $cont; 
    } 

    public function setSize($size)
    { 
        /* Valid Sizes 
        Package Size                Description        Service(s) Available 
        Regular package length plus girth     (84 inches or less)    Parcel Post 
                                        Priority Mail 
                                        Express Mail 

        Large package length plus girth        (more than 84 inches but    Parcel Post 
                            not more than 108 inches)    Priority Mail 
                                        Express Mail 

        Oversize package length plus girth   (more than 108 but        Parcel Post 
                             not more than 130 inches) 

        */ 
        $this->size = $size; 
    } 

    public function setMachinable($mach)
    { 
        /* Required for Parcel Post only, set to True or False */ 
        $this->machinable = $mach; 
    } 
     
    public function getDomesticPrice()
    { 
    	global $settings;
    	// may need to urlencode xml portion 
        $str = $this->server. "?API=RateV4&XML=<RateV4Request%20USERID=\"";
        $str .= urlencode($this->user)."\"%20PASSWORD=\"".urlencode($this->pass)."\"><Package%20ID=\"0\">";
		if ($this->display_mode == "all")
		{
			$str .= "<Service>All</Service>";
		}
		else
		{
        	$str .= "<Service>".urlencode($this->service)."</Service>";
		}
		if (trim($this->fc_type) != "")
		{
			$str .= "<FirstClassMailType>".urlencode($this->fc_type)."</FirstClassMailType>";
		}
		$str .= "<ZipOrigination>".urlencode($this->orig_zip)."</ZipOrigination>";
        $str .= "<ZipDestination>".urlencode($this->dest_zip)."</ZipDestination>"; 
        $str .= "<Pounds>".urlencode($this->pounds)."</Pounds><Ounces>".urlencode($this->ounces)."</Ounces>"; 
        $str .= "<Container>".urlencode($this->container)."</Container><Size>".urlencode($this->size)."</Size>"; 
        $str .= "<Machinable>".urlencode($this->machinable)."</Machinable></Package></RateV4Request>"; 
		//echo "<hr><p><b>XML data sent to USPS (service: ".$this->service."):</b><br>".htmlspecialchars($str)."</p>";
		$body = "";
		
		$cu = curl_init($str);
		
		if ($settings["ProxyAvailable"] == "YES")
		{
			curl_setopt($cu, CURLOPT_VERBOSE, 1);
			if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
			{
				curl_setopt($cu, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
			}
			curl_setopt($cu, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
			if ($settings["ProxyRequiresAuthorization"] == "YES")
			{
				curl_setopt($cu, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
			}

			curl_setopt($cu, CURLOPT_TIMEOUT, 120);
		}
		
		curl_setopt($cu, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($cu, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($cu, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
		curl_setopt($cu, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
		$body = curl_exec($cu);
		//echo "<p><b>USPS answer:</b><br>".htmlspecialchars($body)."</p>";
		if (trim($body) != "")
		{
	        # note: using split for systems with non-perl regex (don't know how to do it in sys v regex) 
    	    if (!preg_match("/Error/", $body))
    	    { 
    	    	$xmlParser = new XMLParser();
		    	$data = $xmlParser->parse($body);
        	    if (isset($data["RateV4Response"][0]["Package"][0]["Postage"][0]))
        	    {
	            	$tmp_price = $data["RateV4Response"][0]["Package"][0]["Postage"][0];
    	        	return($tmp_price["Rate"][0]); 
				}
				else
				{
					return false;
				}
			}
			else
			{
				return false;
			}
        } 
		else
		{ 
            return(false); 
        } 
    }
	
	function GetInternationalPrice()
	{
		global $settings, $_SESSION, $order;
		
		$order->subtotalAmount;
		$parts = explode("=", $this->mailtype);
		$mailtype = strtolower(trim($parts[0]));
		$service_id = strtolower(trim($parts[1]));

		if (!isset($_SESSION["USPS_InternationalCacheResponse"]))
		{
			$str = '<IntlRateV2Request USERID="'.$this->user.'" PASSWORD="'.$this->pass.'">'.
			'<Revision>2</Revision>'.
			'<Package ID="0">'.
			'<Pounds>'.$this->pounds.'</Pounds><Ounces>'.$this->ounces.'</Ounces>'. 
			'<MailType>'.$mailtype.'</MailType>'.
			'<ValueOfContents>'.number_format($order->subtotalAmount, 2, '.', '').'</ValueOfContents>'.
			'<Country>'.$this->country.'</Country>'.
			'<Container>RECTANGULAR</Container>'.
			'<Size>'.strtoupper($this->size).'</Size>';

			// The package size determines the maximum/min width/height
			$str .= (strtoupper($this->size) == 'REGULAR')
				? "<Width></Width><Length></Length><Height></Height><Girth></Girth>"
				: "<Width>".intval($settings['ShippingUSPSPackageWidth'])."</Width><Length>".intval($settings['ShippingUSPSPackageLength'])."</Length><Height>".intval($settings['ShippingUSPSPackageHeight'])."</Height><Girth>".ceil(2 * (intval($settings['ShippingUSPSPackageWidth']) + intval($settings['ShippingUSPSPackageLength'])))."</Girth>";

			$str .= '</Package></IntlRateV2Request>'; 
			$str = $this->server.'?API=IntlRateV2&XML='.urlencode($str);
			
			$body = "";
			$cu = curl_init($str);
		
			if ($settings["ProxyAvailable"] == "YES")
			{
				curl_setopt($cu, CURLOPT_VERBOSE, 1);
				if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
				{
					curl_setopt($cu, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
				}
				curl_setopt($cu, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
				if ($settings["ProxyRequiresAuthorization"] == "YES")
				{
					curl_setopt($cu, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
				}
				curl_setopt($cu, CURLOPT_TIMEOUT, 120);
			}
		
			curl_setopt($cu, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($cu, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($cu, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
			curl_setopt($cu, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
			$body = curl_exec($cu);
			
			$_SESSION["USPS_InternationalCacheResponse"] = $body;
		}
		else
		{
			$body = $_SESSION["USPS_InternationalCacheResponse"];
		}
		
		
		if (trim($body) != "")
		{
    	    if (!preg_match("/Error/", $body))
    	    {
    	    	
    	    	$xmlParser = new XMLParser();
				$data = $xmlParser->parse($body);
				
				if (isset($data["IntlRateV2Response"][0]["Package"][0]["Service"]))
				{
					$services = $data["IntlRateV2Response"][0]["Package"][0]["Service"];
					for ($i=0; $i<count($services); $i++)
					{
						$service = $services[$i];
						$returned_service_id = $data["IntlRateV2Response"][0]["Package"][0]["Service@"][$i]["ID"];
						if ($returned_service_id == $service_id)
						{
							return $service["Postage"][0];
						}
					}
				}
				return false;
			}
			else
			{
				return false;
			}
        } 
		else
		{ 
            return(false); 
        } 
	}
	
	function track($tracking_number)
	{
		global $settings;
		$xml =
			'<TrackRequest%20USERID="'.$this->user.'"%20PASSWORD="'.$this->pass.'">'.
			'<TrackID%20ID="'.$tracking_number.'"></TrackID>'.
			'</TrackRequest>';
		$request = $this->server."?API=TrackV2&XML=".$xml;
		
		$c = curl_init($request);
		
		if ($settings["ProxyAvailable"] == "YES")
		{
			//curl_setopt($c, CURLOPT_VERBOSE, 1);
			if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
				curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
			}
			curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
			if($settings["ProxyRequiresAuthorization"] == "YES"){
				curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
			}

			curl_setopt($c, CURLOPT_TIMEOUT, 120);
		}
		
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
		curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
		$body = curl_exec($c);
		
		if (curl_errno($c) == 0)
		{
		
			$xml_parser = new XMLParser();
		
			$xml_result = $xml_parser->parse($body);
			
			if (isset($xml_result["TrackResponse"][0]))
			{
				if (isset($xml_result["TrackResponse"][0]["TrackInfo"][0]))
				{
					$result = $xml_result["TrackResponse"][0]["TrackInfo"][0]["TrackSummary"][0];
					if (isset($xml_result["TrackResponse"][0]["TrackInfo"][0]["TrackDetail"]))
					{
						for ($i=0; $i<count($xml_result["TrackResponse"][0]["TrackInfo"][0]["TrackDetail"]); $i++)
						{
							$result.="<br/></br>".$xml_result["TrackResponse"][0]["TrackInfo"][0]["TrackDetail"][$i];
						}
					}
					return $result;
				}
			}
		}
		return false;
	}
} 
