<?php

interface GoogleOrderRepositoryInterface
{
	function createTransaction($google_order_number, $response, $amount=0);

	function getOrderByGoogleOrderNumber($google_order_number);
}

class GoogleOrderRepository implements GoogleOrderRepositoryInterface
{
	protected $db;
	protected $settings;

	public function __construct(&$db, &$settings)
	{
		$this->db = $db;
		$this->settings = $settings;
	}

	public function createTransaction($google_order_number, $response, $amount=0)
	{	
		$this->db->query("SELECT * FROM ".DB_PREFIX."orders WHERE custom1='".$google_order_number."'");
		if ($row = $this->db->moveNext())
		{ 
			$subtotal_amount = $row["subtotal_amount"]; 
			$tax_amount = $row["tax_amount"];
			$shipping_amount = $row["shipping_amount"]; 
			$total_amount =  $amount > 0?$amount:$row["total_amount"];
			$o_id = $row["oid"];
			$u_id = $row["uid"];

			// Create transaction function
			$this->db->reset();
			$this->db->assign("oid", $o_id);
			$this->db->assign("uid", $u_id);		
			$this->db->assign("completed", "NOW()");
			//$this->db->assignStr("extra", $extra);
		
			$this->db->assignStr("payment_type", "ipn"); 
			$this->db->assignStr("payment_gateway", "googlecheckout (Google Checkout)");
			$this->db->assignStr("payment_response", $response);
				
			$this->db->assignStr("order_subtotal_amount", $subtotal_amount);
			$this->db->assignStr("order_total_amount", $total_amount);
		
			$this->db->assignStr("shipping_method", "");
			$this->db->assignStr("shipping_submethod", "");
			$this->db->assignStr("shipping_amount", $shipping_amount);
		
			$this->db->assignStr("tax_amount", $tax_amount);			
			$this->db->insert(DB_PREFIX."payment_transactions");
			//end of createTransaction							
		}
	}

	public function getOrderByGoogleOrderNumber($google_order_number)
	{
		$order_data = $this->db->selectOne("SELECT oid,uid FROM ".DB_PREFIX."orders WHERE custom1 = '".$google_order_number."'");

		if ($order_data)
		{
			$order_id = $order_data['oid'];

			/**
			 * User data
			 */
			$user = USER::getById($this->db, $this->settings, $order_data['uid']);
			$user->getUserData();

			/**
			 * Order data
			 */
			$order = ORDER::getById($this->db, $this->settings, $user, $order_id);
			$order->getOrderData();
			$order->getOrderItems();

			return $order;
		}

		return null;
	}
}