<?php 
	$payment_processor_id = "datacash";
	$payment_processor_name = "Datacash";
	$payment_processor_class = "PAYMENT_DATACASH";
	$payment_processor_type = "cc";
	
	class PAYMENT_DATACASH extends PAYMENT_PROCESSOR
	{
		function PAYMENT_DATACASH()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "datacash";
			$this->name = "Datacash";
			$this->class_name = "PAYMENT_DATACASH";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function getHtmlDocument($xmldoc)
		{
		    $stringDocument = $xmldoc->getDocument();
		    return $stringDocument;
		}

		function process($db, $user, $order, $post_form)
		{
			global $settings;
			
			//global $form;
			if (isset($post_form) && is_array($post_form))
			{
				global $config;
				//build post data for query
				$post_data = "";
				// get post_form, common, settings and custom vars
				reset($this->common_vars);
				
				$path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/lib/DataCash.php";
				
				include_once($path);
				
				if (trim($this->settings_vars[$this->id."_config_file_path"]["value"])=="")
				{
					$_config_path =$settings["GlobalServerPath"]."/content/engine/payment/datacash/php-transaction.conf";
				}
				else 
				{
					$_config_path =$settings["GlobalServerPath"].$this->settings_vars[$this->id."_config_file_path"]["value"];
				}
				
				$_cardinfo_path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/CardInfoBins";				 
				
				$config = new DataCash_Document();				
	     		$config->readDocumentFromFile($_config_path);	     		
	     		$send_doc = new DataCash_Document("Request"); 

				$send_doc->getDocument();
			    $send_doc->set("Request.Authentication.client",  $this->settings_vars[$this->id."_vtid"]["value"]);			    
			    $send_doc->set("Request.Authentication.password", $this->settings_vars[$this->id."_Password"]["value"] );
			    $send_doc->set("Request.Transaction.TxnDetails.amount", number_format($this->common_vars["order_total_amount"]["value"], 2, ".", ""), array('currency' => $this->settings_vars[$this->id."_currency"]["value"]) );
			    $send_doc->set("Request.Transaction.TxnDetails.merchantreference", "orderId".$this->common_vars["order_id"]["value"]);
			    $send_doc->set("Request.Transaction.CardTxn.Card.pan", $post_form["cc_number"] );
			    $selected_year = mktime(0,0,0,1,1,$post_form["cc_expiration_year"]);
			    $send_doc->set("Request.Transaction.CardTxn.Card.expirydate", $post_form["cc_expiration_month"]."/".date("y",  $selected_year) );
			    $send_doc->set("Request.Transaction.CardTxn.method", $this->settings_vars[$this->id."_method"]["value"] );
			  
			    $cardinfo = new DataCash_CardInfo (array("datadir" => $_cardinfo_path, "pan" => $send_doc->get("Request.Transaction.CardTxn.Card.pan")));
								
	    		$validation = $cardinfo->validation( $send_doc );
				
				if ($validation != null)
				{
					$this->error_message = $this->getHtmlDocument( $validation );
				  	$this->is_error = true;
				}
				
				$agent = new DataCash_SSLAgent($config);
				$success = $agent->send($send_doc);
				
				$this->log("process Send Doc:\n".print_r($send_doc, 1));
				$this->log("process Agent:\n".print_r($agent, 1));
				
				if (!$success)
				{
					$this->error_message = $agent->err_str;
					$this->is_error = true;
				}
				else
				{
					$response_doc = $agent->getResponseDocument();
	  			
					if ($response_doc->get("Response.status")==1)
					{
						$response = $this->getHtmlDocument($response_doc);
						$this->createTransaction(
							$db, 
							$user, 
							$order, 
							$response_doc->get("Response.reason")."\n".$response,
							"",
							$this->settings_vars[$this->id."_method"]["value"],
							$response_doc->get("Response.CardTxn.authcode"),
							0,
							$response_doc->get("Response.datacash_reference")
						);
					  
						if ($this->support_ccs && $this->enable_ccs)
						{
							$card_data = array(
								"fn"=>$post_form["cc_first_name"],
								"ln"=>$post_form["cc_last_name"],
								"ct"=>$post_form["cc_type"],
								"cc"=>$post_form["cc_number"],				
								"em"=>$post_form["cc_expiration_month"], 
								"ey"=>$post_form["cc_expiration_year"]
							);
							$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
						}
						
						$this->is_error = false;
						$this->error_message = "";
					  
						if ($this->settings_vars[$this->id."_method"]["value"] == "auth")
						{
							return "Received";
						}
						elseif(in_array($this->settings_vars[$this->id."_method"]["value"], array("pre","erp")))
						{
							return "Pending";
						}
					}
					else
					{
						$this->is_error = true;
						$this->error_message = $response_doc->get("Response.reason")." , ".$response_doc->get("Response.information");
					}
				}

				if ($this->is_error)
				{
					$this->storeTransaction($db, $user, $order, $response_doc, '', false);
				}
			}
			else
			{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
				return false;
			}
			return !$this->is_error;
		}
		
		//XML Request for cancel
		function cancelation($db, $auth_code, $reference_id, $oid, $uid)
		{
			global $settings, $config;
			// get post_form, common, settings and custom vars
			reset($this->common_vars);
			$path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/lib/DataCash.php";
			
			include_once($path);
				
			if (trim($this->settings_vars[$this->id."_config_file_path"]["value"])=="")
			{
				$_config_path =$settings["GlobalServerPath"]."/content/engine/payment/datacash/php-transaction.conf";
			}
			else 
			{
				$_config_path =$settings["GlobalServerPath"].$this->settings_vars[$this->id."_config_file_path"]["value"];
			}
			
			$_cardinfo_path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/CardInfoBins";				 
				
			$config = new DataCash_Document();				
	     	$config->readDocumentFromFile($_config_path);
			     		
	     	$send_doc = new DataCash_Document("Request"); 
			$send_doc->getDocument();
		    $send_doc->set("Request.Authentication.client",  $settings[$this->id."_vtid"]);			    
		    $send_doc->set("Request.Authentication.password", $settings[$this->id."_Password"]);
		    $send_doc->set("Request.Transaction.HistoricTxn.reference", $reference_id);
		    $send_doc->set("Request.Transaction.HistoricTxn.method", "cancel");
		    
		  	$agent = new DataCash_SSLAgent( $config );
			$success = $agent->send($send_doc);
			
			if (!$success)
			{
				$this->error_message=$agent->err_str;
				$this->is_error = true;
			}
			else
			{
				$response_doc = $agent->getResponseDocument();	  			  
	  			  
				if ($response_doc->get("Response.status")==1)
				{
					$response = $this->getHtmlDocument($response_doc);
					$this->createDatacashTransaction($db,  $oid, $uid, $response,0,"cancel");
					$this->is_error = false;
					$this->error_message = "";
					
					return $response_doc->get("Response.status");
				}
				else
				{
					$this->is_error = true;
					$this->error_message = $response_doc->get("Response.reason")." , ".$response_doc->get("Response.information");
			    }
			}
			return !$this->is_error;
		}
		
		//XML Request for fulfill
		function fulfill($db, $auth_code, $reference_id, $amount, $oid, $uid)
		{
			global $settings, $config;

			// get post_form, common, settings and custom vars
			reset($this->common_vars);
			$path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/lib/DataCash.php";
			
			include_once($path);
			
			if (trim($this->settings_vars[$this->id."_config_file_path"]["value"])=="") 
			{
				$_config_path =$settings["GlobalServerPath"]."/content/engine/payment/datacash/php-transaction.conf";
			}
			else 
			{
				$_config_path =$settings["GlobalServerPath"].$this->settings_vars[$this->id."_config_file_path"]["value"];
			}
			
			$_cardinfo_path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/CardInfoBins";				 
				
			$config = new DataCash_Document();				
	     	$config->readDocumentFromFile($_config_path);
			     		
	     	$send_doc = new DataCash_Document("Request"); 
			$send_doc->getDocument();
		    $send_doc->set("Request.Authentication.client",  $settings[$this->id."_vtid"]);			    
		    $send_doc->set("Request.Authentication.password", $settings[$this->id."_Password"]);		    
		    $send_doc->set("Request.Transaction.HistoricTxn.reference", $reference_id);
		    $send_doc->set("Request.Transaction.HistoricTxn.authcode", $auth_code);				    
		    $send_doc->set("Request.Transaction.HistoricTxn.method", "fulfill");
		    
		  	$agent = new DataCash_SSLAgent( $config );
			$success = $agent->send($send_doc);
			
			if (!$success)
			{
				$this->error_message=$agent->err_str;
				$this->is_error = true;
			}
			else
			{
				$response_doc = $agent->getResponseDocument();		
				
	  			if ($response_doc->get("Response.status")==1)
				{
					$response = $this->getHtmlDocument( $response_doc );
					$this->createDatacashTransaction($db,  $oid, $uid, $response, $amount, "fulfill");
					$this->is_error = false;
					$this->error_message = "";
					
					return $response_doc->get("Response.status");
				}
				else
				{
					$this->is_error = true;
					$this->error_message = $response_doc->get("Response.reason")." , ".$response_doc->get("Response.information");
				}
			}
			return !$this->is_error;

		}
		
		//XML Request for a txn_refund
		function refund($db, $auth_code, $reference_id, $amount, $oid, $uid){
			global $settings, $config;

			// get post_form, common, settings and custom vars
			reset($this->common_vars);
			$path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/lib/DataCash.php";
			include_once($path);
			
			if(trim($this->settings_vars[$this->id."_config_file_path"]["value"])=="") 
				$_config_path =$settings["GlobalServerPath"]."/content/engine/payment/datacash/php-transaction.conf";
			else 
				$_config_path =$settings["GlobalServerPath"].$this->settings_vars[$this->id."_config_file_path"]["value"];
			
			$_cardinfo_path=$settings["GlobalServerPath"]."/content/engine/payment/datacash/CardInfoBins";				 
				
			$config = new DataCash_Document();				
	     	$config->readDocumentFromFile($_config_path);
			     		
	     	$send_doc = new DataCash_Document("Request"); 
			$send_doc->getDocument();
		    $send_doc->set("Request.Authentication.client",  $settings[$this->id."_vtid"]);			    
		    $send_doc->set("Request.Authentication.password", $settings[$this->id."_Password"]);
		    $send_doc->set("Request.Transaction.TxnDetails.amount", $amount);
		    $send_doc->set("Request.Transaction.HistoricTxn.reference", $reference_id);		    
		    $send_doc->set("Request.Transaction.HistoricTxn.method", "txn_refund");
		   
		  	$agent = new DataCash_SSLAgent( $config );
			$success = $agent->send($send_doc);			
			if(!$success){
				$this->error_message=$agent->err_str;
				$this->is_error = true;
			}
			else{
				  $response_doc = $agent->getResponseDocument();						  			  
	  			  if($response_doc->get("Response.status")==1){
					   $response = $this->getHtmlDocument($response_doc);
					  $this->createDatacashTransaction($db,  $oid, $uid, $response , $amount, "txn_refund");
					  $this->is_error = false;
					  $this->error_message = "";
					  return $response_doc->get("Response.status");
				  }
				  else{
				  	  $this->is_error = true;
					  $this->error_message = $response_doc->get("Response.reason")." , ".$response_doc->get("Response.information");
			        }
			}
			return !$this->is_error;

		}
		
		function createDatacashTransaction($db, $oid, $uid, $response, $amount, $action)
		{
			$db->reset();
			$db->assign("oid", $oid);
			$db->assign("uid", $uid);
		
			$db->assign("completed", "NOW()");
			$db->assignStr("extra", "");
		
			$db->assignStr("payment_type", "CC");
			$db->assignStr("payment_gateway", "datacash: ".$action);
			$db->assignStr("payment_response", $response);
		
			$db->assignStr("order_total_amount", $amount);
		
			$db->assignStr("shipping_method", "");
			$db->assignStr("shipping_submethod", "");
			$db->assignStr("shipping_amount", "");
		
			$db->assignStr("tax_amount", "");			
			$db->insert(DB_PREFIX."payment_transactions");
		}
	}
