<?php 
	$payment_processor_id = "fasttransact";
	$payment_processor_name = "FastTransact.com";
	$payment_processor_class = "PAYMENT_FASTTRANSACT";
	$payment_processor_type = "cc";
	
	class PAYMENT_FASTTRANSACT extends PAYMENT_PROCESSOR
	{
		function PAYMENT_FASTTRANSACT()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "fasttransact";
			$this->name = "FastTransact.com";
			$this->class_name = "PAYMENT_FASTTRANSACT";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function process($db, $user, $order, $post_form)
		{
			global $_SERVER;
			global $settings;
			
			if (isset($post_form) && is_array($post_form))
			{
				//build post data for query
				$post_data = "";
				// get post_form, common, settings and custom vars
				reset($this->common_vars);
				$post_data = "".
					"pay_type=C".
					"&tran_type=S".
					
					"&account_id=".urlencode($this->settings_vars[$this->id."_Account_ID"]["value"]).
					"&site_tag=".urlencode($this->settings_vars[$this->id."_Site_Tag"]["value"]).
					
					//"&orig_id=".urlencode($this->common_vars["order_id"]["value"]).
					"&amount=".urlencode(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "")).
					"&tax_amount=".urlencode(number_format($this->common_vars["order_tax_amount"]["value"], 5, ".", "")).
					"&ship_amount=".urlencode(number_format($this->common_vars["order_shipping_amount"]["value"], 2, ".", "")).
					"&purch_order=".urlencode($this->common_vars["order_id"]["value"]).
					
					//form data
					"&bill_name1=".urlencode($post_form["cc_first_name"]).
					"&bill_name2=".urlencode($post_form["cc_last_name"]).
					"&bill_street=".urlencode($this->common_vars["billing_address"]["value"]).
					"&bill_city=".urlencode($this->common_vars["billing_city"]["value"]).
					"&bill_state=".urlencode($this->common_vars["billing_state"]["value"]).
					"&bill_zip=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&bill_country=".urlencode($this->common_vars["billing_country_iso_a2"]["value"]).
					
					//shipping data
					"&ship_name1=".urlencode($this->common_vars["shipping_name"]["value"]).
					"&ship_name2=".urlencode($this->common_vars["shipping_name"]["value"]).
					"&ship_street=".urlencode($this->common_vars["shipping_address"]["value"]).
					"&ship_city=".urlencode($this->common_vars["shipping_city"]["value"]).
					"&ship_state=".urlencode($this->common_vars["shipping_state"]["value"]).
					"&ship_zip=".urlencode($this->common_vars["shipping_zip"]["value"]).
					"&ship_country=".urlencode($this->common_vars["shipping_country_iso_a2"]["value"]).
					
					//cc data
					"&card_number=".urlencode($post_form["cc_number"]).
					"&card_expire=".urlencode($post_form["cc_expiration_month"].substr($post_form["cc_expiration_year"], 2, 2)).
					
					//customer additional data
					"&cust_email=".urlencode($this->common_vars["billing_email"]["value"]).
					"&cust_phone=".urlencode($this->common_vars["billing_phone"]["value"]).
					"&cust_ip=".urlencode($_SERVER["REMOTE_ADDR"]).
					"&cust_host=".urlencode(gethostbyaddr($_SERVER["REMOTE_ADDR"])).
					"&cust_browser=".urlencode($_SERVER["HTTP_USER_AGENT"]);
				
				if ($this->settings_vars[$this->id."_Allow_CVV2"]["value"] == "Yes" && $post_form["cc_cvv2"] != "")
				{
					$post_data .= "&card_cvv2=".urlencode($post_form["cc_cvv2"]);
				}
				else
				{
					$post_data .= "&disable_cvv2=1";
				}
				
				if ($this->settings_vars[$this->id."_Allow_AVS"]["value"] == "No")
				{
					$post_data .= "&disable_avs=1";
				}
				
				$_post_url = trim($this->url_to_gateway)==""?"secure.fasttransact.com":trim($this->url_to_gateway);
				
				$fp = @fsockopen($_post_url, 1401, $errno, $errstr, 600);//, 5);
				if ($fp)
				{
					//prepare header
					$header="POST /gw/sas/direct3.0 HTTP/1.0\n";
					$header.="Host: secure.fasttransact.com:1401\n";
					$header.="Content-Type: application/x-www-form-urlencoded\n";
					$header.="Content-Length: ".strlen($post_data)."\n\n";
					$header.=$post_data;
					
					//post data to gateway
					fputs($fp, $header);
					
					$this->log("process Request:\n".$header);
					
					//read response
					$buffer = "";
					while (!feof($fp))
					{
						$buffer.=@fgets($fp, 1024);
					}
					
					fclose($fp);
					
					$this->log("process Response:\n".$buffer);
					
					//get lines
					$lines = explode("\n", $buffer);
					
					//parse first line, like HTTP/1.1 200 OK Approved
					$parts = explode(" ", $lines[0]);
					$status_code = $parts[1];
					$status_message = "";
					
					for ($i=2; $i<count($parts); $i++)
					{
						$status_message.=$parts[$i]." ";
					}
					
					$status_message = trim($status_message);
					
					//get posted-back data
					$parts = explode("\n\n", $buffer);
					
					if (count($parts) > 0)
					{
						if ($parts[0] != "")
						{
							$parts = explode("&", $parts[0]);
							$values = array('auth_msg' => '');
							
							for ($i=0; $i<count($parts); $i++)
							{
								$a = explode("=", $parts[$i]);
								if (array_key_exists(1, $a))
								{
									$values[strtolower($a[0])] = urldecode($a[1]);
								}
							}
							
							if (isset($values['status_code']) && $values["status_code"] == "1")
							{
								$this->createTransaction($db, $user, $order, $lines);
								
								if ($this->support_ccs && $this->enable_ccs)
								{
									$card_data = array(
										"fn"=>$post_form["cc_first_name"],
										"ln"=>$post_form["cc_last_name"],
										"ct"=>$post_form["cc_type"],
										"cc"=>$post_form["cc_number"],				
										"em"=>$post_form["cc_expiration_month"], 
										"ey"=>$post_form["cc_expiration_year"]
									);
									$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
								}
								$this->is_error = false;
								$this->error_message = "";
							}
							else
							{
								$this->is_error = true;
								$this->error_message = "We are so sorry, but there an error occurred during processing this transaction: ".$values["auth_msg"];
							}
						}
						else
						{
							$this->is_error = true;
							$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
						}
					}
					else
					{
						$this->is_error = true;
						$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
					}

					if ($this->is_error)
					{
						$this->storeTransaction($db, $user, $order, $parts, '', false);
					}
				}
				else
				{
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}
			}
			else
			{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
			}
			return !$this->is_error;
		}
	}
