<?php 
	$payment_processor_id = "ntpnowcom";
	$payment_processor_name = "NTPNow.Com";
	$payment_processor_class = "PAYMENT_NTPNOWCOM";
	$payment_processor_type = "cc";
	
	class PAYMENT_NTPNOWCOM extends PAYMENT_PROCESSOR
	{
		function PAYMENT_NTPNOWCOM()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "ntpnowcom";
			$this->name = "NTPNow.Com";
			$this->class_name = "PAYMENT_NTPNOWCOM";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->show_cvv2 = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function process($db, $user, $order, $post_form)
		{
			global $settings;
			//global $form;
			
			if (isset($post_form) && is_array($post_form))
			{
				//build post data for query
				$post_data = "";
				// get post_form, common, settings and custom vars
				reset($this->common_vars);
				
				if ($post_form["cc_cvv2"] == "")
				{
					$cvv2 = "&CVV2=False";
				}
				else
				{
					$cvv2 = "&CVV2=True&CVV2Number=".urlencode($post_form["cc_cvv2"]);
				}
				
				$post_data = "".
					//form data
					"NTPNowID=".urlencode($this->settings_vars[$this->id."_NTPNowID"]["value"]).
					"&Amount=".urlencode(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "")).
					"&NameOnCard=".urlencode($post_form["cc_first_name"]." ".$post_form["cc_last_name"]).
					"&Street=".urlencode($this->common_vars["billing_address"]["value"]).
					"&City=".urlencode($this->common_vars["billing_city"]["value"]).
					"&State=".urlencode($this->common_vars["billing_state"]["value"]).
					"&Zip=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&Email=".urlencode($this->common_vars["billing_email"]["value"]).
					"&CreditCardNumber=".urlencode($post_form["cc_number"]).
					//"&CreditCardNumber=1234567890123456".
					"&Month=".urlencode($post_form["cc_expiration_month"]).
					"&Year=".urlencode(substr($post_form["cc_expiration_year"], 2, 2)).
					$cvv2.
					"&AVS=".urlencode($this->settings_vars[$this->id."_NTPNowAVS"]["value"]);//"&AVSValidIf=DXY";
				
				$_post_url = trim($this->url_to_gateway)==""?"https://ntpnow.com/payV2_1.asp":trim($this->url_to_gateway);
				
				$c = curl_init($_post_url."?".$post_data);
				
				if ($settings["ProxyAvailable"] == "YES")
				{
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
					{
						curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					
					curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					
					if ($settings["ProxyRequiresAuthorization"] == "YES")
					{
						curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($c, CURLOPT_TIMEOUT, 120);
				}
				
				curl_setopt($c, CURLOPT_VERBOSE, 0);
				curl_setopt($c, CURLOPT_HEADER, 0);
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
				
				if (!safe_mode()) set_time_limit(300);
				
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($c);
				
				$this->log("process request:\n".$post_data);
				$this->log("process response:\n".$buffer);
				
				if (strlen($buffer) > 0)
				{
					$a = explode("|", $buffer);
					$b = array();
					
					for ($i=0; $i<count($a); $i++)
					{
						$c = explode(":", $a[$i]);
						$b[trim(strtoupper($c[0]))] = trim(strtoupper($c[1]));
					}
					
					if (array_key_exists("STATUS", $b) && array_key_exists("AUTHORIZATION RESPONSE", $b))
					{
						if ($b["STATUS"] == "TRANSACTION SUCCESSFUL" && ($b["AUTHORIZATION RESPONSE"] == "APPROVAL" || $b["AUTHORIZATION RESPONSE"] == "APPROVED"))
						{
							$this->createTransaction($db, $user, $order, $b);
							
							if ($this->support_ccs && $this->enable_ccs)
							{
								$card_data = array(
									"fn"=>$post_form["cc_first_name"],
									"ln"=>$post_form["cc_last_name"],
									"ct"=>$post_form["cc_type"],
									"cc"=>$post_form["cc_number"],				
									"em"=>$post_form["cc_expiration_month"], 
									"ey"=>$post_form["cc_expiration_year"]
								);
								$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
							}
							$this->is_error = false;
							$this->error_message = "";
						}
						else
						{
							$this->is_error = true;
							$this->error_message = $b["AUTHORIZATION RESPONSE"];
						}
					}
					else
					{
						$this->is_error = true;
						$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT;
					}
				}
				else
				{
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}

				if ($this->is_error)
				{
					$this->storeTransaction($db, $user, $order, $explode('|', $buffer), '', false);
				}
			}
			else
			{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
				//return false;
			}
			return !$this->is_error;
		}
	}
