<?php 
	$payment_processor_id = "orbital";
	$payment_processor_name = "Orbital Gateway";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_ORBITAL";
	$payment_processor_type = "cc";
	
	class PAYMENT_ORBITAL extends PAYMENT_PROCESSOR{
		
		function PAYMENT_ORBITAL(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "orbital";
			$this->name = "Orbital Gateway";
			$this->version = "";
			$this->class_name = "PAYMENT_ORBITAL";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->need_cc_codes = true;
			$this->support_ccs = false;
			return $this;
		}
		
		function getPaymentForm($db){
			$fields = parent::getPaymentForm($db);
			
			return $fields;
		}
		
		function isTestMode(){
			if($this->settings_vars[$this->id."_test_mode"]["value"] == "On"){
				$this->testMode = true;
			} else{
				$this->testMode = false;
			}
			return $this->testMode;
		}
		
		function process($db, $user, $order, $post_form){
			global $settings;
			
			if(isset($post_form) && is_array($post_form)){
				//build post data for query
				$post_data = "";
				
				// view $post_data from paypal flow pro for reference
				// get post_form, common, settings and custom vars
				
				
				// variables to use
				// bin - Transaction Routing Definition:
				// Assigned by Chase Paymentech
				// 000001 – Salem
				// 000002 – PNS
				// 
				// merchantID 
				
				// get the transaction type
				list($transType) = split(' - ', $this->settings_vars[$this->id."_transaction_type"]["value"]);
				
				$post_data = '
					<?xml version="1.0" encoding="UTF-8"?>
					<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
						<soapenv:Body>
							<NewOrder xmlns="urn:ws.paymentech.net/PaymentechGateway">
								<newOrderRequest xmlns:ns1="urn:ws.paymentech.net/PaymentechGateway" xmlns="" xsi:type="ns1:NewOrderRequestElement">
									<ns1:industryType>EC</ns1:industryType>
									<ns1:transType>'.$transType.'</ns1:transType>
									
									<ns1:bin>'.$this->settings_vars[$this->id."_transaction_routing_definition"]["value"].'</ns1:bin>
									<ns1:merchantID>'.$this->settings_vars[$this->id."_merchant_id"]["value"].'</ns1:merchantID>
									<ns1:terminalID>'.$this->settings_vars[$this->id."_terminal_id"]["value"].'</ns1:terminalID>
									<ns1:ccCardVerifyPresenceInd>2</ns1:ccCardVerifyPresenceInd>
									<ns1:comments>'.$transactionComments.'</ns1:comments>
									
									
									<ns1:ccAccountNum>'.utf8_encode($post_form["cc_number"]).'</ns1:ccAccountNum>
									<ns1:ccExp>'.utf8_encode($post_form['cc_expiration_month'].$post_form['cc_expiration_year']).'</ns1:ccExp>
									<ns1:avsZip>'.utf8_encode($this->common_vars["billing_zip"]["value"]).'</ns1:avsZip>
									<ns1:avsAddress1>'.utf8_encode($this->common_vars["billing_address1"]["value"]).'</ns1:avsAddress1>
									<ns1:avsAddress2>'.utf8_encode($this->common_vars["billing_address2"]["value"]).'</ns1:avsAddress2>
									<ns1:avsCity>'.utf8_encode($this->common_vars["billing_city"]["value"]).'</ns1:avsCity>
									<ns1:avsState>'.utf8_encode($this->common_vars["billing_state".($this->common_vars["billing_country_iso_a2"]["value"]=="US"?"_abbr":'')]['value']).'</ns1:avsState>
									<ns1:avsName>'.utf8_encode($post_form["cc_first_name"].' '.$post_form["cc_last_name"]).'</ns1:avsName>
									<ns1:avsCountryCode>'.utf8_encode($this->common_vars["billing_country_iso_a2"]["value"]).'</ns1:avsCountryCode>
									<ns1:orderID>'.utf8_encode($this->common_vars["order_id"]["value"]).'</ns1:orderID>
									<ns1:amount>'.utf8_encode(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "")).'</ns1:amount>
									
								</newOrderRequest>
							</NewOrder>
						</soapenv:Body>
					</soapenv:Envelope>
				';
				
				$_post_url = (trim($this->url_to_gateway) =='')
					? 'https://api.paypal.com/2.0/'
					: trim($this->url_to_gateway);
				
				$_cert_path = $settings["GlobalServerPath"]."/content/engine/payment/".$this->certificate_path;
				
				$ch = curl_init();
				
				curl_setopt($ch, CURLOPT_TIMEOUT, 120);
				curl_setopt($ch, CURLOPT_URL, $_post_url);

				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

				if( !ini_get('safe_mode') ) 
					set_time_limit(3000);
					
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($ch, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($ch, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($ch);
				
				// re received data, parse it
				if ($buffer){
					$this->logStart();
					$this->log($buffer);
					$this->logFinish();

					$xmlParser = new XMLParser();
					
					$data = $xmlParser->parse($buffer);
					
					if(isset($data["SOAP-ENV:Envelope"][0]["SOAP-ENV:Body"][0]["DoDirectPaymentResponse"][0])){
						
						$a = $data["SOAP-ENV:Envelope"][0]["SOAP-ENV:Body"][0]["DoDirectPaymentResponse"][0];
						if($a["Ack"][0] == "Success" || $a["Ack"][0] == "SuccessWithWarings"){
							$response = "";
							$payment_status = "";
							$charged_amount = 0;
							foreach($a as $var=>$value){
								$response.= $var."  =  ".$value[0]."\n";
								if($var == "TransactionID")
									$transaction_id = $value[0];
							}
							if($this->settings_vars[$this->id."_Payment_Action"]["value"] == "Sale" ){
								$charged_amount = $this->common_vars["order_total_amount"]["value"];
							}
							$custom1 = strtolower($this->settings_vars[$this->id."_Payment_Action"]["value"]);
							$this->createTransaction($db, $user, $order, $response, "", $custom1, "", $charged_amount, $transaction_id);
							if($this->support_ccs && $this->enable_ccs){
								$card_data = array(
									"fn"=>$post_form["cc_first_name"],
									"ln"=>$post_form["cc_last_name"],
									"ct"=>$post_form["cc_type"],
									"cc"=>$post_form["cc_number"],
									"em"=>$post_form["cc_expiration_month"], 
									"ey"=>$post_form["cc_expiration_year"]
								);
								$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
							}
							$this->is_error = false;
							if($this->settings_vars[$this->id."_Payment_Action"]["value"] == "Authorization" ){
								$payment_status = "Pending";
								return $payment_status;
							}
						}
						elseif(trim($a["Ack"][0]) == "Failure"){
							$this->is_error = true;
							$this->error_message = $a["Errors"][0]["ShortMessage"][0]." ".$a["Errors"][0]["LongMessage"][0];
						}
						else{
							$this->is_error = true;
							$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT;
						}
					}
					elseif(isset($data["SOAP-ENV:Envelope"][0]["SOAP-ENV:Body"][0]["SOAP-ENV:Fault"][0]["faultcode"][0])){
						$this->error_message = $data["SOAP-ENV:Envelope"][0]["SOAP-ENV:Body"][0]["SOAP-ENV:Fault"][0]["faultstring"][0];
						$this->is_error = true;
					}
				} else {
					// no $buffer set, return error
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}
			}
			else{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
			}
			return !$this->is_error;
		}
	}
?>
