<?php 
	$payment_processor_id = "paypalec";
	$payment_processor_name = "PayPal Exress Checkout";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_PAYPALEC";
	$payment_processor_type = "cc";

	class PAYMENT_PAYPALEC extends PAYMENT_PROCESSOR
	{
		/**
		 * @return PAYMENT_PAYPALEC
		 */
		public function PAYMENT_PAYPALEC()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "paypalec";
			$this->name = "PayPal Express Checkout";
			$this->version = "60.0";
			$this->class_name = "PAYMENT_PAYPALEC";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->is_certificate = true;
			$this->certificate_path = "paypal/certificate.pem";
			$this->support_accepted_cc = false;
			$this->show_cvv2 = false;
			return $this;
		}

		public function getPaymentForm($db)
		{
			parent::getPaymentForm($db);
			//$cc_options = $this->cc_options;
			$cc_options_codes = $this->cc_options_codes;
			$fields = array();
			$fields[] = array("type"=>"hidden", "name"=>"oa", "value"=>ORDER_PROCESS_PAYMENT);
			return $fields;
		}

		public function getValidatorJS()
		{
			return "";
		}

		public function isTestMode()
		{
			if ($this->settings_vars[$this->id."_Mode"]["value"] == "TEST")
			{
				$this->testMode = true;
				$this->post_url = "https://api.sandbox.paypal.com/2.0/";
			}
			else
			{
				$this->testMode = false;
				//$this->post_url = "https://www.paypal.com/cgi-bin/webscr";
			}
			return $this->testMode;
		}

		public function process($db, $user, $order, $post_form)
		{
			global $settings;
			if (isset($_SESSION["paypal_express_checkout_details"]))
			{
				require_once("content/engine/engine_paypal_ec.php");
				$paypal_ec = new paypalExpressCheckout();
				$paypal_ec->ApiURL = $this->url_to_gateway;

				//check for accelerated boaring mode
				if (trim($settings["paypalec_Email"]) != "")
				{
					$paypal_ec->Email = $this->settings_vars[$this->id."_Email"]["value"];
					$paypal_ec->PaymentAction = "Sale";
				}
				else
				{
					$paypal_ec->Username = $this->settings_vars[$this->id."_Username"]["value"];
					$paypal_ec->Password = $this->settings_vars[$this->id."_Password"]["value"];
					$paypal_ec->PaymentAction = $this->settings_vars[$this->id."_Payment_Action"]["value"];
				}	

				$paypal_ec->OrderTotal = $order->totalAmount;
				$paypal_ec->mode = strtolower($this->settings_vars[$this->id."_Mode"]["value"]);
				$paypal_ec->currencyCode = $this->settings_vars[$this->id."_currency"]["value"];

				$result = $paypal_ec->DoExpressCheckoutPayment();
				$this->enableLog = true;
				$this->log("REQUEST:\n".$paypal_ec->request);
				$this->log("RESPONSE:\n".$paypal_ec->response);
				$this->enableLog = false;
				$charged_amt = 0;

				if ($result)
				{
					$response = "";
					$transaction_id ="";
					$payment_status = "Received";
					foreach ($result as $key=>$value)
					{
						$response.=$key." = ".$value[0]."\n";
						if($key == "TransactionID") $transaction_id = $value[0];
						if($key == "PaymentStatus") $result_payment_status = $value[0];	
						if($key == "PendingReason")	$PendingReason = $value[0];					
					}

					if ($result_payment_status == "Pending" || $result_payment_status == "None")
					{
						$payment_status = "Pending";						
					}
					if ($payment_status == "Received")
					{
						$charged_amt = $order->totalAmount;
					}
					$this->createTransaction($db, $user, $order, $response, "", $PendingReason, "", $charged_amt, $transaction_id);
					$this->is_error = false;

					return $payment_status;
				}
				else
				{
					if ($paypal_ec->is_error)
					{
						$this->is_error = true;
						$this->error_message = "";
						foreach ($paypal_ec->error_messages as $key=>$err)
						{
							$this->error_message.=$err;
						}
					}
					else
					{
						$this->is_error = true;
						$this->error_message = "Unknown error occurred while processing your transaction";
					}
				}
			}
			else
			{
				$this->error_message = "PayPal Express Checkout session expired or does not exist";
				$this->is_error = true;
			}
			return false;
		}
	}
