<?php 

	$payment_processor_id = "pinnaclecart";
	$payment_processor_name = "Billing.PinnacleCart.com";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_PINNACLECART";
	$payment_processor_type = "ipn";
	
	class PAYMENT_PINNACLECART extends PAYMENT_PROCESSOR{
		function PAYMENT_PINNACLECART(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "pinnaclecart";
			$this->name = "Billing.PinnacleCart.com";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_PINNACLECART";
			$this->type = "ipn";
			$this->description = "";
			$this->testMode = false;
			$this->post_url = "https://billing.pinnaclecart.com";
			$this->steps = 2;
			
			return $this;
		}
		
		function getPostUrl(){
			if(trim($this->url_to_gateway) != ""){
				return trim($this->url_to_gateway);
			}
			else{
				return $this->post_url;
			}
		}
		
		//redeclare getPaymentForm
		function getPaymentForm($db){
			global $settings, $order;
			global $msg;
			
			$fields = array();
			
			//print_r($order);
			$items = "";
			foreach($order->items as $id=>$item){
				$fields[] = array("type"=>"hidden", "name"=>"itemproductid_".$id, "value"=>str_replace('"', '__Q__', $item["product_id"]));
				$fields[] = array("type"=>"hidden", "name"=>"itemproductprice_".$id, "value"=>number_format($item["product_price"], 2, ".", ""));
				$fields[] = array("type"=>"hidden", "name"=>"itemquantity_".$id, "value"=>number_format($item["quantity"], 0, "", ""));
				$fields[] = array("type"=>"hidden", "name"=>"itemname_".$id, "value"=>str_replace('"', '__Q__', $item["title"]));
				$fields[] = array("type"=>"hidden", "name"=>"itemoptions_".$id, "value"=>str_replace('"', '__Q__', str_replace("\n", "__NL__", $item["options"])));
			}
			
			$notify_url = ($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page."&oa=".ORDER_PROCESS_PAYMENT;
			$cancel_url = ($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page;
			
			$fields[] = array("type"=>"hidden", "name"=>"x_store_name", "value"=>$this->settings_vars[$this->id."_store_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_notify_email", "value"=>$this->settings_vars[$this->id."_notify_email"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_color_bg", "value"=>$this->settings_vars[$this->id."_color_bg"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_color_text", "value"=>$this->settings_vars[$this->id."_color_text"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_company_name", "value"=>$settings["CompanyName"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"x_store_name", "value"=>$this->settings_vars[$this->id."_store_name"]["value"]);
			
				
			$fields[] = array("type"=>"hidden", "name"=>"x_subtotal_amount", "value"=>number_format($this->common_vars["order_subtotal_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_discount_amount", "value"=>number_format($this->common_vars["order_discount_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_shipping_amount", "value"=>number_format($this->common_vars["order_shipping_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_handling_amount", "value"=>number_format($this->common_vars["order_handling_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_tax_amount", "value"=>number_format($this->common_vars["order_tax_amount"]["value"], 5, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_amount", "value"=>number_format($this->common_vars["order_total_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"x_invoice_num", "value"=>$this->common_vars["order_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_first_name", "value"=>$this->common_vars["billing_first_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_last_name", "value"=>$this->common_vars["billing_last_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_address_1", "value"=>$this->common_vars["billing_address1"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_address_2", "value"=>$this->common_vars["billing_address2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_city", "value"=>$this->common_vars["billing_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_state", "value"=>$this->common_vars["billing_state"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_zip", "value"=>$this->common_vars["billing_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_country", "value"=>$this->common_vars["billing_country"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_email", "value"=>$this->common_vars["billing_email"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_phone", "value"=>$this->common_vars["billing_phone"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_name", "value"=>$this->common_vars["shipping_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_address1", "value"=>$this->common_vars["shipping_address1"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_address2", "value"=>$this->common_vars["shipping_address2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_city", "value"=>$this->common_vars["shipping_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_state", "value"=>$this->common_vars["shipping_state"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_zip", "value"=>$this->common_vars["shipping_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_ship_to_country", "value"=>$this->common_vars["shipping_country"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"x_notify_url", "value"=>$notify_url);
			$fields[] = array("type"=>"hidden", "name"=>"x_cancel_url", "value"=>$cancel_url);$items;
			
			return $fields;
		}
		
		function getValidatorJS(){
			return "";
		}
		
		function isTestMode(){
			$this->testMode = false;
			return $this->testMode;
		}
		
		function process($db, $user, $order, $post_form){
			$response = "This gateway does not return any values";
			$this->createTransaction($db, $user, $order, $response, "");
			$this->is_error = false;
			$this->error_message = "";
			return !$this->is_error;
		}
	}
?>
