<?php 

	$payment_processor_id = "shift4";
	$payment_processor_name = "Shift4.com";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_SHIFT4";
	$payment_processor_type = "cc";
	
	class PAYMENT_SHIFT4 extends PAYMENT_PROCESSOR{
		function PAYMENT_SHIFT4(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "shift4";
			$this->name = "Shift4.com";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_SHIFT4";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function getPaymentForm($db){
			$fields = parent::getPaymentForm($db);
			return $fields;
		}
		
		function isTestMode(){
			$this->testMode = false;
			return $this->testMode;
		}
		
		function process($db, $user, $order, $post_form){
			global $settings;
			if(isset($post_form) && is_array($post_form)){
				$post_data = "";
				//reset($this->common_vars);
				//echo "<br>===".urlencode($this->common_vars["shipping_address"]["value"])."<br>";
				$post_data = "".
					//form data
					"stx=yes".
					"&serialnumber=".urlencode($this->settings_vars[$this->id."_SN"]["value"]).
					"&username=".urlencode($this->settings_vars[$this->id."_Login"]["value"]).
					"&password=".urlencode($this->settings_vars[$this->id."_Password"]["value"]).
					"&merchantid=".urlencode($this->settings_vars[$this->id."_Merchant"]["value"]).
					
					"&functionrequestcode=1D". 
					"&invoice=".urlencode($this->common_vars["order_id"]["value"]).
					//billing data
					"&FirstName=".urlencode($post_form["cc_first_name"]).
					"&LastName=".urlencode($post_form["cc_last_name"]).
					"&AddressLine1=".urlencode($this->common_vars["billing_address1"]["value"]).
					"&AddressLine2=".urlencode($this->common_vars["billing_address2"]["value"]).
					"&City=".urlencode($this->common_vars["billing_city"]["value"]).
					"&State=".urlencode($this->common_vars["billing_state"]["value"]).
					"&PostalCode=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&Country=".urlencode($this->common_vars["billing_country_iso_number"]["value"]).
					"&PhoneNumber=".urlencode($this->common_vars["billing_phone"]["value"]).
					
					"&CustomerIPAddress=".urlencode($_SERVER["REMOTE_ADDR"]).
					"&CustomerEmailAddress=".urlencode($this->common_vars["billing_email"]["value"]).
					"&CustomerName=".urlencode($post_form["cc_first_name"]." ".$post_form["cc_last_name"]).
					
					"&ZipCode=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&StreetAddress=".urlencode($this->common_vars["billing_address"]["value"]).
					
					// card info
					"&cardnumber=".urlencode($post_form["cc_number"]).
					"&expirationdate=".urlencode($post_form["cc_expiration_month"].substr($post_form["cc_expiration_year"], 2, 2)).
					"&vendor=".urlencode($this->settings_vars[$this->id."_Vendor"]["value"]).
					"&primaryamount=".urlencode(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "")).
					"&CVV2Indicator=".(trim($post_form["cc_cvv2"])==""?"0":"1").
					"&CVV2code=".urlencode($post_form["cc_cvv2"]).
					"&Notes=".
					"&Verbose=No".
					"&etx=yes";
				
				//echo "Data send to gateway:<br>";
				//echo str_replace("&", "<br>", $post_data);
				//echo "<hr>";
				
				$_post_url = trim($this->url_to_gateway)==""?"https://certify.shift4.com/api/S4Tran_Action.cfm":trim($this->url_to_gateway);
				
				$c = curl_init($_post_url);
				
				if($settings["ProxyAvailable"] == "YES"){
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
						curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					if($settings["ProxyRequiresAuthorization"] == "YES"){
						curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($c, CURLOPT_TIMEOUT, 120);
				}
				

				curl_setopt($c, CURLOPT_VERBOSE, 0);
				curl_setopt($c, CURLOPT_HEADER, 0);
				curl_setopt($c, CURLOPT_POSTFIELDS, $post_data);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
				if( !ini_get('safe_mode') )
					set_time_limit(3000);
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($c);
				
				//echo "Response:<br>";
				//echo $buffer;
				//echo "<hr>";
				//die();
				//$buffer = "OK 5566,0000000001,\"VS\",\"A\",20.00,\"TEST10\",\"Y\",\"\""; // OK - response example
				//$buffer = "ERROR Cannot process transaction in the clear -- must use HTTPS"; // ERROR - response example
				//echo "<br>buffer=".$buffer."<br>";
				if($buffer){
					$parts = explode("\n", $buffer);
					if(trim($parts[0]) == "OK"){
						$parts2 = explode(",", $parts[1]);
						//echo $parts2[3];
						//die("hehe");
						if($parts2[3] == '"A"' || $parts2[3] == '"C"'){
							$this->createTransaction($db, $user, $order, str_replace(",", "\n", $buffer), "");
							if($this->support_ccs && $this->enable_ccs){
								$card_data = array(
									"fn"=>$post_form["cc_first_name"],
									"ln"=>$post_form["cc_last_name"],
									"ct"=>$post_form["cc_type"],
									"cc"=>$post_form["cc_number"],				
									"em"=>$post_form["cc_expiration_month"], 
									"ey"=>$post_form["cc_expiration_year"]
								);
								$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
							}
							$this->is_error = false;
							$this->error_message = "";
						}
						else{
							$this->is_error = true;
							$this->error_message = "Sorry, but your information was decined. Please check the information you entered and try again, or contact us directly to complete your order";
						}
					}
					else{
						$this->is_error = true;
						$this->error_message = "We are sorry, but there has been an error processing this transaction.<br>Payment gateway response: ".$parts[1];
					}
				}
				else{
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}
			}
			else{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
				//return false;
			}
			return !$this->is_error;
		}
	}
?>
