<?php 
	$payment_processor_id = "verisignpflink";
	$payment_processor_name = "verisign.com";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_VERISIGNPFLINK";
	$payment_processor_type = "ipn";

	class PAYMENT_VERISIGNPFLINK extends PAYMENT_PROCESSOR
	{
		public function PAYMENT_VERISIGNPFLINK()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "verisignpflink";
			$this->name = "verisign.com";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_VERISIGNPFLINK";
			$this->type = "ipn";
			$this->description = "";
			$this->post_url = "https://payflowlink.paypal.com";
			$this->steps = 2;
			return $this;
		}

		//redeclare getPaymentForm
		public function getPaymentForm($db)
		{
			global $settings, $order;

			$notify_url = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?pcsid=".session_id()."&_pcod=".$this->common_vars["order_security_id"]["value"]."&p=".$this->payment_page."&oa=".ORDER_PROCESS_PAYMENT;
			
			$fields = array();
			
			$fields[] = array("type"=>"hidden", "name"=>"LOGIN", "value"=>$this->settings_vars[$this->id."_Login"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"PARTNER", "value"=>$this->settings_vars[$this->id."_Partner"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"AMOUNT", "value"=>number_format($this->common_vars["order_total_amount"]["value"], 2, ".", ""));
			$fields[] = array("type"=>"hidden", "name"=>"TYPE", "value"=>($this->settings_vars[$this->id."_Transaction_Type"]["value"] == "Sale" ? "S" : "A"));
			
			$fields[] = array("type"=>"hidden", "name"=>"NAME", "value"=>$this->common_vars["billing_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"ADDRESS", "value"=>$this->common_vars["billing_address"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"CITY", "value"=>$this->common_vars["billing_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"STATE", "value"=>$this->common_vars["billing_state"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"ZIP", "value"=>$this->common_vars["billing_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"COUNTRY", "value"=>$this->common_vars["billing_country"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"PHONE", "value"=>$this->common_vars["billing_phone"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"EMAIL", "value"=>$this->common_vars["billing_email"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"NAMETOSHIP", "value"=>$this->common_vars["shipping_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"ADDRESSTOSHIP", "value"=>trim($this->common_vars["shipping_address"]["value"]));
			$fields[] = array("type"=>"hidden", "name"=>"CITYTOSHIP", "value"=>$this->common_vars["shipping_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"STATETOSHIP", "value"=>$this->common_vars["shipping_state"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"ZIPTOSHIP", "value"=>$this->common_vars["shipping_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"COUNTRYTOSHIP", "value"=>$this->common_vars["shipping_country"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"ECHODATA", "value"=>"TRUE");
			$fields[] = array("type"=>"hidden", "name"=>"USER1", "value"=>$notify_url);
		
			return $fields;
		}

		public function getValidatorJS()
		{
			return "";
		}

		public function isTestMode()
		{
			$this->testMode = false;
			return $this->testMode;
		}

		public function getPostUrl()
		{
			if (trim($this->url_to_gateway) != "")
			{
				return trim($this->url_to_gateway);
			}
			else
			{
				return $this->post_url;
			}
		}

		public function process($db, $user, $order, $post_form)
		{
			$_result = isset($post_form["RESULT"])?intval($post_form["RESULT"]):-1000;
			$_respmsg = isset($post_form["RESPMSG"])?"Gateway Response: ".$post_form["RESPMSG"]:PAYMENT_SERVER_ERROR_TEXT;
			
			if ($_result == 0 && $_respmsg == "Gateway Response: Approved")
			{
				$response = "";
				foreach ($post_form as $var_name=>$var_value)
				{
					$response.=$var_name." = ".$var_value."\n";
				}
				$this->createTransaction($db, $user, $order, $response, "");
				$this->is_error = false;
				$this->error_message = "";
			}
			else
			{
				$this->is_error = true;
				$this->error_message = $_respmsg;
			}
			return !$this->is_error;
		}
	}
