<?php 
	$payment_processor_id = "verisignpfpro";
	$payment_processor_name = "VeriSign.Net PayFlow Pro";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_VERISIGNPFPRO";
	$payment_processor_type = "cc";
	
	class PAYMENT_VERISIGNPFPRO extends PAYMENT_PROCESSOR
	{
		function PAYMENT_VERISIGNPFPRO()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "verisignpfpro";
			$this->name = "VeriSign.Net PayFlow Pro";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_VERISIGNPFPRO";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function getPaymentForm($db)
		{
			$fields = parent::getPaymentForm($db);
			return $fields;
		}
		
		function isTestMode()
		{
			if ($this->settings_vars[$this->id."_ProcessingMode"]["value"] == "Test")
			{
				$this->testMode = true;
			}
			else
			{
				$this->testMode = false;
			}
			return $this->testMode;
		}

		// Curl custom headers; adjust appropriately for your setup:
		function get_curl_headers() 
		{
		  global $settings;
		  $system = trim($settings[$this->id."_ServerOs"]);
		  $headers = array();
		  
		  $headers[] = "Content-Type: text/namevalue"; //or maybe text/xml
		  $headers[] = "X-VPS-Timeout: 30";
		  //$headers[] = "X-VPS-VIT-OS-Name:".$system;  // Name of your OS
		  //$headers[] = "X-VPS-VIT-OS-Version: RHEL 4";  // OS Version
		  //$headers[] = "X-VPS-VIT-Client-Type: PHP/cURL";  // What you are using
		  //$headers[] = "X-VPS-VIT-Client-Version: 0.01";  // For your info
		  //$headers[] = "X-VPS-VIT-Client-Architecture: x86";  // For your info
		  //$headers[] = "X-VPS-VIT-Integration-Product: MyApplication";  // For your info, would populate with application name
		  //$headers[] = "X-VPS-VIT-Integration-Version: 0.01"; // Application version    
		  
		  return $headers;  
		}
	
		// parse result and return an array
		function get_curl_result($result) 
		{
			if (empty($result)) return;
			$pfpro = array();
			$result = strstr($result, 'RESULT');    
			$valArray = explode('&', $result);
			foreach ($valArray as $val) 
			{
				$valArray2 = explode('=', $val);
				$pfpro[$valArray2[0]] = $valArray2[1];
			}
			return $pfpro;    
		}
			
		function process($db, $user, $order, $post_form)
		{ 
			global $settings, $order;
			$path = $settings["GlobalServerPath"]."/content/engine/payment/verisign/";
				
			$system = trim($settings[$this->id."_ServerOs"]);
			$engine_path = $settings["GlobalServerPath"];
			if (isset($post_form) && is_array($post_form))
			{
				// build hash
				$tempstr = $post_form["cc_number"] . number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "") . date('YmdGis') . "1";
				$request_id = md5($tempstr);
				$tr_type = $this->settings_vars[$this->id."_Transaction_Type"]["value"] == "Sale" ? "S" : "A";	
				
				$plist = 'USER='.$this->settings_vars[$this->id."_UserName"]["value"].'&';
				$plist.= 'VENDOR='.$this->settings_vars[$this->id."_Vendor"]["value"].'&';
				$plist.= 'PARTNER='.$this->settings_vars[$this->id."_Partner"]["value"].'&';
				$plist.= 'PWD='.$this->settings_vars[$this->id."_Password"]["value"].'&';
				$plist.= 'TRXTYPE='.$tr_type.'&';
				$plist.= 'TENDER=C&';
				$plist.= 'AMT='.number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "").'&';
				$plist.= 'ACCT='.$post_form["cc_number"].'&';
				$plist.= 'EXPDATE='.$post_form["cc_expiration_month"].substr($post_form["cc_expiration_year"], 2, 2).'&';
				$plist.= 'NAME='.$post_form["cc_first_name"]." ".$post_form["cc_last_name"].'&';
				$plist.= 'CVV2='.$post_form["cc_cvv2"].'&';
				$plist.= 'INVNUM='.$this->common_vars["order_id"]["value"].'&';
				$plist.= 'ZIP='.$this->common_vars["billing_zip"]["value"].'&';
				$plist.= 'STREET='.$this->common_vars["billing_address"]["value"];
				
				$_post_url = trim($this->url_to_gateway)==""?"https://payflowpro.paypal.com":trim($this->url_to_gateway);
					
				$headers = $this->get_curl_headers();
				$headers[] = "X-VPS-Request-ID: " . $request_id;
				
				$ch = curl_init(); 
					
				if ($settings["ProxyAvailable"] == "YES")
				{
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
					{
						curl_setopt($ch, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					curl_setopt($ch, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					if ($settings["ProxyRequiresAuthorization"] == "YES")
					{
						curl_setopt($ch, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($ch, CURLOPT_TIMEOUT, 120);
				}
					
				curl_setopt($ch, CURLOPT_URL, $_post_url);
				curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
				curl_setopt($ch, CURLOPT_HEADER, 1); // tells curl to include headers in response
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
				
				$this->log($plist);
				
				curl_setopt($ch, CURLOPT_POSTFIELDS, $plist); //adding POST data
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2); //verifies ssl certificate
				curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE); //forces closure of connection when done 
				curl_setopt($ch, CURLOPT_POST, 1); //data sent as POST 
		
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($ch, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($ch, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);

				$result = curl_exec($ch);
				$tp = curl_error($ch);
				$headers = curl_getinfo($ch);
				curl_close($ch);
	
				$response = $this->get_curl_result($result); //result arrray
				
				$this->log($response);
				
				if ($response)
				{
					// Approved
					$buffer = "";
					if ($response["RESULT"] == "0" || $response["RESULT"] == "126")
					{
						foreach ($response as $var=>$val)
						{
							$buffer = $buffer.$var." = ".$val."\n";
						}
						$this->createTransaction($db, $user, $order, str_replace("~", "\n", $buffer), "");
						if ($this->support_ccs && $this->enable_ccs)
						{
							$card_data = array(
								"fn"=>$post_form["cc_first_name"],
								"ln"=>$post_form["cc_last_name"],
								"ct"=>$post_form["cc_type"],
								"cc"=>$post_form["cc_number"],													
								"em"=>$post_form["cc_expiration_month"], 
								"ey"=>$post_form["cc_expiration_year"]
							);
							$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
						}
						$this->is_error = false;
						$this->error_message = "";
					}
					else
					{
						$this->logStart();
						$this->log($buffer);
						$this->logFinish();
						$this->is_error = true;
						$this->error_message = "Error code: ".$response["RESULT"]." ".$response["RESPMSG"];						
					}
				}
				else
				{
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}
			}
			else
			{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
				//return false;
			}			
			return !$this->is_error;			
		}
	}
