<?php 
	$payment_processor_id = "viaklix";
	$payment_processor_name = "ViaKLIX.com";
	$payment_processor_version = "3.3";
	$payment_processor_class = "PAYMENT_VIAKLIX";
	$payment_processor_type = "cc";
	
	class PAYMENT_VIAKLIX extends PAYMENT_PROCESSOR{
		function PAYMENT_VIAKLIX(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "viaklix";
			$this->name = "ViaKLIX.com";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_VIAKLIX";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}
		
		function getPaymentForm($db){
			$fields = parent::getPaymentForm($db);
			return $fields;
		}
		
		function isTestMode(){
			if($this->settings_vars[$this->id."_test_mode"]["value"] == "true"){
				$this->testMode = true;
			}
			else{
				$this->testMode = false;
			}
			return $this->testMode;
		}
		
		function process($db, $user, $order, $post_form){
			global $settings;
			if(isset($post_form) && is_array($post_form)){
				$post_data = "";
				// get post_form, common, settings and custom vars
				reset($this->common_vars);
				$sale_tax = "";
				if($this->common_vars["order_tax_amount"]["value"]>0)
					$sale_tax = "&ssl_salestax=".urlencode(number_format($this->common_vars["order_tax_amount"]["value"], 2, ".", ""));
				$post_data = "".
					//form data
					"ssl_first_name=".urlencode($post_form["cc_first_name"]).
					"&ssl_last_name=".urlencode($post_form["cc_last_name"]).
					"&ssl_card_number=".urlencode($post_form["cc_number"]).
					"&ssl_exp_date=".urlencode($post_form["cc_expiration_month"].substr($post_form["cc_expiration_year"], 2, 2)).
					"&ssl_cvv2=Present".
					"&ssl_cvv2cvc2=".urlencode($post_form["cc_cvv2"]).
					
					//merchant data
					"&ssl_merchant_id=".urlencode($this->settings_vars[$this->id."_merchant_id"]["value"]).
					"&ssl_user_id=".urlencode($this->settings_vars[$this->id."_user_id"]["value"]).
					"&ssl_pin=".urlencode($this->settings_vars[$this->id."_pin"]["value"]).
					
					//test mode
					"&ssl_test_mode=".urlencode($this->settings_vars[$this->id."_test_mode"]["value"]).
					
					//order data
					"&ssl_transaction_type=SALE".
					"&ssl_amount=".urlencode(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "")).
					$sale_tax.
					"&ssl_invoice_number=".urlencode($this->common_vars["order_id"]["value"]).
					"&ssl_customer_code=".urlencode($this->common_vars["customer_id"]["value"]).
					
					//customer data
					"&ssl_company=".urlencode($this->common_vars["billing_company"]["value"]).
					"&ssl_avs_address=".urlencode($this->common_vars["billing_address1"]["value"]).
					"&ssl_address2=".urlencode($this->common_vars["billing_address2"]["value"]).
					"&ssl_city=".urlencode($this->common_vars["billing_city"]["value"]).
					"&ssl_state=".urlencode($this->common_vars["billing_state_abbr"]["value"]==""?$this->common_vars["billing_state"]["value"]:$this->common_vars["billing_state_abbr"]["value"]).
					"&ssl_avs_zip=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&ssl_country=".urlencode($this->common_vars["billing_country"]["value"]).
					"&ssl_phone=".urlencode($this->common_vars["billing_phone"]["value"]).
					"&ssl_email=".urlencode($this->common_vars["billing_email"]["value"]).
					
					//shipping data
					"&ssl_ship_to_company=".urlencode($this->common_vars["shipping_company"]["value"]).
					"&ssl_ship_to_first_name=".urlencode($this->common_vars["shipping_name"]["value"]).
					"&ssl_ship_to_last_name=".urlencode($this->common_vars["shipping_name"]["value"]).
					"&ssl_ship_to_address=".urlencode($this->common_vars["shipping_address"]["value"]).
					"&ssl_ship_to_city=".urlencode($this->common_vars["shipping_city"]["value"]).
					"&ssl_ship_to_state=".urlencode($this->common_vars["shipping_state_abbr"]["value"]==""?$this->common_vars["shipping_state"]["value"]:$this->common_vars["shipping_state_abbr"]["value"]).
					"&ssl_ship_to_zip=".urlencode($this->common_vars["shipping_zip"]["value"]).
					"&ssl_ship_to_country=".urlencode($this->common_vars["shipping_country"]["value"]).
					
					//transaction properties
					"&ssl_show_form=FALSE".
					"&ssl_result_format=ASCII";
				
				//die($post_data);
				
				$_post_url = trim($this->url_to_gateway)=="" ? "https://www.viaKLIX.com/process.asp" : trim($this->url_to_gateway);
				
				//post data to viaclix gateway
				$c = curl_init($_post_url);
				
				if($settings["ProxyAvailable"] == "YES"){
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if(defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5")){
						curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					if($settings["ProxyRequiresAuthorization"] == "YES"){
						curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($c, CURLOPT_TIMEOUT, 120);
				}

				curl_setopt($c, CURLOPT_VERBOSE, 0);
				curl_setopt($c, CURLOPT_HEADER, 0);
				curl_setopt($c, CURLOPT_POSTFIELDS, $post_data);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
				set_time_limit(300);
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($c);
				
				//echo str_replace("&", "<br>", $post_data);
				//echo "<hr>";
				//echo nl2br($buffer);
				
				//parse response
				if(trim($buffer) != ""){
					$values = array();
					$lines = explode("\n", $buffer);
					for($i=0; $i<count($lines); $i++){
						if(trim($lines[$i])){
							$pos = strpos($lines[$i], "=");
							//echo $pos;
							if($pos === false){
							}
							else{
								$key = trim(substr($lines[$i], 0, $pos));
								$value = trim(substr($lines[$i], $pos+1, strlen($lines[$i]) - $pos));
								$values[$key] = $value;
							}
						}
					}
					if(count($values)){
						if(($values["ssl_result"] == "0") && $values["ssl_result_message"] == "APPROVED"){
							$this->createTransaction($db, $user, $order, $buffer, "");
							if($this->support_ccs && $this->enable_ccs){
								$card_data = array(
									"fn"=>$post_form["cc_first_name"],
									"ln"=>$post_form["cc_last_name"],
									"ct"=>$post_form["cc_type"],
									"cc"=>$post_form["cc_number"],				
									"em"=>$post_form["cc_expiration_month"], 
									"ey"=>$post_form["cc_expiration_year"]
								);
								$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
							}
							$this->is_error = false;
							$this->error_message = "";
						}
						else{
							$this->error_message = "We are sorry, but this transaction has been declined.<br>Payment gateway response: ".$values["ssl_result_message"];
							$this->is_error = true;
						}
					}
					else{
						$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT;
						$this->is_error = true;
					}
				}
				else{
					$this->error_message = PAYMENT_TRANSACTION_ERROR_TEXT;
					$this->is_error = true;
				}
			}
			return !$this->is_error;
		}
	}
?>
