<?php
	if (!defined("ENV")) exit();
?>
<div id="admin-tab-sheet-inventory" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
<?
	if(_ACCESS_ALL || _ACCESS_INVENTORY){
?>
<script language="javascript" type="text/javascript">
	function setInvControlType(){
		var sel = document.getElementsByName('inventory_control');
		var selected_opt;		
		var radioLength = sel.length;
		
		for(var i = 0; i < radioLength; i++) { 
			if(sel[i].checked) {
				selected_opt = sel[i].value;
				
			}
		}

		var div_prod = document.getElementById('divInvProdLevel');
		var div_attr = document.getElementById('divInvAttrLevel');		
		if(selected_opt && div_prod && div_attr){
			switch(selected_opt){
				case "No" : 
					div_prod.style.display = 'none';
					div_attr.style.display = 'none';
					break;
				case "Yes" :
					div_attr.style.display = 'none';
					div_prod.style.display = 'block';
					break;
				case "AttrRuleInc" :
				case "AttrRuleExc" :
					div_prod.style.display = 'none';
					div_attr.style.display = 'block';
					break;
			}
		}
	}
</script>

	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_inventory.gif"/></div>
				<div class="formHeaderText">Inventory Control</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><label id="checkbox_inventory_control">Do you want inventory tracking for this item?</label></td>
			<td class="formItemControl">
				<input id="radio_inventory_control1" name="inventory_control" value="No" type="radio" <?=$inventory_control=="No"?"checked":""?> onclick="setInvControlType();"> No Inventory Tracking <br />
				<input id="radio_inventory_control2" name="inventory_control" value="Yes" type="radio" <?=$inventory_control=="Yes"?"checked":""?> onclick="setInvControlType();"> Track Inventory at product level <br />
				<input id="radio_inventory_control4" name="inventory_control" value="AttrRuleInc" type="radio" <?=$inventory_control=="AttrRuleInc"?"checked":""?> onclick="setInvControlType();"> Track inventory at attribute level - Track only defined combinations<br />
				<div class="formItemComment">	
					In this method only DEFINED combinations are tracked and all undefined combinations are available for purchase.  If an attribute combination is not defined below, a customer WILL BE allowed to purchase the product. Once a defined attribute reaches 0, customers will not be able to purchase it.
				</div>
				<input id="radio_inventory_control3" name="inventory_control" value="AttrRuleExc" type="radio" <?=$inventory_control=="AttrRuleExc"?"checked":""?> onclick="setInvControlType();"> Track inventory at attribute level - Sell only defined combinations <br />
				<div class="formItemComment">	
					In this method only DEFINED attribute combinations are available for purchase. If an attribute combination is not defined below, a customer WILL NOT be able to purchase it. Once a defined attribute reaches 0, customers will not be able to purchase it.
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">If product / attribute is out of stock :</td>
			<td class="formItemControl">
				<select name="inventory_rule" style="width:250px;">
					<option value="OutOfStock">Show "Out Of Stock" message</option>
					<option value="Hide" <?=$inventory_rule=="Hide"?'selected="selected"':""?>>Do not display</option>
				</select>
			</td>
		</tr>
	</table>
	<div id="divInvProdLevel" style="display:none">
		<table width="100%" cellpadding="0" cellspacing="5" border="0">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_inventory.gif"/></div>
					<div class="formHeaderText">Inventory Control on Product Level</div>
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption">Number of items in inventory</td>
				<td class="formItemControl">
					<input type="text" name="stock" style="width:123px;" value="<?=$stock?>">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption">Notify me when inventory is equal to or less than</td>
				<td class="formItemControl">
					<input type="text" name="stock_warning" style="width:123px;" value="<?=$stock_warning?>">
				</td>
			</tr>
		</table>
	</div>
	<div id="divInvAttrLevel" style="display:none">
		<table width="100%" cellpadding="0" cellspacing="5" border="0">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_inventory.gif"/></div>
					<div class="formHeaderText">Inventory Control on Product's Attribute Level</div>
				</td>
			</tr>
<?		
		$db->query("
			SELECT * FROM ".DB_PREFIX."products_attributes 
			WHERE pid='".$pid."' AND is_active='Yes' AND track_inventory=1 AND (attribute_type='radio' OR attribute_type='select') 
			ORDER BY priority, name, is_modifier
		");
		if($db->numRows() > 0){?>
<?
			while($db->moveNext()){
				$attribute = $db->col;
				$attribute["options"] = array();
				parseOptions($db->col["options"], $price, $weight, $attribute["options"], true);			
?>
			<tr valign="top">
				<td class="formItemCaption" style="padding-top:2px;">
					Attribute "<b><?=htmlspecialchars($attribute["name"])?></b>"
				</td>
				<td class="formItemControl">
<?			
				if($attribute["attribute_type"] == "select" || $attribute["attribute_type"] == "radio"){
					echo '<select name="inv_attribute_option['.$attribute["paid"].']">';						
					foreach($attribute["options"] as $option_key=>$option_data){
						echo '<option value="'.htmlspecialchars($option_key).'">'.htmlspecialchars($option_key).'</option>';		
					}
					echo '</select>';
				}
?>
				</td>
			</tr>
<?
			}
?>
			<tr valign="top">
				<td class="formItemCaption"><b>Product Sub ID</b></td>
				<td class="formItemControl">
					<input type="text" name="inv_attr_subid" style="width:250px;" value="">
					<div class="formItemComment">Must be unique for product</div>
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption">Number of items in inventory</td>
				<td class="formItemControl">
					<input type="text" name="inv_attr_stock" style="width:123px;" value="10">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption">Notify me when inventory is equal to or less than</td>
				<td class="formItemControl">
					<input type="text" name="inv_attr_stock_warning" style="width:123px;" value="0">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption">Activate these settings?</td>
				<td class="formItemControl">
					<input type="checkbox" name="inv_attr_active" value="1" checked="checked"/>
				</td>
			</tr>
			<tr>
				<td colspan="2" class="admin-form-buttons">
					<input type="submit" value="Add New Inventory Record" onFocus="frmProduct.elements['do_apply'].value='yes';" onBlur="frmProduct.elements['do_apply'].value='no';" onClick="frmProduct.elements['do_apply'].value='yes';"/>
				</td>
			</tr>
<?		}
		else{?>

			<tr>
				<td colspan="2" height="60" style="color:#990000;padding-left:25px;">
					<img src="images/icons/ic_hint.gif" align="left" hspace="4">
					<b>You don't have active attributes.</b>
				</td>
			</tr>
<?			}
?>
		</table>
		<table width="100%" cellpadding="0" cellspacing="5" border="0">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_properties.gif"/></div>
					<div class="formHeaderText">Current Inventory</div>
				</td>
			</tr>
		</table>
		<table width="100%" cellpadding="5" cellspacing="0" border="0">
			<tr>
				<td class="formListHeaderIcon">&nbsp;</td>
				<td class="formListHeaderCaption" width="60" style="width:60px;"><b>Active</b></td>
				<td class="formListHeaderCaption" width="180" style="width:180px;"><b>Product Sub ID</b></td>
				<td class="formListHeaderCaption" width="180" style="width:180px;"><b>Attrbibutes / Options</b></td>
				<td class="formListHeaderCaption" width="80" style="width:80px;"><b>Stock</b></td>
				<td class="formListHeaderCaption" width="80" style="width:80px;"><b>Stock Warning</b></td>
				<td class="formListHeaderCaption">&nbsp;</td>
			</tr>
<?		$db->query("SELECT * FROM ".DB_PREFIX."products_inventory WHERE pid='".$pid."'");
		if($db->numRows() > 0){
			while($db->moveNext()){
?>
			<tr valign="top">
				<td class="formListItemIcon">&nbsp;</td>
				<td class="formListItemText" width="60" style="width:60px;"><input type="checkbox" name="inv_arr_active[<?=$db->col["pi_id"]?>]" value="1" <?=$db->col["is_active"]=="1"?'checked="checked"':''?>>
				<td class="formListItemText" width="180" style="width:180px;"><input type="text" name="int_arr_subid[<?=$db->col["pi_id"]?>]" value="<?=htmlspecialchars(trim($db->col["product_subid"]))?>" style="width:165px;"/></td>
				<td class="formListItemText" width="180" style="width:180px;"><?=nl2br(htmlspecialchars($db->col["attributes_list"]))?></td>
				<td class="formListItemText" width="80" style="width:80px;"><input type="text" name="inv_arr_stock[<?=$db->col["pi_id"]?>]" style="width:65px;" value="<?=$db->col["stock"]?>"/></td>
				<td class="formListItemText" width="80" style="width:80px;"><input type="text" name="inv_arr_stock_warning[<?=$db->col["pi_id"]?>]" style="width:65px;" value="<?=$db->col["stock_warning"]?>"/></td>
				<td class="formListItemText" align="right">
					<a href="javascript:ConfirmDeleteProductInventoryRecord(<?=$pid?>, <?=$db->col["pi_id"]?>)"><img src="images/icons/ic_delete.gif" alt="Delete Inventory Record" border="0"/></a>
				</td>
			</tr>
<?
			}
?>
			<tr>
				<td colspan="7" class="admin-form-buttons">
					<input type="submit" value="Apply Changes" onFocus="frmProduct.elements['do_apply'].value='yes';" onBlur="frmProduct.elements['do_apply'].value='no';" onClick="frmProduct.elements['do_apply'].value='yes';"/>
				</td>
			</tr>
<?
		}
		else{?>
			<tr>
				<td colspan="7" height="60" style="color:#990000;padding-left:25px;">
					<img src="images/icons/ic_hint.gif" align="left" hspace="4">
					<b> You do not have any inventory setup.</b>
				</td>
			</tr>
<?	
		}

?>
		</table>
	</div>
	<script language="javascript" type="text/javascript">
		setInvControlType();
	</script>
<?
	}
	else{?>
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader" colspan="2">
			<div class="formHeaderIcon"><img src="images/icons/ic_inventory.gif"/></div>
			<div class="formHeaderText">Product Inventory</div>
		</td>
	</tr>
	<tr><td>
<?
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>This feature is not available under your license agreement. Please contact your provider to upgrade your application.</b>", "url"=>"", "visible"=>true)
		));
		echo "</td></tr></table>";
	}
?>
</div></div>