<?php
/**
 * Displayed when order is completed (thank you page
 */

if (!defined("ENV")) exit();

$order_id = isset($_SESSION["pc_order_id"])?intval($_SESSION["pc_order_id"]):0;
$order_amount = isset($_SESSION["pc_order_amount"])?floatval($_SESSION["pc_order_amount"]):0;
$payment_method_id = isset($_SESSION["pc_method_id"])?intval($_SESSION["pc_method_id"]):"";
$order_quantity = isset($_SESSION["pc_order_quantity"])?intval($_SESSION["pc_order_quantity"]):0;
$order_num = isset($_SESSION["pc_order_num"])?intval($_SESSION["pc_order_num"]):0;
	
if (isset($_SESSION["LastOrderID"]))
{
	$order_id = intval($_SESSION["LastOrderID"]);		
}
	
if (isset($_SESSION["payment_session_delay_timeout"]))
{
	$_t_o = $_SESSION["payment_session_delay_timeout"];
	set_time_limit($_t_o * 5);
		
	session_write_close();
	sleep($_t_o);
	session_set_cookie_params($settings["SecurityUserTimeout"]);
	session_cache_expire(round($settings["SecurityUserTimeout"]/60)); // 24 hours
	session_name("ShoppingCartSession");
	session_start();
	unset($_SESSION["payment_session_delay_timeout"]);
}
	
unset($_SESSION["pc_order_id"]);
unset($_SESSION["pc_order_amount"]);
unset($_SESSION["pc_method_id"]);
unset($_SESSION["pc_order_quantity"]);
unset($_SESSION["pc_order_num"]);
unset($_SESSION["paypal_express_checkout_token"]);
unset($_SESSION["paypal_express_checkout_payer_id"]);
unset($_SESSION["paypal_express_checkout_details"]);
unset($_SESSION["opc_shipping_address_id"]);
unset($_SESSION["product_level_method"]);
unset($_SESSION["order_promo_code"]);
	
$message_thankyou = $msg["cart"]["thank_you_for_order"];

$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE pid='".intval($payment_method_id)."'");

if($db->moveNext())
{
	$is_payment = true;
	$message_thankyou = trim($db->col["message_thankyou"]) == "" ? $message_thankyou : $db->col["message_thankyou"]; 
}	
		
$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".intval($order_id)."' AND digital_product='Yes'");
if($db->moveNext())
{
	$message_thankyou = $message_thankyou."<br/><br/>".$msg['cart']['thank_you_for_order_digital'];
}
	
$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".intval($order_id)."'");
if ($db->moveNext())
{
	$shipping_amount = $db->col["shipping_amount"];
	$tax = $db->col["tax_amount"];
	$order_amount = $db->col["subtotal_amount"];
	$city = $db->col["shipping_city"];
	$stid = $db->col["shipping_state"];
	$coid = $db->col["shipping_country"];
	$order_total = $db->col["total_amount"];
	$order_num = $db->col["order_num"];		
	$region = getState($db, $stid);
	$country = getCountry($db, $coid);		
	view()->assign("shipping_amount", $shipping_amount); /* Shipping Amount */
	view()->assign("city", $city); /* City of Purchaser */
	view()->assign("region", $region); /* State/Region of Purchaser */
	view()->assign("country", $country); /* Country of Purchaser */
	view()->assign("tax", $tax); /* Tax  Amount */
	
	$db->query("
		SELECT
			".DB_PREFIX."orders_content.ocid as line_item, 
			".DB_PREFIX."products.title as product_name, 
			".DB_PREFIX."products.product_id as sku,
			".DB_PREFIX."orders_content.product_sub_id as attribute_sku,
			".DB_PREFIX."catalog.name as catalog_name, 
			".DB_PREFIX."orders_content.price as price, 
			".DB_PREFIX."orders_content.quantity as quantity 
		FROM 
			".DB_PREFIX."orders_content, 
			".DB_PREFIX."products, 
			".DB_PREFIX."catalog 
		WHERE
			".DB_PREFIX."orders_content.oid='".intval($order_id)."' 
			AND ".DB_PREFIX."orders_content.pid=".DB_PREFIX."products.pid 
			AND ".DB_PREFIX."catalog.cid=".DB_PREFIX."products.cid");
	while ($db->moveNext())
	{
		$items[] = $db->col;
	}
	view()->assign("items", $items); /* Items Purchased */
}

view()->assign("affiliation", $settings["GlobalSiteName"]); /* Affiliation Key */
view()->assign("order_id", $order_id); /* Unique Order ID in Database (oid), assigned to all orders */
view()->assign("order_amount", $order_amount); /* Total Amount */
view()->assign("order_quantity", $order_quantity); /* Items Quantity */
view()->assign("order_num", $order_num); /* Unique Order Number in Database (order_num), assigned ONLY to completed orders */			
view()->assign("message_thankyou", $message_thankyou);
if ($user->express)
{
	$user->logOut();
	$user->id = 0;
}	
view()->assign("body", "templates/pages/checkout/completed.html");
