<?php
/**
 * Payment page
 */

if (!defined("ENV")) exit();

if (!$order->shippingCompleted)
{
	header("Location: ".$url_dynamic."p=cart");
}

if ($order->itemsCount > 0)
{
	$order->setOrderNum();
	$order->setAbandonStatus();
	view()->assign("order_num", $order->order_num);

	view()->assign("billing_address", $user->getUserData());
	$cf_billing = $customFields->getCustomFieldsValues("billing", $user->id, 0, 0);
	if ($cf_billing)
	{
		view()->assign("cf_billing", $cf_billing);
	}
		
	view()->assign("shipping_address", $order->getShippingAddress());
	$cf_shipping = $customFields->getCustomFieldsValues("shipping", $user->id, $order->oid, 0);
		
	if ($cf_shipping)
	{
		view()->assign("cf_shipping", $cf_shipping);
	}
	
	if (!isset($payment) || !is_object($payment))
	{
		$payment = new PAYMENT($db);
	}

	if ($order->totalAmount == 0)
	{
		view()->assign("payment_url", $url_https);
		$payment_method = new PAYMENT_METHOD(
			0, // pid
			"http", // proto
			"custom", // type
			"", // url to gateway
			"Free", // name
			$msg["billing"]["order_is_free_title"], // form title
			$msg["billing"]["order_is_free_text"], // message payment
			"", // message thak you
			"free", // id
			""
		);
		$payment_method->payment_url = $payment_method->payment_url = $url_https."p=invoice";
		$payment_methods = array($payment_method);
		$active_payment_method = 0;
		$order->updatePaymentMethod("free");
	}
	else
	{
		//prepare
		$first_payment_method = 0;
		$active_payment_method = $order->paymentMethodId;
		$active_payment_method_exists = false;
			
		view()->assign("is_payment_error", $payment->is_error);
		view()->assign("payment_error_message", $payment->error_message);
			
		$payment_methods = $payment->methods;
		$payment_gateways = array();
			
		foreach ($payment_methods as $key => $payment_method)
		{
			$first_payment_method = $first_payment_method > 0 ? $first_payment_method : $payment_method->pid;
			if ($active_payment_method == 0 || $active_payment_method == "")
			{
				$active_payment_method = $payment_method->pid;
			}
			if ($active_payment_method == $payment_method->pid)
			{
				$active_payment_method_exists = true;
			}
			
			$payment_method->payment_url = $url_https;
			
			if ($payment_method->type != "custom")
			{
				unset($payment_gateway);
				$gateway_file = escapeFileName($payment_method->id);
				require_once("content/engine/payment/payment_".$gateway_file.".php");
				eval("\$payment_gateways[".$key."] = new ".$payment_method->class_name."();");
				//$payment_gateways[$key]->type = $payment_method->type;
				$payment_gateways[$key]->protocol = $payment_method->protocol;
				$payment_gateways[$key]->db_id = $payment_method->pid;
				$payment_gateways[$key]->getSettingsData($db);
				$payment_gateways[$key]->assignUser($user);
				$payment_gateways[$key]->assignOrder($order);
				$payment_gateways[$key]->assignOrderItems($order->items);
				$payment_gateways[$key]->getCommonData($user, $order);
				$payment_gateways[$key]->testMode = $payment_gateways[$key]->isTestMode();
				if (trim($payment_gateways[$key]->getPostUrl())!="")
				{
					$payment_method->payment_url = $payment_gateways[$key]->getPostUrl();
				}
				else
				{	
					$payment_method->payment_url = $url_https."p=invoice";
				}
				$payment_form = $payment_gateways[$key]->getPaymentForm($db);
				$payment_gateways[$key]->payment_form = $payment_form;
				$payment_gateways[$key]->validator_code = $payment_gateways[$key]->getValidatorJS();
				$payment_method->gateway = $payment_gateways[$key];
			}
			else
			{
				$payment_method->payment_url = $url_https."p=invoice";				
				$payment_method->gateway = false;
			}
			$payment_methods[$key] = $payment_method;
		}
		if (!$active_payment_method_exists)
		{
			$active_payment_method = $first_payment_method;
		}
		$order->updatePaymentMethod($active_payment_method);
	}

	
	$payment_methods_count = count($payment_methods);
	view()->assign("payment_methods", $payment_methods);
	view()->assign("payment_methods_count", $payment_methods_count);
	view()->assign("active_payment_method", $active_payment_method);
		
	$_SESSION["pc_order_id"] = $order->oid;
	$_SESSION["pc_order_amount"] = $order->totalAmount - $order->shippingAmount - $order->taxAmount - ($order->handlingSeparated ? $order->handlingAmount : 0.00);
	$_SESSION["pc_method_id"] = $order->paymentMethodId;
	$_SESSION["pc_order_quantity"] = $order->itemsCount;
	$_SESSION["pc_order_num"] = $order->order_num;
	view()->assign("body", "templates/pages/checkout/invoice.html");
}
else
{
	header("Location: ".$url_dynamic."p=cart");
}
