<?php
/**
 * Show users address book
 */

if (!defined("ENV")) exit();

require('fpdf17/fpdf.php');
$pdf_name = rand(9999,99999);	
$pdf_date = date("F d, Y");
view()->assign("pdf_date",$pdf_date);

function convert_number_to_words($number) {

    $hyphen      = '-';
    $conjunction = ' and ';
    $separator   = ', ';
    $negative    = 'negative ';
    $decimal     = ' .';
    $dictionary  = array(
        0                   => 'zero',
        1                   => 'one',
        2                   => 'two',
        3                   => 'three',
        4                   => 'four',
        5                   => 'five',
        6                   => 'six',
        7                   => 'seven',
        8                   => 'eight',
        9                   => 'nine',
        10                  => 'ten',
        11                  => 'eleven',
        12                  => 'twelve',
        13                  => 'thirteen',
        14                  => 'fourteen',
        15                  => 'fifteen',
        16                  => 'sixteen',
        17                  => 'seventeen',
        18                  => 'eighteen',
        19                  => 'nineteen',
        20                  => 'twenty',
        30                  => 'thirty',
        40                  => 'fourty',
        50                  => 'fifty',
        60                  => 'sixty',
        70                  => 'seventy',
        80                  => 'eighty',
        90                  => 'ninety',
        100                 => 'hundred',
        1000                => 'thousand',
        1000000             => 'million',
        1000000000          => 'billion',
        1000000000000       => 'trillion',
        1000000000000000    => 'quadrillion',
        1000000000000000000 => 'quintillion'
    );
    
    $dictionary1  = array(
        0                   => '0',
        1                   => '1',
        2                   => '2',
        3                   => '3',
        4                   => '4',
        5                   => '5',
        6                   => '6',
        7                   => '7',
        8                   => '8',
        9                   => '9'
    );

    if (!is_numeric($number)) {
        return false;
    }

    if (($number >= 0 && (int) $number < 0) || (int) $number < 0 - PHP_INT_MAX) {
        // overflow
        trigger_error(
            'convert_number_to_words only accepts numbers between -' . PHP_INT_MAX . ' and ' . PHP_INT_MAX,
            E_USER_WARNING
        );
        return false;
    }

    if ($number < 0) {
        return $negative . convert_number_to_words(abs($number));
    }

    $string = $fraction = null;

    if (strpos($number, '.') !== false) {
        list($number, $fraction) = explode('.', $number);
    }

    switch (true) {
        case $number < 21:
            $string = $dictionary[$number];
            break;
        case $number < 100:
            $tens   = ((int) ($number / 10)) * 10;
            $units  = $number % 10;
            $string = $dictionary[$tens];
            if ($units) {
                $string .= $hyphen . $dictionary[$units];
            }
            break;
        case $number < 1000:
            $hundreds  = $number / 100;
            $remainder = $number % 100;
            $string = $dictionary[$hundreds] . ' ' . $dictionary[100];
            if ($remainder) {
                $string .= $conjunction . convert_number_to_words($remainder);
            }
            break;
        default:
            $baseUnit = pow(1000, floor(log($number, 1000)));
            $numBaseUnits = (int) ($number / $baseUnit);
            $remainder = $number % $baseUnit;
            $string = convert_number_to_words($numBaseUnits) . ' ' . $dictionary[$baseUnit];
            if ($remainder) {
                $string .= $remainder < 100 ? $conjunction : $separator;
                $string .= convert_number_to_words($remainder);
            }
            break;
    }

    if (null !== $fraction && is_numeric($fraction)) {
        $string .= $decimal;
        $words = array();
        foreach (str_split((string) $fraction) as $number) {
            $words[] = $dictionary1[$number];
        }
        $string .= implode('', $words);
    }

    return $string;
}


	//print_r($user);
	$action 		= 	isset($_REQUEST["formaction"])	?	($_REQUEST["formaction"])	:"";
	$price 		    = 	isset($_REQUEST["price"])		?	($_REQUEST["price"])		:"";
	$item 		    = 	isset($_REQUEST["item"])		?	($_REQUEST["item"])		:"";
	$title 		    = 	isset($_REQUEST["title"])		?	($_REQUEST["title"])		:"";
	$company 		= 	isset($_REQUEST["company"])		?	($_REQUEST["company"])		:"";
	$fname 			= 	isset($_REQUEST["fname"])		?	($_REQUEST["fname"])		:"";
	$lname 			= 	isset($_REQUEST["lname"])		?	($_REQUEST["lname"])		:"";
	$officer 		= 	$fname." ".$lname;
	$email 			= 	isset($_REQUEST["email"])		?	($_REQUEST["email"])		:"";
	$phone 			= 	isset($_REQUEST["phone"])		?	($_REQUEST["phone"])		:"";
	$addr1 			= 	isset($_REQUEST["addr1"])		?	($_REQUEST["addr1"])		:"";
	$addr2			= 	isset($_REQUEST["addr2"])		?	($_REQUEST["addr2"])		:"";
	$city 			= 	isset($_REQUEST["city"])		?	($_REQUEST["city"])			:"";
	$zip 			= 	isset($_REQUEST["zip"])			?	($_REQUEST["zip"])			:"";
	$description 	= 	isset($_REQUEST["description"])	?	($_REQUEST["description"])	:"";
	$state 			= 	isset($_REQUEST["_OfficeState93262"])		?	($_REQUEST["_OfficeState93262"])		:"";
	$country 		= 	isset($_REQUEST["_OfficeCountry93259"])		?	($_REQUEST["_OfficeCountry93259"])		:"";
	
	$f_sign = substr($fname,0,1);
	$l_sign = substr($lname,0,1);
	
	$sign = $f_sign.'.'.$l_sign;
	
	if($action == 'post')
	{
		//print_r($_POST); exit();
		if ($settings['captchaMethod'] != 'None')
	{
		
		require_once('content/vendors/recaptcha/recaptchalib.php');
		view()->assign('captcha', recaptcha_get_html($settings['captchaReCaptchaPublicKey']));
		
	}
		
		$captchaError = false;
		

		
		

		require_once('content/vendors/recaptcha/recaptchalib.php');
/*		$resp = recaptcha_check_answer(
			$settings['captchaReCaptchaPrivateKey'],
			$_SERVER["REMOTE_ADDR"],
			$_POST["recaptcha_challenge_field"],
			$_POST["recaptcha_response_field"]
		);*/
	
		if ($_POST['mobile1'] != '')
		{
			//$user->setError("Please enter the valid CAPTCHA words");
			//print_r($resp);
	
			//$captchaError = true;
				
			//$errmsg['captcha'] = 'Please enter Valid Captcha';
			view()->assign("errmsg",$errmsg);
					//view()->assign("insertsuccess", "ok");			
			view()->assign("company",$company);
			view()->assign("price",$price);	
			view()->assign("fname",$fname);	
			view()->assign("lname",$lname);	
			view()->assign("email",$email);	
			view()->assign("phone",$phone);	
			view()->assign("addr1",$addr1);	
			view()->assign("addr2",$addr2);	
			view()->assign("city",$city);	
			view()->assign("zip",$zip);	
			view()->assign("description",$description);	
			view()->assign("dmp_country",$country);	
			view()->assign("dmp_state",$state);		
			view()->assign("body", "templates/pages/account/my_equipment_visitor.html");	
			
		
		}
		else
		{
		if($company != 'google')
		{
			
		$db->query("SELECT * FROM ".DB_PREFIX."users WHERE email = '".trim($email)."'");
		if($db->moveNext())
		{
			$user_id = $db->col['uid'];
			
			$db->reset();
			
			$db->assign("user_id", $user_id);
			$db->assignStr("owner_fname", $db->col['fname']);
			$db->assignStr("owner_lname", $db->col['lname']);
			$db->assignStr("owner_email", $db->col['email']);
			$db->assignStr("owner_phone", $db->col['phone']);
			$db->assignStr("owner_company", $db->col['company']);
			$db->assign("price", $price);
			
			$db->assignStr("title", $item);
			$db->assignStr("item", $item);
			$db->assignStr("officer", $officer);
			$db->assignStr("job_title", $title);
			
			
			
			$product_id = substr(md5(uniqid(rand(), 1)), rand(0, 10), 16);
			$db->assignStr("product_id", $product_id);
			
			$db->assign("added", "NOW()");
			$product_status ="pending";
			$db->assignStr("product_status", $product_status);
			$db->assignStr("user_pdf", $pdf_name.'.pdf');
			
			$pid = $db->insert(DB_PREFIX."products");
			$db->assign("pid", $pid);
			$db->insert(DB_PREFIX."products_users");
		}
		else
		{
			$token = uniqid();
			
			$db->reset();
			
			$db->assignStr("login", $email);
			$db->assignStr("company", $company);
			$db->assignStr("fname", $fname);
			$db->assignStr("lname", $lname);
			$db->assignStr("email", $email);
			$db->assignStr("password", getPasswordHash($token));
			$db->assignStr("phone", $phone);
			$db->assignStr("address1", $addr1);
			$db->assignStr("address2", $addr2);
			$db->assignStr("city", $city);
			//$db->assignStr("state", $state);
			//$db->assignStr("country", $country);
			$db->assignStr("zip", $zip);
			
			$user_id = $db->insert(DB_PREFIX."users");
			
			$db->reset();
			
			$db->assign("user_id", $user_id);
			$db->assignStr("owner_fname", $fname);
			$db->assignStr("owner_lname", $lname);
			$db->assignStr("owner_email", $email);
			$db->assignStr("owner_phone", $phone);
			$db->assignStr("owner_company", $company);
			$db->assign("price", $price);
			$db->assignStr("title", $item);
			$db->assignStr("item", $item);
			$db->assignStr("officer", $officer);
			$db->assignStr("job_title", $title);
			
			$db->assignStr("user_pdf", $pdf_name.'.pdf');
			
			$product_id = substr(md5(uniqid(rand(), 1)), rand(0, 10), 16);
			$db->assignStr("product_id", $product_id);
			
			$db->assign("added", "NOW()");
			$product_status ="pending";
			$db->assignStr("product_status", $product_status);
			
			$pid = $db->insert(DB_PREFIX."products");
			$db->assign("pid", $pid);
			$db->insert(DB_PREFIX."products_users");
						
			emailNewUserRegistered_equ($db, $user_id, $token); 
			
		}
		
$pdf = new FPDF();
$pdf->AddPage();


   /* Top Right Part */
    $pdf->SetFont('Arial','BU',9);
    $pdf->Cell(40,3,"Consignment Agreement: ",0,0,"L"); 
	$pdf->SetFont('Arial','B',9);
    $pdf->Write(4, "THIS AGREEMENT IS MADE by and between: Pavement Technologies International Corp., (herein referred to as 'PTIC') existing under the laws of NY with its principal place of business at 1525 Western Ave, Albany, NY and Supplier noted below (herein referred to as 'Supplier'), jointly referred to as 'Parties', and pertains to a consignment agreement between Parties, pertaining only to the item(s) (herein referred to as 'Item(s)') noted below.");
	
	$pdf->Ln(10);
	$pdf->SetFont('Arial','B',9);
    $pdf->Write(4, "This agreement shall remain exclusive for 120 days, from signature date, during which time Supplier agrees to sell Item(s) solely through PTIC, and not to advertise or market said Item(s) through other parties, after which, agreement will become non-exclusive ");
	$pdf->SetFont('Arial','',9);
	$pdf->Write(4, "and remainder of this Agreement shall remain in full force and effect.");
    
    $pdf->Ln(10);
    $pdf->SetFont('Arial','BU',9);
    $pdf->Cell(60,3,"Supplier agrees to non-circumvention: ",0,0,"L"); 
    $pdf->SetFont('Arial','',9);
    $pdf->Write(4, "Supplier understands that PTIC will introduce prospective Buyers (herein referred to as 'Buyers') and agrees not to circumvent PTIC, not to discuss pricing or sell to Buyers directly or through third party. Upon request from PTIC, Supplier may demonstrate and discuss item's condition and history with Buyers. Supplier agrees to refer all pricing questions to PTIC. This provision shall also survive the termination of this Agreement by a period of two years.");
    
    $pdf->Ln(10);
    $pdf->Write(4, 'Neither this Agreement nor any provision contained herein may be construed as creating or constituting a partnership or joint venture between Parties hereto. The relationship created hereby is strictly that of consignor and consignee. Other than the terms of this Agreement, neither party hereto has the power or authority to, and no party hereto may, assume or create any obligation or responsibility, express or implied, on behalf of the other.');
    
    $pdf->Ln(10);
    $pdf->Write(4, 'This Agreement supersedes any and all prior representations, conditions, warranties, understandings, proposals of previous agreements between Supplier and PTIC, oral or written, relating to the subject matter hereof and constitutes the complete agreement between the Parties. Should any of the provisions of this Agreement be found to be invalid by a court of competent jurisdiction, that portion shall be deemed severed or restricted and the remainder of this Agreement shall remain in full force and effect.');
    
	$pdf->Ln(10);
    $pdf->Write(4, 'The Parties may execute and transmit signed Agreement in written form, by facsimile, email or e-signature (via PavementGroup.com website) and Parties shall be entitled to rely on such as evidence that this signed Agreement has been duly executed by such party.');
    
	$pdf->Ln(10);
    $pdf->Write(4, 'In case there is any non-performance and/or violation of the terms and conditions under the Agreement, Parties hereto shall do their best to settle the matter in question as promptly and amicably as possible and to their mutual satisfaction. Any dispute, action or claim arising out of or in connection with this Agreement may by mutual agreement be referred to the arbitration in NY of a single arbitrator appointed by agreement between Parties.');
    
	$pdf->Ln(10);
    $pdf->Write(4, 'This Agreement will be governed and construed in accordance with the laws of the United States of America, State of New York, without regard to the conflicts of law principles of any jurisdiction. Each party (a) irrevocably consents and submits to the jurisdiction of any State or Federal court sitting in New York with respect to any action or claim or other proceeding connected with this Agreement in any way whatsoever, (b) irrevocably waives the defense of forum non conveniens, (c) acknowledges that a final judgment in any such action or proceeding in the State of New York will be conclusive and may be enforced in other jurisdictions by suit on the judgment or in any other manner provided by law, (d) consents to personal and subject matter jurisdiction of any state or federal court sitting in New York.');
    
    $pdf->Ln(10);
    $pdf->Write(4, 'If agreeable between Parties, Supplier may accept from PTIC a lower price for Item(s) than indicated herein. Seller agrees to disclose any liens on item(s). Upon purchase, PTIC will first apply purchase funds toward the open bank liens on item(s) and balance will be paid to Supplier.  Any lien balance amount in excess of the purchase prices is the responsibility of, and will be paid by, the Supplier.');
	
	$pdf->Ln(10);
   	$pdf->SetFont('Arial','B',9);
	
   	$pdf->Write(4, 'Item(s) Description: ');
   	$pdf->Cell(40,4,"".$item."",0,0,"L");
	
	//$pdf->Ln(5);
	//$pdf->Write(4, 'Item ID# or VIN: ');
   	//$pdf->Cell(40,4,"",0,0,"L");
	
	$pdf->Ln(5);
	$pdf->Write(4, 'Supplier Price USD: $');
   	$pdf->Cell(40,4,"".$price." (".convert_number_to_words($price)." Dollars) ",0,0,"L");

    $pdf->Ln(10);
   	$pdf->SetFont('Arial','B',9);
   	$pdf->SetTextColor(255,0,0);
		
   	$pdf->Write(4, 'Agreement Date: ');
	$pdf->Cell(40,4,"".$pdf_date."",0,0,"L");
	
	$pdf->Ln(5);
	$pdf->Write(4, "Supplier - Business Name: ");
	$pdf->Cell(40,4,"".$company."",0,0,"L");
	
	$pdf->Ln(5);
	$pdf->Write(4, "Supplier - Representative Name: ");
	$pdf->Cell(40,4,"".$officer."",0,0,"L");
	
	$pdf->Ln(5);
	$pdf->Write(4, "Supplier - Representative Title: ");
	$pdf->Cell(40,4,"".$title."",0,0,"L");
	
	$pdf->Ln(10);
    $pdf->SetFont('Arial','',9);
	$pdf->SetTextColor(0,0,0);
    $pdf->Write(4, 'As conclusive evidence of their acceptance of the terms and conditions of this Agreement, Parties and all their affiliated companies and entities execute this Agreement:');
	
	$pdf->Ln(10);
	$pdf->SetFont('Arial','B',9);
	$pdf->SetTextColor(255,0,0);
	$pdf->Write(4, 'Supplier Signature: ');
   	$pdf->Cell(40,4,"".strtoupper($sign)." _____________",0,0,"L");
	  	
   	$pdf->Ln(10);
	$pdf->SetFont('Arial','B',9);
	$pdf->SetTextColor(0,0,0);
	$pdf->Write(4, 'PTIC: Pavement Technologies International Corp. ');
	$pdf->SetFont('Arial','',9);
	$pdf->Write(4, 'Mark Reeves, President');
	$pdf->Image('/usr/local/apache/htdocs/pavementgroup/images/pdf_signature.jpg',122,265,30,0,'','');

   	$pdf->Ln(10);
//    $pdf->Output();

$dmp = '/usr/local/apache/htdocs/pavementgroup/pdf/'.$pdf_name.'.pdf';
$pdf->Output($dmp);		
//$pdf->Output();		
	
		$insertQuery = mysql_query
		("insert into visitor_equipment
			(company,fname,lname,email,phone,addr1,addr2,city,state,zip,country,description,insert_date,price,item,title,officer)values('".addslashes($company)."','".addslashes($fname)."','".addslashes($lname)."','".$email."','".$phone."','".addslashes($addr1)."','".addslashes($addr2)."','".addslashes($city)."','".addslashes($state)."','".$zip."','".$country."','".addslashes($description)."',Now(),'".$price."','".$item."','".$title."','".$officer."')")or die(mysql_error()); 
			
		$visitor_id = mysql_insert_id();
			
		emailvisitorsellEquipment($db,$_POST,$visitor_id);
					 
		view()->assign("insertsuccess", "ok");			
		view()->assign("body", "templates/pages/account/my_equipment_visitor.html");					
		
		/*pageHeader("Product Added", "", "ic_product_done.gif");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>New product has been successfully added.</b>", "url"=>"", "visible"=>true),
			array("icon"=>"ic_warning.gif", "text"=>"<font color=\"#dd0000\"><b>Duplicate Product ID - the product you entered contained a Product ID (".gs($old_product_id).") already found in the database. The product was assigned a new Product ID (".$product_id."). To change it, please click on the link below.</b></font>", "url"=>"", "visible"=>$duplicate_product_id),
			array("icon"=>"ic_warning.gif", "text"=>"<font color=\"#dd0000\"><b>Can't Find a File ".$digital_product_file." - the product file you entered does not exists. Now product is not available for sale</b></font>", "url"=>"", "visible"=>$digital_product_error)
		));
		pageWhat(array(
			array("icon"=>"ic_change_text.gif", "text"=>"Edit previous product", "url"=>"admin.php?p=product&mode=update&pid=".$pid."&last_active_tab=".$last_active_tab),
			array("icon"=>"ic_insert_row.gif", "text"=>"Add a new product", "url"=>"admin.php?p=product&mode=insert&cid=".$cid),
			array("icon"=>"ic_product.gif", "text"=>"Browse all products", "url"=>"admin.php?p=products")
		));*/
		
		//header("Location:".$url_https."p=my_notification");
		//exit();
		//echo $url_https;
		
		}
		}
	}
