<?php
/**
 * One Page Checkout
 */
	if (!defined("ENV")) exit();
	
	if ($order->itemsCount > 0 && $user->auth_ok)
	{
		// Prepare order
		$order->setOrderNum();
		$order->setAbandonStatus();
		
		// Reset gift certificate
		if ($settings['enable_gift_cert'] == "Yes")
		{
			$giftCertificates = new GiftCertificates($db);
			$giftCertificates->UpdateOrderGCAmount($order->oid, 0.00);
			$giftCertificates->SetOrderGiftCert($order->oid, '', '', '');
			$order->gift_cert_amount = 0;
			
		}
		
		// Country / state data
		require_once("content/classes/class.regions.php");
		$regions = new Regions($db);
		view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));
		
		// Billing data
		$billingData = $user->getBillingInfo();
		if ($user->express && $billingData["country"] == 0)
		{
			$billingIsEmpty = true;
			$billingData["country"] = "-1";
			$billingData["state"] = "-1";
		}
		else
		{
			$billingIsEmpty = false;
		}
		
		
		//custom fields
		$custom_field = isset($_REQUEST["custom_field"]) ? $_REQUEST["custom_field"] : array();
		view()->assign("cf_signup", $cf_signup = $customFields->getCustomFieldsValues("signup", $user->id, $order->oid, 0));
		view()->assign("cf_account", $cf_account = $customFields->getCustomFieldsValues("account", $user->id, $order->oid, 0));
		view()->assign("cf_invoice", $cf_invoice = $customFields->getCustomFieldsValues("invoice", $user->id, $order->oid, 0));
		view()->assign("cf_billing", $cf_billing = $customFields->getCustomFieldsValues("billing", $user->id, $order->oid, 0));
		view()->assign("cf_shipping", $cf_shipping = $customFields->getCustomFieldsValues("shipping", $user->id, $order->oid, 0));
		
		if ($cf_signup) view()->assign("cf_signup_c1", ceil(count($cf_signup) / 2));
		if ($cf_account) view()->assign("cf_account_c1", ceil(count($cf_account) / 2));
		if ($cf_billing) view()->assign("cf_billing_c1", ceil(count($cf_billing) / 2));
		if ($cf_invoice) view()->assign("cf_invoice_c1", ceil(count($cf_invoice) / 2));
		
		$additionalIsEmpty = false;
		
		if ($cf_invoice)
		{
			foreach ($cf_invoice as $cf)
			{
				if ($cf["is_active"] && $cf["is_required"] && $cf["value"] == "") $additionalIsEmpty = true;
			}
		}
		
		// Shipping Data
		$shippingAddressId = isset($_SESSION["opc-shipping-address-id"]) ? $_SESSION["opc-shipping-address-id"] : "billing";
		$shippingMethodId = isset($_SESSION["opc-shipping-method-id"]) ? $_SESSION["opc-shipping-method-id"] : "0";
		if ($shippingAddressId == "billing")
		{
			$billingData = $user->getBillingInfo();
			$order->updateShippingAddress($billingData);		
		}
		
		$shippingAddressBook = $user->getShippingAddresses();
		$shippingAddress = $order->getShippingAddress();
		
		if ($shippingAddress["country_id"] == 0)
		{
			$shippingIsEmpty = true;
			$shippingAddress["country_id"] = "-1";
			$shippingAddress["state_id"] = "-1";
		}
		else
		{
			$shippingIsEmpty = false;
		}
		
		// Payment Methods
		if (!isset($payment)) $payment = new PAYMENT($db);
	
		// TODO: Moneybookers to work in OPC
		// Temporarily keeping moneybookers from being used in OPC
		$moneybookers_count = 0;	
		/**
		foreach ($payment->methods as $method)
		{
			if (in_array($method->id, array('moneybookers', 'moneybookersacc', 'moneybookersewallet'))) $moneybookers_count++;
		}
		**/
			
		view()->assign("payment_methods", $payment->methods);
		view()->assign("payment_methods_count", count($payment->methods) - $moneybookers_count);
		
		// add free payment method (when possible order is free)
		// case 1: we are 100% sure that order is free - subtotal = 0, no fees, no taxes, no shipping costs - when all items have free shipping OR are digital 
		// case 2: we don't know 100% that order is free - subtota = 1, no fess, no taxes, but shipping costs may be added depending on method selected
		$freePaymentMethod = new PAYMENT_METHOD(0, "http", "custom", "", "Free", $msg["billing"]["order_is_free_title"], $msg["billing"]["order_is_free_text"], "", "free", "");
		$freePaymentMethod->payment_url = $url_https."p=one_page_checkout";
		view()->assign("free_payment_method", $freePaymentMethod);		
		
		$paymentMethodId = isset($_SESSION["opc-payment-method-id"]) ? $_SESSION["opc-payment-method-id"] : "0";
		
		$order->recalcOrderData();
		$order->getOrderData();
		
		$orderData = array(
			"subtotalAmount" => $order->subtotalAmount,
			"discountAmount" => $order->discountAmount,
			"promoDiscountAmount" => $order->promoDiscountAmount,
			"insureShipActive" => intval($order->insureShipActive),
			"insureShipAmount" => $order->insureShipAmount,
			// Promo Code calculations
			"promoDiscountValue" => $order->promoDiscountValue,
			"promoDiscountType" => $order->promoDiscountType,
			"promoType" => $order->promoType, // Global, Product, or Shipping
			
			"shippingAmount" => $order->shippingAmount,
			"handlingSeparated" => $order->handlingSeparated, 
			"handlingAmount" => $order->handlingAmount,
			"taxAmount" => $order->taxAmount,
			"giftCertificateAmount" => $order->gift_cert_amount,
			"totalAmount" => $order->totalAmount
		);
		
		// Assign variables
		$opcData = array(
			"orderNumber" => intval($order->order_num),
			"orderData" => $orderData,
			"expressCheckout" => intval($user->express),
			"billingIsEmpty" => $billingIsEmpty || $additionalIsEmpty,
			"billingData" => $billingData,
			"shippingIsFree" => intval($order->shippingIsFree),
			"shippingIsEmpty" => intval($shippingIsEmpty),
			"shippingShowAlternativeOnFree" => strtolower($settings["ShippingShowAlternativeOnFree"]) == "yes" ? true : false,
			"shippingIsDigital" => intval($order->shippingDigital),
			"shippingAddressId" => $shippingAddressId,
			"shippingMethodId" => $shippingMethodId,
			"shippingAddress" => $shippingAddress,
			"shippingAddressBook" => $shippingAddressBook,
			"shippingWithoutMethod" => strtolower($settings["ShippingWithoutMethod"]) == "yes",
			"shippingEnabled" => strtolower($settings["ShippingCalcEnabled"]) == "yes",
			"paymentMethodsCount" => count($payment->methods),
			"paymentMethods" => $payment->methods,
			"paymentMethodId" => $paymentMethodId,
			"paymentFormValidatorJS" => '',
			"paymentError" => $payment->is_error ? $payment->error_message : false,
			"giftCertificateEnabled" => strtolower($settings['enable_gift_cert']) == "yes",
			"promoAvailable" => strtolower($settings["DiscountsPromo"]) == "yes",
			"promoCode" => isset($_SESSION["order_promo_code"]) ? $_SESSION["order_promo_code"] : "",
			"currentCurrency" => $_SESSION["current_currency"],
			"displayPricesWithTax" => strtolower($settings["DisplayPricesWithTax"]) == "yes"
		);
		
		view()->assign("opcData", json_encode($opcData));
		
		view()->assign("body", "templates/pages/checkout/opc.html");
	}
	else
	{
		header("Location: ".$url_dynamic."p=cart");
	}