<?php
/**
 * Show users payment_profiles
 */

if (!defined("ENV")) exit();

if ($user->auth_ok)
{
	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));
	
	$months = array();
	for ($k = 1; $k <= 12; $k++)
	{
		$months[($k < 10 ? '0'.$k : $k)] = $k;
	}
	view()->assign('cc_expiration_months', $months);

	$years = array();
	for ($k = date("Y"); $k <= date("Y")+10; $k++)
	{
		$years[] = $k;
	}
	view()->assign('cc_expiration_years', $years);
	
	if ($ua == USER_UPDATE_PAYMENT_PROFILE)
	{
		//TODO: Need to return error messages
		view()->assign("edit_profile", $_POST["form"]);
		$profile = $_POST["form"];
		view()->assign('profile_id', $_REQUEST['profile_id']);
		view()->assign('payment_id', $_POST['form']['pid']);
		view()->assign('ext_profile_id', $_POST['form']['ext_profile_id']);
		view()->assign('is_primary', strtolower($_POST['form']['is_primary']) == 'on');
	}
	else
	{
		$db->query("SELECT upp.*, pm.id, pm.class FROM ".DB_PREFIX."users_payment_profiles upp
			INNER JOIN ".DB_PREFIX."payment_methods pm ON upp.pid = pm.pid AND pm.active='Yes' WHERE upp.uid=".$db->escape($user->id)." AND upp.usid=".$db->escape($_GET['profile_id']));
	
		$profile = false;
		if ($db->moveNext())
		{
			if ($db->col['class'] != '')
			{
				view()->assign('payment_id', $db->col['pid']);
				view()->assign('is_primary', $db->col['is_primary'] == 'Yes');
				view()->assign('ext_profile_id', $db->col['ext_profile_id']);
	
				require_once('content/engine/payment/payment_'.$db->col['id'].'.php');
				$gw_temp = new $db->col['class'];
	
				$profile = $gw_temp->getPaymentProfileDetails($db, $db->col['ext_profile_id']);
				$profile['cc_number'] = str_pad('', 12, 'X').substr($profile['cc_number'], 12, 4);
	
				view()->assign('profile_id', $_REQUEST['profile_id']);
				view()->assign('edit_profile', $profile);
				
				$payment_form = $gw_temp->getPaymentForm($db);
			}
		}
	}
	view()->assign('USER_UPDATE_PAYMENT_PROFILE', USER_UPDATE_PAYMENT_PROFILE);
	if ($profile)
	{
		view()->assign("body", "templates/pages/account/payment-profile-edit.html");
	}
	else
	{
		view()->assing("body", "templates/pages/account/auth-error.html");
	}
}
else
{
	view()->assign("body", "templates/pages/account/auth-error.html");
}