<?php
/**
 * Show product page
 */

if (!defined("ENV")) exit();

$is_print_version = isset($_REQUEST["is_print_version"]) ? $_REQUEST["is_print_version"] : false;
$id = !empty($_REQUEST["id"])?intval($_REQUEST["id"]):"0";

$parent = 0;

$oa_quantity = isset($_REQUEST["oa_quantity"]) ? intval($_REQUEST["oa_quantity"]) : 0;

require_once("content/classes/class.products.php");
	
$products = new ShoppingCartProducts($db, $settings);
$products->parent = $parent;
$products->taxRates = $order->taxRates;
$product = $products->getProductById($id, $user->level, $parent);
	
if($product)
{
	// inventory by tracking
	if ($product["inventory_control"] == "AttrRuleExc" || $product["inventory_control"] == "AttrRuleInc")
	{
		// store temporary copy of hash
		$inventory_hashes = array();
		$inventory_stock = array();
		
		if (!empty($product['inventory_hashes']))
		{
			foreach ($product['inventory_hashes'] as $_inventory_hash)
			{
				$inventory_hashes[] = $_inventory_hash['attributes_list'];
				$inventory_stock[$_inventory_hash['attributes_list']] = $_inventory_hash['stock'];
			}
			unset($_inventory_hash);
		}
		
		// loop through each attribute
		foreach ($product['attributes'] as $attributes_key => $attributes)
		{
			// loop through attribute options
			foreach ($attributes['options'] as $key => $attribute_option)
			{
				$option_hash = $attributes['name'].': '.$attribute_option['name'];
				switch ($product['inventory_control'])
				{
					case 'AttrRuleExc':
					{
						if (count($product['attributes']) == 1)
						{
							if (!in_array($option_hash, $inventory_hashes) || ($product["inventory_rule"] == 'Hide' && intval($inventory_stock[$option_hash]) == 0))
							{
								unset($product['attributes'][$attributes_key]['options'][$key]);
							}
							//TODO: Check is break in right place - may effect attributes
							break;
						}
					}
					case 'AttrRuleInc':
					{
						if ($product["inventory_rule"] == 'Hide' && isset($inventory_stock[$option_hash]) && intval($inventory_stock[$option_hash]) == 0)
						{
							unset($product['attributes'][$attributes_key]['options'][$key]);
						}
							if (!in_array($option_hash, $inventory_hashes) && $product["out_of_stock"] == 1)
						{
							$product["out_of_stock"] = 0;
						}
						break;
					}
				}
			}
				// if there are no attributes left from inventory tracking, remove from attributes array
			if (!count($product['attributes'][$attributes_key]['options']))
			{
				unset($product['attributes'][$attributes_key]);
			}
		}
	}
	
	$parent = $parent > 0 ? $parent : intval($product["cid"]);
	view()->assign("product", $product);
	view()->assign("product_families", $products->getProductFamilies($id, $user->level));
	view()->assign("free_products", $products->getFreeProducts($id, $user->level));
	
	// product reviews smarty vars
	$reviews = new Ddm_Product_Reviews();
	$product_rating = $reviews->getProductRating($product['pid']);
	
	view()->assign('reviews', $reviews->getReviews($product['pid']));
	view()->assign('product_rating', round($product_rating['rating'], 1));
	view()->assign('product_rating_total', $product_rating['total_reviews']);
	view()->assign('has_written_review', 0);//$reviews->hasWrittenReview($product['pid'], $user->id));
	
	if ($settings["SearchAutoGenerate"] == "YES")
	{
		$meta_title = $product["title"].": ".$meta_title;
		$meta_keywords .= ", ".$product["title"];
		if(trim($product["overview"]) != ""){
			$meta_description = str_replace("\r", "", str_replace("\n", "", str_replace('"', "", str_replace("'", " ", strip_tags($product["overview"])))));
		}
			
		//new changes
		$meta_title = trim($product["meta_title"]) == "" ? $meta_title : $product["meta_title"];
		$meta_keywords = trim($product["meta_keywords"]) == "" ? $meta_keywords : $product["meta_keywords"];
		$meta_description = trim($product["meta_description"]) == "" ? $meta_description : $product["meta_description"];
	}
	
	if ($parent == "0") $parent = $product["cid"];
	
	view()->assign("parent_id", isset($parent_id) ? $parent_id : "");
	view()->assign("oa_quantity", $oa_quantity);
	view()->assign("page_nav", $categories->getParsedPath($parent));
	view()->assign("body", "templates/pages/product/views/".strtolower($settings["CatalogProductPage"]).".html");
	view()->assign("item_link", $product["url"]);
	view()->assign("zoom_option", $zoom_option = $settings["ZoomOption"]);
	view()->assign("zoom_option_secondary", $settings["ZoomOptionSecondary"]);
	view()->assign("weight_unit", $settings["LocalizationWeightUnits"]);
	view()->assign("separating_symbol", $settings["LocalizationCurrencySeparatingSymbol"]);
	
	$recentItems->add($product["url"], $product["title"]);
	
	LogStatistics($db, $user->id, "product", $id, $product["title"]);
}
else
{
	LogStatistics($db, $user->id, "other", 0, "");
	header("Location: ".$settings["GlobalHttpUrl"]."/index.php?p=404");
	session_write_close();
	die();
}

