<?php
/**
 * Show product page
 */

	if (!defined("ENV")) exit();
	
	$id = !empty($_REQUEST["id"]) ? intval($_REQUEST["id"]) : "0";
	
	$parent = 0;
	
	$oa_quantity = isset($_REQUEST["oa_quantity"]) ? intval($_REQUEST["oa_quantity"]) : 0;
	
	require_once("content/classes/class.products.php");
	
	$userLevel = ($user->auth_ok) ? ($user->level) : ($userCookie ? $userCookie["l"] : 0);
		
	$products = new ShoppingCartProducts($db, $settings);
	$products->parent = $parent;
	$products->taxRates = $order->taxRates;
	$product = $products->getProductById($id, $userLevel, $parent);
		
	if($product)
	{
		$parent = intval($product["cid"]);

		$products->cleanupSubProducts($product);

		view()->assign("product", $product);

		view()->assign("canonical_url", getProductUrl($product["url_custom"] == "" ? $product["url_default"] : $product["url_custom"], $product['pid']));

		
		view()->assign("product_attributes_json", json_encode(isset($product["attributes"]) ? array_values($product["attributes"]) : false));
		view()->assign("product_inventory_hashes_json", json_encode(isset($product["inventory_hashes"]) ? $product["inventory_hashes"] : false));
		
		view()->assign("product_families", $products->getProductFamilies($id, $userLevel));
		view()->assign("product_siblings", $products->getProductSiblings($id, $userLevel, $parent, $settings["SiblingProductsCount"]));
		view()->assign("free_products", $products->getFreeProducts($id, $userLevel));
		
		// product reviews smarty vars
		$reviews = new Ddm_Product_Reviews();
		$product_rating = $reviews->getProductRating($product['pid']);
		
		view()->assign('reviews', $reviews->getReviews($product['pid']));
		view()->assign('product_rating', round($product_rating['rating'], 1));
		view()->assign('product_rating_total', $product_rating['total_reviews']);
		view()->assign('has_written_review', 0);//$reviews->hasWrittenReview($product['pid'], $user->id));
		
		if ($settings["SearchAutoGenerate"] == "YES")
		{
			$meta_title = $product["title"].": ".$meta_title;
			$meta_keywords .= ", ".$product["title"];
			if (trim($product["overview"]) != "")
			{
				$meta_description = str_replace("\r", "", str_replace("\n", "", str_replace('"', "", str_replace("'", " ", strip_tags($product["overview"])))));
			}
			//new changes
			$meta_title = trim($product["meta_title"]) == "" ? $meta_title : $product["meta_title"];
			$meta_keywords = trim($product["meta_keywords"]) == "" ? $meta_keywords : $product["meta_keywords"];
			$meta_description = trim($product["meta_description"]) == "" ? $meta_description : $product["meta_description"];
		}
		
		view()->assign("parent_id", isset($parent_id) ? $parent_id : "");
		view()->assign("oa_quantity", $oa_quantity);
		view()->assign("page_nav", $categories->getParsedPath($parent));
		view()->assign("body", "templates/pages/product/views/".(MOBILE ? 'mobile' : strtolower($settings["CatalogProductPage"])).".html");
		view()->assign("item_link", $product["url"]);
		view()->assign("zoom_option", $zoom_option = $settings["ZoomOption"]);
		view()->assign("zoom_option_secondary", $settings["ZoomOptionSecondary"]);
		view()->assign("weight_unit", $settings["LocalizationWeightUnits"]);
		view()->assign("separating_symbol", $settings["LocalizationCurrencySeparatingSymbol"]);
		
		$recentItems->add($product["url"], $product["title"]);
		
		LogStatistics($db, $user->id, "product", $id, $product["title"]);
	}
	else
	{
		LogStatistics($db, $user->id, "other", 0, "");
		header("Location: ".$settings["GlobalHttpUrl"]."/index.php?p=404");
		_session_write_close();
		die();
	}

