<?php
/**
 * Get order shipping quote
 */

if (!defined("ENV")) exit();

$sq_country = isset($_POST["sq_country"]) ? intval($_POST["sq_country"]) : "";
$sq_state = isset($_POST["sq_state"]) ? intval($_POST["sq_state"]) : "";
$sq_zip = isset($_POST["sq_zip"]) ? trim($_POST["sq_zip"]) : "";
	
if ($sq_country == "" || $sq_zip == "")
{
	if ($user->auth_ok)
	{
		$order->getShippingAddress();
		if ($order->shippingAddress["country_id"] > 0 && trim($order->shippingAddress["zip"]) != "")
		{
			$sq_country = $order->shippingAddress["country_id"];
			$sq_state = $order->shippingAddress["state_id"];
			$sq_zip = $order->shippingAddress["zip"];
		}
		elseif (isset($user->data["country"]) && isset($user->data["state"]) && isset($user->data["zip"]))
		{
			$sq_country = $user->data["country"];
			$sq_state = $user->data["state"];
			$sq_zip = $user->data["zip"];
		}
	}
	else
	{
		$sq_country = $settings["ShippingOriginCountry"];
	}
}

if (isset($_REQUEST["get_shipping_quote"]))
{
	view()->assign("show_shipping_quote", true);
	
	$shipping_quote_address = array(
		"country_id" => $sq_country,
		"state_id" => $sq_state, 
		"shipping_zip" => $sq_zip
	);
	$r = getShippingQuotes($db, $user, $order, true, $shipping_quote_address);
	
	view()->assign("shipping_is_free", $order->shippingIsFree);

	if ($settings["ShippingCalcEnabled"] != "YES" || ($order->shippingCarrierID == "custom" && $order->shippingMethodID == "free"))
	{
		$next_step = "shipping_method";
		$order->closeShipping();
	}
	else
	{
		$next_step = "shipping_method";
	}
	view()->assign("show_continue_button", $r["shipping_methods_count"] > 0 || $r["shipping_price_at_product_level"] > 0 || $settings["ShippingWithoutMethod"] == "YES");
}
else
{
	view()->assign("show_shipping_quote", false);
}

//country / state data
require_once("content/classes/class.regions.php");
$regions = new Regions($db);
$countries_states = $regions->getCountriesStatesForSite();
view()->assign("countries_states", $countries_states);
	
view()->assign("sq_country", $sq_country);
view()->assign("sq_state", $sq_state);
view()->assign("sq_zip", $sq_zip);
	
view()->assign("body", "templates/pages/checkout/shipping-quote.html");
