<?php
/**
 * Get order shipping quote
 */

	if (!defined("ENV")) exit();

	/**
	 * Check variable
	 */
	$sq_country = isset($_POST["sq_country"]) ? intval($_POST["sq_country"]) : "";
	$sq_state = isset($_POST["sq_state"]) ? intval($_POST["sq_state"]) : "";
	$sq_zip = isset($_POST["sq_zip"]) ? trim($_POST["sq_zip"]) : "";

	/**
	 * Prepare address
	 */
	if ($sq_country == "" || $sq_zip == "")
	{
		if ($user->auth_ok)
		{
			$order->getShippingAddress();
			if ($order->shippingAddress["country_id"] > 0 && trim($order->shippingAddress["zip"]) != "")
			{	
				$sq_country = $order->shippingAddress["country_id"];
				$sq_state = $order->shippingAddress["state_id"];
				$sq_zip = $order->shippingAddress["zip"];
			}
			elseif (isset($user->data["country"]) && isset($user->data["state"]) && isset($user->data["zip"]))
			{	
				$sq_country = $user->data["country"];
				$sq_state = $user->data["state"];
				$sq_zip = $user->data["zip"];
			}
		}
		else
		{
			$sq_country = $settings["ShippingOriginCountry"];
		}
	}

	/**
	 * Get shipping quote
	 */
	if (isset($_REQUEST["get_shipping_quote"]))
	{
		view()->assign("show_shipping_quote", true);
	
		if ($order->itemsCount > 0)
		{
			
			$db->query("
				SELECT 
					'John Doe' AS name,
					'Some Company, LLC' AS company,
					'123 Some Street' AS address1,
					'' AS address2,
					'Bestcity' AS city,
					".DB_PREFIX."countries.coid AS country_id,
					".DB_PREFIX."countries.name AS country,
					".DB_PREFIX."countries.name AS country_name,
					".DB_PREFIX."countries.iso_a2 AS country_iso_a2,
					".DB_PREFIX."countries.iso_a3 AS country_iso_a3,
					".DB_PREFIX."countries.iso_number AS country_iso_number,
					".DB_PREFIX."states.short_name AS state_abbr,
					".DB_PREFIX."states.name AS state,
					".DB_PREFIX."states.name AS province,
					".DB_PREFIX."states.stid AS state_id
				FROM ".DB_PREFIX."countries, ".DB_PREFIX."states
				WHERE ".DB_PREFIX."countries.coid = ".intval($sq_country)." AND ".DB_PREFIX."states.stid = ".intval($sq_state)."
			");
			if ($db->moveNext(false, MYSQL_ASSOC))
			{
				$shipping_quote_address = $db->col;
			}
			else
			{
				$shipping_quote_address = array(
					"country_id" => $sq_country,
					"state_id" => $sq_state, 
				);
			}

			$shipping_quote_address["shipping_zip"] = $sq_zip;
			$shipping_quote_address["zip"] = $sq_zip;
			
			/**
	 		 * Get shipping rates
	 		 */
			$rates = false;
			$ratesA = false;
			if ($order->shippingIsFree)
			{	
				if ($settings["ShippingShowAlternativeOnFree"] == "YES")
				{
					$ratesA = getShippingQuotes($db, $user, $order, true, $shipping_quote_address, true);
				}
			}
			else
			{
				$rates = getShippingQuotes($db, $user, $order, true, $shipping_quote_address, false);
				// show alternative shipping methods for free shipping products
				if ($settings["ShippingShowAlternativeOnFree"] == "YES" && $order->shippingFreeProductsCount > 0)
				{
					$ratesA = getShippingQuotes($db, $user, $order, true, $shipping_quote_address, true);
					$ratesA = filterAlternativeShippingQuotes($rates, $ratesA);
				}
			}

			if (!$order->shippingIsFree || $ratesA["shipping_methods_count"])
			{
				view()->assign("shippingMethods", $rates && is_array($rates) ? $rates : false);
				view()->assign("shippingMethodsAlternative", $ratesA && is_array($ratesA) ? $ratesA : false);
				view()->assign("shipping_is_free", $order->shippingIsFree);
			}
		}
	}
	else
	{
		view()->assign("show_shipping_quote", false);
	}

	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	$countries_states = $regions->getCountriesStatesForSite();
	view()->assign("countries_states", $countries_states);
	
	view()->assign("sq_country", $sq_country);
	view()->assign("sq_state", $sq_state);
	view()->assign("sq_zip", $sq_zip);
	view()->assign("body", "templates/pages/checkout/shipping-quote.html");
