<?php
/**
 * Testimonials page
 */ 

if (!defined("ENV")) exit();
if ($settings["testimonials_Enabled"] == "Yes")
{

	if (!isset($cartPlugins) || !is_object($cartPlugins))
	{
		require_once("content/classes/class.plugins.php");
		$cartPlugins = new cartPlugins("content/admin/plugins");
	}
	
	$objTestimonials = $cartPlugins->getPluginObject('testimonials');
	$objTestimonials->setupPlugin($db);

	if (isset($_REQUEST["submitTestimonial"]))
	{
		// save testimonial
		$error = false;
		
		$testimonial = isset($_POST["testimonial"]) ? (is_array($_POST["testimonial"]) ? $_POST["testimonial"] : array()) : array();
		
		if (!isset($testimonial["name"]) || !validate($testimonial["name"], VALIDATE_NAME)) $error = true;
		if ($settings['testimonials_Use_Rating'] == 'Yes' && (!isset($testimonial["rating"]) || !validate($testimonial["rating"], VALIDATE_DECIMAL))) $error = true;
		if (!isset($testimonial["testimonial"]) || !validate($testimonial["testimonial"], VALIDATE_NOT_EMPTY)) $error = true;
		
		if ($settings['captchaMethod'] != 'None' && $settings['testimonials_Use_Captcha'] == 'Yes')
		{
			require_once('content/vendors/recaptcha/recaptchalib.php');
			$resp = recaptcha_check_answer(
				$settings['captchaReCaptchaPrivateKey'],
				$_SERVER["REMOTE_ADDR"],
				$_POST["recaptcha_challenge_field"],
				$_POST["recaptcha_response_field"]
			);
			if (!$resp->is_valid) $error = true;
		}
	
		if (!$error)
		{
			if ($settings['testimonials_Use_Rating'] != 'Yes') $testimonial["rate"] = 10;
			$testimonial['status'] = 'pending';
			$objTestimonials->saveTestimonial($testimonial);
			view()->assign('testimonialSubmited', true);
		}
		else
		{
			view()->assign('testimonialError', true);
			view()->assign('testimonialToEdit', $testimonial);
		}
	}

	// view testimonials
	$perPage = intval($settings['testimonials_Per_Page']);
	if (isset($_REQUEST["start"]))
	{
		$start = intval($_REQUEST["start"]);
	}
	else
	{
		$start = 0;
	}
	
	$testimonials = $objTestimonials->getTestimonials($start,$perPage,'approved');
	view()->assign('testimonials', $testimonials);

	if ($objTestimonials->totalTestimonials > $perPage+$start)
	{
		view()->assign('nextLink','index.php?p=testimonials&start='.($start+$perPage));
	}
	
	if ($start != 0)
	{
		view()->assign('prevLink','index.php?p=testimonials&start='.($start-$perPage));
	}
	
	if ($settings['testimonials_Use_Rating'] == 'Yes')
	{
		$rating = $objTestimonials->getRating();
		view()->assign('rating',$rating);
	}

	view()->assign('starFull', $objTestimonials->getImage('full'));
	view()->assign('starHalf', $objTestimonials->getImage('half'));
	view()->assign('starEmpty', $objTestimonials->getImage('empty'));
	
	if ($settings['captchaMethod'] != 'None' && $settings['testimonials_Use_Captcha'] == 'Yes')
	{
		require_once('content/vendors/recaptcha/recaptchalib.php');
		view()->assign('captcha', recaptcha_get_html($settings['captchaReCaptchaPublicKey']));
	}
	
	view()->assign('body', 'templates/pages/site/testimonials.html');
}
else
{
	header("Location: ".$settings["GlobalHttpUrl"]."/index.php?p=404");
	_session_write_close();
	die();
}
