<?php
/**
 * 
 * @param $params
 * @param $smarty
 * @return string
 */
function smarty_function_meta($params, &$smarty)
{
	/**
	 * save meta data into static var
	 */
	if (is_array($params) && count($params) > 0)
	{
		
		if (!array_key_exists("name", $params) && !array_key_exists("http-equiv", $params))
		{
			view()->trigger_error("meta: name or http-equiv param missed");
			return;
		}
		if (!array_key_exists("content", $params))
		{
			view()->trigger_error("meta: content param missed");
			return;
		}
		
		// check if this is an http-equiv metatag
		$is_equiv = false;
		if (array_key_exists('http-equiv', $params))
		{
			$is_equiv = true;
			$params['name'] = $params['http-equiv'];
		}
		
		view()->appendMetatag($params['name'], $params['content'], $is_equiv);
		return "";
	}
	
	/**
	 * otherwise render metas html code 
	 */
	return "\r\n".implode("\r\n", view()->getMetatags());
}