<?php

class core_Form_MultiSelectField extends core_Form_SelectField
{
	protected $values = array();

	public function getValues()
	{
		return $this->values;
	}
	public function setValues($values)
	{
		$this->values = $values;
	}

	public function getType()
	{
		return 'multiselect';
	}

	public function getCssClass()
	{
		$class = parent::getCssClass();

		$class .= ' multi';

		return $class;
	}

	public function bindValue($value)
	{
		$this->setValues($values);
	}

	public function getData()
	{
		return $this->getValues();
	}

	public static function createFromFormBuilder($name, $options = array())
	{
		core_Form_Field::setDefaults($options);

		$defaults = array(
			'options' => array(),
			'empty_value' => null,
		);

		$options = array_merge($defaults, $options);

		$field = new core_Form_MultiSelectField(
			$name, $options['label'], $options['value'], $options['required'], 
			$options['lockable'], $options['lockName'], $options['tooltip'], $options['note'],
			$options['attr'], $options['wrapperClass'], $options['readonly']
		);

		if ($options['empty_value'] != null)
		{
			$keys = array_keys($options['empty_value']);

			$value = $keys[0];
			$label = $options['empty_value'][$value];

			$field->addOption(new core_Form_Option($value, $label));
		}
		$field->addOptions($options['options']);

		return $field;
	}
}