<?php

	/**
	 * Do not cache output
	 */
	header("Cache-Control: private");
	header("Content-Type: text/html");
	
	
	//or, if you DO want a file to cache, use:
	header("Cache-Control: max-age=2592000");

	define("ENV", true);
	
	require_once("content/engine/engine_config.php");
	require_once("content/engine/engine_label.php");
	require_once("content/engine/engine_functions.php");
	require_once("content/engine/engine_mysql.php");
	require_once("content/engine/engine_tree.php");
	require_once("content/engine/engine_wishlist.php");
	require_once("content/engine/engine_images.php");
	require_once("content/classes/class.json.php");
	require_once("content/classes/class.xml.php");
	require_once("content/admin/admin_config.php");
	

	/**
	 * Create main database connection
	 */
	$db = new DB;
	$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
	
	/**
	 * Load site settings in $settings array
	 */
	require_once("content/engine/engine_settings.php");
	
	//print_r($settings);die();
	/**
	 * Mailchimp stuff
	 */
	if ($settings["mailchimp_e360"] == "1")
	{
		$thirty_days = time()+60*60*24*30;
		if (isset($_REQUEST['mc_cid'])) setcookie('mailchimp_campaign_id', trim($_REQUEST['mc_cid']), $thirty_days);
		if (isset($_REQUEST['mc_eid'])) setcookie('mailchimp_email_id', trim($_REQUEST['mc_eid']), $thirty_days);
	}
 	
	/**
	 * Resolve magic quotes
	 */
	if (get_magic_quotes_gpc() || $settings["ForceStripSlashes"] == "Yes")
	{
		strips($_POST);
		strips($_GET);
		strips($_REQUEST);
	}
	
	if (isset($_GET["url"])) require_once("content/engine/engine_url_parser.php");
	
	/**
	 * TODO: buysafe
	if ($settings["buysafe_active"] == "Yes") require_once("content/classes/class.buysafe.php");
	 */

	/**
	 * Start session
	 */
	$userCookie = false;
	//echo $_COOKIE["_pcud"];
	if (isset($_COOKIE["_pcud"]))
	{
		$userCookie = unserialize(base64_decode($_COOKIE["_pcud"]));
		//print_r($userCookie) ;
		if (!$userCookie || !is_array($userCookie)) $userCookie = false;
		if ($userCookie)
		{
			$db->query("SELECT * FROM ".DB_PREFIX."users WHERE uid='".$db->escape($userCookie["i"])."' AND level='".$db->escape($userCookie["l"])."' AND MD5(session_id)='".(isset($userCookie["s"]) ? $db->escape($userCookie["s"]) : '')."'");
			if (!$db->moveNext()) $userCookie = false;
		}
	}
	
	$session_dir = "content".DS."cache".DS."sessiondata";
	if (is_dir($session_dir) && is_writable($session_dir))
	{
		ini_set("session.save_path", $settings["GlobalServerPath"].DS.$session_dir);
	}
	
	/**
	 * Handle session in HTTPS mode
	 */
	$isDesignMode = false;
	if ((isset($_COOKIE["_admc"]) && $_COOKIE["_admc"] == "true") || isset($_GET["_admc"]) || isset($_POST["_admc"]))
	{
		$isDesignMode = true;
		$_COOKIE["_admc"] = "true";
		setcookie("_admc", "true", time() + 60*60, "/");
	}
	else
	{
		$isDesignMode = false;
	}
	
	define('DESIGN_MODE', $isDesignMode ? true : false);
	
	/**
	 * Handle session
	 */
	$pcsid = isset($_REQUEST["pcsid"]) ? $_REQUEST["pcsid"] : false;
	if ($pcsid && preg_match("/[0-9a-zA-Z]{1,}/", $pcsid)) session_id($pcsid);
	if (isset($_GET["_pcod"]))
	{
		setcookie("_pcod", $_GET["_pcod"], time() + 60*60*24*30*6, "/");
		$_COOKIE["_pcod"] = $_GET["_pcod"]; 
	}
	
	$host = parse_url($_SERVER["SERVER_PORT"] == 443 ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"], PHP_URL_HOST);
	if ($host != "localhost")
	{
		session_set_cookie_params($settings["SecurityUserTimeout"], "/", $host);
	}
	else
	{
		session_set_cookie_params($settings["SecurityUserTimeout"], "/");
	}
	session_cache_expire(round($settings["SecurityUserTimeout"]/60)); 
	session_name($isDesignMode ? "ShoppingCartSessionAdmin"  : "ShoppingCartSession");
	session_start();
	
	/**
	 * DEMO Mode
	 */
	if ($settings["FrontEndDemo"] == "Yes")
	{
		if (!defined("DEMO_MODE")) define("DEMO_MODE", true);
		if (!defined("DEMO_LOCK")) define("DEMO_LOCK", true);
		
		$demoModeSkins = array(
			"BigDesign"=>"BigBlue Design",
			"BlueGreen"=>"Blue Green",
			"ModernVista"=>"Modern Vista",
			"NewOrange"=>"New Orange",
			"SimpleGreen"=>"Simple Green",
			"Template3700"=>"Template 3700",
			"Template3701"=>"Template 3701",
			"Template3702"=>"Template 3702",
			"Template3703"=>"Template 3703",
			"Template3704"=>"Template 3704",
			"Template3705"=>"Template 3705",
			"Template3706"=>"Template 3706",
			"Template3707"=>"Template 3707",
			"Template3708"=>"Template 3708",
			"Template3709"=>"Template 3709"
		);
		
		//Set new skin
		if (isset($_REQUEST["demoModeSetSkin"]) && array_key_exists($_REQUEST["demoModeSetSkin"], $demoModeSkins))
		{
			$settings['DesignSkinName'] = $_REQUEST["demoModeSetSkin"];
			$_SESSION['demoModeSkin'] = $_REQUEST["demoModeSetSkin"];
		}
		
		//Get current skin
		$settings['DesignSkinName'] = $sn = isset($_SESSION["demoModeSkin"]) ? $_SESSION["demoModeSkin"] : $settings['DesignSkinName'];
		
		$demoModeSkinsSettings = array(
			"BigDesign"=>array("width"=>"doc1024x768C", "layout"=>false),
			"BlueGreen"=>array("width"=>"doc1024x768C", "layout"=>false),
			"ModernVista"=>array("width"=>"doc1024x768C", "layout"=>false),
			"NewOrange"=>array("width"=>"doc1024x768C", "layout"=>'a:1:{s:5:"pages";a:9:{s:7:"_global";a:1:{s:5:"zones";a:2:{s:4:"left";a:4:{i:0;a:2:{s:5:"class";s:39:"element_panels_panel-catalog-categories";s:4:"file";s:46:"templates/panels/panel-catalog-categories.html";}i:1;a:2:{s:5:"class";s:42:"element_panels_panel-catalog-manufacturers";s:4:"file";s:49:"templates/panels/panel-catalog-manufacturers.html";}i:2;a:2:{s:5:"class";s:42:"element_panels_panel-newsletters-subscribe";s:4:"file";s:49:"templates/panels/panel-newsletters-subscribe.html";}i:3;a:2:{s:5:"class";s:36:"element_panels_panel-account-profile";s:4:"file";s:43:"templates/panels/panel-account-profile.html";}}s:5:"right";a:2:{i:0;a:2:{s:5:"class";s:34:"element_panels_panel-checkout-cart";s:4:"file";s:41:"templates/panels/panel-checkout-cart.html";}i:1;a:2:{s:5:"class";s:35:"element_panels_panel-catalog-search";s:4:"file";s:42:"templates/panels/panel-catalog-search.html";}}}}s:7:"catalog";a:1:{s:5:"zones";a:1:{s:4:"left";a:4:{i:0;a:2:{s:5:"class";s:39:"element_panels_panel-catalog-categories";s:4:"file";s:46:"templates/panels/panel-catalog-categories.html";}i:1;a:2:{s:5:"class";s:42:"element_panels_panel-catalog-manufacturers";s:4:"file";s:49:"templates/panels/panel-catalog-manufacturers.html";}i:2;a:2:{s:5:"class";s:42:"element_panels_panel-newsletters-subscribe";s:4:"file";s:49:"templates/panels/panel-newsletters-subscribe.html";}i:3;a:2:{s:5:"class";s:36:"element_panels_panel-account-profile";s:4:"file";s:43:"templates/panels/panel-account-profile.html";}}}}s:4:"cart";a:1:{s:5:"zones";a:0:{}}s:6:"signup";a:1:{s:5:"zones";a:1:{s:4:"left";a:4:{i:0;a:2:{s:5:"class";s:39:"element_panels_panel-catalog-categories";s:4:"file";s:46:"templates/panels/panel-catalog-categories.html";}i:1;a:2:{s:5:"class";s:42:"element_panels_panel-catalog-manufacturers";s:4:"file";s:49:"templates/panels/panel-catalog-manufacturers.html";}i:2;a:2:{s:5:"class";s:42:"element_panels_panel-newsletters-subscribe";s:4:"file";s:49:"templates/panels/panel-newsletters-subscribe.html";}i:3;a:2:{s:5:"class";s:36:"element_panels_panel-account-profile";s:4:"file";s:43:"templates/panels/panel-account-profile.html";}}}}s:28:"billing_and_shipping_address";a:1:{s:5:"zones";a:1:{s:4:"left";a:5:{i:0;a:2:{s:5:"class";s:39:"element_panels_panel-catalog-categories";s:4:"file";s:46:"templates/panels/panel-catalog-categories.html";}i:1;a:2:{s:5:"class";s:42:"element_panels_panel-catalog-manufacturers";s:4:"file";s:49:"templates/panels/panel-catalog-manufacturers.html";}i:2;a:2:{s:5:"class";s:42:"element_panels_panel-newsletters-subscribe";s:4:"file";s:49:"templates/panels/panel-newsletters-subscribe.html";}i:3;a:2:{s:5:"class";s:36:"element_panels_panel-account-profile";s:4:"file";s:43:"templates/panels/panel-account-profile.html";}i:4;a:2:{s:5:"class";s:34:"element_panels_panel-checkout-cart";s:4:"file";s:41:"templates/panels/panel-checkout-cart.html";}}}}s:15:"shipping_method";a:1:{s:5:"zones";a:0:{}}s:7:"invoice";a:1:{s:5:"zones";a:0:{}}s:17:"one_page_checkout";a:1:{s:5:"zones";a:0:{}}s:4:"home";a:1:{s:5:"zones";a:1:{s:4:"left";a:4:{i:0;a:2:{s:5:"class";s:39:"element_panels_panel-catalog-categories";s:4:"file";s:46:"templates/panels/panel-catalog-categories.html";}i:1;a:2:{s:5:"class";s:42:"element_panels_panel-catalog-manufacturers";s:4:"file";s:49:"templates/panels/panel-catalog-manufacturers.html";}i:2;a:2:{s:5:"class";s:42:"element_panels_panel-newsletters-subscribe";s:4:"file";s:49:"templates/panels/panel-newsletters-subscribe.html";}i:3;a:2:{s:5:"class";s:36:"element_panels_panel-account-profile";s:4:"file";s:43:"templates/panels/panel-account-profile.html";}}}}}}'),
			"SimpleGreen"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3700"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3701"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3702"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3703"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3704"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3705"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3706"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3707"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3708"=>array("width"=>"doc1024x768C", "layout"=>false),
			"Template3709"=>array("width"=>"doc1024x768C", "layout"=>false)
		);
		
		if ($demoModeSkinsSettings[$sn]["width"]) $settings["LayoutSiteWidth"] = $demoModeSkinsSettings[$sn]["width"];
		if ($demoModeSkinsSettings[$sn]["layout"]) $settings["LayoutElements"] = $demoModeSkinsSettings[$sn]["layout"];
		//set skin settings
		
		view()->assign("demoModeSkins", $demoModeSkins);
		view()->assign("demoModeCurrentSkin", $settings['DesignSkinName']);
	}
	else
	{
		if (!defined("DEMO_MODE")) define("DEMO_MODE", false);
		if (!defined("DEMO_LOCK")) define("DEMO_LOCK", false);	
	}
	
	/**
	 * Init XAJAX
	 */
	define('XAJAX_DEFAULT_CHAR_ENCODING', 'utf-8');
	require_once("content/vendors/ajax/xajax.inc.php");
	$xajax = new xajax("index.php?process_ajax_request=true");
	$xajax->setCharEncoding(XAJAX_DEFAULT_CHAR_ENCODING);
	$xajax->decodeUTF8InputOff();
	$xajax->debugOff();
	$xajax->registerFunction("processAjaxAction");

	/**
	 * Currency
	 */
	require_once("content/classes/class.currencies.php");
	$currencies = new Currencies($db);
	if (isset($_POST["set_current_currency"]))
	{
		$currencies->setCurrentCurrency(intval($_POST["set_current_currency"]));
	}
	else
	{
		$currencies->getCurrentCurrency();
	}
	
	if (!isset($_SESSION["default_currency"]))
	{
		$_SESSION["default_currency"] = $currencies->getDefaultCurrency();
	}

	// load localization procedures
	require_once("content/engine/engine_localization.php");
	require_once("content/engine/engine_url_".($settings["USE_MOD_REWRITE"]=="YES" ? "rewrite" : "default").".php");
	require_once("content/engine/engine_pages.php");
	require_once("content/engine/engine_notifications.php");
	require_once("content/engine/engine_payment.php");
	require_once("content/engine/engine_shipping.php");

	/**
	 * Current page
	 */
	$p = isset($_REQUEST["p"]) ? trim($_REQUEST["p"]) : "home";
	$p = preg_match("/^([a-z0-9_-])+$/", $p) ? $p : "home";
	
	
	// FIXME: do NOT commit the following line
	// if (array_key_exists('ddmskin', $_REQUEST)) $settings['DesignSkinName'] = $_REQUEST['ddmskin'];
	/**
	 * Init smarty
	 */
	view()->debugging = false;
	view()->use_sub_dirs = false;
	view()->assign("isDemoMode", DEMO_MODE);
	view()->assign("isDevMode", defined("DEVMODE") && DEVMODE);
	
	// FIXME: Assemble through backend only
	if (
		!is_dir('content/cache/skins/'.escapeFileName($settings['DesignSkinName'])) || 
		(isset($_SESSION['admin_auth_id']) && $_SESSION['admin_auth_id'] && isset($_SESSION['admin_design_mode']) && $_SESSION['admin_design_mode'])
		|| (defined("DEVMODE") && DEVMODE)
	)
	{
		view()->assemble('content'.DS.'cache'.DS.'skins'.DS.escapeFileName($settings['DesignSkinName']).DS);
	}
	
	
	

	/**
	 * Languages
	 */
	require_once("content/classes/class.languages.php");
	$languages = new Language($db);
	
	view()->assign("languages", $active_languages = $languages->getActiveLanguages());
	view()->assign("languages_count", count($active_languages));
	
	// check / set language for a first time
	if (!isset($_SESSION["current_language_id"]))
	{
		$def_lang = $languages->getDefaultLanguage();
		$_SESSION["current_language_id"] = $def_lang["language_id"];
	}
	//change current active language
	if (isset($_POST["set_language"]))
	{
		if (array_key_exists(intval($_POST["set_language"]), $active_languages))
		{
			$_SESSION["current_language_id"] = intval($_POST["set_language"]);
		}
	}	
	
	//check / set current active language
	$current_language = $languages->getActiveLanguageById($_SESSION["current_language_id"]);
	view()->assign("current_language", $current_language);
	view()->assign("msg", $msg = $languages->getDictionary($current_language["code"]));
	view()->prependJavascript($languages->getJavascriptCache($current_language["code"]));
		
	// pass settings to smarty
	foreach ($settings as $key=>$value) view()->assign($key, $value);

	// by default user is unknown
	view()->assign("user_cookie", $userCookie);
	view()->assign("auth_ok", "no");
	view()->assign("current_page", $p);
	
	view()->assign("url_admin", $settings["GlobalHttpsUrl"]);
	
	// Added url request uri
	view()->assign("url_request_uri", htmlentities($_SERVER['REQUEST_URI']));
	
	// load user and order
	require_once("content/engine/engine_user.php");
	require_once("content/engine/engine_order.php");

	// assign most used user and cart actions
	view()->assign("USER_EXPRESS_CHECKOUT", USER_EXPRESS_CHECKOUT);
	view()->assign("USER_START_CHECKOUT", USER_START_CHECKOUT);
	view()->assign("USER_LOGIN", USER_LOGIN);
	view()->assign("USER_LOGOUT", USER_LOGOUT);
	view()->assign("USER_PASSWORD_RESET", USER_PASSWORD_RESET);
	
	view()->assign("USER_NEW_PASSWORD", USER_NEW_PASSWORD);	
	view()->assign("USER_NEW_USERNAME", USER_NEW_USERNAME);
		
	view()->assign("USER_UPDATE_ADDRESS", USER_UPDATE_ADDRESS);
	view()->assign("USER_DELETE_ADDRESS", USER_DELETE_ADDRESS);
	view()->assign("USER_ADD_TO_WISHLIST", USER_ADD_TO_WISHLIST);
	view()->assign("USER_UPDATE_PROFILE", USER_UPDATE_PROFILE);
	view()->assign("USER_ADD_ADDRESS", USER_ADD_ADDRESS);
	view()->assign("ORDER_ADD_ITEM", ORDER_ADD_ITEM);
	view()->assign("ORDER_REMOVE_ITEM", ORDER_REMOVE_ITEM);
	view()->assign("ORDER_CLEAR_ITEMS", ORDER_CLEAR_ITEMS);
	view()->assign("ORDER_UPDATE_ITEMS", ORDER_UPDATE_ITEMS);
	view()->assign("ORDER_UPDATE_SHIPPING_METHOD", ORDER_UPDATE_SHIPPING_METHOD);
	view()->assign("ORDER_COMPLETE_ORDER", ORDER_COMPLETE_ORDER);
	view()->assign("ORDER_WISHLIST_TO_CART", ORDER_WISHLIST_TO_CART);
	view()->assign("ORDER_COMPLETE_ORDER", ORDER_COMPLETE_ORDER);
	view()->assign("ORDER_PROCESS_PAYMENT", ORDER_PROCESS_PAYMENT);
	view()->assign("ORDER_PROCESS_PAYMENT_VALIDATION", ORDER_PROCESS_PAYMENT_VALIDATION);
	view()->assign("ORDER_ADD_GIFT_CERT", ORDER_ADD_GIFT_CERT);
	view()->assign("ORDER_UPDATE_BILLING_AND_SHIPPING_ADDRESS", ORDER_UPDATE_BILLING_AND_SHIPPING_ADDRESS);
	
	
	view()->assign("ORDER_ONE_PAGE_CHECKOUT", ORDER_ONE_PAGE_CHECKOUT);
	view()->assign("ORDER_BILLING_AND_SHIPPING_ADDRESS", ORDER_BILLING_AND_SHIPPING_ADDRESS);
	

	view()->assign("ORDER_CONTINUE_SHOPPING", ORDER_CONTINUE_SHOPPING);
	view()->assign("ORDER_CHECK_PROMO", ORDER_CHECK_PROMO);
	
	//echo "<pre>";print_r($_SESSION);die;	
	
	/**
	 * Define page zones
	 */
	$pages_public = array(
		"home", "page", "catalog", "product", "cart", "site_map", "homeproductvideo",
		"login", "signup", "signup_new", "subscribe", "unsubscribe", "password_reset","reset","resetuser","username_ajax","temp","username_reset", "blocked", "completed",
		"email2friend", "makeanoffer", "ajaxcat", "requestinfo", "financevehicle", "financeform", "shipping_quote", "international", "wishlist", "manage_wishlist", "gift_certificate", "successregistration","my_equipments","my_equipment","my_equipment_visitor","box_quote","my_notification","my_inventory","pricedrop","emailpdfs",
		"testimonials", "smartsuggest", "404", "admin_product_process", "ajax","dealer_inquiries","contact_us", "contact-success","feedback","user_search"
	);
	$pages_public_only = array("!login", "!signup", "!password_reset","!reset","!resetuser","!temp", "blocked","!username_ajax");
	$pages_protected = array(
		"backup_restore","account", "profile", "orders", "order", "address_book", "address_edit",
		"billing_and_shipping_address", "shipping_method",
		"invoice", "payment_validation", "completed", "one_page_checkout"
	);
	$pages_for_https = array(
		"backup_restore","account", "profile", "orders", "order", 
		"billing_and_shipping_address", "shipping_method",
		"invoice", "payment_validation", "completed", "address_book", "address_edit", "one_page_checkout",
		"cart",	"login", "signup", "password_reset","reset","resetuser","temp","username_reset","username_ajax"
	);

	/**
	 * Prepare dynamic URLs engine
	 */
	if ($_SERVER["SERVER_PORT"] == 443)
	{
		if ($isDesignMode)
		{
			$url_dynamic = $url_http = $url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?_admc=true&";
		}
		else
		{
			$url_http = $settings["GlobalHttpUrl"]."/".$settings["INDEX"]."?";
			$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?";
			$url_dynamic = (isset($_SESSION["UserID"]) && intval($_SESSION["UserID"]) > 0 ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?";
		}
		$url_base = $settings["GlobalHttpsUrl"]."/";
	} 
	else
	{
		if ($isDesignMode)
		{
			$url_http = $url_dynamic = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?";
		
			if (parse_url($settings["GlobalHttpUrl"], PHP_URL_HOST) != parse_url($settings["GlobalHttpsUrl"], PHP_URL_HOST))
			{
				$_pcod = isset($_COOKIE["_pcod"]) ? ("&_pcod=".$_COOKIE["_pcod"]) : "";
				$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?pcsid=".session_id().$_pcod."&_admc=true&";
			}
			else
			{
				$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?_admc=true&";	
			}
			$url_base = $settings["GlobalHttpsUrl"]."/";
		}
		else
		{
			$url_http = $url_dynamic = $settings["GlobalHttpUrl"]."/".$settings["INDEX"]."?";
		
			if (parse_url($settings["GlobalHttpUrl"], PHP_URL_HOST) != parse_url($settings["GlobalHttpsUrl"], PHP_URL_HOST))
			{
				$_pcod = isset($_COOKIE["_pcod"]) ? ("&_pcod=".$_COOKIE["_pcod"]) : "";
				$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?pcsid=".session_id().$_pcod."&";
				
				//$_pcod = isset($_COOKIE["_pcod"]) ? ("_pcod=".$_COOKIE["_pcod"]) : "";
				//$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?".$_pcod."&";
			}
			else
			{
				$url_https = $settings["GlobalHttpsUrl"]."/".$settings["INDEX"]."?";	
			}
			$url_base = $settings["GlobalHttpUrl"]."/";
		}
	}
	
	$url_rel = $settings["INDEX"]."?";
	$url_checkout = $url_https."ua=".USER_START_CHECKOUT."&checkout_start_page=".$p;
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		view()->assign("url_http", $url_http);
	view()->assign("pageURL", $pageURL);
	view()->assign("url_https", $url_https);
	view()->assign("url_dynamic", $url_dynamic);
	view()->assign("url_dinamic", $url_dynamic); // backwards compatibility
	view()->assign("url_base", $url_base);
	view()->assign("url_rel", $url_rel);
	view()->assign("url_checkout", $url_checkout);
	view()->assign("url_ajax", $url_ajax = (isSslMode() ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"]) . '/'.$settings['INDEX'].'?pcsid='.session_id());
	view()->assign("url_ajax_admin", $url_ajax_admin = (isSslMode() ? $settings["GlobalHttpsUrl"] : $settings["GlobalHttpUrl"]));
	view()->assign("search_str2","Enter Keyword");
        view()->assign("equipment",0);
		view()->assign("dmp_SessionID",$_SESSION["SessionID"]);
		view()->assign('popup_display', $settings['PopupDisplay']);
		

        require_once("content/classes/class.catalog.php");
$catalog = new ShoppingCartCatalog($db);
//print_r($catalog->getCategories_home()); die();
view()->assign("categories_home", $catalog->getCategories_home());
	// gift certificates
	require_once("content/classes/class.gift_certificates.php");
	
	// custom fields
	require_once("content/classes/class.custom_fields.php");
	$customFields = new CustomFields($db);

	// load and start shopping cart engine
	require_once("content/engine/engine_logic.php");

	// handle ajax calls
	if (isset($_REQUEST["process_ajax_request"]))
	{		
		require_once("content/engine/engine_ajax_processor.php");
		$xajax->processRequests();
	}
	
	// check redirects and generate global back URL
	$backurl = isset($backurl) ? $backurl : "";
	
	//complete here in case of ajax or backurl
	if ($backurl != "" || isset($_REQUEST["process_ajax_request"]))
	{
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == 443 ? "https://" :"http://").$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		
		$_mysession = $_SESSION;
		foreach ($_mysession as $_mysessionvar=>$_mysessionkey)
		{
			$_SESSION[$_mysessionvar] = $_mysessionkey;
		}
		
		_session_write_close();
		
		if ($backurl != "") header("Location: ".$backurl."\n");
		die();
	}
	//print_r($user->data['fname']); die();
	// assign user security / order vars
	view()->assign("auth_ok", $user->auth_ok?"yes":"no");
	view()->assign("fname", $user->data['fname']);
	view()->assign("lname", $user->data['lname']);
	view()->assign("user_level", $user->auth_ok ? $user->level : (isset($userCookie) ? $userCookie["l"] : 0));
	view()->assign("auth_express", $user->express?"yes":"no");
	view()->assign("express_dmp", $user->express_dmp?"yes":"no");
	view()->assign("order", $order);
	view()->assign("order_items", $order->getOrderItems());

	foreach ($_GET as $_name => $_value)
	{
		if ($_name != "set_language")
		{
			$backurl .= urlencode($_name)."=".urlencode($_value)."&";
		}
	}
	view()->assign("backurl", $backurl);

	//////////////////////////////
	// HERE STARTS BLACK WOOD :)
	// I started to develop this application 5 years ago.
	// 5 years. It is pretty big kid now.
	
	//////////////////////////////////////////////////////////
	// DISPLAY PART

	//catalog menu	
	if (isset($_REQUEST["parent"]))
	{
		$parent = intval($_REQUEST["parent"]);
	}
	elseif ($settings["USE_MOD_REWRITE"] == "YES" && isset($_REQUEST["catalog_code"]))
	{
		$parts = explode("-", $_REQUEST["catalog_code"]);
		$parent = count($parts) == 3 ? intval($parts[1]) : "0";
	}
	else
	{
		$parent = "0";
	}
	//print_r($settings);die();
	require_once("content/classes/class.catalog.php");
        view()->assign("new_equip_count", $settings["menu_new_equip"]);
        view()->assign("used_equip_count", $settings["menu_used_equip"]);
	
	$categories = new ShoppingCartCatalog($db);
	$categories_tree = $categories->getParsedTree($parent, true);
	//print_r($categories_tree);
	
	#shree modified
	$used_equipment_visible="No";
	$new_equipment_visible="No";
	$material_equipment_visible="No";
		
	foreach($categories->tree as  $parentids)
	{
		if($parentids[cid]==1 && $parentids[is_visible]=="Yes") $used_equipment_visible='Yes';
		elseif($parentids[cid]==2 && $parentids[is_visible]=="Yes") $new_equipment_visible='Yes';
		elseif($parentids[cid]==68 && $parentids[is_visible]=="Yes") $material_equipment_visible='Yes';
		
	}
#shree modified	
	
	view()->assign("parent", $parent);
	view()->assign("categories", $categories->tree);
	#shree modified
	view()->assign("used_equipment_visible_new", $used_equipment_visible);
	view()->assign("new_equipment_visible_new", $new_equipment_visible);
	view()->assign("material_visible_new", $material_equipment_visible);
	#shree modified
	
    view()->assign("categories_count", count($categories->tree));
      // echo "<pre>"; print_r($categories->tree); exit;
	// added for new added categories
	if (isset($_REQUEST["parent_cat"]))
	{
		$parent_cat = intval($_REQUEST["parent_cat"]);
	}
	else
	{
		$parent_cat = "0";
	}
	$categories_new = new ShoppingCartCatalog($db);
	//var_dump($categories_new); 
	$categories_tree1 = $categories_new->getParsedTreeNew($parent_cat);
	//print_r($categories_tree1); 
	view()->assign("parent_cat", $parent_cat);
	view()->assign("categories_new", $categories_new->tree);
	
	// dmp code whishlist
	if($user->id != '0')
	{
		$wishlist_index = new WISHLIST($db, $user->id);
		//echo "<pre>";
		//print_r($wishlist_index->wishlistList_index);
		$dmp_index = $wishlist_index->wishlistList_index;
		$dmp_index_count = count($dmp_index);
		if($dmp_index_count != '0')
		{
			view()->assign("wish_lists_index", $dmp_index);
		}
		else
		{	
			view()->assign("wish_lists_index", 'no');
		}	
	}
	else
	{
		view()->assign("wish_lists_index", 'no');
	}
	
	//code ends
	//manufacturers
	if ($settings["CatalogManufacturers"] == "YES")
	{
		require_once("content/classes/class.manufacturers.php");
		$manufacturers = new Manufacturers($db);
		$manufacturers_list = $manufacturers->getManufacturers(true);
		if ($manufacturers_list)
		{
			view()->assign("manufacturers", $manufacturers_list);
			$is_manufacturers = true;
		}
		else
		{
			view()->assign("manufacturers", false);
			$is_manufacturers = false;
		}
	}
	else
	{
		view()->assign("manufacturers", false);
		$is_manufacturers = false;
	}

	view()->assign("current_currency", $_SESSION["current_currency"]);
	$currencies_list = $currencies->getCurrencies();
	if ($currencies_list)
	{
		view()->assign("currencies", $currencies_list);
		view()->assign("currencies_count", count($currencies_list));
		$is_currencies = true;
	}
	else
	{
		view()->assign("currencies", array());
		view()->assign("currencies_count", 1);
		$is_currencies = false;
	}

	//bestsellers
	if (
		(isset($settings["CatalogBestsellersAvailable"]) && $settings["CatalogBestsellersAvailable"] == "YES")
		||
		(isset($settings["CatalogBestSellersAvailable"]) && $settings["CatalogBestSellersAvailable"] == "YES")
	)
	{
		require_once("content/classes/class.products.php");
		$params = $settings;
		if ($parent)
		{
			if (in_array($parent, array_keys($categories->tree)))
			{
				$params["categories"][] = $parent;
				if (is_array($categories->tree[$parent]["children"]))
				{
					reset($categories->tree[$parent]["children"]);
					foreach ($categories->tree[$parent]["children"] as $id=>$node)
					{
						$params["categories"][] = $id;
					}
				}
			}
		}
		else
		{
			$params["categories"][] = 0;
		}
		$bs = new ShoppingCartProducts($db, $settings);
		$bs->taxRates = $order->taxRates;
		view()->assign("bestsellers", $bs->getItemsBestSellers($params, $user->auth_ok ? $user->level : (isset($userCookie) ? $userCookie["l"] : 0)));
		view()->assign("bestsellers_view", $settings["CatalogBestsellersView"]);		
		$is_bestsellers = $bs->bestsellersCount > 0;
	}
	else
	{
		view()->assign("bestsellers", false);//
		$is_bestsellers = false;
	}

	if ($user->auth_ok)
	{
		view()->assign("user_name", gs($user->data["fname"]." ".$user->data["lname"]));
	}

	//top & bottom links
	$page_id = isset($_REQUEST["page_id"]) ? $_REQUEST["page_id"] : "";
	view()->assign("pages_links", $pages_links = getPagesLinks($db, $p=="page"?$page_id:""));
        

	//recent items
	require_once("content/classes/class.recent.php");
	$recentItems = new ShoppingCartRecentItems($settings);
	view()->assign("recent_items", $recentItems->getItems());

	view()->assign("designImages", view()->getImages());

	view()->assign("label_app_name", $label_app_name);
	view()->assign("label_home_site", $label_home_site);

	$meta_keywords = $settings["SearchMetaKeywords"];
	$meta_title = $settings["SearchTitle"];
	$meta_description = $settings["SearchMetaDescription"];

	// check page exists and page protection
	if (in_array($p, $pages_public) || in_array($p, $pages_protected))
	{
		$body = "content/public/public_".$p.".php";
		if (in_array($p, $pages_protected) && (!$user->auth_ok))
		{
			$_SESSION["after_login_url"] = currentPageURL(); 
			$backurl = $url_https."p=login";
			$_mysession = $_SESSION;
			foreach ($_mysession as $_mysessionvar=>$_mysessionkey) $_SESSION[$_mysessionvar] = $_mysessionkey;
			_session_write_close();
			//echo $backurl; die("Ds");
			if ($backurl != "") header("Location: ".$backurl."\n");
			die();
		}
	}
	else
	{
		$p = "404";
		$body = "content/public/public_404.php";
	}

	if ($user->auth_ok && in_array($p, $pages_public_only))
	{
		header("Location: ".$url_dynamic."p=cart");
	}

	view()->assign("site_map_url", getSiteMapUrl());

	//ajax javascript
	view()->assign("ajax_javascript", $xajax->getJavascript("content/vendors/ajax"));

	/**
	 * Log statistics
	 */
	require_once("content/engine/engine_statistics.php");
	if (($p != "catalog") && ($p != "product"))
	{
		LogStatistics($db, $user->id, "other", 0, "");
	}
	// load executable module (by $p variable)
	require($body);
	
	 // handle simple ajax calls
	if (isset($_REQUEST["request_type"]) && $_REQUEST["request_type"] == "ajax" && $_REQUEST['page_id'] =='product')
	{
		die;
	}
	if (isset($_REQUEST['page_id']) && $_REQUEST['page_id'] =='ajaxcat')
	{
		die;
	}
	// assign $meta_xxx vars
	view()->assign("meta_title", $meta_title);
	view()->assign("meta_keywords", $meta_keywords);
	view()->assign("meta_description", $meta_description);
	
	// meta pre-assign
	view()->appendMetatag('Content-Type', 'text/html; charset='.$msg['common']['charset'], true, 'http-equiv');
	view()->appendMetatag('keywords', $meta_keywords);
	view()->appendMetatag('description', $meta_description);
	view()->setTitle($meta_title);
	
	// forces IE7 compatibility mode for IE8 browsers
	view()->appendMetatag('X-UA-Compatible', 'IE=EmulateIE7', true, 'http-equiv');
	
	// sets the metatags for use with designmode
	view()->appendMetatag('ddm-page', htmlentities($p));
	view()->appendMetatag('ddm-lang', $current_language["code"]);
	
	$doRender = ((array_key_exists('norender', $_GET) && $_GET['norender'] == 'true') === false);
	
	require_once("content/engine/engine_design_mode.php");

	if (in_array($p, array("completed", "invoice", "payment_validation", "cart", "billing", "one_page_checkout")))
	{
		view()->force_compile = true;
	}

	/**
	 * Render output
	 */
	if ($doRender)
	{
		$wrapperToRender = "default.html";
		if ($settings["StoreClosed"] == "Yes" && !$isDesignMode)
		{
			view()->assign("ClosedMessage", $settings["StoreClosedMessage"]);
			$wrapperToRender = "store_closed.html";
		}
		else
		{		
			$is_print_version = isset($_REQUEST["is_print_version"])?$_REQUEST["is_print_version"]:false;
			view()->assign("is_print_version", $is_print_version);
		
			if ($is_print_version == "true")
			{
				view()->assign("site_title", $settings["GlobalSiteName"]);
				$wrapperToRender = "print.html";
			}
		}
		
		view()->render("templates/wrappers/{$wrapperToRender}");
	}
	
	/**
	 * Done
	 */
	$db->done();
	
	if ($p != "email2friend" && $p != "404")
	{
	
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == "443" ? "https://" : "http://").$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	}
	else if ($p != "makeanoffer" && $p != "404")
	{
	
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == "443" ? "https://" : "http://").$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	}
	else if ($p != "requestinfo" && $p != "404")
	{
	
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == "443" ? "https://" : "http://").$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	}
	else if ($p != "financevehicle" && $p != "404")
	{
	
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == "443" ? "https://" : "http://").$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	}
	else if ($p != "financeform" && $p != "404")
	{
	
		$_SESSION["HTTP_REFERER"] = ($_SERVER["SERVER_PORT"] == "443" ? "https://" : "http://").$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	}
	
	/**
	 * Save data from HTTPS to HTTP session
	 */
	
	_session_write_close();
	
/**
 * The End. To be continued. See you next time.
 */
